## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[fn_cdc_get_column_ordinal\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.fn_cdc_get_column_ordinal**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Scalar |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -1037876544 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@capture_instance| |sysname|128|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@column_name| |sysname|128|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|@Return|int|4|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[fn_cdc_get_column_ordinal\]
 No dependencies exist

---
### Objects that \[sys\].\[fn_cdc_get_column_ordinal\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create function sys.fn_cdc_get_column_ordinal                
(                                                        
    @capture_instance    sysname,
    @column_name        sysname
)
returns int
with returns null on null input
as                                                    
begin
    declare @ordinal_position int
        ,@source_schema sysname
        ,@source_name sysname
        
    -- Verify capture instance is not null or empty
    if (@capture_instance is null) or (rtrim(@capture_instance) = N'') 
    begin
        return null
    end
    
    -- Verify column name is not null or empty
    if (@column_name is null) or (rtrim(@column_name) = N'') 
    begin
        return null
    end
    
    set @source_schema = N'cdc'
    set @source_name = @capture_instance + N'_CT' 

    -- Caller must have select access to the source table
    if ([sys].[fn_cdc_has_select_access](@capture_instance) != 1)
    begin
        return null
    end
    
    select @ordinal_position = sys.fn_cdc_get_column_ordinal_internal(
        @source_schema, @source_name, @column_name)
    
    return @ordinal_position
end
GO
  
~~~

---
### See also
[List of functions](../functions.md)

