## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[fn_column_store_row_groups\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.fn_column_store_row_groups**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Inline |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -112789279 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@obj_id| |bigint|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|object_id|int|4|
|index_id|int|4|
|partition_number|int|4|
|row_group_id|int|4|
|delta_store_hobt_id|bigint|8|
|state|tinyint|1|
|state_description|nvarchar|60|
|total_rows|bigint|8|
|deleted_rows|bigint|8|
|size_in_bytes|bigint|8|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[fn_column_store_row_groups\]
 No dependencies exist

---
### Objects that \[sys\].\[fn_column_store_row_groups\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION sys.fn_column_store_row_groups
    (
    @obj_id BIGINT
    )
RETURNS TABLE
AS
    RETURN SELECT rg.parent_object_id as [object_id],
        rg.parent_index_id as [index_id],
        rg.parent_part_number as [partition_number],
        rg.[row_group_id],
        rg.[delta_store_hobt_id],
        rg.[state],
        sd.[name] as state_description,
        rg.[total_rows],
        rg.[deleted_rows],
        rg.[size_in_bytes]
    -- First parameter determines which table to open
    -- Second parameter determines the object id passed in
    -- Third parameter determines which view to show,
    -- 1 is to show dm_db_column_store_row_group_physical_stats
    -- 0 is to show fn_column_store_row_groups or column_store_row_groups
    FROM OpenRowset(TABLE COLUMNSTORE_ROW_GROUPS, @obj_id, 0) rg
    INNER JOIN sys.syspalvalues sd
        ON sd.class = 'CSRG' AND sd.value = rg.state
    WHERE has_access('CO', rg.parent_object_id) = 1;
GO
  
~~~

---
### See also
[List of functions](../functions.md)

