## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[fn_replformatdatetime\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.fn_replformatdatetime**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Scalar |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -154846366 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@datetime| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|@Return|nvarchar|50|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[fn_replformatdatetime\]
 No dependencies exist

---
### Objects that \[sys\].\[fn_replformatdatetime\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
--
-- Name: fn_replformatdatetime
--
-- Description: This function encapsulates the definitive method for 
--              formatting a datetime field into a string in SQL Replication.
--
-- Parameter: @datetime datetime (mandatory)
--
-- Returns: nvarchar(50) (leaves room for modification in the future)
--
-- Security: Execute permission of this function is granted to public
--           (public interface object)
--
create function sys.fn_replformatdatetime (
    @datetime datetime
    ) returns nvarchar(50)
as
begin
    declare @datetime_string nvarchar(50)
    select @datetime_string = convert(nvarchar(12), @datetime, 112) +
        substring(convert(nvarchar(24), @datetime, 121), 11, 13)    
    return @datetime_string
end
GO
  
~~~

---
### See also
[List of functions](../functions.md)

