## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[fn_check_object_signatures\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.fn_check_object_signatures**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Inline |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -234465429 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@class| |sysname|128|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@thumbprint| |varbinary|20|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|type|nvarchar|60|
|entity_id|int|4|
|is_signed|int|4|
|is_signature_valid|int|4|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[fn_check_object_signatures\]
 No dependencies exist

---
### Objects that \[sys\].\[fn_check_object_signatures\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE FUNCTION sys.fn_check_object_signatures(@class SYSNAME, @thumbprint VARBINARY(20))
RETURNS TABLE
AS
    RETURN
        SELECT     o.type_desc                type,    -- OBJECT
            o.object_id                entity_id,
            CASE WHEN is_objectsigned('OBJECT', o.object_id, @class, @thumbprint) IS NULL
            THEN 0 ELSE 1 END            is_signed,
            CASE WHEN is_objectsigned('OBJECT', o.object_id, @class, @thumbprint) = 1 THEN 1
            ELSE 0 END                is_signature_valid
            FROM sys.objects o
            LEFT JOIN sys.crypt_properties p ON o.object_id = p.major_id
            WHERE sys.fn_is_signable_object(o.type) = 1
            GROUP BY o.object_id, o.type_desc
        UNION
        SELECT     'ASSEMBLY'                class,    -- ASSEMBLY
            s.assembly_id                entity_id,
            CASE WHEN is_objectsigned('ASSEMBLY', s.assembly_id, @class, @thumbprint) IS NULL
            THEN 0 ELSE 1 END            is_signed,
            CASE WHEN is_objectsigned('ASSEMBLY', s.assembly_id, @class, @thumbprint) = 1 THEN 1
            ELSE 0 END                is_signature_valid
            FROM sys.assemblies s
            LEFT JOIN sys.crypt_properties p ON s.assembly_id = p.major_id
            GROUP BY s.assembly_id
GO
  
~~~

---
### See also
[List of functions](../functions.md)

