## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[dm_db_index_physical_stats\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.dm_db_index_physical_stats**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Inline |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -333557461 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@DatabaseId| |smallint|2|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@ObjectId| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@IndexId| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@PartitionNumber| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@Mode| |nvarchar|20|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|database_id|smallint|2|
|object_id|int|4|
|index_id|int|4|
|partition_number|int|4|
|index_type_desc|nvarchar|60|
|alloc_unit_type_desc|nvarchar|60|
|index_depth|tinyint|1|
|index_level|tinyint|1|
|avg_fragmentation_in_percent|float|8|
|fragment_count|bigint|8|
|avg_fragment_size_in_pages|float|8|
|page_count|bigint|8|
|avg_page_space_used_in_percent|float|8|
|record_count|bigint|8|
|ghost_record_count|bigint|8|
|version_ghost_record_count|bigint|8|
|min_record_size_in_bytes|int|4|
|max_record_size_in_bytes|int|4|
|avg_record_size_in_bytes|float|8|
|forwarded_record_count|bigint|8|
|compressed_page_count|bigint|8|
|hobt_id|bigint|8|
|columnstore_delete_buffer_state|tinyint|1|
|columnstore_delete_buffer_state_desc|nvarchar|60|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[dm_db_index_physical_stats\]
 No dependencies exist

---
### Objects that \[sys\].\[dm_db_index_physical_stats\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create function sys.dm_db_index_physical_stats
(
    @DatabaseId            SMALLINT        = 0,
    @ObjectId              INT             = 0,
    @IndexId             INT             = -1,
    @PartitionNumber    INT                = 0,
    @Mode                 nvarchar(20)      = NULL
)
returns table
as
    return select *
           from OpenRowset
        (    TABLE
            INDEXANALYSIS,
            @DatabaseId,
            @ObjectId,
            @IndexId,
            @PartitionNumber,
            @Mode
        )
GO
  
~~~

---
### See also
[List of functions](../functions.md)

