## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[fn_virtualfilestats\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.fn_virtualfilestats**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Table |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -337551382 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@DatabaseId| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@FileId| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|DbId|smallint|2|
|FileId|smallint|2|
|TimeStamp|bigint|8|
|NumberReads|bigint|8|
|BytesRead|bigint|8|
|IoStallReadMS|bigint|8|
|NumberWrites|bigint|8|
|BytesWritten|bigint|8|
|IoStallWriteMS|bigint|8|
|IoStallMS|bigint|8|
|BytesOnDisk|bigint|8|
|FileHandle|varbinary|8|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[fn_virtualfilestats\]
 No dependencies exist

---
### Objects that \[sys\].\[fn_virtualfilestats\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create function sys.fn_virtualfilestats
    (
    @DatabaseId Int = -1,
    @FileId Int = -1
    )
returns @tab table(DbId SmallInt NOT NULL, FileId SmallInt NOT NULL, TimeStamp BigInt NOT NULL,
        NumberReads BigInt NOT NULL, BytesRead BigInt NOT NULL, IoStallReadMS BigInt NOT NULL,
        NumberWrites BigInt NOT NULL, BytesWritten BigInt NOT NULL, IoStallWriteMS BigInt NOT NULL,
        IoStallMS BigInt NOT NULL, BytesOnDisk BigInt NOT NULL, FileHandle VarBinary(8) NOT NULL)
as
begin
    insert @tab
     select database_id,
         file_id,
         sample_ms,
         num_of_reads,
         num_of_bytes_read,
         io_stall_read_ms,
         num_of_writes,
         num_of_bytes_written,
         io_stall_write_ms,
         io_stall,
         size_on_disk_bytes,
         file_handle
     from OpenRowset(TABLE VIRTUALFILESTATS, @DatabaseId, @FileId)

    return
end -- fn_virtualfilestats
GO
  
~~~

---
### See also
[List of functions](../functions.md)

