## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[fn_varbintohexsubstring\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.fn_varbintohexsubstring**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Scalar |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -403477184 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@fsetprefix| |bit|1|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@pbinin| |varbinary|2147483647|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@startoffset| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@cbytesin| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|@Return|nvarchar|1073741823|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[fn_varbintohexsubstring\]
 No dependencies exist

---
### Objects that \[sys\].\[fn_varbintohexsubstring\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create function sys.fn_varbintohexsubstring (
    @fsetprefix bit = 1        -- append '0x' to the output
    ,@pbinin varbinary(max) -- input binary stream
    ,@startoffset int = 1     -- starting offset 
    ,@cbytesin int = 0         -- length of input to consider, 0 means total length
)
returns nvarchar(max)
as
begin
    declare @pstrout nvarchar(max)
        ,@i int
        ,@firstnibble int
        ,@secondnibble int
        ,@tempint int
        ,@hexstring char(16)
       
    --
    -- initialize and validate
    --
    if (@pbinin IS NOT NULL)
    begin    
        select @i = 0
                ,@cbytesin = case when (@cbytesin &gt; 0 and @cbytesin &lt;= DATALENGTH(@pbinin) ) then @cbytesin else DATALENGTH(@pbinin) end
                ,@pstrout =  case when (@fsetprefix = 1) then N'0x' else N'' end
                ,@hexstring = '0123456789abcdef'

              --the output limit for nvarchar(max) is 2147483648 (2^31) bytes, that is 1073741824 (2^30) unicode characters
        if ( ((@cbytesin * 2) + 2 &gt; 1073741824) or ((@cbytesin * 2) + 2 &lt; 1) or ( @cbytesin is null ))
            return NULL

        if ( ( @startoffset &gt; DATALENGTH(@pbinin) ) or ( @startoffset &lt; 1 ) or ( @startoffset is null ))
            return NULL

        --
        -- adjust the length to process based on start offset and
        -- total length
        --
        if ((DATALENGTH(@pbinin) - @startoffset + 1) &lt; @cbytesin)
            select @cbytesin = DATALENGTH(@pbinin) - @startoffset + 1
        
        --
        -- do for each byte
        --
        while (@i &lt; @cbytesin)
        begin
            --
            -- Each byte has two nibbles
            -- which we convert to character
            --
            select @tempint = cast(substring(@pbinin, @i + @startoffset, 1) as int)
            select @firstnibble = @tempint / 16
            select @secondnibble = @tempint % 16

            --
            -- we need to do an explicit cast with substring 
            -- for proper string conversion. 
            --
            select @pstrout = @pstrout +
                cast(substring(@hexstring, (@firstnibble+1), 1) as nvarchar) +
                cast(substring(@hexstring, (@secondnibble+1), 1) as nvarchar)

            select @i = @i + 1
        end
    end
    
    -- All done
    return @pstrout
end
GO
  
~~~

---
### See also
[List of functions](../functions.md)

