## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[fn_repluniquename\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.fn_repluniquename**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Scalar |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -408691375 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@guid| |uniqueidentifier|16|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@prefix1| |sysname|128|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@prefix2| |sysname|128|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@prefix3| |sysname|128|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@prefix4| |sysname|128|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|@Return|nvarchar|100|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[fn_repluniquename\]
 No dependencies exist

---
### Objects that \[sys\].\[fn_repluniquename\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create function sys.fn_repluniquename (
-- cannot use newid() in a UDF
    @guid uniqueidentifier = NULL,
    @prefix1 sysname = NULL,
    @prefix2 sysname = NULL,
    @prefix3 sysname = NULL,
    @prefix4 sysname = NULL
    ) returns nvarchar(100)
as
begin
    declare @name nvarchar(100)
    select @name = N''

    -- Max len is (16 + 1) * 4 + 32 = 100
    if @prefix1 is not null
        select @name = @name + CONVERT(nvarchar(16),@prefix1) + N'-'
    if @prefix2 is not null
        select @name = @name + CONVERT(nvarchar(16),@prefix2) + N'-'
    if @prefix3 is not null
        select @name = @name + CONVERT(nvarchar(16),@prefix3) + N'-'
    if @prefix4 is not null
        select @name = @name + CONVERT(nvarchar(16),@prefix4) + N'-'
        
    select @name = @name + replace(isnull(convert(nvarchar(36), @guid), N''), N'-',N'')
    return @name
end
GO
  
~~~

---
### See also
[List of functions](../functions.md)

