## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[fn_cdc_check_parameters\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.fn_cdc_check_parameters**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Scalar |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -413025611 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@capture_instance| |sysname|128|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@from_lsn| |binary|10|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@to_lsn| |binary|10|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@row_filter_option| |nvarchar|30|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@net_changes| |bit|1|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|@Return|bit|1|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[fn_cdc_check_parameters\]
 No dependencies exist

---
### Objects that \[sys\].\[fn_cdc_check_parameters\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create function [sys].[fn_cdc_check_parameters]                
(                                                        
    @capture_instance sysname,
    @from_lsn binary(10),
    @to_lsn binary(10),
    @row_filter_option nvarchar(30),
    @net_changes bit 
)                                                        
returns bit
as                                                    
begin
    declare @val bit

    select @capture_instance = rtrim(@capture_instance)
    
    if ([sys].[fn_cdc_has_select_access](@capture_instance) = 0)
    begin
        if (@net_changes is null) or (@net_changes = 0)
        begin
            -- Force error 229 execute permission denied on all changes dummy
            if exists(
                select * from cdc.[fn_cdc_get_all_changes_...](0X00, 0X01, 'all')
            )
                return 0
        end
        else
        begin
            -- Force error 229 execute permission denied on net changes dummy
            if exists(
                select * from cdc.[fn_cdc_get_net_changes_...](0X00, 0X01, 'all')
            )
                return 0
        end
        
        return 0
    end

    if ([sys].[fn_cdc_is_range_valid](@from_lsn, @to_lsn, @capture_instance) = 0)
    begin
        -- Force error 313 -- Insufficient number of arguments
        if ((@net_changes is null) or (@net_changes = 0))
        begin
            select @val = sys.fn_cdc_all_changes_range_error()
            return 0    
        end            
        else
        begin
            select @val = sys.fn_cdc_net_changes_range_error()
            return 0    
        end
    end        
    
    if ((@net_changes is null) or (@net_changes = 0))
    begin
        if (@row_filter_option is NULL) or
           (lower(rtrim(ltrim(@row_filter_option))) not in (N'all', N'all update old'))
        begin
            -- Force error 313 -- Insufficient number of arguments
            select @val = sys.fn_cdc_all_changes_range_error()
            return 0    
        end            
    end
    else
    begin
        if (@row_filter_option is NULL) or
           (lower(rtrim(ltrim(@row_filter_option))) not in (N'all', N'all with mask', N'all with merge'))
        begin
            -- Force error 313 -- Insufficient number of arguments
            select @val = sys.fn_cdc_net_changes_range_error()
            return 0    
        end            
    end
    
    return 1
                            
end                                                                    
GO
  
~~~

---
### See also
[List of functions](../functions.md)

