## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[fn_my_permissions\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.fn_my_permissions**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Table |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -462384620 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@entity| |sysname|128|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@class| |nvarchar|60|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|entity_name|nvarchar|128|
|subentity_name|nvarchar|128|
|permission_name|nvarchar|60|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[fn_my_permissions\]
 No dependencies exist

---
### Objects that \[sys\].\[fn_my_permissions\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE FUNCTION sys.fn_my_permissions(@entity sysname, @class nvarchar(60))
RETURNS @myperms table (
            entity_name sysname        NULL,
            subentity_name sysname    NULL,
            permission_name nvarchar(60))
AS
    BEGIN
    IF (LOWER(@class) = 'database')
        SET @entity = NULL
    IF (@class IS NULL or len(@class) = 0)
        SET @class = 'server'

    DECLARE @pseudoclass sysname
    IF (LOWER(@class) = 'server')
        SET @pseudoclass = NULL
    ELSE
        SET @pseudoclass = @class

    DECLARE @entityname sysname
    SET @entityname = CASE LOWER(@class)
                WHEN 'server' THEN 'server'
                WHEN 'database' THEN 'database'
                ELSE @entity
              END
    IF (LOWER(@class) = 'server')
        SET @pseudoclass = NULL
    ELSE
        SET @pseudoclass = @class

    -- Get Entity Level Permissions
    INSERT INTO @myperms
        SELECT @entityname, '', fbp.permission_name
        FROM sys.fn_builtin_permissions(@class) AS fbp
        WHERE has_perms_by_name(@entity, @pseudoclass, fbp.permission_name) &lt;&gt; 0

    -- Get Sub Entity Level Permissions
    IF (LOWER(@class) = 'object')
        BEGIN
        DECLARE @objId int
        DECLARE @thisPerm sysname

        SELECT @objId = object_id(@entity)

        INSERT INTO @myperms
            SELECT @entity, name, 'SELECT'
            FROM sys.columns where object_id = @objId AND
            has_perms_by_name(@entity, 'object', 'select', quotename(name), 'column') &lt;&gt; 0

        INSERT INTO @myperms
            SELECT @entity, name, 'UPDATE'
            FROM sys.columns where object_id = @objId AND
            has_perms_by_name(@entity, 'object', 'update', quotename(name), 'column') &lt;&gt; 0

        INSERT INTO @myperms
            SELECT @entity, name, 'REFERENCES'
            FROM sys.columns where object_id = @objId AND
            has_perms_by_name(@entity, 'object', 'references', quotename(name), 'column') &lt;&gt; 0
        end
    RETURN
    END
GO
  
~~~

---
### See also
[List of functions](../functions.md)

