## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[fn_MapSchemaType\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.fn_MapSchemaType**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Scalar |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -465170922 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@schematype| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@schemasubtype| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|@Return|sysname|128|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[fn_MapSchemaType\]
 No dependencies exist

---
### Objects that \[sys\].\[fn_MapSchemaType\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
-- This function takes returns the type of the schema change
create function sys.fn_MapSchemaType (@schematype int, @schemasubtype int)
returns sysname
as
begin
    declare @friendly_schematype sysname

    declare @SCHEMA_TYPE_SQLCOMMAND                 int 
    declare @SCHEMA_TYPE_SCHEMASCRIPT       int 
    declare @SCHEMA_TYPE_NATIVEBCP                  int
    declare @SCHEMA_TYPE_CHARACTERBCP       int
    declare @SCHEMA_TYPE_LASTRECGEN         int
    declare @SCHEMA_TYPE_LASTSENTGEN        int
    declare @SCHEMA_TYPE_DIRECTORY                  int 
    declare @SCHEMA_TYPE_PRIORITYCHANGE         int     
    declare @SCHEMA_TYPE_RETENTIONCHANGE    int
    declare @SCHEMA_TYPE_TRIGGERSCRIPT      int 
    declare @SCHEMA_TYPE_ALTERTABLE                 int
    declare @SCHEMA_TYPE_REINITALL                  int
    declare @SCHEMA_TYPE_NONSQLALTERTABLE   int
    declare @SCHEMA_TYPE_REINITWITHUPLOAD   int
    declare @SCHEMA_TYPE_DRISCRIPT                  int 
    declare @SCHEMA_TYPE_METADATACLEANUP    int
    declare @SCHEMA_TYPE_UPDATELASTSENTGEN  int
    declare @SCHEMA_TYPE_BACKWARD_COMPAT_LEVEL int
    declare @SCHEMA_TYPE_VALIDATE_SUBSCRIBERINFO int
    declare @SCHEMA_TYPE_WELLPARTITIONED int
    declare @SCHEMA_TYPE_ARTICLERESOLVER int
    declare @SCHEMA_TYPE_ARTICLEPROCESSINGORDER int
    declare @SCHEMA_TYPE_PUBLISHED_IN_TRANPUB int
    declare @SCHEMA_TYPE_COMPENSATE_FOR_ERRORS int
    declare @SCHEMA_TYPE_ALTSNAPSHOTFOLDER int
    declare @SCHEMA_TYPE_UPLOADOPTIONS int
    declare @SCHEMA_TYPE_DELETETRACKING int
    declare @SCHEMA_TYPE_DROPARTICLE int
    declare @SCHEMA_TYPE_RETENTIONUNITCHANGE int
    declare @SCHEMA_TYPE_USER_SCHEMA int
    declare @SCHEMA_TYPE_PRESNAPSHOTSCRIPT int
    declare @SCHEMA_TYPE_POSTSNAPSHOTSCRIPT int
    declare @SCHEMA_TYPE_ONDEMANDUSERSCRIPT int
    declare @SCHEMA_TYPE_MERGEPROCEDURESCRIPT int
    declare @SCHEMA_TYPE_SNAPSHOTHEADERBEGIN int
    declare @SCHEMA_TYPE_SNAPSHOTHEADEREND int
    declare @SCHEMA_TYPE_SNAPSHOTTRAILER int
    declare @SCHEMA_TYPE_FTPADDRESS int
    declare @SCHEMA_TYPE_FTPPORT int
    declare @SCHEMA_TYPE_FTPSUBDIR int
    declare @SCHEMA_TYPE_SNAPSHOTCOMPRESSED int
    declare @SCHEMA_TYPE_FTPLOGIN int
    declare @SCHEMA_TYPE_FTPPASSWORD int
    declare @SCHEMA_TYPE_SYSPRESCRIPT int
    declare @SCHEMA_TYPE_PROCSCHEMA int
    declare @SCHEMA_TYPE_VIEWSCHEMA int
    declare @SCHEMA_TYPE_UDFSCHEMA int
    declare @SCHEMA_TYPE_VIEWINDEXES int
    declare @SCHEMA_TYPE_EXTENDEDPROPERTIES int
    declare @SCHEMA_TYPE_VALIDATE int
    declare @SCHEMA_TYPE_PRESNAPSHOTSQLCOMMAND int
    declare @SCHEMA_TYPE_DYNSNAPVALIDATION int
    declare @SCHEMA_TYPE_SYSTABLE_NATIVE_BCP_90 int
    declare @SCHEMA_TYPE_SYSTABLE_CHAR_BCP_90 int
    declare @SCHEMA_TYPE_SYSTABLE_NATIVE_BCP_90_FORGLOBALONLY int
    declare @SCHEMA_TYPE_SYSTABLE_CHAR_BCP_90_FORGLOBALONLY int
    declare @SCHEMA_TYPE_SYSTABLE_NATIVE_BCP_90_FORLIGHTWEIGHT int
    declare @SCHEMA_TYPE_SYSTABLE_CHAR_BCP_90_FORLIGHTWEIGHT int
    declare @SCHEMA_TYPE_USER_DEFINED_DATA_TYPE int
    declare @SCHEMA_TYPE_CLR_USER_DEFINED_DATA_TYPE int
    declare @SCHEMA_TYPE_ASSEMBLY int
    declare @SCHEMA_TYPE_PARTITIONSCHEME int
    declare @SCHEMA_TYPE_PARTITIONFUNCTION int
    declare @SCHEMA_TYPE_XMLSCHEMANAMESPACE int
    declare @SCHEMA_TYPE_FULLTEXTCATALOG int
    declare @SCHEMA_TYPE_SYNONYM int
    declare @SCHEMA_TYPE_DYNAMICBCPBIT int
    declare @SCHEMA_TYPE_DYNAMICNATIVEBCP int
    declare @SCHEMA_TYPE_DYNAMICCHARBCP int
    declare @SCHEMA_TYPE_DYNAMIC_SYSTABLE_NATIVE_BCP_90 int
    declare @SCHEMA_TYPE_DYNAMIC_SYSTABLE_CHAR_BCP_90 int
    declare @SCHEMA_TYPE_DYNAMIC_SYSTABLE_NATIVE_BCP_90_FORGLOBALONLY int
    declare @SCHEMA_TYPE_DYNAMIC_SYSTABLE_CHAR_BCP_90_FORGLOBALONLY int
    declare @SCHEMA_TYPE_DYNAMIC_SYSTABLE_NATIVE_BCP_90_FORLIGHTWEIGHT int
    declare @SCHEMA_TYPE_DYNAMIC_SYSTABLE_CHAR_BCP_90_FORLIGHTWEIGHT int
    declare @SCHEMA_TYPE_DDL_ACTIONS int
    declare @SCHEMA_TYPE_DDL_RELATED_COLUMN_FIXUP int
    declare @SCHEMA_TYPE_INCREMENTALSNAPSHOTCONTROL int
    declare @SCHEMA_TYPE_INCREMENTALALTSNAPSHOTFOLDER int
    declare @SCHEMA_TYPE_INCREMENTALSNAPSHOTHEADERBEGIN int
    declare @SCHEMA_TYPE_INCREMENTALSNAPSHOTHEADEREND int
    declare @SCHEMA_TYPE_INCREMENTALSNAPSHOTTRAILER int
    declare @SCHEMA_TYPE_INCREMENTALFTPADDRESS int
    declare @SCHEMA_TYPE_INCREMENTALFTPPORT int
    declare @SCHEMA_TYPE_INCREMENTALFTPSUBDIR int
    declare @SCHEMA_TYPE_INCREMENTALSNAPSHOTCOMPRESSED int
    declare @SCHEMA_TYPE_INCREMENTALFTPLOGIN int
    declare @SCHEMA_TYPE_INCREMENTALFTPPASSWORD int
    declare @SCHEMA_TYPE_CHANGE_MERGE_PUBLICATION_90RTM int
    declare @SCHEMA_TYPE_CHANGE_MERGE_ARTICLE_90RTM int
    declare @SCHEMA_TYPE_USER_DEFINED_TABLE_TYPE int

    set @SCHEMA_TYPE_SQLCOMMAND             = 1 
    set @SCHEMA_TYPE_SCHEMASCRIPT           = 2 
    set @SCHEMA_TYPE_NATIVEBCP              = 3
    set @SCHEMA_TYPE_CHARACTERBCP           = 4
    set @SCHEMA_TYPE_LASTRECGEN         = 5
    set @SCHEMA_TYPE_LASTSENTGEN        = 6
    set @SCHEMA_TYPE_DIRECTORY              = 7 
    set @SCHEMA_TYPE_PRIORITYCHANGE     = 8     
    set @SCHEMA_TYPE_RETENTIONCHANGE    = 9
    set @SCHEMA_TYPE_TRIGGERSCRIPT          = 10        
    set @SCHEMA_TYPE_ALTERTABLE             = 11
    set @SCHEMA_TYPE_REINITALL              = 12
    set @SCHEMA_TYPE_NONSQLALTERTABLE   = 13
    set @SCHEMA_TYPE_REINITWITHUPLOAD   = 14
    set @SCHEMA_TYPE_DRISCRIPT              = 15        
    set @SCHEMA_TYPE_METADATACLEANUP    = 16
    set @SCHEMA_TYPE_UPDATELASTSENTGEN  = 17
    set @SCHEMA_TYPE_BACKWARD_COMPAT_LEVEL = 18
    set @SCHEMA_TYPE_VALIDATE_SUBSCRIBERINFO = 19
    set @SCHEMA_TYPE_WELLPARTITIONED = 20
    set @SCHEMA_TYPE_ARTICLERESOLVER = 21
    set @SCHEMA_TYPE_ARTICLEPROCESSINGORDER = 22
    set @SCHEMA_TYPE_PUBLISHED_IN_TRANPUB = 23
    set @SCHEMA_TYPE_COMPENSATE_FOR_ERRORS = 24
    set @SCHEMA_TYPE_ALTSNAPSHOTFOLDER = 25
    set @SCHEMA_TYPE_UPLOADOPTIONS = 26
    set @SCHEMA_TYPE_DELETETRACKING = 27
    set @SCHEMA_TYPE_DROPARTICLE = 28
    set @SCHEMA_TYPE_RETENTIONUNITCHANGE = 29
    set @SCHEMA_TYPE_USER_SCHEMA = 31
    set @SCHEMA_TYPE_PRESNAPSHOTSCRIPT = 40
    set @SCHEMA_TYPE_POSTSNAPSHOTSCRIPT = 45
    set @SCHEMA_TYPE_ONDEMANDUSERSCRIPT = 46
    set @SCHEMA_TYPE_MERGEPROCEDURESCRIPT = 48
    set @SCHEMA_TYPE_SNAPSHOTHEADERBEGIN = 50
    set @SCHEMA_TYPE_SNAPSHOTHEADEREND = 51
    set @SCHEMA_TYPE_SNAPSHOTTRAILER = 52
    set @SCHEMA_TYPE_FTPADDRESS = 53
    set @SCHEMA_TYPE_FTPPORT = 54
    set @SCHEMA_TYPE_FTPSUBDIR = 55
    set @SCHEMA_TYPE_SNAPSHOTCOMPRESSED = 56
    set @SCHEMA_TYPE_FTPLOGIN = 57
    set @SCHEMA_TYPE_FTPPASSWORD = 58
    set @SCHEMA_TYPE_SYSPRESCRIPT = 60
    set @SCHEMA_TYPE_PROCSCHEMA = 61
    set @SCHEMA_TYPE_VIEWSCHEMA = 62
    set @SCHEMA_TYPE_UDFSCHEMA = 63
    set @SCHEMA_TYPE_VIEWINDEXES = 64
    set @SCHEMA_TYPE_EXTENDEDPROPERTIES = 65
    set @SCHEMA_TYPE_VALIDATE = 66
    set @SCHEMA_TYPE_PRESNAPSHOTSQLCOMMAND = 67
    set @SCHEMA_TYPE_DYNSNAPVALIDATION = 71
    set @SCHEMA_TYPE_SYSTABLE_NATIVE_BCP_90 = 80
    set @SCHEMA_TYPE_SYSTABLE_CHAR_BCP_90 = 81
    set @SCHEMA_TYPE_SYSTABLE_NATIVE_BCP_90_FORGLOBALONLY = 82
    set @SCHEMA_TYPE_SYSTABLE_CHAR_BCP_90_FORGLOBALONLY = 83
    set @SCHEMA_TYPE_SYSTABLE_NATIVE_BCP_90_FORLIGHTWEIGHT = 84
    set @SCHEMA_TYPE_SYSTABLE_CHAR_BCP_90_FORLIGHTWEIGHT = 85
    set @SCHEMA_TYPE_USER_DEFINED_DATA_TYPE = 88
    set @SCHEMA_TYPE_CLR_USER_DEFINED_DATA_TYPE = 89
    set @SCHEMA_TYPE_ASSEMBLY = 90
    set @SCHEMA_TYPE_PARTITIONSCHEME = 91
    set @SCHEMA_TYPE_PARTITIONFUNCTION = 92
    set @SCHEMA_TYPE_XMLSCHEMANAMESPACE = 93
    set @SCHEMA_TYPE_FULLTEXTCATALOG = 96
    set @SCHEMA_TYPE_SYNONYM = 100
    set @SCHEMA_TYPE_USER_DEFINED_TABLE_TYPE = 105
    set @SCHEMA_TYPE_DYNAMICBCPBIT = 128
    set @SCHEMA_TYPE_DYNAMICNATIVEBCP = 131
    set @SCHEMA_TYPE_DYNAMICCHARBCP = 132
    set @SCHEMA_TYPE_DYNAMIC_SYSTABLE_NATIVE_BCP_90 = 208
    set @SCHEMA_TYPE_DYNAMIC_SYSTABLE_CHAR_BCP_90 = 209
    set @SCHEMA_TYPE_DYNAMIC_SYSTABLE_NATIVE_BCP_90_FORGLOBALONLY = 210
    set @SCHEMA_TYPE_DYNAMIC_SYSTABLE_CHAR_BCP_90_FORGLOBALONLY = 211
    set @SCHEMA_TYPE_DYNAMIC_SYSTABLE_NATIVE_BCP_90_FORLIGHTWEIGHT = 212
    set @SCHEMA_TYPE_DYNAMIC_SYSTABLE_CHAR_BCP_90_FORLIGHTWEIGHT = 213
    set @SCHEMA_TYPE_DDL_ACTIONS = 300
    set @SCHEMA_TYPE_DDL_RELATED_COLUMN_FIXUP = 301
    set @SCHEMA_TYPE_CHANGE_MERGE_PUBLICATION_90RTM = 302
    set @SCHEMA_TYPE_CHANGE_MERGE_ARTICLE_90RTM = 303
    set @SCHEMA_TYPE_INCREMENTALSNAPSHOTCONTROL = 1024
    set @SCHEMA_TYPE_INCREMENTALALTSNAPSHOTFOLDER = 1049
    set @SCHEMA_TYPE_INCREMENTALSNAPSHOTHEADERBEGIN = 1074
    set @SCHEMA_TYPE_INCREMENTALSNAPSHOTHEADEREND = 1075
    set @SCHEMA_TYPE_INCREMENTALSNAPSHOTTRAILER = 1076
    set @SCHEMA_TYPE_INCREMENTALFTPADDRESS = 1077
    set @SCHEMA_TYPE_INCREMENTALFTPPORT = 1078
    set @SCHEMA_TYPE_INCREMENTALFTPSUBDIR = 1079
    set @SCHEMA_TYPE_INCREMENTALSNAPSHOTCOMPRESSED = 1080
    set @SCHEMA_TYPE_INCREMENTALFTPLOGIN = 1081
    set @SCHEMA_TYPE_INCREMENTALFTPPASSWORD = 1082


    --enum of constants
    declare  @schemasubtype_addcolumn int
            ,@schemasubtype_dropcolumn int
            ,@schemasubtype_altercolumn int
            ,@schemasubtype_disabletrigger int
            ,@schemasubtype_enabletrigger int
            ,@schemasubtype_disabletriggerall int
            ,@schemasubtype_enabletriggerall int
            ,@schemasubtype_dropconstraint int
            ,@schemasubtype_enableconstraint int
            ,@schemasubtype_disableconstraint int
            ,@schemasubtype_enableconstraintall int
            ,@schemasubtype_disableconstraintall int
            ,@schemasubtype_addfk int
            ,@schemasubtype_addun int
            ,@schemasubtype_addchk int
            ,@schemasubtype_adddf int
            ,@schemasubtype_addpk int

    select @schemasubtype_addcolumn = 1                         --N'ADDCOLUMN'
        ,@schemasubtype_dropcolumn =  2                         --N'DROPCOLUMN'
        ,@schemasubtype_altercolumn = 3                         --N'ALTERCOLUMN'
        ,@schemasubtype_addpk = 4                                --N'ADDPRIMARYKEY'
        ,@schemasubtype_addun = 5                                --N'ADDUNIQUE'
        ,@schemasubtype_addfk = 6                                --N'ADDREFERENCE'
        ,@schemasubtype_dropconstraint = 7                      --N'DROPCONSTRAINT'
        ,@schemasubtype_adddf = 8                               --N'ADDDEFAULT'
        ,@schemasubtype_addchk = 9                              --N'ADDCHECK'
        ,@schemasubtype_disabletrigger = 10                     --N'DISABLETRIGGER'
        ,@schemasubtype_enabletrigger = 11                        --N'ENABLETRIGGER'
        ,@schemasubtype_disabletriggerall = 12                    --N'DISABLETRIGGER'
        ,@schemasubtype_enabletriggerall = 13                   --N'ENABLETRIGGER'
        ,@schemasubtype_enableconstraint = 14                   --N'ENABLECONSTRAINT'
        ,@schemasubtype_disableconstraint = 15                  --N'DISABLECONSTRAINT'
        ,@schemasubtype_enableconstraintall = 16                --N'ENABLECONSTRAINT'
        ,@schemasubtype_disableconstraintall = 17               --N'DISABLECONSTRAINT'

    select @friendly_schematype = case @schematype
    when @SCHEMA_TYPE_SQLCOMMAND then 'SCHEMA_TYPE_SQLCOMMAND'
    when @SCHEMA_TYPE_SCHEMASCRIPT then 'SCHEMA_TYPE_SCHEMASCRIPT'      
    when @SCHEMA_TYPE_NATIVEBCP then 'SCHEMA_TYPE_NATIVEBCP'
    when @SCHEMA_TYPE_CHARACTERBCP then 'SCHEMA_TYPE_CHARACTERBCP'
    when @SCHEMA_TYPE_LASTRECGEN then 'SCHEMA_TYPE_LASTRECGEN'
    when @SCHEMA_TYPE_LASTSENTGEN then 'SCHEMA_TYPE_LASTSENTGEN'
    when @SCHEMA_TYPE_DIRECTORY then 'SCHEMA_TYPE_DIRECTORY'
    when @SCHEMA_TYPE_PRIORITYCHANGE then 'SCHEMA_TYPE_PRIORITYCHANGE'
    when @SCHEMA_TYPE_RETENTIONCHANGE  then 'SCHEMA_TYPE_RETENTIONCHANGE'
    when @SCHEMA_TYPE_TRIGGERSCRIPT         then 'SCHEMA_TYPE_TRIGGERSCRIPT'    
    when @SCHEMA_TYPE_ALTERTABLE                    then 'SCHEMA_TYPE_ALTERTABLE'
    when @SCHEMA_TYPE_REINITALL             then 'SCHEMA_TYPE_REINITALL'
    when @SCHEMA_TYPE_NONSQLALTERTABLE   then 'SCHEMA_TYPE_NONSQLALTERTABLE'
    when @SCHEMA_TYPE_REINITWITHUPLOAD   then 'SCHEMA_TYPE_REINITWITHUPLOAD'
    when @SCHEMA_TYPE_DRISCRIPT                     then 'SCHEMA_TYPE_DRISCRIPT'        
    when @SCHEMA_TYPE_METADATACLEANUP    then 'SCHEMA_TYPE_METADATACLEANUP'
    when @SCHEMA_TYPE_UPDATELASTSENTGEN  then 'SCHEMA_TYPE_UPDATELASTSENTGEN'
    when @SCHEMA_TYPE_BACKWARD_COMPAT_LEVEL then 'SCHEMA_TYPE_BACKWARD_COMPAT_LEVEL'
    when @SCHEMA_TYPE_VALIDATE_SUBSCRIBERINFO then 'SCHEMA_TYPE_VALIDATE_SUBSCRIBERINFO'
    when @SCHEMA_TYPE_WELLPARTITIONED then 'SCHEMA_TYPE_WELLPARTITIONED'
    when @SCHEMA_TYPE_ARTICLERESOLVER then 'SCHEMA_TYPE_ARTICLERESOLVER'
    when @SCHEMA_TYPE_ARTICLEPROCESSINGORDER then 'SCHEMA_TYPE_ARTICLEPROCESSINGORDER'
    when @SCHEMA_TYPE_PUBLISHED_IN_TRANPUB then 'SCHEMA_TYPE_PUBLISHED_IN_TRANPUB'
    when @SCHEMA_TYPE_COMPENSATE_FOR_ERRORS then 'SCHEMA_TYPE_COMPENSATE_FOR_ERRORS'
    when @SCHEMA_TYPE_ALTSNAPSHOTFOLDER then 'SCHEMA_TYPE_ALTSNAPSHOTFOLDER'
    when @SCHEMA_TYPE_UPLOADOPTIONS then 'SCHEMA_TYPE_UPLOADOPTIONS'
    when @SCHEMA_TYPE_DELETETRACKING then 'SCHEMA_TYPE_DELETETRACKING'
    when @SCHEMA_TYPE_DROPARTICLE then 'SCHEMA_TYPE_DROPARTICLE'
    when @SCHEMA_TYPE_RETENTIONUNITCHANGE then 'SCHEMA_TYPE_RETENTIONUNITCHANGE'
    when @SCHEMA_TYPE_USER_SCHEMA then 'SCHEMA_TYPE_USER_SCHEMA'
    when @SCHEMA_TYPE_PRESNAPSHOTSCRIPT then 'SCHEMA_TYPE_PRESNAPSHOTSCRIPT'
    when @SCHEMA_TYPE_POSTSNAPSHOTSCRIPT then 'SCHEMA_TYPE_POSTSNAPSHOTSCRIPT'
    when @SCHEMA_TYPE_ONDEMANDUSERSCRIPT then 'SCHEMA_TYPE_ONDEMANDUSERSCRIPT'
    when @SCHEMA_TYPE_MERGEPROCEDURESCRIPT then 'SCHEMA_TYPE_MERGEPROCEDURESCRIPT'
    when @SCHEMA_TYPE_SNAPSHOTHEADERBEGIN then 'SCHEMA_TYPE_SNAPSHOTHEADERBEGIN'
    when @SCHEMA_TYPE_SNAPSHOTHEADEREND then 'SCHEMA_TYPE_SNAPSHOTHEADEREND'
    when @SCHEMA_TYPE_SNAPSHOTTRAILER then 'SCHEMA_TYPE_SNAPSHOTTRAILER'
    when @SCHEMA_TYPE_FTPADDRESS then 'SCHEMA_TYPE_FTPADDRESS'
    when @SCHEMA_TYPE_FTPPORT then 'SCHEMA_TYPE_FTPPORT'
    when @SCHEMA_TYPE_FTPSUBDIR then 'SCHEMA_TYPE_FTPSUBDIR'
    when @SCHEMA_TYPE_SNAPSHOTCOMPRESSED then 'SCHEMA_TYPE_SNAPSHOTCOMPRESSED'
    when @SCHEMA_TYPE_FTPLOGIN then 'SCHEMA_TYPE_FTPLOGIN'
    when @SCHEMA_TYPE_FTPPASSWORD then 'SCHEMA_TYPE_FTPPASSWORD'
    when @SCHEMA_TYPE_SYSPRESCRIPT then 'SCHEMA_TYPE_SYSPRESCRIPT'
    when @SCHEMA_TYPE_PROCSCHEMA then 'SCHEMA_TYPE_PROCSCHEMA'
    when @SCHEMA_TYPE_VIEWSCHEMA then 'SCHEMA_TYPE_VIEWSCHEMA'
    when @SCHEMA_TYPE_UDFSCHEMA then 'SCHEMA_TYPE_UDFSCHEMA'
    when @SCHEMA_TYPE_VIEWINDEXES then 'SCHEMA_TYPE_VIEWINDEXES'
    when @SCHEMA_TYPE_EXTENDEDPROPERTIES then 'SCHEMA_TYPE_EXTENDEDPROPERTIES'
    when @SCHEMA_TYPE_VALIDATE then 'SCHEMA_TYPE_VALIDATE'
    when @SCHEMA_TYPE_PRESNAPSHOTSQLCOMMAND then 'SCHEMA_TYPE_PRESNAPSHOTSQLCOMMAND'
    when @SCHEMA_TYPE_DYNSNAPVALIDATION then 'SCHEMA_TYPE_DYNSNAPVALIDATION'
    when @SCHEMA_TYPE_SYSTABLE_NATIVE_BCP_90 then 'SCHEMA_TYPE_SYSTABLE_NATIVE_BCP_90'
    when @SCHEMA_TYPE_SYSTABLE_CHAR_BCP_90 then 'SCHEMA_TYPE_SYSTABLE_CHAR_BCP_90'
    when @SCHEMA_TYPE_SYSTABLE_NATIVE_BCP_90_FORGLOBALONLY then 'SCHEMA_TYPE_SYSTABLE_NATIVE_BCP_90_FORGLOBALONLY'
    when @SCHEMA_TYPE_SYSTABLE_CHAR_BCP_90_FORGLOBALONLY then 'SCHEMA_TYPE_SYSTABLE_CHAR_BCP_90_FORGLOBALONLY'
    when @SCHEMA_TYPE_SYSTABLE_NATIVE_BCP_90_FORLIGHTWEIGHT then 'SCHEMA_TYPE_SYSTABLE_NATIVE_BCP_90_FORLIGHTWEIGHT'
    when @SCHEMA_TYPE_SYSTABLE_CHAR_BCP_90_FORLIGHTWEIGHT then 'SCHEMA_TYPE_SYSTABLE_CHAR_BCP_90_FORLIGHTWEIGHT'
    when @SCHEMA_TYPE_USER_DEFINED_DATA_TYPE then 'SCHEMA_TYPE_USER_DEFINED_DATA_TYPE'
    when @SCHEMA_TYPE_CLR_USER_DEFINED_DATA_TYPE then 'SCHEMA_TYPE_CLR_USER_DEFINED_DATA_TYPE'
    when @SCHEMA_TYPE_ASSEMBLY then 'SCHEMA_TYPE_ASSEMBLY'
    when @SCHEMA_TYPE_PARTITIONSCHEME then 'SCHEMA_TYPE_PARTITIONSCHEME'
    when @SCHEMA_TYPE_PARTITIONFUNCTION then 'SCHEMA_TYPE_PARTITIONFUNCTION'
    when @SCHEMA_TYPE_XMLSCHEMANAMESPACE then 'SCHEMA_TYPE_XMLSCHEMANAMESPACE'
    when @SCHEMA_TYPE_FULLTEXTCATALOG then 'SCHEMA_TYPE_FULLTEXTCATALOG'
    when @SCHEMA_TYPE_SYNONYM then 'SCHEMA_TYPE_SYNONYM'
    when @SCHEMA_TYPE_USER_DEFINED_TABLE_TYPE then 'SCHEMA_TYPE_USER_DEFINED_TABLE_TYPE'
    when @SCHEMA_TYPE_DYNAMICBCPBIT then 'SCHEMA_TYPE_DYNAMICBCPBIT'
    when @SCHEMA_TYPE_DYNAMICNATIVEBCP then 'SCHEMA_TYPE_DYNAMICNATIVEBCP'
    when @SCHEMA_TYPE_DYNAMICCHARBCP then 'SCHEMA_TYPE_DYNAMICCHARBCP'
    when @SCHEMA_TYPE_DYNAMIC_SYSTABLE_NATIVE_BCP_90 then 'SCHEMA_TYPE_DYNAMIC_SYSTABLE_NATIVE_BCP_90'
    when @SCHEMA_TYPE_DYNAMIC_SYSTABLE_CHAR_BCP_90 then 'SCHEMA_TYPE_DYNAMIC_SYSTABLE_CHAR_BCP_90'
    when @SCHEMA_TYPE_DYNAMIC_SYSTABLE_NATIVE_BCP_90_FORGLOBALONLY then 'SCHEMA_TYPE_DYNAMIC_SYSTABLE_NATIVE_BCP_90_FORGLOBALONLY'
    when @SCHEMA_TYPE_DYNAMIC_SYSTABLE_CHAR_BCP_90_FORGLOBALONLY then 'SCHEMA_TYPE_DYNAMIC_SYSTABLE_CHAR_BCP_90_FORGLOBALONLY'
    when @SCHEMA_TYPE_DYNAMIC_SYSTABLE_NATIVE_BCP_90_FORLIGHTWEIGHT then 'SCHEMA_TYPE_DYNAMIC_SYSTABLE_NATIVE_BCP_90_FORLIGHTWEIGHT'
    when @SCHEMA_TYPE_DYNAMIC_SYSTABLE_CHAR_BCP_90_FORLIGHTWEIGHT then 'SCHEMA_TYPE_DYNAMIC_SYSTABLE_CHAR_BCP_90_FORLIGHTWEIGHT'
    when @SCHEMA_TYPE_DDL_ACTIONS then 
        case @schemasubtype 
            when @schemasubtype_addcolumn then 'SCHEMA_TYPE_DDL_ACTIONS_ADDCOLUMN'
            when @schemasubtype_dropcolumn then 'SCHEMA_TYPE_DDL_ACTIONS_DROPCOLUMN'
            when @schemasubtype_altercolumn then 'SCHEMA_TYPE_DDL_ACTIONS_ALTERCOLUMN'
            when @schemasubtype_addpk then 'SCHEMA_TYPE_DDL_ACTIONS_ADDPRIMARYKEY'
            when @schemasubtype_addun then 'SCHEMA_TYPE_DDL_ACTIONS_ADDUNIQUE'
            when @schemasubtype_addfk then 'SCHEMA_TYPE_DDL_ACTIONS_ADDREFERENCE'
            when @schemasubtype_dropconstraint then 'SCHEMA_TYPE_DDL_ACTIONS_DROPCONSTRAINT'
            when @schemasubtype_adddf then 'SCHEMA_TYPE_DDL_ACTIONS_ADDDEFAULT'
            when @schemasubtype_addchk then 'SCHEMA_TYPE_DDL_ACTIONS_ADDCHECK'
            when @schemasubtype_disabletrigger then 'SCHEMA_TYPE_DDL_ACTIONS_DISABLETRIGGER'
            when @schemasubtype_enabletrigger then 'SCHEMA_TYPE_DDL_ACTIONS_ENABLETRIGGER'
            when @schemasubtype_disabletriggerall then 'SCHEMA_TYPE_DDL_ACTIONS_DISABLETRIGGER'
            when @schemasubtype_enabletriggerall then 'SCHEMA_TYPE_DDL_ACTIONS_ENABLETRIGGER'
            when @schemasubtype_enableconstraint then 'SCHEMA_TYPE_DDL_ACTIONS_ENABLECONSTRAINT'
            when @schemasubtype_disableconstraint then 'SCHEMA_TYPE_DDL_ACTIONS_DISABLECONSTRAINT'
            when @schemasubtype_enableconstraintall then 'SCHEMA_TYPE_DDL_ACTIONS_ENABLECONSTRAINT'
            when @schemasubtype_disableconstraintall then 'SCHEMA_TYPE_DDL_ACTIONS_DISABLECONSTRAINT'
            else 'SCHEMA_TYPE_DDL_ACTIONS'
        end
    when @SCHEMA_TYPE_DDL_RELATED_COLUMN_FIXUP then 'SCHEMA_TYPE_DDL_RELATED_COLUMN_FIXUP'
    when @SCHEMA_TYPE_CHANGE_MERGE_PUBLICATION_90RTM then 'SCHEMA_TYPE_CHANGE_MERGE_PUBLICATION_90RTM'
    when @SCHEMA_TYPE_CHANGE_MERGE_ARTICLE_90RTM then 'SCHEMA_TYPE_CHANGE_MERGE_ARTICLE_90RTM'
    when @SCHEMA_TYPE_INCREMENTALSNAPSHOTCONTROL then 'SCHEMA_TYPE_INCREMENTALSNAPSHOTCONTROL'
    when @SCHEMA_TYPE_INCREMENTALALTSNAPSHOTFOLDER then 'SCHEMA_TYPE_INCREMENTALALTSNAPSHOTFOLDER'
    when @SCHEMA_TYPE_INCREMENTALSNAPSHOTHEADERBEGIN then 'SCHEMA_TYPE_INCREMENTALSNAPSHOTHEADERBEGIN'
    when @SCHEMA_TYPE_INCREMENTALSNAPSHOTHEADEREND then 'SCHEMA_TYPE_INCREMENTALSNAPSHOTHEADEREND'
    when @SCHEMA_TYPE_INCREMENTALSNAPSHOTTRAILER then 'SCHEMA_TYPE_INCREMENTALSNAPSHOTTRAILER'
    when @SCHEMA_TYPE_INCREMENTALFTPADDRESS then 'SCHEMA_TYPE_INCREMENTALFTPADDRESS'
    when @SCHEMA_TYPE_INCREMENTALFTPPORT then 'SCHEMA_TYPE_INCREMENTALFTPPORT'
    when @SCHEMA_TYPE_INCREMENTALFTPSUBDIR then 'SCHEMA_TYPE_INCREMENTALFTPSUBDIR'
    when @SCHEMA_TYPE_INCREMENTALSNAPSHOTCOMPRESSED then 'SCHEMA_TYPE_INCREMENTALSNAPSHOTCOMPRESSED'
    when @SCHEMA_TYPE_INCREMENTALFTPLOGIN then 'SCHEMA_TYPE_INCREMENTALFTPLOGIN'
    when @SCHEMA_TYPE_INCREMENTALFTPPASSWORD then 'SCHEMA_TYPE_INCREMENTALFTPPASSWORD'
    else 'SCHEMA_TYPE_INVALID'
    end
    return @friendly_schematype
end
GO
  
~~~

---
### See also
[List of functions](../functions.md)

