## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[dm_db_database_page_allocations\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.dm_db_database_page_allocations**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Inline |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -466280530 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@DatabaseId| |smallint|2|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@TableId| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@IndexId| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@PartitionId| |bigint|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@Mode| |nvarchar|64|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|database_id|int|4|
|object_id|int|4|
|index_id|int|4|
|partition_id|int|4|
|rowset_id|bigint|8|
|allocation_unit_id|bigint|8|
|allocation_unit_type|int|4|
|allocation_unit_type_desc|nvarchar|60|
|data_clone_id|int|4|
|clone_state|int|4|
|clone_state_desc|nvarchar|9|
|extent_file_id|smallint|2|
|extent_page_id|int|4|
|allocated_page_iam_file_id|smallint|2|
|allocated_page_iam_page_id|int|4|
|allocated_page_file_id|smallint|2|
|allocated_page_page_id|int|4|
|is_allocated|tinyint|1|
|is_iam_page|tinyint|1|
|is_mixed_page_allocation|tinyint|1|
|page_free_space_percent|int|4|
|page_type|int|4|
|page_type_desc|nvarchar|256|
|page_level|tinyint|1|
|next_page_file_id|smallint|2|
|next_page_page_id|int|4|
|previous_page_file_id|smallint|2|
|previous_page_page_id|int|4|
|is_page_compressed|tinyint|1|
|has_ghost_records|tinyint|1|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[dm_db_database_page_allocations\]
 No dependencies exist

---
### Objects that \[sys\].\[dm_db_database_page_allocations\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create function sys.dm_db_database_page_allocations
    (
    @DatabaseId            SMALLINT,
    @TableId            INT             = NULL,
    @IndexId             INT             = NULL,
    @PartitionId        BIGINT            = NULL,
    @Mode                NVARCHAR(64)    = 'LIMITED'
    )
returns table
as
    return select DA.[database_id], DA.[object_id], DA.[index_id], DA.[partition_id], DA.[rowset_id],
        DA.[allocation_unit_id], DA.[allocation_unit_type], IP.[name] as 'allocation_unit_type_desc',
        DA.[data_clone_id], DA.[data_clone_state] as 'clone_state',
        case (DA.[data_clone_state]) when 0 then N'PRIMARY' else N'SECONDARY' end AS clone_state_desc,
        DA.[extent_file_id], DA.[extent_page_id],
        DA.[allocated_page_iam_file_id], DA.allocated_page_iam_page_id, DA.[allocated_page_file_id], DA.allocated_page_page_id,
        DA.is_allocated, DA.is_iam_page, DA.is_mixed_page_allocation, DA.page_free_space_percent,
        DA.page_type, DA.page_type_desc, DA.page_level, DA.next_page_file_id, DA.next_page_page_id, DA.previous_page_file_id, DA.previous_page_page_id,
        DA.is_page_compressed, DA.has_ghost_records
    from openrowset (table DM_DB_DATABASE_ALLOCATIONS, @DatabaseId, @TableId, @IndexId, @PartitionId, @Mode) DA
        JOIN sys.syspalvalues IP ON IP.[class] = 'AUTY' AND IP.[value] = DA.[allocation_unit_type]
GO
  
~~~

---
### See also
[List of functions](../functions.md)

