## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[fn_sqlagent_jobsteps\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.fn_sqlagent_jobsteps**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Table |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -474931775 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@job_id| |uniqueidentifier|16|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@step_id| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|job_id|uniqueidentifier|16|
|step_id|int|4|
|step_name|nvarchar|128|
|subsystem|nvarchar|40|
|command|nvarchar|2147483647|
|flags|int|4|
|additional_parameters|nvarchar|2147483647|
|cmdexec_success_code|int|4|
|on_success_action|tinyint|1|
|on_success_step_id|int|4|
|on_fail_action|tinyint|1|
|on_fail_step_id|int|4|
|server|nvarchar|128|
|database_name|nvarchar|128|
|database_user_name|nvarchar|128|
|retry_attempts|int|4|
|retry_interval|int|4|
|os_run_priority|int|4|
|output_file_name|nvarchar|200|
|last_run_outcome|int|4|
|last_run_duration|int|4|
|last_run_retries|int|4|
|last_run_date|int|4|
|last_run_time|int|4|
|step_uid|uniqueidentifier|16|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[fn_sqlagent_jobsteps\]
 No dependencies exist

---
### Objects that \[sys\].\[fn_sqlagent_jobsteps\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION sys.fn_sqlagent_jobsteps(
    @job_id UNIQUEIDENTIFIER NULL,
    @step_id INT NULL
)
RETURNS @agent_jobsteps TABLE (
        job_id                  UNIQUEIDENTIFIER    NOT NULL,
        step_id                 INT                 NOT NULL, 
        step_name               SYSNAME             NOT NULL, 
        subsystem               NVARCHAR(40)        NOT NULL, 
        command                 NVARCHAR(MAX)       NULL, 
        flags                   INT                 NOT NULL, 
        additional_parameters   NVARCHAR(MAX)       NULL, 
        cmdexec_success_code    INT                 NOT NULL, 
        on_success_action       TINYINT             NOT NULL, 
        on_success_step_id      INT                 NOT NULL, 
        on_fail_action          TINYINT             NOT NULL, 
        on_fail_step_id         INT                 NOT NULL, 
        [server]                SYSNAME             NULL, 
        database_name           SYSNAME             NULL, 
        database_user_name      SYSNAME             NULL, 
        retry_attempts          INT                 NOT NULL, 
        retry_interval          INT                 NOT NULL, 
        os_run_priority         INT                 NOT NULL, 
        output_file_name        NVARCHAR(200)       NULL, 
        last_run_outcome        INT                 NOT NULL, 
        last_run_duration       INT                 NOT NULL, 
        last_run_retries        INT                 NOT NULL, 
        last_run_date           INT                 NOT NULL, 
        last_run_time           INT                 NOT NULL, 
        step_uid                UNIQUEIDENTIFIER    NOT NULL
    )
AS
BEGIN
    -- Check if we are in msdb database context
    IF(LOWER(DB_NAME()) = 'msdb')
    BEGIN
        INSERT INTO @agent_jobsteps
        SELECT job_id,
            step_id,
            step_name,
            subsystem,
            command,
            flags,
            additional_parameters,
            cmdexec_success_code,
            on_success_action,
            on_success_step_id,
            on_fail_action,
            on_fail_step_id ,
            [server],
            database_name,
            database_user_name,
            retry_attempts,
            retry_interval,
            os_run_priority,
            output_file_name, 
            last_run_outcome,
            last_run_duration,
            last_run_retries,
            last_run_date,
            last_run_time,
            step_uid 
            FROM sys.sqlagent_jobsteps
        WHERE ISNULL(@job_id, job_id) = job_id
        AND ISNULL(@step_id, step_id) = step_id 
    END
    RETURN
END
GO
  
~~~

---
### See also
[List of functions](../functions.md)

