## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[dm_sql_referenced_entities\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.dm_sql_referenced_entities**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Inline |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -481970182 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@name| |nvarchar|517|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@referencing_class| |nvarchar|60|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|referencing_minor_id|int|4|
|referenced_server_name|nvarchar|128|
|referenced_database_name|nvarchar|128|
|referenced_schema_name|nvarchar|128|
|referenced_entity_name|nvarchar|128|
|referenced_minor_name|nvarchar|128|
|referenced_id|int|4|
|referenced_minor_id|int|4|
|referenced_class|tinyint|1|
|referenced_class_desc|nvarchar|60|
|is_caller_dependent|bit|1|
|is_ambiguous|bit|1|
|is_selected|bit|1|
|is_updated|bit|1|
|is_select_all|bit|1|
|is_all_columns_found|bit|1|
|is_insert_all|bit|1|
|is_incomplete|bit|1|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[dm_sql_referenced_entities\]
 No dependencies exist

---
### Objects that \[sys\].\[dm_sql_referenced_entities\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION sys.dm_sql_referenced_entities(@name nvarchar(517), @referencing_class nvarchar(60)= N'OBJECT')
RETURNS TABLE
AS           
    RETURN 
        -- Get dependency information from the STVF (This will return nothing if @name is schema bound)
        -- FHasSQLDefinitionAccess is checked in the STVF
        SELECT
            referencing_minor_id,
            referenced_server_name,
            referenced_database_name,
            referenced_schema_name,
            referenced_entity_name,
            referenced_minor_name,
            referenced_id,
            referenced_minor_id,
            referenced_class,
            referenced_class_desc,
            is_caller_dependent,
            is_ambiguous,
            is_selected,
            is_updated,
            is_select_all,
            is_all_columns_found,
            is_insert_all,
            is_incomplete
        FROM OPENROWSET(TABLE DM_SQL_REFERENCED_ENTITIES, @name, @referencing_class)
        UNION ALL
        -- Get dependency information for schema bound entities from the view.
        SELECT
           dp.referencing_minor_id as referencing_minor_id,
           NULL AS referenced_server_name,
           NULL AS referenced_database_name,
           dp.referenced_schema_name AS referenced_schema_name,
           dp.referenced_entity_name AS referenced_entity_name,
           dp.referenced_minor_name as referenced_minor_name,
           dp.referenced_id AS referenced_id,
           dp.referenced_minor_id AS referenced_minor_id,
           dp.referenced_class AS referenced_class,
           dp.referenced_class_desc AS referenced_class_desc,
           sysconv(bit, 0) AS is_caller_dependent,
           sysconv(bit, 0) AS is_ambiguous,
           is_selected,
           is_updated,
           is_select_all,
           sysconv(bit, 1) AS is_all_columns_found,    -- 1 because for columns of tables which become schema-bound 
                                                       -- when they are used in computed columns, we should show 1
           is_insert_all,
           sysconv(bit, 0) as is_incomplete
       FROM sys.sql_expression_dependencies$ dp
       WHERE dp.is_schema_bound_reference = 1
           AND dp.referencing_id = entity_id(parsename(@name, 4), 
                        parsename(@name, 3), 
                        parsename(@name, 2), 
                        parsename(@name, 1), 
                        CASE LOWER (@referencing_class collate Latin1_General_CI_AS)
                        WHEN N'object' THEN 1
                        ELSE 0 
                        END,
                        0, 
                        NULL)
           AND has_access('OD', object_id(@name)) = 1
GO
  
~~~

---
### See also
[List of functions](../functions.md)

