## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[dm_db_index_operational_stats\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.dm_db_index_operational_stats**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Inline |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -500638940 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@DatabaseId| |smallint|2|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@TableId| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@IndexId| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@PartitionNumber| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|database_id|smallint|2|
|object_id|int|4|
|index_id|int|4|
|partition_number|int|4|
|hobt_id|bigint|8|
|leaf_insert_count|bigint|8|
|leaf_delete_count|bigint|8|
|leaf_update_count|bigint|8|
|leaf_ghost_count|bigint|8|
|nonleaf_insert_count|bigint|8|
|nonleaf_delete_count|bigint|8|
|nonleaf_update_count|bigint|8|
|leaf_allocation_count|bigint|8|
|nonleaf_allocation_count|bigint|8|
|leaf_page_merge_count|bigint|8|
|nonleaf_page_merge_count|bigint|8|
|range_scan_count|bigint|8|
|singleton_lookup_count|bigint|8|
|forwarded_fetch_count|bigint|8|
|lob_fetch_in_pages|bigint|8|
|lob_fetch_in_bytes|bigint|8|
|lob_orphan_create_count|bigint|8|
|lob_orphan_insert_count|bigint|8|
|row_overflow_fetch_in_pages|bigint|8|
|row_overflow_fetch_in_bytes|bigint|8|
|column_value_push_off_row_count|bigint|8|
|column_value_pull_in_row_count|bigint|8|
|row_lock_count|bigint|8|
|row_lock_wait_count|bigint|8|
|row_lock_wait_in_ms|bigint|8|
|page_lock_count|bigint|8|
|page_lock_wait_count|bigint|8|
|page_lock_wait_in_ms|bigint|8|
|index_lock_promotion_attempt_count|bigint|8|
|index_lock_promotion_count|bigint|8|
|page_latch_wait_count|bigint|8|
|page_latch_wait_in_ms|bigint|8|
|page_io_latch_wait_count|bigint|8|
|page_io_latch_wait_in_ms|bigint|8|
|tree_page_latch_wait_count|bigint|8|
|tree_page_latch_wait_in_ms|bigint|8|
|tree_page_io_latch_wait_count|bigint|8|
|tree_page_io_latch_wait_in_ms|bigint|8|
|page_compression_attempt_count|bigint|8|
|page_compression_success_count|bigint|8|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[dm_db_index_operational_stats\]
 No dependencies exist

---
### Objects that \[sys\].\[dm_db_index_operational_stats\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create function sys.dm_db_index_operational_stats
    (
    @DatabaseId            SMALLINT    = 0,
    @TableId            INT         = 0,
    @IndexId             INT         = -1,
    @PartitionNumber    INT            = 0
    )
returns table
as
    return select *
    from OpenRowset
            (    TABLE
                VIRTUALINDEXSTATS,
                @DatabaseId,
                @TableId,
                @IndexId,
                @PartitionNumber)
GO
  
~~~

---
### See also
[List of functions](../functions.md)

