## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[fn_hadr_is_same_replica\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.fn_hadr_is_same_replica**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 06/15/2019 |
| Type | Scalar |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -604437957 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@lag_id| |uniqueidentifier|16|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@lag_replica_id| |uniqueidentifier|16|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@ag_replica_id| |uniqueidentifier|16|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|@Return|bit|1|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[fn_hadr_is_same_replica\]
 No dependencies exist

---
### Objects that \[sys\].\[fn_hadr_is_same_replica\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE function sys.fn_hadr_is_same_replica(
    @lag_id uniqueidentifier,
    @lag_replica_id uniqueidentifier,
    @ag_replica_id uniqueidentifier)
returns bit
as
begin
     declare @ag_id uniqueidentifier
     declare @local_replica_id uniqueidentifier
     declare @ret bit

     SELECT @ag_id = group_id
     FROM sys.fn_hadr_distributed_ag_replica(@lag_id, @lag_replica_id)

     SELECT @local_replica_id = replica_id
     FROM sys.dm_hadr_internal_availability_replica_states
     WHERE group_id = @ag_id AND is_local = 1

     set @ret = case when (@local_replica_id = @ag_replica_id) then 1 else 0 end

     return @ret
end
GO
  
~~~

---
### See also
[List of functions](../functions.md)

