## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[fn_GetRowsetIdFromRowDump\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.fn_GetRowsetIdFromRowDump**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Scalar |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -633331936 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@rowdump| |varbinary|2147483647|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|@Return|bigint|8|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[fn_GetRowsetIdFromRowDump\]
 No dependencies exist

---
### Objects that \[sys\].\[fn_GetRowsetIdFromRowDump\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
-------------------------------------------------------------------------------
-- Name: sys.fn_GetRowsetIdFromRowDump
--
-- Description:
--    Cracks the output of %%rowdump%% virtual column and returns the rowset id
--
-- Notes:
-------------------------------------------------------------------------------
CREATE FUNCTION sys.fn_GetRowsetIdFromRowDump (@rowdump AS varbinary (max))
RETURNS BIGINT
AS
BEGIN
    declare @offset INT
    declare @rowsetId BIGINT

    set @offset = 1

    -- Check there are enough bytes for partition_id
    --
    if (datalength (@rowdump) &lt; 8)
    BEGIN
        RETURN NULL
    END

    -- Rowset id is first 8 bytes
    --
    select @rowsetId = convert (bigint, convert (binary (8), reverse (substring (@rowdump, @offset, 8))))
    RETURN @rowsetId
END
GO
  
~~~

---
### See also
[List of functions](../functions.md)

