## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[fn_get_audit_file\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.fn_get_audit_file**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Inline |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -647968877 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@file_pattern| |nvarchar|260|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@initial_file_name| |nvarchar|260|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@audit_record_offset| |bigint|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|event_time|datetime2|8|
|sequence_number|int|4|
|action_id|varchar|4|
|succeeded|bit|1|
|permission_bitmask|varbinary|16|
|is_column_permission|bit|1|
|session_id|smallint|2|
|server_principal_id|int|4|
|database_principal_id|int|4|
|target_server_principal_id|int|4|
|target_database_principal_id|int|4|
|object_id|int|4|
|class_type|varchar|2|
|session_server_principal_name|nvarchar|128|
|server_principal_name|nvarchar|128|
|server_principal_sid|varbinary|85|
|database_principal_name|nvarchar|128|
|target_server_principal_name|nvarchar|128|
|target_server_principal_sid|varbinary|85|
|target_database_principal_name|nvarchar|128|
|server_instance_name|nvarchar|128|
|database_name|nvarchar|128|
|schema_name|nvarchar|128|
|object_name|nvarchar|128|
|statement|nvarchar|4000|
|additional_information|nvarchar|4000|
|file_name|nvarchar|260|
|audit_file_offset|bigint|8|
|user_defined_event_id|smallint|2|
|user_defined_information|nvarchar|4000|
|audit_schema_version|int|4|
|sequence_group_id|varbinary|85|
|transaction_id|bigint|8|
|client_ip|nvarchar|128|
|application_name|nvarchar|128|
|duration_milliseconds|bigint|8|
|response_rows|bigint|8|
|affected_rows|bigint|8|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[fn_get_audit_file\]
 No dependencies exist

---
### Objects that \[sys\].\[fn_get_audit_file\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE FUNCTION sys.fn_get_audit_file (
    @file_pattern nvarchar(260), 
    @initial_file_name nvarchar(260) = NULL, 
    @audit_record_offset bigint = NULL)
RETURNS table
AS
    RETURN SELECT     
        event_time, 
        sequence_number, 
        action_id, 
        succeeded, 
        permission_bitmask, 
        is_column_permission, 
        session_id, 
        server_principal_id, 
        database_principal_id, 
        target_server_principal_id, 
        target_database_principal_id, 
        object_id, 
        class_type,             
        session_server_principal_name, 
        server_principal_name, 
        server_principal_sid, 
        database_principal_name, 
        target_server_principal_name, 
        target_server_principal_sid, 
        target_database_principal_name, 
        server_instance_name, 
        database_name, 
        schema_name, 
        object_name, 
        statement, 
        additional_information, 
        file_name, 
        audit_file_offset,
        user_defined_event_id,
         user_defined_information,
         audit_schema_version,
         sequence_group_id,
        transaction_id,
        client_ip,
        application_name,
        duration_milliseconds,
        response_rows,
        affected_rows
    FROM OpenRowSet(TABLE FN_GET_AUDIT_FILE, @file_pattern, @initial_file_name, @audit_record_offset)
GO
  
~~~

---
### See also
[List of functions](../functions.md)

