## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[fn_cdc_map_time_to_lsn\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.fn_cdc_map_time_to_lsn**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Scalar |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -65585398 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@relational_operator| |nvarchar|30|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@tracking_time| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|@Return|binary|10|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[fn_cdc_map_time_to_lsn\]
 No dependencies exist

---
### Objects that \[sys\].\[fn_cdc_map_time_to_lsn\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create function [sys].[fn_cdc_map_time_to_lsn]                
(                                                        
    @relational_operator nvarchar(30),
    @tracking_time datetime                                    
)                                                        
returns binary(10)
with returns null on null input
as                                                    
begin                                                    
    declare @lsn binary(10)
    
    select @relational_operator = rtrim(ltrim(lower(@relational_operator)))
        
    if (@relational_operator not in (N'largest less than',     N'largest less than or equal',
                                     N'smallest greater than', N'smallest greater than or equal'))
    begin
        return null
    end

    set @lsn = null
    if (@relational_operator = N'largest less than')
    begin
        select @lsn = max(start_lsn)
        from [cdc].[lsn_time_mapping]
        where tran_end_time &lt; @tracking_time
    end
    
    else if (@relational_operator = N'largest less than or equal')
    begin
        select @lsn = max(start_lsn)
        from [cdc].[lsn_time_mapping]
        where tran_end_time &lt;= @tracking_time
    end
    
    else if (@relational_operator = N'smallest greater than')
    begin
        select @lsn = min(start_lsn)
        from [cdc].[lsn_time_mapping]
        where tran_end_time &gt; @tracking_time
    end

    else if (@relational_operator = N'smallest greater than or equal')
    begin
        select @lsn = min(start_lsn)
        from [cdc].[lsn_time_mapping]
        where tran_end_time &gt;= @tracking_time
    end
    return @lsn                                        
end                                                
GO
  
~~~

---
### See also
[List of functions](../functions.md)

