## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[fn_repladjustcolumnmap\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.fn_repladjustcolumnmap**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Scalar |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -661149850 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@objid| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@total_col| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@inmap| |varbinary|4000|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|@Return|varbinary|4000|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[fn_repladjustcolumnmap\]
 No dependencies exist

---
### Objects that \[sys\].\[fn_repladjustcolumnmap\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create function sys.fn_repladjustcolumnmap
(
    @objid    int
    ,@total_col int
    ,@inmap varbinary(4000)
) 
returns varbinary(4000)
as
begin
    declare @colmap table (relativeorder int identity(1,1), colid int)
    declare
        @outmap varbinary(4000)
        ,@relpos int
        ,@colid int
        ,@bytepos int
        ,@bitpos int
        ,@num_bytes int

    --
    -- initialize
    --
    select @outmap = cast(0 as binary(4000))
    insert into @colmap (colid)
        select column_id from sys.columns where object_id = @objid order by column_id
    if (@@error != 0)
    begin
        return cast(NULL as varbinary(4000))
    end

    --
    -- for each column in the column map
    --
    declare #colmap_cursor cursor local fast_forward for 
        select relativeorder, colid from @colmap 
        order by relativeorder
    for read only

    open #colmap_cursor
    fetch #colmap_cursor into @relpos, @colid
    while (@@fetch_status = 0)
    begin
        --
        -- select the absolute column position
        --
        select @bytepos = 1 + ((@colid-1) / 8)
            ,@bitpos =  power(2, (@colid-1) % 8 ) 

        if (substring(@inmap, @bytepos, 1) &amp; @bitpos = @bitpos)
        begin
            --
            -- set the relative position for this column in the output
            --
            select @bytepos = 1 + ((@relpos-1) / 8)
                ,@bitpos =  power(2, (@relpos-1) % 8 )
                ,@num_bytes = @total_col / 8 + 1

            select @outmap = substring(@outmap, 1, (@bytepos - 1)) + 
                (convert(binary(1), substring(@outmap, @bytepos, 1) | convert(tinyint,@bitpos))) + 
                substring(@outmap, (@bytepos + 1), (@num_bytes - @bytepos))
        end

        -- fetch next column mapping
        fetch #colmap_cursor into @relpos, @colid        
    end
    close #colmap_cursor
    deallocate #colmap_cursor

    return @outmap
end
GO
  
~~~

---
### See also
[List of functions](../functions.md)

