## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[dm_sql_referencing_entities\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.dm_sql_referencing_entities**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Inline |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -686951493 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@name| |nvarchar|517|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@referenced_class| |nvarchar|60|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|referencing_schema_name|nvarchar|128|
|referencing_entity_name|nvarchar|128|
|referencing_id|int|4|
|referencing_class|tinyint|1|
|referencing_class_desc|nvarchar|60|
|is_caller_dependent|bit|1|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[dm_sql_referencing_entities\]
 No dependencies exist

---
### Objects that \[sys\].\[dm_sql_referencing_entities\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION sys.dm_sql_referencing_entities(@name nvarchar(517), @referenced_class nvarchar(60))
    RETURNS TABLE
    AS           
    RETURN 
        SELECT DISTINCT
            d.referencing_schema_name as referencing_schema_name,
            d.referencing_entity_name as referencing_entity_name,
            d.referencing_id as referencing_id, 
            d.referencing_class as referencing_class, 
            d.referencing_class_desc as referencing_class_desc, 
            d.is_caller_dependent as is_caller_dependent 
        FROM sys.sql_expression_dependencies$ as d 
        WHERE d.referenced_class =     CASE LOWER (@referenced_class collate Latin1_General_CI_AS) 
                                    WHEN N'object' THEN 1 
                                    WHEN N'type' THEN 6
                                    WHEN N'xml_schema_collection' THEN 10 
                                    WHEN N'partition_function' THEN 21 
                                    ELSE 0 END
            AND d.referenced_entity_name = parsename(@name, 1)
            AND 
            (-- Match by id (if caller dependent, then id will be NULL)
            d.referenced_id = entity_id(parsename(@name, 4), 
                        parsename(@name, 3), 
                        parsename(@name, 2), 
                        parsename(@name, 1), 
                        CASE LOWER (@referenced_class collate Latin1_General_CI_AS)
                        WHEN N'object' THEN 1
                        WHEN N'type' THEN 6 
                        WHEN N'xml_schema_collection' THEN 10 
                        WHEN N'partition_function' THEN 21 
                        ELSE 0 
                        END,
                        0, 
                        NULL)
            OR
            -- Match by name if caller dependent ref. and the referencing object is on this server in the current DB. 
            -- This will show all possible caller dependent references on the given object. 
            ((d.is_caller_dependent = 1 AND 
                (d.referenced_database_name IS NULL OR
                    ((d.referenced_server_name IS NULL OR d.referenced_server_name = @@SERVERNAME) AND (d.referenced_database_name = N'' OR d.referenced_database_name = DB_NAME()))))
            ))
            AND    -- Permissions on referenced object : None
                -- Permissions on referencing objects: As of now sys. dm_sql_referencing_entities returns 3 classes of entities:
                --    1.    Object - VIEW DEFINITION on the object
                --    2.    Database-level DDL trigger- VIEW DEFINITION on the database
                --    3.    Server-level DDL trigger- VIEW ANY DEFINITION
                CASE d.referencing_class
                WHEN 1 THEN has_access('OD', d.referencing_id)                
                WHEN 12 THEN has_perms_by_name(quotename(db_name()), 'DATABASE', 'VIEW DEFINITION')
                WHEN 13 THEN has_perms_by_name(NULL,NULL, 'VIEW ANY DEFINITION')
                ELSE 0
                END = 1
GO
  
~~~

---
### See also
[List of functions](../functions.md)

