## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[dm_io_virtual_file_stats\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.dm_io_virtual_file_stats**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Inline |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -806439612 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@DatabaseId| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@FileId| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|database_id|smallint|2|
|file_id|smallint|2|
|sample_ms|bigint|8|
|num_of_reads|bigint|8|
|num_of_bytes_read|bigint|8|
|io_stall_read_ms|bigint|8|
|io_stall_queued_read_ms|bigint|8|
|num_of_writes|bigint|8|
|num_of_bytes_written|bigint|8|
|io_stall_write_ms|bigint|8|
|io_stall_queued_write_ms|bigint|8|
|io_stall|bigint|8|
|size_on_disk_bytes|bigint|8|
|file_handle|varbinary|8|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[dm_io_virtual_file_stats\]
 No dependencies exist

---
### Objects that \[sys\].\[dm_io_virtual_file_stats\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE FUNCTION sys.dm_io_virtual_file_stats
    (
    @DatabaseId Int = null,
    @FileId Int = null
    )
RETURNS TABLE
as
    RETURN SELECT 
            database_id,
            file_id,
            sample_ms,
            num_of_reads,
            num_of_bytes_read,
            io_stall_read_ms,
            io_stall_queued_read_ms,
            num_of_writes,
            num_of_bytes_written,
            io_stall_write_ms,
            io_stall_queued_write_ms,
            io_stall,
            size_on_disk_bytes,
            file_handle
        FROM OpenRowset(TABLE VIRTUALFILESTATS, @DatabaseId, @FileId)
GO
  
~~~

---
### See also
[List of functions](../functions.md)

