## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[fn_MStestbit\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.fn_MStestbit**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Scalar |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -831527161 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@bitmap| |varbinary|128|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@colidx| |smallint|2|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|@Return|bit|1|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[fn_MStestbit\]
 No dependencies exist

---
### Objects that \[sys\].\[fn_MStestbit\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create function sys.fn_MStestbit (@bitmap varbinary(128), @colidx smallint)
returns bit
as
begin
    -- size of bitmap is 1024 bits
    if @colidx &lt; 1 or @colidx &gt; 1024 return 0

    declare @byte binary(1)
    declare @mask tinyint
    declare @idxinbyte tinyint
    declare @shift tinyint

    set @byte= substring(@bitmap, (@colidx-1)/8+1, 1)
    set @shift= @colidx%8
    if @shift = 0
        set @shift= 7
    else
        set @shift= @shift -1
    set @mask= power(2, @shift)
    return @byte &amp; @mask
end
GO
  
~~~

---
### See also
[List of functions](../functions.md)

