## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[fn_sqlagent_jobs\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.fn_sqlagent_jobs**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Table |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -836572785 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@job_id| |uniqueidentifier|16|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|job_id|uniqueidentifier|16|
|name|nvarchar|128|
|enabled|bit|1|
|description|nvarchar|512|
|start_step_id|int|4|
|notify_level_eventlog|bit|1|
|delete_level|int|4|
|date_created|datetime|8|
|date_modified|datetime|8|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[fn_sqlagent_jobs\]
 No dependencies exist

---
### Objects that \[sys\].\[fn_sqlagent_jobs\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION sys.fn_sqlagent_jobs(
    @job_id UNIQUEIDENTIFIER NULL 
 )
RETURNS @agent_jobs TABLE (
        job_id                  UNIQUEIDENTIFIER    NOT NULL, 
        name                    SYSNAME             NOT NULL, 
        [enabled]               BIT                 NOT NULL, 
        [description]           NVARCHAR(512)       NULL, 
        start_step_id           INT                 NOT NULL, 
        notify_level_eventlog   BIT                 NOT NULL, 
        delete_level            INT                 NOT NULL, 
        date_created            DATETIME            NOT NULL, 
        date_modified           DATETIME            NOT NULL 
    )
AS
BEGIN
    -- Check if we are in msdb database context
    IF(LOWER(DB_NAME()) = 'msdb')
    BEGIN
        INSERT INTO @agent_jobs
        SELECT job_id,
            name,
            [enabled],
            [description],
            start_step_id,
            notify_level_eventlog,
            delete_level,
            date_created,
            date_modified
        FROM sys.sqlagent_jobs
        WHERE ISNULL(@job_id, job_id) = job_id
    END
    RETURN
END
GO
  
~~~

---
### See also
[List of functions](../functions.md)

