## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[fn_repldecryptver4\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.fn_repldecryptver4**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Scalar |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -882476690 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@password| |nvarchar|524|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|@Return|nvarchar|524|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[fn_repldecryptver4\]
 No dependencies exist

---
### Objects that \[sys\].\[fn_repldecryptver4\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
--
-- Name: 
--    fn_repldecryptver4
-- 
-- Description: 
--    This function accepts an encrypted password as input 
--    and decrypts the value using the server provided crypto 
--    based on the master key created in the local database. 
--    If it detects that the logged on user is not DBO or that
--    the password has not been encrypted using the server dpapi
--    then the original password input is returned.
--
-- Parameters: 
--    See the procedure definition.
--
-- Returns: 
--    0 - On Success
--    1 - On Failure
--
-- Result: 
--    None
--
-- Security: 
--    DBO (func is public because snapshot agent calls it)
--
CREATE FUNCTION sys.fn_repldecryptver4 
(
    @password nvarchar(524)
)
RETURNS nvarchar(524)
AS
BEGIN
    -- if we are dbo and the encryption on the password
    -- is version 4 then we will decrypt using the cert
    IF IS_MEMBER('db_owner') = 1
        AND sys.fn_replencryptversion(@password) = 4
        AND EXISTS(SELECT *
                    FROM sys.symmetric_keys 
                    WHERE name = '##MS_DatabaseMasterKey##')
        AND EXISTS(SELECT *
                    FROM sys.symmetric_keys 
                    WHERE name = 'SQLSERVER_REPLICATION')
    BEGIN
        SELECT @password = CONVERT(nvarchar(524), DECRYPTBYKEYAUTOCERT(CERT_ID('SQLSERVER_REPLICATION'), NULL, CONVERT(varbinary(4000), RIGHT(@password, LEN(@password) - 4))))
    END

    RETURN @password
END
GO
  
~~~

---
### See also
[List of functions](../functions.md)

