## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[fn_sqlagent_jobsteps_logs\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.fn_sqlagent_jobsteps_logs**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Table |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -921000736 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@step_uid| |uniqueidentifier|16|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|log_id|int|4|
|log_text|nvarchar|2147483647|
|date_created|datetime|8|
|step_uid|uniqueidentifier|16|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[fn_sqlagent_jobsteps_logs\]
 No dependencies exist

---
### Objects that \[sys\].\[fn_sqlagent_jobsteps_logs\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION sys.fn_sqlagent_jobsteps_logs(
    @step_uid UNIQUEIDENTIFIER NULL
 )
RETURNS @jobstep_logs TABLE (
        [log_id]        INT NOT NULL,
        [log_text]      NVARCHAR(MAX) NOT NULL,
        [date_created]  DATETIME NOT NULL,
        [step_uid]      UNIQUEIDENTIFIER NOT NULL 
    )
AS
BEGIN
    -- Check if we are in msdb database context
    IF(LOWER(DB_NAME()) = 'msdb')
    BEGIN
        INSERT INTO @jobstep_logs
        SELECT log_id,
            log_text,
            date_created,
            step_uid
        FROM sys.sqlagent_jobsteps_logs
        WHERE ISNULL(@step_uid, step_uid) = step_uid
    END
    RETURN
END
GO
  
~~~

---
### See also
[List of functions](../functions.md)

