## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[fn_MSget_dynamic_filter_login\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.fn_MSget_dynamic_filter_login**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Scalar |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -928826610 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@publication_number| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@partition_id| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|@Return|sysname|128|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[fn_MSget_dynamic_filter_login\]
 No dependencies exist

---
### Objects that \[sys\].\[fn_MSget_dynamic_filter_login\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
-- This function returns the dynamic filter login (suser_sname) corresponding to the given
-- value of partitionid. If the publication uses both hostname and suser_sname for filtering
-- it uses the current value of hostname set on the connection to get the correct partition id.
create function sys.fn_MSget_dynamic_filter_login
(
    @publication_number int,
    @partition_id int
)
returns sysname
as
begin
    declare @pubid uniqueidentifier
    declare @retcode int
    declare @uses_host_name bit
    declare @suser_sname sysname
    declare @host_name sysname
    declare @select_command nvarchar(400)

    if (is_member('db_owner') &lt;&gt; 1)
    begin
        return NULL
    end
    
    select @pubid = pubid from dbo.sysmergepublications where publication_number = @publication_number
    if @pubid is NULL
        return NULL

    select @uses_host_name = sys.fn_MSpublication_uses_host_name(@pubid) 
    if @@error &lt;&gt; 0
        return NULL

    if @uses_host_name = 1
        select @host_name = host_name()
    else
        select @host_name = NULL

    -- the following is in dynamic sql because the hostname column may not exist when all publications
    -- use suser_sname for filtering
    if @uses_host_name = 1
        select @suser_sname = sys.fn_MSget_dynamic_filter_login_with_hostname(@publication_number, @partition_id)
    else
        select @suser_sname = SUSER_SNAME_FN from dbo.MSmerge_partition_groups 
            where publication_number = @publication_number
             and partition_id = @partition_id
        
    return @suser_sname
end
GO
  
~~~

---
### See also
[List of functions](../functions.md)

