## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[fn_IsBitSetInBitmask\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.fn_IsBitSetInBitmask**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Scalar |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -92987834 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@bitmask| |varbinary|500|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@colid| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|@Return|int|4|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[fn_IsBitSetInBitmask\]
 No dependencies exist

---
### Objects that \[sys\].\[fn_IsBitSetInBitmask\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create function sys.fn_IsBitSetInBitmask
(@bitmask varbinary(500), @colid int)
    returns int
as
begin
    declare @word smallint
    declare @bit  smallint
    declare @mask binary(2)
    declare @mval int
    declare @oldword binary(2)  

    if @colid &lt; 1 return 0

    SELECT @word = 1 + FLOOR((@colid -1)/16)

    SELECT @bit = (@colid -1) % 16

    SELECT @mval = POWER(2, @bit)
    SELECT @mask = convert( binary(2), unicode( substring( convert( nchar(2), convert( binary(4), @mval ) ), 2, 1 ) ) )
    
    SELECT @oldword = convert( binary(2), SUBSTRING( convert( nvarchar(64),@bitmask), @word, 1) )
    IF @oldword IS NULL return 0

    return  convert( smallint, @oldword ) &amp; convert( smallint, @mask )
end
GO
  
~~~

---
### See also
[List of functions](../functions.md)

