## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[dm_fts_parser\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.dm_fts_parser**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Inline |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -970703799 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@querystring| |nvarchar|4000|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@lcid| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@stoplistid| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@accentsensitive| |bit|1|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|keyword|varbinary|128|
|group_id|int|4|
|phrase_id|int|4|
|occurrence|int|4|
|special_term|nvarchar|16|
|display_term|nvarchar|4000|
|expansion_type|int|4|
|source_term|nvarchar|4000|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[dm_fts_parser\]
 No dependencies exist

---
### Objects that \[sys\].\[dm_fts_parser\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create function sys.dm_fts_parser(
    @querystring nvarchar(4000),
    @lcid int,
    @stoplistid int,
    @accentsensitive bit)
returns table as return
    select keyword, groupid group_id, phraseid phrase_id, occurrence,
    case matchop
        when 0 then N'Exact Match'
        when 2 then N'Noise Word'
        when 3 then N'End Of Sentence'
        when 4 then N'End of Paragraph'
        when 5 then N'End of Chapter'
        else N'Unknown'
    end special_term,
    fulltext_display_term(keyword) display_term, expansiontype expansion_type, sourceterm source_term
    from openrowset(TABLE WORDBREAK, @querystring, @lcid, @stoplistid, @accentsensitive) pars
GO
  
~~~

---
### See also
[List of functions](../functions.md)

