## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[fn_isrolemember\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.fn_isrolemember**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Scalar |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -977642094 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@mode| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@login| |sysname|128|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@tranpubid| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|@Return|int|4|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[fn_isrolemember\]
 No dependencies exist

---
### Objects that \[sys\].\[fn_isrolemember\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create function sys.fn_isrolemember
(
    @mode int  -- 0 = generic pal role check in DB, 1 = DB owner role check, 2 = specific tran PAL role check
    ,@login sysname -- @login we need to check for
    ,@tranpubid int -- optional - needed for mode = 2
)
returns int
as
begin
    declare @fret int

    if (@mode not in (0,1,2))
        select @mode = 0
    if (@login is null)
        select @login = suser_sname()
    select @fret = 0

    if (@mode = 0)
    begin
        --
        -- generic PAL check in the current db
        --
        if exists (select * from sys.database_role_members
            where role_principal_id in (select principal_id 
                                                    from sys.database_principals 
                                                    where name like N'MSReplPAL_' + cast(db_id() as nvarchar(10)) + N'_%' 
                                                        or name like N'MSmerge_%')
                and member_principal_id = (select dp.principal_id
                                                        from sys.database_principals as dp join master.dbo.syslogins as s
                                                        on dp.sid = s.sid
                                                        and s.name = @login))
        begin
            --
            -- has access
            --
            select @fret = 1
        end
    end
    else if (@mode = 1)
    begin
        --
        -- db owner check
        --
        if exists (select * from sys.database_role_members
            where role_principal_id in (select principal_id 
                                                    from sys.database_principals 
                                                    where lower(name) = 'db_owner')
                and member_principal_id = (select dp.principal_id
                                                        from sys.database_principals as dp join master.dbo.syslogins as s
                                                        on dp.sid = s.sid
                                                        and s.name = @login))
        begin
            --
            -- has access
            --
            select @fret = 1
        end
    end
    else if (@mode = 2)
    begin
        --
        -- PAL role membership check for specific transactional publication
        --
        if exists (select * from sys.database_role_members
            where role_principal_id = (select principal_id 
                                                    from sys.database_principals 
                                                    where name = N'MSReplPAL_' + cast(db_id() as nvarchar(10)) + N'_' + cast(@tranpubid as nvarchar(10)) )
                and member_principal_id = (select dp.principal_id
                                                        from sys.database_principals as dp join master.dbo.syslogins as s
                                                        on dp.sid = s.sid
                                                        and s.name = @login))
        begin
            --
            -- has access
            --
            select @fret = 1
        end
    end
    --
    -- all done
    --
    return @fret
end
GO
  
~~~

---
### See also
[List of functions](../functions.md)

