## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[sys\].\[fn_sqlagent_job_history\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **sys.fn_sqlagent_job_history**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | Table |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | -998585937 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@job_id| |uniqueidentifier|16|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@step_id| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|instance_id|int|4|
|job_id|uniqueidentifier|16|
|step_id|int|4|
|sql_message_id|int|4|
|sql_severity|int|4|
|message|nvarchar|4000|
|run_status|int|4|
|run_date|int|4|
|run_time|int|4|
|run_duration|int|4|
|operator_id_emailed|int|4|
|operator_id_paged|int|4|
|retries_attempted|int|4|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[sys\].\[fn_sqlagent_job_history\]
 No dependencies exist

---
### Objects that \[sys\].\[fn_sqlagent_job_history\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION sys.fn_sqlagent_job_history(
    @job_id UNIQUEIDENTIFIER NULL,
    @step_id INT NULL
 )
RETURNS @job_history TABLE (
        instance_id          INT              NOT NULL,
        job_id               UNIQUEIDENTIFIER NOT NULL,
        step_id              INT              NOT NULL,
        sql_message_id       INT              NOT NULL,
        sql_severity         INT              NOT NULL,
        [message]            NVARCHAR(4000)   NULL,
        run_status           INT              NOT NULL,
        run_date             INT              NOT NULL,
        run_time             INT              NOT NULL,
        run_duration         INT              NOT NULL,
        operator_id_emailed  INT              NOT NULL,
        operator_id_paged    INT              NOT NULL,
        retries_attempted    INT              NOT NULL
    )
AS
BEGIN
    -- Check if we are in msdb database context
    IF(LOWER(DB_NAME()) = 'msdb')
    BEGIN
        INSERT INTO @job_history
        SELECT instance_id,
            job_id,
            step_id,
            sql_message_id,
            sql_severity,
            [message],
            run_status,
            run_date,
            run_time,
            run_duration,
            operator_id_emailed,
            operator_id_paged,
            retries_attempted
        FROM sys.sqlagent_job_history
        WHERE ISNULL(@job_id, job_id) = job_id
        AND ISNULL(@step_id, step_id) = step_id
    END
    RETURN
END
GO
  
~~~

---
### See also
[List of functions](../functions.md)

