## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[dbo\].\[ufnGetContactInformation\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **ufnGetContactInformation**

---
###  Description  
 Table value function returning the first name, last name, job title and contact type for a given contact. 



---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/1.md) |
| Owner | [\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md) |
| Creation date | 11/16/2015 |
| Type | Table |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | 1373247947 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@PersonID|Input parameter for the table value function ufnGetContactInformation. Enter a valid PersonID from the Person.Contact table.|int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|PersonID|int|4|
|FirstName|nvarchar|50|
|LastName|nvarchar|50|
|JobTitle|nvarchar|50|
|BusinessEntityType|nvarchar|50|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[dbo\].\[ufnGetContactInformation\]
 No dependencies exist

---
### Objects that \[dbo\].\[ufnGetContactInformation\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Person\].\[BusinessEntityContact\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1045578763.md)|Table|1|
|[\[Person\].\[ContactType\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1093578934.md)|Table|1|
|[\[Sales\].\[Customer\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1317579732.md)|Table|1|
|[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|Table|1|
|[\[Person\].\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|Table|1|
|[\[Sales\].\[Store\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/846626059.md)|Table|1|
|[\[Purchasing\].\[Vendor\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1086626914.md)|Table|1|

 Total 7 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|*|Table|
|[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|BusinessEntityID|Table|
|[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|JobTitle|Table|
|[\[Person\].\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|BusinessEntityID|Table|
|[\[Person\].\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|FirstName|Table|
|[\[Person\].\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|LastName|Table|
|[\[Person\].\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|*|Table|
|[\[Purchasing\].\[Vendor\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1086626914.md)|BusinessEntityID|Table|
|[\[Purchasing\].\[Vendor\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1086626914.md)|*|Table|
|[\[Person\].\[BusinessEntityContact\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1045578763.md)|BusinessEntityID|Table|
|[\[Person\].\[BusinessEntityContact\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1045578763.md)|*|Table|
|[\[Person\].\[BusinessEntityContact\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1045578763.md)|PersonID|Table|
|[\[Person\].\[BusinessEntityContact\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1045578763.md)|ContactTypeID|Table|
|[\[Person\].\[ContactType\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1093578934.md)|ContactTypeID|Table|
|[\[Person\].\[ContactType\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1093578934.md)|Name|Table|
|[\[Sales\].\[Store\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/846626059.md)|BusinessEntityID|Table|
|[\[Sales\].\[Store\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/846626059.md)|*|Table|
|[\[Sales\].\[Customer\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1317579732.md)|PersonID|Table|
|[\[Sales\].\[Customer\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1317579732.md)|*|Table|
|[\[Sales\].\[Customer\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1317579732.md)|StoreID|Table|

 Total 20 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Functions/1373247947_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Table value function returning the first name, last name, job title and contact type for a given contact.|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION [dbo].[ufnGetContactInformation](@PersonID int)
RETURNS @retContactInformation TABLE 
(
    -- Columns returned by the function
    [PersonID] int NOT NULL, 
    [FirstName] [nvarchar](50) NULL, 
    [LastName] [nvarchar](50) NULL, 
    [JobTitle] [nvarchar](50) NULL,
    [BusinessEntityType] [nvarchar](50) NULL
)
AS 
-- Returns the first name, last name, job title and business entity type for the specified contact.
-- Since a contact can serve multiple roles, more than one row may be returned.
BEGIN
    IF @PersonID IS NOT NULL 
        BEGIN
        IF EXISTS(SELECT * FROM [HumanResources].[Employee] e 
                    WHERE e.[BusinessEntityID] = @PersonID) 
            INSERT INTO @retContactInformation
                SELECT @PersonID, p.FirstName, p.LastName, e.[JobTitle], 'Employee'
                FROM [HumanResources].[Employee] AS e
                    INNER JOIN [Person].[Person] p
                    ON p.[BusinessEntityID] = e.[BusinessEntityID]
                WHERE e.[BusinessEntityID] = @PersonID;

        IF EXISTS(SELECT * FROM [Purchasing].[Vendor] AS v
                    INNER JOIN [Person].[BusinessEntityContact] bec 
                    ON bec.[BusinessEntityID] = v.[BusinessEntityID]
                    WHERE bec.[PersonID] = @PersonID)
            INSERT INTO @retContactInformation
                SELECT @PersonID, p.FirstName, p.LastName, ct.[Name], 'Vendor Contact' 
                FROM [Purchasing].[Vendor] AS v
                    INNER JOIN [Person].[BusinessEntityContact] bec 
                    ON bec.[BusinessEntityID] = v.[BusinessEntityID]
                    INNER JOIN [Person].ContactType ct
                    ON ct.[ContactTypeID] = bec.[ContactTypeID]
                    INNER JOIN [Person].[Person] p
                    ON p.[BusinessEntityID] = bec.[PersonID]
                WHERE bec.[PersonID] = @PersonID;
        
        IF EXISTS(SELECT * FROM [Sales].[Store] AS s
                    INNER JOIN [Person].[BusinessEntityContact] bec 
                    ON bec.[BusinessEntityID] = s.[BusinessEntityID]
                    WHERE bec.[PersonID] = @PersonID)
            INSERT INTO @retContactInformation
                SELECT @PersonID, p.FirstName, p.LastName, ct.[Name], 'Store Contact' 
                FROM [Sales].[Store] AS s
                    INNER JOIN [Person].[BusinessEntityContact] bec 
                    ON bec.[BusinessEntityID] = s.[BusinessEntityID]
                    INNER JOIN [Person].ContactType ct
                    ON ct.[ContactTypeID] = bec.[ContactTypeID]
                    INNER JOIN [Person].[Person] p
                    ON p.[BusinessEntityID] = bec.[PersonID]
                WHERE bec.[PersonID] = @PersonID;

        IF EXISTS(SELECT * FROM [Person].[Person] AS p
                    INNER JOIN [Sales].[Customer] AS c
                    ON c.[PersonID] = p.[BusinessEntityID]
                    WHERE p.[BusinessEntityID] = @PersonID AND c.[StoreID] IS NULL) 
            INSERT INTO @retContactInformation
                SELECT @PersonID, p.FirstName, p.LastName, NULL, 'Consumer' 
                FROM [Person].[Person] AS p
                    INNER JOIN [Sales].[Customer] AS c
                    ON c.[PersonID] = p.[BusinessEntityID]
                    WHERE p.[BusinessEntityID] = @PersonID AND c.[StoreID] IS NULL; 
        END

    RETURN;
END;
GO
EXEC sp_addextendedproperty N'MS_Description', N'Table value function returning the first name, last name, job title and contact type for a given contact.', 'SCHEMA', N'dbo', 'FUNCTION', N'ufnGetContactInformation', NULL, NULL
GO
EXEC sp_addextendedproperty N'MS_Description', N'Input parameter for the table value function ufnGetContactInformation. Enter a valid PersonID from the Person.Contact table.', 'SCHEMA', N'dbo', 'FUNCTION', N'ufnGetContactInformation', 'PARAMETER', N'@PersonID'
GO
  
~~~

---
### See also
[List of functions](../functions.md)

