## ![](../../../../Images32x32Metro/OBJECT_FUNCTION.png "") Function:\[AdventureWorks2016CTP3\].\[Security\].\[customerAccessPredicate\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Functions](../../../../DbEngine/(local)/AdventureWorks2016CTP3/functions.md) > **Security.customerAccessPredicate**

---
### Function properties
| Name | Value |
|-|-|
| Schema | [\[Security\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/10.md) |
| Owner | [\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md) |
| Creation date | 10/23/2015 |
| Type | Inline |
| Is schema bound |![](../../../../ImagesMetro/CHECK_OUT.png "")|
| Is deterministic |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Implementation type | Transact SQL |
| ID | 1678629023 |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|DataType |Max length |ReadOnly|
|-|-|-|-|-|
|@TerritoryID| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordset returned
|Name |Datatype |Max length |
|-|-|-|
|accessResult|int|4|

---
###  Permissions
No permissions defined

---
### Objects that depend on \[Security\].\[customerAccessPredicate\]
 No dependencies exist

---
### Objects that \[Security\].\[customerAccessPredicate\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Security\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/10.md)|Schema|1|
|[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|Table|1|
|[\[Sales\].\[SalesPerson\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1874105717.md)|Table|1|

 Total 3 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|BusinessEntityID|Table|
|[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|LoginID|Table|
|[\[Sales\].\[SalesPerson\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1874105717.md)|BusinessEntityID|Table|
|[\[Sales\].\[SalesPerson\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1874105717.md)|TerritoryID|Table|

 Total 4 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Functions/1678629023_gr.md) to view dependencies graphically

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION Security.customerAccessPredicate(@TerritoryID int)
    RETURNS TABLE
    WITH SCHEMABINDING
AS
    RETURN SELECT 1 AS accessResult
    FROM HumanResources.Employee e 
    INNER JOIN Sales.SalesPerson sp ON sp.BusinessEntityID = e.BusinessEntityID
    WHERE
        ( RIGHT(e.LoginID, LEN(e.LoginID) - LEN('adventure-works\')) = USER_NAME() AND sp.TerritoryID = @TerritoryID ) 
        OR IS_MEMBER('SalesManagers') = 1
        OR IS_MEMBER('db_owner') = 1
GO
  
~~~

---
### See also
[List of functions](../functions.md)

