## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSrepl_subscription_rowset\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSrepl_subscription_rowset**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -1002621381 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@subscriber| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@agent_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@agent_type| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSrepl_subscription_rowset\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSrepl_subscription_rowset\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSrepl_subscription_rowset
(
    @subscriber sysname,
    @agent_id int,
    @agent_type int = 0
)
AS
BEGIN
    DECLARE @retcode int
    DECLARE @subscriber_provider sysname
    
    SELECT @subscriber_provider = NULL
    
    -- Security check: sysadmin/dbo/PAL only
    EXEC @retcode = sys.sp_MScheck_pull_access @agent_id = @agent_id,
                                                @agent_type = @agent_type
    IF @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
        RETURN 1
        
    -- Query the MSdistribution_agents entry for the subscriber provider
    SELECT  @subscriber_provider = ma.subscriber_provider
    FROM    MSdistribution_agents ma, master.dbo.sysservers ss
    WHERE    UPPER(ss.srvname) = UPPER(@subscriber) collate database_default
      AND    ma.subscriber_id = ss.srvid
      AND    ma.id = @agent_id

    IF @@error &lt;&gt; 0
        RETURN 1
    
    -- If the subscriber_provider from the MSdistribution_agents table is     
    -- NULL, we either have a downlevel publisher, or yukon security is not
    -- enabled.  In both cases, we need to call sp_MSrepl_linkedserver_rowset
    -- to generate the rowset.
    IF ISNULL(@subscriber_provider, N' ') = N' '
    BEGIN
        exec @retcode = sys.sp_MSrepl_linkedservers_rowset @srvname = @subscriber,
                                                          @agent_id = @agent_id,
                                                          @agent_type = @agent_type
        IF @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
        BEGIN
            RETURN 1
        END
            
        RETURN 0    
            
    END 

    -- Query the MSdistribution_agents entry for the subscriber information
    SELECT  SUB_NAME            = ss.srvname,
            SUB_PRODUCT         = ss.srvproduct,
            SUB_PROVIDERNAME    = ma.subscriber_provider,
            SUB_DATASOURCE      = ma.subscriber_datasrc,
            SUB_PROVIDERSTRING  = ma.subscriber_provider_string,
            SUB_LOCATION        = ma.subscriber_location,
            SUB_CATALOG         = ma.subscriber_catalog
    FROM    MSdistribution_agents ma, master.dbo.sysservers ss
    WHERE    UPPER(ss.srvname) = UPPER(@subscriber) collate database_default
      AND    ma.subscriber_id = ss.srvid
      AND    ma.id = @agent_id

    IF @@error &lt;&gt; 0
    BEGIN
        RETURN 1
    END    
                                               
    RETURN 0
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

