## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MShelpreplicationtriggers\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MShelpreplicationtriggers**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -100674768 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@object_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@object_schema| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MShelpreplicationtriggers\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MShelpreplicationtriggers\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MShelpreplicationtriggers (
    @object_name    sysname,
    @object_schema  sysname
    )
as
begin
    set nocount on
    declare @retcode int
          , @object_id int
          , @guidstr nvarchar(100)

    set @retcode = 0
    set @guidstr = null

    exec @retcode = sys.sp_MSreplcheck_publish
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
        return 1

    set @object_id = object_id(quotename(@object_schema) + N'.' +  quotename(@object_name))

    if @object_id is null return 0 -- There is nothing to do here

    if object_id(N'dbo.sysarticleupdates', 'U') is not null
    begin
        select 'trigger_name' = object_name(sync_upd_trig)
          from dbo.sysarticleupdates updates
    inner join dbo.sysarticles arts -- Can't have synctran triggers on 
            on updates.artid = arts.artid
         where arts.objid = @object_id
    end

    if object_id(N'dbo.sysmergearticles', 'U') is not null
    begin
        -- Note: All merge articles of the same source object share
        -- the same article id.

        select @guidstr = sys.fn_MSguidtostr(artid)
          from dbo.sysmergearticles
         where objid = @object_id

        if @guidstr is not null
        begin
            declare @ins_trigger_name sysname
                  , @upd_trigger_name sysname
                  , @del_trigger_name sysname
                  , @yukon_ins_trigger_name sysname
                  , @yukon_upd_trigger_name sysname
                  , @yukon_del_trigger_name sysname
                            
            set @ins_trigger_name = N'ins_' + @guidstr
            set @upd_trigger_name = N'upd_' + @guidstr
            set @del_trigger_name = N'del_' + @guidstr
            set @yukon_ins_trigger_name = N'MSmerge_ins_' + @guidstr
            set @yukon_upd_trigger_name = N'MSmerge_upd_' + @guidstr
            set @yukon_del_trigger_name = N'MSmerge_del_' + @guidstr

            select 'trigger_name' = name
              from sys.triggers
             where parent_class = 1
               and parent_id = @object_id
               and name in (@ins_trigger_name
                           ,@upd_trigger_name
                           ,@del_trigger_name
                           ,@yukon_ins_trigger_name
                           ,@yukon_upd_trigger_name
                           ,@yukon_del_trigger_name)
                        
        end
    end

    return @retcode    
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

