## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSdroparticletombstones\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSdroparticletombstones**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -1010228660 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@artid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@pubid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSdroparticletombstones\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSdroparticletombstones\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_MSdroparticletombstones
    @artid      uniqueidentifier,
    @pubid      uniqueidentifier = null
as
    declare @progress_token nvarchar(500)
    declare @progress_token_hash int
    declare @session_token nvarchar(260)
    declare @retcode int
    
    -- Security Checking 
    -- PAL user access
    exec @retcode = sys.sp_MSrepl_PAL_rolecheck @pubid = @pubid, @artid = @artid
    if (@retcode &lt;&gt; 0) or (@@error &lt;&gt; 0)
        return 1

    if @pubid is not null -- Coming from a 9.0 agent
    begin
        if object_id('dbo.MSsnapshotdeliveryprogress', 'U') is not null
        begin    
            select @session_token = null,
                   @progress_token = N'&lt;MergePubId&gt;:' + convert(nvarchar(100), @pubid),
                   @progress_token_hash = sys.fn_repl32bitstringhash(@progress_token)
            -- Try to get the session token from the merge pubid
            select @session_token = session_token 
              from dbo.MSsnapshotdeliveryprogress
             where progress_token_hash = @progress_token_hash
               and progress_token = @progress_token
            if @session_token is not null
            begin
                select @progress_token = N'&lt;DroppedArticleTombstones&gt;:' + convert(nvarchar(100), @artid),
                       @progress_token_hash = sys.fn_repl32bitstringhash(@progress_token)
                if exists (select * from dbo.MSsnapshotdeliveryprogress
                            where session_token = @session_token
                              and progress_token_hash = @progress_token_hash
                              and progress_token = @progress_token)
                begin
                    -- Meta-data table had been cleaned up by an interrupted
                    -- snapshot session before, don't do it again
                    return (0)
                end
                else
                begin
                    exec @retcode = sys.sp_MSrecordsnapshotdeliveryprogress 
                            @snapshot_session_token = @session_token,
                            @snapshot_progress_token = @progress_token
                    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0 return (1)
                            
                end                
            end
        end
    end

    declare @tablenick int
    select @tablenick = nickname from dbo.sysmergearticles where artid = @artid
    if @tablenick is not null
    begin
        delete from dbo.MSmerge_tombstone where tablenick = @tablenick
        delete from dbo.MSmerge_current_partition_mappings where tablenick = @tablenick
        delete from dbo.MSmerge_past_partition_mappings where tablenick = @tablenick
        delete from dbo.MSmerge_contents where tablenick = @tablenick
        delete from dbo.MSmerge_generation_partition_mappings where generation in
            (select generation from dbo.MSmerge_genhistory where art_nick=@tablenick)
        delete from dbo.MSmerge_genhistory where art_nick=@tablenick
    end
    return (0)
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

