## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_check_dynamic_filters\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_check_dynamic_filters**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -1014496800 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_check_dynamic_filters\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_check_dynamic_filters\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_check_dynamic_filters @publication sysname
as
    set nocount on
    
    declare @can_use_partition_groups bit
    , @has_dynamic_filters bit
    , @dynamic_filters_function_list nvarchar(500)
    , @validate_subscriber_info nvarchar(500)
    , @uses_host_name bit
    , @uses_suser_sname bit
    , @retcode int
    
    /*
    ** Security Check
    */
    exec @retcode = sys.sp_MSrepl_PAL_rolecheck @publication=@publication
    if @@ERROR &lt;&gt; 0 or @retcode &lt;&gt; 0
        return(1)
    
    exec @retcode = sys.sp_MScheck_dynamic_filters @publication = @publication    
                                                    , @can_use_partition_groups = @can_use_partition_groups output
                                                    , @has_dynamic_filters = @has_dynamic_filters output
                                                    , @dynamic_filters_function_list = @dynamic_filters_function_list output
                                                    , @validate_subscriber_info = @validate_subscriber_info output
                                                    , @uses_host_name = @uses_host_name output
                                                    , @uses_suser_sname = @uses_suser_sname output
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
        return 1
        
    select can_use_partition_groups = @can_use_partition_groups
    , has_dynamic_filters = @has_dynamic_filters
    , dynamic_filters_function_list = @dynamic_filters_function_list
    , validate_subscriber_info = @validate_subscriber_info
    , uses_host_name = @uses_host_name
    , uses_suser_sname = @uses_suser_sname
    
    return 0
                                    
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

