## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSactivatelogbasedarticleobject\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSactivatelogbasedarticleobject**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -1018665623 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@qualified_logbased_object_name| |nvarchar|517|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSactivatelogbasedarticleobject\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSactivatelogbasedarticleobject\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
--
-- Name: sp_MSactivatelogbasedarticleobject
--
-- Description: This procedure is called by the snapshot agent to activate
--              a single logbased article object.
-- 
-- Parameter: @qualified_logbased_object_name 
--
-- Returns: 0 - succeeded 
--          1 - failed
--
-- Notes: This procedure must be called within a user transaction or it
--        will result in a no-op.
--
-- Security: Public interface, will result in no-op if called by non-db_owner
--           or non-replication agent.
-- Requires Certificate signature for catalog access
-- 
create procedure sys.sp_MSactivatelogbasedarticleobject (
    @qualified_logbased_object_name nvarchar(517)
    )
as
begin
    set nocount on

    if @@trancount &lt; 1 return 1

    if sessionproperty('replication_agent') &lt;&gt; 1 return 1

    if object_id(N'dbo.syspublications', 'U') is null return 1
    
    declare @retcode int
          , @is_replicated bit
          , @object_id int
          , @error int
    set @retcode = 0
    
    exec @retcode = sys.sp_MSreplcheck_publish
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
        return 1
    
    set @is_replicated = null
    set @object_id = object_id(@qualified_logbased_object_name)
    select @is_replicated = is_replicated
      from sys.tables
     where object_id = @object_id

    if @is_replicated is null
    begin
        select @is_replicated = is_replicated
          from sys.views
         where object_id = @object_id
    end

    if @is_replicated = 0
    begin
        exec %%Object(MultiName = @qualified_logbased_object_name).LockMatchID(ID = @object_id, Exclusive = 1, BindInternal = 0)
        set @error = @@error if @error &lt;&gt; 0 begin raiserror(@error, 16, -1) return 1 end
        exec %%Relation(ID = @object_id).SetReplicated(Value = 1)
        set @error = @@error if @error &lt;&gt; 0 begin raiserror(@error, 16, -1) return 1 end
    end
    return 0 

end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

