## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSrepl_enumpublishertables\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSrepl_enumpublishertables**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -1023117618 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@silent| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSrepl_enumpublishertables\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSrepl_enumpublishertables\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE sys.sp_MSrepl_enumpublishertables
(
    @publisher    sysname,
    @silent        bit = 0
)
AS
BEGIN
    DECLARE @retcode    int
    DECLARE @publisher_type    sysname
    DECLARE @cmd        nvarchar(4000)
    DECLARE @distribdb    sysname
    
    SET @retcode = 0

    --
    -- Security Check: require sysadmin
    --
    IF (ISNULL(IS_SRVROLEMEMBER('sysadmin'),0) = 0)
    BEGIN
        RAISERROR(21089,16,-1) 
        RETURN (1)
    END

    EXEC @retcode = sys.sp_MSrepl_getdistributorinfo    @publisher      = @publisher,
                                                        @publisher_type    = @publisher_type OUTPUT,
                                                        @distribdb        = @distribdb OUTPUT

    IF @retcode &lt;&gt; 0
    BEGIN
        RETURN (@retcode)
    END

    IF @distribdb IS NULL
    BEGIN
        RAISERROR(21600, 16, -1, @publisher)
        RETURN(1)
    END

    -- Create temp table to store the results (if not already available)
    IF object_id(N'tempdb..#publishertables', 'U') IS NULL
    BEGIN
        CREATE TABLE #publishertables
        (
            owner                        sysname,
            name                        sysname,
            has_valid_pk                bit,
            has_unique_with_nullable    bit,
            is_published                bit,
            has_explicit_select_grant    bit,
            is_tranpublished            bit
        )
    END

    -- Get per provider method for determining publisher tables
    IF UPPER(@publisher_type) IN ('ORACLE', 'ORACLE GATEWAY')
    BEGIN
        SET @cmd = QUOTENAME(@distribdb) + N'.sys.sp_ORAenumpublishertables'

        EXEC @retcode = @cmd @publisher

        IF (@silent = 0)
        BEGIN
            SELECT    *
            FROM    #publishertables
            ORDER BY owner, name

            DROP TABLE #publishertables
        END
    END
    ELSE
    BEGIN
        RAISERROR(21645, 16, -1, @publisher_type)
        SET @retcode = 1
    END

    RETURN (@retcode)
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

