## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSrepl_dropdatatypemappings\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSrepl_dropdatatypemappings**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -1025657285 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
 No parameters exist

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSrepl_dropdatatypemappings\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSrepl_dropdatatypemappings\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

--
-- Name:
--        sp_MSrepl_dropdatatypemappings
--
-- Description:
--        Drops data type mapping tables
--
-- Returns:
--        0 if successful
--        1 if failed
--
-- Security:
--        Public
-- Requires Certificate signature for catalog access
--
-- Notes:
--        Expected to be called internally only via MSDB install script
--        
--

create procedure sys.sp_MSrepl_dropdatatypemappings
as
begin
    DECLARE @cmd nvarchar(4000)
    
    --
    -- Security Check: require sysadmin
    --
    IF (ISNULL(IS_SRVROLEMEMBER('sysadmin'),0) = 0)
    BEGIN
        RAISERROR(21089,16,-1) 
        RETURN (1)
    END

    -- MSdatatype_mappings view
    IF OBJECT_ID(N'dbo.MSdatatype_mappings', 'V') IS NOT NULL
    BEGIN
        PRINT 'Dropping view MSdatatype_mappings...'
        
        SELECT @cmd = 'DROP VIEW dbo.MSdatatype_mappings'
        EXEC(@cmd)
    END
    
    -- sysdatatypemappings view
    IF OBJECT_ID(N'dbo.sysdatatypemappings', 'V') IS NOT NULL
    BEGIN
        PRINT 'Dropping view sysdatatypemappings...'
        
        SELECT @cmd = 'DROP VIEW dbo.sysdatatypemappings'
        EXEC(@cmd)
    END

    -- MSdbms_datatype_mapping
    IF OBJECT_ID(N'dbo.MSdbms_datatype_mapping', 'U') IS NOT NULL
    BEGIN
        PRINT 'Dropping table MSdbms_datatype_mapping...'

        ALTER TABLE MSdbms_map
        DROP CONSTRAINT fk_MSdbms_map_default_datatype_mapping_id

        DROP TABLE dbo.MSdbms_datatype_mapping
    END

    -- MSdbms_map
    IF OBJECT_ID(N'dbo.MSdbms_map', 'U') IS NOT NULL
    BEGIN
        PRINT 'Dropping table MSdbms_map...'
        DROP TABLE dbo.MSdbms_map
    END

    -- MSdbms_datatype
    IF OBJECT_ID(N'dbo.MSdbms_datatype', 'U') IS NOT NULL
    BEGIN
        PRINT 'Dropping table MSdbms_datatype...'
        DROP TABLE dbo.MSdbms_datatype
    END

    -- MSdbms
    IF OBJECT_ID(N'dbo.MSdbms', 'U') IS NOT NULL
    BEGIN
        PRINT 'Dropping table MSdbms...'
        DROP TABLE dbo.MSdbms
    END
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

