## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_help_fulltext_catalogs_cursor\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_help_fulltext_catalogs_cursor**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -1030637209 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@cursor_return| |int|4|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@fulltext_catalog_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_help_fulltext_catalogs_cursor\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_help_fulltext_catalogs_cursor\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_help_fulltext_catalogs_cursor
    @cursor_return CURSOR VARYING OUTPUT,
    @fulltext_catalog_name        sysname = NULL        -- full-text catalog name
as
    -- FULLTEXT MUST BE ACTIVE IN DATABASE --
    if DatabasePropertyEx(db_name(), 'IsFulltextEnabled') = 0
    begin
        raiserror(15601,-1,-1)
        return 1
    end

    -- CATALOG MUST EXIST IF SPECIFIED --
    if @fulltext_catalog_name is not null
    begin
        declare @ftcatid smallint
        select @ftcatid = fulltext_catalog_id from sys.fulltext_catalogs where name = @fulltext_catalog_name
        if @ftcatid is null
        begin
            declare @curdbname sysname
            declare @curdbnamelen int
            select @curdbname = db_name()
            select @curdbnamelen = LEN(@curdbname)
            raiserror(7641,-1,-1,@fulltext_catalog_name, @curdbnamelen, @curdbname)
            return 1
        end
    end

    -- SELECT ANY ROWS THAT MEET THE CRITERIA --
    set @cursor_return =    CURSOR LOCAL SCROLL STATIC FOR
    select CAT.fulltext_catalog_id as ftcatid,
           CAT.name as NAME,
           isnull(sysfs.physical_name, CAT.path) as PATH,
           FullTextCatalogProperty(CAT.name, 'PopulateStatus') AS STATUS ,
           (select COUNT(*)
              from sys.fulltext_indexes
              where fulltext_catalog_id = CAT.fulltext_catalog_id
           ) as NUMBER_FULLTEXT_TABLES
    from sys.fulltext_catalogs as CAT left outer join sys.database_files as sysfs on (sysfs.file_id = CAT.file_id)
    where ( @fulltext_catalog_name is null or CAT.name = @fulltext_catalog_name )
    order by fulltext_catalog_id

    open @cursor_return

    -- SUCCESS --
    return 0    -- sp_help_fulltext_catalogs_cursor
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

