## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSdopartialdatabasesnapshotinitiation\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSdopartialdatabasesnapshotinitiation**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -1030928183 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSdopartialdatabasesnapshotinitiation\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSdopartialdatabasesnapshotinitiation\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
--
-- Name: sp_MSdopartialdatabasesnapshotinitiation
--
-- Description: This procedure is called by the snapshot agent to perform the
--              the necessary (article &amp; subscription) initiation procedures
--              when generating a partial snapshot from a database snapshot.
-- Parameter: @publication sysname (mandatory)
--
-- Notes: This procedure is assumed to be run within a transaction from the
--        snapshot agent. As such, no explicit error handling is performed
--        in it. This procedure will also return 1 immediately if one of the 
--        following is not true:
--        1) Caller is not member of db_owner role
--        2) Caller is not a replication agent connection
--        3) @@trancount &lt; 1
--
--        *This procedure assumes that the #partial_snapshot_artids temporary
--        table has already been created prior to its invocation.
--
-- Returns: 0 - succeeded
--          1 - failed
--  
-- Security: Public interface, non-db_owner caller will result in no-op
--
create procedure sys.sp_MSdopartialdatabasesnapshotinitiation (
    @publication sysname
    )
as
begin
    set nocount on

    if @@trancount &lt; 1 return 1

    if sessionproperty('replication_agent') &lt;&gt; 1 return 1

    if object_id(N'dbo.syspublications', 'U') is null return 1

    declare @retcode int
    set @retcode = 0

    exec @retcode = sys.sp_MSreplcheck_publish
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
        return 1

    declare @qualifiedname nvarchar(520),
            @objid int,
            @articletype tinyint,
            @pubid int,
            @repl_freq tinyint,
            @error int

    set @pubid = null
    set @error = 0

    select @pubid = pubid,
           @repl_freq = repl_freq
      from dbo.syspublications
     where name = @publication

    if @pubid is null return 1

        update dbo.syssubscriptions
           set status = 3
          from dbo.syssubscriptions subs
    inner join dbo.sysextendedarticlesview arts
            on subs.artid = arts.artid
    inner join #partial_snapshot_artids snaparts
            on arts.artid = snaparts.artid
         where arts.pubid = @pubid
           and (subs.status in (0, 1) and subs.sync_type = 1 
                or subs.srvid = -1)

    update dbo.sysarticles
       set status = status | 1
     where artid in
        (select subs.artid
           from syssubscriptions subs
     inner join dbo.sysarticles arts
             on subs.artid = arts.artid
     inner join #partial_snapshot_artids snaparts
             on arts.artid = snaparts.artid
          where arts.pubid = @pubid)

    update dbo.sysschemaarticles
       set status = status | 1
     where artid in
        (select subs.artid
           from syssubscriptions subs
     inner join dbo.sysschemaarticles arts
             on subs.artid = arts.artid
     inner join #partial_snapshot_artids snaparts
             on arts.artid = snaparts.artid
          where arts.pubid = @pubid)

    exec @retcode = sys.sp_replflush          
    return @retcode
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

