## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_check_for_sync_trigger\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_check_for_sync_trigger**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -103199093 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@tabid| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@trigger_op| |char|10|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@fonpublisher| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_check_for_sync_trigger\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_check_for_sync_trigger\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_check_for_sync_trigger 
(
    @tabid int, 
    @trigger_op char(10) = NULL OUTPUT,
    @fonpublisher bit = 0 -- 0 = on Subscriber, 1 = publisher
)
as
begin
    declare @retcode int

    select @trigger_op = NULL
    if (@fonpublisher = 0)
    begin
        declare @ins_trigid int
                    ,@upd_trigid int
                    ,@del_trigid int
        --
        -- get the id for subscriber sync tran triggers
        --
        select @ins_trigid = object_id from sys.objects where
            type = N'TR' and name like N'trg_MSsync_ins_%' and parent_object_id = @tabid
        select @upd_trigid = object_id from sys.objects where
            type = N'TR' and name like N'trg_MSsync_upd_%' and parent_object_id = @tabid
        select @del_trigid = object_id from sys.objects where
            type = N'TR' and name like N'trg_MSsync_del_%' and parent_object_id = @tabid
        if trigger_nestlevel( @ins_trigid ) &gt; 0
        begin
             select @trigger_op = 'ins'
             return 1
        end
        else    -- if nestlevel of insert trigger on same table &gt; 0 then bail
        if trigger_nestlevel( @upd_trigid ) &gt; 0
        begin
             select @trigger_op = 'upd'
             return 1
        end
        else
        if trigger_nestlevel( @del_trigid ) &gt; 0
        begin
             select @trigger_op = 'del'
             return 1
        end
    end
    else
    begin
        declare @ver_trigid int
        --
        -- get the id for publisher version update trigger
        --
        select @ver_trigid = object_id from sys.objects where
            type = N'TR' and name like N'sp_MSsync_upd_trig_%' and parent_object_id = @tabid
        if trigger_nestlevel( @ver_trigid ) &gt; 0
        begin
             select @trigger_op = 'upd'
             return 1
        end
    end
    --
    -- no trigger was selected
    --
    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

