## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_adjustpublisheridentityrange\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_adjustpublisheridentityrange**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -103439020 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@table_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@table_owner| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_adjustpublisheridentityrange\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_adjustpublisheridentityrange\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_adjustpublisheridentityrange (
    @publication    sysname = NULL,
    @table_name         sysname = NULL,
    @table_owner    sysname = NULL
)
AS
set nocount on

declare @retcode                 int, @object_found bit
declare @objid                    int
declare @qualified_table_name    nvarchar(260)
declare @identity_support        int
declare @pubid                    uniqueidentifier

select @object_found = 0

/*
** Security Check
*/
EXEC @retcode = sys.sp_MSreplcheck_publish
IF @@ERROR &lt;&gt; 0 or @retcode &lt;&gt; 0
    return (1)

if ((@publication is NULL and @table_name is NULL) or 
        (@publication is not NULL and @table_name is not NULL))
begin
    raiserror(21314, 16, -1, '@publication', '@table_name')
    return (1)
end

if @publication is NULL
begin
    if @table_owner is NULL
        select @table_owner = schema_name()
    select @qualified_table_name = QUOTENAME(@table_owner) + '.' + QUOTENAME(@table_name)
    
    select @objid = object_id(@qualified_table_name)
    if @objid is NULL
    begin 
        RAISERROR (14027, 11, -1, @qualified_table_name)
        return (1)
    end
end

--Do this for merge?
if object_id('sysmergepublications') is not NULL
begin
    if @publication is NULL
    begin
        select @identity_support = identity_support from dbo.sysmergearticles where objid=@objid
        if @identity_support is not null
        begin
            select @object_found = 1
            if @identity_support = 0
                return (0)
            exec @retcode = sys.sp_MSadjustmergeidentity @qualified_table_name=@qualified_table_name    
            if @retcode&lt;&gt;0 or @@ERROR&lt;&gt;0
            begin
                raiserror(21315, 16, -1, @table_name)
                return (1)
            end
        end
    end

    if @table_name is NULL
    begin
        select @pubid=pubid FROM dbo.sysmergepublications
            WHERE name = @publication and UPPER(publisher)=UPPER(publishingservername()) and publisher_db=db_name()
        if @pubid is not null
        begin
            select @object_found = 1
            if not exists (select * from dbo.sysmergearticles where pubid=@pubid and identity_support=1)
                return (0)
            exec @retcode = sys.sp_MSadjustmergeidentity @publication=@publication
            if @retcode&lt;&gt;0 or @@ERROR&lt;&gt;0
            begin
                raiserror(21316, 16, -1, @publication)
                return (1)
            end    
        end    
    end
end

if object_id('syspublications') is not NULL
begin
    if @publication is NULL
    begin
        declare @artid int
        select top 1 @artid = artid from sysarticles where 
            objid = @objid
        if @artid is not null
        begin
            select @object_found = 1
            exec @retcode = sys.sp_MSpub_adjust_identity @artid
            if @retcode&lt;&gt;0 or @@ERROR&lt;&gt;0
                return (1)
        end
    end
    else
    begin
        declare @publication_id int
        select @publication_id = pubid from syspublications where name = @publication
        if @publication_id is not null
        begin
            select @object_found = 1
            DECLARE adjust_identity CURSOR LOCAL FAST_FORWARD FOR
                SELECT art1.objid
                  FROM sysarticles art1,
                       sysarticleupdates art2
                  where art1.pubid = @publication_id and
                        art1.artid = art2.artid and
                        art2.identity_support = 1 and
                        (art1.artid = @artid or @artid is null)
            FOR READ ONLY

            OPEN adjust_identity        
            FETCH adjust_identity INTO @objid
            WHILE (@@fetch_status &lt;&gt; -1)
            begin
                exec @retcode = sys.sp_MSpub_adjust_identity @artid
                if @retcode&lt;&gt;0 or @@ERROR&lt;&gt;0
                    return (1)
                FETCH adjust_identity INTO @objid
            end
        end
    end
end
if @object_found = 0
begin
    if @publication is null
        raiserror(21246, 16, -1, @qualified_table_name)
    else
        RAISERROR (20026, 11, -1, @publication)
end

RETURN (0)
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

