## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_revokedbaccess\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_revokedbaccess**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -103770002 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@name_in_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_revokedbaccess\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_revokedbaccess\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_revokedbaccess
    @name_in_db     sysname
as
    -- SETUP RUNTIME OPTIONS / DECLARE VARIABLES --
    set nocount on
    declare @ret        int,
            @stmtU        nvarchar(4000)

    -- DISALLOW USER TRANSACTION --
    set implicit_transactions off
    IF (@@trancount &gt; 0)
    begin
        raiserror(15002,-1,-1,'sys.sp_revokedbaccess')
        return (1)
    end

    exec @ret = sys.sp_validname @name_in_db
    if @ret &lt;&gt; 0
        return(1)

    BEGIN TRANSACTION
    -- drop user
        -- for guest disable its access to database, this way guest schema is not dropped
    declare @guestname sysname
    set @guestname='guest'

    if lower(@name_in_db) = @guestname
    begin
        if db_id() in (1,2)
        begin
            ROLLBACK TRANSACTION
            raiserror(15182,-1,-1)
            return (1)
        end

        -- don't let disable guest twice
        if not exists (select * from sys.database_permissions p where p.class = 0 and p.major_id = 0 and p.minor_id = 0
            and p.grantee_principal_id = 2 and p.type = 'CO' and p.state in ('G','W')
            and not exists (select * from sys.database_permissions d where d.class = 0 and d.major_id = 0 and d.minor_id = 0
                and d.grantee_principal_id = p.grantee_principal_id and d.type = 'CO' and d.state = 'D'))
        begin
            ROLLBACK TRANSACTION
            raiserror(15539,-1,-1,@name_in_db)
            return (1)
        end
    end
    else
    begin
        -- this will drop the schema owned by the user that has the same name as the user,
        -- if such schema exists
        EXEC %%Owner(Name = @name_in_db).DropSchema(OwnerType = 1)
        if @@error &lt;&gt; 0
        begin
            ROLLBACK TRANSACTION
            -- error message comes from inside the invoke
            return (1)
        end
    end

    set @stmtU = 'drop user ' + quotename(@name_in_db, ']')

    -- drop the owner
    exec (@stmtU)
    if @@error &lt;&gt; 0
    begin
        ROLLBACK TRANSACTION
        -- error message comes from inside the statement
        return (1)
    end

    COMMIT TRANSACTION

    -- RETURN SUCCESS --
    return (0)    -- sp_revokedbaccess
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

