## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSadd_repl_command\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSadd_repl_command**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -1037786908 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher_id| |smallint|2|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@xact_id| |varbinary|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@xact_seqno| |varbinary|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@originator| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@originator_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@article_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@command_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@type| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@partial_command| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@command| |varbinary|1024|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSadd_repl_command\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSadd_repl_command\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_MSadd_repl_command
(
    @publisher_id smallint = NULL,
    @publisher_db sysname,
    @xact_id varbinary(16) = 0x0,
    @xact_seqno varbinary(16) = 0x0,
    @originator sysname = NULL,
    @originator_db sysname = NULL,
    @article_id int = NULL,
    @command_id int = 1,
    @type int = NULL,
    @partial_command bit = NULL,
    @command varbinary(1024) = NULL,
    @publisher sysname = NULL
)
AS
begin
   SET NOCOUNT ON

   DECLARE @date datetime
   DECLARE @publisher_database_id int
   declare @originator_id int

    --
    -- security check
    -- only db_owner can execute this
    --
    if (is_member ('db_owner') != 1) 
    begin
        raiserror(14260, 16, -1)
        return (1)
    end
   SELECT @date = GETDATE()

   if @publisher_id is NULL
        select @publisher_id = srvid from master.dbo.sysservers where
            UPPER(srvname) = UPPER(@publisher)

    -- Get publisher database id.
    SELECT @publisher_database_id = id from MSpublisher_databases where publisher_id = @publisher_id and 
        publisher_db = @publisher_db
    
   /* 
   ** To minimize contention, snapshot does not include this SP call
   ** inside a transaction. We have to insert to MSrepl_transactions table
   ** first to ensure clean up stored precedures to work, which only use 
   ** MSrepl_transactions table but NOT MSrepl_commands table to find transactions
   ** to be deleted.
   */

   IF @command_id = 1
   BEGIN
      INSERT INTO MSrepl_transactions VALUES (@publisher_database_id,
         @xact_id,  @xact_seqno, @date)
      IF @@ERROR &lt;&gt; 0
         RETURN 1
   END

   IF @command IS NOT NULL
   begin
      if @originator &lt;&gt; N'' and @originator_db &lt;&gt; N'' and @originator is not null and @originator_db is not null 
      begin
        set @originator_id = null select @originator_id = id from MSrepl_originators where
            publisher_database_id = @publisher_database_id and UPPER(srvname) = UPPER(@originator) and
            dbname = @originator_db
        if @originator_id is null
        begin
            insert into MSrepl_originators (publisher_database_id, srvname, dbname) values
                (@publisher_database_id, UPPER(@originator), @originator_db)
            select @originator_id = @@identity
        end

      end
      else
        select @originator_id = 0
      

      if( @type in( 37,38 ) )
      begin
            declare @syncstat int
          select @syncstat = 38 - @type
          exec sp_MSset_syncstate @publisher_id, @publisher_db, @article_id, @syncstat, @xact_seqno 
      end

      INSERT INTO MSrepl_commands (publisher_database_id, xact_seqno, type, article_id, originator_id, command_id, partial_command, command)
        VALUES (@publisher_database_id, @xact_seqno,
        @type, @article_id, @originator_id, @command_id, @partial_command, @command)
    end

    IF @@ERROR &lt;&gt; 0
      RETURN (1)
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

