## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSresetsnapshotdeliveryprogress\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSresetsnapshotdeliveryprogress**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -1042000603 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@snapshot_session_token| |nvarchar|260|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSresetsnapshotdeliveryprogress\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSresetsnapshotdeliveryprogress\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
--
-- Name: sp_MSresetsnapshotdeliveryprogress
--
-- Description: This procedure removes all rows in the  
--              MSsnapshotdeliveryprogress table (if it exists) corresponding
--              to the specified snapshot delivery session. This will
--              effectively wipes out all memory of any previous 
--              progress that the snapshot delivery processes had made to
--              the subscriber database.
--
-- Notes: This procedure should be called at the subscriber database by
--        the distribution or the merge agent.
--
-- Parameter: @snapshot_session_token nvarchar(260) (mandatory)
--                - A UniCode string that uniquely identifies a snapshot
--                  delivery session. For now, this will be the snapshot
--                  generation folder of the snapshot being applied. 
--
-- Returns: 0 - succeeded
--          1 - failed
--
-- Security: Execute permission of this procedure is granted to public;
--           procedural security check will be performed to make sure
--           that the caller is either a db_owner of the current database
--           or a sysadmin. 
--
create procedure sys.sp_MSresetsnapshotdeliveryprogress
    @snapshot_session_token nvarchar(260)
as
begin
    set nocount on
    declare @retcode int
    select @retcode = 0
    exec @retcode = sys.sp_MSreplcheck_subscribe 
    if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
    begin
        select @retcode = 1
        goto FAILURE
    end
    if object_id('dbo.MSsnapshotdeliveryprogress') is not null
    begin
        delete dbo.MSsnapshotdeliveryprogress
        where session_token = @snapshot_session_token
        if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
        begin
            select @retcode = 1
            goto FAILURE
        end
    end
    if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
    begin
        select @retcode = 1
        goto FAILURE
    end


FAILURE:
    return @retcode    
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

