## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSchecksnapshotstatus\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSchecksnapshotstatus**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -1049257763 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSchecksnapshotstatus\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSchecksnapshotstatus\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSchecksnapshotstatus
    @publication        sysname
AS
    declare @db_name        sysname
    declare @retention      int
    declare @retention_period_unit tinyint
    declare @snapshot_ready int
    declare @pubid          uniqueidentifier
    declare @last_snapshot  datetime
    
    select @snapshot_ready = NULL
    select @db_name = db_name()
    select @snapshot_ready=snapshot_ready, @retention=retention, @retention_period_unit = retention_period_unit, @pubid=pubid
        from dbo.sysmergepublications where name=@publication and publisher=publishingservername() and publisher_db=@db_name
    if @snapshot_ready is NULL
        select @snapshot_ready=snapshot_ready, @retention=retention, @retention_period_unit = retention_period_unit, @pubid=pubid
            from dbo.sysmergepublications where name=@publication
    if @snapshot_ready is NULL
    begin
        raiserror (21423, 11, -1, @publication)
        return (1)
    end

    /*
        ** Check to see if current publication has permission
        */
        if ({ fn ISPALUSER(@pubid) } &lt;&gt; 1)
        begin   
                RAISERROR (21423, 11, -1, @publication)
                return (1)
        end

    if @snapshot_ready=1 and @retention&gt;0
    begin
        select @last_snapshot=last_validated from dbo.sysmergesubscriptions where subid=@pubid
        if sys.fn_add_units_to_date(@retention, @retention_period_unit, @last_snapshot) &lt; getdate()
            select @snapshot_ready=3 /* snapshot is obsolete */
    end
    select @snapshot_ready
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

