## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_cdc_disable_table\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_cdc_disable_table**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -1057038550 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@source_schema| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@capture_instance| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_cdc_disable_table\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_cdc_disable_table\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_cdc_disable_table 
(
    @source_schema sysname,
    @source_name sysname,
    @capture_instance sysname
)
as
begin
    declare @retcode int
        ,@db_name sysname
   
    -- Verify caller is authorized to disable change data capture for the table.
    -- Caller must either be a member of the fixed sysadmin SQL Server role, or
    -- a member of the current database db_owner role. 
    if (isnull(is_srvrolemember('sysadmin'),0) = 0) and (isnull(is_member('db_owner'),0) = 0)
    begin
         raiserror(22904, 16, -1)
        return 1
    end
    
    -- Verify database is enabled for change data capture before switching to the database 'cdc' user 
    if ([sys].[fn_cdc_is_db_enabled]() != 1)
    begin
        set @db_name = db_name()
        raiserror(22901, 16, -1, @db_name)
        return 1
    end
 
    -- Switch to the database 'cdc' user prior to calling module that can
    -- cause DML and/or DDL triggers to fire.   
    execute as user = 'cdc'
    
    -- Call internal stored procedure that executes as 'cdc' user to do the work
    exec @retcode = sys.sp_cdc_disable_table_internal
        @source_schema,
        @source_name,
        @capture_instance
        
    if (@@error &lt;&gt; 0) or (@retcode &lt;&gt; 0)
    begin
        revert
        return 1
    end
    
    revert
    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

