## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_dropremotelogin\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_dropremotelogin**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -1057934000 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@remoteserver| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@loginame| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@remotename| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_dropremotelogin\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_dropremotelogin\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_dropremotelogin
    @remoteserver    sysname,            -- name of remote server
    @loginame        sysname = NULL,        -- user's local user name
    @remotename        sysname = NULL        -- user's remote name
as
    declare @sid varbinary(85)

    -- DISALLOW USER XACT --
    set implicit_transactions off
    if @@trancount &gt; 0
    begin
        raiserror(15002,-1,-1,'sys.sp_dropremotelogin')
        return (1)
    end

    -- CHECK PERMISSIONS
    if not (has_perms_by_name(null, null, 'alter any login') = 1)
    begin
        EXEC %%System().AuditEvent(ID = 1380207698, Success = 0, TargetLoginName = @loginame, TargetUserName = NULL, Role = NULL, Object = @remotename, Provider = NULL, Server = @remoteserver)
        raiserror(15247,-1,-1)
        return (1)
    end
    else
        EXEC %%System().AuditEvent(ID = 1380207698, Success = 1, TargetLoginName = @loginame, TargetUserName = NULL, Role = NULL, Object = @remotename, Provider = NULL, Server = @remoteserver)


    -- CHECK FOR INVALID PARAMETER SYNTAX --
    if @remoteserver is null OR (@loginame is null and @remotename is not null)
    begin
        raiserror(15600,-1,-1,'sys.sp_dropremotelogin')
        return (1)
    end

    BEGIN TRAN

    -- VALIDATE/LOCK SERVER NAME --
    EXEC %%LinkedServer ( Name = @remoteserver ) . Lock ( Exclusive = 1 )
    IF @@ERROR &lt;&gt; 0
    begin
        ROLLBACK TRAN
        raiserror(15015,-1,-1,@remoteserver)
        return (1)
    end

    -- VALIDATE/LOCK @loginame --
    if @loginame is not null
    begin
        -- share-lock the local login
        EXEC %%LocalLogin ( Name = @loginame ) . Lock ( Exclusive = 0 )
        IF @@ERROR = 0
            select @sid = sid from sys.server_principals
                where name = @loginame and type = 'S'        -- cannot map to NT login
        if @sid is null
        begin
            ROLLBACK TRAN
            raiserror(15007,-1,-1,@loginame)
            return (1)
        end
    end

    -- CHECK IF REQUESTED MAPPING ACTUALLY EXISTS --
    IF NOT EXISTS (SELECT * FROM master.dbo.sysremotelogins WHERE
            remoteserverid IN (SELECT srvid FROM master.dbo.sysservers WHERE srvname = @remoteserver)
            AND ((@sid IS NULL and sid IS NULL) or sid = @sid)
            AND ((@remotename IS NULL and remoteusername IS NULL) or remoteusername = @remotename) )
    BEGIN
        ROLLBACK TRAN
        raiserror(15185,-1,-1,@remotename,@loginame,@remoteserver)
        return (1)
    END

    -- DROP REMOTE LOGIN --
    EXEC %%LinkedServer(Name=@remoteserver).RemoveRemoteLogin( RemoteName = @remotename )

    -- SUCCESS --
    COMMIT TRAN
    return (0)    -- sp_dropremotelogin
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

