## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSgetdynamicsnapshotapplock\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSgetdynamicsnapshotapplock**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -1059059673 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@partition_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@lock_acquired| |int|4|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@timeout| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSgetdynamicsnapshotapplock\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSgetdynamicsnapshotapplock\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSgetdynamicsnapshotapplock(
    @publication sysname,
    @partition_id int,
    @lock_acquired int OUTPUT,
    @timeout int = -1)
as
    set nocount on

    declare @retcode smallint
    declare @lock_resource nvarchar(255)
    declare @pubnumber smallint
    declare @publisher sysname
    declare @publisher_db sysname
    declare @pubid uniqueidentifier       
    declare @PALRole sysname

    select @publisher = publishingservername() 
    select @publisher_db = DB_NAME() 
    select @pubnumber = 0

    select @retcode = 0
    select @lock_acquired = -1

    -- partition id can be &gt;= 0 
    if @partition_id = -1
    begin
        raiserror(20627, 16, -1)
        return 1
    end

    exec @retcode = sys.sp_MSrepl_PAL_rolecheck @publication = @publication
    if @retcode&lt;&gt;0 or @@ERROR&lt;&gt;0
        return 1

    select @pubnumber = publication_number, @pubid = pubid  from dbo.sysmergepublications  
            where name=@publication and upper(publisher)=upper(@publisher) and publisher_db=@publisher_db
    if @pubnumber is NULL or @pubnumber = 0 
    begin
        RAISERROR (20026, 16, -1, @publication)
        return 1
    end

    -- Since we have gone through the PAL check already, the PAL role
    -- should have been set. The following call to fn_MSmerge_GetPALRole 
    -- is nothing more than a way to retrieve the PAL role name
    select @PALRole = NULL
    select @PALRole = sys.fn_MSmerge_GetPALRole(@pubid)
    if @PALRole is NULL
        return 1

    select @lock_resource = N'MSinternal_dynamic_snapshot_' + 
                    convert(nvarchar(6), db_id()) + '_' +
                    convert(nvarchar(6), @pubnumber) + '_' +
                    convert(nvarchar(11), @partition_id)

    exec @retcode = sp_getapplock @Resource = @lock_resource,
                                  @LockMode = N'Exclusive',
                                  @LockOwner = N'Session',
                                  @LockTimeout = @timeout, -- wait till the the given @timeout time to get it
                                  @DbPrincipal = @PALRole
    if @@error = 0
    begin
        select @lock_acquired = @retcode
        select @retcode = 0
    end
    else
    begin
        select @lock_acquired = -1
        select @retcode  = 1
    end

    return @retcode
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

