## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_replmonitorrefreshjob\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_replmonitorrefreshjob**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -1067473073 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@iterations| |tinyint|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@profile| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_replmonitorrefreshjob\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_replmonitorrefreshjob\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_replmonitorrefreshjob 
(
    @iterations tinyint = 0 -- 0 - run continuously, non 0 - run for specified iterations
    ,@profile bit = 0 -- for internal use - DO NOT DOCUMENT (remove this before release)
)
as
begin
    set nocount on
    declare @retcode int
                ,@distribution_db sysname
                ,@loopcounter tinyint
                ,@prechecksum int
                ,@postchecksum int
                ,@lastcomputetime int
                ,@delaytime int 
                ,@strdelaytime sysname
                ,@datebuf datetime
                ,@refreshpolicy tinyint

    --
    -- initialize
    --
    select @distribution_db = db_name()
                ,@loopcounter = 0
                ,@prechecksum = 0
                ,@postchecksum = 0
                ,@lastcomputetime = 0
                ,@refreshpolicy = 1
    --
    -- security check
    --
    if not (is_member(N'db_owner') = 1 or isnull(is_member(N'replmonitor'),0) = 1)
    begin
        raiserror(14260, 16, -1)
        return (1)
    end
    --
    -- security: Has to be executed from distribution database
    --
    if sys.fn_MSrepl_isdistdb (@distribution_db) != 1
    begin
        raiserror (21482, 16, -1, 'sp_replmonitorrefreshjob', 'distribution')
        return 1
    end
    --
    -- validate @iterations
    --
    if (@iterations &lt; 0)
    begin
        raiserror(20587, 16, -1, '@iterations', 'sp_replmonitorrefreshjob')
        return (1)
    end
    --
    -- We are going through the main loop to do refresh
    --
    while (1=1)
    begin
        --
        -- get the checksum value before refresh
        --
        select @prechecksum = checksum(time_stamp)
            from dbo.MSreplication_monitordata
        
        --
        -- refresh the cache
        --
        exec @retcode = sys.sp_replmonitorrefreshdata @refreshpolicy = @refreshpolicy, @profile = @profile
        if @retcode != 0 or @@error != 0
            return 1
        --
        -- check if we need to break out of loop
        --
        if (@iterations &gt; 0)
        begin
            select @loopcounter = @loopcounter + 1 
            if (@profile = 1)
                raiserror('Completed %d iteration(s)', 10, 1, @loopcounter)
            if (@iterations = @loopcounter)
                break
        end
        --
        -- we need to wait for next cycle
        -- get the checksum value after refresh
        --
        select @postchecksum = checksum(time_stamp)
                    ,@lastcomputetime = isnull(computetime, 0)
            from dbo.MSreplication_monitordata
       
        --
        -- compute how much to wait in seconds
        --
        select @delaytime = case 
            -- no changes were there in cache
            when (@prechecksum = @postchecksum) then case when (30 &gt; @lastcomputetime) then 30 else @lastcomputetime end
            -- changes were there in cache
            else case when (4 &gt; @lastcomputetime) then 4 else @lastcomputetime end 
            end
        --
        -- convert the delaytime to usable format
        --
        select @datebuf = dateadd(ss, @delaytime, 0x0)
        select @strdelaytime = cast(datepart(hh, @datebuf) as nvarchar(4)) + N':'
                    + cast(datepart(mi, @datebuf) as nvarchar(4)) + N':'
                    + cast(datepart(ss, @datebuf) as nvarchar(6)) 
        --
        -- wait for given delay
        --
        if (@profile = 1)
            raiserror('Waitfor delay %s', 10, 1, @strdelaytime)
        waitfor delay @strdelaytime
    end -- while (1=1)
    --
    -- all done
    --
    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

