## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_password\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_password**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -1067822458 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@old| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@new| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@loginame| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_password\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_password\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_password
    @old sysname = NULL,        -- the old (current) password
    @new sysname,               -- the new password
    @loginame sysname = NULL    -- user to change password on
as
    -- SETUP RUNTIME OPTIONS / DECLARE VARIABLES --
    set nocount on
    declare @exec_stmt nvarchar(4000)

    -- RESOLVE LOGIN NAME
    if @loginame is null
        select @loginame = suser_sname()

    if @new is null
        select @new = ''

    -- DISALLOW USER TRANSACTION --
    set implicit_transactions off
    IF (@@trancount &gt; 0)
    begin
        raiserror(15002,-1,-1,'sys.sp_password')
        return (1)
    end

    -- CHECK IT'S A SQL LOGIN --
    if not exists (select * from master.dbo.syslogins where
                   loginname = @loginame and isntname = 0)
    begin
        raiserror(15007,-1,-1,@loginame)
        return (1)
    end

    if @old is null
        set @exec_stmt = 'alter login ' + quotename(@loginame) +
            ' with password = ' + quotename(@new, '''')
    else
        set @exec_stmt = 'alter login ' + quotename(@loginame) +
            ' with password = ' + quotename(@new, '''') + ' old_password = ' + quotename(@old, '''')

    exec (@exec_stmt)    

    if @@error &lt;&gt; 0
        return (1)

    -- RETURN SUCCESS --
    return  (0)    -- sp_password
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

