## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_help_log_shipping_monitor_secondary\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_help_log_shipping_monitor_secondary**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -107214840 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@secondary_server| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@secondary_database| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|secondary_server|nvarchar|128|
|secondary_database|nvarchar|128|
|secondary_id|uniqueidentifier|16|
|primary_server|nvarchar|128|
|primary_database|nvarchar|128|
|restore_threshold|int|4|
|threshold_alert|int|4|
|threshold_alert_enabled|bit|1|
|last_copied_file|nvarchar|500|
|last_copied_date|datetime|8|
|last_copied_date_utc|datetime|8|
|last_restored_file|nvarchar|500|
|last_restored_date|datetime|8|
|last_restored_date_utc|datetime|8|
|last_restored_latency|int|4|
|history_retention_period|int|4|

---
### Objects that depend on \[sys\].\[sp_help_log_shipping_monitor_secondary\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_help_log_shipping_monitor_secondary\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_help_log_shipping_monitor_secondary 
(
    @secondary_server sysname
    ,@secondary_database sysname
)
as
begin
    set nocount on
    declare @retcode int
    --
    -- security check
    --
    exec @retcode = sys.sp_MSlogshippingsysadmincheck
    if (@retcode != 0 or @@error != 0)
        return 1
    --
    -- must be invoked from master db
    --
    if (db_name() != N'master')
    begin
        raiserror(5001, 16,-1)
        return 1
    end
    --
    -- return resultset
    --
    select *
    from msdb.dbo.log_shipping_monitor_secondary
    where secondary_server = upper(@secondary_server)
        and secondary_database = @secondary_database
    --
    -- all done
    --
    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

