## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSalreadyhavegeneration\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSalreadyhavegeneration**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -1073624922 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@genguid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscribernick| |binary|6|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@compatlevel| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSalreadyhavegeneration\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSalreadyhavegeneration\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSalreadyhavegeneration
    (@genguid uniqueidentifier, 
     @subscribernick binary(6),
     @compatlevel int = 10) -- backward compatibility level, default=Sphinx

as
    declare @nicknames varbinary(1000)
    declare @offset int
    declare @retcode int
    declare @dbname sysname
    
    -- Security Checking 
    -- PAL users have access
    exec @retcode = sys.sp_MSrepl_PAL_rolecheck
    if (@retcode &lt;&gt; 0) or (@@error &lt;&gt; 0)
        return 1
        
    if (@genguid is null)
    begin
        RAISERROR(14043, 16, -1, '@genguid', 'sp_MSalreadyhavegeneration')
        return (1)
    end

    select @nicknames = nicknames from dbo.MSmerge_genhistory where guidsrc = @genguid
    if @nicknames is null
    begin
        set @dbname= db_name()
        -- what is the appropriate error to return?
        RAISERROR(21333, 16, -1, @dbname)
        return (1)
    end

    if @compatlevel &lt; 90
        set @subscribernick= substring(@subscribernick,1,4) + 0x0000

    declare @replnicklength int
    set @replnicklength= col_length('sysmergesubscriptions', 'replnickname')
    set @offset= 1
    while @offset &lt; DATALENGTH(@nicknames)
    begin
        -- If the subscriber nickname is already in the list just return
        if substring(@nicknames, @offset, @replnicklength) = @subscribernick
            return (0)
        set @offset = @offset + @replnicklength
    end
    
    -- Subscriber nickname is not in the array.  Add it so that we won't send this gen
    -- back down in the return message.  (Would waste bandwidth...)

    -- Append guard byte
        set @offset = DATALENGTH(@nicknames)
    if substring(@nicknames, @offset, 1) &lt;&gt; 0xFF
        begin
                set @nicknames = @nicknames + 0xFF
        end

    if @nicknames = 0x0
        set @nicknames = @subscribernick + 0xFF
    else
        set @nicknames = @subscribernick + @nicknames

    update dbo.MSmerge_genhistory set nicknames = @nicknames where guidsrc = @genguid
    
    return (0)
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

