## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSreenable_check\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSreenable_check**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -110745426 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@objname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@objowner| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSreenable_check\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSreenable_check\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSreenable_check @objname sysname, @objowner sysname = NULL
as
    set nocount on
    
    declare @cnstname sysname
    declare @cnstid int
    declare @objid int
    declare @enable_cmd nvarchar(4000)
    declare @dest nvarchar(514)

    declare @retcode int
    IF @objname IS NULL
    BEGIN
        RAISERROR (14043, 16, -1, '@objname', 'sp_MSreenable_check')
        RETURN (1)
    END

    if(@objowner is not null)
        select @dest = quotename(@objowner) + N'.' + quotename(@objname)
    else
        select @dest = quotename(@objname)

    EXEC @retcode = sys.sp_MSreplcheck_publish
    IF @@ERROR &lt;&gt; 0 or @retcode &lt;&gt; 0
            return (1)

    select @objid = object_id(@objname)
    
    declare ms_crs_cnst cursor local static for
    select name, object_id 
        from sys.objects 
        where parent_object_id = @objid 
            and OBJECTPROPERTY(object_id, 'CnstIsDisabled') = 1 
            and OBJECTPROPERTY(object_id, 'CnstIsNotRepl') = 0 
            and (OBJECTPROPERTY(object_id, 'IsCheckCnst') = 1 
                or OBJECTPROPERTY(object_id, 'IsForeignKey') = 1)
    union
    select name, object_id
        from sys.triggers
        where parent_id = @objid 
            and OBJECTPROPERTY(object_id, 'IsTrigger') = 1 
            and OBJECTPROPERTY(object_id, 'ExecIsTriggerNotForRepl') = 0 
            and OBJECTPROPERTY(object_id, 'ExecIsTriggerDisabled') = 1
    for read only

    open ms_crs_cnst
    fetch ms_crs_cnst into @cnstname, @cnstid
    while @@fetch_status &gt;= 0
    begin
        if(ObjectProperty(@cnstid, 'IsTrigger') = 1)
            select @enable_cmd = N'alter table ' + @dest + N' enable trigger ' + quotename(@cnstname)
        else
            select @enable_cmd = N'alter table ' + @dest + N' check constraint ' + quotename(@cnstname)

        execute(@enable_cmd)
        fetch ms_crs_cnst into @cnstname, @cnstid
    end     --of major loop
    deallocate ms_crs_cnst
    return 0
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

