## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MShelpmergeidentity\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MShelpmergeidentity**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -121629849 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MShelpmergeidentity\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MShelpmergeidentity\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MShelpmergeidentity 
    @publication sysname
as
    declare @pubid                  uniqueidentifier
    declare @artid                  uniqueidentifier
    declare @nickname               int
    declare @next_seed              bigint
    declare @retcode                int
    declare @tablename              sysname
    declare @range                  bigint
    declare @threshold              int
    declare @db_name                sysname
    declare @tmp_table TABLE (tablename sysname, next_seed bigint, range bigint, threshold int, nickname int)
    declare @publishingservername sysname
    declare @subid uniqueidentifier

    /*
    ** To public.
    */
    set nocount on
    if (@publication is null)
    begin
        RAISERROR(14003, 16, -1)
        return (1)
    end

    select @db_name = db_name()
            ,@publishingservername = publishingservername()

    /* 
    ** Security Check.
    */
    exec @retcode = sys.sp_MSmerge_validate_publication_presence @publication, @db_name, @publishingservername, @pubid output
    if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
        return 1

    
    select TOP 1 @artid=artid, @nickname=nickname from dbo.sysmergearticles where pubid=@pubid and identity_support=1 order by nickname ASC
    while (@artid is not NULL)
    begin
        -- we need a local subid to look up the entry in MSmerge_identity_range
        select @subid=subid from dbo.MSmerge_identity_range where artid=@artid and is_pub_range=1 and (sys.fn_MSmerge_islocalsubid(subid)=1)
        
        insert @tmp_table (tablename, next_seed, range, threshold, nickname)
            select object_name(a.objid), i.max_used, a.range, a.threshold, a.nickname 
            from dbo.sysmergearticles a
                inner join dbo.MSmerge_identity_range i on i.artid=a.artid and i.subid=@subid and i.is_pub_range=1
            where a.artid = @artid and a.pubid = @pubid
        if @@ERROR&lt;&gt;0
        begin
            raiserror(21197, 16, -1)
            return (1)
        end
        select @artid = NULL 
        select TOP 1 @artid=artid, @nickname=nickname from dbo.sysmergearticles 
            where pubid=@pubid and nickname&gt;@nickname and identity_support=1 order by nickname ASC
    end
    select t.* from @tmp_table t, dbo.sysmergearticles sma 
    where t.nickname = sma.nickname
    and sma.pubid = @pubid
    order by sma.processing_order ASC, sma.nickname ASC
    
    return (0)  
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

