## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSuniquename\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSuniquename**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -122012172 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@seed| |nvarchar|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@start| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|Name|nvarchar|128|
|Next|int|4|

---
### Objects that depend on \[sys\].\[sp_MSuniquename\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSuniquename\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_MSuniquename
    @seed nvarchar(128), @start int = null
as
    /* Return a unique name for sysobjects, based on a passed-in seed. */
    set nocount on
    declare @i int, @append nvarchar(10), @seedlen int, @temp nvarchar(128), @recalcseedlen int, @seedcharlen int
    select @i = 1, @seedlen = datalength(@seed), @recalcseedlen = 1, @seedcharlen = 0
    if (@start is not null and @start &gt;= 0)
        select @i = @start
    while 1 &lt; 2
    begin
        /* This is probably overkill, but start at max length of seed name, leaving room under OSQL_DBLSYSNAME_SET for @append. */
        /* We'll work our way back along the string if more room needed (pathological user). */
        select @append = ltrim(str(@i)) + N'__' + ltrim(str(@@spid))
        if (@recalcseedlen = @i or @seedcharlen = 0)
        begin
            while @recalcseedlen &lt;= @i
                select @recalcseedlen = @recalcseedlen * 10
            select @seedcharlen = @seedlen
            if ((@seedlen + datalength(@append)) &gt; 128) begin
                select @seedlen = 128 - datalength(@append)

                /* Get the charlen of this datalength for the substring() call. */
                select @seedcharlen = @seedlen
               /* exec sp_GetMBCSCharLen @seed, @seedlen, @seedcharlen out */
            end        /* Recalc seedlen */
        end        /* Check seedlen */

        select @temp = substring(@seed, 1, @seedcharlen) + @append

        /* If I don't set a limit somewhere, it's gonna look hung -- I'd rather get a nonunique error. */
        if object_id(@temp) is null or @i &gt; 999999        /* if increased, watch out for overflow of @recalcseedlen */
        begin
            set nocount off
            select Name = @temp, Next = @i + 1
            return 0
        end
        select @i = @i + 1
    end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

