## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MShelpdynamicsnapshotjobatdistributor\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MShelpdynamicsnapshotjobatdistributor**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -122391960 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@dynamic_filter_login| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@dynamic_filter_hostname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_type| |int|4|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_interval| |int|4|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_subday| |int|4|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_subday_interval| |int|4|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_relative_interval| |int|4|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_recurrence_factor| |int|4|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@active_start_date| |int|4|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@active_end_date| |int|4|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@active_start_time_of_day| |int|4|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@active_end_time_of_day| |int|4|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MShelpdynamicsnapshotjobatdistributor\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MShelpdynamicsnapshotjobatdistributor\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
--
-- Name: sp_MShelpdynamicsnapshotjobatdistributor
--
-- Description: This gives scheduling information about a dynamic snapshot job 
--
-- Returns: 0 - succeeded
--          1 - failed
--
-- Security: Only members of the 'sysadmin' server role and members of the 
--           'db_owner' database role at the distributor can call this 
--           procedure. This procedure is intended to be called through 
--           the distributor_admin remote login in the case where
--           the distributor is a different machine from the publisher. 
--
create procedure sys.sp_MShelpdynamicsnapshotjobatdistributor 
(
    @publisher sysname,
    @publisher_db sysname,
    @publication sysname,
    @dynamic_filter_login sysname,
    @dynamic_filter_hostname sysname,
    @frequency_type     int output,
    @frequency_interval int output,
    @frequency_subday   int output,
    @frequency_subday_interval   int output,
    @frequency_relative_interval int output,
    @frequency_recurrence_factor int output,
    @active_start_date           int output,
    @active_end_date             int output,
    @active_start_time_of_day    int output,
    @active_end_time_of_day      int output
)
as
begin
    set nocount on

    declare @retcode int
    declare @job_id uniqueidentifier
    declare @publisher_id int
    declare @publication_type int
    
    --
    -- security check
    -- only db_owner can execute this
    --
    if (is_srvrolemember('sysadmin') != 1) 
    begin
        raiserror(14260, 16, -1)
        return (1)
    end
    --
    -- security check
    -- Has to be executed from distribution database
    --
    if (sys.fn_MSrepl_isdistdb (db_name()) != 1)
    begin
        raiserror(21482, 16, -1, 'sp_MShelpdynamicsnapshotjobatdistributor', 'distribution')
        return (1)
    end

    if @dynamic_filter_login is NULL and @dynamic_filter_hostname is NULL
    begin
        raiserror(20653, 16, -1)
        return 1
    end
    
    select @retcode = 0

    SELECT @publisher_id = srvid 
      FROM master.dbo.sysservers
     WHERE UPPER(srvname) = UPPER(@publisher)
    IF @publisher_id IS  NULL
    BEGIN
        RAISERROR(21169, 16, -1, @publisher, @@SERVERNAME, @publisher)    
    END

    select @job_id = job_id,
           @publication_type = publication_type
      from MSsnapshot_agents
     where publisher_id = @publisher_id and 
           publication = @publication and 
           publisher_db = @publisher_db and
           ((@dynamic_filter_login is NULL and dynamic_filter_login is NULL) or dynamic_filter_login = @dynamic_filter_login)  and
           ((@dynamic_filter_hostname is NULL and dynamic_filter_hostname is NULL) or dynamic_filter_hostname = @dynamic_filter_hostname)
    if @job_id is NULL
    begin
        raiserror(21325, 11, -1)
        return 1
    end
    
    if @publication_type &lt;&gt; 2
    begin
        raiserror(20654, 16, -1)
        return 1
    end

    select @frequency_type = ss.freq_type,
           @frequency_interval = ss.freq_interval,
           @frequency_subday = ss.freq_subday_type,
           @frequency_subday_interval = ss.freq_subday_interval,
           @frequency_relative_interval = ss.freq_relative_interval,
           @frequency_recurrence_factor = ss.freq_recurrence_factor,
           @active_start_date = ss.active_start_date,
           @active_end_date = ss.active_end_date,
           @active_start_time_of_day = ss.active_start_time,
           @active_end_time_of_day = ss.active_end_time
    from msdb..sysjobs sjb, msdb..sysjobschedules sjs, msdb..sysschedules ss
    where sjb.job_id = @job_id and
          sjs.job_id = sjb.job_id and
          ss.schedule_id = sjs.schedule_id

    
    RETURN(0)

UNDO:
    return(1)
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

