## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSenum_distribution_s\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSenum_distribution_s**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -125164353 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@name| |nvarchar|100|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@hours| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@session_type| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSenum_distribution_s\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSenum_distribution_s\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSenum_distribution_s
(
    @name nvarchar(100), 
    @hours int = 0, /* @hours &lt; 0 will return TOP 100 */
    @session_type int = 1 /* Return all sessions */
)
as
begin
    set nocount on

    declare @notstarted int
        ,@succeed int
        ,@retry int
        ,@failure int
        ,@min_time datetime
        ,@agent_id int

    --
    -- security check
    -- only replmonitor can execute this
    --
    if not (is_member(N'db_owner') = 1 or isnull(is_member(N'replmonitor'),0) = 1)
    begin
        raiserror(14260, 16, -1)
        return (1)
    end
    
    /* 
    ** Status const defined in sqlrepl.h 
    */
    select @notstarted = 0
            ,@succeed = 2
            ,@retry = 5
            ,@failure = 6
            ,@min_time = NULL

    select @agent_id = id 
        from MSdistribution_agents 
        where name = @name
    
    --
    -- Check @hours
    -- return top 100 rows if &lt; 0
    -- return session later than if &gt; 0
    --
    if @hours &lt; 0
        set rowcount 100
    else if @hours &gt; 0
        select @min_time = dateadd(hour, -@hours, getdate())
    --
    -- enumerate the sessions now
    --
    select rh.runstatus, 
            'start_time' = sys.fn_replformatdatetime(rh.start_time), 
            'time' = sys.fn_replformatdatetime(rh.time), 
            rh.comments, rh.duration, 
            rh.delivery_rate,
            rh.delivery_latency,
            0, /*delivery_time */   
            rh.delivered_transactions, rh.delivered_commands, rh.average_commands, 
            'action_count' = hs.action_count,
            rh.error_id
        from MSdistribution_history rh with (READPAST) 
            join (select agent_id, 
                        start_time, 
                        count(start_time) as action_count, 
                        max(timestamp) as max_timestamp 
                    from MSdistribution_history with (READPAST)
                    where agent_id = @agent_id
                        and runstatus != @notstarted
                        and comments not like N'&lt;stats state%'    
                        and (@session_type = 1
                            or runstatus = @failure)
                    group by agent_id, start_time) as hs
            on rh.agent_id = hs.agent_id
                and rh.start_time = hs.start_time
                and rh.timestamp = hs.max_timestamp
        -- if min time is specified then return sessions after that 
        where @min_time IS NULL 
            or time &gt;= @min_time
        order by timestamp desc
    --
    -- all done
    --
    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

