## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_add_log_shipping_primary_secondary\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_add_log_shipping_primary_secondary**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -128382326 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@primary_database| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@secondary_server| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@secondary_database| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@overwrite| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_add_log_shipping_primary_secondary\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_add_log_shipping_primary_secondary\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_add_log_shipping_primary_secondary 
(
    @primary_database sysname
    ,@secondary_server sysname
    ,@secondary_database sysname
    ,@overwrite bit = 0
)
as
begin
    set nocount on
    declare @retcode int
                ,@primary_id uniqueidentifier

    --
    -- security check
    --
    exec @retcode = sys.sp_MSlogshippingsysadmincheck
    if (@retcode != 0 or @@error != 0)
        return 1
    --
    -- must be invoked from master db
    --
    if (db_name() != N'master')
    begin
        raiserror(5001, 16,-1)
        return 1
    end
    
    --
    -- Primary database should exist
    --
    select @primary_id = primary_id
    from msdb.dbo.log_shipping_primary_databases
    where primary_database = @primary_database
    if (@primary_id is null)
    begin
        raiserror(32010, 10, 4, @primary_database)
        return 0
    end

    --
    -- Parameter Check: @secondary_server
    --
    if @secondary_server is null or @secondary_server=N''
    begin
        raiserror (32052, 16, -1, N'@secondary_server')
        return 1
    end

    --
    -- Parameter Check: @secondary_server
    --
    if @secondary_database is null or @secondary_database=N''
    begin
        raiserror (32052, 16, -1, N'@secondary_database')
        return 1
    end
    
    --
    -- secondary should not exist already
    --
    if exists (select * from msdb.dbo.log_shipping_primary_secondaries
                where primary_id = @primary_id
                    and secondary_server = upper(@secondary_server)
                    and secondary_database = @secondary_database)
    begin
        if (@overwrite = 0)
        begin
            raiserror(32012, 10, 1, @secondary_server, @secondary_database, @primary_database)
            return 1
        end
        else
        begin
            delete msdb.dbo.log_shipping_primary_secondaries
            where primary_id = @primary_id
                and secondary_server = upper(@secondary_server)
                and secondary_database = @secondary_database
        end
    end
    --
    -- add a row in msdb.dbo.log_shipping_primary_secondaries
    --
    insert into msdb.dbo.log_shipping_primary_secondaries (
        primary_id, secondary_server, secondary_database)
    values (@primary_id, upper(@secondary_server), @secondary_database)
    if (@@error != 0)
        return 1
    --
    -- all done
    --
    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

