## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MScreatelightweightprocstriggersconstraints\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MScreatelightweightprocstriggersconstraints**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -128481486 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@pubid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@artid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@next_seed| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@range| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@threshold| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MScreatelightweightprocstriggersconstraints\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MScreatelightweightprocstriggersconstraints\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MScreatelightweightprocstriggersconstraints
    @pubid            uniqueidentifier,
    @artid            uniqueidentifier,
    @next_seed        bigint= NULL,    -- for id range mgt
    @range            bigint= NULL,    -- for id range mgt
    @threshold        int= NULL        -- for id range mgt
as
    set nocount on

    declare @retcode    int

    -- security check
    exec @retcode = sys.sp_MSreplcheck_subscribe 
    if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0 return 1
    
    begin tran
    save tran sp_MSlightweightprocsandtriggers

    -- create the procedures
    exec @retcode= sys.sp_MScreatelightweightarticleprocs @pubid= @pubid, @artid= @artid
    if @@error &lt;&gt;0 or @retcode &lt;&gt; 0 goto Failure

    -- create the triggers if the article is updateable
    if 1 = sys.fn_MSarticle_allows_DML_at_this_replica(@artid, default)
    begin
        exec @retcode= sys.sp_MScreatelightweighttriggers @artid= @artid
        if @@error &lt;&gt;0 or @retcode &lt;&gt; 0 goto Failure
    end
    else
    begin
        -- Create trigger that disallows local updates/inserts/deletes.
        exec @retcode= sys.sp_MScreatedownloadonlytriggers @artid= @artid
        if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0 goto Failure
    end

    -- set the identity range
    if @range is not null
    begin
        declare @objid int

        select @objid= objid from dbo.sysmergearticles where
            pubid = @pubid and artid = @artid
        if @objid is null goto Failure
        
        exec @retcode= sys.sp_MSreseed 
                                @objid= @objid, 
                                @next_seed= @next_seed,
                                @range= @range
        if @@error &lt;&gt;0 or @retcode &lt;&gt; 0 goto Failure

        if not exists (select objid from dbo.MSmerge_idrange where objid = @objid)
        begin   
            insert into dbo.MSmerge_idrange    (objid, max_identity, range, threshold) 
                                    values (@objid, @next_seed + @range, @range, @threshold)
        end
        if @@error &lt;&gt;0 or @retcode &lt;&gt; 0 goto Failure
    end

    commit tran
    return 0

Failure:
    rollback tran sp_MSlightweightprocsandtriggers
    commit tran
    return 1
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

