## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_helpmergealternatepublisher\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_helpmergealternatepublisher**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -132862586 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_helpmergealternatepublisher\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_helpmergealternatepublisher\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_helpmergealternatepublisher (
    @publisher                    sysname,    /* Publisher server */
    @publisher_db                sysname,    /* Publisher database */
    @publication                sysname    /* Publication name */
) AS

    SET NOCOUNT ON
    declare @subid                uniqueidentifier
    declare @pubid                uniqueidentifier
    declare @distributor        sysname
    declare @retcode            int

    declare @MShelpmergealternatepublisher TABLE
    (
        subid                    uniqueidentifier    not null,
        alternate_publisher        sysname                collate database_default not null,     
        alternate_publisher_db    sysname                collate database_default not null,     
        alternate_publication    sysname                collate database_default not null,     
        alternate_distributor    sysname                collate database_default null,     
        friendly_name            nvarchar(255)        collate database_default null,     
        enabled                    bit                    not null
    )
    
    set @publisher= LOWER(@publisher collate SQL_Latin1_General_CP1_CS_AS)
    
    /*
    ** Select the subscription's pubid and subid
    */
    select @pubid = pubid from dbo.sysmergepublications     
                where name = @publication and
                    LOWER(publisher collate SQL_Latin1_General_CP1_CS_AS) = @publisher and
                    publisher_db = @publisher_db
    if @pubid is NULL
    begin
        -- since we are adding a sysmergepublications entry for the alternate publisher
        -- see sp_MScreateglobalreplica - the entry should be there
        raiserror (21423, 11, -1, @publication)
        return (1)
    end

    if  1 &lt;&gt; {fn ISPALUSER(@pubid)} 
    begin
        raiserror(21423, 11, -1, @publication)
        return (1)
    end
        
    insert into @MShelpmergealternatepublisher 
        (subid, alternate_publisher, alternate_publisher_db, 
         alternate_publication, alternate_distributor, friendly_name, enabled)
    select distinct pub.pubid, pub.publisher, pub.publisher_db, 
          pub.name, pub.distributor, alt.description, 1
    from dbo.sysmergepublications pub, dbo.MSmerge_altsyncpartners alt
    where pub.pubid = alt.alternate_subid and alt.subid = @pubid

    insert into @MShelpmergealternatepublisher 
        (subid, alternate_publisher, alternate_publisher_db, 
         alternate_publication, alternate_distributor, friendly_name, enabled)
    select pubid, publisher, publisher_db, 
          name, distributor, description, 1
    from dbo.sysmergepublications where pubid = @pubid

    insert into @MShelpmergealternatepublisher 
        (subid, alternate_publisher, alternate_publisher_db, 
         alternate_publication, alternate_distributor, friendly_name, enabled)
    select distinct pub.pubid, pub.publisher, pub.publisher_db, 
          pub.name, pub.distributor, sub.description, 0
    from dbo.sysmergepublications pub, dbo.sysmergesubscriptions sub
    where pub.pubid not in (select subid from dbo.MSmerge_altsyncpartners) and
          pub.pubid not in (select alternate_subid from dbo.MSmerge_altsyncpartners) and
          pub.pubid not in (select subid from @MShelpmergealternatepublisher) and
          sub.pubid = pub.pubid and sub.pubid = sub.subid
          
    select distinct alternate_publisher,
        alternate_publisher_db,
        alternate_publication,
        alternate_distributor,
        friendly_name,
        enabled 
        from @MShelpmergealternatepublisher 
    order by alternate_publisher, alternate_publisher_db, alternate_publication, alternate_distributor
    
    return (0)

GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

