## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_column_privileges_ex\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_column_privileges_ex**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -134075252 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@table_server| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@table_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@table_schema| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@table_catalog| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@column_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|TABLE_CAT|nvarchar|128|
|TABLE_SCHEM|nvarchar|128|
|TABLE_NAME|nvarchar|128|
|COLUMN_NAME|nvarchar|128|
|GRANTOR|nvarchar|128|
|GRANTEE|nvarchar|128|
|PRIVILEGE|nvarchar|128|
|IS_GRANTABLE|varchar|3|

---
### Objects that depend on \[sys\].\[sp_column_privileges_ex\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_column_privileges_ex\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_column_privileges_ex
(
    @table_server       sysname,
    @table_name         sysname = null,
    @table_schema       sysname = null,
    @table_catalog      sysname = null,
    @column_name        sysname = null
)
as
    select
        TABLE_CAT       = TABLE_CATALOG,
        TABLE_SCHEM     = TABLE_SCHEMA,
        TABLE_NAME      = TABLE_NAME,
        COLUMN_NAME     = COLUMN_NAME,
        GRANTOR         = GRANTOR,
        GRANTEE         = GRANTEE,
        PRIVILEGE       = PRIVILEGE_TYPE,
        IS_GRANTABLE    = case IS_GRANTABLE
                            when 1 then 'YES'
                            when 0 then 'NO'
                            else null
                          end
    from sys.fn_remote_column_privileges(@table_server,
                                         @table_catalog,
                                         @table_schema,
                                         @table_name,
                                         NULL,
                                         NULL,
                                         NULL)
    where
        (COLUMN_NAME like @column_name or @column_name is NULL)
    order by TABLE_CAT, TABLE_SCHEM, TABLE_NAME, COLUMN_NAME, PRIVILEGE
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

