## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_procoption\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_procoption**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -140677272 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@ProcName| |nvarchar|776|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@OptionName| |varchar|35|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@OptionValue| |varchar|12|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_procoption\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_procoption\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_procoption
    @ProcName        nvarchar(776)
   ,@OptionName        varchar(35)
   ,@OptionValue    varchar(12)
as
    -- DECLARE VARIABLES
    declare    @tabid        int
            ,@uid        int
            ,@opt_value    int
            ,@opt_flag    bit
            ,@dbname    sysname

    -- DISALLOW USER TRANSACTION --
    set nocount on
    set implicit_transactions off
    if @@trancount &gt; 0
    begin
        raiserror(15002,-1,-1,'sys.sp_procoption')
        return @@error
    end

    -- VALIDATE OPTION NAME AND VALUE
    select @opt_flag = 
        case
            when (lower(@OptionValue) in ('1' ,'on' ,'yes' ,'true')) then 1
            when (lower(@OptionValue) in ('0' ,'off' ,'no' ,'false')) then 0
        end
    if (@opt_flag is null) OR (isnull(lower(@OptionName), '') &lt;&gt; 'startup')
    begin
        raiserror(15600,-1,-1, 'sys.sp_procoption')
        return @@error
    end
    
    -- RESOLVE GIVEN OBJECT NAME --
    select @tabid = object_id, @uid = schema_id from sys.objects
        where object_id = object_id(@ProcName, 'local') and type in ('X','P','PC')
    
    if @tabid is null
    begin
        raiserror(15165,-1,-1,@ProcName)
        return @@error
    end
    
    BEGIN TRANSACTION
    
    -- LOCK PROC &amp; CHECK PERMISSION --
    EXEC %%Object(MultiName = @ProcName).LockMatchID(ID = @tabid, Exclusive = 1, BindInternal = 0)
    if @@error &lt;&gt; 0
    begin
        ROLLBACK TRANSACTION
        raiserror(15165,-1,-1,@ProcName)
        return @@error
    end
        
    -- MUST BE sysadmin (Startup-procs run as sysadmin) --
    if is_srvrolemember('sysadmin') = 0
    begin
        --In case of failure Audit the event. Note in case of success the event will be audited when we lock the
        -- the object in exclusive mode and evaluate the permissions again through the security manager.
        if not (@tabid is null)
        begin 
            EXEC %%System().AuditEvent(ID = 1128350287, Success = 0, TargetLoginName = NULL, TargetUserName = NULL, Role = NULL, Object = @ProcName, Provider = NULL, Server = NULL)
        end
        ROLLBACK TRANSACTION
        raiserror(15165,-1,-1,@ProcName)
        return @@error
    end
    
    -- STARTUP PROC MUST BE OWNED BY DBO IN MASTER --
    if (db_id() &lt;&gt; 1 OR @uid &lt;&gt; 1)
    begin
        ROLLBACK TRANSACTION
        raiserror(15398,-1,-1)
        return @@error
    end
    
    -- VALID OBJECT IN DATABASE? --
    if @tabid is null
    begin
        ROLLBACK TRANSACTION
        select @dbname = db_name()
        raiserror(15009,-1,-1 ,@ProcName, @dbname)
        return @@error
    end

    -- PROC CANNOT HAVE PARAMETERS --
    if exists ( select * from sys.parameters where object_id = @tabid )
    begin
        ROLLBACK TRANSACTION
        raiserror(15399,-1, -1)
        return @@error
    end

    EXEC %%Module(ID = @tabid).SetStartup(Value = @opt_flag)

    -- Set Config option for startup procs
    set @opt_value =
            case when exists (select * from sys.objects where type in ('X','P','PC')
                and ObjectProperty(object_id, 'ExecIsStartup') = 1)
            then 1 else 0 end
    EXEC %%ServerConfiguration(ConfigID = 1547).SetValue(Value = @opt_value)

    -- EMDEventType(x_eet_AlterProc), EMDUniversalClass(x_eunc_Table), src major id, src minor id, src name
    -- -1 means ignore target stuff, target major id, target minor id, target name,
    -- # of parameters, 5 parameters
    EXEC %%System().FireTrigger(ID = 52, ID = 1, ID = @tabid, ID = 0, Value = @ProcName,
        ID = -1, ID = 0, ID = 0, Value = NULL, ID = 3,
        Value = @ProcName, Value = @OptionName, Value = @OptionValue, Value = NULL, Value = NULL, Value = NULL, Value = NULL)

    -- Commit and reconfigure
    COMMIT TRANSACTION
    RECONFIGURE WITH OVERRIDE

    -- RETURN SUCCESS
    RETURN 0 -- sp_procoption
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

