## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_addmergelogsettings\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_addmergelogsettings**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -14715688 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscriber| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscriber_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@support_options| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@web_server| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@log_severity| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@log_modules| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@log_file_path| |nvarchar|255|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@log_file_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@log_file_size| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@no_of_log_files| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@upload_interval| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@delete_after_upload| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@custom_script| |nvarchar|2000|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@message_pattern| |nvarchar|2000|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@agent_xe| |varbinary|2147483647|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@agent_xe_ring_buffer| |varbinary|2147483647|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@sql_xe| |varbinary|2147483647|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_addmergelogsettings\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_addmergelogsettings\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_addmergelogsettings (
    @publication        sysname = NULL,     /* Publication name */
    @subscriber         sysname = NULL,     /* Subscriber server */
    @subscriber_db      sysname = NULL,     /* Subscription database */
    @support_options    int = 1,
    @web_server            sysname = NULL, 
    @log_severity        int = 2, 
    @log_modules        int = 0, 
    @log_file_path        nvarchar(255) = NULL, 
    @log_file_name        sysname = NULL, 
    @log_file_size        int = 10000000, 
    @no_of_log_files    int = 5, 
    @upload_interval    int = 0, 
    @delete_after_upload int = 1,
    @custom_script    nvarchar(2000) = NULL,
    @message_pattern    nvarchar(2000)= NULL,
    @agent_xe    varbinary(max) = NULL,
    @agent_xe_ring_buffer    varbinary(max) = NULL,
    @sql_xe    varbinary(max) = NULL
    ) AS 

    declare @retcode                int
    declare @pubid                    uniqueidentifier
    declare @subid                    uniqueidentifier

    declare @log_sev_lobyte       int
    declare @log_sev_hibyte       int

    /*
    ** Security Check.
    */
    exec @retcode= sys.sp_MSreplcheck_subscribe
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
    begin
        raiserror(15247,-1,-1)
        return (1)
    end


    /*
    **    Check to see if current database is doing publishing/subscribing
    */
    IF object_id('sysmergesubscriptions') is NULL
    BEGIN
        RAISERROR (14055, 16, -1)
        RETURN (1)
    END

    /*
    ** Parameter Check:     @publication.
    ** Make sure that the publication exists.
    */

    IF @publication IS NULL
        BEGIN
            RAISERROR (14043, 16, -1, '@publication', 'sp_addmergelogsettings')
            RETURN (1)
        END

    select @pubid = pubid
       FROM dbo.sysmergepublications 
       WHERE name = @publication  and UPPER(publisher)=UPPER(publishingservername()) and publisher_db=db_name()
    IF @pubid IS NULL
        BEGIN
            RAISERROR (20026, 11, -1, @publication)
            RETURN (1)
        END

    
    /*
    ** Parameter Check:     @subscriber.
    ** Check to make sure we have a valid subscriber.
    */
    IF @subscriber IS NULL
    BEGIN
        RAISERROR (14043, 16, -1, '@subscriber', 'sp_addmergelogsettings')
        RETURN (1)
    END
    
    /*
    ** Parameter Check:     @subscriber_db.
    ** Check to make sure we have a valid subscriber.
    */
    IF @subscriber_db IS NULL
    BEGIN
        RAISERROR (14043, 16, -1, '@subscriber_db', 'sp_addmergelogsettings')
        RETURN (1)
    END

    /*
    ** Check to see if you have a subscription on this publication
    */
    set @subid = NULL
    select @subid = subid
          from dbo.sysmergesubscriptions
        where UPPER(subscriber_server) collate database_default = UPPER(@subscriber) collate database_default
            and db_name = @subscriber_db
            and pubid = @pubid  /* identified from publication name */
            
    if @subid IS NULL 
        begin
            RAISERROR (14050, 11, -1)
            RETURN(1)
        end                    

    /*
    ** Parameter Check: all other parameters
    ** 
    */
    if @support_options &lt; 0 or @support_options &gt; 5
    begin
        RAISERROR (20722, 16, -1, 'sp_addmergelogsettings', '@support_options')
        RETURN(1)
    end                    

    set @log_sev_lobyte = @log_severity &amp; 0xF
    set @log_sev_hibyte = @log_severity &amp; 0xF0
    
    if (@log_severity IS NOT NULL) and ((@log_sev_lobyte &lt; 0 or @log_sev_lobyte &gt; 5) or (@log_sev_hibyte &lt; 0 or @log_sev_hibyte &gt; 1))
    begin
        RAISERROR (20722, 16, -1, 'sp_addmergelogsettings', '@log_severity')
        RETURN(1)
    end                    

    if @log_file_size &lt; 2000000 or @log_file_size &gt; 999000000
    begin
        RAISERROR (20722, 16, -1, 'sp_addmergelogsettings', '@log_file_size')
        RETURN(1)
    end                    

    if @no_of_log_files &lt; 2 or @no_of_log_files &gt; 500
    begin
        RAISERROR (20722, 16, -1, 'sp_addmergelogsettings', '@no_of_log_files')
        RETURN(1)
    end                    

    if @upload_interval &lt; 0 or @upload_interval &gt; 40320    -- 60 * 24 * 7 *4 (4 weeks)
    begin
        RAISERROR (20722, 16, -1, 'sp_addmergelogsettings', '@upload_interval')
        RETURN(1)
    end                    

    if @delete_after_upload not in (0,1)
    begin
        RAISERROR (20722, 16, -1, 'sp_addmergelogsettings', '@delete_after_upload')
        RETURN(1)
    end                    

    begin tran
    save TRAN addmergelogsettings

    -- custom script is ignored when setting web_server log settings
    if @web_server IS NOT NULL
    begin
        select @custom_script = NULL
    end

    if not exists (select * from dbo.MSmerge_supportability_settings
                WHERE pubid = @pubid and subid = @subid and
                    ((@web_server IS NULL and web_server IS NULL) or (@web_server IS NOT NULL and
                    UPPER(web_server) collate database_default = UPPER(@web_server) collate database_default )))
    begin
    
            insert into dbo.MSmerge_supportability_settings 
                (pubid, subid, web_server, support_options, log_severity, log_modules, log_file_path, log_file_name, log_file_size, 
                no_of_log_files, upload_interval, delete_after_upload,custom_script,message_pattern, agent_xe, agent_xe_ring_buffer, sql_xe)
                
            values(@pubid, @subid, @web_server, @support_options, @log_severity, @log_modules, @log_file_path, @log_file_name, @log_file_size, 
                @no_of_log_files, @upload_interval, @delete_after_upload,@custom_script,@message_pattern, @agent_xe, @agent_xe_ring_buffer, @sql_xe)
        end
    else
        begin
            -- call update proc
            exec sp_changemergelogsettings @publication, @subscriber, @subscriber_db, @support_options, @web_server, @log_severity, @log_modules, @log_file_path, @log_file_name, @log_file_size, @no_of_log_files, @upload_interval, @delete_after_upload, @custom_script, @message_pattern, @agent_xe, @agent_xe_ring_buffer, @sql_xe
        end
        
    if @@ERROR &lt;&gt; 0
    BEGIN
        GOTO FAILURE
    END

    update dbo.sysmergesubscriptions
        set supportability_mode = 1
    where subid = @subid and pubid = @pubid

    if @@ERROR &lt;&gt; 0
    BEGIN
        GOTO FAILURE
    END

    COMMIT TRAN
    return (0)

FAILURE:
    RAISERROR (20717, 16, -1)
    /* UNDONE : This code is specific to 6.X nested transaction semantics */
    if @@TRANCOUNT &gt; 0
    begin
        ROLLBACK TRANSACTION addmergelogsettings
        COMMIT TRANSACTION
    end
    RETURN (1)
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

