## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_delete_log_shipping_primary_secondary\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_delete_log_shipping_primary_secondary**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -147233974 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@primary_database| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@secondary_server| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@secondary_database| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_delete_log_shipping_primary_secondary\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_delete_log_shipping_primary_secondary\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_delete_log_shipping_primary_secondary 
(
    @primary_database sysname
    ,@secondary_server sysname
    ,@secondary_database sysname
)
as
begin
    set nocount on
    declare @retcode int
                ,@primary_id uniqueidentifier

    --
    -- security check
    --
    exec @retcode = sys.sp_MSlogshippingsysadmincheck
    if (@retcode != 0 or @@error != 0)
        return 1
    --
    -- must be invoked from master db
    --
    if (db_name() != N'master')
    begin
        raiserror(5001, 16,-1)
        return 1
    end
    --
    -- Primary database should exist
    --
    select @primary_id = primary_id
    from msdb.dbo.log_shipping_primary_databases
    where primary_database = @primary_database
    if (@primary_id is null)
    begin
        raiserror(32010, 10, 5, @primary_database)
        return 0
    end
    --
    -- delete secondary if it exists
    --
    if exists (select * from msdb.dbo.log_shipping_primary_secondaries
                where primary_id = @primary_id
                    and secondary_server = upper(@secondary_server)
                    and secondary_database = @secondary_database)
    begin
        delete msdb.dbo.log_shipping_primary_secondaries
                where primary_id = @primary_id
                    and secondary_server = upper(@secondary_server)
                    and secondary_database = @secondary_database
    end
    --
    -- all done
    --
    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

