## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSreset_transaction\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSreset_transaction**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -147567580 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@xact_seqno| |varbinary|10|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSreset_transaction\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSreset_transaction\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_MSreset_transaction 
(
    @publisher sysname,
    @publisher_db sysname,
    @xact_seqno varbinary(10)
) 
AS
begin
    SET NOCOUNT ON
    --
    -- security check
    -- only db_owner can execute this
    --

    if (is_member ('db_owner') != 1) 
    begin
        raiserror(14260, 16, -1)
        return (1)
    end
    declare @publisher_database_id int

    select @publisher_database_id = a.id    
            from dbo.MSpublisher_databases a join master.dbo.sysservers b on  a.publisher_id = b.srvid
        where a.publisher_db = @publisher_db
            and upper(b.srvname) = upper(@publisher) collate database_default

    if @@error&lt;&gt;0
        return 1 

    insert dbo.MSrepl_transactions (publisher_database_id, xact_id, xact_seqno, entry_time) 
                values     (@publisher_database_id, @xact_seqno, @xact_seqno, GetDate())
    if @@error&lt;&gt;0
        return 1 
    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

