## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_getapplock\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_getapplock**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -155622469 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@Resource| |nvarchar|255|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@LockMode| |varchar|32|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@LockOwner| |varchar|32|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@LockTimeout| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@DbPrincipal| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_getapplock\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_getapplock\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_getapplock --- 1999/04/14 00:00
 @Resource nvarchar (255) = NULL,           -- Resource to lock
 @LockMode varchar (32),                    -- Lock mode
 @LockOwner varchar (32) = 'Transaction',   -- Lock Owner - [D = Transaction]
 @LockTimeout int = NULL,                   -- Lock timeout [D = Session setting]
 @DbPrincipal sysname = N'public'        -- DB principal to use for name space and permissions
as

  declare @mode integer
  declare @owner integer
  declare @result integer
  declare @dbid integer

  select @mode =
   CASE @LockMode
     When ('Shared')            Then 3
     When ('Update')            Then 4
     When ('Exclusive')         Then 5
     When ('IntentExclusive')   Then 8
     When ('IntentShared')      Then 6
     Else -1
   END

  if @mode = -1
  begin
    raiserror(15625, -1, -1, @LockMode, N'@LockMode')
    return (-999)
  end

  select @owner =
   CASE @LockOwner
    When ('Transaction')    Then 1
    When ('Session')        Then 3
    Else -1
   END

  if @owner = -1
  begin
    raiserror(15625, -1, -1, @LockOwner, N'@LockOwner')
    return (-999)
  end

  if @LockTimeout is null
  begin
    set @LockTimeout = @@LOCK_TIMEOUT
  end

  select @dbid = db_id ()

  if @owner = 1 and @@trancount = 0
  begin
    raiserror(15626, -1, -1)
    return (-999)
  end

  exec @result = sys.xp_userlock 0, @dbid, @DbPrincipal, @Resource, @mode, @owner, @LockTimeout

  return @result
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

