## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSchange_article\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSchange_article**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -157081197 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@article| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@article_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@property| |nvarchar|20|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@value| |nvarchar|255|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSchange_article\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSchange_article\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_MSchange_article
(
    @publisher sysname,
    @publisher_db sysname,
    @publication sysname,
    @article sysname,
    @article_id int,
    @property nvarchar(20) = NULL,
    @value nvarchar(255) = NULL
)
AS
begin
    DECLARE @retcode int
    DECLARE @publisher_id smallint
    DECLARE @publication_id int
    declare @tablename sysname

    --
    -- security check
    -- only db_owner can execute this
    --
    if (is_member ('db_owner') != 1) 
    begin
        raiserror(14260, 16, -1)
        return (1)
    end
    --
    -- security check
    -- Has to be executed from distribution database
    --
    if (sys.fn_MSrepl_isdistdb (db_name()) != 1)
    begin
        raiserror(21482, 16, -1, 'sp_MSchange_article', 'distribution')
        return (1)
    end

    -- Get publisher id

    exec @retcode = sys.sp_MSvalidate_distpublisher @publisher, @publisher_id OUTPUT
    if @retcode &lt;&gt; 0
    begin
        return(1)
    end

    -- lower case property
    select @property = lower (@property)
    
    -- Get publication id

    select @publication_id = publication_id
        from dbo.MSpublications where
        publisher_id = @publisher_id and 
        publisher_db = @publisher_db and
        publication = @publication
    if @publication_id is NULL
    begin
        raiserror (20026, 11, -1, @publication)
        return (1)
    end

    if @property = N'description'     
    begin
        update MSarticles set description = @value
        where publisher_id = @publisher_id
        and publisher_db = @publisher_db
        and publication_id = @publication_id
        and article = @article
        and article_id = @article_id
        if @@error &lt;&gt; 0
        begin
            return 1
        end
    end
    else if @property in( N'dest_table', N'dest_object' )
    begin
        update MSarticles set destination_object = @value
        where publisher_id = @publisher_id
        and publisher_db = @publisher_db
        and publication_id = @publication_id
        and article = @article
        and article_id = @article_id
        if @@error &lt;&gt; 0
        begin
            return 1
        end
    end
    else if @property = 'identity_range'
    begin
        declare @range bigint
        select @range = convert(bigint, @value)
        select @tablename = source_object from MSarticles 
            where publisher_id = @publisher_id
            and publisher_db = @publisher_db
            and publication_id = @publication_id
            and article = @article
            and article_id = @article_id

        update MSrepl_identity_range set range = @range where
            publisher = @publisher and
            publisher_db = @publisher_db and
            tablename = @tablename
        if @@error &lt;&gt; 0
        begin
            return 1
        end
    end
    else if @property = 'threshold'
    begin
        declare @threshold int
        select @threshold = convert(int, @value)
        select @tablename = source_object from MSarticles 
            where publisher_id = @publisher_id
            and publisher_db = @publisher_db
            and publication_id = @publication_id
            and article = @article
            and article_id = @article_id

        update MSrepl_identity_range set threshold = @threshold where
            publisher = @publisher and
            publisher_db = @publisher_db and
            tablename = @tablename
        if @@error &lt;&gt; 0
        begin
            return 1
        end
    end
    else if @property in ('destination_owner', 'dest_owner')
    begin
        update MSarticles
            set destination_owner = @value
            where publisher_id = @publisher_id
                and publisher_db = @publisher_db
                and publication_id = @publication_id
                and article = @article
                and article_id = @article_id
        if @@error &lt;&gt; 0
        begin
            return 1
        end
    end
    else
    begin
        return 1
    end
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

