## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_droplinkedsrvlogin\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_droplinkedsrvlogin**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -158885234 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@rmtsrvname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@locallogin| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_droplinkedsrvlogin\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_droplinkedsrvlogin\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_droplinkedsrvlogin
    @rmtsrvname        sysname,
    @locallogin        sysname
as
    declare @localid    int

    -- DISALLOW USER TRANSACTION
    set implicit_transactions off
    if @@trancount &gt; 0
    begin
        raiserror(15002,-1,-1,'sys.sp_droplinkedsrvlogin')
        return (1)
    end

    -- CHECK PERMISSIONS
    if not (has_perms_by_name(null, null, 'alter any login') = 1)
    begin
        EXEC %%System().AuditEvent(ID = 1380207692, Success = 0, TargetLoginName = @locallogin, TargetUserName = NULL, Role = NULL, Object = NULL, Provider = NULL, Server = @rmtsrvname)
        raiserror(15247,-1,-1)
        return (1)
    end
    else
        EXEC %%System().AuditEvent(ID = 1380207692, Success = 1, TargetLoginName = @locallogin, TargetUserName = NULL, Role = NULL, Object = NULL, Provider = NULL, Server = @rmtsrvname)
            
    BEGIN TRAN

    -- VALIDATE/LOCK SERVER NAME --
    EXEC %%LinkedServer ( Name = @rmtsrvname ) . Lock ( Exclusive = 1 )
    IF @@ERROR &lt;&gt; 0
    begin
        ROLLBACK TRAN
        raiserror(15015,-1,-1,@rmtsrvname)
        return (1)
    end

    -- CHECK LOCAL USER NAME IF GIVEN
    select @localid = 0
    if @locallogin is not null
    begin
        -- share-lock the local login
        EXEC %%LocalLogin ( Name = @locallogin ) . Lock ( Exclusive = 0 )
        IF @@ERROR = 0
            select @localid = principal_id from sys.server_principals
                where name = @locallogin and type in ('S', 'U')
        if @localid = 0
        begin
            -- THERE WILL BE NO LinkedLogins, SO ONLY AN ERROR IF NO NT-NAME OUT THERE --
            IF suser_sid(@locallogin) IS NULL
            BEGIN
                ROLLBACK TRAN
                raiserror(15007,-1,-1,@locallogin)
                return (1)
            END

            -- "SUCCESS" --
            COMMIT TRAN
            return(0)
        end
    end

    -- IF MAPPING EXISTS FOR THIS SID, REMOVE IT --
    IF EXISTS (SELECT * FROM sys.linked_logins WHERE
            server_id IN (SELECT server_id FROM sys.servers where name = @rmtsrvname)
            AND local_principal_id = @localid)
    BEGIN
        EXEC %%LinkedServer(Name=@rmtsrvname).RemoveLinkedLogin(LocalID=@localid)
    END

    -- EMDEventType(x_eet_Drop_Linked_Server_Login), EMDUniversalClass(x_eunc_Linked_Server), src major id, src minor id, src name
    -- -1 means ignore target stuff, target major id, target minor id, target name,
    -- # of parameters, 5 parameters
    EXEC %%System().FireTrigger(ID = 236, ID = 102, ID = 0, ID = 0, Value = @rmtsrvname,
        ID = 101, ID = @localid, ID = 0, Value = NULL, 
        ID = 2, Value = @rmtsrvname, Value = @locallogin, Value = NULL, Value = NULL, Value = NULL, Value = NULL, Value = NULL)

    -- SUCCESS --
    COMMIT TRAN
    return(0) -- sp_droplinkedsrvlogin
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

