## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_getpublisherlink\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_getpublisherlink**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -160551264 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@trigger_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@connect_string| |nvarchar|300|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@islocalpublisher| |bit|1|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_getpublisherlink\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_getpublisherlink\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_getpublisherlink 
(
    @trigger_id int
    ,@connect_string nvarchar(300) output
    ,@islocalpublisher bit output -- 1 = local, 0 = remote
)
AS
BEGIN
    SET NOCOUNT ON
    declare @publisher sysname
                ,@publisher_db sysname
                ,@linkname sysname
                ,@security_mode int
                ,@retcode int

    --
    -- Make sure this proc is called from the trigger.
    -- Better to use object_id if owner name is passed in.
    --
    if trigger_nestlevel(@trigger_id) = 0
    begin
        raiserror(14126, 16, -1)
        return (1) -- current user does not have insert permission to underlying table
    end
    --
    -- Get the security information
    --
    IF object_id('MSsubscription_properties', 'U') is not NULL
    begin
        --
        -- MSsubscription_properties exists
        -- Check for the subscription
        --
        select @linkname = case when (p.publisher_security_mode in (0,1)) 
                            then sys.fn_MSrepllinkname(N'REPLLINK', upper(o.publisher), o.publisher_db, o.publication, db_name())
                            else p.publisherlink end
                ,@security_mode = case when (p.publisher_security_mode not between 0 and 2) then null else cast(p.publisher_security_mode as tinyint) end
                ,@publisher = upper(o.publisher)
                ,@publisher_db = o.publisher_db
        from MSsubscription_properties p join MSreplication_objects o
            on UPPER(p.publisher) = UPPER(o.publisher) 
                and p.publisher_db = o.publisher_db
                and p.publication = o.publication
                and o.object_name = object_name(@trigger_id) 
        select @islocalpublisher = case when (@publisher = upper(publishingservername())) then 1 else 0 end
        if (@security_mode is null)
        begin
            --
            -- entry for the subscription does not exist
            -- or, sp_link_publication has not been called
            --
            raiserror(21079, 16, 1)
            return(1)
        end
    end
    else
    begin
        --
        -- MSsubscription_properties does not exist
        --
        raiserror(21079, 16, 3)
        return(1)
    end
    --
    -- if we have come this far - the subscription exists
    --
    select @connect_string = case when (@islocalpublisher = 1) 
                    then quotename(@publisher_db)
                    else quotename(@linkname) + N'.' + quotename(@publisher_db)
                    end
    --
    -- all done
    --
    return 0
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

