## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_helpmergeconflictrows\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_helpmergeconflictrows**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -160804806 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@conflict_table| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@logical_record_conflicts| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_helpmergeconflictrows\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_helpmergeconflictrows\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_helpmergeconflictrows(
    @publication    sysname = '%',
    @conflict_table sysname,
    @publisher        sysname = NULL,
    @publisher_db    sysname = NULL,
    @logical_record_conflicts int = 0
    
    )
as 
    set nocount on
    declare @pubid          uniqueidentifier
    declare @cmd            nvarchar(max)  
    declare @colname        sysname
    declare @colid            int
    declare @pubidstr       nvarchar(38)
    declare @retcode        int
    declare @result_table    sysname
    declare @guid            uniqueidentifier

    -- Security check
    if 1 &lt;&gt; is_member('db_owner') and
       (1 &lt;&gt; is_member('replmonitor') or is_member('replmonitor') is null)
    begin    
        RAISERROR (15247, 11, -1)
        return (1)
    end

    declare @quotedcolname nvarchar(258)

    select @guid = newid()

    if @publisher IS NULL
        select @publisher = publishingservername()
        
    if @publisher_db IS NULL
        select @publisher_db = db_name()

    select @colname=NULL
    
    select @colid = min(column_id) from sys.columns where object_id = object_id(@conflict_table)
    select @colname=name from sys.columns where object_id = object_id(@conflict_table) and column_id=@colid
    select @cmd = 'select '

    while (@colname is not NULL)
    begin
        if @colname &lt;&gt; 'origin_datasource_id'
        begin
            select @quotedcolname = quotename(@colname)
            select @cmd = @cmd + ' ct.' + @quotedcolname + ','    
        end
        select @colid = min(column_id) from sys.columns where object_id = object_id(@conflict_table) and column_id &gt; @colid
        select @colname = NULL
        select @colname=name from sys.columns where object_id = object_id(@conflict_table) and column_id=@colid
    end
    select @cmd = @cmd + ' m.origin_datasource, m.conflict_type, m.reason_code, m.reason_text, m.pubid, m.MSrepl_create_time from' 
    select @cmd = @cmd + QUOTENAME(@conflict_table) + ' ct, MSmerge_conflicts_info m where ct.origin_datasource_id=m.origin_datasource_id
                and m.conflict_type&lt;&gt;4 and ct.rowguidcol=m.rowguid '

    -- Do not return logical record conflicts unless specifically asked for
    if @logical_record_conflicts = 0
    begin
        select @cmd = @cmd + ' and m.conflict_type not in (11,12,13,14) '
    end
    
    if @publication &lt;&gt; '%'
    begin
        /*
        ** Parameter Check:  @publication.
        ** Make sure that the publication exists.
        */
        select @pubid = pubid from dbo.sysmergepublications 
            where name = @publication and 
                LOWER(publisher) = LOWER(@publisher) and
                publisher_db = @publisher_db
        if @pubid IS NULL
            BEGIN
                RAISERROR (20026, 16, -1, @publication)
                RETURN (1)
            END

        set @pubidstr = '''' + convert(nchar(36), @pubid) + '''' 
        select @cmd = @cmd + ' and m.pubid = ' + @pubidstr
    end
    exec (@cmd)

    if (@@ERROR &lt;&gt; 0)
        return (1)
       return (0)
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

