## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_helpremotelogin\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_helpremotelogin**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -161588637 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@remoteserver| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@remotename| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|server|nvarchar|22|
|local_user_name|nvarchar|22|
|remote_user_name|nvarchar|22|
|options|nvarchar|9|

---
### Objects that depend on \[sys\].\[sp_helpremotelogin\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_helpremotelogin\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_helpremotelogin
@remoteserver sysname = NULL,    /* remote server name */
@remotename sysname = NULL        /* remote login name */
as
set nocount on

--  If no server given, get 'em all.
if not exists (select * from master.dbo.sysservers s, master.dbo.sysremotelogins r
    where s.srvid = r.remoteserverid
        and (@remoteserver is null or s.srvname = @remoteserver ))
    begin
        if @remoteserver is null
            begin
                raiserror(15200,-1,-1)
                return (0)
            end

        raiserror(15201,-1,-1,@remoteserver)
        return (1)
    end

--  If no remotename given, get 'em all.
if not exists (select * from master.dbo.sysremotelogins
    where (@remotename is null or isnull(remoteusername, ' ') = @remotename))
    begin
        if @remotename is null
            begin
                raiserror(15202,-1,-1)
                return (1)
            end

        raiserror(15203,-1,-1,@remotename)
        return (1)

    end

--  Check for empty results.
if not exists (select *
    from master.dbo.sysremotelogins r, master.dbo.sysservers s
    where ( @remotename is null or isnull(r.remoteusername, ' ') = @remotename)
        and s.srvid = r.remoteserverid
        and (@remoteserver is null or s.srvname = @remoteserver))
    begin
        raiserror(15204,-1,-1,@remotename,@remoteserver)
        return (1)
    end

--  select the information.
select server = substring(s.srvname, 1, 22),
    local_user_name =
        substring(isnull(suser_sname(r.sid), '** use local name **'), 1, 22),
    remote_user_name =
        substring(isnull(r.remoteusername, '** mapped locally **'), 1, 22),
    options = case 
                when datalength(v.name) is null then ''
                when datalength(v.name) = 0 then ''
                else substring(v.name, 1, 9)
              end
        from master.dbo.sysservers s, master.dbo.sysremotelogins r,
            master.dbo.spt_values v
    where s.srvid = r.remoteserverid
        and (@remoteserver is null or s.srvname = @remoteserver)
        and (@remotename is null or isnull(r.remoteusername, ' ') = @remotename)
        and v.type = 'F'
        and v.number = r.status
order by server, remote_user_name

return (0) -- sp_helpremotelogin
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

