## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_dbmmonitorchangemonitoring\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_dbmmonitorchangemonitoring**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -165453794 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@parameter_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@value| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_dbmmonitorchangemonitoring\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_dbmmonitorchangemonitoring\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_dbmmonitorchangemonitoring
(
    @parameter_id        int,    -- There is only one parameter_id now.  1 = update period in minutes.
    @value                int
)
as
begin
    set nocount on
    if (is_srvrolemember( N'sysadmin') &lt;&gt; 1 )
        begin
            raiserror(21089, 16, 1)
            return 1
        end

    declare @retcode        int,
            @schedname        nvarchar( 256 )

    select @schedname = isnull( formatmessage( 32048 ), N'Database Mirroring Schedule' )

    if (@parameter_id &lt; 1 OR @parameter_id &gt; 1)
        begin
            raiserror( 32036, 16, 1 )
            return 1
        end

    if (@parameter_id = 1) -- kind of a redundant check
        begin
        -- validate update_period to make sure that it is a reasonable number. 1-120 minutes for now.
        -- do not forget to keep this in synch with the add sp.
        if (@value &lt; 1 or @value &gt; 120)
        begin
             raiserror ( 32032, 16, 1, @value)    -- specific message for the update period.
            return( 1 )
        end
        exec @retcode = msdb.dbo.sp_update_schedule
            @name = @schedname,
            @freq_type = 4,                        -- Daily
            @freq_interval = 1,                    -- Every 1 days
            @freq_subday_type = 4,                -- Based on Minutes
            @freq_subday_interval =    @value        -- interval
        end

    if ( @@error != 0 OR @retcode != 0 )
        begin
            raiserror( 32035, 16, 1 )
            return 1
        end

    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

