## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_check_log_shipping_monitor_alert\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_check_log_shipping_monitor_alert**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -168058348 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
 No parameters exist

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_check_log_shipping_monitor_alert\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_check_log_shipping_monitor_alert\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_check_log_shipping_monitor_alert 
as
begin
    set nocount on
    declare @retcode int
                ,@server sysname
                ,@database sysname
                ,@threshold_alert int
                ,@curdate_utc datetime
                ,@threshold int
                ,@elapsedtime int
                ,@latency int
    --
    -- security check
    --
    exec @retcode = sys.sp_MSlogshippingsysadmincheck
    if (@retcode != 0 or @@error != 0)
        return 1
    --
    -- must be invoked from master db
    --
    if (db_name() != N'master')
    begin
        raiserror(5001, 16,-1)
        return 1
    end
    select @curdate_utc = getutcdate()
    --
    -- enumerate through the primary and secondaries
    -- which have crossed the thresholds
    --
    declare #hclsalert cursor local fast_forward for 
        (select primary_server
                ,primary_database
                ,isnull(threshold_alert, 14420)
                ,backup_threshold
                ,datediff(minute, last_backup_date_utc, @curdate_utc)
                ,cast(0 as int)
            from msdb.dbo.log_shipping_monitor_primary
            where threshold_alert_enabled = 1
                and datediff(minute, last_backup_date_utc, @curdate_utc) &gt; backup_threshold)
        union
        (select secondary_server
                ,secondary_database
                ,isnull(threshold_alert, 14421)
                ,restore_threshold
                ,datediff(minute, last_restored_date_utc, @curdate_utc)
                ,isnull(last_restored_latency,0)
            from msdb.dbo.log_shipping_monitor_secondary
            where threshold_alert_enabled = 1
                and (datediff(minute, last_restored_date_utc, @curdate_utc) &gt; restore_threshold
                        or last_restored_latency &gt; restore_threshold))

    open #hclsalert
    fetch #hclsalert into @server, @database, @threshold_alert, @threshold, @elapsedtime, @latency
    while (@@fetch_status != -1)
    begin
        --
        -- log error that raises alerts
        --
        raiserror(@threshold_alert, 16, 1, @server, @database, @threshold, @elapsedtime, @latency)
        fetch #hclsalert into @server, @database, @threshold_alert, @threshold, @elapsedtime, @latency
    end
    close #hclsalert
    deallocate #hclsalert
    --
    -- all done
    --
    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

