## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSsetup_partition_groups\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSsetup_partition_groups**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -168996112 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSsetup_partition_groups\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSsetup_partition_groups\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

-- Requires Certificate signature for catalog access
create procedure sys.sp_MSsetup_partition_groups @publication sysname
as
begin
    declare @use_partition_groups smallint
            , @dynamic_filters bit
            , @dynamic_filters_function_list nvarchar(500)
            , @retcode int
            , @pubid uniqueidentifier
            , @snapshot_ready int
    
    exec @retcode = sys.sp_MSreplcheck_publish
    if @retcode&lt;&gt;0 or @@ERROR&lt;&gt;0
        return 1

    select @pubid = pubid, 
    @use_partition_groups = use_partition_groups, 
    @dynamic_filters = dynamic_filters, 
    @dynamic_filters_function_list = dynamic_filters_function_list,
    @snapshot_ready = snapshot_ready
    from dbo.sysmergepublications 
    where name = @publication and UPPER(publisher)=UPPER(publishingservername()) and publisher_db=db_name()

    if @pubid is null
    begin
        raiserror(20026, 16, -1, @publication)
        return (1)
    end

    if @snapshot_ready = 1 -- this is a subsequent snapshot and partition groups should have already been setup.
        return 0
        
    if (@use_partition_groups = 1)
    begin
        if (@dynamic_filters = 1 and @dynamic_filters_function_list is not null and @dynamic_filters_function_list &lt;&gt; ' ')
            or (@dynamic_filters = 0)
        begin
            -- dynamically filtered and we have the dynamic filters function list.
            -- or
            -- statically-filtered

            begin tran
            save transaction setup_partition_groups

            -- Then make sure that existing changes in contents are evaluated for partition memberships for this pubid only.
            -- Note that the tombstone changes cannot be evaluated since the data is no longer present. We may either not support
            -- going from use_partition_groups = 0 to use_partition_groups = 1, or we can document that all existing subscriptions must
            -- be in sync with the publication before sp_changemergepublication is called, or all tombstone rows can be marked as going to 
            -- all known partitions at this time. This has the effect of sending some unnecessary deletes, but if we use the generation value
            -- properly in the PastChange_to_Partition_Mapping table, then irrelevant deletes will not be sent after the first merge
            -- after sp_changemergepublication.
            -- For a given dynamic subscription the unique partition id is determined based on the row that has only the columns
            -- corresponding to functions used in that publication's filters, and obviously when the column values match the values
            -- those functions evaluate to for the merge agent.
            exec @retcode = sys.sp_MSsetup_publication_for_partition_groups @pubid

            if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
            begin 
                goto UNDO
            end

            commit transaction
        end
    end

    -- If not using partition groups, and snapshot is not already ready, 
    -- then call sp_MSevaluate_logicalrecordparent_allcontentsrows.
    -- This is for unfiltered publications using logical records. For 
    -- filtered publications, sp_MSevaluate_logicalrecordparent_allcontentsrows
    -- has already been called above in sp_MSsetup_publication_for_partition_groups.
    if (@use_partition_groups = 0 and @snapshot_ready &lt;&gt; 1)
    begin

        -- don't regenerate triggers as the snapshot will do it after calling this proc
        /*
        exec @retcode = sys.sp_MSregenerate_mergetriggers @publication
        if @@ERROR&lt;&gt;0 OR @retcode&lt;&gt;0 
        begin
            goto UNDO
        end */
        
        exec @retcode = sys.sp_MSevaluate_logicalrecordparent_allcontentsrows @pubid=@pubid
        if @@ERROR&lt;&gt;0 OR @retcode&lt;&gt;0 
        begin
            goto UNDO
        end 
    end
    
    if @use_partition_groups = 1
    begin
        
        IF NOT EXISTS (SELECT * FROM sys.indexes WHERE name = 'nc5MSmerge_contents' 
            AND object_id = OBJECT_ID('MSmerge_contents'))
        begin
            create unique index nc5MSmerge_contents on dbo.MSmerge_contents(tablenick, marker, rowguid)
            if @@ERROR &lt;&gt; 0    goto UNDO
        end
    end
    else
    begin
        if not exists (select * from dbo.sysmergepublications where use_partition_groups &gt; 0)
        begin
            IF EXISTS (SELECT * FROM sys.indexes WHERE name = 'nc5MSmerge_contents' 
                AND object_id = OBJECT_ID('MSmerge_contents'))
                drop index dbo.MSmerge_contents.nc5MSmerge_contents
        end
    end

    return 0

UNDO:
    if @@trancount &gt; 0
    begin
        rollback transaction setup_partition_groups
        commit transaction
    end

    return 1
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

