## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSchange_originatorid\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSchange_originatorid**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -171602657 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@originator_node| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@originator_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@originator_publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@originator_publication_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@originator_db_version| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@originator_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@originator_version| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSchange_originatorid\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSchange_originatorid\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSchange_originatorid
(
    @originator_node            sysname,
    @originator_db            sysname,
    @originator_publication        sysname,
    @originator_publication_id    int,
    @originator_db_version        int,
    @originator_id                int,
    @originator_version        int
)
as
begin
    declare @retcode bit

    -- security check for subscriber
    exec @retcode = sys.sp_MSreplcheck_subscribe 
    if @@error &lt;&gt; 0 or  @retcode &lt;&gt; 0 
    begin
           return 1
    end
    
    begin tran 
    save tran tr_sp_MSchange_originatorid

    update dbo.MSpeer_lsns
    set originator_id =    case @originator_id 
                        when 0 then NULL
                                       else @originator_id
                    end,
         originator_version = @originator_version
    where originator = UPPER(@originator_node)
        and originator_db = @originator_db
        and originator_publication    = @originator_publication
        and originator_publication_id = @originator_publication_id
        and originator_db_version    = @originator_db_version

    if @@error &lt;&gt; 0
    begin
        -- The procedure sys.sp_MSchange_originatorid failed to UPDATE the resource MSpeer_lsns. Server error =  @@error.
        raiserror (21499, 16, -1, 'sys.sp_MSchange_originatorid', 'UPDATE', 'MSpeer_lsns', @@error)
        goto FAILURE
       end

    if object_id(N'dbo.MSpeer_originatorid_history') is not NULL
    begin
        if @originator_id is not NULL and @originator_id &lt;&gt; 0 and not exists(select * from dbo.MSpeer_originatorid_history where originator_publication = @originator_publication
                                                                                and originator_id = @originator_id
                                                                                and UPPER(originator_node) = UPPER(@originator_node)
                                                                                and originator_db = @originator_db
                                                                                and originator_db_version = @originator_db_version)
        begin
            insert dbo.MSpeer_originatorid_history
                (originator_publication, originator_id, originator_node, originator_db, originator_db_version, originator_version)
            values(@originator_publication, @originator_id, UPPER(@originator_node), @originator_db, @originator_db_version, @originator_version)

            if @@error &lt;&gt; 0
            begin
                -- The procedure sys.sp_MSchange_originatorid failed to INSERT into the resource MSpeer_originatorid_history. Server error =  @@error.
                raiserror (21499, 16, -1, 'sys.sp_MSchange_originatorid', 'INSERT into', 'MSpeer_originatorid_history', @@error)
                goto FAILURE
            end
        end
    end

    commit tran
    
    return 0

FAILURE:
    
    rollback tran tr_sp_MSchange_originatorid
    commit tran
    
    return 1
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

