## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSensure_single_instance\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSensure_single_instance**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -174830992 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@application_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@agent_type| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSensure_single_instance\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSensure_single_instance\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_MSensure_single_instance
(
    @application_name     sysname,
    @agent_type         int = NULL
)
AS
BEGIN
    SET NOCOUNT ON

    DECLARE @retcode     int,
            @type         sysname,
            @dbprincipal sysname

    if @agent_type = 4 and exists (select 1 from sys.database_principals where name=N'MSmerge_PAL_role' and type = 'R')
    begin
        -- for merge any pal user (PAL of any publication) can do the instance check
        exec @retcode = sys.sp_MSrepl_PAL_rolecheck 
        if (@retcode &lt;&gt; 0) or (@@error &lt;&gt; 0)
            return 1

        -- use the merge pal role for merge  
        select @dbprincipal = N'MSmerge_PAL_role'
    end
    else
    begin
        IF IS_MEMBER('db_owner') != 1
        BEGIN
            -- "Only members of the sysadmin or db_owner roles can perform this operation."
            RAISERROR(21050, 14, -1)
            RETURN 1
        END

        -- use db_owner principal
        select @dbprincipal = N'db_owner'        
    end

    IF @agent_type = 1
    BEGIN 
        SELECT @type = 'snapshot'
    END
    ELSE IF @agent_type = 2
    BEGIN
        SELECT @type = 'logreader'
    END
    ELSE IF @agent_type = 9
    BEGIN
        SELECT @type = 'queuereader'
    END
    ELSE IF @agent_type = 10
    BEGIN
        SELECT @type = 'distribution'
    END
    ELSE IF @agent_type = 4
    BEGIN
        SELECT @type = 'merge'
    END
    ELSE
    BEGIN
        -- "Invalid value given for parameter @type."
        RAISERROR(15021, 16, -1, '@type')
        RETURN 1
    END
    
    -- get an applock at the db_owner level to ensure we 
    -- only allow one agent to run at a time. only dbo
    -- for the distribution db will be able to aquire this
    EXEC @retcode = sys.sp_getapplock @Resource = @application_name, 
                                      @LockMode = 'Exclusive', 
                                      @LockOwner = 'Session',
                                      @LockTimeout = 0,
                                      @DbPrincipal = @dbprincipal
    IF @@ERROR &lt;&gt; 0 OR @retcode NOT IN (0, 1)
    BEGIN
        -- "Another '@type' agent for the subscription(s) is running or the server is working on a previous request by the same agent."
        RAISERROR(21036, 16, -1, @type)
        RETURN 1
    END

    -- Select the name of the server this executes on if the physical server name is not the same as the virtual server name
    if lower(@@servername) &lt;&gt; lower(publishingservername())
        select @@servername
    else
        select NULL
        
    RETURN 0
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

