## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MScheck_subscription_expiry\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MScheck_subscription_expiry**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -176422931 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@pubid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscriber| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscriber_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@expired| |bit|1|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MScheck_subscription_expiry\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MScheck_subscription_expiry\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MScheck_subscription_expiry 
    @pubid uniqueidentifier,
    @subscriber sysname,
    @subscriber_db sysname,
    @expired bit output
AS
    declare @status int
    declare @retcode int
    declare @subid uniqueidentifier
    declare @retention          int -- in time unit
    declare @retention_period_unit tinyint -- the time unit
    declare @recent_merge       datetime
    declare @minus_retention    datetime
    declare @pubname sysname
    declare @subscriber_type int

    if @pubid is NULL
    begin
        raiserror (14043, 11, -1, '@pubid', 'sp_MScheck_subscription_expiry')
        return (1)
    end
    
    exec @retcode = sys.sp_MSrepl_PAL_rolecheck @pubid = @pubid
    if @@error&lt;&gt;0 or @retcode&lt;&gt;0
        return 1

    select @pubname = name, @retention = retention, @retention_period_unit = retention_period_unit from dbo.sysmergepublications where pubid = @pubid
    if @pubname is NULL
    begin
        raiserror (21723, 11, -1, 'sp_MScheck_subscription_expiry')
        return (1)
    end
    
    if @retention is not NULL and @retention &gt; 0
    begin
        select @minus_retention = sys.fn_add_units_to_date(-@retention, @retention_period_unit, getdate())
        select @subid=subid, @status=status, @recent_merge = last_sync_date, @subscriber_type = subscriber_type 
            from dbo.sysmergesubscriptions where pubid=@pubid and db_name=@subscriber_db and 
                UPPER(subscriber_server) collate database_default = UPPER(@subscriber) collate database_default
        if @subid is NULL
        begin
            -- this could mean that for local or anonymous or lighweight subscriptions that we
            -- do not know about the subscription. For global subscriptions this should never happen.
            -- The reconciler should call this proc after ascertaining that the subscription exists
            if @subscriber_type = 1
                select @expired = 1
            else
                select @expired = 0
            return 0
        end

        if @status=2
        begin
            select @expired = 1
        end
        else
        begin
            if @recent_merge is not NULL and @recent_merge&lt;@minus_retention
            begin
                update dbo.sysmergesubscriptions set status=2 where subid=@subid
                IF @@ERROR&lt;&gt;0
                    return 1
                select @expired = 1
            end
            else
                select @expired = 0
        end         
    end
    else
        select @expired = 0

GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

