## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSenumschemachange\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSenumschemachange**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -182780707 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@pubid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@schemaversion| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@compatlevel| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@AlterTableOnly| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@invalidateupload_schemachanges_for_ssce| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@filter_skipped_schemachanges| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSenumschemachange\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSenumschemachange\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_MSenumschemachange(
    @pubid              uniqueidentifier,
    @schemaversion      int,
    @compatlevel        int = 7000000, -- default=SPHINX
    @AlterTableOnly     bit = 0,
    @invalidateupload_schemachanges_for_ssce bit = 0,
    @filter_skipped_schemachanges bit = 0
    )
as  
begin
    set nocount on
    declare @retcode int

    select @retcode = 0
    
    if ({ fn ISPALUSER(@pubid) } &lt;&gt; 1)
    begin
        RAISERROR (14126, 11, -1)
        return (1)
    end

    -- Delegate call to the appropriate sp that
    -- handles the given compatibility-level  
    
    if @compatlevel &gt;= 10000000
    begin
        exec @retcode = sys.sp_MSenumschemachange_100 @pubid = @pubid,
                                                     @AlterTableOnly = @AlterTableOnly,
                                                     @schemaversion = @schemaversion,
                                                     @invalidateupload_schemachanges_for_ssce = @invalidateupload_schemachanges_for_ssce,
                                                     @filter_skipped_schemachanges = @filter_skipped_schemachanges
                                                     
    end
    else if @compatlevel &gt;= 9000000
    begin
        exec @retcode = sys.sp_MSenumschemachange_90 @pubid = @pubid,
                                                     @AlterTableOnly = @AlterTableOnly,
                                                     @schemaversion = @schemaversion,
                                                     @invalidateupload_schemachanges_for_ssce = @invalidateupload_schemachanges_for_ssce,
                                                     @filter_skipped_schemachanges = @filter_skipped_schemachanges
                                                     
    end
    else if @compatlevel &gt;= 8000500 -- this value stands for 80sp3 
    begin
        exec @retcode = sp_MSenumschemachange_80sp3 @pubid = @pubid, 
                                                                                            @AlterTableOnly = @AlterTableOnly,
                                                    @schemaversion = @schemaversion

    end    
    else if @compatlevel &gt; 7000200 --this value standing for 70SP2
    begin
        exec @retcode = sys.sp_MSenumschemachange_80 @pubid = @pubid, 
                                                     @AlterTableOnly = @AlterTableOnly,
                                                     @schemaversion = @schemaversion
    end
    else
    begin
        exec @retcode = sys.sp_MSenumschemachange_70 @pubid = @pubid,
                                                     @AlterTableOnly = @AlterTableOnly,
                                                     @schemaversion = @schemaversion,
                                                     @compatlevel=@compatlevel
    end

    return @retcode
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

