## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSchangeobjectowner\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSchangeobjectowner**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -183134016 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@tablename| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@dest_owner| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSchangeobjectowner\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSchangeobjectowner\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO


create procedure sys.sp_MSchangeobjectowner(
    @tablename sysname,
    @dest_owner    sysname
)AS
    declare @uid         smallint
    declare @retcode    int
    
    -- Security check
    exec @retcode= sp_MSreplcheck_subscribe
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
    begin
        raiserror(15247, 11, -1)
        return (1)
    end

    select @uid=schema_id from sys.objects where name=@tablename

    --do not bother to call sp_changeobjectowner the object is owned by the @dest_owner itself
    if SCHEMA_NAME(@uid)=@dest_owner
        return(0)
    exec @retcode=sys.sp_changeobjectowner @tablename, @dest_owner
    if @@ERROR&lt;&gt;0 or @retcode&lt;&gt;0
    begin
        raiserror(21346, 16, -1, @tablename, @dest_owner)
        return (1)
    end
    return(0)    
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

