## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_adddistpublisher\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_adddistpublisher**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -183612124 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@distribution_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@security_mode| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@login| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@password| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@working_directory| |nvarchar|255|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@trusted| |nvarchar|5|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@encrypted_password| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@thirdparty_flag| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_type| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_adddistpublisher\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_adddistpublisher\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_adddistpublisher
(
    @publisher                sysname,
    @distribution_db        sysname,
    @security_mode            int = 1,
    @login                    sysname = NULL,
    @password                sysname = NULL,
    @working_directory        nvarchar(255) = NULL,
    @trusted                nvarchar(5) = 'false',
    @encrypted_password        bit = 0,
    @thirdparty_flag        bit = 0,
    @publisher_type            sysname = N'MSSQLSERVER'
)
AS
BEGIN
    DECLARE @cmd        nvarchar(4000)
    DECLARE @retcode    int

    SET @retcode = 0
    SET @cmd = N''

    -- DEPRECATED PARAMETER: @trusted
    -- For security reasons, @trusted is no longer supported.
    -- Implicitly, it must always be @trusted == false.  If
    -- anything other than false is supplied, an error is thrown.
    IF LOWER(@trusted collate SQL_Latin1_General_CP1_CS_AS) NOT IN ('false')
    BEGIN
        RAISERROR(21698, 16, -1, '@trusted')
        RETURN (1)
    END
    
    -- Check if HREPL
    IF NOT @publisher_type = N'MSSQLSERVER'
    BEGIN
        SET @cmd = @cmd + QUOTENAME(@distribution_db) + N'.'
    END

    -- Add sp
    SET @publisher = UPPER(@publisher) COLLATE DATABASE_DEFAULT
    set @cmd = @cmd + N'sys.sp_MSrepl_adddistpublisher'
    
    EXEC @retcode = @cmd
                    @publisher,
                    @distribution_db,
                    @security_mode,
                    @login,
                    @password,
                    @working_directory,
                    @trusted,
                    @encrypted_password,
                    @thirdparty_flag,
                    @publisher_type

    RETURN (@retcode)
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

