## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_cdc_drop_job\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_cdc_drop_job**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -186936061 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@job_type| |nvarchar|20|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_cdc_drop_job\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_cdc_drop_job\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_cdc_drop_job
(
    @job_type nvarchar(20)
)    
as
begin
    set nocount on

    declare @retval int
    --
    -- Authorization check.
    --
    if (isnull(is_srvrolemember('sysadmin'),0) = 0) and (isnull(is_member('db_owner'),0) = 0)
    begin
        raiserror(22904, 16, -1)
        return(1)
    end

    -- NOTE:  The bit identifying a database as enabled for cdc is
    --        cleared before the jobs can be dropped, so only admin
    --        authorization is checked here.  If this changes, then
    --        job security can be checked.
    --
    -- CDC Job security check 
    --
    --exec @retcode = [sys].[sp_MScdc_job_security_check] 
    --if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
    --    return (1)
        
    set @job_type = rtrim(ltrim(lower(@job_type)))    
    
    -- Verify parameter
    if ((@job_type is null) or (@job_type not in (N'capture', N'cleanup')))
    begin
        raiserror(22992, 16, -1, @job_type)
        return(1)
    end

    -- Call internal stored procedure to drop the job
    if (serverproperty('EngineEdition') &lt;&gt; 5)
    begin
    exec @retval = sys.sp_cdc_drop_job_internal
        @job_type
    end
    else
    begin
        exec @retval = sys.sp_cdc_drop_job_internal_db_scoped
            @job_type
    end
    
    if @@error &lt;&gt; 0 or @retval &lt;&gt; 0
        return 1

    return(0)
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

