## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MShasdbaccess\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MShasdbaccess**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -188153101 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
 No parameters exist

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|dbname|nvarchar|128|
|owner|nvarchar|24|
|DboOnly|int|4|
|ReadOnly|bit|1|
|SingleUser|int|4|
|Detached|int|4|
|Suspect|int|4|
|Offline|int|4|
|InLoad|int|4|
|EmergencyMode|int|4|
|StandBy|int|4|
|ShutDown|int|4|
|InRecovery|int|4|
|NotRecovered|int|4|

---
### Objects that depend on \[sys\].\[sp_MShasdbaccess\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MShasdbaccess\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- sp_MShasdbaccess
-- =============================================
-- List all databases a user has access to
-- along with their db properties
--
-- PARAMETERS: N/A
--
-- REMARKS: for SQL Server 7.0 and 8.0
-- =============================================
create proc sys.sp_MShasdbaccess
as

set nocount on
set deadlock_priority low

select name as 'dbname',
owner = substring(suser_sname(sid), 1, 24),
(CASE WHEN DATABASEPROPERTYEX(name, 'UserAccess') = 'RESTRICTED_USER' THEN 1 ELSE 0 END) as 'DboOnly',
(SELECT is_read_only FROM sys.databases WHERE name=sys.sysdatabases.name) as 'ReadOnly',
(CASE WHEN DATABASEPROPERTYEX(name, 'UserAccess') = 'SINGLE_USER' THEN 1 ELSE 0 END) as 'SingleUser',
NULL as 'Detached',    -- DATABASEPROPERTY(name, N'IsDetached') always return NULL since IsDetached property doesn't exist
(CASE WHEN DATABASEPROPERTYEX(name, 'Status') = 'SUSPECT' THEN 1 ELSE 0 END) as 'Suspect',
(CASE WHEN DATABASEPROPERTYEX(name, 'Status') = 'OFFLINE' THEN 1 ELSE 0 END) as 'Offline',
(CASE WHEN DATABASEPROPERTYEX(name, 'Status') = 'RESTORING' THEN 1 ELSE 0 END) as 'InLoad',
(CASE WHEN DATABASEPROPERTYEX(name, 'Status') = 'EMERGENCY' THEN 1 ELSE 0 END) as 'EmergencyMode',
CONVERT(INT, DATABASEPROPERTYEX(name, N'IsInStandBy')) as 'StandBy',
(CASE WHEN DATABASEPROPERTYEX(name, 'Status') = 'SUSPECT' THEN 1 ELSE 0 END) as 'ShutDown', -- Both 'IsShutDown' and 'Suspect' are now mapped to 'Suspect'.
(CASE WHEN DATABASEPROPERTYEX(name, 'Status') = 'RECOVERING' THEN 1 ELSE 0 END) as 'InRecovery',
NULL as 'NotRecovered' -- DATABASEPROPERTY(name, N'IsNotRecovered') always return NULL since IsNotRecovered property doesn't exist

from sys.sysdatabases
where has_dbaccess(name) = 1
order by name
-- =============================================
-- end sp_MShasdbaccess
-- =============================================
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

