## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_helppublication\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_helppublication**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -188298606 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@found| |int|4|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_helppublication\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_helppublication\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

--
-- Name:    
--          sp_helppublication
--          
-- Description: 
--          Returns information about a publication.  If the article
--          name is not specified, it returns information for all publications
--          associated with the publishing database.
--
--          For a SQL Server publication, this stored procedure is executed
--          at the Publisher on the publishing database.  For a heterogeneous
--          publication, this stored procedure may be executed in any database
--          at the distributor for the associated publisher.
--
--          When the @publication parameter is NULL, results are only returned
--          for those publications that the current user has PAL access to.
--  
-- Security: 
--          SQL Server publication:     'sysadmin', db_owner of publishing database, PAL
--          Heterogeneous publication:  'sysadmin', db_owner of distribution database, PAL
--
-- Returns:
--          Result set of publication properties
--      
-- Owner:   
--          &lt;current owner&gt; 
--

create procedure sys.sp_helppublication
(
    @publication sysname = N'%',
    @found int = 23456 OUTPUT, -- flag indicate returning row
    @publisher sysname = NULL
)
AS
BEGIN
    SET NOCOUNT ON
    DECLARE @cmd nvarchar(4000)
                ,@retcode int
                ,@publisher_type sysname

    EXEC @retcode = sys.sp_MSrepl_getpublisherinfo
                                            @publisher = @publisher,
                                            @publisher_type = @publisher_type OUTPUT,
                                            @rpcheader = @cmd OUTPUT,
                                            @skipSecurityCheck = 1
    IF @retcode &lt;&gt; 0
        RETURN (@retcode)

    SELECT   @publisher = UPPER(@publisher)
                ,@cmd = case when (@publisher_type = N'MSSQLSERVER') 
                            then @cmd + N'sys.sp_MSrepl_helppublication' 
                            else @cmd + N'sys.sp_IHhelppublication' end
    EXEC @retcode = @cmd
                                @publication,
                                @found OUTPUT,
                                @publisher,
                                @publisher_type
    RETURN (@retcode)
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

