## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_getagentparameterlist\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_getagentparameterlist**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -190667301 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@agent_type| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_getagentparameterlist\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_getagentparameterlist\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_getagentparameterlist
(
    @agent_type int
)
as
begin
    declare  @snapshot_type      int
                ,@logreader_type     int
                ,@distribution_type  int
                ,@merge_type         int
                ,@qreader_type       int

    -- security check - must be sysadmin/dbo
    if (IS_SRVROLEMEMBER('sysadmin') &lt;&gt; 1 AND is_member ('db_owner') &lt;&gt; 1)
    begin
        RAISERROR(21089,16,-1) 
        return 1
    end
    
    --initialize the constants
    select @snapshot_type = 1
            ,@logreader_type = 2
            ,@distribution_type = 3
            ,@merge_type = 4
            ,@qreader_type = 9

    --validate the agent_type
    if (@agent_type not in 
            (@snapshot_type
            ,@logreader_type
            ,@distribution_type
            ,@merge_type
            ,@qreader_type))
    begin
        --The agent type is NULL or is invalid
        RAISERROR (21804, 16, -1, @agent_type) 
        return 1
    end

    -- return all the parameters for this agent type
    SELECT 
        agent_type
        ,N'-' + parameter_name
        ,default_value
        ,min_value
        ,max_value
    FROM msdb.dbo.MSagentparameterlist 
    WHERE agent_type=@agent_type
    if @@error &lt;&gt; 0 
    begin
        --could not select from MSagentparameterlist
        RAISERROR (21499, 16, -1, 'sys.sp_getagentparameterlist', 'SELECT from', 'msdb.dbo.MSagentparameterlist', @@error)
        return 1
    end

    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

