## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSgetdbversion\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSgetdbversion**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -191643044 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@current_version| |int|4|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSgetdbversion\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSgetdbversion\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
--
-- Name: 
--        sp_MSgetdbversion
-- 
-- Description: 
--        Retrieves the guid restore version value and converts it to a nearly unique int.
--     
-- Parameters: 
--         See the procedure definition.
--
-- Returns: 
--        0 - succeeded
--      1 - failed
--
-- Result: 
--        None
-- 
-- Security: 
--        Called by dist agents  (must be made public).
--        SYSADMIN or DBO of db
--  Requires Certificate signature for catalog access
--
create procedure sys.sp_MSgetdbversion
(
    @current_version int output
)
as
begin
    declare @retcode int,
            @currentGuid uniqueidentifier

    -- Security Check
    if is_srvrolemember('sysadmin') != 1
        and is_member ('db_owner') != 1
    begin
        raiserror (21050, 16, -1)
        return 1
    end
    
    select @currentGuid = recovery_fork_guid
        from sys.database_recovery_status
        where database_id = db_id()
    if @@error &lt;&gt; 0
        return 1
    
    select @current_version = substring(convert(binary(16), isnull(@currentGuid, 0x0)),1,6)

    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

