## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MScdc_capture_job\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MScdc_capture_job**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -19522091 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
 No parameters exist

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MScdc_capture_job\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MScdc_capture_job\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure [sys].[sp_MScdc_capture_job]
as
begin
    set nocount on
    declare @retcode int
           ,@pollinginterval bigint
           ,@continuous bit
           ,@maxtrans int
           ,@maxscans int
           ,@db_name sysname
           ,@is_from_job bit

    set @db_name = db_name()

    set @is_from_job = 1

    --
    -- security check - should be dbo or sysadmin
    --
    exec @retcode = sp_MSreplcheck_publish
    if @@ERROR != 0 or @retcode != 0
    begin
        raiserror(22864, 16, -1, @db_name)
        return 1
    end    

    --
    -- security check
    -- Has to be executed from cdc enabled db
    --
    if not sys.fn_cdc_is_enabled_for_current_db () = 0
    begin
        RAISERROR(22901, 16, -1, @db_name)
        return (1)
    end

    --
    -- Insure that transactional replication is not also trying to scan the log
    --
    exec @retcode = [sys].[sp_MScdc_tranrepl_check] 
    if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
    begin
        raiserror(22864, 16, -1, @db_name)
        return 1
    end    
    
    if (serverproperty('EngineEdition') &lt;&gt; 5)
    begin
    -- Get job parameters for msdb.cdc_jobs
    exec @retcode = sys.sp_cdc_get_job_parameters
        @pollinginterval output
        ,@continuous  output
        ,@maxscans output
        ,@maxtrans output
    end
    else
    begin
        -- Get job parameters for cdc.cdc_jobs
        exec @retcode = sys.sp_cdc_get_job_parameters_db_scoped
            @pollinginterval output
            ,@continuous  output
            ,@maxscans output
            ,@maxtrans output
    end

    if (@@error &lt;&gt; 0) or (@retcode &lt;&gt; 0)
    begin
        raiserror(22864, 16, -1, @db_name)
        return 1
    end
    
    if @continuous is null 
        set @continuous = 1
            
    if @maxtrans is null
        set @maxtrans = 500
        
    if @maxscans is null
        set @maxscans = 10
            
    if @pollinginterval is null
        if @continuous = 1
            set @pollinginterval = 5
        else
            set @pollinginterval = 0

    if (serverproperty('EngineEdition') = 5)
    begin
        set @is_from_job = 0
    end

    exec @retcode = sp_cdc_scan
         @pollinginterval = @pollinginterval
        ,@continuous = @continuous
        ,@maxtrans = @maxtrans
        ,@maxscans = @maxscans
        ,@is_from_job = @is_from_job
    
    if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
    begin
        raiserror(22864, 16, -1, @db_name)
        return 1
    end
        
    return 0
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

