## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSgetalternaterecgens\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSgetalternaterecgens**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -19625589 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@repid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSgetalternaterecgens\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSgetalternaterecgens\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
-- retrieve recgen information about all alternate publications known at this replica
create procedure sys.sp_MSgetalternaterecgens
        @repid uniqueidentifier
as

        declare @retcode                        int
        declare @publisher              sysname
        declare @publisher_db   sysname
        declare @publication    sysname
        
        /*
        ** do permission checking
        */
        exec @retcode = sys.sp_MSrepl_PAL_rolecheck @repid = @repid
        if @retcode&lt;&gt;0 or @@ERROR&lt;&gt;0 
            return (1)

        select @publisher= publisher, @publisher_db= publisher_db, @publication= name
                from dbo.sysmergepublications
                where pubid = @repid

    select distinct p.pubid as altpubid, s.recguid as recguid, s.recgen as recgen
    from dbo.sysmergesubscriptions s, dbo.sysmergepublications p, dbo.MSmerge_altsyncpartners alt
    where (p.pubid = alt.subid or p.pubid = alt.alternate_subid) and
          p.pubid &lt;&gt; @repid and
          upper(s.subscriber_server collate SQL_Latin1_General_CP1_CS_AS) = upper(p.publisher collate SQL_Latin1_General_CP1_CS_AS) and
          s.db_name = p.publisher_db and
                  s.pubid = @repid
         and s.recguid is not null and s.recgen is not null
        return @retcode 
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

