## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSlocktable\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSlocktable**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -197241335 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@ownername| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@tablename| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSlocktable\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSlocktable\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSlocktable
(
@ownername        sysname,
@tablename        sysname
)
AS
begin
    declare @retcode            int
            ,@procname            sysname
            ,@objid                 int
            ,@qualified_name        nvarchar(300)
            ,@spretcode int
            ,@spcall nvarchar(256)
    
    if @ownername is null
        set @qualified_name= QUOTENAME(@tablename)
    else
        set @qualified_name= QUOTENAME(@ownername) + '.' + QUOTENAME(@tablename)

    select @objid = object_id(@qualified_name)
    if @objid is NULL
        select @objid = object_id from sys.objects where name=@tablename
    if @objid is null
        return (1)
    
    exec @retcode = sys.sp_MSrepl_PAL_rolecheck @objid = @objid 
    if ((@retcode &lt;&gt; 0) or (@@error &lt;&gt; 0))
        return 1

    if 1=sys.fn_MSuselightweightreplication(null, null, null, null, null, null, @objid)
    begin
        --
        -- For security: break ownership chain as
        -- we have no control over the proc name is
        --
        select @procname= 'dbo.MSmerge_lws_sp_multi_' + procname_postfix from dbo.sysmergearticles where objid = @objid
                            and (1 = {fn ISPALUSER(pubid)})
        select @spcall = N'exec @p1 = ' + @procname + N' @action = 4 '
        exec @retcode = sys.sp_executesql @stmt = @spcall
            ,@params = N'@p1 int output'
            ,@p1 = @spretcode output
        IF @@ERROR&lt;&gt;0 or @retcode&lt;&gt;0 or @spretcode != 0 
            RETURN (1)
    end            
    else
    begin
        --
        -- For security: break ownership chain as
        -- we have no control over the proc name is
        --
        select @procname = 'dbo.' + select_proc from dbo.sysmergearticles where objid = @objid
                        and (1 = {fn ISPALUSER(pubid)})
        select @spcall = N'exec @p1 = ' + @procname + N' @maxschemaguidforarticle = NULL, @type = 7 '
        exec @retcode = sys.sp_executesql @stmt = @spcall
            ,@params = N'@p1 int output'
            ,@p1 = @spretcode output
        IF @@ERROR&lt;&gt;0 or @retcode&lt;&gt;0 or @spretcode != 0 
            RETURN (1)
    end
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

