## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MScheck_pub_identity\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MScheck_pub_identity**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -205081227 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@tablename| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@current_max| |bigint|8|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@pub_range| |bigint|8|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@threshold| |int|4|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@range| |bigint|8|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@next_seed| |bigint|8|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@max_identity| |bigint|8|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MScheck_pub_identity\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MScheck_pub_identity\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_MScheck_pub_identity 
(
    @publisher            sysname,
    @publisher_db        sysname,
    @tablename            sysname, 
    @current_max        bigint  = NULL OUTPUT,
    @pub_range            bigint  = NULL OUTPUT,
    @threshold            int  = NULL OUTPUT,
    @range                bigint  = NULL OUTPUT,
    @next_seed            bigint  = NULL OUTPUT,
    @max_identity        bigint = NULL OUTPUT
)
AS
begin
    declare @retcode        int

    --
    -- security check
    -- only db_owner can execute this
    --
    if (is_member ('db_owner') != 1) 
    begin
        raiserror(14260, 16, -1)
        return (1)
    end

    if @current_max is not NULL
    begin
        select @current_max=current_max from MSrepl_identity_range 
            where tablename=@tablename and LOWER(publisher)=LOWER(@publisher) and publisher_db=@publisher_db
        if @@ERROR&lt;&gt;0    
            return (1)
    end

    if @max_identity is not NULL
    begin
        select @max_identity=max_identity from MSrepl_identity_range 
            where tablename=@tablename and LOWER(publisher)=LOWER(@publisher) and publisher_db=@publisher_db
        if @@ERROR&lt;&gt;0    
            return (1)
    end

    if @pub_range is not NULL
    begin
        select @pub_range=pub_range from MSrepl_identity_range 
            where tablename=@tablename and LOWER(publisher)=LOWER(@publisher) and publisher_db=@publisher_db
        if @@ERROR&lt;&gt;0    
            return (1)
    end

    if @threshold is not NULL
    begin
        select @threshold=threshold from MSrepl_identity_range 
            where tablename=@tablename and LOWER(publisher)=LOWER(@publisher) and publisher_db=@publisher_db
        if @@ERROR&lt;&gt;0    
            return (1)
    end
    if @next_seed is not NULL
    begin
        select @next_seed=next_seed from MSrepl_identity_range 
            where tablename=@tablename and LOWER(publisher)=LOWER(@publisher) and publisher_db=@publisher_db
        if @@ERROR&lt;&gt;0    
            return (1)
    end
    if @range is not NULL
    begin
        select @range=range from MSrepl_identity_range 
            where tablename=@tablename and LOWER(publisher)=LOWER(@publisher) and publisher_db=@publisher_db
        if @@ERROR&lt;&gt;0    
            return (1)
    end

    return (0)
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

