## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSenum_replsqlqueues\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSenum_replsqlqueues**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -205885895 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@curdistdb| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSenum_replsqlqueues\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSenum_replsqlqueues\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSenum_replsqlqueues
(
    @curdistdb    sysname = NULL
)
as
begin
    declare @distbit int
    declare @db_name sysname
    declare @cmd nvarchar(1024)

    select @distbit = 16

    --
    -- create the temp table to store the relevant information
    --
    create table #replqueue (
        publisher sysname collate database_default not null,
        publisher_db sysname collate database_default not null,
        subscriber sysname collate database_default not null,
        subscriber_db sysname collate database_default not null,
        publication sysname collate database_default not null,
        dist_db sysname collate database_default not null
    )
    create unique index ucreplqueue ON #replqueue (subscriber, subscriber_db, publication)

    --
    -- Has the user specified a distribution database
    --
    if (@curdistdb is NULL)
    begin
        --
        -- Go through all the distribution databases
        --
        declare hCdatabase CURSOR LOCAL FAST_FORWARD FOR 
            select name from master.dbo.sysdatabases 
            where
                category &amp; @distbit &lt;&gt; 0 and
                has_dbaccess(name) = 1
            for read only
    end
    else
    begin
        --
        -- User specified Distribution Database
        -- Validate the user specified name
        --
        if exists (select name from master.dbo.sysdatabases 
        where
            name = @curdistdb and
            category &amp; @distbit &lt;&gt; 0 and
            has_dbaccess(name) = 1)
        begin
            declare hCdatabase CURSOR LOCAL FAST_FORWARD FOR
            select @curdistdb
            for read only
        end
        else
        begin
            --
            -- Error : Invalid distribution db specified
            --
            raiserror(20587, 16, 3, N'@curdistdb', N'sp_MSenum_replsqlqueues')
            return 1
        end
    end
    
    --
    -- Enumerate
    --
    open hCdatabase
    fetch next from hCdatabase into @db_name
    while (@@fetch_status &lt;&gt; -1)
    begin
        select @cmd =
        'SET NOCOUNT ON ' +
        'INSERT INTO #replqueue (publisher, publisher_db, subscriber, subscriber_db, publication, dist_db) ' +
        'SELECT c.srvname, a.publisher_db, b.srvname, a.subscriber_db, a.publication, N' + QUOTENAME(@db_name, N'''') + ' ' +
        'FROM ' + QUOTENAME(@db_name) + '.dbo.MSdistribution_agents as a ' +
            'JOIN master.dbo.sysservers as b ' +
            'ON a.subscriber_id = b.srvid ' +
            'JOIN master.dbo.sysservers as c ' + 
            'ON a.publisher_id = c.srvid ' + 
            'WHERE queue_id = N''mssqlqueue'' '
            
        exec (@cmd)
        fetch next from hCdatabase into @db_name
    end
    close hCdatabase
    deallocate hCdatabase

    --
    -- select the contents of the temp table
    --
    select * from #replqueue

    --
    -- cleanup
    --
    drop table #replqueue
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

