## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSset_snapshot_xact_seqno\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSset_snapshot_xact_seqno**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -207141777 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@article_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@xact_seqno| |varbinary|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@reset| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_seqno| |varbinary|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@ss_cplt_seqno| |varbinary|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSset_snapshot_xact_seqno\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSset_snapshot_xact_seqno\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_MSset_snapshot_xact_seqno
(
    @publisher_id int,
    @publisher_db sysname,
    @article_id int, 
    @xact_seqno varbinary(16),
    @reset bit = 0,         /* @reset = 1 is used for Scheduled Snapshot publications by snapshot */
    @publication sysname = NULL,
    @publisher_seqno varbinary(16) = 0x00,
    @ss_cplt_seqno varbinary(16) = NULL
    /* 
    ** Required for 6x publishers!
    */
)
AS
begin
    DECLARE @virtual smallint     /* const: virtual subscriber id */
    DECLARE @virtual_anonymous smallint /* const: virtual anonymous subscriber id */
    DECLARE @old_xact_seqno varbinary(16)
    DECLARE @old_publisher_seqno varbinary(16)
    DECLARE @subscribed tinyint
    DECLARE @automatic tinyint
    DECLARE @old_snapshot_seqno_flag bit
    DECLARE @publication_id int
    DECLARE @initiated tinyint
    DECLARE @publisher_database_id int

    --
    -- security check
    -- only db_owner can execute this
    --
    if (is_member ('db_owner') != 1) 
    begin
        raiserror(14260, 16, -1)
        return (1)
    end

    SELECT @publisher_database_id = id
      FROM dbo.MSpublisher_databases
     WHERE publisher_db = @publisher_db
       AND publisher_id = @publisher_id

    SELECT @virtual = -1
    SELECT @virtual_anonymous = -2
    SELECT @subscribed = 1
    SELECT @automatic = 1
    SELECT @initiated = 3
    
    if @ss_cplt_seqno is null 
    begin
        select @ss_cplt_seqno = @xact_seqno;
    end

    -- 6.5 only!!! @publication is not null only if the publisher is 6.5 sever!
    -- Set the publication_id and sync_type in dbo.MSsubscriptions.
    -- It will be used in sp_MSupdate_subscriptions 
    IF @publication IS NOT NULL
    BEGIN
        -- Get the publication id
        SELECT @publication_id = publication_id FROM dbo.MSpublications
            WHERE   publisher_id = @publisher_id AND
                    publisher_db = @publisher_db AND    
                    publication  = @publication

        -- Set the pubid and the sync_type
        -- Avoid update rows with no change to reduce update locks.
        
        UPDATE dbo.MSsubscriptions SET publication_id = @publication_id
          FROM dbo.MSsubscriptions with (index(iMSsubscriptions))
            WHERE   publisher_id = @publisher_id AND
                    publisher_database_id = @publisher_database_id AND    
                    article_id  = @article_id and
                    status = @subscribed and
                    publication_id &lt;&gt; @publication_id
        
        -- Have to do this to avoid no sync subs from 6.5 publisher being
        -- updated.
        UPDATE dbo.MSsubscriptions SET sync_type = @automatic
          FROM dbo.MSsubscriptions with (index(iMSsubscriptions)) 
            WHERE   publisher_id = @publisher_id AND
                    publisher_database_id = @publisher_database_id AND    
                    article_id  = @article_id and
                    status = @subscribed and
                    sync_type &lt;&gt; @automatic
    END

    begin tran
    save TRANSACTION MSset_snapshot_xact_seqno

    /* 
    ** Set snapshot_xact_seqno for all new subscriptions,
    ** plus the virtual subscription or all subscriptions if @reset = 1
    ** Note virtual anonymous subscription will not be set
    ** (2 virtual subscriptions of anonymous publication will be activated
    ** immediately without snapshot
    ** 
    ** @reset = 1 is used for Scheduled Snapshot publications by snapshot
    */
    UPDATE dbo.MSsubscriptions SET subscription_seqno = @xact_seqno,
        publisher_seqno = @publisher_seqno,
        snapshot_seqno_flag = 1,
        subscription_time = getdate(),
        ss_cplt_seqno = @ss_cplt_seqno
      FROM dbo.MSsubscriptions with (index(iMSsubscriptions))
      WHERE 
         dbo.MSsubscriptions.publisher_id = @publisher_id and
         dbo.MSsubscriptions.publisher_database_id = @publisher_database_id and
         dbo.MSsubscriptions.article_id = @article_id and 
         /* virtual subscriptions are automatic sync type */
         dbo.MSsubscriptions.sync_type = @automatic and 
         (MSsubscriptions.status in(@subscribed,@initiated) or 
         dbo.MSsubscriptions.subscriber_id = @virtual or
         -- Set for virtual anonymous account if snapshot_seqno_flag
         -- is 0.
         -- The virtual anonymous account is activated immediately at subscription
         -- time for no init option for anonymous agent.
         (MSsubscriptions.subscriber_id = @virtual_anonymous and 
         (MSsubscriptions.snapshot_seqno_flag = 0 or 
         dbo.MSsubscriptions.status in(@subscribed,@initiated))) or
         @reset = 1) 

    IF @@ERROR &lt;&gt; 0
    BEGIN
        if @@trancount &gt; 0
        begin
            ROLLBACK TRANSACTION MSset_snapshot_xact_seqno
            commit tran
        end
        RETURN (1)
    END

    COMMIT TRANSACTION
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

