## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSadd_repl_error\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSadd_repl_error**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -207888728 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@error_type_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_type_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@error_code| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@error_text| |nvarchar|1073741823|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@session_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@add_event_log| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@event_log_context| |nvarchar|1073741823|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@map_source_type| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSadd_repl_error\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSadd_repl_error\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_MSadd_repl_error 
(
    @id                 int,
    @error_type_id      int,
    @source_type_id     int,
    @source_name        sysname,
    @error_code         sysname,
    @error_text         nvarchar(max),
    @session_id            int = NULL,
    @add_event_log        int = 0,
    @event_log_context     nvarchar(max) = NULL,
    @map_source_type    bit = 0
)
AS
begin
    declare @retcode int
    declare @xact_seqno varbinary(16)
    declare @command_id int
    declare @binctx binary(128)
    declare @event_log_text nvarchar(4000)

    -- these values can be found in SQLREPL.h
    declare @REPL_SOURCE_NULL         int,
            @REPL_SOURCE_COMMAND     int,
            @REPL_SOURCE_AGENT         int,
            @REPL_SOURCE_OS         int,
            @REPL_SOURCE_ODBC         int,
            @REPL_SOURCE_SQLSERVER     int,
            @REPL_SOURCE_NETLIB     int,
            @REPL_SOURCE_SQLDMO     int,
            @REPL_MERGE_PROVIDER     int,
            @REPL_MERGE_PROCESS     int,
            @REPL_SOURCE_TRANSPORT    int,
            @REPL_SOURCE_SQLCE         int,
            @REPL_SOURCE_OCI         int,
            @REPL_SOURCE_OLEDB         int,
            @REPL_SOURCE_SMO         int,
            @REPL_SOURCE_RMO         int,
            @REPL_SOURCE_ORACLE    int,
            @REPL_SOURCE_DB2    int

    select @REPL_SOURCE_NULL        = 0,
            @REPL_SOURCE_COMMAND    = 1,
            @REPL_SOURCE_AGENT        = 2,
            @REPL_SOURCE_OS            = 3,
            @REPL_SOURCE_ODBC        = 4,
            @REPL_SOURCE_SQLSERVER    = 5,
            @REPL_SOURCE_NETLIB        = 6,
            @REPL_SOURCE_SQLDMO        = 7,
            @REPL_MERGE_PROVIDER    = 8,
            @REPL_MERGE_PROCESS        = 9,
            @REPL_SOURCE_TRANSPORT    = 10,
            @REPL_SOURCE_SQLCE      = 11,
            @REPL_SOURCE_OCI         = 12,
            @REPL_SOURCE_OLEDB        = 13,
            @REPL_SOURCE_SMO        = 14,            
            @REPL_SOURCE_RMO        = 15,            
            @REPL_SOURCE_ORACLE        = 16,            
            @REPL_SOURCE_DB2        = 17

    -- Security Check
    -- require the login to be in cache regardless of the publication id and agent_id.
    -- This means that once a agent get into the distribution db, it
    -- can add any error.   
    exec @retcode = sys.sp_MScheck_pull_access
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
        return (1)
        
    if object_id('MSrepl_errors') is NULL
        return 0

    if @map_source_type = 1
    begin
        -- Here we will override the source_name if we know we sould.
        -- The only case we shouldn't is when the user input for source
        -- type id is set to NULL or REPL_SOURCE_VALID. We force the 
        -- change of source name to allow the UI to construct help links.
        select @source_type_id = ISNULL(@source_type_id, @REPL_SOURCE_NULL)
        
        if @source_type_id in (@REPL_SOURCE_AGENT,
                                @REPL_SOURCE_OS, 
                                @REPL_MERGE_PROVIDER, 
                                @REPL_MERGE_PROCESS,
                                @REPL_SOURCE_TRANSPORT)
        begin
            select @source_name = N'MSSQL_REPL'
        end
        else if @source_type_id  in ( @REPL_SOURCE_ORACLE,
                                @REPL_SOURCE_OCI)
        begin
            select @source_name = N'MSSQL_REPL_ORACLE'
        end
        else if @source_type_id  = @REPL_SOURCE_DB2
        begin
            select @source_name = N'MSSQL_REPL_DB2'
        end
        else
        begin
            select @source_name = N'MSSQL_ENG'
        end
    end
    
    select @xact_seqno = xact_seqno, @command_id = command_id from dbo.MSrepl_errors where
        id = @id and xact_seqno is not null

    if @session_id is null
    begin
        select @binctx = isnull(context_info(),0x00)
        set @session_id = cast( @binctx AS int )
    end

    -- Insert into the Event log
--       if (@add_event_log = 1) and (is_member('db_owner') = 1)
--       begin
--           if @event_log_context is not null
--               select @event_log_text = @event_log_context + @error_text
--        else
--               select @event_log_text = @error_text
--        select @event_log_text = @source_name + ' -(' + @error_code + ') ' + @event_log_text
--               exec master.dbo.xp_logevent  70000, @event_log_text, 'ERROR'
--       end
            
    INSERT INTO dbo.MSrepl_errors (id, time, error_type_id, source_type_id, source_name,
                error_code, error_text, xact_seqno, command_id, session_id)
        VALUES (@id, getdate(), @error_type_id, @source_type_id,
                @source_name, @error_code, @error_text, @xact_seqno, @command_id, @session_id)
    IF @@ERROR &lt;&gt; 0
    BEGIN
       RETURN (1)
    END
    
    -- delete the placeholder row since it is never needed by anyone.
    delete from dbo.MSrepl_errors where id = @id and error_type_id is null
    
    return (0)
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

