## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MScleanup_agent_entry\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MScleanup_agent_entry**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -208474024 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
 No parameters exist

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MScleanup_agent_entry\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MScleanup_agent_entry\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_MScleanup_agent_entry
AS
    declare @min_valid_day         datetime
    , @publisher_id         int
    , @subscriber_id         int
    , @publication             sysname
    , @publication_id        int
    , @publisher_db         sysname
    , @subscriber_db         sysname
    , @retention             int
    , @publication_type     int
    , @agent_id            int
    , @num_dropped    int
    , @retcode int
    , @retention_period_unit tinyint

    set nocount on
    select @num_dropped = 0

    EXEC @retcode = sys.sp_MSreplcheck_publish
    IF @@ERROR &lt;&gt; 0 or @retcode &lt;&gt; 0
        return (1)

    declare PC CURSOR LOCAL FAST_FORWARD for 
        select distinct publisher_id, publisher_db, publication, retention, publication_type, 
            retention_period_unit, publication_id
        from MSpublications
        where retention&lt;&gt;0
    open PC
    fetch PC into @publisher_id, @publisher_db, @publication, @retention, @publication_type, 
        @retention_period_unit, @publication_id
    while (@@fetch_status &lt;&gt; -1)
    begin    
        if @publication_type = 2  --merge publication
        begin
            select @min_valid_day = sys.fn_add_units_to_date(-@retention, @retention_period_unit, getdate())

            declare hC CURSOR LOCAL FAST_FORWARD FOR 
                select msa.id from dbo.MSmerge_agents msa
                where msa.creation_date &lt; @min_valid_day
                and not exists 
                (
                    select * from dbo.MSmerge_sessions sess
                    where sess.agent_id = msa.id 
                    and sess.end_time &gt; @min_valid_day
                )
                and msa.publisher_id = @publisher_id
                and msa.publisher_db = @publisher_db
                and msa.publication = @publication   
                and msa.anonymous_subid is not null        -- Only do this for anonymous agents
                and not exists 
                (
                    select * from dbo.MSmerge_subscriptions mss
                    where mss.publisher_id = @publisher_id
                    and mss.publisher_db = @publisher_db
                    and mss.publication_id = @publication_id
                    and upper(mss.subscriber) = upper(msa.subscriber_name)
                    and mss.subscriber_db = msa.subscriber_db
                    and mss.subscriber_version &gt;= 90
                )
            for read only
            open hC
            fetch hC into @agent_id
            while (@@fetch_status &lt;&gt; -1)
            begin
                exec @retcode = sys.sp_MSdrop_merge_agentid @agent_id
                if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
                    return (1)
                select @num_dropped = @num_dropped + 1
                fetch hC into @agent_id
            end
            close hC
            deallocate hC
        end
           else if @publication_type in (0,1) --Tran level publication
              begin  
                select @min_valid_day = dateadd(hour, @retention * (-1), getdate())    
                -- Only do this for anonymous agents
                declare hC CURSOR LOCAL FAST_FORWARD FOR 
                    select id from MSdistribution_agents where creation_date &lt; @min_valid_day
                        and not exists (select * from MSdistribution_history where agent_id = id and time &gt; @min_valid_day)
                        and publisher_id=@publisher_id
                        and publisher_db = @publisher_db
                        and publication = @publication            
                        -- Only do this for anonymous agents
                        and subscriber_name is not null                             
                for read only
                open hC
                fetch hC into @agent_id
                while (@@fetch_status &lt;&gt; -1)
                begin
                    exec @retcode = sys.sp_MSdrop_distribution_agentid @agent_id
                    if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
                        return (1)
                    select @num_dropped = @num_dropped + 1
                    fetch hC into @agent_id
                end
            close hC
            deallocate hC
            end
          fetch PC into @publisher_id, @publisher_db, @publication, @retention, @publication_type, 
              @retention_period_unit, @publication_id
    end
    close PC
    deallocate PC
    if @num_dropped &gt; 0
        RAISERROR(20597, 10, -1, @num_dropped) 
       return (0)
FAILURE:
    close PC
    deallocate PC
       return (1)        
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

