## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MShelplogreader_agent\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MShelplogreader_agent**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -212914494 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MShelplogreader_agent\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MShelplogreader_agent\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
--
-- Name:    
--        sp_MShelplogreader_agent
--            
-- Description: 
--        Displays the following information on logreader agent:
--            LA id
--             name
--            publisher_security_mode
--            publisher_login
--            publisher_password
--             job_id
--             job_login
--             job_password
--    
-- Security: 
--        SA
-- Requires Certificate signature for catalog access
--
-- Returns:     
--        0 : success
--        1 : failure          
--

CREATE PROCEDURE sys.sp_MShelplogreader_agent
(
    @publisher        sysname,
    @publisher_db    sysname
)
AS
BEGIN
    DECLARE @publisher_id int

    -- Security Check: require sysadmin
    IF (ISNULL(IS_SRVROLEMEMBER('sysadmin'),0) = 0)
    BEGIN
        RAISERROR(21089,16,-1) 
        RETURN 1
    END

    -- database must be distribution db
    IF sys.fn_MSrepl_isdistdb(DB_NAME()) &lt;&gt; 1
    BEGIN
        RAISERROR (21482, 16, -1, 'sp_MShelplogreader_agent', 'distribution')
        RETURN (1)
    END

    SELECT @publisher_id = server_id
        FROM sys.servers
        WHERE UPPER(name) = UPPER(@publisher)

    SELECT msla.id, 
            msla.name,
            msla.publisher_security_mode,
            msla.publisher_login,
            N'**********' as [publisher_password],
            sjb.job_id,
            sc.credential_identity as [job_login],
            N'**********' as [job_password]
        FROM MSlogreader_agents msla
                JOIN msdb..sysjobs sjb
                    ON convert(uniqueidentifier, msla.job_id) = sjb.job_id
                LEFT JOIN msdb..sysjobsteps sj
                    ON msla.job_step_uid = sj.step_uid
                LEFT JOIN msdb..sysproxies sp
                    ON sj.proxy_id = sp.proxy_id
                LEFT JOIN sys.credentials sc
                    ON sp.credential_id = sc.credential_id
        WHERE msla.publisher_id = @publisher_id
            AND msla.publisher_db = @publisher_db

    RETURN 0
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

