## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSsetlastrecgen\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSsetlastrecgen**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -216136147 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@repid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@srcgen| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@srcguid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSsetlastrecgen\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSsetlastrecgen\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE sys.sp_MSsetlastrecgen
    (@repid uniqueidentifier, @srcgen bigint, @srcguid uniqueidentifier)
as
    /*
    ** Check to see if current publication has permission
    */
    declare @retcode    int

    exec @retcode = sys.sp_MSrepl_PAL_rolecheck @repid = @repid
    if (@retcode &lt;&gt; 0) or (@@error &lt;&gt; 0)
        return 1
        
    if (@repid is null)
    begin
        RAISERROR(14043, 16, -1, '@repid', 'sp_MSsetlastrecgen')
        return (1)
    end
    if (@srcgen is null)
    begin
        RAISERROR(14043, 16, -1, '@srcgen', 'sp_MSsetlastrecgen')
        return (1)
    end
    if (@srcguid is null)
    begin
        RAISERROR(14043, 16, -1, '@srcguid', 'sp_MSsetlastrecgen')
        return (1)
    end
    if object_id('MSmerge_contents') is NULL and
       object_id('MSmerge_rowtrack') is NULL
    begin
        RAISERROR(20054 , 16, -1)
        return (1)
    end

    update dbo.sysmergesubscriptions set recgen = @srcgen, recguid = @srcguid,
                                         last_local_recgen = case when recguid = @srcguid or recguid is null or recguid = '00000000-0000-0000-0000-000000000000' then last_local_recgen else NULL end,
                                         last_local_recguid = case when recguid = @srcguid or recguid is null or recguid = '00000000-0000-0000-0000-000000000000' then last_local_recguid else recguid end
        where subid = @repid
    IF @@ERROR &lt;&gt;0 return (1) 
   
    return (0)

GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

