## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_cdc_enable_table\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_cdc_enable_table**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -219753055 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@source_schema| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@capture_instance| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@supports_net_changes| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@role_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@index_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@captured_column_list| |nvarchar|1073741823|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@filegroup_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@allow_partition_switch| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_cdc_enable_table\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_cdc_enable_table\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_cdc_enable_table 
(
    @source_schema sysname,
    @source_name sysname,
    @capture_instance sysname = null,
    @supports_net_changes bit = null,
    @role_name sysname,
    @index_name sysname = null,
    @captured_column_list nvarchar(max) = null,
    @filegroup_name sysname = null,
    @allow_partition_switch bit = 1
)
as
begin
    declare @retcode int
        ,@db_name sysname
        
    -- Verify CDC is supported for this SQL Server edition
    IF ([sys].[fn_cdc_is_supported]() = 1)
    BEGIN
        DECLARE @edition sysname
        SELECT @edition = CONVERT(sysname, SERVERPROPERTY('Edition'))
        RAISERROR(22988, 16, -1, @edition)
        RETURN (1)
    END
   
    -- Verify caller is entitled to enable change data capture for the table 
    if (isnull(is_srvrolemember('sysadmin'),0) = 0) and (isnull(is_member('db_owner'),0) = 0)
    begin
           raiserror(22904, 16, -1)
        return 1
    end
    
    -- Verify database is enabled for change data capture before we switch to cdc 
    if ([sys].[fn_cdc_is_db_enabled]() != 1)
    begin
        set @db_name = db_name()
        raiserror(22901, 16, -1, @db_name)
        return 1
    end
    
    -- Switch to database user 'cdc' before executing stored procedure that
    -- can cause database DML and DDL triggers to fire.
    execute as user = 'cdc'

    -- Call internal stored procedure that executes as 'dbo' to do the work.    
    exec @retcode = sys.sp_cdc_enable_table_internal 
        @source_schema,
        @source_name,
        @capture_instance,
        @supports_net_changes,
        @role_name,
        @index_name,
        @captured_column_list,
        @filegroup_name,
        @allow_partition_switch
        
    if (@@error &lt;&gt; 0) or (@retcode &lt;&gt; 0)
    begin
        revert
        return 1
    end
    
    revert
    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

