## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSsub_check_identity\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSsub_check_identity**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -220985857 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@lower_bound_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSsub_check_identity\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSsub_check_identity\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSsub_check_identity
@lower_bound_id int
as
    declare @retcode int
    declare @cmd nvarchar(1000)
    declare @objid int, @threshhold bigint, @range bigint, @next_seed bigint
    declare    @last_seed bigint, @identity_so_far bigint, @threshold int
    declare @table_name sysname
    declare @qualname nvarchar(517)

    --  Security Check
    EXEC @retcode = sys.sp_MSreplcheck_subscribe
    IF @@ERROR &lt;&gt; 0 or @retcode &lt;&gt; 0
    RETURN(1)

    -- This proc will be called by distribution agent called repeatedly until
    -- one result returned
    if object_id('MSsub_identity_range') is not NULL
    begin
        while 1 = 1
        begin
            select @objid = null
            select top 1 @objid = objid from MSsub_identity_range where
                objid &gt; @lower_bound_id 
                order by objid ASC
            if @objid is null
                break

            select @lower_bound_id = @objid
            -- Since we don't always clean up the subscriber, Skipping invalid entry.
            if object_name(@objid) is null 
                continue
            if objectproperty(@objid, 'TableHasIdentity') &lt;&gt; 1
                continue

            exec sys.sp_MSget_qualified_name @objid, @qualname OUTPUT

            select @range = range, @last_seed = last_seed, @threshold = threshold from 
                MSsub_identity_range where objid=@objid
                
            if @range = 0
                -- First time after initial bcp, always request a new range
                -- return this object
                break
            else
            begin                 

                -- Leave one slot unused. This is to prevent violation of primary key constraint
                -- if the next value is used by a subscriber and the publisher has received it.
                -- It seems the pk constraint will be validated before this check.
                declare @actual_range int
                if @range &gt; 0
                    select @actual_range = @range - 1
                else
                    select @actual_range = @range + 1

                select @identity_so_far = isnull(ident_current(@qualname), ident_seed(@qualname))

                if 100*(@identity_so_far - @last_seed)/@actual_range &gt;= @threshold
                    -- Need new range
                    break
            end

            select @lower_bound_id = @objid
        end
    end
    select @table_name = object_name(@objid)            

    -- Return nothing if @table_name is null, which means no more table needs to be adjust
    select 'objid' = @objid, 'table_name' = @table_name where @objid is not null    
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

