## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_addlogin\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_addlogin**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -222378892 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@loginame| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@passwd| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@defdb| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@deflanguage| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@sid| |varbinary|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@encryptopt| |varchar|20|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_addlogin\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_addlogin\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_addlogin
    @loginame        sysname
   ,@passwd         sysname = Null
   ,@defdb          sysname = 'master'      -- UNDONE: DEFAULT CONFIGURABLE???
   ,@deflanguage    sysname = Null
   ,@sid            varbinary(16) = Null
   ,@encryptopt        varchar(20) = Null
AS
    -- SETUP RUNTIME OPTIONS / DECLARE VARIABLES --
    set nocount on
    declare @exec_stmt nvarchar(4000)
    declare @hextext varchar(256)
    declare @ret int

    -- DISALLOW USER TRANSACTION --
    set implicit_transactions off
    IF (@@trancount &gt; 0)
    begin
        raiserror(15002,-1,-1,'sys.sp_addlogin')
        return (1)
    end

    -- VALIDATE LOGIN NAME:
    execute @ret = sys.sp_validname @loginame
    if (@ret &lt;&gt; 0)
        return (1)

    set @exec_stmt = 'create login ' + quotename(@loginame)

    if @passwd is null
        select @passwd = ''

    if (@encryptopt is null)
        set @exec_stmt = @exec_stmt + ' with password = ' + quotename(@passwd, '''')
    else
    begin
        declare @passwdbin varbinary(256)
        set @passwdbin = convert(varbinary(256), @passwd)
        execute sys.sp_hexadecimal @passwdbin, @hextext OUT
        set @exec_stmt = @exec_stmt + ' with password = ' + @hextext

        if (@encryptopt = 'skip_encryption_old')
            set @exec_stmt = @exec_stmt + ' hashed '
        else if (@encryptopt = 'skip_encryption')
            set @exec_stmt = @exec_stmt + ' hashed '
        else
        begin
            raiserror(15600,-1,-1,'sys.sp_addlogin')
            return 1
        end
    end
    
    if (@defdb is not null)
        set @exec_stmt = @exec_stmt + ', default_database = ' + quotename(@defdb)

    if (@deflanguage is not null)
        set @exec_stmt = @exec_stmt + ', default_language = ' + quotename(@deflanguage)

    if (@sid is not null)
    begin
        execute sys.sp_hexadecimal @sid, @hextext OUT
        set @exec_stmt = @exec_stmt + ', sid = ' + @hextext
    end

    exec (@exec_stmt)

    if @@error &lt;&gt; 0
        return (1)

    -- RETURN SUCCESS --
    return  (0)    -- sp_addlogin
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

