## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_table_privileges_rowset\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_table_privileges_rowset**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -222979952 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@table_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@table_schema| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@grantor| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@grantee| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|GRANTOR|nvarchar|128|
|GRANTEE|nvarchar|128|
|TABLE_CATALOG|nvarchar|128|
|TABLE_SCHEMA|nvarchar|128|
|TABLE_NAME|nvarchar|128|
|PRIVILEGE_TYPE|nvarchar|30|
|IS_GRANTABLE|bit|1|

---
### Objects that depend on \[sys\].\[sp_table_privileges_rowset\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_table_privileges_rowset\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_table_privileges_rowset
(
    @table_name         sysname,
    @table_schema       sysname = null,
    @grantor            sysname = null,
    @grantee            sysname = null
)
as
    select
        GRANTOR         = s_tpv.GRANTOR,
        GRANTEE         = s_tpv.GRANTEE,
        TABLE_CATALOG   = s_tpv.TABLE_CATALOG,
        TABLE_SCHEMA    = s_tpv.TABLE_SCHEMA,
        TABLE_NAME      = s_tpv.TABLE_NAME,
        PRIVILEGE_TYPE  = s_tpv.PRIVILEGE_TYPE,
        IS_GRANTABLE    = s_tpv.IS_GRANTABLE
    from
        sys.spt_table_privileges_view s_tpv
    where
        s_tpv.TABLE_NAME = @table_name and
        (@table_schema is null or @table_schema = s_tpv.TABLE_SCHEMA) and
        (@grantee is null or @grantee = s_tpv.GRANTEE) and
        (@grantor is null or @grantor = s_tpv.GRANTOR)
    order by 4,5,6,1,2
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

