## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_cdc_start_job\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_cdc_start_job**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -224608904 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@job_type| |nvarchar|20|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_cdc_start_job\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_cdc_start_job\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_cdc_start_job
(
    @job_type nvarchar(20) = N'capture'
)    
as
begin
    set nocount on

    declare @job_id uniqueidentifier
           ,@retcode int
           ,@db_name sysname
  
    set @db_name = db_name()
           
    -- Verify CDC is supported for this SQL Server edition
    IF ([sys].[fn_cdc_is_supported]() = 1)
    begin
        declare @edition sysname
        select @edition = CONVERT(sysname, SERVERPROPERTY('Edition'))
        raiserror(22988, 16, -1, @edition)
        return (1)
    end

    --
    -- Job security check proc
    --
    exec @retcode = [sys].[sp_MScdc_job_security_check]
    if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
        return(1)
        
    -- Verify database is currently enabled for change data capture
    if ([sys].[fn_cdc_is_db_enabled]() != 1)
    begin
        raiserror(22901, 16, -1, @db_name)
        return 1
    end
        
    set @job_type = rtrim(ltrim(lower(@job_type)))
            
    -- Verify parameter
    if ((@job_type is null) or (@job_type not in (N'capture', N'cleanup')))
    begin
        raiserror(22992, 16, -1, @job_type)
        return(1)
    end
    
    --
    -- Insure that transactional replication is not also enabled for the database
    --
    if (@job_type = N'capture')
    begin
        exec @retcode = [sys].[sp_MScdc_tranrepl_check] 
        if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
            return (1)
    end
    
    -- Call internal procedure to start the job
    exec @retcode = sys.sp_cdc_start_job_internal
        @job_type
        
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
        return 1
        
    return 0        
end

--
-- Name: [sys].[sp_cdc_stop_job_internal]
--
-- Description:
--    Stops the CDC job if it exists
--
-- Parameters: 
--   @job_type    'capture' (default), 'cleanup'
--
-- Returns: 0 - success
--          1 - Otherwise
--
-- Security: Internal.
--
--            Module requires with execute as 'dbo' in order to authorize
--          access to msdb.
-- 
raiserror(15339,-1,-1,'[sys].[sp_cdc_stop_job_internal]')
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

