## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_getsubscription_status_hsnapshot\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_getsubscription_status_hsnapshot**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -224977668 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@article| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_getsubscription_status_hsnapshot\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_getsubscription_status_hsnapshot\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

--
-- Name:    
--          sp_getsubscription_status_hsnapshot
--          
-- Description: 
--          Specialized stored procedure for heterogeneous snapshot agent to
--          determine subscription status.
--  
-- Security: 
--          Agent
--
--          Result set:  Subscription status
--      
-- Owner:   
--          sward 

create procedure sys.sp_getsubscription_status_hsnapshot
(
    @publication    sysname,
    @article    sysname,
    @publisher    sysname
)
AS
BEGIN
    DECLARE @cmd            nvarchar(4000)
    DECLARE @retcode        int
    DECLARE @publisher_type    sysname

    SET @retcode = 0

    EXEC @retcode = sys.sp_MSrepl_getpublisherinfo
        @publisher = @publisher,
        @publisher_type = @publisher_type OUTPUT,
        @rpcheader = @cmd OUTPUT,
        @skipSecurityCheck    = 1

    IF @retcode &lt;&gt; 0
        RETURN (@retcode)

    -- This procedue is only to be used with heterogeneous publishers    
    IF @publisher_type = N'MSSQLSERVER'
    BEGIN
        RAISERROR (21659, 16, -1)
        RETURN (1)
    END

    SET @publisher = UPPER(@publisher) COLLATE DATABASE_DEFAULT
    set @cmd = @cmd + N'sys.sp_MSrepl_getsubscription_status_hsnapshot'
    
    EXEC @retcode = @cmd
        @publication,
        @article,
        @publisher

    RETURN (@retcode)
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

