## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_flush_commit_table\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_flush_commit_table**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -231648755 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@flush_ts| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@cleanup_version| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@rowcount| |int|4|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@date_cleanedup| |datetime|8|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_flush_commit_table\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_flush_commit_table\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE PROC sys.sp_flush_commit_table (@flush_ts BIGINT, @cleanup_version BIGINT = NULL, @rowcount INT OUTPUT, @date_cleanedup DATETIME OUTPUT) AS
BEGIN
    DECLARE @cleanup_ts BIGINT
    SET        @cleanup_ts = change_tracking_hardened_cleanup_version ()

    IF @cleanup_ts &gt; @cleanup_version
        SET @cleanup_ts = @cleanup_version

    DECLARE @start_ts BIGINT
    SET        @start_ts = (SELECT MAX(commit_ts) FROM sys.syscommittab)

    IF @start_ts IS NULL OR @start_ts &lt; @cleanup_ts
        SET @start_ts = @cleanup_ts

    INSERT    sys.syscommittab
    SELECT    *
    FROM    OpenRowset (table SYSCOMMITTABLE, db_id (), @start_ts, 1)
    WHERE    commit_ts &lt;= @flush_ts

    IF @@ROWCOUNT &gt; 10000
        SET @rowcount = @@ROWCOUNT
    ELSE
        SET @rowcount = 10000

    DELETE TOP(@rowcount) sys.syscommittab WHERE commit_ts &lt; @cleanup_ts
    SET @rowcount = @@ROWCOUNT

    select @date_cleanedup=min(commit_time) from sys.syscommittab where commit_ts = (select min(commit_ts) from sys.syscommittab)

    IF (@date_cleanedup is null)
        SET @date_cleanedup = GETUTCDATE()

END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

