## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_foreignkeys\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_foreignkeys**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -234385068 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@table_server| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@pktab_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@pktab_schema| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@pktab_catalog| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@fktab_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@fktab_schema| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@fktab_catalog| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|PKTABLE_CAT|nvarchar|128|
|PKTABLE_SCHEM|nvarchar|128|
|PKTABLE_NAME|nvarchar|128|
|PKCOLUMN_NAME|nvarchar|128|
|FKTABLE_CAT|nvarchar|128|
|FKTABLE_SCHEM|nvarchar|128|
|FKTABLE_NAME|nvarchar|128|
|FKCOLUMN_NAME|nvarchar|128|
|KEY_SEQ|int|4|
|UPDATE_RULE|int|4|
|DELETE_RULE|int|4|
|FK_NAME|nvarchar|128|
|PK_NAME|nvarchar|128|
|DEFERRABILITY|smallint|2|

---
### Objects that depend on \[sys\].\[sp_foreignkeys\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_foreignkeys\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_foreignkeys
(
    @table_server       sysname,
    @pktab_name         sysname = null,
    @pktab_schema       sysname = null,
    @pktab_catalog      sysname = null,
    @fktab_name         sysname = null,
    @fktab_schema       sysname = null,
    @fktab_catalog      sysname = null
)
as
    select
        PKTABLE_CAT     = PK_TABLE_CATALOG,
        PKTABLE_SCHEM   = PK_TABLE_SCHEMA,
        PKTABLE_NAME    = PK_TABLE_NAME,
        PKCOLUMN_NAME   = PK_COLUMN_NAME,
        FKTABLE_CAT     = FK_TABLE_CATALOG,
        FKTABLE_SCHEM   = FK_TABLE_SCHEMA,
        FKTABLE_NAME    = FK_TABLE_NAME,
        FKCOLUMN_NAME   = FK_COLUMN_NAME,
        KEY_SEQ         = ORDINAL,
        UPDATE_RULE     =
                        case UPDATE_RULE
                            when 'CASCADE' then 0
                            when 'NO ACTION' then 1
                            when 'SET NULL' then 2
                            when 'SET DEFAULT' then 3
                            else null
                        end,
        DELETE_RULE     =
                        case DELETE_RULE
                            when 'CASCADE' then 0
                            when 'NO ACTION' then 1
                            when 'SET NULL' then 2
                            when 'SET DEFAULT' then 3
                            else null
                        end,
        FK_NAME         = convert(sysname, NULL),
        PK_NAME         = convert(sysname, NULL),
        DEFERRABILITY   = convert(smallint, null)

    from
        sys.fn_remote_foreign_keys (
                @table_server,
                @pktab_catalog,
                @pktab_schema,
                @pktab_name,
                @fktab_catalog,
                @fktab_schema,
                @fktab_name)
    order by FKTABLE_CAT, FKTABLE_SCHEM, FKTABLE_NAME, KEY_SEQ
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

