## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSpeerapplyresponse\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSpeerapplyresponse**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -242627501 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@request_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@originator| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@originator_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@response_srvr| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@response_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSpeerapplyresponse\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSpeerapplyresponse\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSpeerapplyresponse
(
    @request_id        int,
    @originator        sysname,
    @originator_db    sysname,
    @response_srvr    sysname,
    @response_db    sysname
)
as
begin
    set nocount on    
    
    declare @retcode int
    
    -- security check for subscriber
    exec @retcode = sys.sp_MSreplcheck_subscribe 
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0 
    begin
        return 1
    end

    -- we will exit in either of these conditions since this means we
    -- are not at the correct node and we should treat this as a noop
    -- the conditions are as follows:
    --    1. Any of the user provided information is NULL
    --    2. We are not on the originator server
    --    3. The originator and reponse_srvr are the same
    --
    -- section 1 
    if @request_id is NULL
        or @originator is NULL
        or @originator_db is NULL
        or @response_srvr is NULL
        or @response_db is NULL
        -- section 2
        or UPPER(@originator) &lt;&gt; UPPER(publishingservername())
        or @originator_db &lt;&gt; db_name()
        -- section 3
        or (UPPER(@originator) = UPPER(@response_srvr)
            and @originator_db = @response_db)
    begin
        return 0
    end
    
    begin transaction tr_sp_MSpeerapplyresponse
    save transaction tr_sp_MSpeerapplyresponse

    update MSpeer_response
        set received_date = getdate()
        where request_id = @request_id
            and peer = @response_srvr
            and peer_db = @response_db
    if @@error &lt;&gt; 0
    begin
        -- The procedure sys.sp_MSpeerapplyresponse failed to UPDATE the resource MSpeer_response Server error =  0.
        raiserror (21499, 16, -1, 'sys.sp_MSpeerapplyresponse', 'UPDATE', 'MSpeer_response.', @@error)
        goto FAILURE
    end

    commit transaction tr_sp_MSpeerapplyresponse

    return 0
FAILURE:
    rollback transaction tr_sp_MSpeerapplyresponse
    commit transaction 
    
    return 1
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

