## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSgetpeerlsns\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSgetpeerlsns**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -243918086 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@xlockrows| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSgetpeerlsns\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSgetpeerlsns\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSgetpeerlsns
(
    @publication    sysname,
     @xlockrows         bit
)
as
begin
    set nocount on

    declare @retcode     int,
            @dbversion    int
    
    -- security check for subscriber
    exec @retcode = sys.sp_MSreplcheck_subscribe 
    if @@error &lt;&gt; 0 or  @retcode &lt;&gt; 0 
    begin
        return 1
    end

    -- retrieve the current subscriber database version
    exec @retcode = sys.sp_MSgetdbversion @current_version = @dbversion output 
    if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
    begin
        return 1
    end
    
    -- user wants to place an exclusive lock on the retrieved rows for 
    -- the duration of the transaction in which this SP is called...
    if @xlockrows = 1 
    begin
        -- note that here we order by pk to ensure lock order
        select distinct    UPPER(originator),
                originator_db,
                originator_publication_id,
                originator_db_version,
                originator_lsn,
                id
            from MSpeer_lsns with (XLOCK, ROWLOCK, INDEX(nci_MSpeer_lsns))
            where originator_publication = @publication
                    -- and they can not be local water marks or they must be from a differnt db version
                    and (originator             != UPPER(publishingservername())
                        or originator_db             != db_name()
                        or originator_db_version     != @dbversion)
            order by id
        if @@error &lt;&gt; 0
            return 1
    end
    else
    begin
        -- same query as above without the xlock, rowlock hint and no order by
        select distinct    UPPER(originator),
                originator_db,
                originator_publication_id,
                originator_db_version,
                originator_lsn
            from MSpeer_lsns with (INDEX(nci_MSpeer_lsns))
            where originator_publication = @publication
                    -- and they can not be local water marks or they must be from a differnt db version
                    and (originator             != UPPER(publishingservername())
                        or originator_db             != db_name()
                        or originator_db_version     != @dbversion)
        if @@error &lt;&gt; 0
            return 1
    end

    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

