## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSmerge_log_identity_range_allocations\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSmerge_log_identity_range_allocations**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -24538674 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@article| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscriber| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscriber_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@is_pub_range| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@ranges_allocated| |tinyint|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@range_begin| |numeric|17|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@range_end| |numeric|17|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@next_range_begin| |numeric|17|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@next_range_end| |numeric|17|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSmerge_log_identity_range_allocations\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSmerge_log_identity_range_allocations\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSmerge_log_identity_range_allocations
(
    @publisher sysname,
    @publisher_db sysname,
    @publication sysname,
    @article sysname,
    @subscriber sysname,
    @subscriber_db sysname,
    @is_pub_range bit,
    @ranges_allocated tinyint, 
    @range_begin numeric(38,0),
    @range_end numeric(38,0),
    @next_range_begin numeric(38,0),
    @next_range_end numeric(38,0)
)
as
    set nocount on

    declare @retcode tinyint
    declare @max_used numeric(38,0)
    declare @publisher_id int

    --
    -- security check
    -- only db_owner can execute this
    --
    if (is_member ('db_owner') != 1) 
    begin
        raiserror(14260, 16, -1)
        return (1)
    end

    -- Has to be executed from distribution database
    if sys.fn_MSrepl_isdistdb (db_name()) != 1
    begin
        raiserror (21482, 16, -1, 'sp_MSmerge_log_identity_range_allocation', 'distribution')
        return 1
    end

    select @publisher_id = srvid
        from master..sysservers
        where upper(srvname) = upper(@publisher)
    if @publisher_id is NULL
    begin
        -- Publisher @publisher does not exist.
        raiserror(21618, 16, -1, @publisher)
        return 1
    end

    -- we cannot allocate 0 ranges or call this proc with range_end begin NULL
    if @ranges_allocated = 0 or @ranges_allocated is NULL or @range_end is NULL
    begin
        raiserror(20710, 16, -1, @publisher, @publisher_db, @publication, @article)
        return 1
    end

    if @next_range_end is NULL
        select @max_used = @range_end
    else
        select @max_used = @next_range_end
        
    -- insert the passed in information into the table
    insert into dbo.MSmerge_identity_range_allocations 
        (publisher_id, publisher_db, publication, article, subscriber, subscriber_db, 
         is_pub_range, ranges_allocated, range_begin, range_end, next_range_begin, next_range_end, max_used)
    values
        (@publisher_id, @publisher_db, @publication, @article, @subscriber, @subscriber_db, 
         @is_pub_range, @ranges_allocated, @range_begin, @range_end, @next_range_begin, @next_range_end, @max_used)

    if @@error&lt;&gt;0 
        return 1

    return 0
    
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

