## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSenumpartialdeletes\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSenumpartialdeletes**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -245848481 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@maxrows| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@tablenick| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@rowguid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@tablenotbelongs| |nvarchar|255|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@bookmark| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@specified_article_only| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@compatlevel| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@pubid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@enumentirerowmetadata| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSenumpartialdeletes\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSenumpartialdeletes\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
-- If the default parameters change, make sure to adjust the corresponding values in OSQL_Q_ENUMPARTIALDELETES_90.
create procedure sys.sp_MSenumpartialdeletes
    (@maxrows int,
     @tablenick int,
     @rowguid uniqueidentifier,
     @tablenotbelongs nvarchar(255),
     @bookmark int = NULL,
     @specified_article_only int = 0,
     @compatlevel int = 10, -- backward compatibility level, default=Sphinx
     @pubid uniqueidentifier = NULL,
     @enumentirerowmetadata bit= 1)
as
    declare @tnstring       nvarchar(12)
    declare @lowrangestr    nvarchar(12) 
    declare @highrangestr   nvarchar(12) 
    declare @pubidstr        varchar(40)
    declare @last_art_processing_order int
    declare @last_art_processing_order_str varchar(12)
    declare @rowguid_clause nvarchar(100)

    /*
    ** do permission checking
    */
    declare @retcode             int
    exec @retcode = sys.sp_MSrepl_PAL_rolecheck @tablenick = @tablenick
    if @retcode&lt;&gt;0 or @@ERROR&lt;&gt;0 return (1)
    
    declare @selecttop nvarchar(50)
    if (@maxrows = 0)
        set @selecttop= 'select'
    else
        set @selecttop= 'select top ' + cast(@maxrows as nvarchar(9)) 

    declare @metadatacol nvarchar(200)
    declare @metadatacol2 nvarchar(200)

    if 0 = @enumentirerowmetadata
    begin
        if 1 &gt; @tablenick or 0 = @specified_article_only
        begin
            set @metadatacol= 'sys.fn_MSgeneration_downloadonly(generation, tablenick), sys.fn_MSvector_downloadonly(lineage, tablenick)'
            set @metadatacol2= 'sys.fn_MSgeneration_downloadonly(t.generation, tablenick), sys.fn_MSvector_downloadonly(lineage, tablenick)'
        end
        else
        begin
            set @metadatacol= 'null, null'
            set @metadatacol2= 'null, null'
        end
    end
    else if @compatlevel &gt;= 90
    begin
        set @metadatacol= 'coalesce(generation, 0), lineage'
        set @metadatacol2= 'coalesce(t.generation, 0), lineage'
    end
    else
    begin
        set @metadatacol= 'coalesce(generation, 0), {fn LINEAGE_90_TO_80(lineage)}'
        set @metadatacol2= 'coalesce(t.generation, 0), {fn LINEAGE_90_TO_80(lineage)}'
    end

    if @pubid is not null
    begin
        select @pubidstr = '''' + convert(varchar(36), @pubid) + ''''
        if @tablenick &gt; 0
        begin
            exec sys.sp_MSget_article_processing_order @tablenick, @pubid, @last_art_processing_order output
            select @last_art_processing_order_str = convert(varchar(12), @last_art_processing_order)
        end
    end

-- DEBUG    insert into MSmerge_debug
-- DEBUG        (okay, artnick, twhen, comment)
-- DEBUG        values (0, @tablenick, getdate(), 'sp_MSenumpartialdeletes; maxrows=' + convert(nvarchar, @maxrows) 
-- DEBUG        + ', startguid=' + convert(nchar(36), @rowguid) + ', bookmark=' + convert(nvarchar, @bookmark)
-- DEBUG        + ', specified_article_only=' + convert(nchar(1), @specified_article_only))

    if (@tablenick &lt; 1)
    begin
        if @pubid is null
            execute (@selecttop + ' tablenick, rowguid, ' + @metadatacol + ', type, bookmark from ' + @tablenotbelongs + '
                    order by tablenick desc, rowguid asc' )
        else
            execute (@selecttop + ' t.tablenick, t.rowguid, ' + @metadatacol2 + ', t.type, t.bookmark 
                    from ' + @tablenotbelongs + ' t, dbo.sysmergearticles sma
                    where t.tablenick = sma.nickname
                    and sma.pubid = ' + @pubidstr + '
                    order by sma.processing_order desc, t.tablenick desc, t.rowguid asc' )
        IF @@ERROR &lt;&gt;0 
        begin
-- DEBUG    insert into MSmerge_debug (okay, twhen, comment)
-- DEBUG        values (1, getdate(), 'sp_MSenumpartialdeletes: select from notbelong failed')
            return (1)  
        end

-- DEBUG    execute ('insert into MSmerge_debug (okay, artnick, rowguid, generation_new, lineage_new, twhen, comment) ' +
-- DEBUG                @selecttop + ' 0, tablenick, rowguid, COALESCE (generation, 0), lineage, getdate(), ''sp_MSenumpartialdeletes'' 
-- DEBUG                from ' + @tablenotbelongs + ' order by tablenick desc, rowguid asc' )
    end
    else 
    begin
        set @tnstring = convert(nchar, @tablenick)
        if @rowguid is NULL or @rowguid = '00000000-0000-0000-0000-000000000000'
            select @rowguid_clause = ' '
        else
            select @rowguid_clause = ' and rowguid &gt; ''' + convert(nchar(36), @rowguid) + ''' '

        /* 
        ** If a 7.0 SP1 Merge agent is calling this sp, it passed a valid bookmark parameter 
        ** Use the bookmark column in the ##belongs_&lt;&gt; table to retrieve the next batch of rows
        */
        if @bookmark is NOT NULL 
        begin
            set @lowrangestr = convert(nchar, @bookmark)
            set @highrangestr = convert(nchar, (@bookmark + @maxrows))

            if (@specified_article_only = 1)
            begin
                -- don't rely on @highrangestr since it will be equal to @lowrangestr if @maxrows=0.
                execute (@selecttop + ' tablenick, rowguid, ' + @metadatacol + ', type, bookmark from ' + @tablenotbelongs + '
                            where  tablenick = ' + @tnstring + ' and 
                            bookmark &gt; ' + @lowrangestr + ' 
                            order by tablenick, rowguid' )

                if @@ERROR&lt;&gt;0
                begin
-- DEBUG            insert into MSmerge_debug (okay, twhen, comment)
-- DEBUG            values (2, getdate(), 'sp_MSenumpartialdeletes: select from notbelong failed')
                    return (1)
                end                     

-- DEBUG        execute ('insert into MSmerge_debug (okay, artnick, rowguid, generation_new, lineage_new, type, twhen, comment) ' + 
-- DEBUG                    @selecttop + ' 0, tablenick, rowguid, COALESCE (generation, 0), lineage, type, getdate(), ''sp_MSenumpartialdeletes: @specified_article_only = 1''
-- DEBUG                    from ' + @tablenotbelongs + '
-- DEBUG                    where  tablenick = ' + @tnstring + ' and 
-- DEBUG                    bookmark &gt; ' + @lowrangestr + ' 
-- DEBUG                    order by rowguid' )

            end
            else
            begin
                if @pubid is null
                    execute ('select tablenick, rowguid, ' + @metadatacol + ', type, bookmark from ' + @tablenotbelongs + '
                            where  ((tablenick = ' + @tnstring + ' and 
                            bookmark &gt; ' + @lowrangestr + ' and bookmark &lt;= ' + @highrangestr + ') or
                            tablenick &lt; ' + @tnstring + ') 
                            order by tablenick desc, rowguid asc' )
                else
                    execute ('select t.tablenick, t.rowguid, ' + @metadatacol2 + ', t.type, t.bookmark 
                            from ' + @tablenotbelongs + ' t, dbo.sysmergearticles sma
                            where t.tablenick = sma.nickname
                            and sma.pubid = ' + @pubidstr + '
                            and
                            (
                                (t.tablenick = ' + @tnstring + ' and t.bookmark &gt; ' + @lowrangestr + ' and t.bookmark &lt;= ' + @highrangestr + ') or
                                (sma.processing_order = ' + @last_art_processing_order_str + ' and t.tablenick &lt; ' + @tnstring + ')  or
                                sma.processing_order &lt; ' + @last_art_processing_order_str + '
                            )
                            order by sma.processing_order desc, t.tablenick desc, t.rowguid asc' )

                if @@ERROR&lt;&gt;0
                begin
-- DEBUG            insert into MSmerge_debug (okay, twhen, comment)
-- DEBUG                values (3, getdate(), 'sp_MSenumpartialdeletes: select from notbelong failed')
                    return (1)
                end                     

-- DEBUG        execute ('insert into MSmerge_debug (okay, artnick, rowguid, generation_new, lineage_new, type, twhen, comment)
-- DEBUG                    select 0, tablenick, rowguid, COALESCE (generation, 0), lineage, type, getdate(), ''sp_MSenumpartialdeletes: @specified_article_only &lt;&gt; 1'' 
-- DEBUG                    from ' + @tablenotbelongs + '
-- DEBUG                    where  ((tablenick = ' + @tnstring + ' and 
-- DEBUG                    bookmark &gt; ' + @lowrangestr + ' and bookmark &lt;= ' + @highrangestr + ') or
-- DEBUG                    tablenick &lt; ' + @tnstring + ') 
-- DEBUG                    order by tablenick desc, rowguid asc' )
            end
        end

        /* 
        ** Backward compatibilty mode : If a 7.0 Merge agent is calling this sp, it will pass a NULL bookmark parameter 
        ** Use the rowguid and set rowcount to retrieve the next batch of rows
        */
        else
        begin
            if (@specified_article_only = 1)
            begin
                execute (@selecttop + ' tablenick, rowguid, ' + @metadatacol + ', type from ' + @tablenotbelongs + '
                            where  tablenick = ' + @tnstring + @rowguid_clause + '
                            order by tablenick, rowguid' )
                IF @@ERROR &lt;&gt;0 
                begin
-- DEBUG                insert into MSmerge_debug (okay, twhen, comment)
-- DEBUG                values (4, getdate(), 'sp_MSenumpartialdeletes: select from notbelong failed')
                    return (1)  
                end

-- DEBUG                execute ('insert into MSmerge_debug (okay, artnick, rowguid, generation_new, lineage_new, type, twhen, comment) ' + 
-- DEBUG                    @selecttop + ' 0, tablenick, rowguid, COALESCE (generation, 0), lineage, type, getdate(), ''sp_MSenumpartialdeletes: @specified_article_only = 0''
-- DEBUG                    from ' + @tablenotbelongs + '
-- DEBUG                    where  tablenick = ' + @tnstring + ' and 
-- DEBUG                    rowguid &gt; ' + @rgstring + ' 
-- DEBUG                    order by rowguid' )
            end
            else
            begin
                if @pubid is null
                    execute (@selecttop + ' tablenick, rowguid, ' + @metadatacol + ', type from ' + @tablenotbelongs + '
                            where  ((tablenick = ' + @tnstring + @rowguid_clause + ') or tablenick &lt; ' + @tnstring + ') 
                            order by tablenick desc, rowguid asc' )
                else
                    execute (@selecttop + ' t.tablenick, t.rowguid, ' + @metadatacol2 + ', t.type 
                            from ' + @tablenotbelongs + ' t, dbo.sysmergearticles sma
                            where t.tablenick = sma.nickname
                            and sma.pubid = ' + @pubidstr + '
                            and
                            (
                                (tablenick = ' + @tnstring + @rowguid_clause + ') or 
                                (sma.processing_order = ' + @last_art_processing_order_str + ' and t.tablenick &lt; ' + @tnstring + ')  or
                                sma.processing_order &lt; ' + @last_art_processing_order_str + '
                            )

                            order by sma.processing_order desc, t.tablenick desc, t.rowguid asc' )

                IF @@ERROR &lt;&gt;0 
                begin
-- DEBUG                insert into MSmerge_debug (okay, twhen, comment)
-- DEBUG                values (5, getdate(), 'sp_MSenumpartialdeletes: select from notbelong failed')
                    return (1)  
                end

-- DEBUG                execute ('insert into MSmerge_debug (okay, artnick, rowguid, generation_new, lineage_new, type, twhen, comment) ' + 
-- DEBUG                    @selecttop + ' 0, tablenick, rowguid, COALESCE (generation, 0), lineage, type, getdate(), ''sp_MSenumpartialdeletes: @specified_article_only = 0''
-- DEBUG                    from ' + @tablenotbelongs + '
-- DEBUG                    where  ((tablenick = ' + @tnstring + ' and 
-- DEBUG                    rowguid &gt; ' + @rgstring + ') or tablenick &lt; ' + @tnstring + ')
-- DEBUG                    order by tablenick desc, rowguid asc' )
            end
        end
    end
    return (0)
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

