## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_helpmergedeleteconflictrows\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_helpmergedeleteconflictrows**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -2490518 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_object| |nvarchar|386|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@logical_record_conflicts| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_helpmergedeleteconflictrows\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_helpmergedeleteconflictrows\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_helpmergedeleteconflictrows(
    @publication    sysname = '%',
    @source_object    nvarchar(386) = NULL,
    @publisher        sysname = NULL,
    @publisher_db    sysname = NULL,
    @logical_record_conflicts int = 0
    )
as
    declare @pubid            uniqueidentifier
    declare @cmd            nvarchar(4000)    
    declare @pubidstr        nvarchar(38)
    declare @retcode        int

    -- Security check: dbo and sysadmin only
    exec @retcode = sys.sp_MSreplcheck_publish
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
    begin
        return 1
    end       

    if @publisher IS NULL
        select @publisher = publishingservername()
        
    if @publisher_db IS NULL
        select @publisher_db = db_name()
    select @cmd = 'select distinct source_object = schema_name(sys.objects.schema_id) + '
    select @cmd = @cmd + '''.'''
    select @cmd = @cmd + ' + sys.objects.name, MSmerge_conflicts_info.rowguid, MSmerge_conflicts_info.conflict_type, '
    select @cmd = @cmd + ' MSmerge_conflicts_info.reason_code, MSmerge_conflicts_info.reason_text, '
    select @cmd = @cmd + ' MSmerge_conflicts_info.origin_datasource, MSmerge_conflicts_info.pubid, MSmerge_conflicts_info.MSrepl_create_time from MSmerge_conflicts_info, dbo.sysmergearticles, sys.objects'     
    select @cmd = @cmd + ' where dbo.sysmergearticles.nickname = MSmerge_conflicts_info.tablenick 
                     and sys.objects.object_id = dbo.sysmergearticles.objid '

    -- Do not return logical record conflicts unless requested.
    if @logical_record_conflicts = 0
    begin
        select @cmd = @cmd + ' and MSmerge_conflicts_info.conflict_type in (4, 7, 8) '
    end
    else
    begin
        select @cmd = @cmd + ' and MSmerge_conflicts_info.conflict_type in (4, 7, 8, 12) '
    end
    
    if @publication &lt;&gt; '%'
        begin
            /*
            ** Parameter Check:     @publication.
            ** Make sure that the publication exists.
            */
            select @pubid = pubid from dbo.sysmergepublications 
                where name = @publication and 
                    LOWER(publisher) = LOWER(@publisher) and
                    publisher_db = @publisher_db
            if @pubid IS NULL
                BEGIN
                    RAISERROR (20026, 16, -1, @publication)
                    RETURN (1)
                END
            set @pubidstr = '''' + convert(nchar(36), @pubid) + '''' 
            select @cmd = @cmd + ' and MSmerge_conflicts_info.pubid = ' + @pubidstr
        end

    if @source_object IS NOT NULL
        begin
            declare @object            sysname     
            declare @owner            sysname     
            declare @tablenick        int
            declare @tablenickstr    nvarchar(11)
            
            select @object = PARSENAME(@source_object, 1)
            select @owner = PARSENAME(@source_object, 2)
            execute sys.sp_MStablenickname @owner, @object, @tablenick output
            if @tablenick IS NULL
                BEGIN
                    raiserror (20003, 11, -1, @object)
                    RETURN (1)
                END
            set @tablenickstr = convert(nchar, @tablenick)
            select @cmd = @cmd + ' and MSmerge_conflicts_info.tablenick = '
            select @cmd = @cmd + @tablenickstr
        end

    exec (@cmd)
    if (@@error &lt;&gt; 0)
        RETURN (1)
    
    return 0
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

