## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_IHget_loopback_detection\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_IHget_loopback_detection**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -251997161 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscriber| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscriber_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_IHget_loopback_detection\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_IHget_loopback_detection\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE sys.sp_IHget_loopback_detection
(
    @publisher sysname,
    @publisher_db sysname,
    @publication sysname,        
    @subscriber sysname,              
    @subscriber_db sysname
)
as
begin
    set nocount on

    DECLARE @retcode     int
 
   -- Security check: Sysadmins and db_owners only
   exec @retcode = sys.sp_MSreplcheck_publish
   if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
   begin
      return 1
   end

   -- Has to be executed from distribution database
   if sys.fn_MSrepl_isdistdb (db_name()) != 1
   begin
      raiserror (21482, 16, -1, 'sp_IHget_loopback_detection', 'distribution')
      return 1
   end

    select distinct loopback_detection
    from 
        MSsubscriptions s,
         master.dbo.sysservers ss
    where 
    s.publisher_id =
         (select srvid from master.dbo.sysservers
         where UPPER(srvname collate database_default) = UPPER(@publisher) collate database_default) and 
    s.publisher_db = @publisher_db and
    s.publication_id =
         (select publication_id from MSpublications
          where publisher_id = s.publisher_id and
               publisher_db = s.publisher_db and
               publication = @publication) and
    s.subscriber_db = @subscriber_db and
    s.subscriber_id = ss.srvid and
    UPPER(ss.srvname collate database_default) = UPPER(@subscriber) collate database_default and
    s.subscriber_id &gt;= 0 
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

