## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_lookupcustomresolver\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_lookupcustomresolver**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -252228858 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@article_resolver| |nvarchar|255|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@resolver_clsid| |nvarchar|50|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@is_dotnet_assembly| |bit|1|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@dotnet_assembly_name| |nvarchar|255|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@dotnet_class_name| |nvarchar|255|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_lookupcustomresolver\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_lookupcustomresolver\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
--
-- Name: sp_lookupcustomresolver
--
-- Descriptions: 
--
-- Parameters: as defined in create statement
--
-- Returns: 0 - success
--          1 - Otherwise
--
-- Security: 
-- Requires Certificate signature for catalog access
--

create procedure sys.sp_lookupcustomresolver
    @article_resolver  nvarchar(255),
    @resolver_clsid    nvarchar(50)   OUTPUT,
    @is_dotnet_assembly bit = 0 OUTPUT,                 -- This flag is set to TRUE while registering a .NET Framework Assembly 
    @dotnet_assembly_name  nvarchar(255) = NULL OUTPUT, -- For .NET Framework Assemblies, this parameter must be set to the name of the .NET assembly that implements the BusinessLogicModule class
    @dotnet_class_name  nvarchar(255) = NULL OUTPUT,     -- For .NET Framework Assemblies, this parameter must be set to the name of the .NET class that implements the BusinessLogicModule class    
    @publisher sysname = NULL
AS

    declare @distributor sysname
    declare @distributiondb sysname
    declare @distproc nvarchar(1000)
    declare @retcode  int
    declare @stmt  nvarchar(1000)
    
    set @retcode = 0

    -- Security check
    if 1 &lt;&gt; is_member('db_owner')
    begin    
        RAISERROR (15247, 11, -1)
        return (1)
    end

    if @article_resolver IS NULL or @article_resolver = ''
    begin
        RAISERROR (21717, 16, -1)
        return 1
    end

    select @is_dotnet_assembly = 0

    if @publisher is null
         select @publisher = publishingservername()

    /*
    ** Get the distributor 
    */
    if ((@distributor is null) or (@distributiondb is null))
    begin
        EXEC @retcode = sys.sp_helpdistributor @rpcsrvname=@distributor OUTPUT,
                                                @distribdb = @distributiondb OUTPUT,
                                                @publisher  = @publisher
        IF @@error &lt;&gt; 0 or @retcode &lt;&gt; 0 or @distributiondb is NULL
        BEGIN
            RAISERROR (20036, 16, -1)
            RETURN (1)
        END
    end

    /*
    ** For a local distributor, query the MSmerge_articleresolver directly
    */
    if @distributor = @@servername and db_name() = @distributiondb
    begin
        select @resolver_clsid                  = resolver_clsid,
                 @is_dotnet_assembly          = is_dotnet_assembly,
                 @dotnet_assembly_name    = dotnet_assembly_name,
                 @dotnet_class_name          = dotnet_class_name
        from dbo.MSmerge_articleresolver
        where article_resolver = @article_resolver

    end
    /* 
    ** Since a downlevel publisher can connect to a remote distributor with a higher
    ** version, it is better to return the resolver list using the RPC as opposed
    ** to reading regkeys directly since they might change from version to version.
    */
    else
    begin
        select @distproc = quotename(RTRIM(@distributor)) + '.' + quotename(@distributiondb) +'.sys.sp_lookupcustomresolver'
        exec @distproc 
            @article_resolver  = @article_resolver,
            @resolver_clsid    = @resolver_clsid OUTPUT,
            @is_dotnet_assembly = @is_dotnet_assembly OUTPUT,
            @dotnet_assembly_name = @dotnet_assembly_name OUTPUT,
            @dotnet_class_name = @dotnet_class_name OUTPUT,
            @publisher = @publisher
        if @@ERROR&lt;&gt; 0 
            return (1)
    end

    return @retcode
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

