## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_db_selective_xml_index\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_db_selective_xml_index**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -26156665 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@dbname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@selective_xml_index| |varchar|6|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|selective_xml_index|bit|1|

---
### Objects that depend on \[sys\].\[sp_db_selective_xml_index\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_db_selective_xml_index\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_db_selective_xml_index
(
    @dbname sysname = null,
    @selective_xml_index varchar(6) = null --&gt; 'true', 'false', 'on', 'off'
)
as
    -- If database is not specified then is current database
    if (@dbname is null)
    begin
        set @dbname = DB_NAME();
    end
    -- If ON/OFF parameter is specified then is an action call
    if @selective_xml_index is not null
    begin
    -- on, true - enable Selective XML Index feature for particular database (@dbname)
    -- off, false - disable Selective XML Index feature for partcular database (@dbname)
        if (lower(@selective_xml_index) not in ('on', 'off', 'true', 'false'))
        begin
            raiserror (15231,16,1,'@selective_xml_index','sp_db_selective_xml_index');
            return (1);
        end
        declare @fOnOff bit = 0;
        set @fOnOff = case lower(@selective_xml_index)
            when 'on' then 1
            when 'true' then 1
            else 0
            end;

        -- SQL 11: is not possible to disable support, raise informational message
        if @fOnOff = 0
        begin
            raiserror (657,0,1);
        end
    end

    select cast(1 as bit) as selective_xml_index
         from sys.databases
         where name = @dbname;
    return (0);
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

