## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_validatemergepublication\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_validatemergepublication**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -262165357 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@level| |tinyint|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_validatemergepublication\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_validatemergepublication\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_validatemergepublication
    (@publication            sysname,
     @level                    tinyint
     ) AS
     
    set nocount on 
    declare @artid                    uniqueidentifier
    declare @schematype                int
    declare @schemaversion            int
    declare @schemaguid                uniqueidentifier
    declare @schematext                nvarchar
    declare @retcode                int
    declare @pubid                    uniqueidentifier
    declare @compatlevel int
    
    /*
    ** Security Check
    */
    EXEC @retcode = sys.sp_MSreplcheck_publish
    IF @@ERROR &lt;&gt; 0 or @retcode &lt;&gt; 0
        return (1)

    /* make sure current database is enabled for merge replication */
    exec @retcode=sys.sp_MSCheckmergereplication
    if @@ERROR&lt;&gt;0 or @retcode&lt;&gt;0
        return (1)

    select @pubid = pubid, @compatlevel = backward_comp_level from dbo.sysmergepublications where name = @publication and UPPER(publisher)=UPPER(publishingservername()) and publisher_db=db_name()
    if @pubid is NULL
    begin
        raiserror (20026, 16, -1, @publication)
        return (1)
    end
    if @level &lt;1 or @level &gt; 3
    begin
        raiserror(21184, 16, -1, '@level', '1', '2','3')
        return (1)
    end

    if @compatlevel &lt; 30
    begin
        raiserror(21356, 10, -1, @publication)
        exec @retcode=sys.sp_MSBumpupCompLevel @pubid, 30 
        if @@ERROR&lt;&gt;0 or @retcode&lt;&gt;0        
            return (1)
    end
    
    select @schemaversion = schemaversion from dbo.sysmergeschemachange
    if (@schemaversion is NULL)
        set @schemaversion = 1
    else
        select @schemaversion = 1 + max(schemaversion) from dbo.sysmergeschemachange
        set @schemaguid = newid()
        set @artid = newid()
        set @schematype = 66 /* publication wide validation */
        select @schematext = convert(nvarchar, @level)        
        exec @retcode=sys.sp_MSinsertschemachange @pubid, @artid, @schemaversion, @schemaguid, @schematype, @schematext
        if @@ERROR&lt;&gt;0 or @retcode&lt;&gt;0
            return (1)
    return (0)
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

