## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_flush_commit_table_on_demand\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_flush_commit_table_on_demand**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -262735975 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@numrows| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_flush_commit_table_on_demand\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_flush_commit_table_on_demand\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROC sys.sp_flush_commit_table_on_demand (@numrows as BIGINT = NULL) AS
BEGIN

    IF (is_srvrolemember('sysadmin') = 0)
    BEGIN
        raiserror(21089,0,1)
        return 1
    END


    IF (@numrows&lt;=0)
    BEGIN
        raiserror(23100,0,1)
        return 1
    END


    SET DEADLOCK_PRIORITY LOW

    -- checking for change tracking side table watermark
    DECLARE @cleanup_ts BIGINT
    SET        @cleanup_ts = change_tracking_hardened_cleanup_version ()
    RAISERROR(22866,0,1,35502,@cleanup_ts)

    -- checking for safe cleanup watermark
    DECLARE @cleanup_version BIGINT
    set @cleanup_version = safe_cleanup_version ()
    RAISERROR(22866,0,1,35503,@cleanup_version)

    IF @cleanup_ts &gt; @cleanup_version
        SET @cleanup_ts = @cleanup_version


    IF (@numrows is null)
    BEGIN
        DELETE TOP(10000) sys.syscommittab WHERE commit_ts &lt; @cleanup_ts
        WHILE(@@ROWCOUNT&gt;0)
            DELETE TOP(10000) sys.syscommittab WHERE commit_ts &lt; @cleanup_ts
    END
    ELSE IF( @numrows &gt; 10000)
    BEGIN
        DELETE TOP(10000) sys.syscommittab WHERE commit_ts &lt; @cleanup_ts
        SET @numrows-=10000
        WHILE(@numrows &gt; 0 and @@ROWCOUNT &gt; 0)
        BEGIN
            DELETE TOP(10000) sys.syscommittab WHERE commit_ts &lt; @cleanup_ts
            SET @numrows-=10000
        END
    END
    ELSE
        DELETE TOP(@numrows) sys.syscommittab WHERE commit_ts &lt; @cleanup_ts

    DECLARE @dbname sysname
    SET @dbname= DB_NAME()

    raiserror(21092,-1,-1,@dbname) WITH LOG

END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

