## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSenumdeletesmetadata\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSenumdeletesmetadata**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -266234835 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@pubid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@maxrows| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@genlist| |varchar|8000|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@tablenick| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@rowguid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@filter_partialdeletes| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@specified_article_only| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@mingen| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@maxgen| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@compatlevel| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@enumentirerowmetadata| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSenumdeletesmetadata\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSenumdeletesmetadata\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_MSenumdeletesmetadata(
    @pubid uniqueidentifier, 
    @maxrows int, 
    @genlist varchar(8000), 
    @tablenick int, 
    @rowguid    uniqueidentifier,
    @filter_partialdeletes int = 0,
    @specified_article_only int = 0,
    @mingen bigint = 0,
    @maxgen bigint = 0,
    @compatlevel int = 10,  -- backward compatibility level, default=Sphinx
    @enumentirerowmetadata bit= 1)

as
    declare @tnstring nvarchar(12)
    declare @pubidstr nvarchar(38)
    declare @tablenick_qual nvarchar(100)
    declare @generation_clause1 nvarchar(max)
    declare @generation_clause2 nvarchar(max)
    declare @generation_clause3 nvarchar(max)
    declare @last_art_processing_order int
    declare @last_art_processing_order_str varchar(12)
    declare @rowguid_clause nvarchar(100)

    if (@genlist is null)
    begin
        RAISERROR(14043, 16, -1, '@genlist', 'sp_MSenumdeletesmetadata')
        return (1)
    end
    if object_id('MSmerge_contents') is NULL
    begin
        RAISERROR(20054 , 16, -1)
        return (1)
    end

    -- security check
        if ({ fn ISPALUSER(@pubid) } &lt;&gt; 1)
        begin   
        if (@pubid is NULL)
        begin
                RAISERROR (21723, 16, -1, 'sp_MSenumdeletesmetadata')
                return 1
        end
        else
        begin
                RAISERROR (14126, 11, -1)
                return 1
        end
        end

    select @generation_clause1 = ' '
    select @generation_clause2 = ' ' 
    select @generation_clause3 = ' '
    
            
-- DEBUG    insert into MSmerge_debug
-- DEBUG        (okay, artnick, twhen, comment)
-- DEBUG        values (0, @tablenick, getdate(), 'sp_MSenumdeletesmetadata; maxrows=' + convert(nvarchar, @maxrows) 
-- DEBUG        + ', startguid=' + convert(nchar(36), @rowguid) 
-- DEBUG        + ', genlist=' + rtrim(ltrim(@genlist)) + ', pubid=' + convert(nchar(36), @pubid)
-- DEBUG        + ', filter_partialdeletes=' + convert(nchar(1), @filter_partialdeletes) 
-- DEBUG        + ', specified_article_only=' + convert(nchar(1), @specified_article_only))

    set @pubidstr = '''' + convert(nchar(36), @pubid) + ''''

    /* If the filter_partialdeletes is NOT set, include all types of tombstones, else filter the type = 5 ones */
    if (@filter_partialdeletes = 0)
        set @tablenick_qual = ' and ts.tablenick = sm.nickname '
    else
        set @tablenick_qual = ' and ts.tablenick = sm.nickname and ts.type &lt;&gt; 5'
    
    declare @selecttop nvarchar(50)
    if (@maxrows = 0)
        set @selecttop= 'select'
    else
        set @selecttop= 'select top ' + cast(@maxrows as nvarchar(9)) 
    
    declare @mingenstr nvarchar(21)
    declare @maxgenstr nvarchar(21)

    select @mingenstr = convert(nvarchar, @mingen)
    select @maxgenstr = convert(nvarchar, @maxgen)

    declare @metadatacol nvarchar(200)

    if 0 = @enumentirerowmetadata
    begin
        if 0 = @tablenick or 0 = @specified_article_only
                set @metadatacol= 'sys.fn_MSgeneration_downloadonly(generation, tablenick), sys.fn_MSvector_downloadonly(lineage, tablenick)'
        else
                set @metadatacol= 'null, null'
    end
    else if @compatlevel &gt;= 90
        set @metadatacol= 'generation, lineage'
    else
        set @metadatacol= 'generation, {fn LINEAGE_90_TO_80(lineage)}'

    if (@maxgen = 0)
    begin
        select @generation_clause1 = ' generation in ('
        select @generation_clause2 = rtrim(ltrim(@genlist)) 
        select @generation_clause3 = ') '
    end
    else if @mingen = @maxgen
        select @generation_clause1 = ' generation = ' + @mingenstr + ' '
    else
    begin
        select @generation_clause1 = ' generation &gt;= ' + @mingenstr + ' and generation &lt;= ' + @maxgenstr + ' and 
                                generation in ('
                select @generation_clause2 = rtrim(ltrim(@genlist))
                select @generation_clause3 = ') '
        end

    if (@tablenick = 0)
    begin
        if (@genlist is not null and rtrim(ltrim(@genlist)) &lt;&gt; '')
        begin
            execute (@selecttop + ' tablenick, rowguid, ' + @metadatacol + ', ts.type 
                from dbo.MSmerge_tombstone ts, dbo.sysmergearticles sm
                where ' + @generation_clause1 + @generation_clause2 + @generation_clause3 + '
                and sm.pubid = ' + @pubidstr + @tablenick_qual + '
                and (ts.tablenick in 
                                                (select nickname from dbo.sysmergepartitioninfoview where pubid = ' + @pubidstr + '
                                                and logical_record_view is null)
                                        or
                                        ts.logical_record_parent_rowguid is null
                                        )
                order by processing_order desc, tablenick desc, rowguid asc' )
                
            IF @@ERROR &lt;&gt;0 
            begin
    -- DEBUG        insert into MSmerge_debug (okay, twhen, comment)
    -- DEBUG            values (1, getdate(), 'sp_MSenumdeletesmetadata')
                return (1)  
            end

    -- DEBUG    execute ('insert into MSmerge_debug (okay, artnick, rowguid, generation_new, lineage_new, type, twhen, comment) ' +
    -- DEBUG                @selecttop + ' 0, tablenick, rowguid, generation, lineage, ts.type, getdate(), ''sp_MSenumdeletesmetadata'' 
    -- DEBUG                from dbo.MSmerge_tombstone ts, dbo.sysmergearticles sm
    -- DEBUG                where ' + @generation_clause1 + @generation_clause2 + @generation_clause3 + '
    -- DEBUG                and sm.pubid = ' + @pubidstr + @tablenick_qual + '
        -- DEBUG                                and (ts.tablenick in 
        -- DEBUG                                        (select nickname from dbo.sysmergepartitioninfoview where pubid = ' + @pubidstr + '
        -- DEBUG                                        and logical_record_view is null)
        -- DEBUG                                        or
        -- DEBUG                                        ts.logical_record_parent_rowguid is null
        -- DEBUG                                        )
    -- DEBUG                order by processing_order desc, tablenick desc, rowguid asc' )

        end
    end
    else
    begin
        set @tnstring = convert(nchar, @tablenick)
        if @rowguid is NULL or @rowguid = '00000000-0000-0000-0000-000000000000'
            select @rowguid_clause = ' '
        else
            select @rowguid_clause = ' and rowguid &gt; ''' + convert(nchar(36), @rowguid) + ''' '
                
        if (@genlist is not null and rtrim(ltrim(@genlist)) &lt;&gt; '')
        begin
            if (@specified_article_only = 1)
            begin
                -- specify tablenick in the order by for performance reasons
                execute (@selecttop + ' tablenick, rowguid, ' + @metadatacol + ', ts.type 
                                        from dbo.MSmerge_tombstone ts
                    where ' + @generation_clause1 + @generation_clause2 + @generation_clause3 + ' and 
                    tablenick = ' + @tnstring + @rowguid_clause + ' 
                    order by ts.tablenick, ts.rowguid' )

                IF @@ERROR &lt;&gt;0 
                begin
    -- DEBUG            insert into MSmerge_debug (okay, twhen, comment)
    -- DEBUG                values (2, getdate(), 'sp_MSenumdeletesmetadata, @specified_article_only = 1')
                    return (1)  
                end

    -- DEBUG        execute ('insert into MSmerge_debug (okay, artnick, rowguid, generation_new, lineage_new, type, twhen, comment) ' +
    -- DEBUG                    @selecttop + ' 0, tablenick, rowguid, generation, lineage, ts.type, getdate(), ''sp_MSenumdeletesmetadata'' 
    -- DEBUG                    from dbo.MSmerge_tombstone ts, dbo.sysmergearticles sm
    -- DEBUG                    where ' + @generation_clause1 + @generation_clause2 + @generation_clause3 + ' and 
    -- DEBUG                    tablenick = ' + @tnstring + ' and 
    -- DEBUG                    rowguid &gt; ' + @rgstring + ' 
    -- DEBUG                    and sm.pubid = ' + @pubidstr + @tablenick_qual + ' 
    -- DEBUG                    order by rowguid' )
            end
            else
            begin
                                exec sys.sp_MSget_article_processing_order @tablenick, @pubid, @last_art_processing_order output
                                select @last_art_processing_order_str = convert(varchar, @last_art_processing_order)

                execute (@selecttop + ' tablenick, rowguid, ' + @metadatacol + ', ts.type 
                        from dbo.MSmerge_tombstone ts, dbo.sysmergearticles sm
                    where ' + @generation_clause1 + @generation_clause2 + @generation_clause3 + ' and 
                    (
                                                (tablenick = ' + @tnstring + @rowguid_clause + ') or
                                                (processing_order = ' + @last_art_processing_order_str + ' and tablenick &lt; ' + @tnstring + ') or
                                                processing_order &lt; ' + @last_art_processing_order_str + '
                                        ) 
                    and sm.pubid = ' + @pubidstr + @tablenick_qual + ' 
                    and (ts.tablenick in 
                                                (select nickname from dbo.sysmergepartitioninfoview where pubid = ' + @pubidstr + '
                                                and logical_record_view is null)
                                                or
                                                ts.logical_record_parent_rowguid is null
                                                )
                    order by processing_order desc, tablenick desc, rowguid asc' )

                IF @@ERROR &lt;&gt;0 
                begin
    -- DEBUG            insert into MSmerge_debug (okay, twhen, comment)
    -- DEBUG                values (3, getdate(), 'sp_MSenumdeletesmetadata, @specified_article_only &lt;&gt; 1')
                    return (1)  
                end

    -- DEBUG            execute (@selecttop + ' tablenick, rowguid, generation, ' + @lincol + ', ts.type 
    -- DEBUG            from dbo.MSmerge_tombstone ts, dbo.sysmergearticles sm
    -- DEBUG        where ' + @generation_clause1 + @generation_clause2 + @generation_clause3 + ' and 
    -- DEBUG            (
    -- DEBUG                            (tablenick = ' + @tnstring + ' and rowguid &gt; ' + @rgstring + ') or
    -- DEBUG                            (processing_order = ' + @last_art_processing_order_str + ' and tablenick &lt; ' + @tnstring + ') or
    -- DEBUG                            processing_order &lt; ' + @last_art_processing_order_str + '
    -- DEBUG                    ) 
    -- DEBUG        and sm.pubid = ' + @pubidstr + @tablenick_qual + ' 
    -- DEBUG                            and (ts.tablenick in 
    -- DEBUG                                    (select nickname from dbo.sysmergepartitioninfoview where pubid = ' + @pubidstr + '
    -- DEBUG                                    and logical_record_view is null)
    -- DEBUG                                    or
    -- DEBUG                                    ts.logical_record_parent_rowguid is null
    -- DEBUG                                    )

    -- DEBUG        order by processing_order desc, tablenick desc, rowguid asc' )
            end
        end
    end

    return (0)
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

