## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSpeertopeerfwdingexec\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSpeertopeerfwdingexec**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -266309725 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@command| |nvarchar|1073741823|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@execute| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@change_results_originator| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSpeertopeerfwdingexec\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSpeertopeerfwdingexec\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSpeertopeerfwdingexec
(
    @command                    nvarchar(max),
    @publication                sysname,
    @execute                    bit = 1,
    @change_results_originator    bit = 0
)
as
begin
    declare @OPT_ENABLED_FOR_P2P int
    
    declare @retcode     int,
            @cmd_type     int,
            @pubid        int,
            @artid        int
            
    select @OPT_ENABLED_FOR_P2P = 0x1
        
    -- security check for subscriber
    -- Though the work below is related to a publisher, we use 
    -- a check for the subscriber because this is normally executed
    -- by the distribution agent at a subscriber (republisher).
    -- this should only be used by peer to peer subscribers.
    exec @retcode = sys.sp_MSreplcheck_subscribe 
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0 
    begin
        return 1
    end
    
    begin transaction tran_sp_MSpeertopeerfwdingexec
    save transaction tran_sp_MSpeertopeerfwdingexec

    -- only exec the command if we have been requested to do so
    if @execute = 1
    begin
        exec(@command)
        if @@error &lt;&gt; 0 
        begin
            goto FAILURE
        end
    end
    
    -- if this is not a republisher then we can just commit and exit
    if sys.fn_MSrepl_istranpublished(db_name(),0) = 0
    begin
        goto COMMIT_TRAN
    end

    /*
     * Here we begin to perform the fwding...
     */
            
    -- we will post this for the peer publication that is in 
    -- this database and matches the originator publication
    select @pubid = sp.pubid,
              @artid = min(sa.artid)
        from syspublications sp
            join sysextendedarticlesview sa
                on sp.pubid = sa.pubid
        where (sp.options &amp; @OPT_ENABLED_FOR_P2P) = @OPT_ENABLED_FOR_P2P
            and sp.name = @publication
        group by sp.pubid

    -- if we do not find a publication or article then we just do a no-op
    if @pubid is NULL
        or @artid is NULL
    begin
        goto COMMIT_TRAN
    end

    -- Here we will set the command type and command based on 
    -- wether or not we want to have the commands results proxied
    if @change_results_originator = 1
    begin
        -- in this case post as proxied cmd
        select @cmd_type = 42    -- REPL_PEERTOPEERPROXIEDCMD
    end
    else
    begin
        -- in this case post as forwarding cmd
        select @cmd_type = 43    -- REPL_PEERTOPEERFWDINGCMD
    end
    
    exec @retcode = sys.sp_replpostcmd 0, @pubid, @artid, @cmd_type, @command
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0 
    begin
        goto FAILURE
    end
   
COMMIT_TRAN:
    commit transaction tran_sp_MSpeertopeerfwdingexec
    return 0

FAILURE:
    -- An error occurred executing a Peer-To-Peer forwarding command.
    raiserror(20806, 16, -1)
    
    rollback transaction tran_sp_MSpeertopeerfwdingexec
    commit transaction tran_sp_MSpeertopeerfwdingexec

    return 1
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

