## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSprepare_mergearticle\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSprepare_mergearticle**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -267728737 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@source_owner| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_table| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@qualified_tablename| |nvarchar|270|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSprepare_mergearticle\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSprepare_mergearticle\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSprepare_mergearticle
    @source_owner    sysname,
    @source_table     sysname,         /* table name */
    @publication     sysname,
    @qualified_tablename     nvarchar(270)
as
    declare @retcode            int
    declare @id                 int
    declare @qualified_name     nvarchar(270)
    declare @pubid              uniqueidentifier
    declare @article_status     tinyint
    declare @snapshot_ready     tinyint
    declare @article sysname
        
    set nocount on

    -- Security check
    if 1 &lt;&gt; is_member('db_owner')
    begin
        raiserror(15247,-1,-1)
        return 1
    end
    
    -- Security check
    exec @retcode= dbo.sp_MSreplcheck_publish
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0 return (1)
    
    select @pubid = pubid, @snapshot_ready = snapshot_ready
    from dbo.sysmergepublications 
    where name=@publication and upper(publisher)=upper(publishingservername()) and publisher_db=db_name()
    
    select @qualified_name = QUOTENAME(@source_owner) + '.' + QUOTENAME(@source_table)
    select @id = object_id(@qualified_name)
        
    select top 1 @article_status = sma.status 
    from dbo.sysmergearticles sma join dbo.sysmergepublications smp
    on sma.pubid = smp.pubid
    where sma.objid = @id
    
    if @snapshot_ready = 2 or (@article_status &lt;&gt; 2 and @article_status &lt;&gt; 6)
    begin

        -- addguidcolumn needs to be called even if article is active. This is needed to 
        -- drop and recreate rowguid default constraint - to make it go back and forth 
        -- between newid() and newsequentialid().
        exec @retcode = sys.sp_MSaddguidcolumn @source_owner, @source_table
        if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
            return (1)
    end

    select @article_status = status, @article = name 
        from dbo.sysmergearticles where objid=@id and pubid=@pubid
        
    if (@article_status = 2 or @article_status = 6) and @snapshot_ready = 1
        return 0

    begin tran 
    save tran prep_merge_article
    
    exec @retcode = sys.sp_MSaddguidindex @publication, @source_owner, @source_table
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
        goto FAILURE
        
    exec @retcode = sys.sp_MSsetup_publisher_idrange @publication, @source_table, @source_owner
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
        goto FAILURE

    -- snapshot will separately call creating the triggers
    --exec @retcode = sys.sp_MSaddmergetriggers @qualified_tablename
    --if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
    --    goto FAILURE

    commit tran
    return 0

FAILURE:
    rollback tran prep_merge_article
    raiserror(20714, 10, -1, @article, @publication)
    return 1
    
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

