## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_deletemergeconflictrow\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_deletemergeconflictrow**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -268189240 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@conflict_table| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_object| |nvarchar|386|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@rowguid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@origin_datasource| |varchar|255|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@drop_table_if_empty| |varchar|10|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_deletemergeconflictrow\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_deletemergeconflictrow\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_deletemergeconflictrow(
    @conflict_table            sysname = '%',
    @source_object            nvarchar(386) = NULL,
    @rowguid                uniqueidentifier,
    @origin_datasource        varchar(255),
    @drop_table_if_empty    varchar(10) = 'false')
as
    declare @retcode        int
    declare @cmd            nvarchar(4000)    
    declare @rowguidstr        nvarchar(40)
    declare @object            sysname     
    declare @owner            sysname     
    declare @tablenick        int
    declare @tablenickstr    nvarchar(11)
    declare @escaped_origin_datasource varchar(511)

    -- Security check: dbo and sysadmin only
    exec @retcode = sys.sp_MSreplcheck_publish
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
    begin
        return 1
    end       

    set @rowguidstr = convert(nchar(36), @rowguid)
    set @escaped_origin_datasource = replace(@origin_datasource, '''', '''''')

    /* Delete conflict from Conflict_&lt;Table&gt; */
    if @conflict_table &lt;&gt; '%'
        begin
            select @cmd = 'delete '
            select @cmd = @cmd + quotename(@conflict_table) 
            select @cmd = @cmd + ' from ' + quotename(@conflict_table) + ' ct , MSmerge_conflicts_info info '
            select @cmd = @cmd + ' where info.origin_datasource = '''
            select @cmd = @cmd + @escaped_origin_datasource 
            select @cmd = @cmd + ''' and ct.rowguidcol = '''
            select @cmd = @cmd + @rowguidstr
            select @cmd = @cmd + ''' and info.rowguidcol = '''
            select @cmd = @cmd + @rowguidstr
            select @cmd = @cmd + 'ct.origin_datasource_id=info.origin_datasource_id '          
            select @cmd = @cmd + ''''

            -- DEBUG select 'Delete conflict_table query' = @cmd
            exec (@cmd)
            if @@ERROR&lt;&gt;0 return (1)

            select @cmd = 'delete from MSmerge_conflicts_info where origin_datasource = ''' + @escaped_origin_datasource + '''
                                and rowguid = ''' + @rowguidstr + ''''
            exec (@cmd)
            if @@ERROR&lt;&gt;0 return (1)

            if LOWER(@drop_table_if_empty collate SQL_Latin1_General_CP1_CS_AS) = 'true'
            begin
                select @cmd = 'if not exists (select 1 from ' 
                select @cmd = @cmd + quotename(@conflict_table) 
                select @cmd = @cmd + ')'
                select @cmd = @cmd + ' update dbo.sysmergearticles set ins_conflict_proc = NULL, conflict_table = NULL where conflict_table = ''' + quotename(@conflict_table) + ''''
                -- DEBUG select "Update conflict_table query" = @cmd
                exec (@cmd)
                if @@ERROR&lt;&gt;0 
                    return (1)
                
                select @cmd = 'if not exists (select 1 from ' 
                select @cmd = @cmd + quotename(@conflict_table)
                select @cmd = @cmd + ')'
                select @cmd = @cmd + ' drop table '
                select @cmd = @cmd + quotename(@conflict_table)
                select @cmd = @cmd + ''
                -- DEBUG select "Drop conflict_table query" = @cmd
                exec (@cmd)
                if @@ERROR&lt;&gt;0 return (1)
            end
        end
    /* Delete conflict from MSmerge_conflicts_info */
    else
        begin
            if @source_object is NULL
                begin
                    raiserror(14043, 16, -1, '@source_object', 'sp_deletemergeconflictrow')
                    return (1)
                end
            select @object = PARSENAME(@source_object, 1)
            select @owner = PARSENAME(@source_object, 2)
            execute @retcode=sys.sp_MStablenickname @owner, @object, @tablenick output
        
            if @tablenick IS NULL or @@ERROR&lt;&gt;0 or @retcode&lt;&gt;0
                BEGIN
                    raiserror (20003, 11, -1, @object)
                    RETURN (1)
                END

            set @tablenickstr = convert(nchar, @tablenick)

            
            select @cmd = 'delete from MSmerge_conflicts_info'
            select @cmd = @cmd + ' where origin_datasource = '''
            select @cmd = @cmd + @escaped_origin_datasource 
            select @cmd = @cmd + ''' and tablenick = '
            select @cmd = @cmd + @tablenickstr
            select @cmd = @cmd + ' and rowguid = '''
            select @cmd = @cmd + @rowguidstr
            select @cmd = @cmd + ''''
            -- DEBUG select 'MSMerge_Delete conflict_table query' = @cmd
            exec (@cmd)
            if @@ERROR&lt;&gt;0 return (1)

        end

GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

