## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSadd_subscriber_schedule\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSadd_subscriber_schedule**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -269356371 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscriber| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@agent_type| |smallint|2|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_type| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_interval| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_relative_interval| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_recurrence_factor| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_subday| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_subday_interval| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@active_start_time_of_day| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@active_end_time_of_day| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@active_start_date| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@active_end_date| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSadd_subscriber_schedule\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSadd_subscriber_schedule\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_MSadd_subscriber_schedule
(
    @publisher sysname,
    @subscriber sysname,
    @agent_type smallint = 0,   -- 0 for distribution agent, 1 for merge agent
    @frequency_type int = 4,
    @frequency_interval int = 1,
    @frequency_relative_interval int = 1,
    @frequency_recurrence_factor int = 0,
    @frequency_subday int = 4,
    @frequency_subday_interval int = 5,
    @active_start_time_of_day int = 0,
    @active_end_time_of_day int = 235959,
    @active_start_date int = 0,
    @active_end_date int = 99991231
)
AS
begin
   set nocount on
   declare @retcode int

    --
    -- security check
    -- only sysadmin can execute this
    --
    if (isnull(is_srvrolemember('sysadmin'),0) = 0) 
    begin
        raiserror(21089, 16, -1)
        return (1)
    end
    --
    -- security check
    -- Has to be executed from distribution database
    --
    if (sys.fn_MSrepl_isdistdb (db_name()) != 1)
    begin
        raiserror(21482, 16, -1, 'sp_MSadd_subscriber_schedule', 'distribution')
        return (1)
    end
    
       /* Add the subscriber to dbo.sysservers as a RPC server, if it does not
      ** already exist.
       */
       if not exists (select * from  master.dbo.sysservers where  UPPER(srvname) = UPPER(@subscriber))
    begin
          DECLARE @upper_subscriber sysname

        SELECT @upper_subscriber = UPPER(@subscriber collate database_default)
        
        exec @retcode = dbo.sp_addserver @upper_subscriber
        if @retcode &lt;&gt; 0
            return 1
    end

    /* only insert if it doesn't exist */
    if not exists (select * 
                from MSsubscriber_schedule 
                where UPPER(publisher) = UPPER(@publisher) 
                    and UPPER(subscriber) = UPPER(@subscriber) 
                    and agent_type = @agent_type)
    begin
           insert MSsubscriber_schedule (publisher, subscriber, agent_type, 
              frequency_type, frequency_interval, frequency_relative_interval,
              frequency_recurrence_factor, frequency_subday, frequency_subday_interval,
              active_start_time_of_day, active_end_time_of_day, active_start_date,
              active_end_date)
              
              values (@publisher, @subscriber, @agent_type, 
              @frequency_type, @frequency_interval, @frequency_relative_interval,
              @frequency_recurrence_factor, @frequency_subday, @frequency_subday_interval,
              @active_start_time_of_day, @active_end_time_of_day, @active_start_date,
              @active_end_date)
           if @@error &lt;&gt; 0
              return 1
    end
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

