## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_replmonitorhelppublicationthresholds\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_replmonitorhelppublicationthresholds**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -274284928 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication_type| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@thresholdmetricname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_replmonitorhelppublicationthresholds\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_replmonitorhelppublicationthresholds\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_replmonitorhelppublicationthresholds 
(
    @publisher sysname -- cannot be null
    ,@publisher_db sysname -- cannot be null
    ,@publication sysname -- cannot be null
    ,@publication_type int = NULL -- NULL for wildcard, 0 transactional 1 snapshot 2 merge    
    ,@thresholdmetricname sysname = NULL -- NULL for all entries
)
as
begin
    set nocount on
    declare @retcode int
        ,@publisher_id int
        ,@publication_id int

    --
    -- security check : replmonitor
    --
    if not (is_member(N'db_owner') = 1 or isnull(is_member(N'replmonitor'),0) = 1)
    begin
        raiserror(14260, 16, -1)
        return (1)
    end
    --
    -- security: Has to be executed from distribution database
    --
    if sys.fn_MSrepl_isdistdb (db_name()) != 1
    begin
        raiserror (21482, 16, -1, 'sp_replmonitorhelppublicationthresholds', 'distribution')
        return 1
    end
    --
    -- Validate @publisher
    --
    select @publisher_id = server_id
    from sys.servers 
    where upper(name) = upper(@publisher)
    if (@publisher_id is null)
    begin
        raiserror(21618, 16, -1, @publisher)
        return 1
    end
    --
    -- validate publication
    --
    if not exists (select publication_id
                        from dbo.MSpublications 
                        where publisher_id = @publisher_id
                            and publisher_db = @publisher_db
                            and publication = @publication
                            and publication_type= case when (@publication_type is null) then publication_type else @publication_type end)
    begin
        raiserror(20026, 16, 1, @publication)
        return 1
    end
    --
    -- validate metric
    --
    if (@thresholdmetricname is not null)
    begin
        if not exists (select metric_id
                from msdb.dbo.MSreplmonthresholdmetrics
                where title = lower(@thresholdmetricname))
        begin
            raiserror(14200, 16, 2, '@thresholdmetricname')
            return 1
        end
    end
    --
    -- prepare the resultset to display
    --
    if @publication_type IS null
    select t.metric_id, m.title, cast(t.value as int) as value, t.shouldalert, t.isenabled
    from (dbo.MSpublicationthresholds as t join dbo.MSpublications as p
        on t.publication_id = p.publication_id 
        and p.publisher_id = @publisher_id
        and p.publisher_db = @publisher_db
        and p.publication = @publication) 
        join         
        msdb.dbo.MSreplmonthresholdmetrics as m
        on t.metric_id = m.metric_id
        and m.title = case when (@thresholdmetricname is null) then m.title
                            else lower(@thresholdmetricname) end
    else
     select t.metric_id, m.title, cast(t.value as int) as value, t.shouldalert, t.isenabled
    from (dbo.MSpublicationthresholds as t join dbo.MSpublications as p
        on t.publication_id = p.publication_id 
        and p.publisher_id = @publisher_id
        and p.publisher_db = @publisher_db
        and p.publication = @publication and p.publication_type=@publication_type) 
        join         
        msdb.dbo.MSreplmonthresholdmetrics as m
        on t.metric_id = m.metric_id
        and m.title = case when (@thresholdmetricname is null) then m.title
                            else lower(@thresholdmetricname) end
    --
    -- return
    --
    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

