## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_check_sync_trigger\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_check_sync_trigger**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -27754508 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@trigger_procid| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@trigger_op| |char|10|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@owner| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_check_sync_trigger\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_check_sync_trigger\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_check_sync_trigger
(
    @trigger_procid int
    ,@trigger_op char(10) OUTPUT
    ,@owner sysname = null
)
as
begin
    declare @trigid int
    --
    -- Security check
    -- Make sure this proc is infact being called from the given object(trigger)
    -- 
    if (trigger_nestlevel(@trigger_procid) = 0)
    begin
        raiserror(14126, 16, 2)
        return -1
    end
    --
    -- Security check: the caller of this SP has to be one of the 
    -- predefined replication triggers defined in the db
    --
    if not exists (select so.object_id from (dbo.MSreplication_objects as ro join sys.objects as so
        on ro.object_name = so.name)
        where so.object_id = @trigger_procid and ro.object_type = 'T' 
        and (@owner is null or schema_name(so.schema_id) = @owner))
    begin
        raiserror(14126, 16, 3)
        return -1
    end
    --
    -- process
    --
    select @trigger_op = NULL
    select @trigid = so1.object_id from sys.objects so1, sys.objects so2 where
        so1.type = N'TR' and so1.name like N'trg_MSsync_ins_%' and so1.parent_object_id = so2.parent_object_id
        and so2.object_id = @trigger_procid
    
    -- if nestlevel of insert trigger on same table &gt; 0 then bail
    if trigger_nestlevel( @trigid ) &gt; 0
         return 1
    else
        return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

