## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSinsert_identity\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSinsert_identity**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -279933393 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@tablename| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@identity_support| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@pub_identity_range| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@identity_range| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@threshold| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@next_seed| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@max_identity| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSinsert_identity\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSinsert_identity\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_MSinsert_identity 
(
    @publisher             sysname,
    @publisher_db         sysname,
    @tablename             sysname,
    @identity_support    int,
    @pub_identity_range bigint,
    @identity_range     bigint,
    @threshold             int,
    @next_seed            bigint,
    @max_identity        bigint = NULL
) 
AS
begin
    declare @pub_seed         bigint    
    declare @current_max     bigint
    --
    -- security check
    -- only db_owner can execute this
    --
    if (is_member ('db_owner') != 1) 
    begin
        raiserror(14260, 16, -1)
        return (1)
    end
    --
    -- security check
    -- Has to be executed from distribution database
    --
    if (sys.fn_MSrepl_isdistdb (db_name()) != 1)
    begin
        raiserror(21482, 16, -1, 'sp_MSinsert_identity', 'distribution')
        return (1)
    end
    if not exists (select * from MSrepl_identity_range 
            where tablename=@tablename and LOWER(publisher)=LOWER(@publisher) and publisher_db=@publisher_db)
    begin
        select @pub_seed = @pub_identity_range + @next_seed
        select @current_max = @pub_seed - 1
        insert MSrepl_identity_range(publisher, publisher_db, tablename, identity_support, next_seed, pub_range, range, max_identity, threshold, current_max    )
                values (@publisher, @publisher_db, @tablename, @identity_support, @pub_seed,  @pub_identity_range, @identity_range, @max_identity, @threshold, @current_max)
        if @@ERROR&lt;&gt;0
            return 1
    end
    else if 1 &gt; 1 --disable this segment for now.
        begin --adjust republisher's resource table
            select @pub_seed = @pub_identity_range - 1
            /* update range, threshold at republisher as needed. Max and next_seed has been set already. */
            update MSrepl_identity_range set    range = @identity_range,
                                                pub_range = @pub_identity_range,
                                                threshold=@threshold, 
                                                next_seed=next_seed + @pub_identity_range,
                                                current_max=next_seed + @pub_seed --new next_seed not yet picked up
            where tablename=@tablename and LOWER(publisher)=LOWER(@publisher) and publisher_db=@publisher_db
            if @@ERROR&lt;&gt;0
                return (1)
        end
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

