## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSset_sub_guid\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSset_sub_guid**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -280603845 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscription_type| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscription_guid| |binary|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@queue_id| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@queue_server| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSset_sub_guid\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSset_sub_guid\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSset_sub_guid (
    @publisher      sysname,                    -- publishing server name
    @publisher_db   sysname,                    -- publishing database name. If NULL then same as current db
    @publication    sysname,                    -- publication name,
    @subscription_type int,
    @subscription_guid binary(16),
    @queue_id        sysname,
    @queue_server    sysname = NULL
)
AS
BEGIN
    set nocount on
    declare @retcode int
                ,@independent_agent bit
                ,@subqueue_id sysname

    --  Security Check
    EXEC @retcode = sys.sp_MSreplcheck_subscribe
    IF @@ERROR &lt;&gt; 0 or @retcode &lt;&gt; 0
        RETURN(1)

    -- For non independent agent publications
    if @publication is null or @publication = ''
    begin
        select @publication = 'ALL'
                ,@independent_agent = 0
    end
    else
        select @independent_agent = 1

    if @queue_id = N''
        select @queue_id = NULL

    if @queue_server = N''
        select @queue_server = NULL
    --
    -- Special processing when we are dealing with pull SQL queue updating subscription
    --
    if ((@subscription_type = 1) and substring(@queue_id, 1, 10) = N'mssqlqueue')
    begin
        --
        -- For SQL Queue case - Check the current queue_id on the table
        --
        select @subqueue_id = queue_id
        from dbo.MSsubscription_agents
        where UPPER(publisher) = UPPER(@publisher)
            and publisher_db =  @publisher_db
            and publication = @publication
            and subscription_type = @subscription_type
        if (@subqueue_id is not NULL and substring(@subqueue_id, 1, 10) = N'mssqlqueue')
        begin
            --
            -- Use the local Queue ID on subscriber as this contains the queue version. 
            -- We are attaching an initialized subscription and do not want to change the 
            -- queue version stored in queue_id for SQL Queues. The value passed by Distribution
            -- Agent is from the distributor metadata and does not contain the queue version information.
            -- This is specific to SQL Queues only.
            --
            select @queue_id = @subqueue_id
        end
    end
    --
    -- Update metadata in MSsubscription_agents
    --
    update MSsubscription_agents set      
        queue_id = @queue_id
        ,queue_server = @queue_server
    where UPPER(publisher) = UPPER(@publisher)
    and publisher_db =  @publisher_db
    and publication = @publication
    and subscription_type = @subscription_type

    update MSreplication_subscriptions set      
        [time] = getdate(),
        subscription_guid = @subscription_guid
    where UPPER(publisher) = UPPER(@publisher)
        and publisher_db =  @publisher_db
        and (@independent_agent = 0 or publication = @publication)
        and subscription_type = @subscription_type
        and independent_agent = @independent_agent
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

