## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_helpdbfixedrole\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_helpdbfixedrole**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -284265562 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@rolename| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|DbFixedRole|nvarchar|128|
|Description|nvarchar|35|

|Name |Datatype |Max length |
|-|-|-|
|DbFixedRole|nvarchar|128|
|Description|nvarchar|35|

---
### Objects that depend on \[sys\].\[sp_helpdbfixedrole\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_helpdbfixedrole\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_helpdbfixedrole
    @rolename        sysname = NULL
AS
    if @rolename is not null
    begin
        -- VALIDATE GIVEN NAME
        if not exists (select * from sys.database_principals where name = @rolename
                        and principal_id &gt;= 16384 and principal_id &lt;= 16393)
        begin
            raiserror(15412, -1, -1, @rolename)
            return (1)
        end

        -- RESULT SET FOR SINGLE FIXED-ROLE
        select 'DbFixedRole' = u.name, 'Description' = p.name collate catalog_default
            from sys.database_principals u, sys.role_permissions p
            where u.name = @rolename and
                  u.principal_id &gt;= 16384 and
                  u.principal_id &lt;= 16393 and
                  p.number = u.principal_id and p.type = 'DBR' and p.low = 0
    end
    else
    begin
        -- RESULT SET FOR ALL FIXED-ROLES
        select 'DbFixedRole' = u.name, 'Description' = p.name collate catalog_default
            from sys.database_principals u, sys.role_permissions p
            where u.principal_id &gt;= 16384 and
                  u.principal_id &lt;= 16393 and
                  p.number = u.principal_id and p.type = 'DBR' and p.low = 0
    end

    return (0) -- sp_helpdbfixedrole
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

