## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSdropconstraints\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSdropconstraints**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -285389157 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@table| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@owner| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSdropconstraints\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSdropconstraints\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
-- This will be called merge at the subscriber side, check for dbo permission
create procedure sys.sp_MSdropconstraints
    @table sysname,
    @owner sysname = null
as
    declare @const_name nvarchar(258)
    declare @objid int
    declare @retcode int
    declare @qualified_tablename   nvarchar(517)
    declare @quoted_tablename   nvarchar(270)
    declare @quoted_ownername   nvarchar(270)
    
    /*
    ** Check for subscribing permission
    */
    exec @retcode=sys.sp_MSreplcheck_subscribe
    if @retcode&lt;&gt;0 or @@ERROR&lt;&gt;0 return (1)

    select @quoted_tablename = quotename(@table)
    
    if @owner is not NULL
    begin
        set @quoted_ownername = QUOTENAME(@owner)
        set @qualified_tablename= @quoted_ownername + '.' + @quoted_tablename
    end
    else
        set @qualified_tablename= @quoted_tablename
    
    set @objid = object_id(@qualified_tablename)
    if @objid is null
    begin
        if @owner is null
        begin
            select @objid = object_id from sys.objects 
                where name=@quoted_tablename
        end
        else
        begin
            select @objid = object_id from sys.objects 
                where name=@quoted_tablename and schema_name(schema_id)=@quoted_ownername
        end
    end
    if @objid is NULL
        return (1)

    select @const_name = QUOTENAME(object_name(object_id)) from 
        sys.foreign_keys where parent_object_id = @objid

    while @const_name is not null
    begin
        exec ('alter table ' + @qualified_tablename +
            ' drop constraint ' + @const_name)
        if @@ERROR &lt;&gt; 0
            return (1)
        set @const_name = NULL
        select @const_name = QUOTENAME(object_name(object_id)) from 
            sys.foreign_keys where parent_object_id = @objid
    end

    return (0)      
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

