## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_articlecolumn\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_articlecolumn**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -285882959 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@article| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@column| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@operation| |nvarchar|5|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@refresh_synctran_procs| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@ignore_distributor| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@change_active| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@force_invalidate_snapshot| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@force_reinit_subscription| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@internal| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_articlecolumn\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_articlecolumn\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_articlecolumn (
        @publication sysname,           /* The publication name */
        @article sysname,               /* The article name */
        @column sysname = NULL,         /* The column name */
        @operation nvarchar(5) = N'add'      /* Add or delete a column */
        -- synctran
        , @refresh_synctran_procs bit = 1      -- refresh synctran procs or not
        , @ignore_distributor bit = 0
        -- DDL
        , @change_active int = 0
        , @force_invalidate_snapshot bit = 0    /* Force invalidate existing snapshot */
        , @force_reinit_subscription bit = 0    /* Force reinit subscription */
        , @publisher    sysname = NULL
        -- Peer-To-Peer
        , @internal bit = 0
        ) 
AS
BEGIN
    DECLARE @cmd            nvarchar(4000)
    DECLARE @cmd2            nvarchar(4000)
    DECLARE @retcode        int
    DECLARE    @publisher_type    sysname
    DECLARE    @publisher_dbms    sysname
    DECLARE    @publisher_version sysname
    
    SET @retcode = 0
    
    EXEC @retcode = sys.sp_MSrepl_getpublisherinfo    @publisher        = @publisher,
                                                    @rpcheader        = @cmd OUTPUT,
                                                    @publisher_type    = @publisher_type OUTPUT
    
    IF @retcode &lt;&gt; 0
        RETURN (@retcode)
        
    SET @publisher = UPPER(@publisher) COLLATE DATABASE_DEFAULT

    IF @publisher_type = N'MSSQLSERVER'
    BEGIN    
        -- Add sp
        set @cmd = @cmd + N'sys.sp_MSrepl_articlecolumn'
    
        EXEC @retcode = @cmd
                    @publication,
                    @article,
                    @column,
                    @operation,
                    @refresh_synctran_procs,
                    @ignore_distributor,
                    @change_active,
                    @force_invalidate_snapshot,
                    @force_reinit_subscription,
                    @internal
    END
    ELSE
    BEGIN

        -- Set publisher DBMS and version (for getting default data type mapping)
        SELECT    @publisher_dbms        = 'ORACLE'

        set @cmd2 = @cmd + N'sys.sp_IHgetversion'
        EXEC @retcode = @cmd2
                    @publisher    = @publisher,
                    @version    = @publisher_version OUTPUT

        IF @retcode != 0 OR @@ERROR != 0
        BEGIN
            RETURN (1)
        END

        -- Add sp
        set @cmd2 = @cmd + N'sys.sp_IHarticlecolumn'
    
        EXEC @retcode = @cmd2
                    @publication,
                    @article,
                    @column,
                    @operation,
                    @refresh_synctran_procs,
                    @ignore_distributor,
                    @change_active,
                    @force_invalidate_snapshot,
                    @force_reinit_subscription,
                    @publisher,
                    @publisher_type,
                    @publisher_dbms,
                    @publisher_version

    END

    RETURN (@retcode)
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

