## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSupdatecachedpeerlsn\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSupdatecachedpeerlsn**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -286307514 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@type| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@agent_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@originator| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@originator_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@originator_publication_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@originator_db_version| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@originator_lsn| |varbinary|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSupdatecachedpeerlsn\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSupdatecachedpeerlsn\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSupdatecachedpeerlsn
(
    @type                        int,        -- 1-insert/update, 2-clear
    @agent_id                    int,
    @originator                    sysname = NULL,
    @originator_db                sysname = NULL,
    @originator_publication_id    int = NULL,
    @originator_db_version        int = NULL,
    @originator_lsn                varbinary(16) = NULL
)
as
begin
    declare @retcode bit

    -- security check - the distribution agent must have access
    exec @retcode = sys.sp_MScheck_pull_access @agent_id = @agent_id, @agent_type = 0
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
    begin
        return 1
    end
    
    if @type not in (0, 1, 2)
    begin
        -- Invalid '@type' value for stored procedure 'sys.sp_MSupdatecachedpeerlsn'.
        raiserror(20587, 16, -1, '@type', 'sys.sp_MSupdatecachedpeerlsn')
        return 1
    end

    begin tran t_MScached_peer_lsns
    
    -- insert/update row
    if @type = 1
    begin
        update MScached_peer_lsns
            set originator_lsn = @originator_lsn
            where agent_id                         = @agent_id
                and UPPER(originator)             = UPPER(@originator)
                and originator_db                 = @originator_db
                and originator_publication_id     = @originator_publication_id
                and originator_db_version         = @originator_db_version
        if @@rowcount &lt; 1
        begin
            insert into MScached_peer_lsns
            (
                agent_id, 
                originator, 
                originator_db,
                originator_publication_id,
                originator_db_version,
                originator_lsn
            )
            values
            (
                @agent_id, 
                UPPER(@originator), 
                @originator_db,
                @originator_publication_id,
                @originator_db_version,
                @originator_lsn
            )
            if @@rowcount &lt; 1 or @@error &lt;&gt; 0
                goto FAILURE
        end
        
        if @@error &lt;&gt; 0
        begin
            -- The distribution agent was unable to update the cached lsns for Originator:%s OriginatorDB:%s OriginatorDBVersion:%d OriginatorPublicationID:%d.
            raiserror(21680, 16, -1, @originator, @originator_db, @originator_db_version, @originator_publication_id)
            goto FAILURE
        end
    end
    -- clear cache for the specified agent
    else if @type = 2
    begin
        delete from MScached_peer_lsns 
            where agent_id = @agent_id
        if @@error &lt;&gt; 0
                   goto FAILURE
    end
    
    commit transaction t_MScached_peer_lsns

    return 0
FAILURE:
    if @@trancount &gt; 0
        rollback transaction t_MScached_peer_lsns

    -- The procedure sys.sp_MSupdatecachedpeerlsn failed to UPDATE the resource MScached_peer_lsns Server error =  21499.
    raiserror (21499, 16, -1, 'sys.sp_MSupdatecachedpeerlsn', 'UPDATE', 'MScached_peer_lsns', @@error)
       return 1
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

