## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSinsertschemachange\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSinsertschemachange**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -290422493 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@pubid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@artid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@schemaversion| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@schemaguid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@schematype| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@schematext| |nvarchar|1073741823|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@schemasubtype| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@update_schemaversion| |tinyint|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSinsertschemachange\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSinsertschemachange\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_MSinsertschemachange(
    @pubid          uniqueidentifier,
    @artid          uniqueidentifier = NULL, /* Can be NULL for directory commands */
    @schemaversion  int,
    @schemaguid     uniqueidentifier,
    @schematype     int,
    @schematext     nvarchar(max),
    @schemasubtype      int = 0,
    @update_schemaversion tinyint = 1
    )
as
    declare @retcode            int
    declare @constraintname     sysname 
    declare @owner              sysname
    declare @tablename          sysname
    declare @qualname           nvarchar(270)
    declare @objid              int
    declare @alter_table_type   int
    declare @subid    uniqueidentifier
    
    /*
    ** Check for subscribing permission
    */
    exec @retcode=sys.sp_MSreplcheck_subscribe
    if @retcode&lt;&gt;0 or @@ERROR&lt;&gt;0 return (1)
    
    select @alter_table_type = 11
    
    /* Parameter validation */
    if (@schemaversion is null)
        begin
        RAISERROR(14043, 16, -1, '@schemaversion', 'sp_MSinsertschemachange')
        return (1)
        end

    /*
    ** Special case: for push subscription, reinit-with-upload, we do not want to cleanup subscriber side
    ** cause we need to upload; however we still need to apply alter-table. To avoid duplicate key insert
    ** failure, we no-OP this insert of alter-table schema.
    */
    if @schematype=@alter_table_type and exists 
        (select * from dbo.sysmergeschemachange where pubid=@pubid and schemaversion=@schemaversion)
        return (1)

    begin transaction tran_sp_MSinsertschemachange
    save transaction tran_sp_MSinsertschemachange
        
    if not exists (select * from dbo.sysmergeschemachange with (HOLDLOCK TABLOCKX)
                where pubid=@pubid and artid=@artid and 
                      schemaversion=@schemaversion and schemaguid = @schemaguid and 
                      schematype = @schematype)
    begin
        insert into dbo.sysmergeschemachange with (HOLDLOCK TABLOCKX)
        (pubid, artid, schemaversion, schemaguid, schematype, schematext, schemasubtype)
                 values (@pubid, @artid, @schemaversion, @schemaguid, @schematype, @schematext, @schemasubtype) 
    end
    else
    begin
        update dbo.sysmergeschemachange with (HOLDLOCK TABLOCKX)
            set schematext = @schematext 
            where pubid=@pubid and artid=@artid and 
                      schemaversion=@schemaversion and schemaguid = @schemaguid and 
                      schematype = @schematype
    end
    if @@error &lt;&gt; 0     
    begin
        rollback transaction tran_sp_MSinsertschemachange
        commit transaction
        RAISERROR(21305 , 16, -1)
        return (1)
    end
    
    /* update the schema version and schemaguid in dbo.sysmergesubscriptions - The following servername is used as a publishing server name */      
    if @update_schemaversion = 1
    begin
        select @subid = subid from dbo.sysmergesubscriptions 
            where UPPER(subscriber_server) collate database_default = UPPER(publishingservername()) collate database_default
               and db_name = DB_NAME() and pubid = @pubid

        update dbo.sysmergesubscriptions set schemaversion = @schemaversion, schemaguid = @schemaguid
            where subid = @subid and (schemaversion&lt;@schemaversion or schemaversion is NULL)
        if @@error &lt;&gt; 0     
            begin
            rollback transaction tran_sp_MSinsertschemachange
            commit transaction
            RAISERROR(21305 , 16, -1)
            return (1)
        end
    end    
    commit transaction
    return (0)      
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

