## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSregenerate_mergetriggersprocs\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSregenerate_mergetriggersprocs**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -292026174 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@pubid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSregenerate_mergetriggersprocs\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSregenerate_mergetriggersprocs\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSregenerate_mergetriggersprocs(
    @pubid uniqueidentifier)
as
begin
    declare @publication sysname
    , @publisher sysname
    , @publisher_db sysname
    , @retcode int
    , @artid uniqueidentifier
    , @prev_artid uniqueidentifier
    , @article sysname
    , @snapshot_ready tinyint
    , @local_pub bit
    
    -- security check
    exec @retcode = sys.sp_MSreplcheck_subscribe
    if @retcode&lt;&gt;0 or @@ERROR&lt;&gt;0
        return 1
    
    select @publication = name, @publisher = publisher, @publisher_db = publisher_db, @snapshot_ready = snapshot_ready 
    from dbo.sysmergepublications
    where pubid = @pubid
    
    if @publication is null
    begin
        return 1
    end

    select @local_pub = sys.fn_MSmerge_islocalpubid(@pubid)

    -- for a local publication if the snapshot is not ready there is not need to regenerate this since the snapshot will
    -- be made ready when the snaphsot is run and the snapshot will regenerate the procs and triggers.
    if @local_pub = 1 and @snapshot_ready &lt;&gt; 1
        return 0
    
    exec @retcode = sys.sp_MSregenerate_mergetriggers @publication, @publisher, @publisher_db
    if @@error&lt;&gt;0 OR @retcode&lt;&gt;0 
    begin
        return 1
    end 
    
    -- Call sp_MSsetartprocs if running on publisher. Else, call sp_MSmakearticleprocs.
    if @local_pub = 1
    begin
        -- at publisher
        select top 1 @artid = artid, @article = name from sysmergearticles where pubid = @pubid order by artid
        while @artid is not null
        begin
            exec @retcode = sys.sp_MSsetartprocs @publication=@publication, @article=@article, 
                                                 @force_flag=0, @pubid=@pubid
            if @@error&lt;&gt;0 OR @retcode&lt;&gt;0 
            begin
                return 1
            end 
            
            select @prev_artid = @artid
            select @artid = NULL
            
            select top 1 @artid = artid, @article = name from sysmergearticles where pubid = @pubid and artid &gt; @prev_artid order by artid
        end
    end
    else
    begin
        -- at subscriber
        select top 1 @artid = artid, @article = name from sysmergearticles where pubid = @pubid order by artid
        while @artid is not null
        begin
            exec @retcode = sys.sp_MSmakearticleprocs @pubid, @artid, 1
            if @@error&lt;&gt;0 OR @retcode&lt;&gt;0 
            begin
                return 1
            end 
            
            select @prev_artid = @artid
            select @artid = NULL
            
            select top 1 @artid = artid, @article = name from sysmergearticles where pubid = @pubid and artid &gt; @prev_artid order by artid
        end
    end
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

