## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_cdc_generate_wrapper_function\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_cdc_generate_wrapper_function**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -293460303 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@capture_instance| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@closed_high_end_point| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@column_list| |nvarchar|1073741823|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@update_flag_list| |nvarchar|1073741823|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_cdc_generate_wrapper_function\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_cdc_generate_wrapper_function\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure [sys].[sp_cdc_generate_wrapper_function]                  
(                                                        
    @capture_instance        sysname = null,
    @closed_high_end_point  bit = 1,
    @column_list            nvarchar(max) = null,
    @update_flag_list        nvarchar(max) = null
)                                                        
as
begin
    set nocount on
    
    declare @retcode int,
        @capture_cnt int,
        @object_id int,
        @quoted_change_table nvarchar(260),
        @db_name sysname
        
    set @quoted_change_table  = N'[cdc].' + quotename(@capture_instance + N'_CT')
    set @db_name = db_name()
        
    -- Verify database is currently enabled for change data capture
    if ([sys].[fn_cdc_is_db_enabled]() != 1)
    begin
        raiserror(22901, 16, -1, @db_name)
        return 1
    end
    
    create table #capture_instances
    (
        capture_instance sysname collate database_default null,
        object_id int null
    )
    
    create table #create_scripts
    (
        function_name nvarchar(145) collate database_default null,
        create_script nvarchar(max) collate database_default null
    )
    
    if (@capture_instance is null) or (rtrim(@capture_instance) = N'')
    begin
        -- If the capture instance is not specified, the @column_list and
        -- @update_flag_list parameters must both be null
        if (@column_list is not null) or (@update_flag_list is not null)
        begin
            raiserror(22921, 16, -1)
            return 1
        end

        -- Get a list of potential capture instances. 
        exec @retcode = sys.sp_cdc_get_capture_instances null, null
        
        if @retcode &lt;&gt; 0
        begin
            return 1
        end
    end
    else
    begin
        -- Get a list of potential capture instances. 
        exec @retcode = sys.sp_cdc_get_capture_instances null, null
        
        if @retcode &lt;&gt; 0
        begin
            return 1
        end
    
        -- If the capture instance is specified, it must exist
        if not exists (
            select capture_instance
            from #capture_instances
            where capture_instance = @capture_instance
        )    
        begin
            raiserror(22920, 16, -1, @capture_instance, @db_name)
            return 1
        end
        
        -- Remove all entries except the one for the named instance
        delete from #capture_instances
        where capture_instance &lt;&gt; @capture_instance
    end
    
    if (@closed_high_end_point is null)
    begin
        set @closed_high_end_point = 1
    end
    
    -- Eliminate from the list any entries that the caller is not
    -- authorized to access
    delete from #capture_instances
    where sys.fn_cdc_has_select_access(capture_instance) = 0
    
    -- If there are no elements in #capture_instances and
    -- an explicit capture instance was entered, return error
    select @capture_cnt = count(*) from #capture_instances
    
    if (@capture_cnt = 0) and (@capture_instance is not null)
    begin
        raiserror(22981, 16, -1)
        return 1 
    end
    
    -- Generate wrapper for the capture instances 
    exec sys.sp_cdc_generate_wrapper_function_internal                  
        @closed_high_end_point
        ,@column_list
        ,@update_flag_list
        
    select function_name, create_script from #create_scripts    

    return 0
end                                                                
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

