## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_cdc_restoredb\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_cdc_restoredb**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -29528818 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@srv_orig| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@db_orig| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@keep_cdc| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_cdc_restoredb\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_cdc_restoredb\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure [sys].[sp_cdc_restoredb]
(
    @srv_orig sysname,
    @db_orig sysname,
    @keep_cdc int
)
as
begin
    set nocount on

    declare @retcode int

    --
    -- Security Check: RESTORE statement requires sysadmin, dbcreator, or 
    --                 dbo (THE dbo, not just any member of the db_owner 
    --                 role.)               
    --
    if (ISNULL(IS_SRVROLEMEMBER('sysadmin'),0) = 0) 
       and (ISNULL(IS_SRVROLEMEMBER('dbcreator'),0) = 0)
       and (ISNULL(IS_MEMBER('db_owner'),0) = 0)
    begin
        raiserror(18799, 16, -1) 
        return 1
    end
    
    exec @retcode = sys.sp_cdc_restoredb_internal @srv_orig
        , @db_orig
        , @keep_cdc
        
    if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
    begin
        return 1
    end
    
    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

