## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_adddatatype\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_adddatatype**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -298952763 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@dbms| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@version| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@type| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@createparams| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_adddatatype\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_adddatatype\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

--
-- Name:
--        sp_adddatatype
--
-- Description:
--        Add DBMS data type as an available type
--
-- Returns:
--        0 if successful
--        1 if failed
--
-- Security:
--        public
--
-- Notes:
--        Implicitly will create a DBMS if it doesn't currently exist.
--

CREATE PROCEDURE sys.sp_adddatatype
(
    @dbms            sysname,
    @version        sysname = NULL,
    @type            sysname,
    @createparams    int = 0
)
AS
BEGIN
    DECLARE @dbms_id int

    SET NOCOUNT ON

    --
    -- Security Check: require sysadmin
    --
    IF (ISNULL(IS_SRVROLEMEMBER('sysadmin'),0) = 0)
    BEGIN
        RAISERROR(21089,16,-1) 
        RETURN (1)
    END

    -- Prepare dbms for case insensitive searches
    SET @dbms = UPPER(@dbms)

    BEGIN TRAN
    SAVE TRAN adddatatype
    
    -- Get DBMS id
    SELECT    @dbms_id = dbms_id
    FROM    msdb.dbo.MSdbms
    WHERE    dbms    = @dbms
      AND    version = @version

    IF @dbms_id IS NULL OR @@ERROR &lt;&gt; 0
    BEGIN
        -- Add new DBMS
        INSERT INTO msdb.dbo.MSdbms (dbms, version)
        VALUES (@dbms, @version)
        
        IF @@ERROR &lt;&gt; 0
        BEGIN
            IF @@TRANCOUNT &gt; 0
            BEGIN
                ROLLBACK TRANSACTION adddatatype
                COMMIT TRAN
            END
            RETURN (1)
        END
        
        SELECT @dbms_id = IDENT_CURRENT('msdb.dbo.MSdbms')
    END

    -- Verify data type doesn't already exist
    IF EXISTS
    (
        SELECT    datatype_id
        FROM    msdb.dbo.MSdbms_datatype
        WHERE    dbms_id    = @dbms_id
          AND    UPPER(type COLLATE DATABASE_DEFAULT) =
            UPPER(@type) COLLATE DATABASE_DEFAULT
    )
    BEGIN
        RAISERROR (21655, 16, -1, @type)
        
        IF @@TRANCOUNT &gt; 0
        BEGIN
            ROLLBACK TRANSACTION adddatatype
            COMMIT TRAN
        END
        RETURN (1)
    END
        
    -- Add data type
    INSERT INTO msdb.dbo.MSdbms_datatype (dbms_id, type, createparams)
    VALUES (@dbms_id, @type, @createparams)

    IF @@ERROR &lt;&gt; 0
    BEGIN
        IF @@TRANCOUNT &gt; 0
        BEGIN
            ROLLBACK TRANSACTION adddatatype
            COMMIT TRAN
        END
        RETURN (1)
    END
    
    COMMIT TRAN
    RETURN (0)        
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

