## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_droplogin\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_droplogin**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -303177665 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@loginame| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_droplogin\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_droplogin\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_droplogin
    @loginame sysname
as
    -- SETUP RUNTIME OPTIONS / DECLARE VARIABLES --
    set nocount on
    declare @exec_stmt nvarchar(4000)
    declare @ret int

    -- DISALLOW USER TRANSACTION --
    set implicit_transactions off
    IF (@@trancount &gt; 0)
    begin
        raiserror(15002,-1,-1,'sys.sp_droplogin')
        return (1)
    end

    -- VALIDATE LOGIN NAME:
    execute @ret = sys.sp_validname @loginame
    if (@ret &lt;&gt; 0)
        return (1)

    -- CHECK IT'S A SQL LOGIN --
    if (not exists (select * from master.dbo.syslogins where
                    loginname = @loginame and isntname = 0))
    begin
        raiserror(15007,-1,-1,@loginame)
        return(1)
    end

    set @exec_stmt = 'drop login ' + quotename(@loginame)

    exec (@exec_stmt)    

    if @@error &lt;&gt; 0
        return (1)

    -- SUCCESS MESSAGE --
    return (0)    -- sp_droplogin
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

