## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSget_min_seqno\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSget_min_seqno**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -30533397 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@agent_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@xact_seqno| |varbinary|16|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSget_min_seqno\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSget_min_seqno\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_MSget_min_seqno
(
    @agent_id int,
    @xact_seqno varbinary(16) OUTPUT
)
as
BEGIN
    declare @publisher_db_id int,
        @publisher sysname, 
        @publisher_dbname sysname,
        @publication_id int,
        @dbversion int,
        @publication sysname, 
        @retcode int,
        @IsP2PAgent bit,
        @nosync_type tinyint

    --
    -- Security Check
    -- 
    if @agent_id is not null
    begin
        exec @retcode = sys.sp_MScheck_pull_access
            @agent_id = @agent_id,
            @agent_type = 0 -- distribution agent
        if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
            return (1)
    end
    else
    begin
        return (1)
    end

    --exec sys.sp_MSispeertopeeragent @agent_id = @agent_id, @is_p2p = @IsP2PAgent output

    --if @@error &lt;&gt; 0 or @IsP2PAgent &lt;&gt; 0
    --begin
    --    return (1)
    --end

   select @publisher_db_id = publisher_database_id
   from MSdistribution_agents
   where id = @agent_id             

    if @publisher_db_id is null
        return (1)

   --MSsubscriptions has a clustered unique key (agent_id, article_id). For one agent_id, there may
   --be multiple article_id. However, all rows with the same @agent_id should have a same value on nosync_type
   select @nosync_type = nosync_type
   from MSsubscriptions
   where agent_id = @agent_id

    if @nosync_type != 3
    begin
        -- In the case where we have a different nosync type, this tells
        --  the distribution agent that can begin replication.
        -- This should be removed in the future.
        select @xact_seqno = 0x00000000000000000001
        return (0)
    end

    select top 1 @xact_seqno = xact_seqno 
        from MSrepl_transactions msrt 
            where msrt.publisher_database_id=@publisher_db_id
            order by xact_seqno asc

    return(0)
END

--
-- Name: sp_MSget_repl_commands
--
-- Descriptions: Note: sp_MSget_repl_commands and sp_MSget_repl_count have very similar
--  queries. Any changes to one of them should be applied to all others.
--
-- Parameters: as defined in create statement
--
-- Returns: 0 - success
--          1 - Otherwise
--
-- BUGBUG: If resource db support does not improve - this SP should be moved back
-- to instdist.sql for supportability. It accesses system catalogs
-- 
-- Security: Public procedure invoked via RPC. PAL check
-- Requires Certificate signature for catalog access
--
raiserror(15339,-1,-1,'sp_MSget_repl_commands')
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

