## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSdist_adjust_identity\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSdist_adjust_identity**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -307602345 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@agent_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@tablename| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSdist_adjust_identity\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSdist_adjust_identity\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_MSdist_adjust_identity
(
    @agent_id int,
    @tablename sysname
)
as
begin
    declare @publisher sysname
    declare @publisher_db sysname
    declare @publisher_id smallint
    declare @publication sysname
    declare @next_seed bigint
    declare @range bigint
    declare @threshold int
    declare @retcode int

    -- Security check.
    exec @retcode = sys.sp_MScheck_pull_access
        @agent_id = @agent_id,
        @agent_type = 0 -- distribution agent
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
        return (1)

    select @publication = publication, @publisher_id = publisher_id,
        @publisher_db = publisher_db from MSdistribution_agents where
        id = @agent_id

    select @publisher = srvname from master.dbo.sysservers where 
        srvid = @publisher_id
    -- Get the publication id.
    -- Note: auto identity range is only supported for queued tran pub
    -- which implies independent agent.
    declare @publication_id int
    select @publication_id = publication_id from dbo.MSpublications    where
        publication =  @publication and
        publisher_id = @publisher_id and
        publisher_db = @publisher_db

    -- Get the source object name
    declare @src_object sysname
    select @src_object = source_object from MSarticles where
        publication_id = @publication_id and
        destination_object = @tablename

    if @src_object is not null
    begin
        exec @retcode = sys.sp_MSfetchAdjustidentityrange
            @publisher = @publisher,
            @publisher_db = @publisher_db,
            @tablename = @src_object,
            @adjust_only = 1,
            @for_publisher = 0,
            @next_seed = @next_seed output,
            @range = @range output,
            @threshold = @threshold output
        if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
            return 1
    end

    -- Return nothing if the table is not found in the table collection served by
    -- the distribution agent.
    select 'next_seed' = @next_seed, 'range' = @range, 'threshold' = @threshold
        where @next_seed is not null 
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

