## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_setapprole\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_setapprole**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -307614281 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@rolename| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@password| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@encrypt| |varchar|10|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@fCreateCookie| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@cookie| |varbinary|8000|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_setapprole\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_setapprole\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_setapprole
    @rolename   sysname,        -- name app role
    @password   sysname,        -- password for app role
    @encrypt    varchar(10)    = 'none',         -- Encryption style ('none' | 'odbc')
    @fCreateCookie bit = 0,
    @cookie varbinary(8000) = 0xFFFFFFFF OUTPUT
as
    -- SETUP RUNTIME OPTIONS / DECLARE VARIABLES --
    set nocount on

    -- DISALLOW USER TRANSACTION --
    set implicit_transactions off
    if (@@trancount &gt; 0)
    begin
        raiserror(15002,-1,-1,'sys.sp_setapprole')
        return (1)
    end

    -- CHECK PARAMETER
    if (@rolename is null)
    begin
        raiserror(15431,-1,-1)
        return (1)
    end

    -- VALIDATE ENCRYPTION
    declare @encrStyle int
    select @encrStyle = case lower(@encrypt) when 'none' then 0 when 'odbc' then 1 else null end
    if (@encrStyle is null)
    begin
        raiserror(15600,-1,-1,'sys.sp_setapprole')
        return (1)
    end

    -- SP MUST BE CALLED AT ADHOC LEVEL --
    if (@@nestlevel &gt; 1)
    begin
        raiserror(15422,-1,-1)
        return (1)
    end

    -- ACTIVATE APPROLE (THIS IS ONLY VALID FROM THIS SP!) --
    if (@fCreateCookie = 1)
        setuser @rolename, @password, @encrStyle, @cookie
    else
        setuser @rolename, @password, @encrStyle

    -- RETURN SUCCESS/FAILURE --
    if (@@error &lt;&gt; 0)
        return (1)
    return (0)    -- sp_setapprole
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

