## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_dbremove\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_dbremove**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -312159816 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@dbname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@dropdev| |varchar|10|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_dbremove\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_dbremove\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_dbremove --- 1996/04/08 00:00
    @dbname sysname = null,
    @dropdev varchar(10) = null
as
    declare @dbid int
    declare @devname sysname
    declare @physname varchar(255)

    if (SERVERPROPERTY('IsMatrix') = 1)
    begin
        raiserror (28401, -1, -1, N'sys.sp_dbremove')
        return (1)
    end

    if @dbname is null
    begin
        raiserror(15131,-1,-1)
        return(1)
    end

    if lower(@dropdev) &lt;&gt; 'dropdev' and @dropdev is not null
    begin
        raiserror(15131,-1,-1)
        return(1)
    end

    -- You must be SA to execute this sproc.
    if (not (is_srvrolemember('sysadmin') = 1))
    begin
        raiserror(15247,-1,-1)
        return(1)
    end

    -- Make sure not trying to remove within a transaction.
    set implicit_transactions off
    if @@trancount &gt; 0
    begin
        raiserror(15002,-1,-1,'sys.sp_dbremove')
        return(1)
    end

    -- Check to see if database exists.
    select @dbid = dbid from master.dbo.sysdatabases where name=@dbname
    if @dbid is null
    begin
        raiserror(15010,-1,-1,@dbname)
        return(1)
    end

    -- Make sure no one is in the db.
    if (select count(*) from master.dbo.sysprocesses where dbid = @dbid) &gt; 0
    begin
        raiserror(15069,-1,-1)
        return (1)
    end

    -- Note: database @dbname may not exist anymore
    -- If invoke gets error, exception will abort this proc.
    EXEC %%DatabaseRef(Name = @dbname).SetSuspect(Value = 1)

    declare @dropCmd nvarchar(max)

    select @dropCmd = 'drop database ' + quotename(@dbname)
    exec (@dropCmd)
    raiserror(15458,-1,-1)

    return(0)    -- sp_dbremove
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

