## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_foreign_keys_rowset_rmt\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_foreign_keys_rowset_rmt**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -315464848 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@server_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@pk_table_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@pk_table_schema| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@pk_table_catalog| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@foreignkey_tab_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@foreignkey_tab_schema| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@foreignkey_tab_catalog| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|PK_TABLE_CATALOG|nvarchar|128|
|PK_TABLE_SCHEMA|nvarchar|128|
|PK_TABLE_NAME|nvarchar|128|
|PK_COLUMN_NAME|nvarchar|128|
|PK_COLUMN_GUID|uniqueidentifier|16|
|PK_COLUMN_PROPID|int|4|
|FK_TABLE_CATALOG|nvarchar|128|
|FK_TABLE_SCHEMA|nvarchar|128|
|FK_TABLE_NAME|nvarchar|128|
|FK_COLUMN_NAME|nvarchar|128|
|FK_COLUMN_GUID|uniqueidentifier|16|
|FK_COLUMN_PROPID|int|4|
|ORDINAL|int|4|
|UPDATE_RULE|nvarchar|128|
|DELETE_RULE|nvarchar|128|
|PK_NAME|int|4|
|FK_NAME|int|4|
|DEFERRABILITY|int|4|

---
### Objects that depend on \[sys\].\[sp_foreign_keys_rowset_rmt\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_foreign_keys_rowset_rmt\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_foreign_keys_rowset_rmt
(
    @server_name                sysname,
    @pk_table_name              sysname = null,
    @pk_table_schema            sysname = null,
    @pk_table_catalog           sysname = null,
    @foreignkey_tab_name        sysname = null,
    @foreignkey_tab_schema      sysname = null,
    @foreignkey_tab_catalog     sysname = null
)
as
    select
        PK_TABLE_CATALOG,
        PK_TABLE_SCHEMA,
        PK_TABLE_NAME,
        PK_COLUMN_NAME,
        PK_COLUMN_GUID,
        PK_COLUMN_PROPID,
        FK_TABLE_CATALOG,
        FK_TABLE_SCHEMA,
        FK_TABLE_NAME,
        FK_COLUMN_NAME,
        FK_COLUMN_GUID,
        FK_COLUMN_PROPID,
        ORDINAL,
        UPDATE_RULE,
        DELETE_RULE,
        PK_NAME = null,         -- ISSUE these 3 columns must be exported by the server
        FK_NAME = null,         -- in \yukon\sql\ntdbms\msql\ddl\sysoledb.cpp :
        DEFERRABILITY = null    -- const SCHEMA_COLUMNS xCol_FOREIGN_KEYS = {
    from
        sys.fn_remote_foreign_keys (@server_name,
                                    @pk_table_catalog,
                                    @pk_table_schema,
                                    @pk_table_name,
                                    @foreignkey_tab_catalog,
                                    @foreignkey_tab_schema,
                                    @foreignkey_tab_name)
    order by 7,8,9,1,2,3,13
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

