## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSissnapshotitemapplied\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSissnapshotitemapplied**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -324175416 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@snapshot_session_token| |nvarchar|260|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@snapshot_progress_token| |nvarchar|500|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSissnapshotitemapplied\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSissnapshotitemapplied\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
--
-- Name: sp_MSissnapshotitemapplied
--
-- Description: This procedure is used by the distribution and the merge 
--              agent to determine if a particular snapshot work item
--              has been applied to the subscriber.
--
-- Notes: This procedure should only be called by the merge agent or the
--        distribution agent at the subscriber database.
--
-- Parameters: @snapshot_session_token nvarchar(260)
--                - A UniCode string that uniquely identifies a snapshot
--                  delivery session. For now, this will be the snapshot
--                  generation folder of the snapshot being applied.
--             @snapshot_progress_token nvarchar(500)  
--                - A UniCode string that uniquely identifies a snapshot
--                  work item.
--
-- Returns: 0 - succeeded
--          1 - failed
--
-- Result: This procedure will always return a result set that includes
--         the following column:
--
--         snapshot_item_applied (int)
--              - 1 if the specified snapshot item is found in 
--                MSsnapshotdeliveryprogress
--              - 0 if the specified snapshot item is not found
--                in MSsnapshotdeliveryprogress or 
--                MSsnapshotdeliveryprogress simply does not exists. 
--         The result set will contain exactly one row.
--
-- Security: Execute permission of this procedure is granted to public;
--           procedural security check will be performed to make sure
--           that the caller is either a db_owner of the current database
--           or a sysadmin. 
--
create procedure sys.sp_MSissnapshotitemapplied (
    @snapshot_session_token nvarchar(260),
    @snapshot_progress_token nvarchar(500)
    )
as
begin
    set nocount on
    declare @retcode int
    declare @snapshot_progress_token_hash int
    select @retcode = 0

    exec @retcode = sys.sp_MSreplcheck_subscribe 
    if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
    begin
        select @retcode = 1
        goto FAILURE
    end

    if object_id('dbo.MSsnapshotdeliveryprogress') is not null
    begin
        select @snapshot_progress_token_hash = 
            sys.fn_repl32bitstringhash(@snapshot_progress_token)
        if @@error &lt;&gt; 0
        begin
            select @retcode = 1
            goto FAILURE
        end
        if exists (select * from MSsnapshotdeliveryprogress    
                    where progress_token_hash = @snapshot_progress_token_hash
                      and progress_token = @snapshot_progress_token
                      and session_token = @snapshot_session_token)
        begin
            select 'snapshot_item_applied' = 1
        end
        else
        begin
            select 'snapshot_item_applied' = 0
        end
        if @@error &lt;&gt; 0
        begin
            select @retcode = 1
            goto FAILURE
        end
    end
    else
    begin
        select 'snapshot_item_applied' = 0
    end
    if @@error &lt;&gt; 0
    begin
        select @retcode = 1
        goto FAILURE
    end
FAILURE:
    return @retcode    
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

