## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSdrop_snapshot_dirs\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSdrop_snapshot_dirs**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -325750352 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
 No parameters exist

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSdrop_snapshot_dirs\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSdrop_snapshot_dirs\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_MSdrop_snapshot_dirs
as
begin
    declare @retcode int
    declare @snapshot_bit int
    declare @directory_type int
    declare @alt_directory_type int
    declare @publisher_database_id int

    declare @dir nvarchar(512)
    declare @command_id int
    declare @xact_seqno varbinary(16)

    select @snapshot_bit = 0x80000000
    select @directory_type = 7
    select @alt_directory_type = 25

    -- Sysadmin check
    if (isnull(is_srvrolemember('sysadmin'),0) = 0) 
    begin
        raiserror(14260, 16, -1)
        return (1)
    end

    --
    -- security check
    -- sysadmin check is done in sp_MSreplremoveuncdir
    --
    declare  hCdirs  CURSOR LOCAL FAST_FORWARD FOR select CONVERT(nvarchar(512), command),
        xact_seqno, command_id, publisher_database_id
        from MSrepl_commands where
        ((type &amp; ~@snapshot_bit) = @directory_type) or
        ((type &amp; ~@snapshot_bit) = @alt_directory_type)
    for read only

    open hCdirs
    fetch hCdirs into @dir, @xact_seqno, @command_id, @publisher_database_id
    while (@@fetch_status &lt;&gt; -1)
    begin
        --
        -- Need to map unc to local drive for access problem
        -- Security check is done in sp_MSreplremoveuncdir
        --
        exec @retcode = sys.sp_MSreplremoveuncdir @dir
        /* Abort the operation if the delete fails */
        if (@retcode &lt;&gt; 0 or @@error &lt;&gt; 0)
            return (1)

        delete MSrepl_commands where 
            publisher_database_id = @publisher_database_id and
            xact_seqno = @xact_seqno and
            command_id = @command_id

        fetch hCdirs into @dir, @xact_seqno, @command_id, @publisher_database_id
    end
    close hCdirs
    deallocate hCdirs
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

