## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSrepl_check_publisher\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSrepl_check_publisher**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -330582943 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher_type| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@security_mode| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@login| |nvarchar|255|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@password| |nvarchar|255|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@connect_timeout| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSrepl_check_publisher\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSrepl_check_publisher\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

--
-- Name:
--        sp_MSrepl_check_publisher
--
-- Description:
--        Determine if an ad-hoc datasource is currently published.
--
-- Returns:
--        Result set:
--        Distributor that owns publisher
--        NULL if not published
--
-- Security:
--        public
--
-- Notes:
--        Used by the UI
--        Connect time out is measure in seconds (default of 60)
--

CREATE PROCEDURE sys.sp_MSrepl_check_publisher
(
    @publisher_type        sysname,
    @publisher        sysname,
    @security_mode        bit = 1,
    @login            nvarchar(255) = null,
    @password        nvarchar(255) = null,
    @connect_timeout    int = 60
)
AS
BEGIN
    DECLARE @retcode int

    IF UPPER(@publisher_type) IN ('ORACLE', 'ORACLE GATEWAY')
    BEGIN
        EXEC sys.sp_ORAcheckpublisher    @publisher,
                                @security_mode,
                                @login,
                                @password,
                                @connect_timeout
    END
    ELSE
    BEGIN
        RAISERROR(21645, 16, -1, @publisher_type)
        RETURN (1)
    END
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

