## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MScdc_ddl_event\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MScdc_ddl_event**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -336962736 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@EventData| |xml|2147483647|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MScdc_ddl_event\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MScdc_ddl_event\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MScdc_ddl_event
(
    @EventData xml
)
as
begin
    declare @retcode int
        ,@ddl_authorized bit
    
    -- if CDC is not enabled for this db, don't do anything
    if (sys.fn_cdc_is_db_enabled() != 1)
    begin
        return 0
    end    

    -- Determine whether the caller is authorized before switching to dbo
    -- Note:  We don't want to prevent DDL that does not impact cdc behavior.
    --        Since we can't determine immediately whether we are interested
    --        in the DDL event or not, we simply retain the authorization
    --        information so it can be checked later, if needed.
    set @ddl_authorized = 1
    if     (isnull(is_srvrolemember('sysadmin'),0) = 0) 
        and (isnull(is_member('db_owner'),0) = 0)
        and (isnull(is_member('db_ddladmin'),0) = 0)
    begin
        set @ddl_authorized = 0
    end
    
    -- Execute logic using an internal stored procedure that executes as 'dbo'
    exec @retcode = sys.sp_cdc_ddl_event_internal @EventData, @ddl_authorized 
    
    if (@@error &lt;&gt; 0) or (@retcode &lt;&gt; 0)
    begin
        return 1
    end    
    
    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

