## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSchangedynamicsnapshotjobatdistributor\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSchangedynamicsnapshotjobatdistributor**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -338977041 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@dynamic_filter_login| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@dynamic_filter_hostname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_type| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_interval| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_subday| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_subday_interval| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_relative_interval| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_recurrence_factor| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@active_start_date| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@active_end_date| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@active_start_time_of_day| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@active_end_time_of_day| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@job_login| |nvarchar|257|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@job_password| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSchangedynamicsnapshotjobatdistributor\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSchangedynamicsnapshotjobatdistributor\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
--
-- Name: sp_MSchangedynamicsnapshotjobatdistributor
--
-- Description: This function is called by sp_changeddynamicsnapshot_job 
--              at the publisher to change the schedule of a dynamic snapshot job 
--              at the distributor. 
--
-- Returns: 0 - succeeded
--          1 - failed
--
-- Security: Only members of the 'sysadmin' server role and members of the 
--           'db_owner' database role at the distributor can call this 
--           procedure. This procedure is intended to be called through 
--           the distributor_admin remote login in the case where
--           the distributor is a different machine from the publisher. 
--
create procedure sys.sp_MSchangedynamicsnapshotjobatdistributor 
(
    @publisher sysname,
    @publisher_db sysname,
    @publication sysname,
    @dynamic_filter_login sysname,
    @dynamic_filter_hostname sysname,

    -- Scheduling information
    @frequency_type                 int = NULL,
    @frequency_interval             int = NULL,
    @frequency_subday                int = NULL,
    @frequency_subday_interval        int = NULL,
    @frequency_relative_interval    int = NULL,
    @frequency_recurrence_factor    int = NULL,
    @active_start_date                int = NULL,
    @active_end_date                int = NULL,
    @active_start_time_of_day        int = NULL,
    @active_end_time_of_day         int = NULL,

    -- Job Login information
    @job_login                        nvarchar(257) = NULL,
    @job_password                    sysname = NULL        
)
as
begin
    set nocount on

    declare @retcode int
    declare @agent_id int
    declare @job_id uniqueidentifier
    declare @job_step_uid uniqueidentifier
    declare @publisher_id int
    declare @publication_type int
    
    --
    -- security check
    -- only db_owner can execute this
    --
    if (is_srvrolemember('sysadmin') != 1) 
    begin
        raiserror(14260, 16, -1)
        return (1)
    end
    --
    -- security check
    -- Has to be executed from distribution database
    --
    if (sys.fn_MSrepl_isdistdb (db_name()) != 1)
    begin
        raiserror(21482, 16, -1, 'sp_MSchangedynamicsnapshotjobatdistributor', 'distribution')
        return (1)
    end

    if @dynamic_filter_login is NULL and @dynamic_filter_hostname is NULL
    begin
        raiserror(20653, 16, -1)
        return 1
    end
    
    select @retcode = 0
    select @agent_id = null

    SELECT @publisher_id = srvid 
      FROM master.dbo.sysservers
     WHERE UPPER(srvname) = UPPER(@publisher)
    IF @publisher_id IS  NULL
    BEGIN
        RAISERROR(21169, 16, -1, @publisher, @@SERVERNAME, @publisher)    
    END
    
    -- Get the publication details from the agent for regular snapshot  
    select @agent_id = id,
           @job_id = job_id,
           @job_step_uid = job_step_uid,
           @publication_type = publication_type
      from MSsnapshot_agents
     where publisher_id = @publisher_id and 
           publication = @publication and 
           publisher_db = @publisher_db and
          ((@dynamic_filter_login is NULL and dynamic_filter_login is NULL) or dynamic_filter_login = @dynamic_filter_login)  and
          ((@dynamic_filter_hostname is NULL and dynamic_filter_hostname is NULL) or dynamic_filter_hostname = @dynamic_filter_hostname)
    if @agent_id is null or @job_id is NULL
    begin
        raiserror(21325, 11, -1)
        return 1
    end

    if @publication_type &lt;&gt; 2
    begin
        raiserror(20654, 16, -1)
        return 1
    end

    -- Change the job
    exec @retcode = sys.sp_MSchange_repl_job @id                             = @job_id,
                                            @step_uid                        = @job_step_uid,
                                            @name                             = NULL,
                                            @frequency_type                 = @frequency_type,
                                            @frequency_interval             = @frequency_interval,
                                            @frequency_subday                = @frequency_subday,
                                            @frequency_subday_interval        = @frequency_subday_interval,
                                            @frequency_relative_interval    = @frequency_relative_interval,
                                            @frequency_recurrence_factor    = @frequency_recurrence_factor,
                                            @active_start_date                = @active_start_date,
                                            @active_end_date                = @active_end_date,
                                            @active_start_time_of_day        = @active_start_time_of_day,
                                            @active_end_time_of_day         = @active_end_time_of_day,
                                            @login                            = @job_login,
                                            @password                        = @job_password

    if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
        goto UNDO
    
    RETURN(0)

UNDO:
    return(1)
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

