## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MScheck_agent_instance\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MScheck_agent_instance**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -340120343 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@application_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@agent_type| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MScheck_agent_instance\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MScheck_agent_instance\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MScheck_agent_instance
    @application_name     sysname,
    @agent_type         int = NULL
as
    declare @count_pro int
    set nocount on

    select @count_pro = count(*) 
        from sys.dm_exec_sessions 
        where program_name = @application_name collate database_default

    -- type 3 is for 7.0 distribution agent backward compatibility.
    if @agent_type = 3
    begin
        -- The distribution agent will before connecting to the publisher with unique 
        -- application name
        if @count_pro &gt; 0
            raiserror (21036, 16, -1, 'distribution')
    end
    -- 10 is 7.5 version of the distribution agent.
    else if @agent_type = 10
    begin
        -- The distribution agent will connecting to the publisher with unique 
        -- application name and then check.
        if @count_pro &gt; 1
            raiserror (21036, 16, -1, 'distribution')
    end
    else if @agent_type = 4
    begin
        -- The merge agent will connect to the publisher with unique application name
        -- then call this procedure
        if @count_pro &gt; 1 
            raiserror (21036, 16, -1, 'merge')
    end
    else if @agent_type = 1
    begin
        -- The snapshot agent will connect to the distributiondb with unique application name
        -- then call this procedure
        if @count_pro &gt; 2 
            raiserror (21036, 16, -1, 'snapshot')
    end
    else if @agent_type = 2
    begin
        -- The logreader agent will connect to the distributiondb with unique application name
        -- then call this procedure
        if @count_pro &gt; 1
            raiserror (21036, 16, -1, 'logreader')
    end
    else if @agent_type = 9
    begin
        -- The queuereader agent will connect to the distributiondb with unique application name
        -- then call this procedure
        if @count_pro &gt; 1 
            raiserror (21036, 16, -1, 'queuereader')
    end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

