## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSdistributoravailable\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSdistributoravailable**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -34754849 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
 No parameters exist

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSdistributoravailable\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSdistributoravailable\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

--
-- Name:
--        sp_MSdistributoravailable
--
-- Description:
--        Procedure used to determine whether the distributor is available
--
-- Returns:
--        0 == SUCCESS
--        1 == FAILURE
--              result set with distribution database as the only column
--
-- Security:
--        public
--
-- Notes:
--        This internal stored procedure is used to determine whether the 
--              distributor associated with the local server is available.  
--        If available, the name of the distribution db will be returned
--        as the only column in the result set, and the return code will
--        be set to zero.    

create procedure sys.sp_MSdistributoravailable
AS
BEGIN
    DECLARE @distribdb sysname,
        @retcode int

    exec @retcode = sp_MSrepl_getdistributorinfo
        @distribdb = @distribdb OUTPUT

    select 'distribdb' = @distribdb
 
    return @retcode
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

