## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_help_log_shipping_secondary_database\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_help_log_shipping_secondary_database**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -347551797 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@secondary_database| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@secondary_id| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|secondary_id|uniqueidentifier|16|
|primary_server|nvarchar|128|
|primary_database|nvarchar|128|
|backup_source_directory|nvarchar|500|
|backup_destination_directory|nvarchar|500|
|file_retention_period|int|4|
|copy_job_id|uniqueidentifier|16|
|restore_job_id|uniqueidentifier|16|
|monitor_server|nvarchar|128|
|monitor_server_security_mode|bit|1|
|secondary_database|nvarchar|128|
|restore_delay|int|4|
|restore_all|bit|1|
|restore_mode|bit|1|
|disconnect_users|bit|1|
|block_size|int|4|
|buffer_count|int|4|
|max_transfer_size|int|4|
|restore_threshold|int|4|
|threshold_alert|int|4|
|threshold_alert_enabled|bit|1|
|last_copied_file|nvarchar|500|
|last_copied_date|datetime|8|
|last_copied_date_utc|datetime|8|
|last_restored_file|nvarchar|500|
|last_restored_date|datetime|8|
|last_restored_date_utc|datetime|8|
|history_retention_period|int|4|
|last_restored_latency|int|4|

---
### Objects that depend on \[sys\].\[sp_help_log_shipping_secondary_database\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_help_log_shipping_secondary_database\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_help_log_shipping_secondary_database 
(
    @secondary_database sysname = NULL
    ,@secondary_id uniqueidentifier = NULL
)
as
begin
    set nocount on
    declare @retcode int

    --
    -- security check
    --
    exec @retcode = sys.sp_MSlogshippingsysadmincheck
    if (@retcode != 0 or @@error != 0)
        return 1
    --
    -- must be invoked from master db
    --
    if (db_name() != N'master')
    begin
        raiserror(5001, 16,-1)
        return 1
    end
    --
    -- validate input
    --
    if (@secondary_database is null and @secondary_id is null)
    begin
        raiserror(14524, 16, 1, N'@secondary_database', N'@secondary_id')
        return 1
    end
    --
    -- do the resultset join
    --
    select 
        s.secondary_id
        ,s.primary_server
        ,s.primary_database
        ,s.backup_source_directory
        ,s.backup_destination_directory
        ,s.file_retention_period
        ,s.copy_job_id
        ,s.restore_job_id
        ,'monitor_server' = case when (s.user_specified_monitor = 1) then s.monitor_server else cast(NULL as sysname) end
        ,'monitor_server_security_mode' = case when (s.user_specified_monitor = 1) then s.monitor_server_security_mode else cast(NULL as bit) end
        ,sd.secondary_database
        ,sd.restore_delay
        ,sd.restore_all
        ,sd.restore_mode
        ,sd.disconnect_users
        ,sd.block_size
        ,sd.buffer_count
        ,sd.max_transfer_size
        ,sm.restore_threshold
        ,sm.threshold_alert
        ,sm.threshold_alert_enabled
        ,sm.last_copied_file
        ,sm.last_copied_date
        ,sm.last_copied_date_utc
        ,sm.last_restored_file
        ,sm.last_restored_date
        ,sm.last_restored_date_utc
        ,sm.history_retention_period
        ,sm.last_restored_latency
    from ((msdb.dbo.log_shipping_secondary as s join msdb.dbo.log_shipping_secondary_databases as sd
            on s.secondary_id = sd.secondary_id) 
        join msdb.dbo.log_shipping_monitor_secondary as sm
            on sd.secondary_id = sm.secondary_id 
                    and sd.secondary_database = sm.secondary_database
                    and s.primary_server = sm.primary_server
                    and s.primary_database = sm.primary_database)
    where (@secondary_database is null or sd.secondary_database = @secondary_database)
        and (@secondary_id is null or s.secondary_id = @secondary_id)
    --
    -- all done
    --
    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

