## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_dropapprole\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_dropapprole**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -347698839 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@rolename| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_dropapprole\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_dropapprole\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_dropapprole
    @rolename       sysname     -- role to be dropped
as
    -- SETUP RUNTIME OPTIONS / DECLARE VARIABLES --
    set nocount on
    declare @ret        int,
            @stmtR        nvarchar(4000)

    -- DISALLOW USER TRANSACTION --
    set implicit_transactions off
    if (@@trancount &gt; 0)
    begin
        raiserror(15002,-1,-1,'sys.sp_dropapprole')
        return (1)
    end

    exec @ret = sys.sp_validname @rolename
    if @ret &lt;&gt; 0
        return(1)

    -- create statement
    set @stmtR = 'drop application role ' + quotename(@rolename, ']')

    BEGIN TRANSACTION

    -- this will drop the schema owned by the approle that has the same name as the approle,
    -- if such schema exists
    EXEC %%Owner(Name = @rolename).DropSchema(OwnerType = 3)
    if @@error &lt;&gt; 0
    begin
        ROLLBACK TRANSACTION
        -- error message comes from inside the invoke
        return (1)
    end

    -- drop the owner
    exec (@stmtR)
    if @@error &lt;&gt; 0
    begin
        ROLLBACK TRANSACTION
        -- error message comes from inside the statement
        return (1)
    end

    COMMIT TRANSACTION

    -- RETURN SUCCESS --
    return (0) -- sp_dropapprole
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

