## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_table_privileges_ex\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_table_privileges_ex**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -362005483 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@table_server| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@table_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@table_schema| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@table_catalog| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@fUsePattern| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|TABLE_CAT|nvarchar|128|
|TABLE_SCHEM|nvarchar|128|
|TABLE_NAME|nvarchar|128|
|GRANTOR|nvarchar|128|
|GRANTEE|nvarchar|128|
|PRIVILEGE|nvarchar|128|
|IS_GRANTABLE|varchar|3|

|Name |Datatype |Max length |
|-|-|-|
|TABLE_CAT|nvarchar|128|
|TABLE_SCHEM|nvarchar|128|
|TABLE_NAME|nvarchar|128|
|GRANTOR|nvarchar|128|
|GRANTEE|nvarchar|128|
|PRIVILEGE|nvarchar|128|
|IS_GRANTABLE|varchar|3|

---
### Objects that depend on \[sys\].\[sp_table_privileges_ex\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_table_privileges_ex\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_table_privileges_ex
(
    @table_server       sysname,
    @table_name         sysname = null,
    @table_schema       sysname = null,
    @table_catalog      sysname = null,
    @fUsePattern        bit = 1 -- To allow users to explicitly disable all pattern matching.
)
as
    if (@fUsePattern = 1) -- Does the user want it?
    begin
        if ((isnull(charindex('%', @table_name),0) = 0) and
            (isnull(charindex('_', @table_name),0) = 0) and
            (isnull(charindex('[', @table_name),0) = 0) and
            (isnull(charindex('%', @table_schema),0) = 0) and
            (isnull(charindex('_', @table_schema),0) = 0) and
            (isnull(charindex('[', @table_schema),0) = 0))
        begin
            select @fUsePattern = 0 -- not a single wild char, so go the fast way.
        end
    end

    if @fUsePattern = 0
    begin
        /* -- Debug output, do not remove it.
        print '*************'
        print 'No pattern matching.'
        print @fUsePattern
        print isnull(@table_name, '@table_name = null')
        print isnull(@table_schema, '@table_schema = null')
        print '*************'
        */
        select
            TABLE_CAT       = rtp.TABLE_CATALOG,
            TABLE_SCHEM     = rtp.TABLE_SCHEMA,
            TABLE_NAME      = rtp.TABLE_NAME,
            GRANTOR         = rtp.GRANTOR,
            GRANTEE         = rtp.GRANTEE,
            PRIVILEGE       = rtp.PRIVILEGE_TYPE,
            IS_GRANTABLE    = case rtp.IS_GRANTABLE
                                when 1 then 'YES'
                                when 0 then 'NO'
                                else null
                              end
        from
            sys.fn_remote_table_privileges (@table_server,
                                            @table_catalog,
                                            @table_schema,
                                            @table_name,
                                            NULL,
                                            NULL) rtp
        order by 1, 2, 3, 6
    end
    else
    begin
        /* -- Debug output, do not remove it.
        print '*************'
        print 'THERE IS pattern matching!'
        print @fUsePattern
        print isnull(@table_name, '@table_name = null')
        print isnull(@table_schema, '@table_schema = null')
        print '*************'
        */
        select
            TABLE_CAT       = rtp.TABLE_CATALOG,
            TABLE_SCHEM     = rtp.TABLE_SCHEMA,
            TABLE_NAME      = rtp.TABLE_NAME,
            GRANTOR         = rtp.GRANTOR,
            GRANTEE         = rtp.GRANTEE,
            PRIVILEGE       = rtp.PRIVILEGE_TYPE,
            IS_GRANTABLE    = case rtp.IS_GRANTABLE
                                when 1 then 'YES'
                                when 0 then 'NO'
                                else null
                              end
        from
            sys.fn_remote_table_privileges (@table_server,
                                            @table_catalog,
                                            NULL,
                                            NULL,
                                            NULL,
                                            NULL) rtp
        where
            (TABLE_SCHEMA like @table_schema or
             @table_schema is NULL or
             (TABLE_SCHEMA is NULL and @table_schema = N'%')) and
            (TABLE_NAME like @table_name or @table_name is NULL)
        order by 1, 2, 3, 6
    end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

