## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSchange_subscription_dts_info\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSchange_subscription_dts_info**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -364963374 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@job_id| |varbinary|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@dts_package_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@dts_package_password| |nvarchar|524|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@dts_package_location| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@change_password| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSchange_subscription_dts_info\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSchange_subscription_dts_info\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_MSchange_subscription_dts_info 
(
    @job_id varbinary(16),
    @dts_package_name sysname,
    @dts_package_password nvarchar(524),
    @dts_package_location int,
    @change_password bit
) 
AS
begin
    /*
    ** Declarations.
    */
    declare @subscriber sysname
    declare @publisher sysname
    declare @subscriber_id smallint
    declare @publisher_id smallint

    --
    -- security check
    -- only db_owner can execute this
    --
    if (is_member ('db_owner') != 1) 
    begin
        raiserror(14260, 16, -1)
        return (1)
    end
    --
    -- security check
    -- Has to be executed from distribution database
    --
    if (sys.fn_MSrepl_isdistdb (db_name()) != 1)
    begin
        raiserror(21482, 16, -1, 'sp_MSchange_subscription_dts_info', 'distribution')
        return (1)
    end
    /*
    ** Initializations.
    */
    SET NOCOUNT ON
    
    select @subscriber_id = subscriber_id, @publisher_id = publisher_id 
        from MSdistribution_agents where 
        job_id = @job_id
    
    select @subscriber = srvname from master.dbo.sysservers where srvid = @subscriber_id
    select @publisher = srvname from master.dbo.sysservers where srvid = @publisher_id

    declare @oledb_subscriber tinyint
    select @oledb_subscriber = 3
    
    -- Only SQL Server and OLEDB subscriber support dts
    if not exists (select * from MSsubscriber_info where 
        UPPER(publisher) = UPPER(@publisher) and 
        UPPER(subscriber) = UPPER(@subscriber) and
        (type = 0 or type = @oledb_subscriber))
    begin
        raiserror(21170, 16, -1)
        return 1
    end
    
    
    update MSdistribution_agents set
        dts_package_name = case 
            when @dts_package_name is null then dts_package_name
            when @dts_package_name = N'' then null
            else @dts_package_name
            end, 
        dts_package_password = case @change_password
            when 0 then dts_package_password
            else @dts_package_password
            end, 
        dts_package_location = case
            when @dts_package_location is null then dts_package_location
            else @dts_package_location
            end
        where
            job_id = @job_id

    RETURN (0)
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

