## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSreset_subscription\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSreset_subscription**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -366885144 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscriber| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscriber_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscription_type| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSreset_subscription\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSreset_subscription\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_MSreset_subscription 
(
    @publisher sysname,
    @publisher_db sysname,
    @publication sysname,  
    @subscriber sysname,
    @subscriber_db sysname,
    @subscription_type int  -- have to have it to identify a distribution agent.
) 
AS
begin
    SET NOCOUNT ON

    /*
    ** Declarations.
    */
    DECLARE @retcode            int
    DECLARE @publisher_id       smallint
    DECLARE @subscriber_id      smallint
    DECLARE @virtual            smallint
    DECLARE @virtual_anonymous  smallint
    declare @anonymous_subtype  smallint
    declare @publication_id        int
    declare @immediate_sync        bit

    --
    -- security check
    -- only db_owner can execute this
    --
    if (is_member ('db_owner') != 1) 
    begin
        raiserror(14260, 16, -1)
        return (1)
    end

    /*
    ** Initializations
    */
    select @virtual = -1
    select @virtual_anonymous = -2
    select @anonymous_subtype = 2

    select @publisher_id = srvid from master.dbo.sysservers where 
        UPPER(srvname) = UPPER(@publisher)

    select @subscriber_id = srvid from master.dbo.sysservers where 
        UPPER(srvname) = UPPER(@subscriber) 

    select @publication_id = publication_id, @immediate_sync = immediate_sync
        from dbo.MSpublications where
        publisher_id = @publisher_id AND
        publisher_db = @publisher_db AND
        publication = @publication

    if @subscriber is NULL
        select @subscriber_id = @virtual

    -- No need to have 2 updates in one transaction.
    if @immediate_sync = 1
    begin
        UPDATE MSdistribution_agents SET subscription_guid = newid()
            WHERE
            publisher_id = @publisher_id AND
            publisher_db = @publisher_db AND
            publication = @publication and
            subscriber_id = @subscriber_id and
            subscriber_db = @subscriber_db and
            subscription_type = @subscription_type

        IF @@ERROR &lt;&gt; 0
            GOTO UNDO

        if @subscriber_id = @virtual
        begin
            -- reset the partial snapshot progress of all anonymous 
            -- agents associated with this virtual subscription

            update dbo.MSdistribution_agents 
               set reset_partial_snapshot_progress = 1
             where
            publisher_id = @publisher_id AND
            publisher_db = @publisher_db AND
            publication = @publication and
            subscriber_id &lt;&gt; @virtual and
            subscriber_id &lt;&gt; @virtual_anonymous and
            subscription_type = @anonymous_subtype
        end 
    end

    UPDATE dbo.MSsubscriptions set subscription_time = getdate() 
        WHERE
        publisher_id = @publisher_id AND
        publisher_db = @publisher_db AND
        publication_id = @publication_id and
        subscriber_id = @subscriber_id and
        subscriber_db = @subscriber_db and
        subscription_type = @subscription_type

    IF @@ERROR &lt;&gt; 0
        GOTO UNDO

    RETURN(0)

UNDO:
    return(1)
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

