## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MScreatedummygeneration\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MScreatedummygeneration**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -368212662 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@pubid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@maxgen_whenadded| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MScreatedummygeneration\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MScreatedummygeneration\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_MScreatedummygeneration @pubid uniqueidentifier, @maxgen_whenadded bigint
as
    declare @retcode    int
    declare @gen        bigint
    declare @tablenick    int
    declare @nickbin    varbinary(255)
    declare @replnick    binary(6)

    /*
    ** Check to see if current publication has permission
    */
    if ({ fn ISPALUSER(@pubid)} &lt;&gt; 1)
    begin    
        RAISERROR (14126, 11, -1)
        return (1)
    end

    -- get the makegeneration applock before calling makegeneration
    declare @lock int
    -- if there exists any open generations below the maxgen_whenadded then call make generation
    -- with flag @gencheck set to 3 to indicate that all existing open generations lower than 
    -- the highest closed generation should either be closed or deleted
    if exists (select * from dbo.MSmerge_genhistory where generation &lt;= @maxgen_whenadded and genstatus in (0, 4) )
    begin
        exec @retcode = sys.sp_MSgetmakegenerationapplock @head_of_queue = @lock OUTPUT
        -- error out if we could not get the makegeneration applock
        if @@error &lt;&gt; 0 or @retcode &lt; 0
            return 1
        
        -- if there exists any open generations at or below the maxgen_whenadded then call make generation
        if exists (select * from dbo.MSmerge_genhistory where generation &lt;= @maxgen_whenadded and genstatus in (0, 4))
        begin
            exec @retcode = sys.sp_MSmakegeneration @gencheck = 3
            if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
            begin
                exec sys.sp_MSreleasemakegenerationapplock
                return 1
            end
        end
        exec sys.sp_MSreleasemakegenerationapplock
    end

    -- insert a dummy closed generation so that the watermark after the download is set higher than maxgen_whenadded.
    if not exists (select 1 from dbo.MSmerge_genhistory where generation &gt; @maxgen_whenadded)
    begin
        exec @retcode= sys.sp_MSgetreplnick @replnick = @replnick out
        if @retcode&lt;&gt;0 or @@error&lt;&gt;0 
            return 1

        -- add a guard byte
        set @nickbin= @replnick + 0xFF
        
        insert into dbo.MSmerge_genhistory with (rowlock)
            (guidsrc, genstatus, art_nick, nicknames, coldate) 
        values (newid(), 1, 0, @nickbin, getdate())
        if @@error&lt;&gt;0
            return 1
    end
    return 0
                        
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

