## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSunregistersubscription\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSunregistersubscription**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -370555004 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscriber| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscriber_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSunregistersubscription\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSunregistersubscription\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_MSunregistersubscription
(
    @publisher         sysname = NULL, 
    @publisher_db     sysname = NULL, 
    @publication     sysname = NULL, 
    @subscriber     sysname = NULL,
    @subscriber_db     sysname = NULL
)
AS
BEGIN
    /* 
    ** Drop the corresponding registry entry for MobileSync
    */
    declare @enabled    int
    declare    @retcode     int
    declare @regkey        nvarchar(1000)

    select @retcode = 0
    
    exec @retcode = sys.sp_MSreplcheck_subscribe

    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
    BEGIN
        RETURN 1
    END

    -- Mark enabled_for_syncmgr bit before trying to delete the key
    -- If the row exists in MSreplication_properties table, 
    -- set enabled_for_syncmgr bit
    -- The logic need to be here because UI call this sp directly.
    IF OBJECT_ID('MSsubscription_properties') IS NOT NULL
    BEGIN
        UPDATE    MSsubscription_properties
        SET        enabled_for_syncmgr = 0
        WHERE    UPPER(publisher) = UPPER(@publisher)
          AND    publisher_db =  @publisher_db
          AND    publication = @publication

        IF @@ERROR &lt;&gt; 0
            RETURN 1
    END

    -- regdelete returns 'Access Denied' message if key does not exist; check before delete
    EXEC sys.sp_MSsubscription_enabled_for_syncmgr    @publisher,
                                                    @publisher_db,
                                                    @publication,
                                                    @subscriber,
                                                    @subscriber_db,
                                                    @enabled OUT,
                                                    @regkey OUT
    IF @@ERROR &lt;&gt; 0
        RETURN 1
        
    IF @enabled = 1 AND LEN(@regkey) &gt; 0
    BEGIN
        EXECUTE @retcode = master.dbo.xp_regdeletekey 'HKEY_LOCAL_MACHINE', @regkey

        IF @@error != 0 OR @retcode != 0
        BEGIN
            return 1
        END
    END

    return 0
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

