## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSenum_merge_s\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSenum_merge_s**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -372036284 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@name| |nvarchar|100|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@hours| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@session_type| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSenum_merge_s\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSenum_merge_s\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSenum_merge_s
(
@name nvarchar(100), 
@hours int = 0, /* @hours &lt; 0 will return TOP 100 */
@session_type int = 1 /* Return all sessions */
)
as
begin
    set nocount on

    declare @succeed int
    declare @agent_id int
    declare @retry int
    declare @failure int
    declare @min_time datetime

    --
    -- security check
    -- only replmonitor can execute this
    --
    if not (is_member(N'db_owner') = 1 or isnull(is_member(N'replmonitor'),0) = 1)
    begin
        raiserror(14260, 16, -1)
        return (1)
    end
    /* 
    ** Status const defined in sqlrepl.h 
    */
    select @succeed = 2
    select @retry = 5
    select @failure = 6

    select @agent_id = id from dbo.MSmerge_agents where name = @name

    /* Get date starting point */
    IF @hours &lt; 0
    BEGIN
        select top 100 ms.runstatus, 
            'start_time' = sys.fn_replformatdatetime(ms.start_time), 
            'time' = sys.fn_replformatdatetime(ms.end_time), 
            rh.comments, ms.duration, 
            -- Note: return average rate here !!! delivery_rate column is current rate
            ms.delivery_rate, 
            ms.download_inserts, ms.download_updates, ms.download_deletes, ms.download_conflicts,
            ms.upload_inserts, ms.upload_updates, ms.upload_deletes, ms.upload_conflicts,
            'action_count' = (select count(*) from dbo.MSmerge_history with (READPAST) where
                session_id = ms.session_id and agent_id = @agent_id),
            rh.error_id
            from dbo.MSmerge_history rh with (READPAST), dbo.MSmerge_sessions ms with (READPAST)
            where
            ms.agent_id = @agent_id and
            ((@session_type = 1 and
            (ms.runstatus = @succeed or
            ms.runstatus = @retry or
            ms.timestamp = (select max(ms2.timestamp) from dbo.MSmerge_sessions ms2 with (READPAST) where
                ms2.agent_id = @agent_id))) or 
            ms.runstatus = @failure) and
            ms.session_id = rh.session_id and
            ms.agent_id = rh.agent_id and
            rh.timestamp = (select max(rh2.timestamp) from dbo.MSmerge_history rh2 with (READPAST) where
                rh2.agent_id = @agent_id and rh2.session_id=ms.session_id)
            order by ms.session_id desc
    END
    ELSE
    BEGIN
        IF @hours = 0
        BEGIN
            select @min_time = NULL
        END
        ELSE
        BEGIN
            select @min_time = dateadd(hour, -@hours, getdate())
        END
        select  ms.runstatus, 
            'start_time' = sys.fn_replformatdatetime(ms.start_time), 
            'time' = sys.fn_replformatdatetime(ms.end_time), 
            rh.comments, ms.duration, 
            -- Note: return average rate here !!! delivery_rate column is current rate
            ms.delivery_rate, 
            ms.download_inserts, ms.download_updates, ms.download_deletes, ms.download_conflicts,
            ms.upload_inserts, ms.upload_updates, ms.upload_deletes, ms.upload_conflicts,
            'action_count' = (select count(*) from dbo.MSmerge_history with (READPAST) where
                session_id = ms.session_id and agent_id = @agent_id),
            rh.error_id
            from dbo.MSmerge_history rh with (READPAST), dbo.MSmerge_sessions ms with (READPAST)
            where
            ms.agent_id = @agent_id and
            ((@session_type = 1 and
            (ms.runstatus = @succeed or
            ms.runstatus = @retry or
            ms.timestamp = (select max(ms2.timestamp) from dbo.MSmerge_sessions ms2 with (READPAST) where
                ms2.agent_id = @agent_id))) or 
            ms.runstatus = @failure) and
            (ms.end_time &gt;= @min_time or @min_time IS NULL) and
               ms.session_id = rh.session_id and
            ms.agent_id = rh.agent_id and
            rh.timestamp = (select max(rh2.timestamp) from dbo.MSmerge_history rh2 with (READPAST) where
                rh2.agent_id = @agent_id and rh2.session_id=ms.session_id)        
            order by ms.session_id desc
    END
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

