## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_syspolicy_update_event_notification\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_syspolicy_update_event_notification**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -379555063 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
 No parameters exist

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_syspolicy_update_event_notification\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_syspolicy_update_event_notification\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_syspolicy_update_event_notification 
AS
    IF (msdb.dbo.fn_syspolicy_is_automation_enabled() = 0)
    BEGIN
        RETURN;
    END

    DECLARE @event_list nvarchar(max)
    SET @event_list = N''

    CREATE TABLE #temp_events (event_name sysname COLLATE database_default)
    INSERT #temp_events 
        SELECT DISTINCT fe.event_name COLLATE database_default
            FROM msdb.dbo.syspolicy_policies pi
            INNER JOIN msdb.dbo.syspolicy_conditions_internal c ON pi.condition_id = c.condition_id
            INNER JOIN msdb.dbo.syspolicy_facet_events fe ON c.facet_id = fe.management_facet_id
            INNER JOIN sys.event_notification_event_types ent ON fe.event_name = ent.type_name COLLATE database_default
            WHERE (pi.execution_mode &amp; 2) = 2 AND pi.is_enabled = 1 AND
                EXISTS (SELECT * FROM msdb.dbo.syspolicy_object_sets_internal os WHERE os.object_set_id = pi.object_set_id)

    DECLARE event_cursor CURSOR LOCAL FOR 
        SELECT event_name FROM #temp_events
    
    DECLARE @event_name sysname
    OPEN event_cursor
    FETCH NEXT FROM event_cursor INTO @event_name
    WHILE @@FETCH_STATUS = 0
    BEGIN
        SET @event_list = @event_list + @event_name + ','    
        FETCH NEXT FROM event_cursor INTO @event_name
    END

    CLOSE event_cursor
    DEALLOCATE event_cursor

    DROP TABLE #temp_events

    -- take out the last comma
    IF( LEN(@event_list) &gt; 0)
        SET @event_list = SUBSTRING(@event_list, 1, LEN(@event_list)-1)

    -- we need to drop and recreate the notification, because
    -- it cannot be altered        
    BEGIN TRANSACTION

    IF EXISTS (SELECT * FROM sys.server_event_notifications WHERE name = N'syspolicy_event_notification')
        DROP EVENT NOTIFICATION [syspolicy_event_notification] ON SERVER 

    -- no more events to read means we only drop the notification
    IF(LEN(@event_list)=0)
    BEGIN
        COMMIT TRANSACTION
        RETURN (0)
    END

    DECLARE @statement nvarchar(max)
    SET @statement  = N'USE msdb; CREATE EVENT NOTIFICATION [syspolicy_event_notification] ON SERVER
    FOR ' + @event_list + '
    TO SERVICE ''syspolicy_event_listener'', ''current database'';'
    EXEC sp_executesql @statement

    COMMIT TRANSACTION

    RETURN (0)
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

