## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_lock\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_lock**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -379671407 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@spid1| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@spid2| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|spid|smallint|2|
|dbid|smallint|2|
|ObjId|int|4|
|IndId|smallint|2|
|Type|nvarchar|4|
|Resource|nvarchar|32|
|Mode|nvarchar|8|
|Status|nvarchar|5|

|Name |Datatype |Max length |
|-|-|-|
|spid|smallint|2|
|dbid|smallint|2|
|ObjId|int|4|
|IndId|smallint|2|
|Type|nvarchar|4|
|Resource|nvarchar|32|
|Mode|nvarchar|8|
|Status|nvarchar|5|

---
### Objects that depend on \[sys\].\[sp_lock\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_lock\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_lock --- 1996/04/08 00:00
@spid1 int = NULL,        /* server process id to check for locks */
@spid2 int = NULL        /* other process id to check for locks */
as

set nocount on
/*
**  Show the locks for both parameters.
*/
set transaction isolation level read committed
if @spid1 is not NULL
begin
    select     convert (smallint, req_spid) As spid,
        rsc_dbid As dbid,
        rsc_objid As ObjId,
        rsc_indid As IndId,
        substring (v.name, 1, 4) As Type,
        substring (rsc_text, 1, 32) as Resource,
        substring (u.name, 1, 8) As Mode,
        substring (x.name, 1, 5) As Status

    from     master.dbo.syslockinfo,
        master.dbo.spt_values v,
        master.dbo.spt_values x,
        master.dbo.spt_values u

    where   master.dbo.syslockinfo.rsc_type = v.number
            and v.type = 'LR'
            and master.dbo.syslockinfo.req_status = x.number
            and x.type = 'LS'
            and master.dbo.syslockinfo.req_mode + 1 = u.number
            and u.type = 'L'

            and req_spid in (@spid1, @spid2)
end

/*
**  No parameters, so show all the locks.
*/
else
begin
    select     convert (smallint, req_spid) As spid,
        rsc_dbid As dbid,
        rsc_objid As ObjId,
        rsc_indid As IndId,
        substring (v.name, 1, 4) As Type,
        substring (rsc_text, 1, 32) as Resource,
        substring (u.name, 1, 8) As Mode,
        substring (x.name, 1, 5) As Status

    from     master.dbo.syslockinfo,
        master.dbo.spt_values v,
        master.dbo.spt_values x,
        master.dbo.spt_values u

    where   master.dbo.syslockinfo.rsc_type = v.number
            and v.type = 'LR'
            and master.dbo.syslockinfo.req_status = x.number
            and x.type = 'LS'
            and master.dbo.syslockinfo.req_mode + 1 = u.number
            and u.type = 'L'
    order by spid
end

return (0) -- sp_lock
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

