## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_describe_cursor_columns\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_describe_cursor_columns**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -383475922 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@cursor_return| |int|4|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@cursor_source| |nvarchar|30|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@cursor_identity| |nvarchar|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_describe_cursor_columns\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_describe_cursor_columns\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
-- Creation of sp_describe_cursor_columns

create procedure sys.sp_describe_cursor_columns
(  @cursor_return CURSOR VARYING OUTPUT,
   @cursor_source nvarchar (30),
   @cursor_identity nvarchar (128)
)
AS
declare @scope int
select @cursor_source = LOWER (@cursor_source collate Latin1_General_CI_AS)

/* Check if the cursor exists by name or handle. */
If cursor_status ( @cursor_source, @cursor_identity ) &gt;= -1
begin
    if convert(varchar(30), @cursor_source) = 'local' OR
        convert(varchar(128), @cursor_source) = 'variable'
        select @scope = 1
    else
    if convert(varchar(30), @cursor_source) = 'global'
        select @scope = 2

    set @cursor_return =      CURSOR LOCAL SCROLL DYNAMIC FOR
                SELECT column_name, ordinal_position, column_characteristics_flags,
                    column_size, 
                    convert(smallint, case when data_type_sql &gt; 32767 then 0 else data_type_sql end) as "data_type_sql", 
                    column_precision,
                    column_scale, order_position, order_direction,
                    hidden_column, columnid, objectid, dbid, dbname
                FROM sys.syscursorrefs scr, sys.syscursorcolumns scc
                WHERE     scr.cursor_scope = @scope and
                    scr.reference_name = @cursor_identity and
                    scr.cursor_handl = scc.cursor_handle
                ORDER BY 2
                FOR READ ONLY
    open @cursor_return

end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

