## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSscript_sync_ins_trig\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSscript_sync_ins_trig**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -385000493 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@objid| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@trigname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@procname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@proc_owner| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@cftproc| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@agent_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@identity_col| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@ts_col| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@filter_clause| |nvarchar|4000|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@primary_key_bitmap| |varbinary|4000|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@pubversion| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@falter| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSscript_sync_ins_trig\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSscript_sync_ins_trig\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSscript_sync_ins_trig (
    @objid          int,
    @publisher    sysname,
    @publisher_db sysname,
    @publication  sysname,
    @trigname     sysname,
    @procname     sysname,
    @proc_owner   sysname,
    @cftproc      sysname,
    @agent_id      int, 
    @identity_col sysname = NULL,
    @ts_col       sysname = NULL,
    @filter_clause nvarchar(4000),
    @primary_key_bitmap  varbinary(4000),
    @pubversion int = 1,
    @falter bit = 0 -- if 1 script alter, otherwise script create
)
as
BEGIN
    declare @colname      sysname
                ,@cmd          nvarchar(4000)
                ,@ins_cmd      nvarchar(4000)
                ,@outvars      nvarchar(4000)
                ,@rc           int
                ,@qualname     nvarchar(517)
                ,@fisqueued       bit

    set nocount on
    --
    -- security check
    --
    exec @rc = sys.sp_MSreplcheck_subscribe
    if @@error &lt;&gt; 0 or @rc &lt;&gt; 0
        return (1)
    exec sys.sp_MSget_qualified_name @objid, @qualname OUTPUT
    if (LOWER(@cftproc) = N'null')
    begin
        select @fisqueued =  0
                ,@cftproc = NULL
    end
    else 
        select @fisqueued =  1

    if @ts_col in ('null','NULL')
        select @ts_col = null

    if @identity_col in ('null','NULL')
        select @identity_col = null

    -- Create temp table
    create table #proctext ( c1 int identity NOT NULL, procedure_text nvarchar(4000) collate database_default null)

    -- 1st preamble common to all synctran procs
    exec sys.sp_MSscript_begintrig1 @publisher, @publisher_db, @publication, @trigname, @objid, @procname, @filter_clause, 'ins', @fisqueued, @falter, @agent_id
                
    -- 2nd preamble common to all synctran procs
    exec sys.sp_MSscript_begintrig2 @publisher, @publisher_db, @publication, @objid, 'ins',@agent_id, @fisqueued

    -- script single row handling
    exec @rc = sys.sp_MSscript_singlerow_trigger @objid,@publisher, @publisher_db, @publication, @procname, @proc_owner, 
        @cftproc, @identity_col, @ts_col, 'ins', @primary_key_bitmap, @pubversion

    -- script multi-row handling
    exec @rc = sys.sp_MSscript_multirow_trigger @objid, @publisher, @publisher_db, @publication, @procname, @proc_owner, 
        @cftproc, @identity_col, @ts_col, 'ins', @primary_key_bitmap, @pubversion

    -- script end of trigger
    exec sys.sp_MSscript_endtrig 

    -- send fragments to client
    select procedure_text from #proctext order by c1 asc
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

