## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_helpfilegroup\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_helpfilegroup**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -386280289 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@filegroupname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|groupname|nvarchar|128|
|groupid|smallint|2|
|filecount|int|4|

|Name |Datatype |Max length |
|-|-|-|
|groupname|nvarchar|128|
|groupid|smallint|2|
|filecount|int|4|

|Name |Datatype |Max length |
|-|-|-|
|file_in_group|nvarchar|128|
|fileid|smallint|2|
|filename|nvarchar|260|
|size|nvarchar|18|
|maxsize|nvarchar|18|
|growth|nvarchar|18|

---
### Objects that depend on \[sys\].\[sp_helpfilegroup\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_helpfilegroup\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_helpfilegroup
@filegroupname sysname = NULL        /* filegroup name or all filegroups */
as

set nocount on
-- status &amp; 0x40 is a log file and thus not in any filegroup
if @filegroupname IS NULL
begin
    select     g.groupname,  g.groupid, 'filecount' =
        (select count(*) from sysfiles f
            where f.groupid = g.groupid
                and (f.status &amp; 0x40 &lt;&gt; 0x40))
    from sysfilegroups g
end
else
begin
    if (filegroup_id(@filegroupname) IS NULL)
    begin
        raiserror (15325, -1, -1, 'filegroup', @filegroupname)
        return (1)
    end
    select     g.groupname,  g.groupid, 'filecount' =
        (select count(*) from sysfiles f
            where f.groupid = g.groupid
                and (f.status &amp; 0x40 &lt;&gt; 0x40))
    from sysfilegroups g
    where g.groupid = filegroup_id(@filegroupname)

    select     'file_in_group' = name,  fileid, filename,
    'size' = convert(nvarchar(15), size * 8) + N' KB',
    'maxsize' = (case maxsize when -1 then N'Unlimited'
            else
            convert(nvarchar(15), maxsize * 8) + N' KB' end),
    'growth' = (case status &amp; 0x100000 when 0x100000 then
        convert(nvarchar(3), growth) + N'%'
        else
        convert(nvarchar(15), growth * 8) + N' KB' end)
    from sysfiles
    where groupid = filegroup_id(@filegroupname)
    and (status &amp; 0x40 &lt;&gt; 0x40)
    order by fileid
end

return (0) -- sp_helpfilegroup
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

