## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSreset_subscription_seqno\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSreset_subscription_seqno**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -391315258 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@agent_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@get_snapshot| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSreset_subscription_seqno\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSreset_subscription_seqno\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_MSreset_subscription_seqno 
(
    @agent_id int,
    @get_snapshot bit 
)
as
begin
    set nocount on

    declare @publication_id int
    declare @sub_agent_id int
    declare @virtual_anonymous smallint
    declare @virtual smallint
    declare @retcode int
    declare @automatic tinyint

    select @automatic = 1
    select @virtual = -1
    select @virtual_anonymous = -2

    -- Security Check
    exec @retcode = sys.sp_MScheck_pull_access
        @agent_id = @agent_id,
        @agent_type = 0 -- distribution agent
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
        return (1)

    -- Get version agent_id
    select top 1 @sub_agent_id = s2.agent_id from dbo.MSsubscriptions s1,
        MSsubscriptions s2 where
        s1.publisher_id = s2.publisher_id and
        s1.publisher_db = s2.publisher_db and
        s1.publication_id = s2.publication_id and
        s1.agent_id = @agent_id and
        s2.subscriber_id = 
            case @get_snapshot when 0 
                then @virtual_anonymous
                else @virtual
            end 
    
    -- If there are no virtual subscriptions defined. Don't reset.
    -- This might happen when the distribution agent tries to 
    -- reset an subscription on a non immediate_sync publication 
    -- (this can
    -- only happen when the publication is changed from immediate_sync to non
    -- immdiate_sync after the distribution agent has queried the immediate_sync
    -- property)
    if @sub_agent_id = 0
        return 0

    -- 'no_sync' subscriptions are handled differently
    if exists (select * from dbo.MSsubscriptions where agent_id = @agent_id and 
        sync_type &lt;&gt; @automatic)
    begin
        -- If @get_snapshot = 0, the distribution agent is process the attached
        -- subscription for the first time. Set subscription_seqno to zero so that
        -- all changes that are not in the subscription copy will be picked up.
        -- Otherwise, do noting.
        if @get_snapshot = 0
        begin
            update dbo.MSsubscriptions  set 
                -- Use current date rather than virtual sub date for the
                -- calculation in cleanup 
                subscription_time = getdate(),
                -- lsn should be ten bytes long. We will not be here
                -- if the publisher is 6.x since 6x publisher does not
                -- support immediate_sync (thus does not support subscription copy as well)
                subscription_seqno = 0x00000000000000000000,
                publisher_seqno = 0x00000000000000000000,
                ss_cplt_seqno = 0x00000000000000000000
                from dbo.MSsubscriptions rs1 where
                    agent_id = @agent_id 
        end        
        return 0
    end

    -- Reset the subscription statue to be that of the virtual_anonymous subscription.
    -- Thus, only the snapshot transactions that are later than the subscriber transaction
    -- timestamp will be picked up (i.e., new article or schema change article.)
    update dbo.MSsubscriptions  set 
        snapshot_seqno_flag =  
            (select snapshot_seqno_flag from dbo.MSsubscriptions rs2
                where
                rs2.agent_id = @sub_agent_id and
                rs2.article_id = rs1.article_id),
        status =    
            (select status from dbo.MSsubscriptions rs2
                where
                rs2.agent_id = @sub_agent_id and
                rs2.article_id = rs1.article_id),
        -- Use current date rather than virtual sub date for the
        -- calculation in cleanup 
        subscription_time = getdate(),
        subscription_seqno = 
            (select subscription_seqno from dbo.MSsubscriptions rs2
                where
                rs2.agent_id = @sub_agent_id and
                rs2.article_id = rs1.article_id),
        publisher_seqno = 
            (select publisher_seqno from dbo.MSsubscriptions rs2
                where
                rs2.agent_id = @sub_agent_id and
                rs2.article_id = rs1.article_id),
        ss_cplt_seqno = 
            (select ss_cplt_seqno from dbo.MSsubscriptions rs2
                where
                rs2.agent_id = @sub_agent_id and
                rs2.article_id = rs1.article_id)
        from dbo.MSsubscriptions rs1 where
            agent_id = @agent_id
        
    if @@ERROR &lt;&gt; 0
        return 1
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

