## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_schemata_rowset\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_schemata_rowset**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -400892491 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@schema_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@schema_owner| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|CATALOG_NAME|nvarchar|128|
|SCHEMA_NAME|nvarchar|128|
|SCHEMA_OWNER|nvarchar|128|
|DEFAULT_CHARACTER_SET_CATALOG|nvarchar|128|
|DEFAULT_CHARACTER_SET_SCHEMA|nvarchar|128|
|DEFAULT_CHARACTER_SET_NAME|nvarchar|128|

---
### Objects that depend on \[sys\].\[sp_schemata_rowset\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_schemata_rowset\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_schemata_rowset
(
    @schema_name    sysname = null,
    @schema_owner   sysname = null
)
as
    select distinct
        CATALOG_NAME                    = db_name(),
        SCHEMA_NAME                     = s.name,
        SCHEMA_OWNER                    = s.name,
        DEFAULT_CHARACTER_SET_CATALOG   = convert(sysname,N'master'),
        DEFAULT_CHARACTER_SET_SCHEMA    = convert(sysname,N'dbo'),
        DEFAULT_CHARACTER_SET_NAME      = convert(sysname,CollationPropertyFromId(-1, 'sqlcharsetname'))

    from
        sys.schemas s inner join
        sys.all_objects o on
            (
                o.schema_id = s.schema_id and
                (@schema_name is null or schema_id(@schema_name) = o.schema_id) and
                (@schema_owner is null or schema_id(@schema_owner) = o.schema_id)
            )

    order by 2
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

