## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MScdc_logddl\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MScdc_logddl**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -401610234 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@source_object_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@ddl_command| |nvarchar|1073741823|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@ddl_lsn| |binary|10|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@ddl_time| |nvarchar|1000|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@commit_lsn| |binary|10|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_column_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@fis_alter_column| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@fis_drop_table| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MScdc_logddl\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MScdc_logddl\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MScdc_logddl 
(
    @source_object_id int
    ,@ddl_command nvarchar(max)
    ,@ddl_lsn binary(10)
    ,@ddl_time nvarchar(1000)
    ,@commit_lsn binary(10)
    ,@source_column_id int = null
    ,@fis_alter_column bit = 0 
    ,@fis_drop_table bit = 0
)
AS
begin
    set nocount on

    declare @retcode int
        ,@db_name sysname
    --
    -- security check - should be dbo or sysadmin
    --
    exec @retcode = sp_MSreplcheck_publish
    if @@ERROR != 0 or @retcode != 0
        return 1

    --
    -- security check
    -- Has to be executed from cdc enabled db
    --
    if sys.fn_cdc_is_enabled_for_current_db () = 1
    begin
        set @db_name = db_name()
        RAISERROR(22901, 16, -1, @db_name)
        return (1)
    end
    
    -- Switch explicitly to execute as database 'cdc' user
    execute as user = 'cdc'
    
    -- Call internal stored procedure to actually do the work
    exec @retcode = sys.sp_cdc_logddl_internal
        @source_object_id
        ,@ddl_command
        ,@ddl_lsn
        ,@ddl_time
        ,@commit_lsn
        ,@source_column_id
        ,@fis_alter_column 
        ,@fis_drop_table
        
    -- Revert to authorization of caller    
    revert
    
    return @retcode
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

