## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_db_vardecimal_storage_format\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_db_vardecimal_storage_format**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -402855003 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@dbname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@vardecimal_storage_format| |varchar|3|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|Database Name|nvarchar|128|
|Vardecimal State|varchar|3|

|Name |Datatype |Max length |
|-|-|-|
|Available databases:|nvarchar|128|

|Name |Datatype |Max length |
|-|-|-|
|Database Name|nvarchar|128|
|Vardecimal State|varchar|3|

---
### Objects that depend on \[sys\].\[sp_db_vardecimal_storage_format\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_db_vardecimal_storage_format\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_db_vardecimal_storage_format    
    @dbname sysname = NULL,            -- database name to change
    @vardecimal_storage_format  varchar(3) = NULL    -- vardecimal format to turn on/off
as
    set nocount    on

    -- If db name is not given, enumerate all databases and print out their vardecimal state
    if @dbname is null
    begin
        select name as 'Database Name', 
        (case 
            when name in ('master', 'tempdb', 'model', 'msdb') then 'OFF'
            else 'ON'
        end) as 'Vardecimal State'
        from master.dbo.sysdatabases

        return (0)
    end
    
    --  Verify the database name and get info
    declare @dbid int
    select @dbid = dbid
        from master.dbo.sysdatabases
        where name = @dbname

    --  If @dbname not found, say so and list the databases.
    if @dbid is null
    begin
        raiserror(15010,-1,-1,@dbname)
        print ' '
        select 'Available databases:' = name
            from master.dbo.sysdatabases
        return (1)
    end

    -- The value specified must be 'ON' or 'OFF'.
    if @vardecimal_storage_format is not null and lower(@vardecimal_storage_format) not in ('on', 'off')
    begin
        raiserror(15229,-1,-1)
        return (1)
    end

    -- Determine whether it's a system database.
    declare @is_system_db bit
    if @dbname in ('master', 'tempdb', 'model', 'msdb')
        set @is_system_db = 1
    else
        set @is_system_db = 0

    if @vardecimal_storage_format is null
    begin
        -- Return ON or OFF based on whether the db is a system database.
        select @dbname as 'Database Name', 
            (case 
                when @is_system_db = 1 then 'OFF'
                else 'ON'
            end) as 'Vardecimal State'
        
        return (0)
    end

    -- Not supported in system databases.
    if @is_system_db = 1
    begin
        raiserror(15657, -1, -1, @dbname)
        return (1)
    end

    return (0) -- sp_db_vardecimal_storage_format
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

