## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_detach_db\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_detach_db**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -406286736 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@dbname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@skipchecks| |nvarchar|10|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@keepfulltextindexfile| |nvarchar|10|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_detach_db\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_detach_db\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_detach_db
    @dbname sysname = null,
    @skipchecks nvarchar(10) = null,
    @keepfulltextindexfile nvarchar(10) = null
as
    declare @dbid int
    declare @exec_stmt nvarchar(4000)

    if (SERVERPROPERTY('IsMatrix') = 1)
    begin
        raiserror (28401, -1, -1, N'sys.sp_detach_db')
        return (1)
    end

    if @dbname is null
    begin
        raiserror(15354,-1,-1)
        return(1)
    end

    if lower(@skipchecks) &lt;&gt; N'true'
        and lower(@skipchecks) &lt;&gt; N'false'
        and @skipchecks is not null
    begin
        raiserror(15354,-1,-1)
        return(1)
    end

    if    @keepfulltextindexfile is not null 
        and lower(@keepfulltextindexfile) &lt;&gt; N'true'
        and lower(@keepfulltextindexfile) &lt;&gt; N'false'
    begin
        raiserror(15354,-1,-1)
        return(1)
    end

    select @dbid = dbid from master.dbo.sysdatabases where name=@dbname
    if @dbid is null
    begin
        raiserror(15010,-1,-1,@dbname)
        return(1)
    end

    -- make sure not trying to detach within a transaction
    if @@trancount &gt; 0
    begin
        raiserror(15002,-1,-1,'sys.sp_detach_db')
        return(1)
    end

    -- run UPDATE STATISTICS on all tables in the database so they are current
    -- when transferred to READONLY media
    if lower(@skipchecks) &lt;&gt; N'true'
    begin
        select @exec_stmt = 'USE ' + quotename( @dbname , '[')
            + ' EXEC sys.sp_updatestats ''RESAMPLE'' '
        EXEC (@exec_stmt)
    end


    if @keepfulltextindexfile is null
    begin
        select @exec_stmt = 'DBCC DETACHDB ('
                + quotename( @dbname , '[')
                + ')'
    end
    else
    begin
        if lower(@keepfulltextindexfile) &lt;&gt; N'true' 
        begin
            select @exec_stmt = 'DBCC DETACHDB ('
                    + quotename( @dbname , '[')
                    + ', 0 )'
        end
        else
        begin
        select @exec_stmt = 'DBCC DETACHDB ('
                + quotename( @dbname , '[')
                + ', 1 )'
        end
    end

    EXEC (@exec_stmt)
    return (0) -- sp_detach_db
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

