## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSget_session_statistics\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSget_session_statistics**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -412973020 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@session_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSget_session_statistics\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSget_session_statistics\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSget_session_statistics 
(
@session_id int
) 
as 
begin
    declare @agent_id int
    declare @retcode int

    -- the merge agent calls this proc
    select @agent_id = 0
    select @agent_id = agent_id from dbo.MSmerge_sessions where session_id = @session_id

    -- Security Check
    exec @retcode = sys.sp_MScheck_pull_access @agent_id = @agent_id, @agent_type = 1 -- merge agent
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
            return (1)

    select  duration,
            upload_time,
            download_time,
            prepare_snapshot_time,
            schema_change_time,
            schema_changes,
            bulk_inserts,
            metadata_rows_cleanedup,
            estimated_upload_changes,
            estimated_download_changes
    from dbo.MSmerge_sessions with (nolock) where session_id = @session_id

    select  phase_id,
            article_name,
            duration,
            inserts,
            updates,
            deletes,
            conflicts,
            rows_retried,
            estimated_changes
     from dbo.MSmerge_articlehistory with (nolock) where session_id = @session_id
     
     return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

