## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_cursor_list\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_cursor_list**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -413804164 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@cursor_return| |int|4|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@cursor_scope| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_cursor_list\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_cursor_list\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
-- Creation of sp_cursor_list

create procedure sys.sp_cursor_list
(
   @cursor_return CURSOR VARYING OUTPUT,
   @cursor_scope int
)
AS

if (@cursor_scope &lt; 1) OR (@cursor_scope &gt; 3)
    begin
        /* Raise an error: ?The value of parameter  is invalid? */
        raiserror ( 16902, 1, 1,N'sys.sp_cursor_list', N'@cursor_scope')
        return (1)
    end

if ( @cursor_scope  &lt; 3)
begin
    set @cursor_return =  CURSOR LOCAL SCROLL DYNAMIC FOR
                    SELECT reference_name, cursor_name, cursor_scope,
                    status, model, concurrency, scrollable,
                    open_status, cursor_rows, fetch_status,
                    column_count, row_count, last_operation,
                    cursor_handle
                FROM sys.syscursorrefs scr, sys.syscursors sc
                WHERE     scr.cursor_scope = @cursor_scope AND
                    scr.cursor_handl = sc.cursor_handle
                ORDER BY cursor_handle
                FOR READ ONLY
end
else
begin
    set @cursor_return =  CURSOR LOCAL SCROLL DYNAMIC FOR
                    SELECT reference_name, cursor_name, cursor_scope,
                    status, model, concurrency, scrollable,
                    open_status, cursor_rows, fetch_status,
                    column_count, row_count, last_operation,
                    cursor_handle
                FROM sys.syscursorrefs scr, sys.syscursors sc
                WHERE scr.cursor_handl = sc.cursor_handle
                ORDER BY cursor_handle
                FOR READ ONLY
end
open @cursor_return
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

