## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_addrole\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_addrole**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -415394370 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@rolename| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@ownername| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_addrole\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_addrole\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_addrole
    @rolename   sysname,        -- name of new role
    @ownername  sysname = NULL  -- name of owner of new role
as
    -- SETUP RUNTIME OPTIONS / DECLARE VARIABLES --
    set nocount on
    declare @ret        int,    -- return value of sp call
            @owner      int,
            @stmtR        nvarchar(4000),
            @stmtS        nvarchar(4000)

    -- DISALLOW USER TRANSACTION --
    set implicit_transactions off
    if (@@trancount &gt; 0)
    begin
        raiserror(15002,-1,-1,'sys.sp_addrole')
        return (1)
    end

    exec @ret = sys.sp_validname @rolename
    if @ret &lt;&gt; 0
        return(1)

    if @ownername is null
        select @ownername = user_name()

    set @stmtR = 'create role '
    set @stmtR = @stmtR + quotename(@rolename, ']')
    set @stmtR = @stmtR + ' authorization '
    set @stmtR = @stmtR + quotename(@ownername, ']')

    -- Create Schema if not one exists with same name and owner
    set @stmtS = 'create schema '
    set @stmtS = @stmtS + quotename(@rolename, ']')
    set @stmtS = @stmtS + ' authorization '
    set @stmtS = @stmtS + quotename(@rolename, ']')

    BEGIN TRANSACTION

    -- issue DDL to create the role --
    exec (@stmtR)
    if @@error &lt;&gt; 0
    begin
        ROLLBACK TRANSACTION
        return (1)
    end


    -- create the Schema if not one exists with same name and owner
    declare @schema_uid int
    declare @owner_uid  int
    select @owner_uid  = principal_id from sys.database_principals where name = @rolename
    select @schema_uid = principal_id from sys.schemas where name = @rolename
    if (@schema_uid is null or        -- there is no schema since if there is one, it will have an owner
        @schema_uid &lt;&gt; @owner_uid)  -- for error message
    begin
        exec (@stmtS)
        if @@error &lt;&gt; 0
        begin
            ROLLBACK TRANSACTION
            return (1)
        end
    end

    COMMIT TRANSACTION

    -- RETURN SUCCESS --
    return (0) -- sp_addrole
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

