## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_cdc_get_captured_columns\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_cdc_get_captured_columns**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -416546841 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@capture_instance| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_cdc_get_captured_columns\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_cdc_get_captured_columns\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure [sys].[sp_cdc_get_captured_columns]                  
(                                                        
    @capture_instance        sysname
)                                                        
as
begin

    -- Verify database is currently enabled for change data capture
    if ([sys].[fn_cdc_is_db_enabled]() != 1)
    begin
        declare @db_name sysname
        set @db_name = db_name()
        raiserror(22901, 16, -1, @db_name)
        return 1
    end
    
    set @capture_instance = rtrim(@capture_instance)    
            
    if (@capture_instance is null) or (@capture_instance = N'')
    begin
        raiserror(22963, 16, -1, N'@capture_instance')
        return 1 
    end

    if ([sys].[fn_cdc_has_select_access](rtrim(@capture_instance)) = 0)
    begin
        raiserror(22981, 16, -1)
        return 1 
    end

    exec sys.sp_cdc_captured_columns @capture_instance 
        
    return 0
end                                                                
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

