## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSreset_attach_state\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSreset_attach_state**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -42516699 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscription_type| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSreset_attach_state\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSreset_attach_state\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSreset_attach_state 
(
    @publisher      sysname,                    -- publishing server name
    @publisher_db   sysname,                    -- publishing database name. If NULL then same as current db
    @publication    sysname,                    -- publication name,
    @subscription_type int
)
AS
BEGIN
    set nocount on
    declare  @retcode int
                ,@agent_id int

    --
    --  Security Check
    --
    EXEC @retcode = sys.sp_MSreplcheck_subscribe
    IF @@ERROR &lt;&gt; 0 or @retcode &lt;&gt; 0
        RETURN(1)
    --
    -- For non independent agent publications
    --
    if @publication is null or @publication = ''
        select @publication = 'ALL'
    --
    -- complete the operation in a transaction
    --
    begin transaction
    --
    -- Processing specific to Queued updating subscriptions
    --
    select @agent_id = id
    from dbo.MSsubscription_agents 
    where UPPER(publisher) = UPPER(@publisher)
        and publisher_db =  @publisher_db
        and publication = @publication
        and subscription_type = @subscription_type
        and update_mode in (2,3,4,5)
    if (@agent_id is not null)
    begin
        --
        -- reinitialize the queue for each article in this subscription
        --
        declare @artid int        
        declare #hc_article CURSOR LOCAL FORWARD_ONLY for 
            select artid 
            from dbo.MSsubscription_articles 
            where agent_id = @agent_id
        open #hc_article
        fetch #hc_article into @artid
        while (@@fetch_status != -1)
        begin        
            --
            -- we cannot have an NULL article id
            --
            if (@artid IS NULL)
            begin
                raiserror(20046, 16, 1)
                goto failure
            end
            --
            -- reset the queue
            --
            exec @retcode = sys.sp_MSreset_queue @publisher, @publisher_db, @publication, @artid
            IF (@retcode != 0 or @@ERROR != 0)
            begin
                raiserror(21465, 16, 1, 'sp_MSreset_queue')
                goto failure
            end
            --
            -- fetch next article
            --
            fetch #hc_article into @artid
        end -- while cursor
        close #hc_article
        deallocate #hc_article
    end -- end processing queued subscription
    --
    -- Update the attach state
    --
    update MSsubscription_agents 
    set attach_state = 0
    where UPPER(publisher) = UPPER(@publisher)
        and publisher_db =  @publisher_db
        and publication = @publication
        and subscription_type = @subscription_type
    if (@@error != 0)
        goto failure
    --
    -- All done 
    -- commit the transaction
    --
    commit transaction
    return (0)
failure:
    --
    -- Rollback transaction
    --
    if (@@trancount &gt; 0)
        rollback transaction
    return (1)
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

