## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_cdc_help_change_data_capture\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_cdc_help_change_data_capture**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -428413284 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@source_schema| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_cdc_help_change_data_capture\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_cdc_help_change_data_capture\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure [sys].[sp_cdc_help_change_data_capture]                  
(                                                        
    @source_schema sysname = null,
    @source_name sysname = null
)                                                        
as
begin
    set nocount on
    
    declare @retcode int,
        @capture_cnt int
        
    -- Verify database is currently enabled for change data capture
    if ([sys].[fn_cdc_is_db_enabled]() != 1)
    begin
        declare @db_name sysname
        set @db_name = db_name()
        raiserror(22901, 16, -1, @db_name)
        return 1
    end
    
    create table #capture_instances
    (
        capture_instance sysname collate database_default null,
        object_id int null
    )
    
    set @source_schema = rtrim(@source_schema)
    set @source_name   = rtrim(@source_name)
    
    -- Get a list of potential capture instances. 
    exec @retcode = sys.sp_cdc_get_capture_instances @source_schema, @source_name
    
    if @retcode &lt;&gt; 0
    begin
        return 1
    end            

    -- Eliminate from the list any entries that the caller is not
    -- authorized to access
    delete from #capture_instances
    where sys.fn_cdc_has_select_access(capture_instance) = 0
    
    -- If there are no elements in the #capture_instances and
    -- an explicit schema was entered, return error
    select @capture_cnt = count(*) from #capture_instances
    
    if (@capture_cnt = 0) and (@source_schema is not null)
    begin
        raiserror(22981, 16, -1)
        return 1 
    end
    
    -- Return information on capture instances 
    exec sys.sp_cdc_change_data_capture

    return 0
end                                                                
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

