## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSenumreplicas90\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSenumreplicas90**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -429768531 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
 No parameters exist

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSenumreplicas90\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSenumreplicas90\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_MSenumreplicas90
as
    declare @inactive tinyint

    -- Security check
    declare @retcode int
    exec @retcode = sys.sp_MSrepl_PAL_rolecheck 
    if (@retcode &lt;&gt; 0) or (@@error &lt;&gt; 0)
            return 1

    select @inactive = 0
    if object_id('sysmergesubscriptions') is NULL
    begin
        RAISERROR(20054 , 16, -1)
        return (1)
    end

    select subs.subid, subs.replnickname, 
           subs.subscriber_type, subs.subscription_type, 
           subs.priority, subs.schemaversion, subs.schemaguid, subs.datasource_type, NULL, subs.subscriber_server,  
           subs.db_name, subs.status, subs.replicastate, subs.sync_type, subs.description, subs.pubid, pubs.name, pubs.distributor,
           subs.replica_version
           from dbo.sysmergesubscriptions subs
           left outer join dbo.sysmergepublications pubs
           on subs.subid = pubs.pubid
           where subs.status &lt;&gt; @inactive
               and subs.subscriber_type = 1
               order by convert(binary, subs.subid)
    IF @@ERROR &lt;&gt;0 return (1) 
    return (0)
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

