## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_replmonitorhelpmergesubscriptionmoreinfo\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_replmonitorhelpmergesubscriptionmoreinfo**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -431730526 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscriber| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscriber_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_replmonitorhelpmergesubscriptionmoreinfo\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_replmonitorhelpmergesubscriptionmoreinfo\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_replmonitorhelpmergesubscriptionmoreinfo(
    @publisher            sysname,        /* Publisher server */
    @publisher_db            sysname,        /* Publisher database */
    @publication            sysname,        /* Publication name */
    @subscriber            sysname,        /* Subscriber server */
    @subscriber_db        sysname        /* Subscription database */
    )AS
begin
    declare @publisher_id smallint
    --
    -- security check
    -- only replmonitor can execute this
    --
    if not (is_member(N'db_owner') = 1 or isnull(is_member(N'replmonitor'),0) = 1)
    begin
        raiserror(14260, 16, -1)
        return (1)
    end
    
    select @publisher_id = srvid from master.dbo.sysservers where
       UPPER(srvname) = UPPER(@publisher)

    if @@rowcount &lt; 1 or @@error &lt;&gt; 0
    begin
        raiserror(25002, 16, -1)
        return (1)
    end

    select sub.subscriber_db as SubscriberDatabase,
       @publisher+'.'+@publisher_db as PublicationLocation, 
    sub.subscription_type as SubscriptionType,
    case when sub.subscription_type=1 then @publisher else UPPER(servers.srvname) end as MergeAgentLocation,
    agents.name as AgentName,
    sys.fn_add_units_to_date(pub.retention, pub.retention_period_unit, sessions.start_time) as TimeToExpire,
    (
    select ss1.start_time
    from dbo.MSmerge_sessions ss1
    where ss1.agent_id=agents.id and ss1.runstatus=8 -- REPL_STATUS_VALIDATION_PASS
    and ss1.timestamp = (
    select max(ss2.timestamp)
            from dbo.MSmerge_sessions ss2 
            where ss2.agent_id=agents.id and ss2.runstatus=8)) as LastSuccessfullValidationTime,
    (
    select ss1.start_time
    from dbo.MSmerge_sessions ss1
    where ss1.agent_id=agents.id and ss1.runstatus in (7,8) 
    and ss1.timestamp = (
    select max(ss2.timestamp)
            from dbo.MSmerge_sessions ss2 
            where ss2.agent_id=agents.id and ss2.runstatus in (7,8))) as LastAttemptedValidationTime
     from dbo.MSpublications pub, 
        dbo.MSmerge_subscriptions sub, 
        master.dbo.sysservers servers, 
        dbo.MSmerge_agents agents,
        dbo.MSmerge_sessions sessions,
    (
    select agent_id, max(start_time) as maxtime 
    from MSmerge_sessions group by agent_id
    ) as latest        
    where pub.publisher_id=@publisher_id and
        pub.publication=@publication and 
        pub.publisher_db=@publisher_db and
        pub.publication_type=2 and --merge
        sub.publisher_id=pub.publisher_id and
        sub.publisher_db=pub.publisher_db and
        sub.publication_id=pub.publication_id and 
        UPPER(sub.subscriber)=UPPER(@subscriber) and
        sub.subscriber_db=@subscriber_db and
        agents.publisher_id=@publisher_id and
        agents.publisher_db=pub.publisher_db and
        agents.publication=pub.publication and 
        UPPER(agents.subscriber_name)=UPPER(sub.subscriber) and 
    agents.subscriber_db=sub.subscriber_db and
    sessions.timestamp = (select max(timestamp)from dbo.MSmerge_sessions where agent_id=agents.id) and
    sessions.agent_id=agents.id and
    sessions.agent_id=latest.agent_id and 
    latest.maxtime=sessions.start_time and
    UPPER(servers.srvname) &lt;&gt; 'REPL_DISTRIBUTOR'
    order by agents.name
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

