## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_gettopologyinfo\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_gettopologyinfo**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -435721276 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@request_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_gettopologyinfo\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_gettopologyinfo\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_gettopologyinfo
(
    @request_id        int = NULL
)
as
begin

    declare @request_complete bit,
            @request_exists bit,
            @retcode        int

    exec @retcode = sys.sp_MSreplcheck_publish
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
    begin
        return 1
    end

    -- if no request_id is specified, get the most recent completed request
    if @request_id is NULL
    begin
        select @request_id = (select top 1 id
                             from MSpeer_topologyrequest
                             order by sent_date desc)

         if @@error &lt;&gt; 0 or @request_id is NULL
         begin
             return 1
         end
    end
    -- otherwise, make sure that the specified request exists
    else
    begin
        select @request_exists = (select case when exists(select * 
                                            from MSpeer_topologyrequest
                                            where id = @request_id
                                            ) then 0 else 1 end)

        if @@error &lt;&gt;0 or @request_exists &lt;&gt; 0
        begin
            return 1
        end
    end

    -- check to see if the request has been completed or not
    select @request_complete = (select case when exists(select * 
                                from MSpeer_topologyresponse 
                                where received_date is NULL
                                    and request_id = @request_id
                                ) then 1 else 0 end)

    -- format the xml nicely
    select * from
    (
        select 1 as Tag,
                NULL as Parent,
                sent_date as [TopologyInformation!1!RequestDate],
                NULL as [Publisher!2!!xmltext],
                NULL as [Publisher!2!ReceivedDate],
                NULL as [Publisher!2!Name],
                NULL as [Publisher!2!Database],
                NULL as [Publisher!2!Version],
                NULL as [Publisher!2!OriginatorId],
                NULL as [Publisher!2!ConflictRetention]
        from MSpeer_topologyrequest
        where id = @request_id
        union all
        select 2,1,
                sent_date,
                connection_info,
                received_date,
                peer,
                peer_db,
                cast(peer_version as nvarchar), -- cast(167773193 as nvarchar),
                cast(originator_id as nvarchar), -- cast(1 as nvarchar),
                cast(peer_conflict_retention as nvarchar) -- cast(60 as nvarchar)
        from MSpeer_topologyresponse join MSpeer_topologyrequest
            on id = request_id
        where id = @request_id
    ) as universal_table
    order by [TopologyInformation!1!RequestDate],[Publisher!2!ReceivedDate],[Publisher!2!Name],[Publisher!2!Database]
    for xml explicit

    if @@error &lt;&gt;0
    begin
        return 1
    end

    if @request_complete &lt;&gt; 0
    begin
        return 2
    end
    
     return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

