## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_removedbreplication\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_removedbreplication**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -439122265 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@dbname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@type| |nvarchar|5|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_removedbreplication\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_removedbreplication\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO



/* Permission to sysadmin - Wrapper to include security check*/
create procedure sys.sp_removedbreplication (
      @dbname     sysname = NULL,
      @type        nvarchar(5) = 'both'    -- 'merge' or 'tran' or 'both' to cleanup.
    ) AS
    set nocount on
    declare @retcode int
    declare @proc  nvarchar(255)
    
    /*
    ** Security Check: require sysadmin
    */
    IF (ISNULL(IS_SRVROLEMEMBER('sysadmin'),0) = 0)
    BEGIN
        RAISERROR(21089,16,-1) 
        RETURN (1)
    END
    
    if @dbname is NULL
        select @dbname = db_name()

    IF LOWER(@type collate SQL_Latin1_General_CP1_CS_AS) NOT IN ('merge', 'tran', 'both')
    BEGIN
        RAISERROR(22551, 16, -1, @type)
        RETURN (1)
    END
    
    if (convert(sysname,DATABASEPROPERTYEX(@dbname,'status'))  = 'ONLINE')
    begin
        exec @retcode = sys.sp_MSremovedbreplication_internal @dbname = @dbname,@type = @type,@ignore_distributor = 1

        -- does brute force clean up for merge
        IF LOWER(@type collate SQL_Latin1_General_CP1_CS_AS) IN ('merge', 'both')
        begin
            SELECT @proc = quotename(@dbname) + N'.sys.sp_MSremovedb_merge_replication_brute_force'    
               exec @retcode = @proc
        end

        IF LOWER(@type collate SQL_Latin1_General_CP1_CS_AS) = 'both'
        BEGIN
            -- drop replication symetrickey
            -- note that since this is brute force we will not confirm 
            -- whether or not replication is still enabled in the db
            SELECT @proc = QUOTENAME(@dbname) + N'.sys.sp_dropreplsymmetrickey'
            EXEC @retcode = @proc @check_replication = 0, @throw_error = 0
        END
        ELSE
        BEGIN
            -- drop replication symetrickey
            -- in this case since we are only dropping one merge/tran it's possibe
            -- that we still need the symetric key... so in this case we will check
            SELECT @proc = QUOTENAME(@dbname) + N'.sys.sp_dropreplsymmetrickey'
            EXEC @retcode = @proc @check_replication = 1, @throw_error = 0
        END
    end
    else
    begin 
        exec @retcode  = sys.sp_MSrepl_clean_replication_bit @dbname=@dbname,@type=@type         
    end
    

    if @@error &lt;&gt; 0 select @retcode = 1
    return @retcode

GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

