## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSrepl_testadminconnection\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSrepl_testadminconnection**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -439243665 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@distributor| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@password| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSrepl_testadminconnection\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSrepl_testadminconnection\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE sys.sp_MSrepl_testadminconnection
(
    @distributor        sysname,
    @password           sysname = null
)
AS
BEGIN
    DECLARE @retcode      int
    DECLARE @linkedsvr    sysname
    DECLARE @login        sysname

    -------- security check, db_owner
    EXEC @retcode = dbo.sp_MSreplcheck_publish
    IF @@ERROR &lt;&gt; 0 or @retcode &lt;&gt; 0
    BEGIN
        RETURN(1)
    END
    
    SELECT @linkedsvr    = CONVERT(sysname, newid()),
           @login        = N'distributor_admin'

    -- Verify @distributor
    IF @distributor IS NULL OR @distributor = N''
    BEGIN
        RAISERROR (14043, 16, -1, '@distributor', 'sp_MSrepl_testadminconnection')
        RETURN (1)
    END

    EXEC @retcode = sys.sp_validname @distributor

    IF @@ERROR &lt;&gt; 0 OR @retcode &lt;&gt; 0
       RETURN (1)

    -- Validate @password
    IF @password IS NULL OR @password = N''
    BEGIN
        RAISERROR(14043, 16, -1, N'@password', 'sp_MSrepl_testadminconnection')
        RETURN (1)
    END

    -- Add temporary linked server entry to test distributor_admin credentials
    EXEC @retcode = sys.sp_addserver  @linkedsvr
    IF @@error &lt;&gt; 0 OR @retcode &lt;&gt; 0
    BEGIN
        RETURN (1)
    END

    -- Mark system link
    EXECUTE @retcode = sys.sp_serveroption  @linkedsvr, 'system', 'true'
    IF @@error &lt;&gt; 0 OR @retcode &lt;&gt; 0
    BEGIN
        GOTO UNDO
    END

    -- Set net name of test link to distributor server name
    EXECUTE @retcode = sys.sp_setnetname  @linkedsvr, @distributor
    IF @@error &lt;&gt; 0 OR @retcode &lt;&gt; 0
    BEGIN
        GOTO UNDO
    END
        
    exec @retcode = sys.sp_addlinkedsrvlogin    @rmtsrvname  = @linkedsvr,
                                                @useself     = 'false',
                                                @locallogin  = NULL,
                                                @rmtuser     = @login,
                                                @rmtpassword = @password
    IF @@error &lt;&gt; 0 OR @retcode &lt;&gt; 0
    BEGIN
        GOTO UNDO
    END
    
    -- Test connection
    BEGIN TRY
        DECLARE @distproc nvarchar(max)
        DECLARE @result int
        
        SELECT @distproc = QUOTENAME(RTRIM(@linkedsvr)) + '.master.sys.sp_executesql'
        EXEC @retcode = @distproc N'SELECT @p1=@@microsoftversion', N'@p1 int OUTPUT', @result OUTPUT
    END TRY
    BEGIN CATCH
        RAISERROR(21670, 16, -1, @distributor)
        SET @retcode = 1
    END CATCH
    
    -- Cleanup
UNDO:
    IF EXISTS (SELECT * FROM sys.servers WHERE name = @linkedsvr)
    BEGIN
        EXEC sys.sp_dropserver @linkedsvr, 'droplogins'
    END
    
    RETURN (@retcode)
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

