## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_recompile\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_recompile**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -440656617 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@objname| |nvarchar|776|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_recompile\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_recompile\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_recompile
    @objname         nvarchar(776)
as
    -- do sets and declares
    Set nocount on
    declare @objid      int

    BEGIN TRANSACTION
    -- CHECK VALIDITY OF OBJECT NAME --
    --  (1) Must exist in current database
    --  (2) Must be a table or an executable object
    select @objid = object_id(@objname, 'local')

        if @objid is null OR
            (ObjectProperty(@objid, 'IsTable') = 0 AND ObjectProperty(@objid, 'IsExecuted') = 0)
        begin
            COMMIT TRANSACTION
            raiserror(15165,-1,-1,@objname)
            return @@error
        end

    if not (@objid is null)
    begin
        if (ObjectProperty(@objid, 'IsExecuted') &lt;&gt; 0 AND
            ObjectProperty(@objid, 'IsInlineFunction') = 0 AND
            ObjectProperty(@objid, 'IsView') = 0)
        begin
            -- The object has its own cache entry.  Removing it from cache will result in recompile on next execution.
            -- Recompiling plans referencing the object is not needed according to sp_recompile semantics in BOL,
            -- nor would it achieve anything useful.

            -- Check ALTER permission on the object.
            if has_perms_by_name(@objname, 'object', 'alter') = 0
            begin
                COMMIT TRANSACTION
                raiserror(15165,-1,-1,@objname)
                return @@error;
            end

            -- Remove the object from plan cache.
            declare @db_id int = db_id();
            EXEC sp_recompile_module @db_id, @objid
        end
        else
        begin
            -- For table/view/inline-function, all plans referencing the object need to be recompiled according to
            -- sp_recompile semantics in BOL.  Bump the schema version of the object to achieve this.
            
        -- LOCK, CHECK PERMISSION, BUMP SCHEMA FOR RECOMPILE  --
        EXEC %%Object(MultiName = @objname).LockMatchID(ID = @objid, Exclusive = 1, BindInternal = 0)
        if @@error &lt;&gt; 0
        begin
            COMMIT TRANSACTION
            raiserror(15165,-1,-1,@objname)
            return @@error
        end
    end
    end
        
    COMMIT TRANSACTION
    raiserror(15070,-1,-1,@objname)
    return (0) -- sp_recompile
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

