## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_cdc_dbsnapshotLSN\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_cdc_dbsnapshotLSN**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -44649105 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@db_snapshot| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@lastLSN| |binary|10|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@lastLSNstr| |varchar|40|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_cdc_dbsnapshotLSN\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_cdc_dbsnapshotLSN\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure [sys].[sp_cdc_dbsnapshotLSN]
(
    @db_snapshot sysname,
    @lastLSN binary(10) = null output,
    @lastLSNstr varchar(40) = null output
)
as
begin
    declare @command nvarchar(max), @str nvarchar(1000), @begin_char int
        ,@lsn binary(10), @lsn_str nvarchar(40), @db_snapshot_quoted nvarchar(1000)
    
    declare @temp table(parentObject nvarchar(255),Object nvarchar(255),field nvarchar(255),value nvarchar(255))
    
    -- Verify that the database snapshot exists
    if not exists (
        select name from sys.databases
        where name = @db_snapshot
        and source_database_id is not null)
    begin
        select @db_snapshot_quoted = quotename(@db_snapshot)
        raiserror(22862, 16, -1, @db_snapshot_quoted)
        return 1
    end         
    
    set @lsn = 0x00
    set @lsn_str = null
    set @command = N'dbcc dbtable(' + quotename(@db_snapshot) + N') with tableresults, no_infomsgs'
    
    insert into @temp exec( @command ) 
        select @str = value from @temp where field = N'm_splitPoint';
    
    if @str is not null
    begin    
        select @begin_char = CHARINDEX('(', @str)
        select @lsn_str = SUBSTRING(@str, @begin_char + 3, 8) + SUBSTRING(@str, @begin_char + 12, 8)
            + SUBSTRING(@str, @begin_char + 21, 4)
        select @lsn = sys.fn_cdc_hexstrtobin(@lsn_str)
    end
    
    set @lastLSN = @lsn
    set @lastLSNstr = @lsn_str        
   
    return 0    
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

