## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_cdc_change_job\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_cdc_change_job**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -446993105 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@job_type| |nvarchar|20|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@maxtrans| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@maxscans| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@continuous| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@pollinginterval| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@retention| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@threshold| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_cdc_change_job\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_cdc_change_job\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_cdc_change_job
(
    @job_type nvarchar(20) = N'capture',
    @maxtrans int = null,
    @maxscans int = null,
    @continuous bit = null,
    @pollinginterval bigint = null,
    @retention bigint = null,
    @threshold bigint = null
)    
as
begin
    set nocount on

    declare @retcode int
        ,@db_name sysname
        
    set @db_name = db_name()    

    --
    -- Job security check proc
    --
    exec @retcode = [sys].[sp_MScdc_job_security_check]
    if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
        return(1)
        
    -- Verify database is currently enabled for change data capture
    if ([sys].[fn_cdc_is_db_enabled]() != 1)
    begin
        raiserror(22901, 16, -1, @db_name)
        return 1
    end
        
    set @job_type = rtrim(ltrim(lower(@job_type)))
        
    -- Verify parameter
    if @job_type not in (N'capture', N'cleanup')
    begin
        raiserror(22992, 16, -1, @job_type)
        return(1)
    end
   
    if (serverproperty('EngineEdition') &lt;&gt; 5)
    begin
    -- Call internal stored procedure to complete verification and update job attributes
    exec @retcode = sys.sp_cdc_change_job_internal
        @job_type,
        @maxtrans,
        @maxscans,
        @continuous,
        @pollinginterval,
        @retention,
        @threshold
    end
    else
    begin
        -- Call internal stored procedure to complete verification and update job attributes
        exec @retcode = sys.sp_cdc_change_job_internal_db_scoped
            @job_type,
            @maxtrans,
            @maxscans,
            @continuous,
            @pollinginterval,
            @retention,
            @threshold
    end
        
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
        return 1
        
    return 0        
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

