## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MScheckfailedprevioussync\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MScheckfailedprevioussync**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -447334294 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@pubid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@last_sync_failed| |bit|1|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MScheckfailedprevioussync\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MScheckfailedprevioussync\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

/*
  *  This proc is called on subscriber when the merge agent wants to do
  * consolidation of generations. This proc checks of the last sync failed.
  * If the last sync failed then the merge agent does not do consolidation.
  * This procs checks for any generations with genstatus of 4 in the genshistory
  * table to make this determination.  
*/
create procedure sys.sp_MScheckfailedprevioussync
    @pubid uniqueidentifier,
    @last_sync_failed bit output
as

    declare @retcode int

    -- Security check
    exec @retcode = sys.sp_MSrepl_PAL_rolecheck 
    if (@retcode &lt;&gt; 0) or (@@error &lt;&gt; 0)
            return 1

    exec @retcode = sys.sp_MSreplcheck_subscribe
    if (@retcode &lt;&gt; 0) or (@@error &lt;&gt; 0)
        return 1

    if exists(select * from dbo.MSmerge_genhistory mgh JOIN dbo.sysmergearticles sma
                ON mgh.art_nick = sma.nickname
                where mgh.genstatus = 4 and 
                    (sma.pubid = @pubid or mgh.art_nick = 0))
    begin
        select @last_sync_failed = 1
    end
    else
    begin
        select @last_sync_failed = 0
    end

    return 0
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

