## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_tables_ex\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_tables_ex**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -447552688 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@table_server| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@table_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@table_schema| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@table_catalog| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@table_type| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@fUsePattern| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|TABLE_CAT|nvarchar|128|
|TABLE_SCHEM|nvarchar|128|
|TABLE_NAME|nvarchar|128|
|TABLE_TYPE|nvarchar|128|
|REMARKS|nvarchar|255|

|Name |Datatype |Max length |
|-|-|-|
|TABLE_CAT|nvarchar|128|
|TABLE_SCHEM|nvarchar|128|
|TABLE_NAME|nvarchar|128|
|TABLE_TYPE|nvarchar|128|
|REMARKS|nvarchar|255|

---
### Objects that depend on \[sys\].\[sp_tables_ex\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_tables_ex\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_tables_ex
(
    @table_server       sysname,
    @table_name         sysname = null,
    @table_schema       sysname = null,
    @table_catalog      sysname = null,
    @table_type         sysname = null,
    @fUsePattern        bit = 1 -- To allow users to explicitly disable all pattern matching.
)
as
    if (@fUsePattern = 1) -- Does the user want it?
    begin
        if ((isnull(charindex('%', @table_name),0) = 0) and
            (isnull(charindex('[', @table_name),0) = 0) and
            (isnull(charindex('_', @table_name),0) = 0) and
            (isnull(charindex('%', @table_schema),0) = 0) and
            (isnull(charindex('[', @table_schema),0) = 0) and
            (isnull(charindex('_', @table_schema),0) = 0) and
            (isnull(charindex('%', @table_catalog),0) = 0) and
            (isnull(charindex('[', @table_catalog),0) = 0) and
            (isnull(charindex('_', @table_catalog),0) = 0))
        begin
            select @fUsePattern = 0 -- not a single wild char, so go the fast way.
        end
    end

    if @fUsePattern = 0
    begin
        /* -- Debug output, do not remove it.
        print '*************'
        print 'No pattern matching.'
        print @fUsePattern
        print isnull(@table_server, '@table_server = null')
        print isnull(@table_name, '@table_name = null')
        print isnull(@table_schema, '@table_schema = null')
        print isnull(@table_catalog, '@table_catalog = null')
        print isnull(@table_type, '@table_type = null')
        print '*************'
        */
        select
            TABLE_CAT   = rt.TABLE_CATALOG,
            TABLE_SCHEM = rt.TABLE_SCHEMA,
            TABLE_NAME  = rt.TABLE_NAME,
            TABLE_TYPE  = rt.TABLE_TYPE,
            REMARKS     = convert(nvarchar(255),rt.DESCRIPTION)
        from
            -- We can not pass @table_type directly here, because in ODBC we enclose
            -- it in '', which is not acceptable for OLEDB SProc.
            sys.fn_remote_tables(@table_server,
                                 @table_catalog,
                                 @table_schema,
                                 @table_name,
                                 NULL) rt
        where
            (charindex ('' + TABLE_TYPE + '', @table_type) &lt;&gt; 0 or @table_type is NULL)
        order by 4, 1, 2, 3
    end
    else
    begin
        /* -- Debug output, do not remove it.
        print '*************'
        print 'THERE IS pattern matching!'
        print @fUsePattern
        print isnull(@table_server, '@table_server = null')
        print isnull(@table_name, '@table_name = null')
        print isnull(@table_schema, '@table_schema = null')
        print isnull(@table_catalog, '@table_catalog = null')
        print isnull(@table_type, '@table_type = null')
        print '*************'
        */
        select
            TABLE_CAT   = TABLE_CATALOG,
            TABLE_SCHEM = TABLE_SCHEMA,
            TABLE_NAME  = TABLE_NAME,
            TABLE_TYPE  = TABLE_TYPE,
            REMARKS     = convert(nvarchar(255),DESCRIPTION)
        from
            sys.fn_remote_tables(@table_server,
                                 @table_catalog,
                                 NULL,
                                 NULL,
                                 NULL)
        where
            (TABLE_SCHEMA like @table_schema or
             @table_schema is NULL or
             (TABLE_SCHEMA is NULL and @table_schema = N'%')) and
            (TABLE_CATALOG like @table_catalog or
             @table_catalog is NULL or
             (TABLE_CATALOG is NULL and @table_catalog = N'%')) and
            (charindex ('' + TABLE_TYPE + '', @table_type) &lt;&gt; 0 or @table_type is NULL) and
            (TABLE_NAME like @table_name or
             @table_name is NULL)
        order by 4, 1, 2, 3
    end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

