## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSupdate_subscriber_tracer_history\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSupdate_subscriber_tracer_history**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -448402955 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@parent_tracer_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@agent_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSupdate_subscriber_tracer_history\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSupdate_subscriber_tracer_history\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
--
-- Name: 
--        sp_MSupdate_subscriber_tracer_history
-- 
-- Description: 
--        This procedure will update the MStracer_history row's subscriber_commit  
--        time to getdate(). 
--  
-- Parameters: 
--        @parent_tracer_id    int                tracer id of the parent
--        @subscriber            sysname            subscriber server name
--        @subscriber_db        sysname            subscriber database
--
-- Returns: 
--        0 - succeeded
--      1 - failed
--
-- Result: 
--        None
--
-- Security: 
--        Sysadmin/dbo/pal (run by distribution agent)
--
create procedure sys.sp_MSupdate_subscriber_tracer_history
(
    @parent_tracer_id    int,
    @agent_id            int
)
as
begin
    set nocount on

    declare @retcode         int,
            @current_date    datetime

    select @current_date = getdate()
    
    -- security check
    exec @retcode = sys.sp_MScheck_pull_access @agent_id = @agent_id, @agent_type = 0
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
    begin
        return 1 
    end
    
    begin transaction tr_sp_MSupd_sub_tracer_hist
    save transaction tr_sp_MSupd_sub_tracer_hist
    
    -- here we will update the subscriber commit time
    -- if the tracer history row no longer exists then
    -- we will exit with no error because this may happen
    -- if cleanup comes bye and removes the history row
    update MStracer_history
        set subscriber_commit = @current_date
        where parent_tracer_id = @parent_tracer_id
            and agent_id = @agent_id
    if @@error &lt;&gt; 0
        goto Err_Handler

    commit transaction tr_sp_MSupd_sub_tracer_hist
    return 0

Err_Handler:
    rollback transaction tr_sp_MSupd_sub_tracer_hist
    commit transaction

    return 1
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

