## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_helplinkedsrvlogin\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_helplinkedsrvlogin**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -449526256 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@rmtsrvname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@locallogin| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|Linked Server|nvarchar|128|
|Local Login|nvarchar|128|
|Is Self Mapping|bit|1|
|Remote Login|nvarchar|128|

---
### Objects that depend on \[sys\].\[sp_helplinkedsrvlogin\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_helplinkedsrvlogin\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_helplinkedsrvlogin
    @rmtsrvname        sysname = NULL,
    @locallogin        sysname = NULL
as
    declare    @srvid    int,
            @lgnid    int

    -- CHECK REMOTE SERVER NAME.
    if @rmtsrvname is not null
    begin
        select @srvid = server_id from sys.servers where name = @rmtsrvname
        if @srvid is null
        begin
        raiserror(15015,-1,-1,@rmtsrvname)
        return (1)
        end
    end

    -- IF SPECIFIED CHECK LOCAL USER NAME
    if (@locallogin IS NOT NULL)
    begin
        select @lgnid = principal_id from sys.server_principals where name = @locallogin
    end
    
    select    u.name as [Linked Server], t.name as [Local Login],
        s.uses_self_credential as [Is Self Mapping], s.remote_name as [Remote Login]
    from sys.linked_logins s left join sys.server_principals t
        on s.local_principal_id=t.principal_id, sys.servers u
    where ((@srvid is null or @srvid=u.server_id) and u.server_id= s.server_id)
        and (@locallogin is null or @lgnid=s.local_principal_id)
    order by u.name

    -- RETURN SUCCESS
    return(0) -- sp_helplinkedsrvlogin
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

