## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_scriptsubconflicttable\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_scriptsubconflicttable**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -45325850 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@article| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@alter| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@usesqlclr| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_scriptsubconflicttable\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_scriptsubconflicttable\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_scriptsubconflicttable (
    @publication sysname
    ,@article sysname
    ,@alter bit = 0 -- if 1 script alter, otherwise script create
    ,@usesqlclr bit = 1
    )
as
begin
    declare @retcode int

    --
    -- Security Check.
    --
    exec @retcode = sys.sp_MSreplcheck_publish
    if (@@error != 0 or @retcode != 0)
        return (1)

    --
    -- Parameter Check: @publication.
    -- The @publication cannot be NULL and must conform to the rules
    -- for identifiers.
    --
    if (@publication IS NULL)
    begin
        raiserror (14043, 16, 2, '@publication', 'sp_scriptsubconflicttable')
        return (1)
    end
    exec @retcode = sys.sp_validname @publication
    if (@retcode != 0)
        return (1)

    --
    -- Parameter Check: @article.
    -- The @article cannot be NULL and must conform to the rules
    -- for identifiers.
    --  
    exec @retcode = sys.sp_MSreplcheck_name @article, '@article', 'sp_scriptsubconflicttable'
    if (@@error != 0 or @retcode != 0)
        return (1)

    if LOWER(@article) = 'all'
    begin
        raiserror (14032, 16, 2, '@article')
        return (1)
    end

    --
    -- now call the SP to generate the script
    --
    exec @retcode = sys.sp_MSmakeconflicttable @article = @article, @publication = @publication, @creation_mode = 1, @is_debug = 0, @alter = @alter, @usesqlclr = @usesqlclr
    return @retcode
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

