## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSsetgentozero\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSsetgentozero**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -454277964 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@tablenick| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@rowguid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@metatype| |tinyint|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSsetgentozero\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSsetgentozero\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSsetgentozero
        (@tablenick int, 
         @rowguid uniqueidentifier,
         @metatype tinyint= null)
as
    declare @retcode int
    declare @METADATA_TYPE_Tombstone tinyint
    declare @METADATA_TYPE_Contents tinyint
    declare @METADATA_TYPE_PartialDelete tinyint
    declare @METADATA_TYPE_SystemDelete tinyint

    set @METADATA_TYPE_Tombstone= 1
    set @METADATA_TYPE_Contents= 2
    set @METADATA_TYPE_PartialDelete= 5
    set @METADATA_TYPE_SystemDelete= 6
    
    if (@rowguid is null)
    begin
        RAISERROR(14043, 16, -1, '@rowguid', 'sp_MSsetgentozero')
        return (1)
    end
    if (@tablenick is null)
    begin
        RAISERROR(14043, 16, -1, '@tablenick', 'sp_MSsetgentozero')
        return (1)
    end
    if (@metatype is not null and 
        @metatype not in (@METADATA_TYPE_Tombstone,
                          @METADATA_TYPE_Contents,
                          @METADATA_TYPE_PartialDelete,
                          @METADATA_TYPE_SystemDelete))
    begin
        --RAISERROR(20052, 16, -1)
        return 0
    end

    -- security check
    exec @retcode = sys.sp_MSrepl_PAL_rolecheck @tablenick = @tablenick
    if (@retcode &lt;&gt; 0) or (@@error &lt;&gt; 0)
        return 1

    if @metatype in (@METADATA_TYPE_Tombstone,
                     @METADATA_TYPE_PartialDelete,
                     @METADATA_TYPE_SystemDelete)
    begin
                update dbo.MSmerge_tombstone 
                        set generation = 0
                        where tablenick = @tablenick and rowguid = @rowguid
    end
    else if @metatype = @METADATA_TYPE_Contents
    begin
                update dbo.MSmerge_contents 
                        set generation = 0
                        where tablenick = @tablenick and rowguid = @rowguid

                update dbo.MSmerge_past_partition_mappings 
                        set generation = 0 
                        where tablenick = @tablenick and rowguid = @rowguid
    end
    else
    begin
                update dbo.MSmerge_tombstone 
                        set generation = 0
                        where tablenick = @tablenick and rowguid = @rowguid

                if 0 = @@rowcount
                begin
                        update dbo.MSmerge_contents 
                                set generation = 0
                                where tablenick = @tablenick and rowguid = @rowguid
                end
        
        update dbo.MSmerge_past_partition_mappings 
            set generation = 0 
            where tablenick = @tablenick and rowguid = @rowguid
    end

    return 0
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

