## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_table_types_rowset\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_table_types_rowset**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -454617025 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@table_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@table_schema| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|TABLE_CATALOG|nvarchar|128|
|TABLE_SCHEMA|nvarchar|128|
|TABLE_NAME|nvarchar|128|
|TABLE_TYPE|nvarchar|30|
|TABLE_GUID|uniqueidentifier|16|
|DESCRIPTION|nvarchar|1|
|TABLE_PROPID|int|4|
|DATE_CREATED|datetime|8|
|DATE_MODIFIED|datetime|8|

---
### Objects that depend on \[sys\].\[sp_table_types_rowset\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_table_types_rowset\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_table_types_rowset
(
    @table_name     sysname = null,
    @table_schema   sysname = null
)
as
    select
        TABLE_CATALOG   = s_tr.TABLE_CATALOG,
        TABLE_SCHEMA    = s_tr.TABLE_SCHEMA,
        TABLE_NAME      = s_tr.TABLE_NAME,
        TABLE_TYPE      = s_tr.TABLE_TYPE,
        TABLE_GUID      = s_tr.TABLE_GUID,
        DESCRIPTION     = s_tr.DESCRIPTION,
        TABLE_PROPID    = s_tr.TABLE_PROPID,
        DATE_CREATED    = s_tr.DATE_CREATED,
        DATE_MODIFIED   = s_tr.DATE_MODIFIED
    from
        sys.spt_table_types_view s_tr
    where
        (@table_name is null or s_tr.TABLE_NAME = @table_name) and
        (@table_schema is null or schema_id(@table_schema) = s_tr.schema_id)
    order by 4, 2, 3
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

