## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_kill_filestream_non_transacted_handles\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_kill_filestream_non_transacted_handles**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -45895095 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@table_name| |nvarchar|776|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@handle_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_kill_filestream_non_transacted_handles\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_kill_filestream_non_transacted_handles\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_kill_filestream_non_transacted_handles
(
    @table_name nvarchar(776) = NULL,
    @handle_id int = -1
)
as
begin
    set nocount    on
    declare @returncode int
    declare @dbid int = db_id()
    declare @hasAccess bit

    -- Check permissions, must have database control permissions to kill handles.
    -- Members of the sysadmin server role and those with SERVER CONTROL have implicit 
    -- DATABASE CONTROL access.
   set @hasAccess = 
       has_perms_by_name(quotename(db_name()), 'DATABASE', 'CONTROL')
    if @hasAccess = 0 OR @hasAccess IS NULL
    begin
        raiserror(33428,-1,-1,@dbid)
        return 1
    end

    EXEC @returncode = sys.sp_kill_filestream_non_transacted_handles_internal @table_name, @handle_id

    return @returncode
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

