## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_assemblies_rowset2\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_assemblies_rowset2**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -460357477 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@assembly_schema| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@assembly_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|ASSEMBLY_CATALOG|nvarchar|128|
|ASSEMBLY_SCHEMA|nvarchar|128|
|ASSEMBLY_NAME|nvarchar|128|
|ASSEMBLY_ID|int|4|
|PERMISSION_SET|nvarchar|30|
|ASSEMBLY_BINARY|varbinary|2147483647|

---
### Objects that depend on \[sys\].\[sp_assemblies_rowset2\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_assemblies_rowset2\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_assemblies_rowset2
(
    @assembly_schema    sysname = null,
    @assembly_id        int = null
)
as
    select
        ASSEMBLY_CATALOG    = db_name(),
        ASSEMBLY_SCHEMA     = user_name(a.principal_id),
        ASSEMBLY_NAME       = a.name,
        ASSEMBLY_ID         = convert(int,a.assembly_id),
        PERMISSION_SET      = convert(NVARCHAR(30),
                                    case a.permission_set
                                    when 1 then 'SAFE'
                                    when 2 then 'EXTERNAL_ACCESS'
                                    when 3 then 'UNSAFE'
                                    end),
        ASSEMBLY_BINARY     = af.content
    from
        sys.assemblies a inner join
        sys.assembly_files af on
            (
                af.assembly_id = a.assembly_id
            )
    where
        (@assembly_schema is null or @assembly_schema = user_name(a.principal_id)) and
        (@assembly_id is null or @assembly_id = a.assembly_id)
    order by 1, 2, 3
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

