## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_cdc_cleanup_change_table\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_cdc_cleanup_change_table**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -46352811 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@capture_instance| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@low_water_mark| |binary|10|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@threshold| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_cdc_cleanup_change_table\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_cdc_cleanup_change_table\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure [sys].[sp_cdc_cleanup_change_table]
(
    @capture_instance sysname,
    @low_water_mark    binary(10),
    @threshold bigint = 5000
)
as
begin
    declare @retcode int
            ,@db_name sysname
            ,@xstr1 nvarchar(22)
    
    set nocount on
    
    set @db_name = db_name()

    -- Verify caller is authorized to clean up change tracking  
    if (isnull(is_srvrolemember('sysadmin'),0) = 0) and (isnull(is_member('db_owner'),0) = 0)
    begin
           raiserror(22904, 16, -1)
        return 1
    end
    
    -- Verify database is enabled for change tracking 
    if ([sys].[fn_cdc_is_db_enabled]() != 1)
    begin
        raiserror(22910, 16, -1, @db_name)
        return 1
    end
    
    -- Parameter @threshold must be positive
    if (@threshold &lt;= 0)
    begin
          raiserror(22850, 16, -1)
        return 1
    end

    -- If non-null, parameter @low_water_mark must appear as the start_lsn 
    -- value of a current entry in the cdc.lsn_time_mapping table.
    if (@low_water_mark is not null)
    begin
        if not exists
            ( select start_lsn from cdc.lsn_time_mapping
            where start_lsn = @low_water_mark )
        begin
            set @xstr1 = upper(sys.fn_varbintohexstr(@low_water_mark))
            raiserror(22964, 16, -1, @xstr1)
            return 1
        end
    end          

    -- Call internal stored procedure to do the work 
    -- Switch to database 'cdc' user to mitigate against malicious dbo triggers
    execute as user = 'cdc'
       
    exec @retcode = sys.sp_cdc_cleanup_change_table_internal
        @capture_instance,
        @low_water_mark,
        @threshold
        
    if (@@error &lt;&gt; 0) or (@retcode &lt;&gt; 0)
    begin
        revert
        return 1
    end
    
    revert
    
    return 0        
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

