## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSenumdeleteslightweight\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSenumdeleteslightweight**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -466710890 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@pubid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@tablenick| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@lastrowguid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@maxrows| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSenumdeleteslightweight\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSenumdeleteslightweight\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSenumdeleteslightweight
    @pubid            uniqueidentifier,
    @tablenick        int,
    @lastrowguid    uniqueidentifier,
    @maxrows         int
as
    set nocount on

    declare @pubnick    int
    declare @METADATA_TYPE_DeleteLightweight tinyint
    declare @last_art_processing_order int
    declare @maxint int
    declare @retcode int

    -- security check
    exec @retcode = sys.sp_MSreplcheck_subscribe
    if (@retcode &lt;&gt; 0 or @@error &lt;&gt; 0)
        return 1

    set @METADATA_TYPE_DeleteLightweight= 10
    set @maxint= 2147483647

    if 0 = @maxrows
    begin
        set @maxrows= @maxint
    end
    
    select @pubnick = sync_info from dbo.MSmerge_replinfo where repid = @pubid

    -- Step 1: Set the localid value for the deletes that will be enumerated.
    --            That localid will be reset upon downloading the proxied metadata
    --           from that publisher.
    -- Step 2: Enumerate all those rows whose localid has just been set.
    --
    if @tablenick = 0
    begin
        -- Step 1
        update rt
            set rt.sync_cookie= @pubnick
            from dbo.MSmerge_rowtrack rt join dbo.sysmergearticles art
            on rt.tablenick = art.nickname
            where art.pubid = @pubid and
                  rt.changetype = @METADATA_TYPE_DeleteLightweight

        -- Step 2
        select top (@maxrows) rt.tablenick, rt.rowguid, rt.rowvector
            from dbo.MSmerge_rowtrack rt join dbo.sysmergearticles art
            on rt.tablenick = art.nickname
            where art.pubid = @pubid and
                  rt.changetype = @METADATA_TYPE_DeleteLightweight and
                  rt.sync_cookie = @pubnick
            order by art.processing_order desc, rt.tablenick desc, rt.rowguid asc
    end
    else
    begin
        exec sys.sp_MSget_lightweightarticle_processing_order @tablenick, @pubid, @last_art_processing_order output
        
        -- Step 1
        update rt
            set rt.sync_cookie= @pubnick
            from dbo.MSmerge_rowtrack rt join dbo.sysmergearticles art
            on rt.tablenick = art.nickname
            where art.pubid = @pubid and
                  rt.changetype = @METADATA_TYPE_DeleteLightweight and
                  ((rt.tablenick = @tablenick and rt.rowguid &gt; @lastrowguid)
                    or
                    (art.processing_order = @last_art_processing_order and rt.tablenick &lt; @tablenick)
                    or 
                    art.processing_order &lt; @last_art_processing_order
                  )

        -- Step 2
        select top (@maxrows) rt.tablenick, rt.rowguid, rt.rowvector
            from dbo.MSmerge_rowtrack rt join dbo.sysmergearticles art
            on rt.tablenick = art.nickname
            where art.pubid = @pubid and
                  rt.changetype = @METADATA_TYPE_DeleteLightweight and
                  ((rt.tablenick = @tablenick and rt.rowguid &gt; @lastrowguid)
                    or
                    (art.processing_order = @last_art_processing_order and rt.tablenick &lt; @tablenick)
                    or 
                    art.processing_order &lt; @last_art_processing_order
                  ) and
                  rt.sync_cookie = @pubnick
            order by art.processing_order desc, rt.tablenick desc, rt.rowguid asc
    end

    return 0
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

