## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_helptrigger\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_helptrigger**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -469610141 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@tabname| |nvarchar|776|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@triggertype| |char|6|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|trigger_name|nvarchar|128|
|trigger_owner|nvarchar|128|
|isupdate|int|4|
|isdelete|int|4|
|isinsert|int|4|
|isafter|int|4|
|isinsteadof|int|4|
|trigger_schema|nvarchar|128|

---
### Objects that depend on \[sys\].\[sp_helptrigger\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_helptrigger\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_helptrigger
    @tabname        nvarchar(776),        -- Table name
    @triggertype    char(6) = NULL    -- Trigger type
as

declare @objid int,        /* id of the object */
        @dbname sysname

-- Check to see that the object names are local to the current database.
select @dbname = parsename(@tabname,3)
       ,@triggertype = UPPER (@triggertype collate Latin1_General_CI_AS)
if @dbname is null
    select @dbname = db_name()
else if @dbname &lt;&gt; db_name()
    begin
        raiserror(15250,-1,-1)
        return (1)
    end

select @objid = object_id from sys.objects where object_id = object_id(@tabname) and type in ('U', 'V')
if @objid is null
    begin
        raiserror(15009,-1,-1,@tabname,@dbname)
        return(1)
    end

/*    Check that input type is update, INSERT, DELETE    */
if @triggertype  is not null and not @triggertype in ('UPDATE', 'INSERT', 'DELETE')
      begin
         raiserror(15305,-1,-1)
         return(1)
      end

select
    trigger_name = name,
    trigger_owner = user_name(ObjectProperty( object_id, 'ownerid')),
    isupdate = ObjectProperty( object_id, 'ExecIsUpdateTrigger'),
    isdelete = ObjectProperty( object_id, 'ExecIsDeleteTrigger'),
    isinsert = ObjectProperty( object_id, 'ExecIsInsertTrigger'),
    isafter = ObjectProperty( object_id, 'ExecIsAfterTrigger'),
    isinsteadof = ObjectProperty( object_id, 'ExecIsInsteadOfTrigger'),
    trigger_schema = schema_name(schema_id)
    from sys.objects
    where parent_object_id = @objid and type IN ('TR','TA')
    AND (    @triggertype is NULL
        OR    ( @triggertype = 'DELETE' AND ObjectProperty( object_id, 'ExecIsDeleteTrigger') = 1 )
        OR    ( @triggertype = 'INSERT' AND ObjectProperty( object_id, 'ExecIsInsertTrigger') = 1 )
        OR    ( @triggertype = 'UPDATE' AND ObjectProperty( object_id, 'ExecIsUpdateTrigger') = 1 ) )

return(0)  --sp_helptrigger
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

