## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSget_logicalrecord_lineage\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSget_logicalrecord_lineage**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -469796406 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@pubid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@parent_nickname| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@parent_rowguid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@dest_common_gen| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSget_logicalrecord_lineage\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSget_logicalrecord_lineage\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSget_logicalrecord_lineage(@pubid uniqueidentifier, @parent_nickname int, @parent_rowguid uniqueidentifier, @dest_common_gen bigint)
AS
begin
        
    declare @metadata_type  tinyint, 
                    @logical_record_lineage varbinary(311),
                    @retcode smallint,
                    @procname nvarchar(270),
                    @num_dest_changed_rows int
                        
    exec @retcode = sys.sp_MSrepl_PAL_rolecheck @pubid = @pubid 
    if (@retcode &lt;&gt; 0) or (@@error &lt;&gt; 0)
        return 1
        
    select @procname= 'dbo.' + select_proc from dbo.sysmergearticles 
            where nickname = @parent_nickname and pubid=@pubid
            
    set @metadata_type = 4
    set @logical_record_lineage = NULL
    set @num_dest_changed_rows = 0
    
    -- check for row in base table
    exec @retcode= @procname @maxschemaguidforarticle = NULL, @type=@metadata_type output, @rowguid=@parent_rowguid
    if @@error &lt;&gt;0 or @retcode &lt;&gt; 0 
        return (1)
        
    begin tran
    if (@metadata_type = 3)
    begin
                select @metadata_type = 2, @logical_record_lineage = logical_record_lineage
               from dbo.MSmerge_contents
               with (serializable)
               where tablenick = @parent_nickname and rowguid = @parent_rowguid
    end
    else
    begin
                -- row is not in base table; either it is in tombstone, or it is missing
        set @metadata_type= 0
        
        select  @metadata_type = type, @logical_record_lineage = logical_record_lineage
                                from dbo.MSmerge_tombstone where
                                tablenick = @parent_nickname and rowguid = @parent_rowguid
     end
     
    select @num_dest_changed_rows = count(*) from dbo.MSmerge_contents mc join 
                    (select distinct nickname from dbo.sysmergepartitioninfoview where logical_record_parent_nickname = @parent_nickname)
                    as smpi
                on mc.tablenick = smpi.nickname
                and mc.logical_record_parent_rowguid = @parent_rowguid
                and (mc.generation &gt; @dest_common_gen or mc.generation = 0)
                
        select @num_dest_changed_rows = @num_dest_changed_rows + count(*) from dbo.MSmerge_tombstone mc 
            join (select distinct nickname from dbo.sysmergepartitioninfoview where logical_record_parent_nickname = @parent_nickname)
                    as smpi
                on mc.tablenick = smpi.nickname
                and mc.logical_record_parent_rowguid = @parent_rowguid
                and (mc.generation &gt; @dest_common_gen or mc.generation = 0)
                
        commit tran

        -- select out our result set
    select @logical_record_lineage, @metadata_type, @num_dest_changed_rows

    return (0)
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

