## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSsendtosqlqueue\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSsendtosqlqueue**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -477530043 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@objid| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@owner| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@tranid| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@data| |varbinary|8000|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@datalen| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@commandtype| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@cmdstate| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSsendtosqlqueue\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSsendtosqlqueue\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSsendtosqlqueue (
    @objid int
    ,@publisher sysname
    ,@publisher_db sysname
    ,@publication sysname
    ,@owner sysname
    ,@tranid sysname
    ,@data varbinary(8000)
    ,@datalen int
    ,@commandtype int = 1
    ,@cmdstate bit = 0
)
as
begin
    set nocount on
    --
    -- Security check
    -- Make sure this proc is infact being called from the given object(trigger)
    -- 
    if (trigger_nestlevel(@objid) = 0)
    begin
        raiserror(14126, 16, 2)
        return 1
    end
    --
    -- Security check: the caller of this SP has to be one of the 
    -- predefined replication objects for this subscription
    --
    if not exists (select so.object_id from (dbo.MSreplication_objects as ro join sys.objects as so
        on ro.object_name = so.name)
        where so.object_id = @objid and ro.object_type = 'T' 
        and (@owner is null or schema_name(so.schema_id) = @owner))
    begin
        raiserror(14126, 16, 3)
        return 1
    end
    --
    -- insert into the queue table
    --
    insert into dbo.MSreplication_queue with (rowlock) (publisher,publisher_db,publication,tranid,data,datalen,commandtype,cmdstate)
        values(UPPER(@publisher),@publisher_db,@publication,@tranid,@data,@datalen,@commandtype,@cmdstate)
    if (@@error != 0)
        return 1
    --
    -- Update MSrepl_queuedtraninfo
    --
    if exists (select *
        from dbo.MSrepl_queuedtraninfo with (nolock)
        where publisher = UPPER(@publisher) 
            and publisher_db = @publisher_db 
            and publication = @publication
            and tranid = @tranid)
    begin
        --
        -- row for this transaction exists - update it
        --
        update dbo.MSrepl_queuedtraninfo with (rowlock)
        set maxorderkey = @@identity
            ,commandcount = commandcount + 1
        where publisher = UPPER(@publisher)
            and publisher_db = @publisher_db 
            and publication = @publication
            and tranid = @tranid
    end
    else
    begin
        --
        -- row for this transaction does not exist - insert it
        --
        insert into dbo.MSrepl_queuedtraninfo with (rowlock) (publisher,publisher_db,publication,tranid,maxorderkey,commandcount)
        values (UPPER(@publisher),@publisher_db,@publication,@tranid,@@identity,1)
    end
    if (@@error != 0)
        return 1
    --
    -- all done
    --
    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

