## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_statistics_rowset\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_statistics_rowset**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -48087781 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@table_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@table_schema| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|TABLE_CATALOG|nvarchar|128|
|TABLE_SCHEMA|nvarchar|128|
|TABLE_NAME|nvarchar|128|
|CARDINALITY|int|4|

---
### Objects that depend on \[sys\].\[sp_statistics_rowset\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_statistics_rowset\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_statistics_rowset
(
    @table_name     sysname,
    @table_schema   sysname = null
)
as
    select
        TABLE_CATALOG = db_name(),
        TABLE_SCHEMA = schema_name(o.schema_id),
        TABLE_NAME = o.name,
        CARDINALITY =   convert (int,
                                (-- Multiple partitions could correspond to one index.
                                    select sum(rows) from sys.partitions s_p
                                    where x.object_id = s_p.object_id and x.index_id = s_p.index_id
                                )
                                )
    from
        sys.all_objects o,
        sys.indexes x
    where
        (
            (@table_schema is null and o.name = @table_name) or
            object_id(quotename(@table_schema) + '.' + quotename(@table_name)) = o.object_id
        ) and
        o.type in ('U') and
        x.object_id = o.object_id and
        x.index_id in (0,1) -- If there are no indexes then table stats are in a row with indid =0
    order by 2, 3
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

