## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSsetreplicainfo\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSsetreplicainfo**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -48298025 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@datasource_type| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@server_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@db_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@datasource_path| |nvarchar|255|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@replnick| |varbinary|6|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@schemaversion| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@compatlevel| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@partition_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@replica_version| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@activate_subscription| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSsetreplicainfo\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSsetreplicainfo\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSsetreplicainfo
    (@publisher         sysname,
     @publisher_db      sysname,
     @publication       sysname,
     @datasource_type   int = 0,             /* 0 = SQL Server, 1 = DSN, 2 = Jet */
     @server_name       sysname = NULL,      /* Server Name */
     @db_name           sysname = NULL,      /* Database Name */
     @datasource_path   nvarchar(255) = NULL,/* Datasource path - JET MDB file path etc */
     @replnick          varbinary(6) = NULL,
     @schemaversion     int = NULL,
     @subid             uniqueidentifier = NULL,
     @compatlevel       int = 10,           -- backward compatibility level, default=Sphinx
     @partition_id      int = NULL,
     @replica_version   int = 60,       -- 60=shiloh sp3 and below, 90=Yukon
     @activate_subscription bit = 1)           
as
    declare @pubid      uniqueidentifier
    declare @repid      uniqueidentifier
    declare @retcode    int
    declare @maxlevel   int

    /*
    ** ODBC Issue - trim names
    */
    select @publisher_db = RTRIM(@publisher_db)
    select @db_name = RTRIM(@db_name)
    
    /* 
    ** Security Check and publication validation
    */
    exec @retcode = sys.sp_MSmerge_validate_publication_presence @publication, @publisher_db, @publisher, @pubid output
    if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
        return 1
    
    if (@server_name is NULL)
        SET @server_name = publishingservername()

    if (@db_name is NULL)
        set @db_name = db_name()

    SELECT @repid = subid FROM dbo.sysmergesubscriptions
        WHERE UPPER(subscriber_server) collate database_default = UPPER(@server_name) collate database_default
            and db_name = @db_name and pubid = @pubid
    if @repid is NULL
    begin
        RAISERROR(20021, 16, -1)
        return (1)
    end

    update dbo.MSmerge_replinfo set validation_level = 0, resync_gen=-1 where repid=@repid

    if 1=@activate_subscription
    begin
        update dbo.sysmergesubscriptions set status=1 where subid=@repid and (status=5 or status=0)
    end

    if @schemaversion is not null and
       -- sp_MSsetreplicainfo is also called to update the subscriber replica info that is stored
       -- at the publisher. If the subscriber has a schemaversion of -1, it means that the subscriber
       -- wants to reinit. However, this should not be set at the publisher, because this would
       -- falsely indicate that the publisher wants to reinit.
       (
            @schemaversion &lt;&gt; -1 or
            UPPER(publishingservername()) collate database_default &lt;&gt; UPPER(@publisher) collate database_default or
            db_name() &lt;&gt; @publisher_db
       )
    begin
        update dbo.sysmergesubscriptions set schemaversion = @schemaversion where subid = @repid
        if @@error &lt;&gt; 0     
        begin
            RAISERROR(20054 , 16, -1)
            return (1)
        end
    end
        
    if @subid is not null and @subid &lt;&gt; @repid
    begin
        /* Fix the repid for pull subscribers before we copy around global replica rows */
        update dbo.MSmerge_replinfo set repid = @subid where repid = @repid
        if @@error &lt;&gt; 0     
        begin
            RAISERROR(20054 , 16, -1)
            return (1)
        end
        update dbo.sysmergesubscriptions set subid = @subid where subid = @repid
        if @@error &lt;&gt; 0     
        begin
            RAISERROR(20054 , 16, -1)
            return (1)
        end
    end
        
    if @replnick IS NOT NULL        
    begin
        /* If this nickname isn't already assigned, reset it */
        /* Replnick in 80 was int and in 90 is binary(6). The proc
           does a implicit conversion from int to varbinary(6) but we still
           need to reverse the binary value to get a corresponding 90 replnick */
        if @compatlevel &lt; 90
            set @replnick= cast(reverse(substring(@replnick,1,4)) as binary(4))+ 0x0000  
        else
        begin
            -- Fix the replnick to 4 bytes + 0x0000 if the compatlevel is less than 80.
            -- This prevents us from having real 6 byte replnicks when there are 80 subscribers
            -- Having real 6 byte replnicks in mixed mode can cause non-convergence because the 
            -- lineages can not be converted from 90 to 80 and back to 90 without losing last two bytes of replnick.
            select @maxlevel= sys.fn_MSgetmaxbackcompatlevel()

            if @maxlevel &lt;= 80
                set @replnick = substring(@replnick,1,4) + 0x0000            
        end
        if exists (select * from dbo.sysmergesubscriptions
                where replnickname = @replnick and subid = subid and 
                    ((UPPER(subscriber_server) collate database_default &lt;&gt; UPPER(@server_name) collate database_default) or db_name &lt;&gt; @db_name))
            return (0)
        update dbo.sysmergesubscriptions set replnickname = @replnick where subid = @subid
        if @@error &lt;&gt; 0     
        begin
            RAISERROR(20054 , 16, -1)
            return (1)
        end
    end         
    
    if @partition_id is not null
    begin
        if exists (select * from dbo.sysmergepartitioninfo where pubid = @pubid and partition_options = 3)
        begin
            if exists (select 1 from dbo.sysmergesubscriptions 
                    where pubid = @pubid and partition_id = @partition_id and subid&lt;&gt;@subid)
            begin
                raiserror(22525, 16, -1, @publication)
                return 1
            end
        end
        update dbo.sysmergesubscriptions set partition_id = @partition_id where subid = @subid
        if @@error &lt;&gt; 0     
        begin
            RAISERROR(20054 , 16, -1)
            return (1)
        end
    end
    
    if @replica_version is not null
    begin
        update dbo.sysmergesubscriptions set replica_version = @replica_version where subid = @subid
        if @@error &lt;&gt; 0     
        begin
            RAISERROR(20054 , 16, -1)
            return (1)
        end
    end
    
    return (0)
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

