## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_resetstatus\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_resetstatus**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -484845845 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@DBName| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_resetstatus\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_resetstatus\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_resetstatus  -- 1995/11/30 14:12 #12092
    @DBName sysname
as
    set nocount on
    declare @state int
    declare @source_dbid int

    if (SERVERPROPERTY('IsMatrix') = 1)
    begin
        raiserror (28401, -1, -1, N'sys.sp_resetstatus')
        return (1)
    end

    -- RESTRICT TO SA --
    if (not (is_srvrolemember('sysadmin') = 1))
    begin
       raiserror(15247,-1,-1)
       return (1)
    end

    -- FORBID ACTIVE TXN --
    set implicit_transactions off
    if @@trancount &gt; 0
    begin
       raiserror(15002,-1,-1,'sys.sp_resetstatus')
       return (1)
    end

    --
    -- Make sure the db exists
    --
    if not exists (select * from master.sys.databases where name = @DBName)
    begin
        raiserror(15010,-1,-1,@DBName)
        return (1)
    end

    select @state = state, 
    @source_dbid = source_database_id
    from master.sys.databases
    where name = @DBName

    -- 
    -- Cannot reset a database snapshot.  Anything but NULL or 0 
    -- is a snapshot.
    --
    if (ISNULL(@source_dbid, 0) &lt;&gt; 0)
    begin
        raiserror(15658,-1,-1)
        return (1)
    end
    
    --
    -- Must already be suspect.  4 is SUSPECT state.
    --
    if (@state &lt;&gt; 4) 
    begin
        raiserror(15056,-1,-1,@DBName)
        return (1)
    end

    -- Note: database @DBName may not exist anymore
    -- If invoke gets error, exception will abort this proc.
    EXEC %%DatabaseRef(Name = @DBName).SetSuspect(Value = 0)

    -- Warning: You must recover this database prior to access.
    raiserror(15074,-1,-1)

    return (0) -- sp_resetstatus
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

