## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_columns_managed\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_columns_managed**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -489491611 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@Catalog| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@Owner| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@Table| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@Column| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@SchemaType| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|TABLE_CATALOG|nvarchar|128|
|TABLE_SCHEMA|nvarchar|128|
|TABLE_NAME|nvarchar|128|
|COLUMN_NAME|nvarchar|128|
|ORDINAL_POSITION|int|4|
|COLUMN_DEFAULT|nvarchar|4000|
|IS_NULLABLE|varchar|3|
|DATA_TYPE|nvarchar|128|
|CHARACTER_MAXIMUM_LENGTH|int|4|
|CHARACTER_OCTET_LENGTH|int|4|
|NUMERIC_PRECISION|tinyint|1|
|NUMERIC_PRECISION_RADIX|smallint|2|
|NUMERIC_SCALE|int|4|
|DATETIME_PRECISION|smallint|2|
|CHARACTER_SET_CATALOG|nvarchar|128|
|CHARACTER_SET_SCHEMA|nvarchar|128|
|CHARACTER_SET_NAME|nvarchar|128|
|COLLATION_CATALOG|nvarchar|128|
|IS_SPARSE|bit|1|
|IS_COLUMN_SET|bit|1|
|IS_FILESTREAM|bit|1|

---
### Objects that depend on \[sys\].\[sp_columns_managed\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_columns_managed\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_columns_managed 
( 
    @Catalog            sysname = NULL,
    @Owner            sysname = NULL,
    @Table             sysname = NULL,
    @Column            sysname = NULL,
    @SchemaType    sysname = 0 )        -- 0 = 'select *' behavior (default), 1 = all columns, 2 = columnset columns
as 
    select 
        TABLE_CATALOG            = s_cv.TABLE_CATALOG,
        TABLE_SCHEMA            = s_cv.TABLE_SCHEMA,
        TABLE_NAME                = s_cv.TABLE_NAME,
        COLUMN_NAME             = s_cv.COLUMN_NAME,
        ORDINAL_POSITION        = s_cv.ORDINAL_POSITION, 
        COLUMN_DEFAULT            = s_cv.COLUMN_DEFAULT,
        IS_NULLABLE             = s_cv.IS_NULLABLE,
        DATA_TYPE                = s_cv.DATA_TYPE,
        CHARACTER_MAXIMUM_LENGTH= s_cv.CHARACTER_MAXIMUM_LENGTH,
        CHARACTER_OCTET_LENGTH    = s_cv.CHARACTER_OCTET_LENGTH,
        NUMERIC_PRECISION        = s_cv.NUMERIC_PRECISION,
        NUMERIC_PRECISION_RADIX    = s_cv.NUMERIC_PRECISION_RADIX,
        NUMERIC_SCALE            = s_cv.NUMERIC_SCALE,
        DATETIME_PRECISION        = s_cv.DATETIME_PRECISION, 
        CHARACTER_SET_CATALOG    = s_cv.CHARACTER_SET_CATALOG,
        CHARACTER_SET_SCHEMA    = s_cv.CHARACTER_SET_SCHEMA,
        CHARACTER_SET_NAME        = s_cv.CHARACTER_SET_NAME,
        COLLATION_CATALOG        = s_cv.COLLATION_CATALOG,
        IS_SPARSE                = s_cv.IS_SPARSE,
        IS_COLUMN_SET            = s_cv.IS_COLUMN_SET,
        IS_FILESTREAM            = s_cv.IS_FILESTREAM
    from 
        sys.spt_columns_view_managed s_cv
    where
        (@Catalog is null or s_cv.TABLE_CATALOG like @Catalog) and
        (@Owner is null or s_cv.TABLE_SCHEMA like @Owner) and
        (@Table is null or s_cv.TABLE_NAME like @Table) and
        (@Column is null or s_cv.COLUMN_NAME like @Column) and
        ( 
            @SchemaType = 0 AND 
            (
                ( s_cv.IS_SPARSE = 0 OR objectproperty ( s_cv.OBJECT_ID, 'tablehascolumnset' ) = 0 ) 
            ) 
            OR @SchemaType = 1
            OR @SchemaType = 2 AND
            (
                ( s_cv.IS_SPARSE = 1 AND objectproperty ( s_cv.OBJECT_ID, 'tablehascolumnset' ) = 1 )
            )
        )
    order by TABLE_CATALOG, TABLE_SCHEMA, TABLE_NAME, IS_NULLABLE 
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

