## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSrepl_enumarticlecolumninfo\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSrepl_enumarticlecolumninfo**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -491447503 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@article| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@defaults| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSrepl_enumarticlecolumninfo\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSrepl_enumarticlecolumninfo\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE sys.sp_MSrepl_enumarticlecolumninfo
(
    @publisher        sysname,
    @publication    sysname,
    @article        sysname,
    @defaults       bit = 0
)
AS
BEGIN
    DECLARE @retcode    int
    DECLARE @publisher_type    sysname
    DECLARE @cmd        nvarchar(4000)
    DECLARE @distribdb    sysname    

    SET @retcode = 0

    --
    -- Security Check: require sysadmin
    --
    IF (ISNULL(IS_SRVROLEMEMBER('sysadmin'),0) = 0)
    BEGIN
        RAISERROR(21089,16,-1) 
        RETURN (1)
    END

    EXEC @retcode = sys.sp_MSrepl_getdistributorinfo    @publisher      = @publisher,
                                                        @publisher_type = @publisher_type OUTPUT,
                                                        @distribdb        = @distribdb OUTPUT
    
    IF @retcode &lt;&gt; 0
    BEGIN
        RETURN (@retcode)
    END

    IF UPPER(@publisher_type) IN ('ORACLE', 'ORACLE GATEWAY')
    BEGIN
        SET @cmd = QUOTENAME(@distribdb) + N'.sys.sp_ORAenumarticlecolumninfo'

        EXEC @retcode = @cmd
                        @publisher,
                        @publication,
                        @article,
                        @defaults
    END
    ELSE
    BEGIN
        RAISERROR(21645, 16, -1, @publisher)
        RETURN (1)
    END

    RETURN (@retcode)
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

