## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_column_privileges_rowset2\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_column_privileges_rowset2**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -494826021 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@table_schema| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@column_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@grantor| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@grantee| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|GRANTOR|nvarchar|128|
|GRANTEE|nvarchar|128|
|TABLE_CATALOG|nvarchar|128|
|TABLE_SCHEMA|nvarchar|128|
|TABLE_NAME|nvarchar|128|
|COLUMN_NAME|nvarchar|128|
|COLUMN_GUID|uniqueidentifier|16|
|COLUMN_PROPID|int|4|
|PRIVILEGE_TYPE|nvarchar|30|
|IS_GRANTABLE|bit|1|

---
### Objects that depend on \[sys\].\[sp_column_privileges_rowset2\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_column_privileges_rowset2\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_column_privileges_rowset2
(
    @table_schema       sysname = null,
    @column_name        sysname = null,
    @grantor            sysname = null,
    @grantee            sysname = null
)
as
-------------------------------------------------------------------------------------------
-- copy &amp; pasted from version 1 of the SProc and removed checks for 1st parameter !
-------------------------------------------------------------------------------------------
    select -- Rows for explicitly set database permissions.
        GRANTOR         = s_cpsv.GRANTOR,
        GRANTEE         = s_cpsv.GRANTEE,
        TABLE_CATALOG   = s_cpsv.TABLE_CATALOG,
        TABLE_SCHEMA    = s_cpsv.TABLE_SCHEMA,
        TABLE_NAME      = s_cpsv.TABLE_NAME,
        COLUMN_NAME     = s_cpsv.COLUMN_NAME,
        COLUMN_GUID     = s_cpsv.COLUMN_GUID,
        COLUMN_PROPID   = s_cpsv.COLUMN_PROPID,
        PRIVILEGE_TYPE  = s_cpsv.PRIVILEGE_TYPE,
        IS_GRANTABLE    = s_cpsv.IS_GRANTABLE
    from
        sys.spt_column_privileges_set_view s_cpsv
    where
        (@table_schema is null or schema_id(@table_schema) = s_cpsv.schema_id) and -- check schema
        (@column_name is null or @column_name = s_cpsv.COLUMN_NAME) and
        (@grantor is null or @grantor = s_cpsv.GRANTOR) and
        (@grantee is null or @grantee = s_cpsv.GRANTEE)

    union all

    select -- Add rows for table owner
        GRANTOR         = s_cpov.GRANTOR,
        GRANTEE         = s_cpov.GRANTEE,
        TABLE_CATALOG   = s_cpov.TABLE_CATALOG,
        TABLE_SCHEMA    = s_cpov.TABLE_SCHEMA,
        TABLE_NAME      = s_cpov.TABLE_NAME,
        COLUMN_NAME     = s_cpov.COLUMN_NAME,
        COLUMN_GUID     = s_cpov.COLUMN_GUID,
        COLUMN_PROPID   = s_cpov.COLUMN_PROPID,
        PRIVILEGE_TYPE  = s_cpov.PRIVILEGE_TYPE,
        IS_GRANTABLE    = s_cpov.IS_GRANTABLE
    from
        sys.spt_column_privileges_owner_view s_cpov
    where
        (@table_schema is null or schema_id(@table_schema) = s_cpov.schema_id) and -- check schema
        (@column_name is null or @column_name = s_cpov.COLUMN_NAME) and
        (@grantor is null or @grantor = s_cpov.GRANTOR) and
        (@grantee is null or @grantee = s_cpov.GRANTEE)

    order by 4, 5, 6, 9, 1, 2
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

