## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSchangedynsnaplocationatdistributor\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSchangedynsnaplocationatdistributor**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -495915163 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@dynamic_filter_login| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@dynamic_filter_hostname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@dynamic_snapshot_location| |nvarchar|255|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSchangedynsnaplocationatdistributor\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSchangedynsnaplocationatdistributor\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
--
-- Name: sp_MSchangedynsnaplocationatdistributor
--
-- Description: This function is called by sp_MSrefreshdynamicsnapshotlocations 
--              at the publisher to change the dynamic snapshot location command line
--              parameter value in an existing dynamic snapshot job
--
-- Returns: 0 - succeeded
--          1 - failed
--
-- Security: Only members of the 'sysadmin' server role and members of the 
--           'db_owner' database role at the distributor can call this 
--           procedure. This procedure is intended to be called through 
--           the distributor_admin remote login in the case where
--           the distributor is a different machine from the publisher. 
--
create procedure sys.sp_MSchangedynsnaplocationatdistributor 
(
    @publisher sysname,
    @publisher_db sysname,
    @publication sysname,
    @dynamic_filter_login sysname,
    @dynamic_filter_hostname sysname,
    @dynamic_snapshot_location nvarchar(255)
)
as
begin
    set nocount on

    declare @retcode int
    declare @agent_id int
    declare @job_id uniqueidentifier
    declare @job_step_uid uniqueidentifier
    declare @publisher_id int
    declare @publication_type int
    declare @command_line nvarchar(4000)
    declare @str_jobid nvarchar(40)
    
    --
    -- security check
    -- only db_owner can execute this
    --
    if (is_srvrolemember('sysadmin') != 1) 
    begin
        raiserror(14260, 16, -1)
        return (1)
    end
    --
    -- security check
    -- Has to be executed from distribution database
    --
    if (sys.fn_MSrepl_isdistdb (db_name()) != 1)
    begin
        raiserror(21482, 16, -1, 'sp_MSchangedynsnaplocationatdistributor', 'distribution')
        return (1)
    end

    if @dynamic_filter_login is NULL and @dynamic_filter_hostname is NULL
    begin
        raiserror(20653, 16, -1)
        return 1
    end
    
    select @retcode = 0
    select @agent_id = null

    SELECT @publisher_id = srvid 
      FROM master.dbo.sysservers
     WHERE UPPER(srvname) = UPPER(@publisher)
    IF @publisher_id IS  NULL
    BEGIN
        RAISERROR(21169, 16, -1, @publisher, @@SERVERNAME, @publisher)    
    END
    
    -- Get the publication details from the agent for regular snapshot  
    select @agent_id = id,
           @job_id = job_id,
           @job_step_uid = job_step_uid,
           @publication_type = publication_type
      from MSsnapshot_agents
     where publisher_id = @publisher_id and 
           publication = @publication and 
           publisher_db = @publisher_db and
          ((@dynamic_filter_login is NULL and dynamic_filter_login is NULL) or dynamic_filter_login = @dynamic_filter_login)  and
          ((@dynamic_filter_hostname is NULL and dynamic_filter_hostname is NULL) or dynamic_filter_hostname = @dynamic_filter_hostname)
    if @agent_id is null or @job_id is NULL
    begin
        raiserror(21325, 11, -1)
        return 1
    end

    if @publication_type &lt;&gt; 2
    begin
        raiserror(20654, 16, -1)
        return 1
    end

    select @str_jobid = convert(nvarchar(40),@job_id)
    
    -- Change the dynamic snapshot location parameter in the job step
    select @command_line = command from msdb.dbo.sysjobsteps 
        where step_uid = @job_step_uid and job_id = @job_id
    if @command_line is NULL
    begin
        raiserror(20724, 16, -1, @str_jobid, @publication)
        goto UNDO
    end

    SELECT @command_line = sys.fn_updateparameterwithargument(@command_line, N'DynamicSnapshotLocation', sys.fn_replquotename(@dynamic_snapshot_location, default) collate database_default )
    if @@error &lt;&gt; 0
    begin
        raiserror(20725, 16, -1, @str_jobid, @publication)
        goto UNDO
    end

    UPDATE msdb.dbo.sysjobsteps
        SET command = @command_line
        WHERE job_id = @job_id
            AND step_uid = @job_step_uid
    if @@error &lt;&gt; 0
    begin
        raiserror(20725, 16, -1, @str_jobid, @publication)
        goto UNDO
    end
    
    RETURN(0)

UNDO:
    return(1)
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

