## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSsetreplicastatus\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSsetreplicastatus**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -496145580 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@subid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@status_value| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSsetreplicastatus\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSsetreplicastatus\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_MSsetreplicastatus
    (@subid uniqueidentifier,
     @status_value int
     ) AS
     
    /*
    ** Check to see if current publication has permission
    */
    declare @retcode int

    exec @retcode = sys.sp_MSrepl_PAL_rolecheck @repid = @subid
    if (@retcode &lt;&gt; 0) or (@@error &lt;&gt; 0)
        return 1
    
    if object_id(N'dbo.sysmergesubscriptions','U') is null
        return 0
    
     IF EXISTS (select subid from dbo.sysmergesubscriptions where subid=@subid)
        begin
            update dbo.sysmergesubscriptions set status = @status_value,
                cleanedup_unsent_changes = case when @status_value=1 then 0 else cleanedup_unsent_changes end   
            WHERE subid=@subid               
            if @@ERROR&lt;&gt;0 return (1)

            if @status_value = 1
            begin
                -- update the publisher replica row's cleanedup_unsent_changes as well.
                update dbo.sysmergesubscriptions set cleanedup_unsent_changes = 0
                WHERE subid = (select top 1 pubid from dbo.sysmergesubscriptions where subid = @subid)               
                if @@ERROR&lt;&gt;0 return (1)
            end

            update dbo.MSmerge_replinfo set resync_gen=-1 WHERE repid=@subid               
            if @@ERROR&lt;&gt;0 return (1)
        end
    return (0)
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

