## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_sqlagent_add_jobstep\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_sqlagent_add_jobstep**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -50216184 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@job_id| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@job_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@step_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@step_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subsystem| |nvarchar|40|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@command| |nvarchar|1073741823|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@additional_parameters| |nvarchar|1073741823|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@cmdexec_success_code| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@on_success_action| |tinyint|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@on_success_step_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@on_fail_action| |tinyint|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@on_fail_step_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@server| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@database_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@database_user_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@retry_attempts| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@retry_interval| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@os_run_priority| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@output_file_name| |nvarchar|200|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@flags| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@step_uid| |uniqueidentifier|16|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_sqlagent_add_jobstep\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_sqlagent_add_jobstep\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE sys.sp_sqlagent_add_jobstep
    @job_id                UNIQUEIDENTIFIER = NULL,   -- Must provide either this or job_name
    @job_name              SYSNAME          = NULL,   -- Must provide either this or job_id
    @step_id               INT              = NULL,   
    @step_name             SYSNAME,
    @subsystem             NVARCHAR(40)     = N'TSQL',
    @command               NVARCHAR(MAX)    = NULL,
    @additional_parameters NVARCHAR(MAX)    = NULL,
    @cmdexec_success_code  INT              = 0,
    @on_success_action     TINYINT          = 1,      -- 1 = Quit With Success, 2 = Quit With Failure, 3 = Goto Next Step, 4 = Goto Step
    @on_success_step_id    INT              = 0,
    @on_fail_action        TINYINT          = 2,      -- 1 = Quit With Success, 2 = Quit With Failure, 3 = Goto Next Step, 4 = Goto Step
    @on_fail_step_id       INT              = 0,
    @server                SYSNAME          = NULL,
    @database_name         SYSNAME          = NULL,
    @database_user_name    SYSNAME          = NULL,
    @retry_attempts        INT              = 0,      
    @retry_interval        INT              = 0,      
    @os_run_priority       INT              = 0,      
    @output_file_name      NVARCHAR(200)    = NULL,
    @flags                 INT              = 128,     -- 128  - System jobstep flag
    @step_uid UNIQUEIDENTIFIER              = NULL OUTPUT
AS
BEGIN
    DECLARE @job_id_as_char VARCHAR(36)
    DECLARE @retval INT

    -- Validate if current db context is supported
    EXEC @retval = sys.sp_sqlagent_verify_database_context
    IF (@retval &lt;&gt; 0)
    BEGIN
        RETURN(@retval)
    END
    
    -- job name / job id is accepted. not both
    IF ((@job_name IS NULL)     AND (@job_id IS NULL)) OR
    ((@job_name IS NOT NULL) AND (@job_id IS NOT NULL))
    BEGIN
        RAISERROR(14294, -1, -1, '@job_id', '@job_name')
        RETURN(1) -- Failure
    END
   
    -- if job_id null, then get the jobid for given job name
    IF (@job_id IS NULL)
    BEGIN
        SELECT @job_id = job_id
        FROM sys.sqlagent_jobs
        WHERE name = @job_name

        -- If returned job_id is null, then throw validation error
        IF(@job_id IS NULL)
        BEGIN
            RAISERROR(14262, -1, -1, '@job_name', @job_name)
            RETURN(1) -- Failure
        END
    END
    
    -- Validate if given job_id exists in agent_jobs
    IF NOT EXISTS (SELECT name
                FROM sys.sqlagent_jobs
                WHERE job_id = @job_id)
    BEGIN
      SET @job_id_as_char = CONVERT(VARCHAR(36), @job_id)
      RAISERROR(14262, -1, -1, '@job_id', @job_id_as_char)
      RETURN(1) -- Failure
    END

    SELECT @step_uid = NEWID()

     -- Default step id (if not supplied)
    IF (@step_id IS NULL)
    BEGIN
        SELECT @step_id = ISNULL(MAX(step_id), 0) + 1
        FROM sys.sqlagent_jobsteps
        WHERE job_id = @job_id
    END

    -- Insert the step
    INSERT INTO sys.sqlagent_jobsteps
    (
        job_id,
        step_id,
        step_name,
        subsystem,
        command,
        flags,
        additional_parameters,
        cmdexec_success_code,
        on_success_action,
        on_success_step_id,
        on_fail_action,
        on_fail_step_id,
        [server],
        database_name,
        database_user_name,
        retry_attempts,
        retry_interval,
        os_run_priority,
        output_file_name,
        last_run_outcome,
        last_run_duration,
        last_run_retries,
        last_run_date,
        last_run_time,
        step_uid
    )
    VALUES 
    (
        @job_id,
        @step_id,
        @step_name,
        @subsystem,
        @command,
        @flags,
        @additional_parameters,
        @cmdexec_success_code,
        @on_success_action,
        @on_success_step_id,
        @on_fail_action,
        @on_fail_step_id,
        @server,
        @database_name,
        @database_user_name,
        @retry_attempts,
        @retry_interval,
        @os_run_priority,
        @output_file_name,
        0,
        0,
        0,
        0,
        0,
        @step_uid
    )

    SELECT @retval = @@error 

    -- If Insert jobstep failed, then we dont need to notify sql agent
    IF (@retval &lt;&gt; 0)
    BEGIN
        RETURN(@retval)
    END


    -- Notify SQL Agent that job was updated
    EXECUTE @retval = master.dbo.xp_sqlagent_notify 
        N'J',
        @job_id,
        NULL,
        NULL,
        N'U',
        NULL,
        1,
        @@trancount,
        NULL

    RETURN(@retval) -- 0 means success 
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

