## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MScdc_cleanup_job\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MScdc_cleanup_job**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -502831970 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
 No parameters exist

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MScdc_cleanup_job\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MScdc_cleanup_job\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure [sys].[sp_MScdc_cleanup_job]
as
begin
    declare @retcode int
            ,@db_name sysname
            ,@retention bigint
            ,@threshold bigint
    
    set nocount on
    
    set @db_name = db_name()

    -- Verify caller is authorized to clean up database change tables 
    if (isnull(is_srvrolemember('sysadmin'),0) = 0) and (isnull(is_member('db_owner'),0) = 0)
    begin
           raiserror(22904, 16, -1)
        return(1)
    end

    -- Verify database is enabled for change data capture 
    if ([sys].[fn_cdc_is_db_enabled]() != 1)
    begin
        raiserror(22910, 16, -1, @db_name)
        return(1)
    end

    -- Determine the database retention time
    if (serverproperty('EngineEdition') &lt;&gt; 5)
    begin
    exec @retcode = sp_cdc_get_cleanup_retention @retention output, @threshold output
    end
    else
    begin
        exec @retcode = sp_cdc_get_cleanup_retention_db_scoped @retention output, @threshold output
    end

    if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
        return(1)

    -- If retention is negative or greater than 52594800 ( 100 years) fail
    if (@retention is null) or (@retention &lt;= 0) or (@retention &gt; 52594800)
    begin
        raiserror(22994, 16, -1)
        return(1)
    end
    
    -- If threshold is negative fail
    if (@threshold is null) or (@threshold &lt;= 0) 
    begin
        raiserror(22850, 16, -1)
        return(1)
    end    
  
    -- Call internal stored procedure to do the work here.
    -- Switch to database 'cdc' user to mitigate against malicious DML triggers.
    execute as user = 'cdc'
    
    exec @retcode = sys.sp_cdc_cleanup_job_internal @retention, @threshold
    if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
    begin
        revert
        return(1)
    end
    
    revert    
    
    return(0)
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

