## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSrepl_backup_complete\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSrepl_backup_complete**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -508437824 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
 No parameters exist

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSrepl_backup_complete\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSrepl_backup_complete\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSrepl_backup_complete
as
    declare @sync_bit int
    declare @dist_bit int

    set nocount on

    set @sync_bit = 32
    set @dist_bit = 16

    -- security Check
    -- BACKUP/RESTORE statements require sysadmin, dbcreator, dbo 
    if isnull(is_srvrolemember('sysadmin'),0) = 0 
        and isnull(is_srvrolemember('dbcreator'),0) = 0
        and isnull(is_member('db_owner'),0) = 0
    begin
        raiserror(18799, 16, -1) 
        return (1)
    end
    
    -- If this is a distribution database and it is marked by 'sync with backup'
    if exists (select * from master.dbo.sysdatabases where
        name = db_name() collate database_default and
        category &amp; (@sync_bit | @dist_bit) = @sync_bit | @dist_bit)
    begin
        update MSrepl_backup_lsns set valid_xact_id = next_xact_id, 
            valid_xact_seqno = next_xact_seqno 
        if @@error &lt;&gt; 0
            return 1
    end

    return 0
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

