## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSisreplmergeagent\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSisreplmergeagent**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -513243099 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@is_merge| |bit|1|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@at_publisher| |bit|1|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSisreplmergeagent\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSisreplmergeagent\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO


create procedure sys.sp_MSisreplmergeagent @is_merge bit output, @at_publisher bit=0 output
as
begin
    declare @cur_context varbinary(128)
    declare @cur_context_first_byte binary(1)
    declare @mergeagent_bitmask tinyint
    declare @atpublisher_bitmask tinyint
        
    select @mergeagent_bitmask = 8        --     snapshot=1, logreader=2, distrib=4, merge=8
    select @atpublisher_bitmask = 16
    
    select @cur_context = isnull(context_info(),0x00)
    
    -- get the first byte out of the 128 byte array.
    select @cur_context_first_byte = substring(@cur_context, 1, 1)
    
    -- check whether it has the merge agent bit set.
    select @mergeagent_bitmask = (convert(tinyint,@cur_context_first_byte) &amp; @mergeagent_bitmask)
    -- set the output param value appropriately.
    select @is_merge = case when @mergeagent_bitmask = 0 then 0 else 1 end
    
    -- check whether it has the "at publisher" bit set.
    select @atpublisher_bitmask = (convert(tinyint,@cur_context_first_byte) &amp; @atpublisher_bitmask)
    -- set the output param value appropriately.
    select @at_publisher = case when @atpublisher_bitmask = 0 then 0 else 1 end

    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

