## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSfilterclause\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSfilterclause**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -514188373 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |nvarchar|258|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@article| |nvarchar|258|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSfilterclause\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSfilterclause\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_MSfilterclause
    @publication nvarchar(258), @article nvarchar(258)
as
    /* Return a text column as multiple readtexts of maxcol length */
    declare @pubid int, @artid int
    select @pubid = pubid from syspublications where name = @publication
    if (@pubid is null) begin
        RAISERROR (15001, 11, -1, @publication)
        return 1
    end
    select @artid = artid from sysarticles where name = @article and pubid = @pubid
    if (@artid is null) begin
        RAISERROR (15001, 11, -1, @article)
        return 1
    end

    declare @val varbinary(16), @len int, @ii int, @chunk int
    -- filter clause is in unicode, the length is a half of the number of bytes.
    select @val = textptr(filter_clause), @len = datalength(filter_clause)/2 from sysarticles where artid = @artid and pubid = @pubid
    select @ii = 0, @chunk = 255

    /* Get all the rows of an maxcol size */
    while @len &gt; @chunk begin
        readtext sysarticles.filter_clause @val @ii @chunk
        select @ii = @ii + @chunk, @len = @len - @chunk
    end

    /* Get the last chunk */
    if (@len &gt; 0)
        readtext sysarticles.filter_clause @val @ii @len
    return 0
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

