## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSadd_log_shipping_error_detail\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSadd_log_shipping_error_detail**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -517820769 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@agent_id| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@agent_type| |tinyint|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@session_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@database| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@sequence_number| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@message| |nvarchar|4000|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source| |nvarchar|4000|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@help_url| |nvarchar|4000|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSadd_log_shipping_error_detail\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSadd_log_shipping_error_detail\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSadd_log_shipping_error_detail 
(
    @agent_id uniqueidentifier     -- primary/secondary ID
    ,@agent_type tinyint              -- 0 = Backup, 1 = Copy, 2 = Restore
    ,@session_id int 
    ,@database sysname = NULL  -- primary/secondary database
    ,@sequence_number int
    ,@message nvarchar(4000) = N'No message specified'
    ,@source nvarchar(4000) = N'No source specified'
    ,@help_url nvarchar(4000) = N'No help_url specified'
)
as
begin
    set nocount on
    declare @retcode int
                ,@agent_idstring sysname
                ,@curdate datetime
                ,@curutcdate datetime
                ,@monitor_server sysname
                ,@monitor_server_security_mode int
    --
    -- security check
    --
    exec @retcode = sys.sp_MSlogshippingsysadmincheck
    if (@retcode != 0 or @@error != 0)
        return 1
    --
    -- must be invoked from master db
    --
    if (db_name() != N'master')
    begin
        raiserror(5001, 16,-1)
        return 1
    end
    --
    -- validate agent_type
    --
    if (@agent_type not in (0,1,2))
    begin
        raiserror(21055, 16, -1, '@agent_type','sp_MSadd_log_shipping_error_detail')
        return 1
    end
    --
    -- validate agent
    --
    if (sys.fn_MSvalidatelogshipagentid(@agent_id, @agent_type) = 0)
    begin
        select @agent_idstring = cast(@agent_id as sysname)
        raiserror(32016, 16, 1, @agent_idstring, @agent_type)
        return 1
    end
    --
    -- set the dates
    --
    select @curdate = getdate()
                ,@curutcdate = getutcdate()
    --
    -- get monitor server information
    --
    if (@agent_type = 0)
    begin
        select @monitor_server = monitor_server
                    ,@monitor_server_security_mode = monitor_server_security_mode
        from msdb.dbo.log_shipping_primary_databases
        where primary_id = @agent_id
    end
    else
    begin
        select @monitor_server = monitor_server
                    ,@monitor_server_security_mode = monitor_server_security_mode
        from msdb.dbo.log_shipping_secondary
        where secondary_id = @agent_id
    end
    --
    -- add error record for monitoring
    --
    exec @retcode = sys.sp_MSprocesslogshippingmonitorerror 
                    @mode = 1
                    ,@agent_id = @agent_id
                    ,@agent_type = @agent_type
                    ,@session_id = @session_id
                    ,@sequence_number = @sequence_number
                    ,@monitor_server = @monitor_server
                    ,@monitor_server_security_mode = @monitor_server_security_mode
                    ,@database = @database
                    ,@log_time = @curdate
                    ,@log_time_utc = @curutcdate
                    ,@message = @message
                    ,@source = @source
                    ,@help_url = @help_url
    if (@retcode != 0 or @@error != 0)
        goto UNDO    
    --
    -- all done
    --
    return 0

UNDO:
    return 1
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

