## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MScheckexistsgeneration\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MScheckexistsgeneration**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -518946516 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@genguid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@gen| |bigint|8|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@pubid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MScheckexistsgeneration\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MScheckexistsgeneration\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE sys.sp_MScheckexistsgeneration
    (@genguid uniqueidentifier, @gen bigint output, @pubid uniqueidentifier = NULL)
as
    declare @retcode int
    /*
    ** Check input parameter
    */
    if (@genguid is null)
        begin
            RAISERROR(14043, 16, -1, '@genguid', 'sp_MScheckexistsgeneration')
            return (1)
        end

    -- security check
    exec @retcode = sys.sp_MSrepl_PAL_rolecheck @pubid = @pubid
    if (@retcode &lt;&gt; 0) or (@@error &lt;&gt; 0)
        return 1

    /* Normal case : do not qualify by pubid */
    if (@pubid IS NULL)
        select @gen = max(generation) from dbo.MSmerge_genhistory where guidsrc = @genguid and genstatus in (1,2)
    else        
    /* If we are reinitializing from an alternate publisher, check if the subscription has received generations for the alternate publication */
        select @gen = max(generation) from dbo.MSmerge_genhistory where guidsrc = @genguid and genstatus in (1,2)
            and ((pubid = @pubid) or (pubid is null))       
    IF @@ERROR &lt;&gt;0 return (1)
    /* OLEDB does not allow output parameter to be NULL - setting it to 0 */
    return (0)
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

