## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_addsubscriber\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_addsubscriber**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -519424645 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@subscriber| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@type| |tinyint|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@login| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@password| |nvarchar|524|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@commit_batch_size| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@status_batch_size| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@flush_frequency| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_type| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_interval| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_relative_interval| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_recurrence_factor| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_subday| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_subday_interval| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@active_start_time_of_day| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@active_end_time_of_day| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@active_start_date| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@active_end_date| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@description| |nvarchar|255|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@security_mode| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@encrypted_password| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_addsubscriber\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_addsubscriber\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_addsubscriber
(
    @subscriber                        sysname,
    @type                            tinyint = 0,
    @login                            sysname = NULL,
    @password                        nvarchar(524) = NULL,
    @commit_batch_size                int = NULL,
    @status_batch_size                int = NULL,
    @flush_frequency                int = NULL,
    @frequency_type                    int = NULL,
    @frequency_interval                int = NULL,
    @frequency_relative_interval    int = NULL,
    @frequency_recurrence_factor    int = NULL,
    @frequency_subday                int = NULL,
    @frequency_subday_interval        int = NULL,
    @active_start_time_of_day        int = NULL,
    @active_end_time_of_day            int = NULL,
    @active_start_date                int = NULL,
    @active_end_date                int = NULL,
    @description                    nvarchar (255) = NULL,
    @security_mode                    int = NULL,  /* backward compatible */ /* 0 standard; 1 integrated */
    @encrypted_password                bit = NULL,
    @publisher                        sysname = NULL
)
AS
BEGIN
    DECLARE @cmd            nvarchar(4000)
    DECLARE @retcode        int
    DECLARE @publisher_type    sysname

    /*
    ** Security Check: require sysadmin
    */
    IF (ISNULL(IS_SRVROLEMEMBER('sysadmin'),0) = 0)
    BEGIN
        RAISERROR(21089,16,-1) 
        RETURN (1)
    END

    SET @retcode = 0
    
    EXEC @retcode = sys.sp_MSrepl_getpublisherinfo    @publisher        = @publisher,
                                                    @rpcheader        = @cmd            OUTPUT,
                                                    @publisher_type    = @publisher_type OUTPUT

                                                        
    IF @retcode &lt;&gt; 0
        RETURN (@retcode)

    --when called on mirror server, this adds original publiser name 
    --in distribution. (MSsubscriber_info and MSsubscriber_schedule)
    IF @publisher IS NULL
        SET @publisher = publishingservername() 

    -- Add sp
    SET @publisher = UPPER(@publisher) COLLATE DATABASE_DEFAULT
    set @cmd = @cmd + N'sys.sp_MSrepl_addsubscriber'
    
    EXEC @retcode = @cmd
                    @subscriber,
                    @type,
                    @login,
                    @password,
                    @commit_batch_size,
                    @status_batch_size,
                    @flush_frequency,
                    @frequency_type,
                    @frequency_interval,
                    @frequency_relative_interval,
                    @frequency_recurrence_factor,
                    @frequency_subday,
                    @frequency_subday_interval,
                    @active_start_time_of_day,
                    @active_end_time_of_day,
                    @active_start_date,
                    @active_end_date,
                    @description,
                    @security_mode,
                    @encrypted_password,
                    @publisher,
                    @publisher_type,
                    N'PRE-YUKON'

    RETURN (@retcode)
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

