## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_datatype_info\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_datatype_info**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -520841490 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@data_type| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@ODBCVer| |tinyint|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|TYPE_NAME|nvarchar|128|
|DATA_TYPE|smallint|2|
|PRECISION|int|4|
|LITERAL_PREFIX|varchar|32|
|LITERAL_SUFFIX|varchar|32|
|CREATE_PARAMS|varchar|32|
|NULLABLE|smallint|2|
|CASE_SENSITIVE|smallint|2|
|SEARCHABLE|smallint|2|
|UNSIGNED_ATTRIBUTE|smallint|2|
|MONEY|smallint|2|
|AUTO_INCREMENT|smallint|2|
|LOCAL_TYPE_NAME|nvarchar|128|
|MINIMUM_SCALE|smallint|2|
|MAXIMUM_SCALE|smallint|2|
|SQL_DATA_TYPE|smallint|2|
|SQL_DATETIME_SUB|smallint|2|
|NUM_PREC_RADIX|int|4|
|INTERVAL_PRECISION|smallint|2|
|USERTYPE|smallint|2|

---
### Objects that depend on \[sys\].\[sp_datatype_info\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_datatype_info\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_datatype_info
(
    @data_type int = 0,
    @ODBCVer tinyint = 2
)
as
    declare @mintype int
    declare @maxtype int

    set @ODBCVer = isnull(@ODBCVer, 2)
    if @ODBCVer &lt; 3 -- includes ODBC 1.0 as well
        set @ODBCVer = 2
    else
        set @ODBCVer = 3

    if @data_type = 0
    begin
        select @mintype = -32768
        select @maxtype = 32767
    end
    else
    begin
        select @mintype = @data_type
        select @maxtype = @data_type
    end

    select
        TYPE_NAME           = v.TYPE_NAME,
        DATA_TYPE           = v.DATA_TYPE_28,          -- for backward compatibility
        PRECISION           = v.PRECISION_28,          -- for backward compatibility
        LITERAL_PREFIX      = v.LITERAL_PREFIX,
        LITERAL_SUFFIX      = v.LITERAL_SUFFIX,
        CREATE_PARAMS       = v.CREATE_PARAMS_90,      -- for backward compatibility
        NULLABLE            = v.NULLABLE,
        CASE_SENSITIVE      = v.CASE_SENSITIVE_28,     -- for backward compatibility
        SEARCHABLE          = v.SEARCHABLE,
        UNSIGNED_ATTRIBUTE  = v.UNSIGNED_ATTRIBUTE,
        MONEY               = v.MONEY,
        AUTO_INCREMENT      = v.AUTO_INCREMENT,
        LOCAL_TYPE_NAME     = v.LOCAL_TYPE_NAME,
        MINIMUM_SCALE       = v.MINIMUM_SCALE_90,      -- for backward compatibility
        MAXIMUM_SCALE       = v.MAXIMUM_SCALE_90,      -- for backward compatibility
        SQL_DATA_TYPE       = v.SQL_DATA_TYPE_28,      -- for backward compatibility
        SQL_DATETIME_SUB    = v.SQL_DATETIME_SUB_90,   -- for backward compatibility
        NUM_PREC_RADIX      = v.NUM_PREC_RADIX,
        INTERVAL_PRECISION  = v.INTERVAL_PRECISION,
        USERTYPE            = v.USERTYPE

    from
        sys.spt_datatype_info_view v

    where
        v.DATA_TYPE_28 between @mintype and @maxtype and
        v.ODBCVer = @ODBCVer

    order by 2, v.MAPPED_TYPE, 12, 11, 20
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

