## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSactivateprocedureexecutionarticleobject\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSactivateprocedureexecutionarticleobject**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -524165324 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@qualified_procedure_execution_object_name| |nvarchar|517|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@is_repl_serializable_only| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSactivateprocedureexecutionarticleobject\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSactivateprocedureexecutionarticleobject\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
--
-- Name: sp_MSactivateprocedureexecutionarticleobject
--
-- Description: This procedure is called by the snapshot agent to activate
--              a single procedure execution article object.
--
-- Parameters: @qualified_procedure_execution_object_name
--             @is_repl_serializable_only
--
-- Notes: This procedure must be called within a user transaction or it will
--        result in a no-op.
--
-- Security: Public interface object, will result in no-op if called by
--           non-db_owner or non-replication agent.
-- Requires Certificate signature for catalog access
-- 
create procedure sys.sp_MSactivateprocedureexecutionarticleobject (
    @qualified_procedure_execution_object_name nvarchar(517),
    @is_repl_serializable_only bit
    )
as
begin
    set nocount on

    if @@trancount &lt; 1 return 1
    
    if sessionproperty('replication_agent') &lt;&gt; 1 return 1
    
    if object_id(N'dbo.syspublications', 'U') is null return 1
    
    declare @retcode int
          , @is_execution_replicated bit
          , @current_is_repl_serializable_only bit
          , @object_id int
          , @error int
    set @retcode = 0

    exec @retcode = sys.sp_MSreplcheck_publish
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
        return 1

    set @object_id = object_id(@qualified_procedure_execution_object_name)
    select @is_execution_replicated = is_execution_replicated
         , @current_is_repl_serializable_only = is_repl_serializable_only
      from sys.procedures
     where object_id = @object_id
    
    if @is_execution_replicated = 0 or 
       @current_is_repl_serializable_only = 0 and @is_repl_serializable_only = 1
    begin
        exec %%Object(MultiName = @qualified_procedure_execution_object_name).LockMatchID(ID = @object_id, Exclusive = 1, BindInternal = 0)
        set @error = @@error if @error &lt;&gt; 0 begin raiserror(@error, 16, -1) return 1 end
        exec %%Module(ID = @object_id).SetProcReplicated(Value = 1)
        set @error = @@error if @error &lt;&gt; 0 begin raiserror(@error, 16, -1) return 1 end
        if @is_repl_serializable_only = 1
        begin
            exec %%Module(ID = @object_id).SetProcReplSerialOnly(Value = 1)
            set @error = @@error if @error &lt;&gt; 0 begin raiserror(@error, 16, -1) return 1 end
        end
    end

    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

