## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSdeletetranconflictrow\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSdeletetranconflictrow**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -526333623 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@tran_id| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@row_id| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@conflict_table| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSdeletetranconflictrow\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSdeletetranconflictrow\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_MSdeletetranconflictrow ( 
    @tran_id sysname,
    @row_id sysname = '%',                      -- % = ALL
    @conflict_table sysname)
as 
begin
    set nocount on
    declare @retcode int
                ,@cmd nvarchar(4000)
                ,@startoffset int
                ,@table    sysname
                ,@schema sysname

    /*
    **  Security check.  restrict to 'sysadmin' and member of db_owner role
    */ 
    exec @retcode = sys.sp_MSreplcheck_publish
    if @@ERROR &lt;&gt; 0 or @retcode &lt;&gt; 0
        return (1)

    if (@conflict_table is NULL)
    begin
        raiserror(14043, 16, 1, '@conflict_table', 'sp_MSdeletetranconflictrow')
        return (1)
    end
    --
    -- check if the conflict table is owner qualified
    -- and build the delete string as necessary
    --
    select @table = PARSENAME(@conflict_table, 1),
            @schema = PARSENAME(@conflict_table, 2)
            
    select @cmd = 'delete ' + ISNULL(NULLIF(QUOTENAME(@schema) + N'.', N'.'), N'') + QUOTENAME(@table)
            + ' where tranid = ' + QUOTENAME(@tran_id, '''')

    if (@row_id != N'%')
    begin
        select @cmd = @cmd +
        ' and qcfttabrowid = ' + QUOTENAME(@row_id, '''')
    end
    
    execute (@cmd)
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

