## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_check_constraints_rowset\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_check_constraints_rowset**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -526944787 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@constraint_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@constraint_schema| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|CONSTRAINT_CATALOG|nvarchar|128|
|CONSTRAINT_SCHEMA|nvarchar|128|
|CONSTRAINT_NAME|nvarchar|128|
|CHECK_CLAUSE|nvarchar|4000|
|DESCRIPTION|nvarchar|1|

---
### Objects that depend on \[sys\].\[sp_check_constraints_rowset\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_check_constraints_rowset\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_check_constraints_rowset
(
    @constraint_name    sysname,
    @constraint_schema  sysname = null
)
as
    select
        CONSTRAINT_CATALOG  = db_name(),
        CONSTRAINT_SCHEMA   = schema_name(o.schema_id),
        CONSTRAINT_NAME     = o.name,
        CHECK_CLAUSE        = convert(nvarchar(4000), m.definition), -- keep the type as it used to be in Shiloh
        DESCRIPTION         = convert(nvarchar(1), null)
    from
        sys.all_objects o inner join
        sys.check_constraints m on (o.type = 'C ' and m.object_id = o.object_id)
    where
        (@constraint_schema is null and o.name = @constraint_name) or
        object_id(quotename(@constraint_schema) + '.' + quotename(@constraint_name)) = o.object_id
    order by 1,2,3
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

