## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_sqlagent_add_job\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_sqlagent_add_job**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -527194805 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@job_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@enabled| |tinyint|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@description| |nvarchar|512|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@start_step_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@notify_level_eventlog| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@delete_level| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@job_id| |uniqueidentifier|16|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_sqlagent_add_job\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_sqlagent_add_job\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_sqlagent_add_job
    @job_name               SYSNAME, 
    @enabled                TINYINT = 1, -- 0 = Disabled, 1 = Enabled 
    @description            NVARCHAR(512) = NULL, 
    @start_step_id          INT = 1, 
    @notify_level_eventlog  INT = 2, -- 0 = Never, 1 = On Success, 2 = On Failure, 3 = Always 
    @delete_level           INT = 0, -- 0 = Never, 1 = On Success, 2 = On Failure, 3 = Always 
    @job_id                 UNIQUEIDENTIFIER = NULL OUTPUT 
AS 
BEGIN 
    DECLARE @retval INT 

    -- Validate if current db context is supported
    EXEC @retval = sys.sp_sqlagent_verify_database_context
    IF (@retval &lt;&gt; 0)
    BEGIN
        RETURN(@retval)
    END


    IF (@job_id IS NULL) 
    BEGIN 
        -- Assign new GUID for the job
        SELECT @job_id = NEWID() 
    END 

    INSERT INTO sys.sqlagent_jobs 
    (
        job_id, 
        name, 
        enabled, 
        description, 
        start_step_id, 
        notify_level_eventlog, 
        delete_level, 
        date_created, 
        date_modified
    ) 
    VALUES 
    (
        @job_id, 
        @job_name, 
        @enabled, 
        @description, 
        @start_step_id, 
        @notify_level_eventlog, 
        @delete_level, 
        GETDATE(), 
        GETDATE() 
    ) 

    SELECT @retval = @@error 

    -- If Insert job failed, then we dont need to notify sql agent
    IF (@retval &lt;&gt; 0)
    BEGIN
        RETURN(@retval)
    END

    --Notify SQL Agent that  new job was created
    EXECUTE @retval = master.dbo.xp_sqlagent_notify 
        N'J',
        @job_id,
        NULL,
        NULL,
        N'I',
        NULL,
        1,
        @@trancount,
        NULL
    
    RETURN(@retval) -- 0 means success 
    
END 
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

