## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_ivindexhasnullcols\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_ivindexhasnullcols**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -536913879 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@viewname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@fhasnullcols| |bit|1|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_ivindexhasnullcols\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_ivindexhasnullcols\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_ivindexhasnullcols (
    @viewname sysname
    ,@fhasnullcols bit OUTPUT
)
as
begin
   declare @f_ind_unique bit
            ,@f_ind_clustered bit
            ,@ivobject_id int
            ,@indkey int
            ,@key sysname
            ,@retcode int

    exec @retcode = sys.sp_MSreplcheck_publish
    if @@ERROR &lt;&gt; 0 or @retcode &lt;&gt; 0
        return(1)
    --
    -- validate view object
    --
    select @ivobject_id = object_id(@viewname)
            ,@fhasnullcols = 0
            
    if (@ivobject_id IS NULL or @ivobject_id = 0)
    begin
        raiserror(15390, 16, 1, @viewname)
        return 1
    end

    --
    -- get the clustered index and validate
    --
    select @f_ind_unique = case (status &amp; 2) when 0 then 0 else 1 end
            ,@f_ind_clustered = case (status &amp; 16) when 0 then 0 else 1 end 
    from dbo.sysindexes
    where id = @ivobject_id and indid = 1
    
    if (@f_ind_unique != 1) or (@f_ind_clustered != 1)
    begin
        raiserror(21751, 16, 1, @viewname)
        return 1
    end
    
    --
    -- create an enumeration of all the columns that are part of the view index
    --
    create table #indcoltab(vindexcol int identity, keyname sysname collate database_default not null)
    select @indkey = 1
    while (@indkey &lt;= 16)
    begin
        select @key = index_col( @viewname, 1, @indkey )
        if (@key is null)
            break
        else
            insert into #indcoltab(keyname) values(@key)

        select @indkey = @indkey + 1
    end

    --
    -- We should not have any column participating in this index
    -- that allows NULL if we do
    -- mark the output flag to TRUE
    --
    if exists (select * 
        from sys.columns 
        where object_id = @ivobject_id 
            and is_nullable = 1
            and name in (select keyname from #indcoltab))
    begin
        select @fhasnullcols = 1
    end

    --
    -- all done, cleanup and return
    --
    drop table #indcoltab
    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

