## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_flush_CT_internal_table_on_demand\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_flush_CT_internal_table_on_demand**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 06/15/2019 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -541968338 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@TableToClean| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_flush_CT_internal_table_on_demand\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_flush_CT_internal_table_on_demand\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
-- Name: 
--    sp_flush_CT_internal_table_on_demand 
-- 
-- Description: 
--    This procedure is called by user by passing a table name for which CT is enabled.  This calls the internal stored proc to manually clean up the backlog of the auto cleanup task.
--
-- Parameters: 
--    See the procedure definition.
--
-- Returns: 
--    0 - succeeded
--    1 - failed
--
-- Result: 
--    None
--
-- Security: 
--    Internal
--
create procedure sys.sp_flush_CT_internal_table_on_demand 
    @TableToClean SYSNAME
AS
BEGIN
    
    SET NOCOUNT ON;

    IF (is_srvrolemember('sysadmin') = 0)
    BEGIN
        RAISERROR(21089,0,1)
        RETURN 1
    END

    DECLARE @cmd    nvarchar(50)
    DECLARE @objid     int
    SELECT @objid = object_id(@TableToClean)

    SET @cmd = N'sys.sp_MSflush_CT_internal_table_on_demand'
    
    EXEC @cmd
        @objid,
        @TableToClean
END            
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

