## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSIfExistsSubscription\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSIfExistsSubscription**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -542122067 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@type| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSIfExistsSubscription\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSIfExistsSubscription\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSIfExistsSubscription
(
    @publisher sysname,
    @publisher_db sysname,
    @publication sysname,
    @type int /* replication type, 1 - transactional/snapshot, 2 - merge */
)
as
begin
    declare @publisher_id smallint
    declare @publication_id int

    --
    -- security check
    -- only replmonitor can execute this
    --
    if not (is_member(N'db_owner') = 1 or isnull(is_member(N'replmonitor'),0) = 1)
    begin
        raiserror(14260, 16, -1)
        return (1)
    end

    if @type not in (1,2)
    begin
        RAISERROR(21055, 16, -1, '@type','sp_MSIfExistsSubscription')
        RETURN (1)
    end

    set nocount on

    select @publisher_id = srvid from master.dbo.sysservers where
       UPPER(srvname) = UPPER(@publisher)

    if @type = 1
    begin
        select @publication_id = publication_id from dbo.MSpublications  where 
                publisher_id = @publisher_id and
                publisher_db = @publisher_db and
                publication = @publication and
                (publication_type = 0 or publication_type = 1)
    
        select TOP 1 1 from MSdistribution_agents a
            where exists (select * from dbo.MSsubscriptions s where
                (a.id = s.agent_id or a.anonymous_agent_id = s.agent_id) and
                s.publisher_id = @publisher_id and
                s.publisher_db = @publisher_db and
                -- For 6.x publisher, we don't know the association between the publication
                -- and subscriptions. Show every dist agent under each publication.
                (s.publication_id = @publication_id or s.publication_id = 0 ) and
                (a.subscriber_id &gt;= 0  or a.subscriber_id is NULL))
    end
    else
    begin
        select @publication_id = publication_id from dbo.MSpublications  where 
                publisher_id = @publisher_id and
                publisher_db = @publisher_db and
                publication = @publication and
                publication_type = 2 -- Merge 
    
        select TOP 1 1 from dbo.MSmerge_agents 
            where publisher_id = @publisher_id and 
                publisher_db = @publisher_db and 
                publication = @publication
    end
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

