## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSinit_publication_access\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSinit_publication_access**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -543341726 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@initinfo| |nvarchar|1073741823|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@skip| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSinit_publication_access\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSinit_publication_access\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_MSinit_publication_access 
(
    @publisher sysname,
    @publisher_db sysname = NULL,
    @publication sysname = NULL,
    @initinfo nvarchar(max),
    @skip bit = 0
) 
as
begin
    set nocount on
    declare @publisher_id smallint
            ,@retcode int
            ,@publication_id int
            ,@login sysname
            ,@sid varbinary(85)
            ,@itemstart bigint
            ,@itemend bigint
    --
    -- sysadmin check
    --
    if (isnull(is_srvrolemember(N'sysadmin'),0) = 0)
    begin
        raiserror(21089,16,-1) 
        return (1)
    end
    --
    -- initinfo should not be null
    --
    if (@initinfo is null or @initinfo = N'')
        return 0
    --
    -- Check if publisher is a defined as a distribution publisher in the current database
    --
    exec @retcode = sys.sp_MSvalidate_distpublisher @publisher, @publisher_id OUTPUT
    if @retcode &lt;&gt; 0
        return(1)
    --
    -- validate publication
    --
    select @publication_id = publication_id 
    from dbo.MSpublications 
    where 
        publisher_id = @publisher_id and
        publisher_db = @publisher_db and
        publication = @publication
    --
    -- Publication does not exist
    --
    if @publication_id is null
    begin
        raiserror (20026, 16, -1, @publication)
        return (1)
    end
    --
    -- while there are items 
    --
    select @itemstart = charindex(N'&lt;item\&gt;', @initinfo)
    while (@itemstart &gt; 0)
    begin
        select @itemend = charindex(N'&lt;/item\&gt;', @initinfo, @itemstart)
        select @login = substring(@initinfo, @itemstart + 7, @itemend - @itemstart - 7)
        --
        -- Check to see if the login exists - should have valid SID
        --
        select @sid = suser_sid(@login,0)
        if (@sid is not null)
        begin
            -- Add login to the access list if it does not exist
            if not exists (select * from dbo.MSpublication_access 
                                where publication_id = @publication_id and
                                        sid = @sid)
            begin
                insert dbo.MSpublication_access (publication_id, login, sid)
                    values (@publication_id,@login,@sid)
                if  @@error &lt;&gt; 0
                    return(1)
            end
        end
        else
        begin
            -- Login does not have access
            if @skip = 0
            begin
                raiserror(21048, 16, 1, @login, @@servername) 
                return (1)
            end
        end
        --
        -- get the start of next item
        --
        select @itemstart = charindex(N'&lt;item\&gt;', @initinfo, @itemend)
    end -- while (@itemstart &gt; 0)
    --
    -- all done
    --
    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

