## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_attach_single_file_db\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_attach_single_file_db**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -543801409 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@dbname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@physname| |nvarchar|260|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_attach_single_file_db\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_attach_single_file_db\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_attach_single_file_db
    @dbname sysname,
    @physname nvarchar(260)
as
    declare @execstring nvarchar (4000)
    set nocount on

    if (SERVERPROPERTY('IsMatrix') = 1)
    begin
        raiserror (28401, -1, -1, N'sys.sp_attach_single_file_db')
        return (1)
    end

    if ((@dbname is null or datalength(@dbname) = 0) or
       (@physname is null or datalength(@physname) = 0))
    begin
        raiserror (15004,-1,-1)
        return (1)
    end

    select @execstring = 'CREATE DATABASE '
        + quotename( @dbname , '[')
        + ' ON (FILENAME ='
        + ''''
        + REPLACE(@physname,N'''',N'''''')
        + ''''
        + ' ) FOR ATTACH'
    EXEC (@execstring)
    if @@error &lt;&gt;  0
    begin
        -- No need to raiserror as the CREATE DATABASE will do so
        return(1)
    end

    -- strip out replication from this database
    EXEC sys.sp_MSremovedbreplication_internal @dbname

    return (0) -- sp_attach_single_file_db
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

