## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_dbmmonitordropalert\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_dbmmonitordropalert**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -545662348 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@database_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@alert_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_dbmmonitordropalert\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_dbmmonitordropalert\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_dbmmonitordropalert
(
    @database_name        sysname,
    @alert_id            int = null
)

as
begin
    set nocount on
    if (is_srvrolemember(N'sysadmin') &lt;&gt; 1 )
        begin
            raiserror(21089, 16, 1)
            return (1)
        end
    if(@alert_id is not null and (@alert_id &lt; 1 or @alert_id &gt; 5) )
    begin
        raiserror( 32036, 16, 1)
        return 1
    end
    -- Is this a system database?
    if(@database_name = N'msdb' or @database_name = N'master' or @database_name = N'model' or @database_name = N'tempdb')
    begin
        raiserror( 32050, 16, 1)
        return 1
    end
    if object_id ( N'msdb.dbo.dbm_monitor_alerts', N'U' ) is null
    begin
        raiserror( 32041, 16, 1 )
        return 1
    end
    -- Does the database exist?
    if not exists (select * from master.sys.databases where name = @database_name)
    begin
        raiserror(15010, 16, 1, @database_name)
        return 1
    end

    if exists (select * from msdb.dbo.dbm_monitor_alerts where database_id = db_id(@database_name))    --TO DO: cache db_id to local variable
    begin
        if @alert_id is null
        begin
            update msdb.dbo.dbm_monitor_alerts set    time_behind = null, enable_time_behind = null,
                                                    send_queue = null, enable_send_queue = null,
                                                    redo_queue = null, enable_redo_queue = null,
                                                    average_delay = null, enable_average_delay = null
                where database_id = db_id(@database_name)
            return 0
        end
        if @alert_id = 1
        begin
            update msdb.dbo.dbm_monitor_alerts set time_behind = null, enable_time_behind = null where database_id = db_id(@database_name)
            return 0
        end
        if @alert_id = 2
        begin
            update msdb.dbo.dbm_monitor_alerts set send_queue = null, enable_send_queue = null where database_id = db_id(@database_name)
            return 0
        end
        if @alert_id = 3
        begin
            update msdb.dbo.dbm_monitor_alerts set redo_queue = null, enable_redo_queue = null where database_id = db_id(@database_name)
            return 0
        end
        if @alert_id = 4
        begin
            update msdb.dbo.dbm_monitor_alerts set average_delay = null, enable_average_delay = null where database_id = db_id(@database_name)
            return 0
        end
        if @alert_id = 5
        begin
            update msdb.dbo.dbm_monitor_alerts set retention_period = null where database_id = db_id(@database_name)
            return 0
        end
    end
    -- Row was not there to drop....
    return 1
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

