## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_reinitsubscription\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_reinitsubscription**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -545750621 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@article| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscriber| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@destination_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@for_schema_change| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@ignore_distributor_failure| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@invalidate_snapshot| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_reinitsubscription\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_reinitsubscription\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_reinitsubscription
(
    @publication                sysname = 'all',
    @article                    sysname = 'all',
    @subscriber                    sysname,
    @destination_db                sysname = 'all',
    @for_schema_change            bit = 0,
    @publisher                    sysname = NULL,
    @ignore_distributor_failure bit = 0,
    @invalidate_snapshot        bit = 0
)
AS
BEGIN
    DECLARE @cmd            nvarchar(4000)
    DECLARE @retcode        int
    DECLARE @distributor    sysname
    DECLARE @distribdb        sysname
    DECLARE @publisher_type    sysname

    SET NOCOUNT ON

    SET @retcode = 0
    
    EXEC @retcode = sys.sp_MSrepl_getpublisherinfo    @publisher            = @publisher,
                                                    @rpcheader            = @cmd OUTPUT,
                                                    @publisher_type        = @publisher_type OUTPUT,
                                                    @skipSecurityCheck    = 1
    
    IF @retcode &lt;&gt; 0
        RETURN (@retcode)

    -- Add sp
    SET @publisher = UPPER(@publisher) COLLATE DATABASE_DEFAULT
    set @cmd = @cmd + N'sys.sp_MSrepl_reinitsubscription'

    -- Get distributor info
    EXEC @retcode = sys.sp_MSrepl_getdistributorinfo    @publisher        = @publisher,
                                            @rpcsrvname        = @distributor OUTPUT,
                                            @distribdb        = @distribdb OUTPUT

    IF (@retcode &lt;&gt; 0 OR @@ERROR &lt;&gt; 0 OR @distribdb IS NULL or @distributor IS NULL) and @ignore_distributor_failure = 0
    BEGIN
        RAISERROR (14071, 16, -1)
        RETURN (1)
    END

    EXEC @retcode = @cmd
                    @publication,
                    @article,
                    @subscriber,
                    @destination_db,
                    @for_schema_change,
                    @distributor,
                    @distribdb,
                    @publisher,
                    @publisher_type,
                    @ignore_distributor_failure,
                    @invalidate_snapshot

    RETURN (@retcode)
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

