## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_clean_db_file_free_space\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_clean_db_file_free_space**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -566824212 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@dbname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@fileid| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@cleaning_delay| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_clean_db_file_free_space\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_clean_db_file_free_space\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_clean_db_file_free_space (
    @dbname sysname,
    @fileid int,
    @cleaning_delay int = 0)
as
begin
    SET NOCOUNT ON
    declare @quoted_dbname nvarchar(258)
    set @quoted_dbname=QUOTENAME(@dbname)

    --
    -- Parameter check
    -- @dbname
    --
    if (db_id(@dbname) is null)
    begin
        RAISERROR(15010, 16, -1, @quoted_dbname)
        return (1)
    end

    --
    -- security check
    -- only db_owner can execute this
    --
    declare @check nvarchar(1024)
    set @check = 'USE ' + @quoted_dbname +
    'if (is_member (''db_owner'') != 1)
    begin
        raiserror(14260, 16, -1)
    end'
    exec (@check)
    if @@error =14260
    begin
        return (1)
    end

    declare @page int
    set @page = 0
    declare @dbid int

    create table #continueclean (
        fileid int,
        page int)
    declare @sql as nvarchar(1024)
    set @sql = 'insert #continueclean (fileid, page) select file_id, size from ' + @quoted_dbname + '.sys.database_files where file_id=' + cast(@fileid as nvarchar) + ' and type=0'
    exec (@sql)

    select @dbid=db_id(@dbname)
    while exists(select * from #continueclean where fileid = @fileid and page &gt; @page)
    begin
        dbcc cleanpage(@dbid , @fileid, @page)
        set @page = @page+1

        -- delay execution to throttle impact on system
        if (@cleaning_delay &gt; 0)
            waitfor delay @cleaning_delay

        -- checkpoint periodically
        if @page % 10000 = 0
        begin
            dbcc flush('data', @dbid)
        end

        set @sql = 'update #continueclean set fileid=file_id, page=size from ' + @quoted_dbname + '.sys.database_files where file_id=' + cast(@fileid as nvarchar) + ' and type=0'
        exec (@sql)
    end
    drop table #continueclean
    dbcc flush('data', @dbid)
    end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

