## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_verifypublisher\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_verifypublisher**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -569937618 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_verifypublisher\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_verifypublisher\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

--
-- Name:
--        sp_verifypublisher
--
-- Description:
--        Verify that publisher state is valid for HREPL
--
-- Returns:
--        0      == Valid
--        1      == Error in publisher state
--
-- Security:
--        Internal
--
-- Notes:
--        Used by any routine that wants to validate
--        the state of the HREPL publisher before
--        performing any actions against it.
--        Errors are issued at warning level to allow
--        the calling proc to decide how to handle it.
--        For example, drop procedures would typically
--        choose to ignore the errors since everything
--        is being dropped.  Add procedures would tend
--        to error out immediately.
--

CREATE PROCEDURE sys.sp_verifypublisher
(
    @publisher            sysname
)
AS
BEGIN
    DECLARE @retcode    int
    DECLARE    @publisher_type    sysname
    DECLARE @cmd        nvarchar(4000)
    
    -------- security check, db_owner
    exec @retcode = dbo.sp_MSreplcheck_publish
    if @@ERROR &lt;&gt; 0 or @retcode &lt;&gt; 0
        return(1)

    -- Get publisher information
    EXEC @retcode = sys.sp_MSrepl_getpublisherinfo    @publisher        = @publisher,
                                                    @publisher_type    = @publisher_type OUTPUT,
                                                    @rpcheader        = @cmd OUTPUT
    
    IF @retcode &lt;&gt; 0
        RETURN (@retcode)

    -- Execute provider-specific verification
    IF UPPER(@publisher_type) IN ('ORACLE', 'ORACLE GATEWAY')
    BEGIN
        SET @publisher = UPPER(@publisher) COLLATE DATABASE_DEFAULT
        SELECT @cmd = @cmd + 'sys.sp_ORAverifypublisher'
        EXEC @retcode = @cmd @publisher
    END
    ELSE
    BEGIN
        RAISERROR(21645, 16, -1, @publisher_type)
        SET @retcode = 1
    END

    return @retcode
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

