## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSenumpubreferences\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSenumpubreferences**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -57042880 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSenumpubreferences\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSenumpubreferences\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSenumpubreferences (@publication sysname)
as
    declare @pubid uniqueidentifier
    declare @retcode int
    
    /* 
    ** Security Check.
    */
    exec @retcode = sys.sp_MSmerge_validate_publication_presence @publication, NULL, NULL, @pubid output
    if @retcode&lt;&gt;0 or @@error&lt;&gt;0
        return 1
        
    /* make sure current database is enabled for merge replication */
    exec @retcode=sys.sp_MSCheckmergereplication
    if @@ERROR&lt;&gt;0 or @retcode&lt;&gt;0
        return (1)

    select distinct ReferencingObject = object_name(referenced_object_id), ArticleObject = object_name(parent_object_id) 
        from sys.foreign_keys
        where parent_object_id in (select objid from dbo.sysmergearticles where pubid = @pubid) and
              referenced_object_id not in (select objid from dbo.sysmergearticles where pubid = @pubid)

    select distinct ReferencedObject = object_name(parent_object_id), ArticleObject = object_name(referenced_object_id) 
        from sys.foreign_keys
        where referenced_object_id in (select objid from dbo.sysmergearticles where pubid = @pubid) and
              parent_object_id not in (select objid from dbo.sysmergearticles where pubid = @pubid)

    -- We need to check if the publication role is already added.
    -- this has to be done here before the snapshot agent calls sp_Mspublicationview
    declare @role sysname
    exec @retcode = sys.sp_MSrepl_FixPALRole @pubid, @role output
    if (@role is NULL or @retcode &lt;&gt; 0 or @@error &lt;&gt; 0)
    begin
        -- add appropriate error message here
        return 1
    end

    -- we also need to fix the pal role for other publications which share an article
    -- with the current publication and the role for those publications are not
    -- present yet
    declare @pubidother uniqueidentifier
    declare pubs_cursor cursor LOCAL FAST_FORWARD
    for (select a.pubid from dbo.sysmergearticles a, dbo.sysmergepublications p
            where a.pubid &lt;&gt; @pubid and a.pubid = p.pubid 
                and LOWER(p.publisher)  collate database_default = LOWER(publishingservername()) collate database_default 
                and p.publisher_db = DB_NAME() and artid in 
                 (select artid from dbo.sysmergearticles where pubid = @pubid)) 
    open pubs_cursor
    fetch pubs_cursor into @pubidother
    while (@@fetch_status &lt;&gt; -1)
    begin
        exec @retcode = sys.sp_MSrepl_FixPALRole @pubidother, @role output
        if (@role is NULL or @retcode &lt;&gt; 0 or @@error &lt;&gt; 0)
        begin
            return 1
        end
        fetch pubs_cursor into @pubidother
    end
    close pubs_cursor
    deallocate pubs_cursor

    --exec sys.sp_MScheck_article_order @pubid
    
    return (0)
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

