## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_addrolemember\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_addrolemember**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -575389030 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@rolename| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@membername| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_addrolemember\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_addrolemember\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
-- FOR BACKWARD COMPATIBILTY ONLY --
create procedure sys.sp_addrolemember
    @rolename       sysname,
    @membername     sysname
AS
    -- SETUP RUNTIME OPTIONS / DECLARE VARIABLES --
    set nocount on
    declare @ret        int,    -- return value of sp call
            @memuid     int,
            @stmtR        nvarchar(4000)

    -- Was a part of check to prevent inside a user Xact. Leave for backward compat.--
    set implicit_transactions off

    exec @ret = sys.sp_validname @rolename
    if @ret &lt;&gt; 0
        return(1)

    exec @ret = sys.sp_validname @membername
    if @ret &lt;&gt; 0
        return(1)

    BEGIN TRANSACTION

        -- EXCL LOCK MEMBER --
        EXEC %%Owner(Name = @membername).Lock(Exclusive = 1) -- may fail

        -- ATTEMPT ADDING IMPLICIT ROW FOR NT NAME --
        if @@error &lt;&gt; 0    -- not found
        begin
            EXEC @ret = sys.sp_MSadduser_implicit_ntlogin @membername
            if (@ret &lt;&gt; 0)
            begin
                ROLLBACK TRANSACTION
                raiserror(15410, -1, -1, @membername)
                return (1)
            end
            -- Member locked by sp_MSadduser_implicit_ntlogin
        end

        set @stmtR = 'alter role '
        set @stmtR = @stmtR + quotename(@rolename, ']')
        set @stmtR = @stmtR + ' add member '
        set @stmtR = @stmtR + quotename(@membername, ']')

        -- issue DDL to create the role --
        exec (@stmtR)
        if @@error &lt;&gt; 0
        begin
            ROLLBACK TRANSACTION
            return (1)
        end

    -- RETURN SUCCESS --
    COMMIT TRANSACTION
    return (0) -- sp_addrolemember
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

