## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_check_removable\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_check_removable**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -587881273 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@autofix| |varchar|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|groupname|nvarchar|128|

---
### Objects that depend on \[sys\].\[sp_check_removable\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_check_removable\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_check_removable @autofix varchar(4)
as
    declare @dbname sysname
    declare @exec_stmt nvarchar(max)
    declare @fgname sysname

    select @dbname=db_name()

    -- USE CORRECT non-dbo/guest CHECKING
    declare @ret int
    EXEC @ret = sys.sp_check_removable_sysusers @autofix
    if @ret &lt;&gt; 0
        return 1

    -- Run UPDATE STATISTICS on all user tables if there are no user defined filegroups
    if @autofix='auto' and
        (select count(*) from sysfilegroups) = 1
    begin
        select @exec_stmt = N'USE ' + quotename( @dbname , '[')
        + N' EXEC sys.sp_updatestats '
        EXEC (@exec_stmt)
    end

    if (select count(*) from sysfilegroups) &gt; 1
    begin
        if @autofix='auto'
        begin
            -- Mark any non-primary filegroups as READONLY
            DECLARE ms_crs_fg CURSOR LOCAL STATIC
            FOR SELECT groupname FROM sysfilegroups fg
                WHERE fg.groupid &gt; 1 -- not primary
                AND fg.status &amp; 0x8 = 0 -- not already readonly
                AND (SELECT count (*) FROM sysfiles f WHERE
                f.groupid = fg.groupid) &gt; 0 -- has some files
            OPEN ms_crs_fg
            FETCH NEXT FROM ms_crs_fg INTO @fgname
            WHILE (@@FETCH_STATUS &lt;&gt; -1)
            BEGIN
                SELECT @exec_stmt = 'ALTER DATABASE '
                + quotename( @dbname , '[')
                + ' MODIFY FILEGROUP '
                + quotename( @fgname , '[')
                + ' READONLY'
                EXEC (@exec_stmt)
                FETCH NEXT FROM ms_crs_fg INTO @fgname
            END
            CLOSE ms_crs_fg
            DEALLOCATE ms_crs_fg
        end
        else
        begin
            if exists (SELECT groupname FROM sysfilegroups fg
                WHERE fg.groupid &gt; 1 -- not primary
                AND fg.status &amp; 0x8 = 0 -- not already readonly
                AND (SELECT count (*) FROM sysfiles f WHERE
                f.groupid = fg.groupid) &gt; 0) -- has some files
            begin
                raiserror(15358,-1,-1)
                SELECT groupname FROM sysfilegroups fg
                    WHERE fg.groupid &gt; 1 -- not primary
                    AND fg.status &amp; 0x8 = 0 -- not already readonly
                return (-1)
            end
        end
    end
    return(0) -- sp_check_removable
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

