## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_sqlagent_start_job\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_sqlagent_start_job**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -590243430 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@job_id| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_sqlagent_start_job\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_sqlagent_start_job\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE sys.sp_sqlagent_start_job 
  @job_id      UNIQUEIDENTIFIER
AS
BEGIN
    DECLARE @retval INT 
    DECLARE @user_name   NVARCHAR(100)
    DECLARE @job_id_as_char VARCHAR(36)

    -- Validate if current db context is supported
    EXEC @retval = sys.sp_sqlagent_verify_database_context
    IF (@retval &lt;&gt; 0)
    BEGIN
        RETURN(@retval)
    END

    -- If  job_id is null, then throw validation error
    IF(@job_id IS NULL)
    BEGIN
        RAISERROR(14262, -1, -1, '@job_id', 'NULL')
        RETURN(1) --Failure
    END

    SELECT @user_name = ISNULL(NT_CLIENT(), ISNULL(SUSER_SNAME(), FORMATMESSAGE(14205)))

    -- Validate if given job_id exists in agent_jobs
    IF NOT EXISTS (SELECT name
                FROM sys.sqlagent_jobs
                WHERE job_id = @job_id)
    BEGIN
      SET @job_id_as_char = CONVERT(VARCHAR(36), @job_id)
      RAISERROR(14262, -1, -1, '@job_id', @job_id_as_char)
      RETURN(1) -- Failure
    END

    -- Notify SQL Agent on job start request
    EXECUTE @retval = master.dbo.xp_sqlagent_notify 
        N'J',
        @job_id,
        NULL,
        NULL,
        N'S',
        @user_name,
        1,
        @@trancount,
        NULL

     RETURN(@retval) -- 0 means success 
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

