## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_getdefaultdatatypemapping\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_getdefaultdatatypemapping**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -594780470 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@source_dbms| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_version| |varchar|10|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_type| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_length| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_precision| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_scale| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_nullable| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@destination_dbms| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@destination_version| |varchar|10|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@destination_type| |sysname|128|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@destination_length| |bigint|8|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@destination_precision| |int|4|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@destination_scale| |int|4|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@destination_nullable| |bit|1|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@dataloss| |bit|1|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_getdefaultdatatypemapping\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_getdefaultdatatypemapping\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

--
-- Name:
--        sp_getdefaultdatatypemapping
--
-- Description:
--        Retrieve default data type for specified parameters
--
-- Returns:
--        0 if successful
--        1 if failed
--
-- Security:
--        Public
--
-- Notes:
--        
--

create procedure sys.sp_getdefaultdatatypemapping
(
    @source_dbms            sysname,
    @source_version            varchar(10) = NULL,
    @source_type            sysname,
    @source_length            bigint = NULL,
    @source_precision        int = NULL,
    @source_scale            int = NULL,
    @source_nullable        bit = 1,
    @destination_dbms        sysname,
    @destination_version    varchar(10) = NULL,
    @destination_type        sysname OUTPUT,
    @destination_length        bigint OUTPUT,
    @destination_precision    int OUTPUT,
    @destination_scale        int OUTPUT,
    @destination_nullable    bit OUTPUT,
    @dataloss                bit OUTPUT
)
as
BEGIN
    DECLARE @retcode int
    SET @retcode = 0

    --
    -- Security Check: require sysadmin
    --
    IF (ISNULL(IS_SRVROLEMEMBER('sysadmin'),0) = 0)
    BEGIN
        RAISERROR(21089,16,-1) 
        RETURN (1)
    END


    -- Check if type even exists
    IF (sys.fn_MSrepl_checktype(@source_type, @source_dbms, @source_version) = 0)
    BEGIN
        RAISERROR(21654, 16, -1, @source_type)
        RETURN (1)
    END
    
    SELECT    @destination_type        = destination_type,
            @destination_length        = destination_length,
            @destination_precision    = destination_precision,
            @destination_scale        = destination_scale,
            @destination_nullable    = destination_nullable,
            @dataloss                = dataloss
    FROM    sys.fn_MSrepl_getdatatypemappings
            (
                @source_dbms,
                @source_version,
                @source_type,
                @source_length,
                @source_precision,
                @source_scale,
                @source_nullable,
                @destination_dbms,
                @destination_version,
                1,
                NULL
            )
            
    IF @@ROWCOUNT = 0
    BEGIN
        RAISERROR (21656, 16, -1, @source_type)
        RETURN (1)
    END

    RETURN (0)
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

