## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_addsrvrolemember\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_addsrvrolemember**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -595219695 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@loginame| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@rolename| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_addsrvrolemember\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_addsrvrolemember\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
-- FOR BACKWARD COMPATIBILTY ONLY --
create procedure sys.sp_addsrvrolemember
    @loginame sysname,            -- login name
    @rolename sysname = NULL    -- server role name
as
    -- SETUP RUNTIME OPTIONS / DECLARE VARIABLES --
    set nocount on
    declare @ret        int,    -- return value of sp call
            @stmtR        nvarchar(4000)

    -- Was a part of check to prevent inside a user Xact. Leave for backward compat.--
    set implicit_transactions off

    exec @ret = sys.sp_validname @rolename
    if @ret &lt;&gt; 0
        return(1)

    exec @ret = sys.sp_validname @loginame
    if @ret &lt;&gt; 0
        return(1)

    BEGIN TRANSACTION
        -- LOCK LOGIN --
        EXEC %%LocalLogin(Name = @loginame).Lock(Exclusive = 1)

        -- ADD ROW FOR NT LOGIN IF NEEDED --
        if @@error &lt;&gt; 0    -- not found
        begin
            execute @ret = sys.sp_MSaddlogin_implicit_ntlogin @loginame
            if (@ret &lt;&gt; 0)
            begin
                ROLLBACK TRANSACTION
                raiserror(15007,-1,-1,@loginame)
                return (1)
            end
            -- login locked
        end

        set @stmtR = 'alter server role '
        set @stmtR = @stmtR + quotename(@rolename, ']')
        set @stmtR = @stmtR + ' add member '
        set @stmtR = @stmtR + quotename(@loginame, ']')

        -- issue DDL to create the role --
        exec (@stmtR)    
        if @@error &lt;&gt; 0
        begin
            ROLLBACK TRANSACTION
            return (1)
        end

    -- RETURN SUCCESS --
    COMMIT TRANSACTION
    return (0) -- sp_addsrvrolemember
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

