## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSreleasesnapshotdeliverysessionlock\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSreleasesnapshotdeliverysessionlock**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -59526061 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
 No parameters exist

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSreleasesnapshotdeliverysessionlock\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSreleasesnapshotdeliverysessionlock\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
--
-- Name: sp_MSreleasesnapshotdeliverysessionlock
--
-- Description: This procedure is used by the distribution/merge agent to
--              release the application lock acquired through 
--              sp_MSacquiresnapshotdeliverysessionlock.
--
-- Returns: 0 - succeeded
--          1 - failed
--
-- Notes: i) This procedure should be executed by the distribution/merge agent
--        at the subscription database.
--
-- Security: Execute permission of this procedure is granted to public;
--           procedural security check will be performed to make sure
--           that the caller is either a db_owner of the current database
--           or a sysadmin. 
--
create procedure sys.sp_MSreleasesnapshotdeliverysessionlock
as
begin
    set nocount on
    declare @retcode int
    declare @resource nvarchar(255)
    select @retcode = 0
    exec @retcode = sys.sp_MSreplcheck_subscribe
    if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
    begin
        select @retcode = 1
        goto FAILURE
    end
    select @resource = N'snapshot_delivery_in_progress_' + 
                       db_name() collate database_default
    exec @retcode = sys.sp_releaseapplock @Resource = @resource,
                                          @LockOwner = 'Session',
                                          @DbPrincipal = N'db_owner'

    if @retcode &lt; 0 or @@error &lt;&gt; 0
    begin
        select @retcode = 1
        goto FAILURE
    end
    select @retcode = 0
FAILURE:
    return @retcode
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

