## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_cdc_vupgrade\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_cdc_vupgrade**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -599786379 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
 No parameters exist

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_cdc_vupgrade\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_cdc_vupgrade\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure [sys].[sp_cdc_vupgrade]
as
begin

    declare    @db_name sysname
            ,@raised_error int
            ,@raised_message nvarchar(4000)
            ,@action nvarchar(1000)
            ,@trancount int
            ,@bypass_proc_gen bit

    set nocount on

    --
     -- Authorization check.
    if (isnull(is_srvrolemember('sysadmin'),0) = 0) and (isnull(is_member('db_owner'),0) = 0)
    begin
        raiserror(22904, 16, -1)
        return(1)
    end

    set @raised_error = 0
    set @db_name = db_name()
    set @bypass_proc_gen = 0
    
    --
    -- Determine whether trace flag to bypass proc generation has been set 
    -- (trace flag 8218)
    exec sys.sp_is_trace_flag_to_bypass_proc_gen_set @bypass_proc_gen output
    
    create table #index_column_names(column_name sysname null, index_ordinal int null)

    -- Encapsulate transaction logic in TRY/CATCH. 
    begin try

        -- Open a transaction to begin metadata updates.
        set @trancount = @@trancount
        
        begin tran
        save tran tr_cdc_vupgrade

        if object_id(N'[cdc].[change_tables]') is not null
        begin
            if not exists (select * from sys.columns where object_id = object_id(N'[cdc].[change_tables]') and name = N'partition_switch')
            begin

                set @action = N'add column partition_switch'
                alter table [cdc].[change_tables] add partition_switch bit default 0 not null
            end
            
            if not exists (select * from sys.indexes where object_id = object_id(N'[cdc].[change_tables]') and name = N'source_object_id_idx')
            begin
            
                set @action = N'create index source_object_id_idx on cdc.change_tables'
                create index [source_object_id_idx] on [cdc].[change_tables] (  source_object_id ASC )
            end
            
            -- Drop index change_table_nonunique_idx if it exists
            if exists (select * from sys.indexes where object_id = object_id(N'[cdc].[change_tables]') and name = N'change_tables_nonunique_idx')
            begin
            
                set @action = N'drop cdc.change_tables index change_tables_nonunique_idx'
                drop index [change_tables_nonunique_idx] on [cdc].[change_tables]
            end
            
            -- create index change_table_unique_idx if it doesn't exist otherwise create with drop_existing option
            if not exists (select * from sys.indexes where object_id = object_id(N'[cdc].[change_tables]') and name = N'change_tables_unique_idx')
            begin
            
                set @action = N'create cdc.change_tables index change_tables_unique_idx'
                create unique index [change_tables_unique_idx] on [cdc].[change_tables] (  capture_instance ASC )
            end
            else
            begin
            
                set @action = N'alter cdc.change_tables index change_tables_unique_idx with (drop_existing = on)'
                create unique index [change_tables_unique_idx] on [cdc].[change_tables] (  capture_instance ASC )
                with (drop_existing = ON)
            end
            
            -- Insure nullability setting is correct for all columns in the meta data tables
            -- cdc.change_tables
            if exists (select * from sys.columns where object_id = object_id('cdc.change_tables') and name = N'version' and is_nullable = 0)
                alter table cdc.change_tables alter column version int null
            if exists (select * from sys.columns where object_id = object_id('cdc.change_tables') and name = N'source_object_id' and is_nullable = 0)
                alter table cdc.change_tables alter column source_object_id int null
            if exists (select * from sys.columns where object_id = object_id('cdc.change_tables') and name = N'supports_net_changes' and is_nullable = 0)
                alter table cdc.change_tables alter column supports_net_changes bit null
            if exists (select * from sys.columns where object_id = object_id('cdc.change_tables') and name = N'has_drop_pending' and is_nullable = 0)
                alter table cdc.change_tables alter column has_drop_pending bit null
            if exists (select * from sys.columns where object_id = object_id('cdc.change_tables') and name = N'create_date' and is_nullable = 0)
                alter table cdc.change_tables alter column create_date datetime null

            -- cdc.captured_columns
            if exists (select * from sys.columns where object_id = object_id('cdc.captured_columns') and name = N'column_id' and is_nullable = 0)
                alter table cdc.captured_columns alter column column_id int null
            if exists (select * from sys.columns where object_id = object_id('cdc.captured_columns') and name = N'is_computed' and is_nullable = 0)
                alter table cdc.captured_columns alter column is_computed bit null
            if not exists (select * from sys.columns where object_id = object_id('cdc.captured_columns') and name = N'masking_function')
                alter table cdc.captured_columns add masking_function nvarchar(4000) collate Latin1_General_CI_AS_KS_WS null
            declare @dmstmt nvarchar(max) = N'
            -- Populate the new masking function column if needed (e.g., if upgrading from a SQL 2016 CTP installation)
            update cdc.captured_columns
            set masking_function = m.masking_function
            from sys.masked_columns m
            inner join cdc.change_tables ct
            on m.object_id = ct.source_object_id
            where cdc.captured_columns.object_id = ct.object_id
                and cdc.captured_columns.column_id = m.column_id

            -- Update the captured columns of the change tables (_CT table) by applying the masking function of the original table, if needed
            declare
                @alter_stmt            nvarchar(max),
                @change_table_name    sysname,
                @ct_column_name        sysname,
                @masking_function    nvarchar(4000)

            declare #hcolumns cursor local fast_forward for
            select t.name as change_table_name, i.column_name, i.masking_function
            from cdc.captured_columns i
            inner join sys.tables t on t.object_id = i.object_id
            where i.masking_function is not null

            open #hcolumns
            fetch #hcolumns into @change_table_name
                ,@ct_column_name
                ,@masking_function
            while (@@fetch_status &lt;&gt; -1)
            begin
                if exists (select * from sys.tables where name = @change_table_name)
                begin
                    set @alter_stmt =  N''alter table [cdc].'' + quotename(@change_table_name) + N'' alter column '' + quotename(@ct_column_name) + N'' add masked with (function = '''''' + @masking_function + N'''''')''
                    exec (@alter_stmt)
                end
                fetch #hcolumns into @change_table_name
                    ,@ct_column_name
                    ,@masking_function
            end
            close #hcolumns
            deallocate #hcolumns'
            exec (@dmstmt)

            -- cdc.index_columns (fixed for a case of nonclustered index with included columns)
            if exists (select * from sys.columns where object_id = object_id('cdc.index_columns') and name = N'column_id' and is_nullable = 1)
            begin
                update cdc.index_columns set column_id = 0 where column_id is null
                alter table cdc.index_columns alter column column_id int not null
                if exists (select * from sys.objects where name = 'index_columns_clustered_idx' and type='PK' and parent_object_id = object_id('cdc.index_columns'))
                begin
                    alter table cdc.index_columns drop constraint [index_columns_clustered_idx]
                    alter table cdc.index_columns add constraint [index_columns_clustered_idx] primary key clustered (object_id ASC, index_ordinal ASC, column_id ASC)
                end
            end

            -- cdc.dll_history
            if exists (select * from sys.columns where object_id = object_id('cdc.ddl_history') and name = N'source_object_id' and is_nullable = 0)
                alter table cdc.ddl_history alter column source_object_id int null
            if exists (select * from sys.columns where object_id = object_id('cdc.ddl_history') and name = N'required_column_update' and is_nullable = 0)
                alter table cdc.ddl_history alter column required_column_update bit null
            if exists (select * from sys.columns where object_id = object_id('cdc.ddl_history') and name = N'ddl_command' and is_nullable = 0)
                alter table cdc.ddl_history alter column ddl_command nvarchar(max) null
            if exists (select * from sys.columns where object_id = object_id('cdc.ddl_history') and name = N'ddl_time' and is_nullable = 0)
                alter table cdc.ddl_history alter column ddl_time datetime null

            -- cdc.lsn_time_mapping
            if exists (select * from sys.columns where object_id = object_id('cdc.lsn_time_mapping') and name = N'tran_begin_time' and is_nullable = 0)
                alter table cdc.lsn_time_mapping alter column tran_begin_time datetime null
            if exists (select * from sys.columns where object_id = object_id('cdc.lsn_time_mapping') and name = N'tran_end_time' and is_nullable = 0)
                alter table cdc.lsn_time_mapping alter column tran_end_time datetime null
            if exists (select * from sys.columns where object_id = object_id('cdc.lsn_time_mapping') and name = N'tran_id' and is_nullable = 0)
                alter table cdc.lsn_time_mapping alter column tran_id varbinary(10) null
            if exists (select * from sys.columns where object_id = object_id('cdc.lsn_time_mapping') and name = N'tran_begin_lsn' and is_nullable = 0)
                alter table cdc.lsn_time_mapping alter column tran_begin_lsn binary(10) null
            
            -- Regenerate the enumeration TVFs to use the modified definition of fn_cdc_check_parameters
            declare @source_schema sysname, @source_name sysname, @capture_instance sysname,
                @supports_net_changes bit, @role_name sysname, @index_name nvarchar(1000),
                @fn_all_changes nvarchar(1000), @fn_net_changes nvarchar(1000), @change_table nvarchar(1000),
                @stmt nvarchar(max), @pk_column_list nvarchar(max), @column_name sysname, @ddl_action nvarchar(10)

            declare #hinstance cursor local fast_forward for
                select object_schema_name(source_object_id) as source_schema,
                       object_name(source_object_id) as source_name,
                       capture_instance, supports_net_changes, role_name
                from cdc.change_tables
                where object_schema_name(source_object_id) is not null and
                      object_name(source_object_id) is not null

            open #hinstance
            fetch #hinstance into @source_schema, @source_name, @capture_instance,
                @supports_net_changes, @role_name

            while (@@fetch_status &lt;&gt; -1)
            begin
                -- Drop the enumeration TVFs if they exist
                set @fn_all_changes = N'[cdc].' + quotename( N'fn_cdc_get_all_changes' +  N'_' + @capture_instance)
                set @fn_net_changes = N'[cdc].' + quotename( N'fn_cdc_get_net_changes' +  N'_' + @capture_instance)
                set @index_name = quotename(@capture_instance + N'_CT_idx')
                set @change_table = N'[cdc].' + quotename(@capture_instance + N'_CT')
    
                if not exists (select * from sys.columns where object_id = object_id(@change_table) and name = N'__$command_id')
                begin
                    set @action = N'add column __$command_id'
                    set @stmt = N'alter table ' + @change_table + N' add __$command_id int null'
                    exec (@stmt)
                end

                if object_id (@fn_all_changes, 'IF') is not null
                begin
                    set @action = N'drop function fn_cdc_get_all_changes_&lt;capture_instance&gt;' 
                    set @stmt = N'drop function ' + @fn_all_changes
                    exec (@stmt)
                end
        
                if object_id (@fn_net_changes, 'IF') is not null
                begin
                    set @action = N'drop function fn_cdc_get_net_changes_&lt;capture_instance&gt;' 
                    set @stmt = N'drop function ' + @fn_net_changes
                    exec (@stmt)
                end
        
                -- Generate the enumeration functions.
                set @action = N'sp_cdc_create_change_enumeration_functions' 
                exec [sys].[sp_cdc_create_change_enumeration_functions]
                    @source_schema, @source_name, @capture_instance, @supports_net_changes

                -- Grant select permission on the enumeration functions.
                set @action = N'sp_cdc_grant_select_on_change_enumeration_functions' 
                exec [sys].[sp_cdc_grant_select_on_change_enumeration_functions]
                    @capture_instance, @supports_net_changes, @role_name
                    
                -- Drop the change table non-clustered index if it exists and then recreate it 
                -- This should only take place when @supports_net_changes = 1 and if new index definition differs from existing one
                -- NB: Following query should be in sync with following index definition
                DECLARE @diff int
                ;WITH OldIdx (name, is_included_column, is_descending_key) AS (
                    SELECT C.name, SIC.is_included_column, SIC.is_descending_key FROM sys.tables ST
                    JOIN sys.columns C ON C.object_id = ST.object_id AND ST.object_id = object_id(@change_table)
                    JOIN sys.indexes SI ON SI.object_id = ST.object_id AND SI.is_unique = 1 AND SI.type = 2 /*NCI*/
                    AND SI.name = @capture_instance + N'_CT_idx' AND SI.is_primary_key = 0 AND SI.is_unique_constraint = 0
                    JOIN sys.index_columns SIC ON SIC.object_id = ST.object_id AND SIC.index_id = SI.index_id AND SIC.column_id = C.column_id
                ), NewIdx (column_name, is_included_column, is_descending_key) AS (
                    SELECT column_name, 0 is_included_column, 0 is_descending_key FROM cdc.index_columns WHERE object_id = object_id(@change_table)
                    UNION SELECT N'__$start_lsn', 0, 0
                    UNION SELECT N'__$command_id', 0, 0
                    UNION SELECT N'__$seqval', 0, 0
                    UNION SELECT N'__$operation', 0, 0
                    UNION SELECT N'__$update_mask', 1, 0
                ) SELECT @diff = count(*) FROM ((SELECT * FROM OldIdx EXCEPT SELECT * FROM NewIdx) UNION ALL (SELECT * FROM NewIdx EXCEPT SELECT * FROM OldIdx)) DifIdx
                IF (@supports_net_changes = 1 AND @diff &lt;&gt; 0)
                begin

                    if exists (select * from sys.indexes where object_id = object_id(@change_table) and quotename(name) = @index_name)
                    begin
                        set @action = N'drop non-clustered change table index'
                        set @stmt = N'drop index ' + @index_name + N' on ' + @change_table
                        exec (@stmt)
                    end    
                                
                    set @pk_column_list = N' '
                    
                    delete #index_column_names
        
                    insert into #index_column_names
                    select column_name, index_ordinal
                    from [cdc].[index_columns] where object_id = object_id(@change_table)

                    declare #hidxcolumns cursor local fast_forward for
                        select column_name
                        from #index_column_names 
                        order by index_ordinal
        
                    open #hidxcolumns
                    fetch #hidxcolumns into @column_name
    
                    while (@@fetch_status &lt;&gt; -1)
                    begin
                        set @pk_column_list = @pk_column_list + quotename(@column_name) +  N' ASC, ' 

                        fetch #hidxcolumns into @column_name
                    end
    
                    close #hidxcolumns
                    deallocate #hidxcolumns
    
                    set @action = N'create unique nonclustered index for change table'
                    -- NB: Following index script should be in sync with above query identifying necessary changes in the index metadata
                    set @stmt =  N'create unique nonclustered index ' + 
                        quotename(@capture_instance + N'_CT_idx') +
                        N' on ' + @change_table + N'
                        ( '  + @pk_column_list + N'
                            [__$start_lsn] ASC,
                            [__$command_id] ASC,
                            [__$seqval] ASC,
                            [__$operation] ASC
                        ) INCLUDE ( [__$update_mask] )'         
    
                    exec (@stmt)
                end

                if (@bypass_proc_gen = 0)
                begin
                    -- Alter the stored procedures to populate the change table
                    -- and mark them as system procs
                    set @action = N'sp_cdc_create_populate_stored_procs'
                    exec [sys].[sp_cdc_create_populate_stored_procs]
                        @capture_instance, N'alter' 
                end    
                
                -- Mark change table as a system object
                set @action = N'sp_MS_marksystemobject @change_table'
                exec sp_MS_marksystemobject @change_table

                fetch #hinstance into @source_schema, @source_name, @capture_instance,
                    @supports_net_changes, @role_name
            end        

            close #hinstance
            deallocate #hinstance
        
        end

        if object_id(N'[cdc].[lsn_time_mapping]') is not null
        begin
            if not exists (select * from sys.columns where object_id = object_id(N'[cdc].[lsn_time_mapping]') and name = N'tran_begin_lsn')
            begin

                set @action = N'add column tran_begin_lsn'
                alter table [cdc].[lsn_time_mapping] add tran_begin_lsn binary(10) null

                set @action = N'upgrade/create procs for lsn_time_mapping'
                exec [sys].[sp_cdc_lsn_time_mapping_procs] @action = N'alter'
                
            end
        end
        
        -- Mark CDC tables as system objects
        set @action = N'sp_MS_marksystemobject cdc.change_tables'
        exec sp_MS_marksystemobject N'cdc.change_tables'

        set @action = N'sp_MS_marksystemobject cdc.ddl_history'
        exec sp_MS_marksystemobject N'cdc.ddl_history'

        set @action = N'sp_MS_marksystemobject cdc.captured_columns'
        exec sp_MS_marksystemobject N'cdc.captured_columns'

        set @action = N'sp_MS_marksystemobject cdc.index_columns'
        exec sp_MS_marksystemobject N'cdc.index_columns'
        
        set @action = N'sp_MS_marksystemobject dbo.systranschemas'
        exec sp_MS_marksystemobject N'dbo.systranschemas'
        
        set @action = N'sp_MS_marksystemobject cdc.lsn_time_mapping'
        exec sp_MS_marksystemobject N'cdc.lsn_time_mapping'
        
        set @action = N'sp_MS_marksystemobject cdc.[fn_cdc_get_all_changes_...]'
        exec sp_MS_marksystemobject N'cdc.[fn_cdc_get_all_changes_...]'
        
        set @action = N'sp_MS_marksystemobject cdc.[fn_cdc_get_net_changes_...]'
        exec sp_MS_marksystemobject N'cdc.[fn_cdc_get_net_changes_...]'
        
        set @action = N'sp_MS_marksystemobject cdc.[fn_cdc_get_all_changes_ ... ]'
        exec sp_MS_marksystemobject N'cdc.[fn_cdc_get_all_changes_ ... ]'
        
        set @action = N'sp_MS_marksystemobject cdc.[fn_cdc_get_net_changes_ ... ]'
        exec sp_MS_marksystemobject N'cdc.[fn_cdc_get_net_changes_ ... ]'

        commit tran


    end try
    begin catch
    
        if @@trancount &gt; @trancount
        begin
            -- If CDC opened the transaction or it is not possible 
            -- to rollback to the savepoint, rollback the transaction
            if ( @trancount = 0 ) OR ( XACT_STATE() &lt;&gt; 1 )
            begin
                rollback tran 
            end
            -- Otherwise rollback to the savepoint
            else
            begin
                rollback tran tr_cdc_vupgrade
                commit tran
            end
        end
     
        -- Save the error number and associated message raised in the TRY block
        select @raised_error = ERROR_NUMBER()
        select @raised_message = N'line ' + cast(ERROR_LINE() as nvarchar) + N', state ' + cast(ERROR_STATE() as nvarchar) + N', ' + ERROR_MESSAGE() 
    end catch
    
    if @raised_error = 0
        return (0)
        
    raiserror(22841, 16, -1, @db_name, @action, @raised_error, @raised_message)  
    return (1)

end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

