## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_helpsubscriptionerrors\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_helpsubscriptionerrors**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -602131058 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscriber| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscriber_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_helpsubscriptionerrors\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_helpsubscriptionerrors\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_helpsubscriptionerrors
(
    @publisher        sysname,
    @publisher_db    sysname,
    @publication    sysname,
    @subscriber        sysname,
    @subscriber_db    sysname
)
AS
BEGIN
    DECLARE @retcode        int,
            @publisher_id    int,
            @subscriber_id    int,
            @agent_id        int

    -- database must be distribution db
    IF sys.fn_MSrepl_isdistdb(DB_NAME()) &lt;&gt; 1
    BEGIN
        RAISERROR (21482, 16, -1, 'sp_helpsubscriptionerrors', 'distribution')
        RETURN 1
    END
    
    -- retrieve pub/sub/agent id
    SELECT @publisher_id = server_id
        FROM sys.servers
        WHERE UPPER(name) = UPPER(@publisher)

    SELECT @subscriber_id = server_id
        FROM sys.servers
        WHERE UPPER(name) = UPPER(@subscriber)

    SELECT @agent_id = id
        FROM MSdistribution_agents
        WHERE publisher_id = @publisher_id
            AND publisher_db = @publisher_db
            AND (publication = @publication
                OR lower(publication) = N'all')
            AND subscriber_id = @subscriber_id
            AND subscriber_db = @subscriber_db    

    -- PAL Security Check
    EXEC @retcode = sys.sp_MScheck_pull_access @agent_id = @agent_id,
                                                @agent_type = 0 -- distribution agent
    IF @@ERROR &lt;&gt; 0 OR @retcode &lt;&gt; 0
        RETURN 1

    -- return the resultset
    SELECT msre.* 
        FROM MSrepl_errors msre
        WHERE msre.id IN (SELECT error_id
                            FROM MSdistribution_history
                            WHERE agent_id = @agent_id)
        ORDER by msre.time desc

    RETURN 0
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

