## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSenum_merge_sd\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSenum_merge_sd**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -60274931 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@name| |nvarchar|100|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@time| |datetime|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSenum_merge_sd\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSenum_merge_sd\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSenum_merge_sd
(
@name nvarchar(100),
@time datetime = NULL
)
as
begin
    set nocount on

    declare @start_time datetime
    declare @agent_id int
    declare @time_up datetime

    --
    -- security check
    -- only replmonitor can execute this
    --
    if not (is_member(N'db_owner') = 1 or isnull(is_member(N'replmonitor'),0) = 1)
    begin
        raiserror(14260, 16, -1)
        return (1)
    end
    
    select @agent_id = id from dbo.MSmerge_agents where name=@name
    
    IF @time IS NULL
        select @time = GETDATE()

    /*
    ** Minute-approximate @time can be used.
    ** Note: The select only return datetime data with minute precision
    */
    IF  DATEPART(second, @time) = 0 AND
        DATEPART(millisecond, @time) = 0
    BEGIN
        SELECT @time_up = DATEADD(second, +59, @time)
        SELECT @time_up = DATEADD(millisecond, +999, @time)
    END
    ELSE
        SELECT @time_up = @time

    declare @session_id int

    select top 1 @session_id=session_id
    from dbo.MSmerge_sessions with (READPAST) 
    where agent_id=@agent_id and
    end_time&lt;= @time_up
    order by session_id DESC

    -- have to fake rate/time and count as we only have cumulative count number
    select  ms.runstatus, 
            'time' = sys.fn_replformatdatetime(ms.end_time),
            rh.comments, ms.duration, 
        -- Note: return average rate here !!! delivery_rate column is current rate
        ms.delivery_rate, 
        ms.download_inserts, ms.download_updates, ms.download_deletes, ms.download_conflicts,
        ms.upload_inserts, ms.upload_updates, ms.upload_deletes, ms.upload_conflicts,
        rh.error_id            
        from dbo.MSmerge_history rh with (READPAST), dbo.MSmerge_sessions ms with (READPAST)
        where
        rh.agent_id = @agent_id and
        rh.session_id = @session_id and 
        ms.agent_id = @agent_id and
        ms.session_id = @session_id
        order by rh.session_id desc, rh.timestamp desc
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

