## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSsetlastsentgen\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSsetlastsentgen**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -605435379 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@repid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@srcgen| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@srcguid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSsetlastsentgen\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSsetlastsentgen\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE sys.sp_MSsetlastsentgen
    (@repid uniqueidentifier, @srcgen bigint, @srcguid uniqueidentifier)
as
    /*
    ** Check to see if current publication has permission
    */
    declare @retcode    int
    declare @pubid      uniqueidentifier
    declare @subscription_type smallint

    -- if this is the light weight client we have nothing to set here
    if object_id('dbo.MSmerge_rowtrack', 'U') is not null
        return 0
    
    exec @retcode = sys.sp_MSrepl_PAL_rolecheck @repid = @repid
    if (@retcode &lt;&gt; 0) or (@@error &lt;&gt; 0)
        return 1

    if (@repid is null)
    begin
        RAISERROR(14043, 16, -1, '@repid', 'sp_MSsetlastsentgen')
        return (1)
    end

    if object_id('MSmerge_contents') is NULL
    begin
        RAISERROR(20054 , 16, -1)
        return (1)
    end

    /* 
    ** This is a special case which is used to update the anonymous subscriptions sent and 
    ** received generation guids at the end of initializing a dynamic subscription. This is 
    ** used in the case where an anonymous subscription is reinitialized after a merge metadata
    ** cleanup
    */
    if (@srcgen is null and @srcguid is null)
    begin

        declare @lastrecsentgen     bigint
        declare @lastrecsentguid    uniqueidentifier

        select @lastrecsentgen = max(g.generation) 
            from MSmerge_genhistory g,
            (select isnull(gen2.generation, gen1.generation) as generation
                from (select max(generation) as generation from dbo.MSmerge_genhistory where genstatus in (1,2)) as gen1,
                        (select min(generation) as generation from dbo.MSmerge_genhistory where genstatus in (0,4)) as gen2
            ) as minopengen
        where g.generation &lt;= minopengen.generation and g.genstatus in (1,2)
        if @lastrecsentgen IS NOT NULL
            select @lastrecsentguid = guidsrc from dbo.MSmerge_genhistory where generation = @lastrecsentgen
        update dbo.sysmergesubscriptions set last_local_sentgen = case when sentgen = @lastrecsentgen then last_local_sentgen else sentgen end, sentgen = @lastrecsentgen, sentguid = @lastrecsentguid
            where subid = @repid
        IF @@ERROR &lt;&gt;0 return (1)
    end
    else
    begin
        -- check for setting a sentgen which is obviously too high
        if (exists (select * from dbo.MSmerge_genhistory where generation &lt; @srcgen and
                    genstatus in (0,4) and
                    (art_nick = 0 or art_nick is null or art_nick in
                        (select nickname from dbo.sysmergearticles where
                                pubid = @pubid) )))
        begin
            RAISERROR('Setting sentgen too high', 16, -1)
            return (1)
        end
        update dbo.sysmergesubscriptions set last_local_sentgen = case when sentgen = @srcgen then last_local_sentgen else sentgen end, sentgen = @srcgen, sentguid = @srcguid 
            where subid = @repid
        IF @@ERROR &lt;&gt;0 return (1)
    end         
    return (0)
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

