## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_adduser\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_adduser**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -614440514 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@loginame| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@name_in_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@grpname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_adduser\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_adduser\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_adduser
    @loginame       sysname,        -- user's login name in syslogins
    @name_in_db     sysname = NULL, -- user's name to add to current db
    @grpname        sysname = NULL  -- role to which user should be added.
as
    -- SETUP RUNTIME OPTIONS / DECLARE VARIABLES --
    set nocount on
    declare @ret        int

    -- LIMIT TO SQL/NT USERS IN SYSLOGINS (BCKWRD COMPAT ONLY!)
    if not exists (select * from master.dbo.syslogins where loginname = @loginame
            and (isntuser = 1 or isntname = 0))
        and @loginame &lt;&gt; 'guest'
    begin
        raiserror(15007,-1,-1,@loginame)
        return (1)
    end

    -- VALIDATE THE ROLENAME --
    if @grpname is not null and
       not exists (select * from sysusers where name = @grpname and issqlrole = 1)
    begin
        raiserror(15014,-1,-1,@grpname)
        return (1)
    end

    if @name_in_db is null
        select @name_in_db = @loginame

    -- In Hydra only the user dbo can do this --
    if (not is_member('dbo') = 1)
    begin
        -- AUDIT FAILED SECURITY CHECK --
        dbcc auditevent (109, 1, 0, @loginame, @name_in_db, @grpname , NULL, NULL, NULL, NULL)
        raiserror(15247,-1,-1)
        return (1)
    end

    -- ADD THE USER TO THE DATABASE --
    EXEC @ret = sys.sp_grantdbaccess @loginame, @name_in_db OUT
    if (@ret &lt;&gt; 0)
        return (1)

    -- ADD USER TO ROLE IF GIVEN. NOP FOR 'public' --
    if (@grpname is not null) and (@grpname &lt;&gt; 'public')
    begin
        EXEC @ret = sys.sp_addrolemember @grpname, @name_in_db
        if @ret &lt;&gt; 0
        begin
            -- "ROLLBACK" THE ABOVE sp_grantdbaccess --
            exec sys.sp_revokedbaccess @name_in_db
            return (1)
        end
    end

    -- RETURN SUCCESS --
    return (0) -- sp_adduser
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

