## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSmerge_parsegenlist\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSmerge_parsegenlist**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -617563979 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@genlist| |varchar|8000|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@gendeclarelist| |varchar|2147483647|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@genselectlist| |varchar|2147483647|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@genunionlist| |varchar|2147483647|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSmerge_parsegenlist\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSmerge_parsegenlist\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSmerge_parsegenlist
    @genlist varchar(8000),       
    @gendeclarelist varchar(max) OUTPUT, 
    @genselectlist varchar(max) OUTPUT,
    @genunionlist varchar(max) OUTPUT     
as             
    declare @gencount int    
    declare @counter int
    declare @listsize int
    declare @position1 int
    declare @position2 int
            
    select @gendeclarelist = ' '
    select @genselectlist = ' '
    select @genunionlist = ' '

    exec sys.sp_MSmerge_getgencount @genlist, @gencount output
    
    if @gencount = 0
        return

    -- for better performance of enum queries, limit the number of queries by
    -- using a small set of gen buckets
    if @gencount &lt;= 10
        set @listsize = 10
    else if @gencount &lt;= 25
        set @listsize = 25
    else if @gencount &lt;= 50
        set @listsize = 50
    else if @gencount &lt;= 100
        set @listsize = 100
    else if @gencount &lt;= 200
        set @listsize = 200
    else if @gencount &lt;= 500
        set @listsize = 500
    else if @gencount &lt;= 1000
        set @listsize = 1000
    else if @gencount &lt;= 1500
        set @listsize = 1500
    else if @gencount &lt;= 2000
        set @listsize = 2000
    else
        set @listsize = @gencount

    if @listsize &lt;&gt; 0 and @gencount &gt; @listsize
        return 

    -- if we get this far, we have at least one gen 
    set @counter = 1
    set @position1 = 1
    set @position2 = charindex(',', @genlist, @position1)

    declare @tempint bigint                    

    while @counter &lt; @listsize 
    begin                        
        select @gendeclarelist = @gendeclarelist + '
    declare @gen' + convert(varchar(16), @counter) + ' bigint '
        
        if @counter &lt; @gencount
        begin
            select @tempint = CONVERT(bigint, substring(@genlist, @position1, @position2 - @position1))
            select @genselectlist = @genselectlist + '
    select @gen' + convert(varchar(16), @counter) + ' =  ' + CONVERT(varchar(20), @tempint)
        end
        else if @counter = @gencount
        begin
            select @tempint = CONVERT(bigint, substring(@genlist, @position1, len(@genlist) - (@position1-1)))
            select @genselectlist = @genselectlist + '
    select @gen' + convert(varchar(16), @counter) + ' =  ' + CONVERT(varchar(20), @tempint)
        end
        else
            select @genselectlist = @genselectlist + '
    select @gen' + convert(varchar(16), @counter) + ' =  null '

        select @genunionlist = @genunionlist + '
            select @gen' + + convert(varchar(16),@counter) + ' as gen union all '
    
        set @counter = @counter + 1
        set @position1 = @position2 + 1
        set @position2 = charindex(',', @genlist, @position1)                               
    end        
    
    -- parse last gen in the list
        select @gendeclarelist = @gendeclarelist + '
    declare @gen' + convert(varchar(16), @counter) + ' bigint '
    
    if @counter = @gencount 
    begin
        select @tempint = CONVERT(bigint, substring(@genlist, @position1, len(@genlist) - (@position1-1)))
        select @genselectlist = @genselectlist + '
    select @gen' + convert(varchar(16), @counter) + ' =  ' + CONVERT(varchar(20), @tempint)
    end
    else 
        select @genselectlist = @genselectlist + '
    select @gen' + convert(varchar(16), @counter) + ' =  null '

        select @genunionlist = @genunionlist + '
        select @gen' + + convert(varchar(16), @counter) + ' as gen '
        
    return 0
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

