## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_markpendingschemachange\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_markpendingschemachange**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -621580645 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@schemaversion| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@status| |nvarchar|10|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_markpendingschemachange\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_markpendingschemachange\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_markpendingschemachange(
    @publication        sysname,
    @schemaversion      int = 0,
    @status             nvarchar(10) = 'active'          /* active, skipped */
    )
as  
begin
    set nocount on
    declare @retcode        int
    declare @pubid          uniqueidentifier
    declare @compatlevel    int
    declare @statusid       int
    declare @SCHEMA_TYPE_SNAPSHOTTRAILER int
    
    select @retcode = 0
    exec @retcode=sys.sp_MSreplcheck_publish
    if @retcode&lt;&gt;0 or @@ERROR&lt;&gt;0 return (1)

    if @publication IS NULL
    begin
        raiserror (14003, 16, -1)
        return (1)
    end

    select @pubid = pubid, @compatlevel = backward_comp_level FROM dbo.sysmergepublications WHERE name = @publication and UPPER(publisher)=UPPER(publishingservername()) and publisher_db=db_name()
    if @pubid is NULL
    begin
        raiserror (21274, 16, -1, @publication)
        return (1)
    end
    
    if @compatlevel &lt; 90
    begin
        raiserror(22557, 16, -1, @publication)
        return 1
    end

    select @status  = lower(@status  collate SQL_Latin1_General_CP1_CS_AS)
    if @status  not in ('active', 'skipped')
    begin
        RAISERROR(22559 , 16, -1)
        return (1)
    end

    if @status = N'active'
        select @statusid = 1
    else if @status = N'skipped'
        select @statusid = 2
    
    update dbo.sysmergeschemachange set schemastatus = @statusid
        where pubid=@pubid and schemaversion = @schemaversion 
    if @@error &lt;&gt; 0 or @@rowcount &lt;&gt; 1
        begin
            RAISERROR(22558 , 16, -1)
            return (1)
        end     
    return (0)
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

