## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MShelp_snapshot_agent\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MShelp_snapshot_agent**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -625196212 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@agent_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MShelp_snapshot_agent\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MShelp_snapshot_agent\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO


--
-- Name: 
--        sp_MShelp_snapshot_agent
-- 
-- Description: 
--        Retrieves snapshot agent information.
--
-- Parameters: 
--        See the procedure definition.
--
-- Returns: 
--        0 - succeeded
--        1 - failed
--
-- Result: 
--        None
--
-- Security: 
--
--    This procedure can only be called by replication_agent. It must
--    be executed in the distribution db and the caller must have the
--    following:
--
--        Min Requirement
--        ---------------------
--        DBO Distribution DBO
-- Requires Certificate signature for catalog access
--
create procedure sys.sp_MShelp_snapshot_agent
(
    @agent_id int
)
as
begin
    declare @retcode                     int,
            @publisher                    sysname,
            @publisher_security_mode     int,
            @publisher_login             sysname,
            @publisher_password         nvarchar(524)

    -- 
    -- make sure this is a replication agent.
    -- if sessionproperty('replication_agent') != 1
    -- begin
    --     -- "You do not have sufficient permission to run this command."
    --     raiserror(14260, 16, -1)
    --     return 1 
    -- end
    -- 
    
    -- sysadmin or db_owner have access
    if is_srvrolemember('sysadmin') != 1 
        and is_member('db_owner') != 1
    begin
        -- "You do not have sufficient permission to run this command."
        raiserror(14260, 16, -1)
        return 1
    end
    
    -- retrieve the publisher server and database name
    select mssa.publisher_security_mode,
            mssa.publisher_login,
            sys.fn_repldecryptver4(mssa.publisher_password)
        from MSsnapshot_agents mssa
        where mssa.id = @agent_id
    if @@error &lt;&gt; 0 return 1

    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

