## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSacquireserverresourcefordynamicsnapshot\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSacquireserverresourcefordynamicsnapshot**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -627158907 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@max_concurrent_dynamic_snapshots| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSacquireserverresourcefordynamicsnapshot\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSacquireserverresourcefordynamicsnapshot\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSacquireserverresourcefordynamicsnapshot (
    @publication sysname,
    @max_concurrent_dynamic_snapshots int
    )
as
begin
    set nocount on
    declare @retcode int
    declare @pubid uniqueidentifier
    declare @process_name sysname
    declare @PALRole sysname
    select @retcode = 0
    

    if object_id('dbo.sysmergepublications') is null
    begin
        raiserror(21423, 16, -1, @publication)
        return (1) 
    end

    select @pubid = null
    select @pubid = pubid 
      from dbo.sysmergepublications
     where name = @publication 
       and publisher_db = db_name()
       and upper(publisher) = upper(publishingservername())
             
    if @pubid is null   
    begin
        raiserror(21423, 16, -1, @publication)
        return (1) 
    end

    if {fn ISPALUSER(@pubid)} &lt;&gt; 1
    begin
        raiserror(21423, 16, -1, @publication)
        return (1) 
    end
    
    -- Since we have gone through the PAL check already, the PAL role
    -- should have been set. The following call to sp_MSrepl_GetPALRole 
    -- is nothing more than a way to retrieve the PAL role name
    select @PALRole = NULL
    select @PALRole = sys.fn_MSmerge_GetPALRole(@pubid)
    if @PALRole is NULL
        return 1

    -- The following string construction will never overflow
    -- sysname
    select @process_name = N'ReplicationSnapshotAgent' + 
        convert(nvarchar(40), @pubid)     

    -- Acquire head of queue lock first
    exec @retcode = sys.sp_MSacquireHeadofQueueLock
        @process_name = @process_name,
        @queue_timeout = 0,
        @no_result = 1,
        @DbPrincipal = @PALRole

    if @@error&lt;&gt;0
        return (1)

    if @retcode&lt;&gt;0
        goto Failure

    exec @retcode = sys.sp_MSacquireSlotLock 
        @process_name = @process_name,
        @concurrent_max = @max_concurrent_dynamic_snapshots,
        @DbPrincipal = @PALRole
    if @@error&lt;&gt;0
        return (1)
    
    -- Also return the PAL role as a separate result set, this is 
    -- used later on by the snapshot agent to release the dynamic snapshot
    -- applock under the proper security principal
    select @PALRole     

Failure:

    return @retcode
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

