## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_renamedb\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_renamedb**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -62818140 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@dbname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@newname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_renamedb\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_renamedb\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_renamedb    --- 1996/08/20 13:52
    @dbname sysname,                -- old (current) db name
    @newname sysname                -- new name we want to call it
as
    -- Use sp_rename instead.
    declare @objid int                -- object id of the thing to rename
    declare @bitdesc varchar(30)    -- bit description for the db
    declare @curdbid int            -- id of database to be changed
    declare @execstring nvarchar (max)

    --  If we're in a transaction, disallow this since it might make recovery impossible.
    set implicit_transactions off
    if @@trancount &gt; 0
    begin
        raiserror(15002,-1,-1,'sys.sp_renamedb')
        return (1)
    end

    --  Only the SA can do this.
    if not (is_srvrolemember('dbcreator') = 1)
    begin
        raiserror(15247,-1,-1)
        return (1)
    end

    --  Make sure the database exists.
    if not exists (select * from master.dbo.sysdatabases where name = @dbname)
    begin
        raiserror(15010,-1,-1,@dbname)
        return (1)
    end

    --  Make sure that the @newname db doesn't already exist.
    if exists (select * from master.dbo.sysdatabases where name = @newname)
    begin
        raiserror(15032,-1,-1,@newname)
        return (1)
    end

    -- Check to see that the @newname is valid.
    declare @returncode int
    EXEC @returncode = sys.sp_validname @newname
    if @returncode &lt;&gt; 0
    begin
        raiserror(15224,-1,15,@newname)
        return(1)
    end

    -- Don't allow the names of master, tempdb, and model to be changed.
    if @dbname in ('master', 'model', 'tempdb')
    begin
        raiserror(15227,-1,-1,@dbname)
        return (1)
    end

    select @execstring = 'ALTER DATABASE '
        + quotename( @dbname , '[')
        + ' MODIFY NAME = '
        + quotename( @newname , '[')

    EXEC (@execstring)

    if @@error &lt;&gt;  0
    begin
        -- No need to raiserror as the CREATE DATABASE will do so
        return(1)
    end

    return (0) -- sp_renamedb
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

