## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_enumeratependingschemachanges\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_enumeratependingschemachanges**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -635594603 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@starting_schemaversion| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_enumeratependingschemachanges\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_enumeratependingschemachanges\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_enumeratependingschemachanges(
    @publication                sysname,
    @starting_schemaversion     int = 0
    )
as  
begin
    set nocount on
    declare @retcode    int
    declare @pubid      uniqueidentifier
    declare @SCHEMA_TYPE_SNAPSHOTTRAILER int
    declare @snapshot_trailer_schemaversion int

    select @retcode = 0
    exec @retcode=sys.sp_MSreplcheck_publish
    if @retcode&lt;&gt;0 or @@ERROR&lt;&gt;0 return (1)

    if @publication IS NULL
    begin
        raiserror (14003, 16, -1)
        return (1)
    end
    select @pubid = pubid FROM dbo.sysmergepublications WHERE name = @publication and UPPER(publisher)=UPPER(publishingservername()) and publisher_db=db_name()
    if @pubid is NULL
    begin
        raiserror (21274, 16, -1, @publication)
        return (1)
    end
    

    set @SCHEMA_TYPE_SNAPSHOTTRAILER = 52
    select @snapshot_trailer_schemaversion = schemaversion from dbo.sysmergeschemachange 
        where pubid=@pubid and schematype = @SCHEMA_TYPE_SNAPSHOTTRAILER
    if (@starting_schemaversion &lt;= @snapshot_trailer_schemaversion) 
        set @starting_schemaversion = @snapshot_trailer_schemaversion + 1
    create table #pendingschemachanges 
    (   
        article_name    sysname           NULL,
        schemaversion   int               NOT NULL,
        schematype      sysname           NOT NULL,
        schematext      nvarchar(max)     collate database_default not null,
        schemastatus    nvarchar(10)      NOT NULL,
        schemaguid      uniqueidentifier  NOT NULL
    )
        
    truncate table #pendingschemachanges
    insert into #pendingschemachanges 
        select distinct case (isnull(ma.artid, '00000000-0000-0000-0000-000000000000')) when  '00000000-0000-0000-0000-000000000000' then 'Publication-wide' else ma.name end, 
            sc.schemaversion, sys.fn_MapSchemaType(sc.schematype, sc.schemasubtype), sc.schematext, 
            case sc.schemastatus 
                when 0 then 'inactive'
                when 1 then 'active'
                when 2 then 'skip'
                else 'invalid'
            end, sc.schemaguid
        from dbo.sysmergeschemachange sc left outer join dbo.sysmergearticles ma on sc.artid = ma.artid
            where sc.pubid=@pubid and 
              sc.schemaversion &gt;= (@starting_schemaversion) order by schemaversion

    select * from  #pendingschemachanges            
    drop table #pendingschemachanges
              
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

