## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_indexes\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_indexes**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -635918266 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@table_server| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@table_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@table_schema| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@table_catalog| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@index_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@is_unique| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|TABLE_CAT|nvarchar|128|
|TABLE_SCHEM|nvarchar|128|
|TABLE_NAME|nvarchar|128|
|NON_UNIQUE|smallint|2|
|INDEX_QUALIFIER|nvarchar|128|
|INDEX_NAME|nvarchar|128|
|TYPE|int|4|
|ORDINAL_POSITION|int|4|
|COLUMN_NAME|nvarchar|128|
|ASC_OR_DESC|varchar|1|
|CARDINALITY|int|4|
|PAGES|int|4|
|FILTER_CONDITION|nvarchar|4000|

---
### Objects that depend on \[sys\].\[sp_indexes\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_indexes\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_indexes
(
    @table_server       sysname,
    @table_name         sysname = null,
    @table_schema       sysname = null,
    @table_catalog      sysname = null,
    @index_name         sysname = null,
    @is_unique          bit = null
)
as
    select
        TABLE_CAT           = TABLE_CATALOG,
        TABLE_SCHEM         = TABLE_SCHEMA,
        TABLE_NAME          = TABLE_NAME,
        NON_UNIQUE          = convert(smallint, 1 - [UNIQUE]),
        INDEX_QUALIFIER     = TABLE_NAME,
        INDEX_NAME          = INDEX_NAME,
        TYPE                = case [CLUSTERED]
                                when 1 then 1
                                else 3
                              end,
        ORDINAL_POSITION    = ORDINAL_POSITION,
        COLUMN_NAME         = COLUMN_NAME,
        ASC_OR_DESC         = case [COLLATION]
                                when 1 then 'A'
                                when 2 then 'D'
                                else null
                              end,
        CARDINALITY         = CARDINALITY,
        PAGES               = case [CLUSTERED]
                                when 1 then PAGES
                                else NULL
                              end,
        FILTER_CONDITION    = FILTER_CONDITION

    from
        sys.fn_remote_indexes (
                @table_server,
                @table_catalog,
                @table_schema,
                @index_name,
                NULL,           -- TYPE (index type)
                @table_name)
    where
        @is_unique is null or @is_unique = [UNIQUE]
    order by NON_UNIQUE, TYPE, INDEX_QUALIFIER, INDEX_NAME, ORDINAL_POSITION
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

