## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_SetAutoSAPasswordAndDisable\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_SetAutoSAPasswordAndDisable**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -65170561 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
 No parameters exist

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_SetAutoSAPasswordAndDisable\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_SetAutoSAPasswordAndDisable\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_SetAutoSAPasswordAndDisable
as
    -- can execute only as SysAdmin
    if (not (is_srvrolemember('sysadmin') = 1))  -- Make sure that it is the SA executing this.
    begin
        raiserror(15247,-1,-1)
        return(1)
    end

       -- Begin a transaction
       BEGIN TRANSACTION

       declare @stmt nvarchar(4000)
    declare @sa nvarchar(128)

       SELECT @sa = name
        FROM sys.server_principals WHERE sid = 0x01

    -- Disable Password Policy on the SA Login
    SELECT @stmt = 'ALTER LOGIN ' + quotename(@sa) + ' WITH CHECK_POLICY = OFF '
    EXEC(@stmt)
    IF @@ERROR &lt;&gt; 0
    BEGIN
        ROLLBACK TRANSACTION
        RETURN (1)
    END

    -- Create a New Guid as the random password
    declare @randompwd UNIQUEIDENTIFIER

    SET @randompwd = newid()
    SELECT @stmt = 'ALTER LOGIN ' + quotename(@sa) + ' WITH PASSWORD = ' + quotename(@randompwd, '''')
    EXEC(@stmt)
    IF @@ERROR &lt;&gt; 0
    BEGIN
        ROLLBACK TRANSACTION
        RETURN (1)
    END

    -- Now set the policy back
    SELECT @stmt = 'ALTER LOGIN ' + quotename(@sa) + ' WITH CHECK_POLICY = ON '
    EXEC(@stmt)
    IF @@ERROR &lt;&gt; 0
    BEGIN
        ROLLBACK TRANSACTION
        RETURN (1)
    END

    -- Now set the policy back
    SELECT @stmt = 'ALTER LOGIN ' + quotename(@sa) + ' DISABLE '
    EXEC(@stmt)
    IF @@ERROR &lt;&gt; 0
    BEGIN
        ROLLBACK TRANSACTION
        RETURN (1)
    END

    -- Commit the transaction
    COMMIT TRANSACTION
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

