## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_dropdevice\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_dropdevice**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -659208155 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@logicalname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@delfile| |varchar|7|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_dropdevice\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_dropdevice\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_dropdevice --- 1996/04/08 00:00
    @logicalname    sysname,        -- logical name of the device
    @delfile    varchar(7) = null    -- optional param. to delete disk file
as
    declare @delfileIn varchar(7)
    select @delfileIn = @delfile
    -- See if user specified something for @delfile and, if so, validate it.
    if @delfile is not null
    begin
        select @delfile = lower(@delfile collate Latin1_General_CI_AS)
        if @delfile &lt;&gt; 'delfile'
        begin
            raiserror(15216,-1,-1,@delfileIn)
            return(1)
        end
    end

    -- If we're in a transaction, disallow this since it might make recovery impossible.
    set implicit_transactions off
    if @@trancount &gt; 0
    begin
        raiserror(15002,-1,-1,'sys.sp_dropdevice')
        return (1)
    end

    -- Only the system administrator (SA) can run this command.
    --  Check to make sure the executor is the sa.
    if not is_srvrolemember('diskadmin') = 1
    begin
        raiserror(15247,-1,-1)
        return (1)
    end

    -- Check and make sure that the device actually exists.
    if not exists (select * from master.dbo.sysdevices where name = @logicalname)
    begin
        raiserror(15012,-1,-1,@logicalname)
        return (1)
    end

    -- Drop the device.
    if @delfile = 'delfile'
        dbcc dbrepair
        ('', 'dropdevice',@logicalname, 1)  WITH NO_INFOMSGS
    else
        dbcc dbrepair
        ('', 'dropdevice',@logicalname, 0)  WITH NO_INFOMSGS

    if @@error &lt;&gt; 0
        return (1)

    raiserror(15463,-1,-1)

    return (0) -- sp_dropdevice
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

