## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSgetalertinfo\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSgetalertinfo**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -6695601 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@includeaddresses| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|AlertFailSafeOperator|nvarchar|255|
|AlertNotificationMethod|int|4|
|AlertForwardingServer|nvarchar|255|
|AlertForwardingSeverity|int|4|
|AlertPagerToTemplate|nvarchar|255|
|AlertPagerCCTemplate|nvarchar|255|
|AlertPagerSubjectTemplate|nvarchar|255|
|AlertPagerSendSubjectOnly|int|4|
|AlertForwardAlways|int|4|

|Name |Datatype |Max length |
|-|-|-|
|AlertFailSafeEmailAddress|nvarchar|255|
|AlertFailSafePagerAddress|nvarchar|255|
|AlertFailSafeNetSendAddress|nvarchar|255|

---
### Objects that depend on \[sys\].\[sp_MSgetalertinfo\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSgetalertinfo\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSgetalertinfo
    @includeaddresses bit = 0
as
    /* Return all alert info at one go, for performance reasons. */
    declare @FailSafeOperator nvarchar(255)
    declare @NotificationMethod int
    declare @ForwardingServer nvarchar(255)
    declare @ForwardingSeverity int
    declare @ForwardAlways int
    declare @PagerToTemplate nvarchar(255)
    declare @PagerCCTemplate nvarchar(255)
    declare @PagerSubjectTemplate nvarchar(255)
    declare @PagerSendSubjectOnly int
    declare @FailSafeEmailAddress nvarchar(255)
    declare @FailSafePagerAddress nvarchar(255)
    declare @FailSafeNetSendAddress nvarchar(255)

    exec sys.xp_instance_regread N'HKEY_LOCAL_MACHINE', N'SOFTWARE\Microsoft\MSSQLServer\SQLServerAgent', N'AlertFailSafeOperator', @param = @FailSafeOperator OUT, @no_output = N'no_output'
    exec sys.xp_instance_regread N'HKEY_LOCAL_MACHINE', N'SOFTWARE\Microsoft\MSSQLServer\SQLServerAgent', N'AlertNotificationMethod', @param = @NotificationMethod OUT, @no_output = N'no_output'
    exec sys.xp_instance_regread N'HKEY_LOCAL_MACHINE', N'SOFTWARE\Microsoft\MSSQLServer\SQLServerAgent', N'AlertForwardingServer', @param = @ForwardingServer OUT, @no_output = N'no_output'
    exec sys.xp_instance_regread N'HKEY_LOCAL_MACHINE', N'SOFTWARE\Microsoft\MSSQLServer\SQLServerAgent', N'AlertForwardingSeverity', @param = @ForwardingSeverity OUT, @no_output = N'no_output'
    exec sys.xp_instance_regread N'HKEY_LOCAL_MACHINE', N'SOFTWARE\Microsoft\MSSQLServer\SQLServerAgent', N'AlertForwardAlways', @param = @ForwardAlways OUT, @no_output = N'no_output'
    exec sys.xp_instance_regread N'HKEY_LOCAL_MACHINE', N'SOFTWARE\Microsoft\MSSQLServer\SQLServerAgent', N'AlertPagerToTemplate', @param = @PagerToTemplate OUT, @no_output = N'no_output'
    exec sys.xp_instance_regread N'HKEY_LOCAL_MACHINE', N'SOFTWARE\Microsoft\MSSQLServer\SQLServerAgent', N'AlertPagerCCTemplate', @param = @PagerCCTemplate OUT, @no_output = N'no_output'
    exec sys.xp_instance_regread N'HKEY_LOCAL_MACHINE', N'SOFTWARE\Microsoft\MSSQLServer\SQLServerAgent', N'AlertPagerSubjectTemplate', @param = @PagerSubjectTemplate OUT, @no_output = N'no_output'
    exec sys.xp_instance_regread N'HKEY_LOCAL_MACHINE', N'SOFTWARE\Microsoft\MSSQLServer\SQLServerAgent', N'AlertPagerSendSubjectOnly', @param = @PagerSendSubjectOnly OUT, @no_output = N'no_output'

    if (@includeaddresses &lt;&gt; 0) begin
        exec sys.xp_instance_regread N'HKEY_LOCAL_MACHINE', N'SOFTWARE\Microsoft\MSSQLServer\SQLServerAgent', N'AlertFailSafeEmailAddress', @param = @FailSafeEmailAddress OUT, @no_output = N'no_output'
        exec sys.xp_instance_regread N'HKEY_LOCAL_MACHINE', N'SOFTWARE\Microsoft\MSSQLServer\SQLServerAgent', N'AlertFailSafePagerAddress', @param = @FailSafePagerAddress OUT, @no_output = N'no_output'
        exec sys.xp_instance_regread N'HKEY_LOCAL_MACHINE', N'SOFTWARE\Microsoft\MSSQLServer\SQLServerAgent', N'AlertFailSafeNetSendAddress', @param = @FailSafeNetSendAddress OUT, @no_output = N'no_output'
    end

    select
        AlertFailSafeOperator = @FailSafeOperator,
        AlertNotificationMethod = @NotificationMethod,
        AlertForwardingServer = @ForwardingServer,
        AlertForwardingSeverity = @ForwardingSeverity,
        AlertPagerToTemplate = @PagerToTemplate,
        AlertPagerCCTemplate = @PagerCCTemplate,
        AlertPagerSubjectTemplate = @PagerSubjectTemplate,
        AlertPagerSendSubjectOnly = @PagerSendSubjectOnly,
        AlertForwardAlways = ISNULL(@ForwardAlways, 0)

    if (@includeaddresses &lt;&gt; 0)
        select
            AlertFailSafeEmailAddress = @FailSafeEmailAddress,
            AlertFailSafePagerAddress = @FailSafePagerAddress,
            AlertFailSafeNetSendAddress = @FailSafeNetSendAddress
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

