## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_helpfile\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_helpfile**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -669885142 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@filename| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|name|nvarchar|128|
|fileid|smallint|2|
|filename|nvarchar|260|
|filegroup|nvarchar|128|
|size|nvarchar|18|
|maxsize|nvarchar|18|
|growth|nvarchar|18|
|usage|varchar|9|

|Name |Datatype |Max length |
|-|-|-|
|name|nvarchar|128|
|filename|nvarchar|260|
|filegroup|nvarchar|128|
|size|nvarchar|18|
|maxsize|nvarchar|18|
|growth|nvarchar|18|
|usage|varchar|9|

---
### Objects that depend on \[sys\].\[sp_helpfile\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_helpfile\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_helpfile
@filename sysname = NULL            /* file name or all files */
as

set nocount on

if @filename IS NULL
begin
select     name,  fileid, filename,
    filegroup = filegroup_name(groupid),
    'size' = convert(nvarchar(15), convert (bigint, size) * 8) + N' KB',
    'maxsize' = (case maxsize when -1 then N'Unlimited'
            else
            convert(nvarchar(15), convert (bigint, maxsize) * 8) + N' KB' end),
    'growth' = (case status &amp; 0x100000 when 0x100000 then
        convert(nvarchar(15), growth) + N'%'
        else
        convert(nvarchar(15), convert (bigint, growth) * 8) + N' KB' end),
    'usage' = (case status &amp; 0x40 when 0x40 then 'log only' else 'data only' end)
    from sysfiles
    order by fileid

end
else
begin
    if file_id(@filename) IS NULL
    begin -- no such file
        raiserror (15325, -1, -1, 'file', @filename)
        return (1)
    end
    select     name,  filename,
    filegroup = filegroup_name(groupid),
    'size' = convert(nvarchar(15), convert (bigint, size) * 8) + N' KB',
    'maxsize' = (case maxsize when -1 then N'Unlimited'
            else
            convert(nvarchar(15), convert (bigint, maxsize) * 8) + N' KB' end),
    'growth' = (case status &amp; 0x100000 when 0x100000 then
        convert(nvarchar(3), growth) + N'%'
        else
        convert(nvarchar(15), convert (bigint, growth) * 8) + N' KB' end),
    'usage' = (case status &amp; 0x40 when 0x40 then 'log only' else 'data only' end)
    from sysfiles
    where fileid = file_id(@filename)
    order by fileid
end

return (0) -- sp_helpfile
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

