## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_approlepassword\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_approlepassword**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -673068117 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@rolename| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@newpwd| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_approlepassword\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_approlepassword\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_approlepassword
    @rolename        sysname,            -- name of app role
    @newpwd            sysname                -- new password
AS
    declare @stmt        nvarchar(4000)

    -- CHECK FOR NULL PASSWORD
    if (@newpwd is null)
    begin
        raiserror(15034,-1,-1)
        return (1)
    end

    -- CHECK FOR NULL NAME
    if (@rolename is null)
    begin
        raiserror(15004,-1,-1)
        return (1)
    end

    -- DISALLOW USER TRANSACTION --
    set implicit_transactions off
    if (@@trancount &gt; 0)
    begin
        raiserror(15002, -1, -1, 'sys.sp_approlepassword')
        return (1)
    end

    set @stmt = 'alter application role '
    set @stmt = @stmt + quotename(@rolename, ']')
    set @stmt = @stmt + ' with password = '
    set @stmt = @stmt + quotename(@newpwd, '''')

    BEGIN TRANSACTION

    exec (@stmt)
    if @@error &lt;&gt; 0
    begin
        ROLLBACK TRANSACTION
        return (1)
    end

    COMMIT TRANSACTION

    -- RETURN SUCCESS --
    return (0) -- sp_approlepassword
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

