## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSadjust_pub_identity\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSadjust_pub_identity**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -673856288 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@tablename| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@current_max| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@threshold| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@range| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@next_seed| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@pub_range| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSadjust_pub_identity\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSadjust_pub_identity\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_MSadjust_pub_identity 
(
    @publisher            sysname,
    @publisher_db        sysname,
    @tablename            sysname,
    @current_max        bigint  = NULL,
    @threshold            int  = NULL,
    @range                bigint = NULL,
    @next_seed            bigint  = NULL,
    @pub_range            bigint  = NULL
)
AS
begin
    declare @retcode        int
    --
    -- security check
    -- only db_owner can execute this
    --
    if (is_member ('db_owner') != 1) 
    begin
        raiserror(14260, 16, -1)
        return (1)
    end
    --
    -- security check
    -- Has to be executed from distribution database
    --
    if (sys.fn_MSrepl_isdistdb (db_name()) != 1)
    begin
        raiserror(21482, 16, -1, 'sp_MSadjust_pub_identity', 'distribution')
        return (1)
    end
    if @current_max is NOT NULL
    begin
        update MSrepl_identity_range set current_max=@current_max 
            where tablename=@tablename and LOWER(publisher)=LOWER(@publisher) and publisher_db=@publisher_db
        if @@ERROR&lt;&gt;0    
            return (1)
        if exists (select * from MSrepl_identity_range where max_identity is not NULL 
            and ABS(current_max) &gt; ABS(max_identity))
        begin
            raiserror(21195, 16, -1)
            return (1)
        end
    end
    if @threshold is NOT NULL
    begin
        update MSrepl_identity_range set threshold=@threshold 
            where tablename=@tablename and LOWER(publisher)=LOWER(@publisher) and publisher_db=@publisher_db
        if @@ERROR&lt;&gt;0    
            return (1)
    end
    if @next_seed is NOT NULL
    begin
        update MSrepl_identity_range set next_seed=@next_seed 
            where tablename=@tablename and LOWER(publisher)=LOWER(@publisher) and publisher_db=@publisher_db
        if @@ERROR&lt;&gt;0
            return (1)
    end
    if @range is NOT NULL
    begin
        update MSrepl_identity_range set range=@range 
            where tablename=@tablename and LOWER(publisher)=LOWER(@publisher) and publisher_db=@publisher_db    
        if @@ERROR&lt;&gt;0
            return (1)
    end
    if @pub_range is NOT NULL
    begin
        update MSrepl_identity_range set pub_range=@pub_range 
            where tablename=@tablename and LOWER(publisher)=LOWER(@publisher) and publisher_db=@publisher_db    
        if @@ERROR&lt;&gt;0
            return (1)
    end

    return (0)
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

