## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_denylogin\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_denylogin**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -673961798 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@loginame| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_denylogin\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_denylogin\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_denylogin
    @loginame        sysname
AS
    -- SETUP RUNTIME OPTIONS / DECLARE VARIABLES --
    set nocount on
    declare @ret   int    -- return value of sp call
    declare @exec_stmt nvarchar(4000)

    -- CHECK PERMISSIONS --
    IF (not is_srvrolemember('securityadmin') = 1)
    begin
       dbcc auditevent (105, 3, 0, @loginame, NULL, NULL, NULL, NULL, NULL, NULL)
       raiserror(15247,-1, -1)
       return (1)
    end
    ELSE
    begin
       dbcc auditevent (105, 3, 1, @loginame, NULL, NULL, NULL, NULL, NULL, NULL)
    end

    -- DISALLOW USER TRANSACTION --
    set implicit_transactions off
    IF (@@trancount &gt; 0)
    begin
        raiserror(15002,-1,-1,'sys.sp_denylogin')
        return (1)
    end

    -- DISALLOW SQL LOGIN (IE. MUST BE 'DOMAIN\USER') --
    if (charindex('\', @loginame) = 0)
    begin
        raiserror(15407, -1, -1, @loginame)
        return (1)
    end

    BEGIN TRANSACTION
    EXEC %%LocalLogin(Name = @loginame).Lock(Exclusive = 0)

    -- ADD ROW FOR NT LOGIN IF NEEDED --
    if @@error &lt;&gt; 0 -- not found
    begin
        execute @ret = sys.sp_MSaddlogin_implicit_ntlogin @loginame
        if (@ret &lt;&gt; 0)
        begin
            ROLLBACK TRANSACTION
            raiserror(15401,-1,-1 ,@loginame)
            return (1)
        end
        -- login locked
    end

    -- DENY ACCESS --
    EXEC %%LocalLogin(Name = @loginame).SetAccess(HasAccess = -1)

    COMMIT TRANSACTION

    -- FINALIZATION: RETURN SUCCESS --
    return (0)    -- sp_denylogin
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

