## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSgetrowmetadata\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSgetrowmetadata**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -675479137 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@tablenick| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@rowguid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@generation| |bigint|8|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@type| |tinyint|1|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@lineage| |varbinary|311|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@colv| |varbinary|2953|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@pubid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@compatlevel| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSgetrowmetadata\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSgetrowmetadata\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_MSgetrowmetadata
    (@tablenick int,
     @rowguid uniqueidentifier,
     @generation bigint output,
     @type  tinyint output,
     @lineage varbinary(311) output,
     @colv varbinary(2953) output,
     @pubid uniqueidentifier = NULL,
     @compatlevel int = 10) -- backward compatibility level, default=Sphinx
as
    declare @retcode        smallint
    declare @rc             int
    declare @procname       nvarchar(270)
    
    /*
    ** To public.
    */
    
    if (@tablenick is null)
    begin
        RAISERROR(14043, 16, -1, '@tablenick', 'sp_MSgetrowmetadata')
        return (1)
    end
        
    -- security check
        exec @retcode = sys.sp_MSrepl_PAL_rolecheck @tablenick=@tablenick, @pubid = @pubid
        if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
                return 1
                
    if (@rowguid is null)
    begin
        RAISERROR(14043, 16, -1, '@rowguid', 'sp_MSgetrowmetadata')
        return (1)
    end

    set @type= 4
    set @generation= 0
    set @lineage= NULL
    set @colv= NULL

    select @procname= 'dbo.' + select_proc from dbo.sysmergearticles where nickname = @tablenick and pubid = @pubid

    -- check for row in base table
    exec @retcode= @procname @maxschemaguidforarticle = NULL, @type=@type output, @rowguid=@rowguid
    if @@error &lt;&gt;0 or @retcode &lt;&gt; 0 
    begin
        return (1)
    end

    begin tran
    if (@type = 3)
    begin
        if @compatlevel &lt; 90
        begin
            declare @iscoltracked int
            declare @cCols int
            set @iscoltracked= sys.fn_fIsColTracked(@tablenick)
            if @iscoltracked = 1
            begin
                set @cCols= sys.fn_cColvEntries_80(@pubid, @tablenick)
            end
        end

        -- row is in base table; check whether it is in contents, too
        --
        -- serializable makes sure row does not go from tombstone to contents between 
        -- querying contents and tombstone, which would falsely result in type = missing
        select @type= 2,  @generation= generation, 
               @lineage= case when @compatlevel &gt;= 90 then lineage else {fn LINEAGE_90_TO_80(lineage)} end, 
               @colv= case when @compatlevel &gt;= 90 or @iscoltracked = 0 then colv1 else {fn COLV_90_TO_80(colv1, @cCols)} end
            from dbo.MSmerge_contents
            with (serializable)
            where tablenick = @tablenick and rowguid = @rowguid
    end
    else
    begin
        -- row is not in base table; either it is in tombstone, or it is missing
        set @type= 0

        select @type= type, @generation= generation, 
               @lineage= case when @compatlevel &gt;= 90 then lineage else {fn LINEAGE_90_TO_80(lineage)} end 
            from dbo.MSmerge_tombstone where
            tablenick = @tablenick and rowguid = @rowguid
    end
    commit tran
    
    return (0)
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

