## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSpostapplyscript_forsubscriberprocs\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSpostapplyscript_forsubscriberprocs**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -676846267 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@procsuffix| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSpostapplyscript_forsubscriberprocs\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSpostapplyscript_forsubscriberprocs\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
-- This proc is called by the .prc file to mark merge replication objects as system objects.
create procedure sys.sp_MSpostapplyscript_forsubscriberprocs    (
    @procsuffix sysname)
    
as
begin
    declare @retcode        smallint
    declare @procname       nvarchar(400)
    declare @ownername      nvarchar(140)
    declare @destowner      nvarchar(140)
    declare @ins_procname   nvarchar(258)
    declare @ins_batch_procname nvarchar(258)
    declare @upd_procname   nvarchar(258)
    declare @upd_batch_procname nvarchar(258)
    declare @sel_procname nvarchar(258)
    declare @sel_metadata_procname nvarchar(258)
    declare @del_procname nvarchar(258)
    declare @conflict_proc nvarchar(258)

    set nocount on
    /*
    ** Check to see if current publication has permission
    */
    exec @retcode=sys.sp_MSreplcheck_subscribe
    if @retcode&lt;&gt;0 or @@ERROR&lt;&gt;0 return (1)
    
    select @ins_procname = quotename('MSmerge_ins_sp_' + @procsuffix)
    select @ins_batch_procname = quotename('MSmerge_ins_sp_' + @procsuffix + '_batch')
    select @upd_procname = quotename('MSmerge_upd_sp_' + @procsuffix)
    select @upd_batch_procname = quotename('MSmerge_upd_sp_' + @procsuffix + '_batch')
    select @del_procname = quotename('MSmerge_del_sp_' + @procsuffix)
    select @sel_procname = quotename('MSmerge_sel_sp_' + @procsuffix)
    select @sel_metadata_procname = quotename('MSmerge_sel_sp_' + @procsuffix + '_metadata')
    select @conflict_proc = quotename('MSmerge_cft_sp_' + @procsuffix)

    select @procname = @ins_procname
    if object_id(@ins_procname ,'P') is not NULL
    begin
        exec sys.sp_MS_marksystemobject @procname        
        exec ('grant exec on ' + @procname + ' to public')
    end
        
    select @procname = @ins_batch_procname
    if object_id(@ins_batch_procname ,'P') is not NULL
    begin
        exec sys.sp_MS_marksystemobject @procname        
        exec ('grant exec on ' + @procname + ' to public')
    end

    select @procname = @upd_procname
    if object_id(@upd_procname ,'P') is not NULL
    begin
        exec sys.sp_MS_marksystemobject @procname        
        exec ('grant exec on ' + @procname + ' to public')
    end

    select @procname = @upd_batch_procname
    if object_id(@upd_batch_procname ,'P') is not NULL
    begin
        exec sys.sp_MS_marksystemobject @procname        
        exec ('grant exec on ' + @procname + ' to public')
    end

    select @procname = @del_procname
    if object_id(@del_procname ,'P') is not NULL
    begin
        exec sys.sp_MS_marksystemobject @procname        
        exec ('grant exec on ' + @procname + ' to public')
    end

    select @procname = @sel_procname
    if object_id(@sel_procname ,'P') is not NULL
    begin
        exec sys.sp_MS_marksystemobject @procname        
        exec ('grant exec on ' + @procname + ' to public')
    end

    select @procname = @sel_metadata_procname
    if object_id(@sel_metadata_procname ,'P') is not NULL
    begin
        exec sys.sp_MS_marksystemobject @procname        
        exec ('grant exec on ' + @procname + ' to public')
    end

    select @procname = @conflict_proc
    if object_id(@conflict_proc ,'P') is not NULL
    begin
        exec sys.sp_MS_marksystemobject @procname        
        exec ('grant exec on ' + @procname + ' to public')
    end
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

