## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_helptracertokens\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_helptracertokens**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -681271668 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_helptracertokens\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_helptracertokens\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_helptracertokens
(
    @publication    sysname,
    @publisher        sysname = NULL,
    @publisher_db    sysname = NULL
)
as
begin
    declare @retcode             int,
            @distproc             nvarchar(1000),
            @distributor         sysname, 
            @distribution_db     sysname
    --
    -- Calling convention is different if we are already at the distdb
    --
    if sys.fn_MSrepl_isdistdb (db_name()) = 1
    begin
        -- security check for distributor is performed in the helper proc.
    
        -- if we are at the distributor then publisher and
        -- publisher db are required parameters for this proc
        if isnull(@publisher, N'') = N''
        begin
            -- Parameter '%s' cannot be NULL or empty string when this procedure is run from a distribution database.
            raiserror(20686, 16, -1, '@publisher', 'distribution')
            return 1
        end
        else if isnull(@publisher_db, N'') = N''
        begin
            -- Parameter '%s' cannot be NULL or empty string when this procedure is run from a distribution database.
            raiserror(20686, 16, -1, '@publisher_db', 'distribution')
            return 1
        end
        
        exec @retcode = sys.sp_MShelptracertokens @publication         = @publication,
                                                    @publisher        = @publisher,    
                                                    @publisher_db    = @publisher_db
        
        return @retcode
    end

    --
    -- Everything below this line is expected to run on the Publisher
    --

    -- Publisher Security Check.
    exec @retcode = sys.sp_MSreplcheck_publish
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
        return 1

    -- check this db is published
    if sys.fn_MSrepl_istranpublished(db_name(),1) &lt;&gt; 1
    begin
        -- "The database is not published."
        raiserror (18757, 16, -1)
        return 1
    end
    
    -- do not allow users to specify pub/pubdb unless at disdb
    if @publisher is not NULL
    begin
        -- Parameter ''%s'' must be NULL when this procedure is not being run from a distribution database.
        raiserror(20687, 16, -1, '@publisher', 'distribution')
        return 1
    end
    else if @publisher_db is not NULL
    begin
        -- Parameter ''%s'' must be NULL when this procedure is not being run from a distribution database.
        raiserror(20687, 16, -1, '@publisher_db', 'distribution')
        return 1
    end

    select @publisher = publishingservername(),
            @publisher_db = db_name()

    exec @retcode = sys.sp_helpdistributor @rpcsrvname = @distributor OUTPUT, 
                                            @distribdb = @distribution_db OUTPUT,
                                            @publisher = @publisher
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0 or @distributor is NULL
    begin
        -- "The Distributor has not been installed correctly."
        raiserror(20036, 16, -1)
        return 1
    end

    select @distproc = QUOTENAME(RTRIM(@distributor)) + '.' + QUOTENAME(RTRIM(@distribution_db)) + '.sys.sp_MShelptracertokens'    
    exec @retcode = @distproc @publication         = @publication,
                                @publisher        = @publisher,    
                                @publisher_db    = @publisher_db
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0 
    begin
        return 1
    end

    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

