## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSgetversion\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSgetversion**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -681539103 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
 No parameters exist

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|(No column name)|sql_variant|8009|
|(No column name)|int|4|
|(No column name)|sql_variant|8009|

---
### Objects that depend on \[sys\].\[sp_MSgetversion\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSgetversion\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
--
-- Name:
--         sp_MSgetversion
--
-- Description:
--     Get the server product version, license type and package type.
--     This procedure is for downlevel compatibility since pre-SQL11 subscribers depend on it.  
--    
-- Returns:
--      0-Success 
--
-- Security: 
--      Internal

CREATE PROCEDURE sys.sp_MSgetversion
AS
BEGIN
    /* 
    * Dev Note (VSTS#749780): 
    * sp_MSgetversion was removed in Denali since it was an internal sp and deprecated. 
    * We re-implement it in repl for downlevel compatibility.
    * Repl agents in Denali do not use it.
    *
    * The package type is not available directly in serverproperty.
    * We do some simple translation from engineedition.The values are,
    *    PACKAGE_STANDARD = 2 ;
    *    PACKAGE_ENTERPRISE = 3 ;
    *    PACKAGE_MSDE = 4 ;
    *    PACKAGE_EXPRESS = 5 ;
    *    ENGINE_MSDE = 1 ;
    *    ENGINE_STANDARD = 2 ;
    *    ENGINE_ENTERPRISE = 3 ;
    *    ENGINE_EXPRESS = 4 ;
    * In fact nobody cares about the package type, we just make it complete.
    */
    SELECT SERVERPROPERTY('ProductVersion'), 
        CASE SERVERPROPERTY('LicenseType')
            WHEN 'PER_SEAT' THEN 1
            WHEN 'PER_PROCESSOR' THEN  2
            -- Just keep same behavior as the old sp, return 1 for other cases
            -- Keep the PER_SEAT case to indicate the licensetype
            ELSE 1
        END,
        CASE SERVERPROPERTY('EngineEdition')
            WHEN 1 THEN 4
            WHEN 4 THEN 5
            ELSE SERVERPROPERTY('EngineEdition')
        END 
    RETURN 0
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

