## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSdeletepeerconflictrow\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSdeletepeerconflictrow**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -681967304 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@originator_id| |nvarchar|32|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@origin_datasource| |nvarchar|255|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@tran_id| |nvarchar|40|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@row_id| |nvarchar|19|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@conflict_table| |nvarchar|270|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSdeletepeerconflictrow\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSdeletepeerconflictrow\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_MSdeletepeerconflictrow
(
    @originator_id nvarchar(32) = '%' ,--int
    @origin_datasource nvarchar(255) = '%', --int
    @tran_id nvarchar(40) = '%', --varbinary(16)
    @row_id nvarchar(19) = '%',  -- timestamp
    @conflict_table nvarchar(270)
)
as 
begin
    set nocount on
    declare @retcode int
                ,@cmd nvarchar(4000)
                ,@startoffset int
                ,@table    sysname
                ,@schema sysname
                ,@whcmd nvarchar(4000) = N'(__$row_id is not null) '


    /*
    **  Security check.  restrict to 'sysadmin' and member of db_owner role
    */ 
    exec @retcode = sys.sp_MSreplcheck_publish
    if @@ERROR &lt;&gt; 0 or @retcode &lt;&gt; 0
        return (1)

    if (@conflict_table is NULL)
    begin
        raiserror(14043, 16, 1, '@conflict_table', 'sp_MSdeletepeerconflictrow')
        return (1)
    end
    --
    -- check if the conflict table is owner qualified
    -- and build the delete string as necessary
    --
    select @table = PARSENAME(@conflict_table, 1),
            @schema = PARSENAME(@conflict_table, 2)

    begin tran
    save tran tr_deletepeerconflictrow

    if (@row_id != N'%') --delete the corresponding winner or loser record
    begin
        select @cmd = N'delete ' + ISNULL(NULLIF(QUOTENAME(@schema) + N'.', N'.'), N'') + QUOTENAME(@table) + N'
                        where __$row_id in (
                            select __$row_id
                            from ' + ISNULL(NULLIF(QUOTENAME(@schema) + N'.', N'.'), N'') + QUOTENAME(@table) + N'
                            where __$change_id = ' + @row_id + N'
                            union
                            select __$change_id
                            from ' + ISNULL(NULLIF(QUOTENAME(@schema) + N'.', N'.'), N'') + QUOTENAME(@table) + N'
                            where __$row_id = ' + @row_id + N' and __$change_id is not null)'
         execute (@cmd)
         if @@error &lt;&gt; 0
             goto UNDO
    end
            
    select @cmd = 'delete ' + ISNULL(NULLIF(QUOTENAME(@schema) + N'.', N'.'), N'') + QUOTENAME(@table)

    if (@originator_id != N'%')
    begin
          select @whcmd = @whcmd + N' and __$originator_id = ' + QUOTENAME(@originator_id, '''')
    end
    if (@origin_datasource != N'%')
    begin
           select @whcmd = @whcmd + N' and __$origin_datasource = ' + QUOTENAME(@origin_datasource, '''')
    end
    if (@tran_id != N'%')
    begin
           select @whcmd = @whcmd + N' and __$tranid = ' + QUOTENAME(@tran_id, '''')
    end
    if (@row_id != N'%')
    begin
            select @whcmd = @whcmd + N' and __$row_id = ' + @row_id --delete the specified record: either loser or winner
    end
    select @cmd = @cmd + N' where ' + @whcmd
    execute (@cmd)
    if @@error &lt;&gt; 0
             goto UNDO

    commit tran
    return (0)

UNDO:
   rollback tran tr_deletepeerconflictrow
   commit tran 

   raiserror(21542, 16, 1, @@error, 'sp_MSdeletepeerconflictrow')
   return (1)

end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

