## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSrepl_linkedservers_rowset\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSrepl_linkedservers_rowset**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -687835931 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@srvname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@agent_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@agent_type| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSrepl_linkedservers_rowset\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSrepl_linkedservers_rowset\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSrepl_linkedservers_rowset
(
    @srvname sysname,
    @agent_id int,
    @agent_type int = 0        -- 0: distagent 1: merge
)
as
begin
    declare @retcode int
    
    -- Security check: sysadmin/dbo/PAL only
    exec @retcode = sys.sp_MScheck_pull_access @agent_id = @agent_id,
                                                @agent_type = @agent_type
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
        return 1

    SELECT    SVR_NAME            = srvname,
            SVR_PRODUCT            = srvproduct,
            SVR_PROVIDERNAME    = providername,
            SVR_DATASOURCE        = datasource,
            SVR_PROVIDERSTRING    = providerstring,
            SVR_LOCATION        = location,
            SVR_CATALOG            = catalog
    FROM    master.dbo.sysservers
    WHERE    UPPER(srvname) = UPPER(@srvname) collate database_default
      AND    ISNULL(providername,' ') &lt;&gt; ' '
      AND    ( ISNULL(datasource, ' ') &lt;&gt; ' '
                  or ISNULL(location, ' ') &lt;&gt; ' '
                  or ISNULL(providerstring, ' ') &lt;&gt; ' '
                  or ISNULL(catalog, ' ') &lt;&gt; ' '
              )
    ORDER BY 1

    if @@error &lt;&gt; 0
        return 1
    else
        return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

