## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_indexes_90_rowset\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_indexes_90_rowset**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -692824696 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@table_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@index_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@table_schema| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|TABLE_CATALOG|nvarchar|128|
|TABLE_SCHEMA|nvarchar|128|
|TABLE_NAME|nvarchar|128|
|INDEX_CATALOG|nvarchar|128|
|INDEX_SCHEMA|nvarchar|128|
|INDEX_NAME|nvarchar|128|
|PRIMARY_KEY|bit|1|
|UNIQUE|bit|1|
|CLUSTERED|bit|1|
|TYPE|smallint|2|
|FILL_FACTOR|int|4|
|INITIAL_SIZE|int|4|
|NULLS|int|4|
|SORT_BOOKMARKS|bit|1|
|AUTO_UPDATE|bit|1|
|NULL_COLLATION|int|4|
|ORDINAL_POSITION|int|4|
|COLUMN_NAME|nvarchar|128|
|COLUMN_GUID|uniqueidentifier|16|
|COLUMN_PROPID|int|4|
|COLLATION|smallint|2|
|CARDINALITY|int|4|
|PAGES|int|4|
|FILTER_CONDITION|nvarchar|2147483647|
|INTEGRATED|bit|1|
|STATUS|int|4|

---
### Objects that depend on \[sys\].\[sp_indexes_90_rowset\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_indexes_90_rowset\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_indexes_90_rowset
(
    @table_name     sysname,
    @index_name     sysname = null,
    @table_schema   sysname = null
)
as
    select
        TABLE_CATALOG       = s_iv.TABLE_CATALOG,
        TABLE_SCHEMA        = s_iv.TABLE_SCHEMA,
        TABLE_NAME          = s_iv.TABLE_NAME,
        INDEX_CATALOG       = s_iv.INDEX_CATALOG,
        INDEX_SCHEMA        = s_iv.INDEX_SCHEMA,
        INDEX_NAME          = s_iv.INDEX_NAME,
        PRIMARY_KEY         = s_iv.PRIMARY_KEY,
        [UNIQUE]            = s_iv.[UNIQUE],
        [CLUSTERED]         = s_iv.[CLUSTERED],
        [TYPE]              = s_iv.[TYPE],
        FILL_FACTOR         = s_iv.FILL_FACTOR,
        INITIAL_SIZE        = s_iv.INITIAL_SIZE,
        NULLS               = s_iv.NULLS,
        SORT_BOOKMARKS      = s_iv.SORT_BOOKMARKS,
        AUTO_UPDATE         = s_iv.AUTO_UPDATE,
        NULL_COLLATION      = s_iv.NULL_COLLATION,
        ORDINAL_POSITION    = s_iv.ORDINAL_POSITION,
        COLUMN_NAME         = s_iv.COLUMN_NAME,
        COLUMN_GUID         = s_iv.COLUMN_GUID,
        COLUMN_PROPID       = s_iv.COLUMN_PROPID,
        [COLLATION]         = s_iv.[COLLATION],
        CARDINALITY         = s_iv.CARDINALITY,
        PAGES               = s_iv.PAGES,
        FILTER_CONDITION    = s_iv.FILTER_CONDITION,
        INTEGRATED          = s_iv.INTEGRATED,
        STATUS              = s_iv.STATUS

    from
        sys.spt_indexes_view s_iv

    where
        (
            (@table_schema is null and s_iv.TABLE_NAME = @table_name) or
            object_id(quotename(@table_schema) + '.' + quotename(@table_name)) = s_iv.object_id
        ) and
        (@index_name is null or @index_name = s_iv.INDEX_NAME)

    order by 8, 10, 4, 5, 6, 17
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

