## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSenumreplicas\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSenumreplicas**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -695717971 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@pubid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSenumreplicas\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSenumreplicas\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_MSenumreplicas (
    @pubid uniqueidentifier)
as
    declare @inactive tinyint

    /*
    ** Check to see if current publication has permission
    */
    if ({ fn ISPALUSER(@pubid) } &lt;&gt; 1)
    begin   
        RAISERROR (14126, 11, -1)
        return (1)
    end

    select @inactive = 0
    if object_id('MSmerge_contents') is NULL
    begin
        RAISERROR(20054 , 16, -1)
        return (1)
    end

    select subs.subid, {fn REPLNICK_90_TO_80(subs.replnickname)}, 
           subs.subscriber_type, subs.subscription_type, 
           subs.priority, subs.schemaversion, subs.schemaguid, subs.datasource_type, subs.subscriber_server, subs.subscriber_server,  
           subs.db_name, subs.status, subs.pubid, subs.sync_type, subs.description, subs.pubid, pubs.name, pubs.distributor
           from dbo.sysmergesubscriptions subs
           left outer join dbo.sysmergepublications pubs
           on subs.subid = pubs.pubid
                where subs.status &lt;&gt; @inactive
                    and subs.subscriber_type = 1
                    -- If called by 8.0 reconciler on 9.0 replica: It does not know about status 7.
                    and subs.status &lt;&gt; 7 -- REPLICA_STATUS_BeforeRestore
                    order by convert(binary, subs.subid)
    IF @@ERROR &lt;&gt;0 return (1) 
    return (0)
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

