## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_revoke_publication_access\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_revoke_publication_access**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -697532365 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@login| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_revoke_publication_access\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_revoke_publication_access\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_revoke_publication_access
(
    @publication    sysname,
    @login            sysname,
    @publisher        sysname = NULL
)
AS
BEGIN
    set nocount on
    
    -- This stored procedure can be called repeatedly.
    DECLARE @distribdb        sysname,
                @distproc        nvarchar (300),
                @retcode        int,
                @dist_rpcname    sysname,
                @database        sysname,
                @publisher_type    sysname,
                @loc_publisher    sysname,
                @role             sysname,
                @pubid             uniqueidentifier,
                @pubidtran         int,
                @pubidstr         nvarchar(40),
                @user             sysname

    -- Security Check
    exec @retcode = sys.sp_MSreplcheck_publish
    if @@ERROR &lt;&gt; 0 or @retcode &lt;&gt; 0
        return(1)

    -- Set publisher name if not supplied
    select @loc_publisher = case when (@publisher is null) then publishingservername() 
                                                else @publisher end

    -- Get publisher info
    EXEC @retcode = sys.sp_MSrepl_getdistributorinfo    @publisher        = @loc_publisher,
                                                        @rpcsrvname        = @dist_rpcname   OUTPUT,
                                                        @distribdb        = @distribdb      OUTPUT,
                                                        @publisher_type    = @publisher_type OUTPUT
    IF @@error &lt;&gt; 0
    BEGIN
         RAISERROR (14071, 16, -1)
         return (1)
    END

    IF @retcode &lt;&gt; 0 OR @distribdb IS NULL OR @dist_rpcname IS NULL
    BEGIN
        RAISERROR (14071, 16, -1)
        return(1)
    END

    -- Restrict specification of publisher to HREPL only
    IF @publisher_type = N'MSSQLSERVER' AND @publisher IS NOT NULL
    BEGIN
        RAISERROR(21606, 16, -1, '@publisher', 'NULL')
        RETURN (1)
    END

    -- Set db context to distributor if HREPL
    select @database = case when (@publisher_type = N'MSSQLSERVER') then db_name() else @distribdb end

    -- remove the user from the PAL role in the publishing database
    -- added for role based security
    if object_id('sysmergepublications') is not NULL
    begin
        select @pubid = pubid from dbo.sysmergepublications where name = @publication and UPPER(publisher) = UPPER(@loc_publisher) collate database_default and publisher_db = db_name()
        if (@pubid is not null)
        begin
            select @role = sys.fn_MSmerge_GetPALRole(@pubid)

            if exists (select * from sys.database_principals where name=@role and type = 'R')
            begin
                select @user = name from sys.database_principals where sid = suser_sid(@login, 0) and name &lt;&gt; 'dbo'
                if @user is not NULL
                begin
                    exec @retcode = sp_droprolemember @role, @user
                    if (@retcode &lt;&gt; 0 or @@error &lt;&gt; 0)
                        return 1
                    exec @retcode = sys.sp_MSrevokeconnectreplication @loc_publisher, @database, @login, @user
                    if (@retcode &lt;&gt; 0 or @@error &lt;&gt; 0)
                        return 1
                end
            end
        end
    end
    if object_id('syspublications') is not NULL
    begin
        if (@publisher_type = N'MSSQLSERVER')
            select @pubidtran = pubid from dbo.syspublications where name = @publication
        else
            select @pubidtran = pubid from sys.fn_IHgetpubid(@publication, @loc_publisher, @publisher_type)
        if (@pubidtran is not null)
        begin
            select @role = N'MSReplPAL_' + cast(db_id() as nvarchar(10)) + N'_' + cast(@pubidtran as nvarchar(10))

            if exists (select * from sys.database_principals where name=@role and type = 'R')
            begin
                select @user = name from sys.database_principals where sid = suser_sid(@login, 0) and name &lt;&gt; 'dbo'
                if @user is not NULL
                begin
                    exec @retcode = sp_droprolemember @role, @user
                    if (@retcode &lt;&gt; 0 or @@error &lt;&gt; 0)
                        return 1                        
                    exec @retcode = sys.sp_MSrevokeconnectreplication @loc_publisher, @database, @login, @user
                    if (@retcode &lt;&gt; 0 or @@error &lt;&gt; 0)
                        return 1
                end
            end
        end
    end

    -- Do check existense when dropping since the login might be dropped
    -- outside replication already.
    SELECT @distproc = QUOTENAME(RTRIM(@dist_rpcname)) + '.' + QUOTENAME(RTRIM(@distribdb)) + '.sys.sp_MSpublication_access'

    EXEC @retcode = @distproc
                    @publisher  = @loc_publisher,
                    @publisher_db = @database,
                    @publication = @publication,
                    @login   = @login,
                    @operation  = 'drop'

    IF @@error &lt;&gt; 0 OR @retcode &lt;&gt; 0
        return (1)
    --
    -- all done
    --
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

