## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSsetup_use_partition_groups\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSsetup_use_partition_groups**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -697733640 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSsetup_use_partition_groups\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSsetup_use_partition_groups\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSsetup_use_partition_groups @publication sysname
as
    declare @use_partition_groups smallint
            , @dynamic_filters bit
            , @dynamic_filters_function_list nvarchar(500)
            , @retcode int
            , @pubid uniqueidentifier
                
    exec @retcode = sys.sp_MSreplcheck_publish
    if @retcode&lt;&gt;0 or @@ERROR&lt;&gt;0
        return 1

    select @pubid = pubid, 
    @use_partition_groups = use_partition_groups, 
    @dynamic_filters = dynamic_filters, 
    @dynamic_filters_function_list = dynamic_filters_function_list
    from dbo.sysmergepublications 
    where name = @publication and UPPER(publisher)=UPPER(publishingservername()) and publisher_db=db_name()

    if @pubid is null
    begin
        raiserror(20026, 16, -1, @publication)
        return (1)
    end

    begin tran
    save transaction setup_partition_groups_table
    if (@use_partition_groups = 2)
    begin
        if (@dynamic_filters = 1 and @dynamic_filters_function_list is not null and @dynamic_filters_function_list &lt;&gt; ' ')
            or (@dynamic_filters = 0)
        begin
            
            -- dynamically filtered and we have the dynamic filters function list.
            -- or
            -- statically-filtered

            update dbo.sysmergepublications 
            set use_partition_groups = 1
            where pubid = @pubid
            and use_partition_groups = 2
            
            -- First make sure the appropriate columns are added to MSmergepartition_groups
            exec @retcode = sys.sp_MSsetup_partition_groups_table @pubid

            if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
            begin 
                goto UNDO
            end
        end
    end
    else if (@use_partition_groups = -1)
    begin
        
        exec @retcode = sys.sp_MSdisable_use_partition_groups @pubid
        if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
        begin
            goto UNDO
        end
    end
    else if (@dynamic_filters = 1 and @use_partition_groups = 0)
    begin
        exec @retcode = sys.sp_MSsetup_partition_groups_table @pubid
        if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
        begin 
            goto UNDO
        end
    end
    commit transaction

    return 0

UNDO:
    rollback transaction setup_partition_groups_table
    commit transaction

    return 1
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

