## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_altermessage\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_altermessage**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -704610542 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@message_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@parameter| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@parameter_value| |varchar|5|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_altermessage\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_altermessage\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_altermessage
    @message_id       int,
    @parameter        sysname,
    @parameter_value  varchar(5)
as
    declare @msg    varchar(128)
    declare @log    bit
    select @parameter = UPPER (@parameter collate Latin1_General_CI_AS)
    select @parameter_value = UPPER (@parameter_value collate Latin1_General_CI_AS)

    -- Must be ServerAdmin to manage messages
    if is_srvrolemember('serveradmin') = 0
    begin
        raiserror(15247,-1,-1)
        return (1)
    end

    -- Is Parameter 'WITH_LOG'?
    if (@parameter &lt;&gt; 'WITH_LOG')
    begin
        raiserror(15176,-1,-1)
        return (1)
    end

    -- Is ParameterValue TRUE or FALSE?
    select @log = (case @parameter_value
        when 'TRUE'    then 1
        when 'FALSE' then 0
        end)
    if @log is null
    begin
        raiserror(15277,-1,-1)
        return (1)
    end

    BEGIN TRANSACTION
    -- Does this message exist?
    EXEC %%ErrorMessage(ID = @message_id).Lock(Exclusive = 1)
    if @@error &lt;&gt; 0
    begin
        COMMIT TRANSACTION
        raiserror(15179,-1,-1,@message_id)
        return (1)
    end

    declare @msg_str nvarchar(50)
    set @msg_str = @message_id

    -- Turn event log on or off
    EXEC %%ErrorMessage(ID = @message_id).SetEventLog(EventLog = @log)
    
    -- EMDEventType(x_eet_Alter_Message), EMDUniversalClass(x_eunc_Message), src major id, src minor id, src name
    -- -1 means ignore target stuff, target major id, target minor id, target name,
    -- # of parameters, 5 parameters
    EXEC %%System().FireTrigger(ID = 215, ID = 106, ID = @message_id, ID = 0, Value = @msg_str,
        ID = -1, ID = 0, ID = 0, Value = NULL, 
        ID = 3, Value = @message_id, Value = @parameter, Value = @parameter_value, Value = NULL, Value = NULL, Value = NULL, Value = NULL)

    COMMIT TRANSACTION

    return (0)    -- sp_altermessage
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

