## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MScdc_db_ddl_event\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MScdc_db_ddl_event**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -708257764 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@EventData| |xml|2147483647|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MScdc_db_ddl_event\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MScdc_db_ddl_event\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MScdc_db_ddl_event 
(
    @EventData xml
)
as
begin
    set nocount on

    declare @old_database_name sysname
        ,@new_database_name sysname
        ,@event_type sysname
        ,@proc nvarchar(1000)
        ,@retcode int
        
    -- If the table msdb.dbo.cdc_jobs doesn't exist, simply return. 
    if ([sys].[fn_cdc_jobs]() = 0)
        return 0

    select @event_type = event_instance.value('EventType[1]', 'nvarchar(100)')
        ,@old_database_name = event_instance.value('DatabaseName[1]', 'sysname')
    FROM       @EventData.nodes('/EVENT_INSTANCE') as R(event_instance)

    --for alter database, all we care is if database name has changed, skip everything else
    if (@event_type = N'ALTER_DATABASE')
    begin
        --if no cdc enabled db, don't do anything
        if not exists (select * from sys.databases where is_cdc_enabled = 1)
            return 0

        if db_id(@old_database_name) is not null
            return 0
        else
        begin
            -- the only reliable way to find new database name is through our jobs
            select @new_database_name = [sys].[fn_cdc_db_name_from_job_entry](@old_database_name)
        
            -- if jobs don't exists for whatever reason, we don't really need to do any thing    
            if @new_database_name is null 
                return 0
            
            set @proc = quotename(@new_database_name) + N'.sys.sp_MScdccheck_ddladmin'
            EXEC @retcode = @proc 
            IF @@ERROR &lt;&gt; 0 or @retcode &lt;&gt; 0
            BEGIN
                return 1
            END
        end
    end

    --only sa can drop cdc-enabled database, even if there's other way to grant non-sa right to do so, 
    --ddl trigger is after effect so db is gone therefore we won't have anyway to evaluate what right you have in the dropped db.
    if (@event_type = N'DROP_DATABASE')
    begin
        --the whole purpose of hooking into DROP_DATABASE is to cleanup cdc jobs, if there is no job, no need to do anything
        if ([sys].[fn_cdc_jobs]() = 1)
        begin
                --again, if the dropped db has no job to clean, why bother
                if ([sys].[fn_cdc_job_entry](@old_database_name) = 1)
                begin
                    if ([sys].[fn_cdc_is_user_authorized]() = 0)
                    begin
                        raiserror(22902, 16, -1)
                        return 1
                    end
                end
                else 
                    return 0
        end
        else
            return 0
    end
    
    -- Remove obsolete entries from msdb jobs tables. This is handled as a best effort.
    -- Failure should not cause DROP or ALTER to fail.
    exec [sys].[sp_cdc_cleanup_job_entries] @event_type, @old_database_name, @new_database_name
    
    return 0
    
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

