## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_dropmergealternatepublisher\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_dropmergealternatepublisher**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -709001410 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@alternate_publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@alternate_publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@alternate_publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_dropmergealternatepublisher\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_dropmergealternatepublisher\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_dropmergealternatepublisher (
    @publisher                    sysname,                    /* Publisher server */
    @publisher_db                sysname,                    /* Publisher database */
    @publication                sysname,                    /* Publication name */
    @alternate_publisher        sysname,                    /* Alternate publisher */
    @alternate_publisher_db        sysname,                    /* Alternate publisher_db */
    @alternate_publication        sysname                        /* Alternate publication */
    ) AS

    SET NOCOUNT ON
    declare @retcode                int
    declare @subid                    uniqueidentifier
    declare @alternate_subid        uniqueidentifier
    declare @pubid                  uniqueidentifier
    
    /*
    ** Security Check
    */
    EXEC @retcode = sys.sp_MSreplcheck_publish
    IF @@ERROR &lt;&gt; 0 or @retcode &lt;&gt; 0
        return (1)

    /* Check is there is an invalid attempt to drop the default publiser/publisher_db/publication */
    if (LOWER(@publisher) = LOWER(@alternate_publisher)) AND
        (@publisher_db = @alternate_publisher_db) AND
        (@publication = @alternate_publication)
        begin
            RAISERROR(21252, 11, -1,  @alternate_publisher, @alternate_publisher_db, @alternate_publication)
            return (1)
        end

    /*
    ** Select the main publication's pubid and subid
    */
    select @pubid = pubid from dbo.sysmergepublications     
                where name = @publication and
                    LOWER(publisher collate database_default) = LOWER(@publisher collate database_default) and
                    publisher_db = @publisher_db
    if @pubid is NULL
    begin
        raiserror (20026, 11, -1, @publication)
        return (1)
    end
    
    -- this subid should really be equal to @pubid
    select @subid = subid from dbo.sysmergesubscriptions  
        where LOWER(subscriber_server) collate database_default = LOWER(@publisher) collate database_default and 
        db_name = @publisher_db and 
        pubid = @pubid and
        status &lt;&gt; 7 -- REPLICA_STATUS_BeforeRestore

    -- check if we know about the publication 
    -- we know of the publication if there is an entry in sysmergepublications corresponding to it
    -- the values of @alternate_subid should be same as 'alternate_pubid' in sysmergepublications
    select @alternate_subid = s.subid
        from dbo.sysmergesubscriptions s, dbo.sysmergepublications p
        where p.name = @alternate_publication and
              LOWER(p.publisher) collate database_default = LOWER(@alternate_publisher) collate database_default and 
              p.publisher_db = @alternate_publisher_db and
              p.pubid = s.pubid and
              s.subid = s.pubid and
              s.status &lt;&gt; 7 -- REPLICA_STATUS_BeforeRestore
    IF @subid is NULL or @alternate_subid IS NULL
    BEGIN
        RAISERROR(21216, 11, -1,  @alternate_publisher, @alternate_publisher_db, @alternate_publication)
        RETURN (1)
    END

    if exists (select * from MSmerge_altsyncpartners where subid = @subid and alternate_subid = @alternate_subid)
    begin
        delete from MSmerge_altsyncpartners where @subid = subid and alternate_subid = @alternate_subid
        if @@ERROR &lt;&gt; 0 or @@rowcount &lt;&gt; 1
        BEGIN
            GOTO FAILURE
        END
    end                
    return (0)

FAILURE:
    RAISERROR(21251, 11, -1,  @alternate_publisher, @alternate_publisher_db, @alternate_publication)
    RETURN (1)
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

