## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSdrop_anonymous_entry\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSdrop_anonymous_entry**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -712140127 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@subid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@login| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@type| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSdrop_anonymous_entry\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSdrop_anonymous_entry\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_MSdrop_anonymous_entry
(
    @subid uniqueidentifier,
    @login sysname,
    @type int -- 1 tran sub, 2 merge sub
)
as
begin
    declare @sid varbinary(85)
    declare @agent_id int, @retcode int
    set nocount on 
    --
    -- security check
    -- only db_owner can execute this
    --
    if (is_member ('db_owner') != 1) 
    begin
        raiserror(14260, 16, -1)
        return (1)
    end
    if @type not in (1,2)
    begin
        raiserror(20587, 16, -1, '@type', 'sp_MSdrop_anonymous_entry')
        return (1)
    end
    -- If tran
    if @type = 1
    begin
        select @sid = sid from MSdistribution_agents where
            anonymous_subid = @subid
    end
    else
    begin
        select @sid = sid from dbo.MSmerge_agents where
            anonymous_subid = @subid
    end
    if @sid is null
    begin
        RAISERROR (14055, 11, -1)
        return(1)
    end
    -- null login means no security check needed
    if @login is not null and suser_sid(@login, 0) &lt;&gt; @sid
    begin
        set @login = suser_sname(@sid)
        RAISERROR (20596, 11, -1, @login)
        RETURN (1)
    end

    if @type = 1
    begin
        select @agent_id = id from MSdistribution_agents where anonymous_subid = @subid
        if @agent_id is not null
        begin
            exec @retcode = sys.sp_MSdrop_distribution_agentid @agent_id
            if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
                return 1
        end
    end
    else
    begin
        select @agent_id = id from dbo.MSmerge_agents where anonymous_subid = @subid
        if @agent_id is not null
        begin
            exec @retcode = sys.sp_MSdrop_merge_agentid @agent_id
            if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
                return 1
        end
    end
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

