## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSset_subscription_properties\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSset_subscription_properties**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -712814795 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscription_type| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@allow_subscription_copy| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@queue_id| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@update_mode| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@attach_version| |binary|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@queue_server| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSset_subscription_properties\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSset_subscription_properties\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSset_subscription_properties 
(
    @publisher      sysname,            -- publishing server name
    @publisher_db   sysname,          -- publishing database name. If NULL then same as current db
    @publication    sysname,          -- publication name,
    @subscription_type int,
    @allow_subscription_copy bit,
    @queue_id sysname,
    @update_mode int,
    @attach_version binary(16),
    @queue_server sysname = NULL
)
AS
BEGIN
    set nocount on
    declare @retcode int
                ,@failover_mode bit

    --  Security Check
    EXEC @retcode = sys.sp_MSreplcheck_subscribe
    IF @@ERROR &lt;&gt; 0 or @retcode &lt;&gt; 0
        RETURN(1)

    -- For non independent agent publications
    if @publication is null or @publication = ''
        set @publication = 'ALL'

    if @queue_server = N''
        select @queue_server = NULL

    if @queue_id = N''
        select @queue_id = NULL

    --
    -- Failover mode is overloaded in @update_mode
    -- Get the proper values for failover_mode and update_mode
    --
    if (@update_mode in (6,7))
    begin
        -- Failover with Queued as the default mode
        if (@update_mode = 6)
        begin
            -- sql queues
            select @update_mode = 5
                     ,@failover_mode = 1
        end
        else
        begin
            -- MQ queues
            select @update_mode = 3
                     ,@failover_mode = 1
        end
    end
    else
    begin
        -- for all other cases, failover_mode should be initialized to 0
        select @failover_mode = 0
    end
    --
    -- Update metadata in MSsubscription_agents
    --
    update dbo.MSsubscription_agents set      
        allow_subscription_copy = @allow_subscription_copy,
        update_mode = @update_mode,
        failover_mode = @failover_mode,
        queue_id = @queue_id,
        queue_server = @queue_server,
        attach_version = @attach_version
    where UPPER(publisher) = UPPER(@publisher)
        and publisher_db =  @publisher_db
        and publication = @publication
        and subscription_type = @subscription_type
    --
    -- for queued pull subscriptions 
    -- update column update_mode in MSreplication_subscriptions
    -- as we never know the right update_mode until initialization
    --
    if ((@subscription_type = 1) and (@queue_id IS NOT NULL) and
    exists (select * from MSreplication_subscriptions 
        WHERE UPPER(publisher) = UPPER(@publisher) AND
            publisher_db  = @publisher_db AND
            publication = @publication AND
            subscription_type = @subscription_type))
    begin
        update MSreplication_subscriptions 
        set update_mode = @update_mode
        WHERE UPPER(publisher) = UPPER(@publisher) AND
            publisher_db  = @publisher_db AND
            publication = @publication AND
            subscription_type = @subscription_type
    end
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

