## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_sqlagent_help_jobstep\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_sqlagent_help_jobstep**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -719582923 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@job_id| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|step_id|int|4|
|step_name|nvarchar|128|
|subsystem|nvarchar|40|
|command|nvarchar|2147483647|
|flags|int|4|
|cmdexec_success_code|int|4|
|on_success_action|tinyint|1|
|on_success_step_id|int|4|
|on_fail_action|tinyint|1|
|on_fail_step_id|int|4|
|server|nvarchar|128|
|database_name|nvarchar|128|
|database_user_name|nvarchar|128|
|retry_attempts|int|4|
|retry_interval|int|4|
|os_run_priority|int|4|
|output_file_name|nvarchar|200|
|last_run_outcome|int|4|
|last_run_duration|int|4|
|last_run_retries|int|4|
|last_run_date|int|4|
|last_run_time|int|4|
|(No column name)|int|4|

---
### Objects that depend on \[sys\].\[sp_sqlagent_help_jobstep\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_sqlagent_help_jobstep\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE sys.sp_sqlagent_help_jobstep 
  @job_id                UNIQUEIDENTIFIER
AS
BEGIN
    DECLARE @job_id_as_char VARCHAR(36)
    DECLARE @retval INT

    -- Validate if current db context is supported
    EXEC @retval = sys.sp_sqlagent_verify_database_context
    IF (@retval &lt;&gt; 0)
    BEGIN
        RETURN(@retval)
    END

    -- If  job_id is null, then throw validation error
    IF(@job_id IS NULL)
    BEGIN
        RAISERROR(14262, -1, -1, '@job_id', 'NULL')
        RETURN(1) --Failure
    END

    -- Validate if given job_id exists in agent_jobs
    IF NOT EXISTS (SELECT name
                FROM sys.sqlagent_jobs
                WHERE job_id = @job_id)
    BEGIN
        SET @job_id_as_char = CONVERT(VARCHAR(36), @job_id)
        RAISERROR(14262, -1, -1, '@job_id', @job_id_as_char)
        RETURN(1) -- Failure
    END

     -- Select the system job's steps
    SELECT step_id,
        step_name,
        subsystem,
        command,
        flags,
        cmdexec_success_code,
        on_success_action,
        on_success_step_id,
        on_fail_action,
        on_fail_step_id,
        [server],
        database_name,
        database_user_name,
        retry_attempts,
        retry_interval,
        os_run_priority,
        output_file_name,
        last_run_outcome,
        last_run_duration,
        last_run_retries,
        last_run_date,
        last_run_time,
        NULL
    FROM sys.sqlagent_jobsteps
    WHERE (job_id = @job_id)
    ORDER BY job_id, step_id

    RETURN(0) -- Success
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

