## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_help_datatype_mapping\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_help_datatype_mapping**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -721021307 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@dbms_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@dbms_version| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@sql_type| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_prec| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|sql_type|nvarchar|128|
|sql_len_min|bigint|8|
|sql_len_max|bigint|8|
|sql_prec_min|bigint|8|
|sql_prec_max|bigint|8|
|sql_scale_min|int|4|
|sql_scale_max|int|4|
|sql_nullable|bit|1|
|sql_createparams|int|4|
|dest_type|nvarchar|128|
|dest_len|bigint|8|
|dest_prec|bigint|8|
|dest_scale|int|4|
|dest_nullable|bit|1|
|dest_createparams|int|4|
|dataloss|bit|1|

---
### Objects that depend on \[sys\].\[sp_help_datatype_mapping\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_help_datatype_mapping\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_help_datatype_mapping
(
    @dbms_name        sysname,
    @dbms_version     sysname = NULL,
    @sql_type        sysname = '%',
    @source_prec    int = NULL
)
as
    set nocount on
    
    -- Prepare dbms for case insensitive searches
    SET @dbms_name = UPPER(@dbms_name)
    
    SELECT    source_type                as [sql_type],
            source_length_min        as [sql_len_min],
            source_length_max        as [sql_len_max],
            source_precision_min    as [sql_prec_min],
            source_precision_max    as [sql_prec_max],
            source_scale_min        as [sql_scale_min],
            source_scale_max        as [sql_scale_max],
            source_nullable            as [sql_nullable],
            source_createparams        as [sql_createparams],                
            destination_type        as [dest_type],
            destination_length        as [dest_len],
            destination_precision    as [dest_prec],
            destination_scale        as [dest_scale],
            destination_nullable    as [dest_nullable],
            destination_createparams as [dest_createparams],
            dataloss                as [dataloss]
    FROM    sys.fn_helpdatatypemap
            (
                N'MSSQLSERVER',
                '%',
                @sql_type,
                @dbms_name,
                '%',
                '%',
                0
            )
    WHERE    source_dbms            = 'MSSQLSERVER' collate database_default
      AND    source_version IS NULL
      AND    destination_dbms    = @dbms_name collate database_default
      AND    ((destination_version = @dbms_version) OR (@dbms_version IS NULL AND destination_version IS NULL))
      AND    source_type like @sql_type collate database_default
    ORDER BY source_type, destination_type
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

