## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_get_job_status_mergesubscription_agent\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_get_job_status_mergesubscription_agent**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -723059186 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@agent_name| |nvarchar|100|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_get_job_status_mergesubscription_agent\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_get_job_status_mergesubscription_agent\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_get_job_status_mergesubscription_agent
(
    @publisher      sysname = NULL,
    @publisher_db   sysname = NULL,
    @publication    sysname = NULL,
    @agent_name nvarchar(100) = NULL   
)
as
begin    
    set nocount on
    declare @retcode  int
    declare @isdistdb bit    
    declare @runstatus int  
    
    select @isdistdb = sys.fn_MSrepl_isdistdb(DB_NAME())

    --
    -- security check
    --
    if (@isdistdb = 1)
    begin
        if not (is_member(N'db_owner') = 1 or isnull(is_member(N'replmonitor'),0) = 1)
        begin
            raiserror(14260, 16, -1)
            return (1)
        end
    end
    else
    begin
        if not (is_member(N'db_owner') = 1)
        begin
            raiserror(14260, 16, -1)
            return (1)
        end
    end


    
        
    if @isdistdb = 1 and @agent_name is null
    begin
        raiserror(14043, 16, -1, '@agent_name', 'sp_get_job_status_mergesubscription_agent')
        return 1
    end
    else if @isdistdb = 0 and (@publisher is null or @publisher_db is null or @publication is null)
    begin
        -- subscriber-side monitoring
        if @publisher is null
            raiserror(14043, 16, -1, '@publisher', 'sp_get_job_status_mergesubscription_agent')
        if @publisher_db is null
            raiserror(14043, 16, -1, '@publisher_db', 'sp_get_job_status_mergesubscription_agent')
        if @publication is null
            raiserror(14043, 16, -1, '@publication', 'sp_get_job_status_mergesubscription_agent')
        return 1
    end    

    if(@isdistdb = 1)
    begin
        exec @retcode = sp_get_job_status_mergepushsubscription_agent @agent_name,@runstatus=@runstatus output 
    end    
    else
    begin
        exec @retcode = sp_get_job_status_mergepullsubscription_agent 
                       @publisher=@publisher,
                       @publisher_db=@publisher_db,
                       @publication=@publication,
                       @runstatus=@runstatus output 
    end

    select @runstatus

    return @retcode
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

