## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_help_fulltext_catalog_components\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_help_fulltext_catalog_components**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -72338227 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
 No parameters exist

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|name|nvarchar|128|
|ftcatid|int|4|
|componenttype|nvarchar|128|
|componentname|nvarchar|128|
|clsid|uniqueidentifier|16|
|fullpath|nvarchar|260|
|version|nvarchar|128|
|manufacturer|nvarchar|128|

---
### Objects that depend on \[sys\].\[sp_help_fulltext_catalog_components\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_help_fulltext_catalog_components\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_help_fulltext_catalog_components
as
    -- FULLTEXT MUST BE ACTIVE IN DATABASE --
    if DatabasePropertyEx(db_name(), 'IsFulltextEnabled') = 0
    begin
        raiserror(15601,-1,-1)
        return 1
    end

    -- dump all full-text components used in this database
    select ftcat.name, ftcat.fulltext_catalog_id as ftcatid, componenttype, componentname, clsid, 
          (case when is_srvrolemember('serveradmin') = 1 then fullpath else NULL end) AS [fullpath], 
           version, manufacturer 
    from sys.fulltext_catalogs as ftcat cross apply sys.fn_ftcatcomponents(0, db_id(), ftcat.file_id) as ftcomp
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

