## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_sqlagent_log_job_history\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_sqlagent_log_job_history**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -724648924 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@job_id| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@step_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@sql_message_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@sql_severity| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@message| |nvarchar|4000|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@run_status| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@run_date| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@run_time| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@run_duration| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@operator_id_emailed| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@operator_id_paged| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@retries_attempted| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_sqlagent_log_job_history\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_sqlagent_log_job_history\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE sys.sp_sqlagent_log_job_history
    @job_id               UNIQUEIDENTIFIER,
    @step_id              INT,
    @sql_message_id       INT = 0,
    @sql_severity         INT = 0,
    @message              NVARCHAR(4000) = NULL,
    @run_status           INT, 
    @run_date             INT,
    @run_time             INT,
    @run_duration         INT,
    @operator_id_emailed  INT = 0,
    @operator_id_paged    INT = 0,
    @retries_attempted    INT
AS
BEGIN
    DECLARE @retval INT

    -- Validate if current db context is supported
    EXEC @retval = sys.sp_sqlagent_verify_database_context
    IF (@retval &lt;&gt; 0)
    BEGIN
        RETURN(@retval)
    END

    -- If  job_id is null, then throw validation error
    IF(@job_id IS NULL)
    BEGIN
        RAISERROR(14262, -1, -1, '@job_id', 'NULL')
        RETURN(1) --Failure
    END

    -- Validate if given job_id exists in agent_jobs
    IF NOT EXISTS (SELECT name
                FROM sys.sqlagent_jobs
                WHERE job_id = @job_id)
    BEGIN
        DECLARE @job_id_as_char VARCHAR(36)
        SET @job_id_as_char = CONVERT(VARCHAR(36), @job_id)
        RAISERROR(14262, -1, -1, '@job_id', @job_id_as_char)
        RETURN(1) -- Failure
    END

    INSERT INTO sys.sqlagent_job_history
    (
        job_id,
        step_id,
        sql_message_id,
        sql_severity,
        [message],
        run_status,
        run_date,
        run_time,
        run_duration,
        operator_id_emailed,
        operator_id_paged,
        retries_attempted
    )
    VALUES (
        @job_id,
        @step_id,
        @sql_message_id,
        @sql_severity,
        @message,
        @run_status,
        @run_date,
        @run_time,
        @run_duration,
        @operator_id_emailed,
        @operator_id_paged,
        @retries_attempted
    )
  
    SET @retval = @@ERROR

    RETURN(@retval) -- 0 means success 
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

