## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MScheck_dropobject\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MScheck_dropobject**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 06/15/2019 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -725526697 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@objid| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MScheck_dropobject\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MScheck_dropobject\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MScheck_dropobject
(
    @objid int
)
as
begin
    declare @retcode int

    if exists (SELECT * FROM dbo.sysextendedarticlesview WHERE objid = @objid)
    begin
        --  Security Check
        EXEC @retcode = sys.sp_MSreplcheck_publish
        IF @@ERROR &lt;&gt; 0 or @retcode &lt;&gt; 0
            return 1
    end

    -- Look for the replication articles, referring to a subject table, whose publication doesn't have
    -- @OPT_ALLOW_DROP = 0x80 bit set, what should block drop of subject table.
    -- Keep shared locks to avoid add of new articles and possible changes to publication options during drop table.
    select @retcode = count(*) from sysarticles sa with(HOLDLOCK)
    join syspublications sp with(HOLDLOCK) on sa.pubid = sp.pubid and sa.objid = @objid and (sp.options &amp; 0x80) &lt;&gt; 0x80

    return @retcode
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

