## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_helprolemember\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_helprolemember**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -73307518 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@rolename| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|DbRole|nvarchar|128|
|MemberName|nvarchar|128|
|MemberSID|varbinary|85|

|Name |Datatype |Max length |
|-|-|-|
|DbRole|nvarchar|128|
|MemberName|nvarchar|128|
|MemberSID|varbinary|85|

---
### Objects that depend on \[sys\].\[sp_helprolemember\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_helprolemember\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_helprolemember
    @rolename       sysname = NULL
AS
    if @rolename is not null
    begin
        -- VALIDATE GIVEN NAME
        if not exists (select * from sysusers where name = @rolename and issqlrole = 1)
        begin
            raiserror(15409, -1, -1, @rolename)
            return (1)
        end

        -- RESULT SET FOR SINGLE ROLE
        select DbRole = g.name, MemberName = u.name, MemberSID = u.sid
            from sys.database_principals u, sys.database_principals g, sys.database_role_members m
            where g.name = @rolename
                and g.principal_id = m.role_principal_id
                and u.principal_id = m.member_principal_id
            order by 1, 2
    end
    else
    begin
        -- RESULT SET FOR ALL ROLES
        select DbRole = g.name, MemberName = u.name, MemberSID = u.sid
            from sys.database_principals u, sys.database_principals g, sys.database_role_members m
            where   g.principal_id = m.role_principal_id
                and u.principal_id = m.member_principal_id
            order by 1, 2
    end

    return (0) -- sp_helprolemember
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

