## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSdropobsoletearticle\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSdropobsoletearticle**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 06/15/2019 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -736112879 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@artid| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@ignore_distributor| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@force_invalidate_snapshot| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSdropobsoletearticle\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSdropobsoletearticle\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSdropobsoletearticle
(
    @artid int = null,
    @ignore_distributor bit = 0,
    @force_invalidate_snapshot bit = 1
)
as
begin
    declare @retcode int = 0
    declare @article sysname
    declare @publication sysname

    -- security check - should be dbo or sysadmin
    exec @retcode = sp_MSreplcheck_publish_withddladmin
    if @@ERROR != 0 or @retcode != 0 return 1

    select top 1 @article = sa.name, @publication = sp.name
        from sysarticles sa join syspublications sp on sa.pubid = sp.pubid
        where sp.options &amp; 0x80 = 0x80 and sa.objid is not null and object_name(sa.objid) is null and (sa.artid = @artid or @artid is null)
    while @@rowcount = 1 and @retcode = 0 begin
        exec @retcode = sp_dropsubscription @publication = @publication, @article = @article, @subscriber = 'all', @ignore_distributor = @ignore_distributor
        if @retcode &lt;&gt; 0 break
        exec @retcode = sp_droparticle @publication = @publication, @article = @article, @force_invalidate_snapshot = @force_invalidate_snapshot, @ignore_distributor = @ignore_distributor
        select top 1 @article = sa.name, @publication = sp.name
            from sysarticles sa join syspublications sp on sa.pubid = sp.pubid
            where sp.options &amp; 0x80 = 0x80 and sa.objid is not null and object_name(sa.objid) is null and (sa.artid = @artid or @artid is null)
    end
        
    return @retcode
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

