## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSupdatesysmergearticles\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSupdatesysmergearticles**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -737902475 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@object| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@artid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@owner| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@pubid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@recreate_repl_view| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSupdatesysmergearticles\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSupdatesysmergearticles\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
-- in yukon this proc should never be called with the identity range
-- parameters being set.
create procedure sys.sp_MSupdatesysmergearticles(
    @object                 sysname,                /* Name of the table */
    @artid                  uniqueidentifier,       /* Article ID */
    @owner                  sysname             = NULL,
    @pubid                  uniqueidentifier    = NULL,
    @recreate_repl_view     bit = 1
) AS
    declare @merge_pub_object_bit   int
    declare @id                     int
    declare @qualified_name         nvarchar(270)
    declare @colid                  int
    declare @colname                sysname
    declare @dynamic_filters        bit
    declare @mergepublish           int
    declare @retcode int
    declare @objid int
    
    SET NOCOUNT ON
    
    /*
    ** Check for subscribing permission
    */
    exec @retcode=sys.sp_MSreplcheck_subscribe
    if @retcode&lt;&gt;0 or @@ERROR&lt;&gt;0 return (1)

    set @dynamic_filters=0
    if @owner is NULL or @owner = ''
    begin
        if object_id(@object) is not NULL
            select @owner = SCHEMA_NAME(schema_id) from sys.objects where object_id = object_id(QUOTENAME(@object))
        else 
        begin
            raiserror(21078, 16, -1, @object)
            return (1)
        end
    end

    select @mergepublish = 0x4000
    
    select @qualified_name = QUOTENAME(@owner) + '.' + QUOTENAME(@object)
    select @objid = object_id(@qualified_name)
        
    select @merge_pub_object_bit    = 128

    if (@artid is NULL)
    BEGIN
        RAISERROR (14057, 16, -1)
        RETURN (1)
    END
    begin tran
    save tran sp_MSupdatesysmergearticles
    
    if exists (select name from sys.objects where object_id = @objid)
    begin

        exec %%Object(MultiName=@qualified_name).LockMatchID(ID=@objid, Exclusive = 1, BindInternal = 0)
        --exec %%Object(MultiName=@qualified_name).LockExclusiveMatchID(ID=@objid)
        if @@error&lt;&gt;0 goto UNDO
        exec %%Relation(ID=@objid).SetMergePublished(Value=1,SetColumns=1)
        if @@ERROR&lt;&gt;0 goto UNDO

        /*
        ** update dbo.sysmergearticles.objid for all articles sharing the same base table
        */
        update dbo.sysmergearticles set objid = @objid where artid = @artid
        IF @@ERROR &lt;&gt; 0
        BEGIN
            RAISERROR (14057, 16, -1)
            goto UNDO
        END

        /*
        ** update dbo.sysmergearticles.sysnc_objid for only the article in this publication
        ** and for articles that no longer has a valid sync_objid (usually for the
        ** non-filtered case)
        */
        update dbo.sysmergearticles set sync_objid=@objid 
         where artid = @artid 
           and (pubid = @pubid or 
                (object_name(sync_objid) is null and isnull(view_type,0) = 0))
        IF @@ERROR &lt;&gt; 0
        BEGIN
            RAISERROR (14057, 16, -1)
            goto UNDO
        END

        if @recreate_repl_view = 1
        begin
            exec @retcode = sys.sp_MScreate_article_repl_view @pubid, @artid
            if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
                goto UNDO
        end
    end
    else -- THIS IS FINE. This dynamic query is there to provide a good error message. No need to use SP.
        raiserror(21078, 16, -1, @object)
        
    exec sys.sp_replupdateschema @qualified_name
    if @@error&lt;&gt;0 goto UNDO

    commit tran
    RETURN 0
UNDO:
    rollback tran sp_MSupdatesysmergearticles
    commit tran
    RETURN 1
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

