## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSfillupmissingcols\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSfillupmissingcols**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -738312993 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_table| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSfillupmissingcols\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSfillupmissingcols\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_MSfillupmissingcols(@publication sysname, @source_table sysname)
AS
declare @sync_objid         int
declare @missingcolid        int
declare @missing_cols        varbinary(128)
declare @excludedcolid        int
declare @excludedbm            varbinary(128)
declare @excludedcolcnt        int
declare @missing_col_count    int
declare @maxcolid            int
declare @column_tracking    bit
declare @id                    int
declare @pubid                uniqueidentifier
declare @missingindex        int
declare @retcode            int
declare @missing_index_absolute int

-- Security check
exec @retcode= dbo.sp_MSreplcheck_publish
if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0 return (1)

select @id = object_id(@source_table)
select @excludedcolcnt = 0
select @pubid=pubid from dbo.sysmergepublications where name=@publication and publisher=publishingservername() and publisher_db=db_name()
select @sync_objid=sync_objid from dbo.sysmergearticles where objid = @id and pubid=@pubid
select @excludedbm = 0x00
select @missingcolid = 1 --instead of using the minimal column_id in sys.columns with the same id, as we used to do 
select TOP 1 @maxcolid = column_id from sys.columns where object_id=@id order by column_id DESC
 
-- check if this is a republisher. If it is then pick the missing_cols value from the row for the subscriber.
select @missing_cols = missing_cols, 
       @missing_col_count = missing_col_count
    from dbo.sysmergearticles where objid=@id and pubid&lt;&gt;@pubid and sys.fn_MSmerge_islocalpubid(pubid)=0

if @missing_cols is null
begin
    select @missing_cols = missing_cols, 
        @missing_col_count = missing_col_count
        from dbo.sysmergearticles where objid = @id and pubid=@pubid
end

while (@missingcolid &lt;= @maxcolid)
begin
    if exists (select * from sys.columns where column_id = @missingcolid and object_id = @id and 
                is_computed &lt;&gt; 1 and system_type_id &lt;&gt; type_id('timestamp') and
                name not in (select name from sys.columns where object_id = @sync_objid))
    begin
        select @excludedcolcnt = @excludedcolcnt + 1
        select @missingindex = count(*) from sys.columns where object_id=@id and column_id&lt;=@missingcolid and is_computed &lt;&gt; 1 and system_type_id &lt;&gt; type_id('timestamp')

        -- Get the absolute index of the excluded column by taking into consideration the
        -- missing column bitmask.
        exec sys.sp_MSget_absolute_colid @missing_cols, @missingindex, @missing_index_absolute OUTPUT
        
        exec sys.sp_MSsetbit @excludedbm OUTPUT, @missing_index_absolute
    end
    set @missingcolid = @missingcolid + 1
end

UPDATE dbo.sysmergearticles set excluded_col_count = @excludedcolcnt, 
                            excluded_cols = @excludedbm,
                            missing_col_count = @missing_col_count,
                            missing_cols = @missing_cols
        where objid = @id and pubid=@pubid
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

