## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSloginmappings\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSloginmappings**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -73900266 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@loginname| |nvarchar|258|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@flags| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSloginmappings\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSloginmappings\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO



create proc sys.sp_MSloginmappings
    @loginname nvarchar(258) = null, @flags int = 0
as

    create table #loginmappings(
        LoginName  nvarchar(128) NULL,
        DBName     nvarchar(128) NULL,
        UserName   nvarchar(128) NULL,
        AliasName  nvarchar(128) NULL
    )

    /*
     * @flags bits:
     *        0x01    - current db only
     */
    /*
     * Added @dbname so dbo can see everyone in current database.
     * Use hacky 4.21 syntax so it will run there, instead of a case..when.
     */
    declare @checkmultilogin int
    select @checkmultilogin = 1
    if ((@flags &amp; 0x01 &lt;&gt; 0) and user_id() = 1)
        select @checkmultilogin = 0

    declare @logincount int
    select @logincount = 0
    if (@loginname is not null)
        select @logincount = count(*) from dbo.syslogins where loginname = @loginname

    /* Gotta be sa or dbo to see other than just current login. */
    declare @numlogins int, @whereloginname nvarchar(258), @name nvarchar(258), @retval int
    if (@loginname is null)
        select @numlogins = 2
    else
        select @numlogins = count(*) from dbo.syslogins where loginname = @loginname

    if (@numlogins = 0) begin
        RAISERROR (15007, -1, -1, @loginname)        /* Login not found */
        return 1
    end
    if (@checkmultilogin &lt;&gt; 0) begin
      /* We do not want to allow everybody to execute this SP */
        if (is_member(N'db_ddladmin') &lt;&gt; 1 and is_member(N'db_owner') &lt;&gt; 1 and is_member(N'db_accessadmin') &lt;&gt; 1 and is_member(N'db_securityadmin') &lt;&gt; 1 and (@numlogins &gt; 1 or suser_sid() &lt;&gt; suser_sid(@loginname))) begin
            RAISERROR (14301, -1, -1, N'')                /* Only sa can see other than the current login */
            return 1
        end
    end
    if (@loginname is not null)
        select @whereloginname = N' and loginname = ' + QUOTENAME(@loginname, '''')
   else
      select @whereloginname = N' '

    /*
     * This proc returns a result set with one or more rows for each database for which a login is a user or aliased to one.
     * If loginname is specified, the results are limited to that login.  First load a temp table with all logins that are
     * in a db, then add those which aren't mapped to any db.
     */
    if (@flags &amp; 0x01 &lt;&gt; 0) begin
        INSERT #loginmappings select l.loginname, db_name(), u.name, null from master.dbo.syslogins l, dbo.sysusers u where l.sid = u.sid and l.loginname is not NULL
        /*
         * We only allow multi-db on a 6.x server because dynamic exec() didn't exist before then,
         * hence there is no way to loop thru every database.  This is caught in SQLDMO so no
         * need for error message here; we'll just return no result sets.
         */
    end else begin
        exec @retval = sys.sp_MSforeachdb
            N'use [?] INSERT #loginmappings select l.loginname, db_name(), u.name, null from master.dbo.syslogins l, dbo.sysusers u where l.sid = u.sid and l.loginname is not NULL'
        if (@retval &lt;&gt; 0)
            return 1
        insert #loginmappings select l.loginname, null, null, null from master.dbo.syslogins l where l.loginname not in (select LoginName from #loginmappings) and l.loginname is not NULL
    end

    /*
     * Now bring them out by loginname, each in its own result set.
     * If this is for all logins, we'll return all logins; if for curdb,
     * only those in #loginmappings (i.e. only those mapped in curdb).
     */
    exec(N'declare hCForEachLogin cursor global for select loginname from master.dbo.syslogins where loginname is not NULL ' + @whereloginname + N' order by loginname')
    if (@@error = 0)
        open hCForEachLogin
    if (@@error &lt;&gt; 0)
        return @@error
    fetch hCForEachLogin into @name
    while (@@fetch_status &gt;= 0) begin
      /* Use '=' instead of 'LIKE' in comparision, so we can handle wide card character correctly */
        if ((@flags &amp; 0x01 = 0) or exists (select * from #loginmappings where LoginName = @name))
            select * from #loginmappings where LoginName = @name
        fetch hCForEachLogin into @name
    end /* FETCH_SUCCESS */
    close hCForEachLogin
    deallocate hCForEachLogin
    return @@error
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

