## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSchange_retention_period_unit\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSchange_retention_period_unit**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -741697557 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@pubid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@value| |tinyint|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSchange_retention_period_unit\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSchange_retention_period_unit\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSchange_retention_period_unit (@pubid uniqueidentifier, @value tinyint)
as
    declare @re_pubid            uniqueidentifier 
    declare @artid                uniqueidentifier
    declare @schemaversion      int 
    declare @schemaguid         uniqueidentifier
    declare @schematype         int
    declare @schematext         nvarchar(2000)
    declare @retcode            int
    declare @SCHEMA_TYPE_RETENTIONUNITCHANGE int

    -- Security check
    exec @retcode = dbo.sp_MSreplcheck_subscribe
    if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
        return 1

    set @SCHEMA_TYPE_RETENTIONUNITCHANGE= 29
    
    begin tran
    save tran change_retention_pu

    update dbo.sysmergepublications set retention_period_unit = @value where pubid = @pubid
    if @@ERROR&lt;&gt;0
        goto UNDO
        
    -- Declare a cursor that iterates over all publications which originate at this node.
    declare #change_retention_period_unit CURSOR LOCAL FAST_FORWARD for 
        select pubid from dbo.sysmergearticles 
            where pubid&lt;&gt;@pubid and 
                  nickname in (select nickname from dbo.sysmergearticles where pubid=@pubid) and
                  pubid in (select pubid from dbo.sysmergepublications 
                                  where upper(publisher) collate database_default = upper(publishingservername()) collate database_default and
                                        publisher_db = db_name())

    open #change_retention_period_unit
    fetch #change_retention_period_unit into @re_pubid
    while (@@fetch_status &lt;&gt; -1)
    BEGIN
        update dbo.sysmergepublications set retention_period_unit = @value where pubid = @re_pubid
        if @@ERROR&lt;&gt;0
            goto UNDO
        set @schematype= @SCHEMA_TYPE_RETENTIONUNITCHANGE
        set @artid = null
        select @schematext = 'exec dbo.sp_MSchange_retention_period_unit '+ '''' + convert(nchar(36),@re_pubid) + '''' + ',' + convert(nvarchar, @value)        
        select @schemaversion = schemaversion from dbo.sysmergeschemachange
        if (@schemaversion is NULL)
            set @schemaversion = 1
        else
            select @schemaversion = 1 + max(schemaversion) from dbo.sysmergeschemachange        
        set @schemaguid = newid()
        exec @retcode=sys.sp_MSinsertschemachange @re_pubid, @artid, @schemaversion, @schemaguid, @schematype, @schematext
        if @@ERROR&lt;&gt;0 or @retcode&lt;&gt;0 
            goto UNDO
        fetch #change_retention_period_unit into @re_pubid
    END
    close #change_retention_period_unit
    deallocate #change_retention_period_unit
    
    COMMIT TRAN
    return (0)
UNDO:
    ROLLBACK tran change_retention_pu
    COMMIT TRAN
    return(1)
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

