## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MScleanup_conflict\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MScleanup_conflict**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -749498974 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@pubid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@conflict_retention| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MScleanup_conflict\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MScleanup_conflict\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_MScleanup_conflict
@pubid                    uniqueidentifier,
@conflict_retention int = NULL
AS
    declare @pubname            sysname
    declare @valid_date            datetime
    declare @conflict_table        nvarchar(512)
    declare @conflict_id        int
    declare @retention_string        nvarchar(100)
    declare @pubidstr            nvarchar(100)
    declare @retcode            int
    
    --if no conflict_retention value is specified, query local table and find out.
    if @conflict_retention is NULL
        select @conflict_retention=conflict_retention from dbo.sysmergepublications where pubid=@pubid

    --do not do any cleanup if conflict retention value is 0
    else if @conflict_retention = 0
        return (0)

    select @pubname=name from dbo.sysmergepublications where pubid=@pubid
    select @pubidstr = convert(nvarchar(40), @pubid)
    select @valid_date = dateadd(day, -@conflict_retention, getdate())
    select @retention_string = convert(nvarchar, @conflict_retention)
    /*
    ** Security Check
    */
    EXEC @retcode = sys.sp_MSreplcheck_publish
    IF @@ERROR &lt;&gt; 0 or @retcode &lt;&gt; 0
            return (1)
    
    declare AC CURSOR LOCAL FAST_FORWARD for select conflict_table from dbo.sysmergearticles where pubid=@pubid
    open AC
    fetch AC into @conflict_table
    while (@@fetch_status&lt;&gt;-1)
    begin
        if @conflict_table is NOT null
            begin

            select @conflict_id = object_id(@conflict_table)
            select @conflict_table=QUOTENAME(@conflict_table)

            if @conflict_id is not NULL and @retention_string is not NULL 
                    begin
                        exec ('delete from ' + @conflict_table + ' from ' + @conflict_table + ' ct , MSmerge_conflicts_info info where 
                            ct.rowguidcol = info.rowguid and ct.origin_datasource_id=info.origin_datasource_id and 
                            datediff(dd, info.MSrepl_create_time, getdate()) &gt; ' + @retention_string 
                            + ' and info.pubid = ''' + @pubidstr + '''')
                        if @@ERROR&lt;&gt;0
                            goto FAILURE
                        exec ('delete from MSmerge_conflicts_info where datediff(dd, MSrepl_create_time, getdate()) &gt; ' + @retention_string 
                            + ' and pubid = ''' + @pubidstr + '''')
                        if @@ERROR&lt;&gt;0
                            goto FAILURE
                    end
            end
        fetch next from AC into @conflict_table
    end
    close AC
    deallocate AC
    return (0)
FAILURE:
    close AC
    deallocate AC
    raiserror(20709, 16, -1, @conflict_table, @pubname);
    return (1)
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

