## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSpeerconflictdetection_topology_applyresponse\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSpeerconflictdetection_topology_applyresponse**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -753071350 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@request_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@peer_node| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@peer_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@peer_version| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@peer_subscriptions| |nvarchar|1073741823|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSpeerconflictdetection_topology_applyresponse\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSpeerconflictdetection_topology_applyresponse\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSpeerconflictdetection_topology_applyresponse (
    @request_id    int,
    @peer_node    sysname, 
    @peer_db    sysname,
    @peer_version    int,
    @peer_subscriptions nvarchar(max) --list of (sub_node, sub_db) in XML format
)
as
begin

    -- security check - should be dbo or sysadmin
    declare @retcode int
    exec @retcode = sp_MSreplcheck_subscribe
    if @@ERROR != 0 or @retcode != 0
        return

    if not exists (select * from MSpeer_conflictdetectionconfigrequest where id = @request_id) --request does not exists
        return

    begin tran 
    save tran tr_topology_applyresponse

    --@peer_subscriptions is extended to contain the root: /peer_subs
       select @peer_subscriptions = N'&lt;peer_subs&gt;' + @peer_subscriptions + N'&lt;/peer_subs&gt;' 
    
    begin try
        insert MSpeer_conflictdetectionconfigresponse (request_id, peer_node, peer_db, peer_version, is_peer, peer_subscriptions, progress_phase)
        values (@request_id, @peer_node, @peer_db, @peer_version, 1, convert(xml, @peer_subscriptions), N'peer version collected')
    end try
    begin catch
           if @@error in (2627, 2601)  ---primary key/unique violation
           begin
                  update MSpeer_conflictdetectionconfigresponse
            set    peer_version = @peer_version,
                is_peer = 1,
                peer_subscriptions = @peer_subscriptions,
                progress_phase = N'peer version collected',
                modified_date = GETDATE()
            where request_id = @request_id
                and peer_node = @peer_node
                and peer_db = @peer_db
                and progress_phase = N'started'
                
            if @@error &lt;&gt; 0
                goto UNDO
           end
           else
               goto UNDO
       end catch

       --incorporate subscribers into MSpeer_conflictdetectionconfigresponse
    declare @DocHandle int
    exec sp_xml_preparedocument @DocHandle OUTPUT, @peer_subscriptions
    if @@error &lt;&gt; 0
        goto UNDO
    
    insert MSpeer_conflictdetectionconfigresponse (request_id, peer_node, peer_db, progress_phase)
    select @request_id, sub_node, sub_db, N'started'
    from (    select  *
             from OPENXML (@DocHandle, N'/peer_subs/sub', 1)
             with (sub_node sysname, sub_db sysname)
         ) A
     where not exists (select * from MSpeer_conflictdetectionconfigresponse
                     where request_id = @request_id and peer_node = A.sub_node and peer_db = A.sub_db)
    
    if @@error &lt;&gt; 0
        goto UNDO

    exec sp_xml_removedocument @DocHandle
    if @@error &lt;&gt; 0
        goto UNDO

       commit tran
       return 

UNDO:
    rollback tran tr_topology_applyresponse
    commit tran
    return
end 
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

