## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_marksubscriptionvalidation\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_marksubscriptionvalidation**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -75314183 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscriber| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@destination_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_marksubscriptionvalidation\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_marksubscriptionvalidation\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_marksubscriptionvalidation (
    @publication sysname,    /* publication name */
    @subscriber sysname,     /* subscriber name */
    @destination_db sysname,  /* destination database name */
    @publisher sysname = NULL /* publisher */
)
AS
BEGIN
    DECLARE @cmd            nvarchar(4000)
    DECLARE @retcode        int
    DECLARE @publisher_type    sysname

    SET @retcode = 0
    
    /* 
    ** Security Check.
    */
    exec @retcode = sys.sp_MSreplcheck_publish
    if @@ERROR &lt;&gt; 0 or @retcode &lt;&gt; 0
        return(1)
    
    EXEC @retcode = sys.sp_MSrepl_getpublisherinfo    @publisher      = @publisher,
                                                    @publisher_type    = @publisher_type OUTPUT,
                                                    @rpcheader      = @cmd OUTPUT
    
    IF @retcode &lt;&gt; 0
        RETURN (@retcode)

    if (@publisher_type = 'MSSQLSERVER')
    begin
        
        set @cmd = @cmd + N'sys.sp_MSmarksubscriptionvalidation '
        EXEC @retcode = @cmd
                @publication,
                @subscriber,
                @destination_db
    end
    else
    begin
        -- Heterogeneous articles are handled directly
        SET @publisher = UPPER(@publisher) COLLATE DATABASE_DEFAULT
        set @cmd = @cmd + N'sys.sp_IHmarksubscriptionvalidation '
        EXEC @retcode = @cmd
                @publication,
                @subscriber,
                @destination_db,
                @publisher,
                @publisher_type
    end    

    RETURN (@retcode)
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

