## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MShelpsummarypublication\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MShelpsummarypublication**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -758818984 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@oename| |nvarchar|260|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@oetype| |nvarchar|100|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MShelpsummarypublication\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MShelpsummarypublication\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

--
-- Name:    
--        sp_MShelpsummarypublication
--            
-- Description: 
--        Called by Object Explorer to populate the Summary Page
--        for a publication
--
-- Security: 
--        Public, PAL access
--
-- Returns:     
--        0 : success
--        1 : failure          
--

CREATE PROCEDURE sys.sp_MShelpsummarypublication
(
    @oename nvarchar(260),
    @oetype nvarchar(100)
)
AS
BEGIN
    DECLARE    @cmd            nvarchar(1000),
            @publication    sysname,
            @publisher_db    sysname,
            @publisher_type    sysname,
            @pos_pubname    int,
            @pos_pubtype    int,
            @retcode        int

    -- Verify oename parameter
    IF (@oename is null OR LEN(@oename) = 0)
    BEGIN
        RAISERROR(7801, 16, -1, @oename)
        RETURN 1
    END

    SET @pos_pubname = PATINDEX(N'%:%', @oename)
    SET @pos_pubtype = PATINDEX(N'%(%)', @oename)

    SELECT    @publication    = LEFT(@oename, @pos_pubname - 1),
            @publisher_db   = CASE WHEN @pos_pubtype &gt; 0
                                THEN SUBSTRING(@oename, @pos_pubname + 1, @pos_pubtype - @pos_pubname - 1)
                                ELSE SUBSTRING(@oename, @pos_pubname + 1, LEN(@oename) - @pos_pubname)
                              END,
            @publisher_type = CASE WHEN @pos_pubtype &gt; 0
                                THEN SUBSTRING(@oename, @pos_pubtype + 1, LEN(@oename) - @pos_pubtype - 1)
                                ELSE NULL
                              END

    IF (@publication IS NULL OR LEN(@publication) = 0 OR @publisher_db IS NULL OR LEN(@publisher_db) = 0)
    BEGIN
        RAISERROR(21423, 16, -1, @publication) --The security check is later, so we want to raise the more generic error 
        RETURN 1
    END

    --
    -- execute the actual proc in publishing db
    -- security check is done inside
    --

    IF @publisher_type IS NULL OR LEN(@publisher_type) = 0
    BEGIN
        -- SQL Server publication
        SELECT @cmd = QUOTENAME(RTRIM(@publisher_db)) + '.sys.sp_publicationsummary'
        EXEC @retcode = @cmd @publication = @publication
    END
    ELSE
    BEGIN
        -- HREPL publication
        EXEC @retcode = sys.sp_publicationsummary    @publication = @publication,
                                                    @publisher   = @publisher_db
    END

    RETURN @retcode
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

