## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSispeertopeeragent\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSispeertopeeragent**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -759005823 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@agent_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@is_p2p| |int|4|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSispeertopeeragent\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSispeertopeeragent\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSispeertopeeragent
(
    @agent_id     int,
    @is_p2p        int output
)
as
begin
    set nocount on
    
    declare @retcode             tinyint,
            @publisher_db         sysname,
            @publisher_id         int,
            @publication         sysname,
            @num_p2p_pubs int

    declare @OPT_ENABLED_FOR_P2P int

    select @OPT_ENABLED_FOR_P2P = 0x1

    -- security check - the distribution agent must have access
    exec @retcode = sp_MScheck_pull_access @agent_id = @agent_id, @agent_type = 0
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
    begin
        return 1
    end
    
    -- Has to be executed from distribution database
    if sys.fn_MSrepl_isdistdb (db_name()) != 1
    begin
        -- sp_MSispeertopeeragent can only be executed in the distribution database.
        raiserror (21482, 16, -1, 'sp_MSispeertopeeragent', 'distribution')
        return 1
    end

       select @publisher_db     = publisher_db,
            @publisher_id     = publisher_id,
            @publication     = publication
        from MSdistribution_agents 
        where id = @agent_id

    -- find out if there are any PeerToPeer publications for this agent
    if lower(@publication) = 'all'
    begin
        --shared agent (one agent for all publications that go to a single subscriber)
        --Get all the subscriptions for this agent, then find out all the publications
        select @num_p2p_pubs = count(*)
            from dbo.MSsubscriptions mss 
                inner join dbo.MSpublications msp 
                    on mss.publisher_id         = msp.publisher_id
                        and mss.publisher_db     = msp.publisher_db
                        and mss.publication_id     = msp.publication_id
            where mss.agent_id = @agent_id
                and (msp.options &amp; @OPT_ENABLED_FOR_P2P) = @OPT_ENABLED_FOR_P2P
    end
    else
    begin
        --independent agent (one agent for each publication)
        select @num_p2p_pubs = count(*)
            from dbo.MSpublications msp
            where msp.publication         = @publication
                and    msp.publisher_db     = @publisher_db
                and msp.publisher_id     = @publisher_id
                and (msp.options &amp; @OPT_ENABLED_FOR_P2P) = @OPT_ENABLED_FOR_P2P
    end

    if @num_p2p_pubs &gt; 0
        select @is_p2p = 1
    else
        select @is_p2p = 0

    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

