## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MStablechecks\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MStablechecks**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -76658790 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@tablename| |nvarchar|517|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@flags| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|(No column name)|nvarchar|128|
|(No column name)|nvarchar|4000|
|(No column name)|int|4|
|(No column name)|int|4|

---
### Objects that depend on \[sys\].\[sp_MStablechecks\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MStablechecks\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_MStablechecks
    @tablename nvarchar(517), @flags int = null
as
   /*** @flags added for DaVinci uses.  If the bit isn't set, use 6.5 ***/
   /*** sp_MStablechecks '%s'                                        ***/

    declare @id int
    select @id = object_id(@tablename)
    if (@id is null) begin
        RAISERROR (15001, -1, -1, @tablename)
        return 1
    end

    /* @flags is for daVinci. */
    if (@flags is null)
        select @flags = 0

    /* We'll put out the check text if it's all in one row (most likely); otherwise leave it */
    /* blank for refetching in its entirety via sp_helptext, unless @flags wants it anyway. */
    select object_name(t.id),
        case when (@flags &amp; 1 &lt;&gt; 0 or not exists (select * from dbo.syscomments where id = t.id and colid = 2))
                then t.text else null end,
        c.status &amp; (convert(int, 0x00200000) | convert(int, 0x00020000) | convert(int, 0x00004000)),
      OBJECTPROPERTY( t.id, N'CnstIsDisabled' )
    from dbo.syscomments t, dbo.sysconstraints c
    where t.id = c.constid and c.id = @id and c.status &amp; 0x0f = 4
        and (@flags &amp; 1 &lt;&gt; 0 or t.colid = 1)
    order by object_name(t.id), t.colid
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

