## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSenumretries\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSenumretries**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -766947507 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@tname| |nvarchar|126|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@maxrows| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@tablenick| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@rowguid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@pubid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSenumretries\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSenumretries\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSenumretries
    (@tname nvarchar(126),
     @maxrows int,
     @tablenick int,
     @rowguid uniqueidentifier,
     @pubid uniqueidentifier = NULL)
as
    declare @tnstring nvarchar(12)
    declare @rgstring nvarchar(38)
    declare @retcode int
    declare @pubidstr varchar(38)
    declare @last_art_processing_order int
    declare @last_art_processing_order_str varchar(12)

    declare @quotedtname nvarchar(744) -- 386 * 2 + 2

    /*
    ** do permission checking
    */
    exec @retcode = sys.sp_MSrepl_PAL_rolecheck @tablenick = @tablenick
    if @retcode&lt;&gt;0 or @@ERROR&lt;&gt;0 return (1)

    /*
    ** Modify temp table, granted to public.
    */

    declare @selecttop nvarchar(50)

    select @quotedtname = quotename(@tname)

    if (@maxrows = 0)
        set @selecttop= 'select'
    else
        set @selecttop= 'select top ' + cast(@maxrows as nvarchar(9)) 
    
        if @pubid is null
        begin
                if (@tablenick &lt; 1)
                begin
                execute (@selecttop + ' * from ' + @quotedtname + 
                                        ' order by tablenick, rowguidcol')
                        IF @@ERROR &lt;&gt;0 RETURN (1)        
                end
                else
                begin
                set @tnstring = convert(nchar, @tablenick)
                        set @rgstring = '''' + convert(nchar(36), @rowguid) + ''''
                        execute (@selecttop + ' * from ' + @quotedtname + 
                                        ' where (tablenick = ' + @tnstring + ' and  rowguidcol &gt; ' + @rgstring + ') or
                                                tablenick &gt; ' + @tnstring + ' order by tablenick, rowguidcol' )
                        if @@ERROR &lt;&gt; 0 RETURN (1)
                end
        end
        else
        begin
                select @pubidstr = '''' + convert(varchar(36), @pubid) + ''''
                if (@tablenick &lt; 1)
                begin
                execute (@selecttop + ' t.* 
                                        from ' + @quotedtname + ' t, dbo.sysmergearticles sma 
                                        where sma.nickname = t.tablenick 
                                        and sma.pubid = ' + @pubidstr + '
                                        order by sma.processing_order, sma.nickname, t.rowguidcol')
                        IF @@ERROR &lt;&gt;0 RETURN (1)        
                end
                else
                begin
                set @tnstring = convert(nchar, @tablenick)
                        set @rgstring = '''' + convert(nchar(36), @rowguid) + ''''
                        exec sys.sp_MSget_article_processing_order @tablenick, @pubid, @last_art_processing_order output
                        select @last_art_processing_order_str = convert(varchar, @last_art_processing_order)

                        execute (@selecttop + ' t.* 
                                        from ' + @quotedtname + ' t, dbo.sysmergearticles sma
                                        where sma.nickname = t.tablenick
                                        and sma.pubid = ' + @pubidstr + '
                                        and 
                                        (
                                                (t.tablenick = ' + @tnstring + ' and  t.rowguidcol &gt; ' + @rgstring + ') or
                                                (sma.processing_order = ' + @last_art_processing_order_str + ' and t.tablenick &gt; ' + @tnstring + ') or
                                                sma.processing_order &gt; ' + @last_art_processing_order_str + '
                                        )
                                        order by sma.processing_order, sma.nickname, t.rowguidcol' )
                        if @@ERROR &lt;&gt; 0 RETURN (1)
                end
        end

        return (0)  
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

