## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_changepublication_snapshot\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_changepublication_snapshot**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -771131695 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_type| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_interval| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_subday| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_subday_interval| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_relative_interval| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_recurrence_factor| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@active_start_date| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@active_end_date| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@active_start_time_of_day| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@active_end_time_of_day| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@snapshot_job_name| |nvarchar|100|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_security_mode| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_login| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_password| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@job_login| |nvarchar|257|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@job_password| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_changepublication_snapshot\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_changepublication_snapshot\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE sys.sp_changepublication_snapshot
(
    @publication                    sysname,    
    @frequency_type                    int = NULL,        /* 4== Daily */
    @frequency_interval                int = NULL,        /* Every day */
    @frequency_subday                int = NULL,        /* Sub interval = Minute */
    @frequency_subday_interval        int = NULL,        /* Every five minutes */
    @frequency_relative_interval    int = NULL, 
    @frequency_recurrence_factor    int = NULL, 
    @active_start_date                int = NULL, 
    @active_end_date                int = NULL, 
    @active_start_time_of_day        int = NULL, 
    @active_end_time_of_day            int = NULL,
    @snapshot_job_name                nvarchar(100) = NULL,
    @publisher_security_mode        int = NULL,
    @publisher_login                sysname = NULL,
    @publisher_password             sysname = NULL,
    @job_login                         nvarchar(257) = NULL,
    @job_password                     sysname = NULL,
    @publisher                        sysname    = NULL
)
AS
BEGIN
    DECLARE @cmd            nvarchar(4000)
    DECLARE @retcode        int
    DECLARE @publisher_type    sysname

    SET @retcode = 0
    
    EXEC @retcode = sys.sp_MSrepl_getpublisherinfo    @publisher        = @publisher,
                                                    @publisher_type    = @publisher_type OUTPUT,
                                                    @rpcheader        = @cmd            OUTPUT
    
    IF @retcode &lt;&gt; 0
        RETURN (@retcode)

    -- Add sp
    SET @publisher = UPPER(@publisher) COLLATE DATABASE_DEFAULT
    set @cmd = @cmd + N'sys.sp_MSrepl_changepublication_snapshot'
    
    EXEC @retcode = @cmd
                    @publication,
                    @frequency_type,
                    @frequency_interval,
                    @frequency_subday,
                    @frequency_subday_interval,
                    @frequency_relative_interval,
                    @frequency_recurrence_factor,
                    @active_start_date,
                    @active_end_date,
                    @active_start_time_of_day,
                    @active_end_time_of_day,
                    @snapshot_job_name,
                    @publisher_security_mode,
                    @publisher_login,
                    @publisher_password,
                    @job_login,
                    @job_password,
                    @publisher,
                    @publisher_type
                    

    RETURN (@retcode)
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

