## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_addextendedproc\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_addextendedproc**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -778373031 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@functname| |nvarchar|517|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@dllname| |varchar|255|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_addextendedproc\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_addextendedproc\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

---------------------------- sp_addextendedproc ------------------------------
create procedure sys.sp_addextendedproc
    @functname nvarchar(517),    -- (owner.)name of function to call
    @dllname varchar(255)        -- name of DLL containing function
as
    -- If we're in a transaction, disallow the addition of the
    --  extended stored procedure.
    set implicit_transactions off
    if @@trancount &gt; 0
    begin
        raiserror(15002,-1,-1,'sys.sp_addextendedproc')
        return (1)
    end

    -- Disallow 0-length string &amp; NULL
    if @dllname is null or datalength(@dllname) = 0
    begin
        raiserror(15311,-1,-1,@dllname)
        return (1)
    end

    BEGIN TRANSACTION

    declare @dllwname nvarchar(255)
    set @dllwname = convert(nvarchar(255), @dllname)

    -- Create the extended procedure mapping.
    EXEC %%System().AddExtendedProc( Name = @functname, Value = @dllwname)
    if @@error &lt;&gt; 0
    begin
        ROLLBACK
        return 1
    end

    declare @objid int
    select @objid = object_id(@functname)

    -- EMDEventType(x_eet_Create_Extended_Procedure), EMDUniversalClass(x_eunc_Object), src major id, src minor id, src name
    -- -1 means ignore target stuff, target major id, target minor id, target name,
    -- # of parameters, 5 parameters
    EXEC %%System().FireTrigger(ID = 221, ID = 1, ID = @objid, ID = 0, Value = @functname,
        ID = -1, ID = 0, ID = 0, Value = NULL, 
        ID = 2, Value = @functname, Value = @dllname, Value = NULL, Value = NULL, Value = NULL, Value = NULL, Value = NULL)
    
    COMMIT

    return (0) -- sp_addextendedproc
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

