## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_help_log_shipping_primary_database\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_help_log_shipping_primary_database**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -778575440 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@database| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@primary_id| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|primary_id|uniqueidentifier|16|
|primary_database|nvarchar|128|
|backup_directory|nvarchar|500|
|backup_share|nvarchar|500|
|backup_retention_period|int|4|
|backup_compression|tinyint|1|
|backup_job_id|uniqueidentifier|16|
|monitor_server|nvarchar|128|
|monitor_server_security_mode|bit|1|
|backup_threshold|int|4|
|threshold_alert|int|4|
|threshold_alert_enabled|bit|1|
|last_backup_file|nvarchar|500|
|last_backup_date|datetime|8|
|last_backup_date_utc|datetime|8|
|history_retention_period|int|4|

---
### Objects that depend on \[sys\].\[sp_help_log_shipping_primary_database\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_help_log_shipping_primary_database\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_help_log_shipping_primary_database 
(
    @database sysname = NULL
    ,@primary_id uniqueidentifier = NULL
)
as
begin
    set nocount on
    declare @retcode int

    --
    -- security check
    --
    exec @retcode = sys.sp_MSlogshippingsysadmincheck
    if (@retcode != 0 or @@error != 0)
        return 1
    --
    -- must be invoked from master db
    --
    if (db_name() != N'master')
    begin
        raiserror(5001, 16,-1)
        return 1
    end
    --
    -- validate input
    --
    if (@database is null and @primary_id is null)
    begin
        raiserror(14524, 16, 1, N'@database', N'@primary_id')
        return 1
    end
    --
    -- return resultset
    --
    select  
        pd.primary_id
        ,pd.primary_database
        ,pd.backup_directory
        ,pd.backup_share
        ,pd.backup_retention_period
        ,pd.backup_compression --note: sqllogship.exe is sensitive to the ordering of these results
        ,pd.backup_job_id
        ,'monitor_server' = case when (pd.user_specified_monitor = 1) then pd.monitor_server else cast(NULL as sysname) end
        ,'monitor_server_security_mode' = case when (pd.user_specified_monitor = 1) then pd.monitor_server_security_mode else cast(NULL as bit) end
        ,mp.backup_threshold
        ,mp.threshold_alert
        ,mp.threshold_alert_enabled
        ,mp.last_backup_file
        ,mp.last_backup_date
        ,mp.last_backup_date_utc
        ,mp.history_retention_period
    from msdb.dbo.log_shipping_primary_databases as pd join msdb.dbo.log_shipping_monitor_primary as mp
        on pd.primary_id = mp.primary_id
    where (@database is not null and pd.primary_database = @database)
        or (@primary_id is not null and pd.primary_id = @primary_id)
    --
    -- all done
    --
    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

