## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_who\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_who**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -781310293 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@loginame| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|spid|smallint|2|
|ecid|smallint|2|
|status|nchar|30|
|loginame|nvarchar|128|
|hostname|nchar|128|
|blk|char|5|
|dbname|nvarchar|128|
|cmd|nchar|16|
|request_id|int|4|

|Name |Datatype |Max length |
|-|-|-|
|spid|smallint|2|
|ecid|smallint|2|
|status|nchar|30|
|loginame|nvarchar|128|
|hostname|nchar|128|
|blk|char|5|
|dbname|nvarchar|128|
|cmd|nchar|16|
|request_id|int|4|

|Name |Datatype |Max length |
|-|-|-|
|spid|smallint|2|
|ecid|smallint|2|
|status|nchar|30|
|loginame|nvarchar|128|
|hostname|nchar|128|
|blk|char|5|
|dbname|nvarchar|128|
|cmd|nchar|16|
|request_id|int|4|

|Name |Datatype |Max length |
|-|-|-|
|spid|smallint|2|
|ecid|smallint|2|
|status|nchar|30|
|loginame|nvarchar|128|
|hostname|nchar|128|
|blk|char|5|
|dbname|nvarchar|128|
|cmd|nchar|16|
|request_id|int|4|

---
### Objects that depend on \[sys\].\[sp_who\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_who\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_who  --- 1995/11/28 15:48
       @loginame sysname = NULL --or 'active'
as

declare     @spidlow    int,
         @spidhigh    int,
         @spid        int,
         @sid        varbinary(85)

select     @spidlow    =     0
        ,@spidhigh    = 32767


if (    @loginame is not NULL
   AND    upper(@loginame collate Latin1_General_CI_AS) = 'ACTIVE'
   )
    begin

    select spid , ecid, status
              ,loginame=rtrim(loginame)
          ,hostname ,blk=convert(char(5),blocked)
          ,dbname = case
                        when dbid = 0 then null
                        when dbid &lt;&gt; 0 then db_name(dbid)
                    end
          ,cmd
          ,request_id
    from  sys.sysprocesses_ex
    where spid &gt;= @spidlow and spid &lt;= @spidhigh AND
          upper(cmd) &lt;&gt; 'AWAITING COMMAND'

    return (0)
    end

if (@loginame is not NULL
   AND    upper(@loginame collate Latin1_General_CI_AS) &lt;&gt; 'ACTIVE'
   )
begin
    if (@loginame like '[0-9]%')    -- is a spid.
    begin
        select @spid = convert(int, @loginame)
        select spid, ecid, status,
               loginame=rtrim(loginame),
               hostname,blk = convert(char(5),blocked),
               dbname = case
                            when dbid = 0 then null
                            when dbid &lt;&gt; 0 then db_name(dbid)
                        end
              ,cmd
              ,request_id
        from  sys.sysprocesses_ex
        where spid = @spid
    end
    else
    begin
        select @sid = suser_sid(@loginame)
        if (@sid is null)
        begin
            raiserror(15007,-1,-1,@loginame)
            return (1)
        end
        select spid, ecid, status,
               loginame=rtrim(loginame),
               hostname ,blk=convert(char(5),blocked),
               dbname = case
                            when dbid = 0 then null
                            when dbid &lt;&gt; 0 then db_name(dbid)
                        end
               ,cmd
               ,request_id
        from  sys.sysprocesses_ex
        where sid = @sid
    end
    return (0)
end


-- loginame arg is null
select spid,
       ecid,
       status,
       loginame=rtrim(loginame),
       hostname,
       blk=convert(char(5),blocked),
       dbname = case
                    when dbid = 0 then null
                    when dbid &lt;&gt; 0 then db_name(dbid)
                end
       ,cmd
       ,request_id
from  sys.sysprocesses_ex
where spid &gt;= @spidlow and spid &lt;= @spidhigh

return (0) -- sp_who
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

