## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_browsereplcmds\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_browsereplcmds**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -782569043 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@xact_seqno_start| |nchar|22|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@xact_seqno_end| |nchar|22|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@originator_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_database_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@article_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@command_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@agent_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@compatibility_level| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_browsereplcmds\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_browsereplcmds\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_browsereplcmds 
    @xact_seqno_start nchar(22) = NULL, --lower boundry of the query
    @xact_seqno_end nchar(22) = NULL, -- upper boundry of the query
    @originator_id int = NULL, -- limit query to the specified originator source
    @publisher_database_id int = NULL, -- limit query to the specified publication database
    @article_id int = NULL, -- limit query to the specified article
    @command_id int = NULL, -- limit query to the specified command id
    --the following apply to agent specific cmds (per sp_MSget_repl_commands called by agent)
    @agent_id int = NULL,  -- when present all other input parameters except @xact_seqno_start are ignored
    @compatibility_level int = 9000000 -- use 7000000 if subscriber is SQL70
as
    declare @query nvarchar( 4000 )
        ,@retcode            int
        ,@dbname sysname

    select @dbname = db_name()
    if (sys.fn_MSrepl_isdistdb (@dbname ) != 1)
    begin
        raiserror(21482, 16, -1, 'sp_browsereplcmds', 'distribution')
        return (1)
    end

    -- security check.
    -- User must be member of 'replmonitor' role in distribution database
    --
    exec @retcode = sys.sp_MSrepl_DistributorReplMonitorAccess @distribution_db = @dbname 
    if @retcode != 0 or @@error != 0
        return (1)

--first let's find out if we are returning cmds specific to an agent
if(@agent_id is not NULL)
begin
    if @xact_seqno_start is null
    begin
        select @xact_seqno_start = N'0x00000000000000000000'
    end
    select @query = N'exec sys.sp_MSget_repl_commands ' + cast (@agent_id as nvarchar(12)) + N', ' + sys.fn_replreplacesinglequote(@xact_seqno_start ) + N', 0, ' + cast (@compatibility_level as nvarchar(12))
    exec sys.sp_printagentstatement @query
    return 0
end

--we know this is not specific to an agent, now go against the entire table.
if( @command_id is not null )
begin
    if( @xact_seqno_start is null or @publisher_database_id is null )
    begin
        raiserror( 21110, 16, -1 )
        return 1
    end
    else if @xact_seqno_start != @xact_seqno_end 
    begin
        raiserror( 21109, 16, -1 )
        return 1
    end
end

if @xact_seqno_start is null
begin
    select @xact_seqno_start = N'0x00000000000000000000'
end
if @xact_seqno_end is null
begin
    select @xact_seqno_end = N'0xFFFFFFFFFFFFFFFFFFFF'
end

select @query = N'select cmds.article_id, cast (cmds.partial_command as tinyint), cmds.command, cmds.xact_seqno, '
select @query = @query + 'cmds.xact_seqno, 0, cmds.command_id, cmds.type, orgs.srvname, orgs.dbname, '
select @query = @query + 'cast (cmds.hashkey as smallint), orgs.publication_id, orgs.dbversion, cmds.originator_lsn '
select @query = @query + 'from MSrepl_commands cmds left join MSrepl_originators orgs on cmds.originator_id = orgs.id '

if @command_id is not null
begin
    select @query = @query + N'where cmds.xact_seqno = ' + sys.fn_replreplacesinglequote(@xact_seqno_start )
end
else
begin
    select @query = @query + N'where cmds.xact_seqno &gt;= ' + sys.fn_replreplacesinglequote(@xact_seqno_start) + N' and cmds.xact_seqno &lt;= ' + sys.fn_replreplacesinglequote(@xact_seqno_end) 
end

if @originator_id is not null
begin
    select @query = @query + N' and cmds.originator_id = ' + convert( nvarchar, @originator_id )
end

if @publisher_database_id is not null
begin
    select @query = @query + N' and cmds.publisher_database_id = ' + convert( nvarchar, @publisher_database_id )
end

if @article_id is not null
begin
    select @query = @query + N' and cmds.article_id = ' + convert( nvarchar, @article_id )
end

if @command_id is not null
begin
    -- No need to use article_id and originator_id
    select @query = @query + N' and cmds.command_id &gt;= ' + convert( nvarchar, @command_id )
    select @query = @query + N' and cmds.command_id &lt;= ( select min( command_id ) from MSrepl_commands c '
    select @query = @query + N' where c.xact_seqno = ' +  sys.fn_replreplacesinglequote(@xact_seqno_start ) 
    select @query = @query + N' and c.publisher_database_id = ' + convert( nvarchar, @publisher_database_id )
    select @query = @query + N' and c.command_id &gt;= ' + convert( nvarchar, @command_id )
    select @query = @query + N' and c.partial_command = 0 )'  
end

select @query = @query + N' order by cmds.originator_id, cmds.publisher_database_id, cmds.xact_seqno, cmds.article_id, cmds.command_id asc'


exec sys.sp_printstatement @query
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

