## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_helpmergearticleconflicts\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_helpmergearticleconflicts**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -785444695 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_helpmergearticleconflicts\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_helpmergearticleconflicts\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_helpmergearticleconflicts(
    @publication    sysname = '%',
    @publisher        sysname = NULL,
    @publisher_db    sysname = NULL
    )
as
    set nocount on
    declare @pubid            uniqueidentifier
    declare @cmd            nvarchar(4000)

    declare @retcode        int
    declare @nickname        int
    declare @retcode2        int
    declare @name            sysname
    declare @source_owner    sysname
    declare @source_object    sysname
    declare @conflict_table sysname
    declare @guidcolname        sysname
    declare @centralized_conflicts int
    declare @objid            int
    declare @command        nvarchar(2000)     
    
    -- Security check: dbo and sysadmin only
    select @retcode = 0
    exec @retcode = sys.sp_MSreplcheck_publish
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
    begin
        return 1
    end

    if @publisher IS NULL
        select @publisher = publishingservername()
        
    if @publisher_db IS NULL
        select @publisher_db = db_name()

    if @publication &lt;&gt; '%'
        begin
            /*
            ** Parameter Check:     @publication.
            ** Make sure that the publication exists.
            */
            select @pubid = pubid from dbo.sysmergepublications 
                where name = @publication and 
                    LOWER(publisher) = LOWER(@publisher) and
                    publisher_db = @publisher_db
            if @pubid IS NULL
            BEGIN
                RAISERROR (20026, 16, -1, @publication)
                RETURN (1)
            END
        end

    create table #temp_conflict(article                    sysname collate database_default,
                                source_owner            sysname collate database_default,
                                source_object            sysname collate database_default,
                                conflict_table            sysname collate database_default,
                                guidcolname                sysname collate database_default,
                                centralized_conflicts    int)    

    declare #cur_conflict cursor local for 
        select name, objid, conflict_table, pubid, nickname from dbo.sysmergearticles 
            where conflict_table is not NULL and pubid in (select pubid from dbo.sysmergepublications where name like @publication)
                for read only
    open #cur_conflict
    fetch #cur_conflict into @name, @objid, @conflict_table, @pubid, @nickname
    while (@@fetch_status &lt;&gt; -1)
    begin
        select @source_owner = SCHEMA_NAME(schema_id) from sys.objects where object_id = @objid
        select @source_object = object_name (@objid)
        select @guidcolname = name from sys.columns where object_id = @objid and is_rowguidcol = 1
        select @centralized_conflicts = centralized_conflicts from dbo.sysmergepublications where pubid = @pubid

        select @command = 'if exists (select * from ' + QUOTENAME(@conflict_table) + ') select @retcode2 = 1
                                else select @retcode2 = 0'
        EXEC @retcode = sys.sp_executesql @command, N'@retcode2 int output', @retcode2 output
        if @retcode &lt;&gt;0
                return (1)
        if @retcode2 = 1 
        begin
            insert into #temp_conflict 
                values (@name, @source_owner, @source_object, @conflict_table, @guidcolname, @centralized_conflicts)
        end
        --return delete conflicts to be compatible with old conflict structure
        if EXISTS (select * from MSmerge_conflicts_info where tablenick = @nickname and conflict_type in (4,7,8,12))
        begin
            insert into #temp_conflict
                values (@name, @source_owner, @source_object, 'MSmerge_conflicts_info', @guidcolname, @centralized_conflicts)
        end
        fetch #cur_conflict into @name, @objid, @conflict_table, @pubid, @nickname
    end

    select * from #temp_conflict order by article, conflict_table

    drop table #temp_conflict
    close #cur_conflict
    deallocate #cur_conflict
return(0)        
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

