## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSgettranconflictrow\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSgettranconflictrow**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -786868573 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@tran_id| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@row_id| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@conflict_table| |nvarchar|270|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@is_subscriber| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSgettranconflictrow\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSgettranconflictrow\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSgettranconflictrow 
( 
    @tran_id sysname = '%',                     -- % = ALL transactions for the article
    @row_id sysname = '%',                     -- % = ALL rows for a given transaction
    @conflict_table nvarchar(270),             -- owner qualified table name - [owner].[tabname]
    @is_subscriber bit                               -- Publisher = 0, Subscriber = 1
)
as 
begin
    set nocount on
    declare @retcode int
            ,@cmd nvarchar(4000)
            ,@whcmd nvarchar(4000)
            ,@unqualified_cft_tab sysname
            ,@publication sysname
            
    --
    -- get the publication name
    --
    if (@is_subscriber = 1)
    begin
        --
        -- check if the conflict table is owner qualified
        --
        select @unqualified_cft_tab = QUOTENAME(PARSENAME(@conflict_table, 1))
        
        --
        -- we are on subscriber
        --
        select @publication = sagnt.publication
        from (MSsubscription_articles as sart join MSsubscription_agents as sagnt 
                on sart.agent_id = sagnt.id)
        where quotename(sart.cft_table) = @unqualified_cft_tab
    end
    else
    begin
        --
        -- we are on publisher
        --
        select @publication = p.name
        from ((sysarticles a join sysarticleupdates b 
            on a.pubid = b.pubid 
            and a.artid = b.artid) join syspublications p 
                on a.pubid = p.pubid)
        where b.conflict_tableid = OBJECT_ID(@conflict_table)
    end
    --
    -- Do PAL security check
    --
    exec @retcode = sys.sp_MSreplcheck_pull @publication = @publication
    if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
        return (1)
    --
    -- passed the security check
    --
    select @cmd = N'select * from ' + ISNULL(NULLIF(QUOTENAME(PARSENAME(@conflict_table, 2)) + N'.', N'.'), N'') + QUOTENAME(PARSENAME(@conflict_table, 1))
    if (@tran_id != N'%')
    begin
        if (@whcmd is null)
            select @whcmd = N'tranid = ' + QUOTENAME(@tran_id, '''')
        else
            select @whcmd = @whcmd + N' and tranid = ' + QUOTENAME(@tran_id, '''')
    end
    if (@row_id != N'%')
    begin
        if (@whcmd is null)
            select @whcmd = N'qcfttabrowid = ' + QUOTENAME(@row_id, '''')
        else
            select @whcmd = @whcmd + N' and qcfttabrowid = ' + QUOTENAME(@row_id, '''')
    end
    if (@whcmd is not null)
    begin
        select @cmd = @cmd + N' where ' + @whcmd
    end
    --
    -- execute the generated select
    --
    execute (@cmd)
    --
    -- all done
    --
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

