## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_dbmmonitorhelpmonitoring\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_dbmmonitorhelpmonitoring**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -787833033 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
 No parameters exist

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|update_period|int|4|

---
### Objects that depend on \[sys\].\[sp_dbmmonitorhelpmonitoring\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_dbmmonitorhelpmonitoring\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_dbmmonitorhelpmonitoring
as
begin
    set nocount on
    if (is_srvrolemember(N'sysadmin') &lt;&gt; 1 )
        begin
            raiserror(21089, 16, 1)
            return (1)
        end

    declare @freq_type                int,    -- 4 = daily
            @freq_interval            int,    -- Every 1 days
            @freq_subday_type        int,    -- 4 = based on Minutes
            @freq_subday_interval    int,    -- interval
            @job_id                    uniqueidentifier,
            @schedule_id            int,
            @retention_period        int,
            @jobname                nvarchar( 256 )

    select @jobname   = isnull( formatmessage( 32047 ), N'Database Mirroring Monitor Job' )

    select @job_id = job_id from msdb.dbo.sysjobs where name = @jobname
    if (@job_id is null)    -- if the job does not exist, error out
    begin
        raiserror( 32049, 16, 1 )
        return 1
    end

    select @schedule_id = schedule_id from msdb.dbo.sysjobschedules where job_id = @job_id
    select    @freq_type = freq_type,
            @freq_interval = freq_interval,
            @freq_subday_type = freq_subday_type,
            @freq_subday_interval = freq_subday_interval
        from msdb.dbo.sysschedules where schedule_id = @schedule_id

    -- If the frequency parameters are not what we expect then return an error
    -- Someone has changed the job schedule on us
    if (@freq_type &lt;&gt; 4) or (@freq_interval &lt;&gt; 1) or (@freq_subday_type &lt;&gt; 4)
    begin
        raiserror( 32037, 16, 1)
        return 1
    end

    select @freq_subday_interval update_period

    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

