## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_processlogshippingretentioncleanup\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_processlogshippingretentioncleanup**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -790652676 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@agent_id| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@agent_type| |tinyint|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@monitor_server| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@monitor_server_security_mode| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@history_retention_period| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@curdate_utc| |datetime|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_processlogshippingretentioncleanup\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_processlogshippingretentioncleanup\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_processlogshippingretentioncleanup 
(
    @agent_id uniqueidentifier
    ,@agent_type tinyint  -- 0 = backup, 1 = copy, 2 = restore
    ,@monitor_server sysname 
    ,@monitor_server_security_mode bit 
    ,@history_retention_period int
    ,@curdate_utc datetime
)
as
begin
    set nocount on
    declare @retcode int
    
    --
    -- security check
    --
    exec @retcode = sys.sp_MSlogshippingsysadmincheck
    if (@retcode != 0 or @@error != 0)
        return 1
    --
    -- This should be called only on the remote monitor server
    --
    if (@monitor_server is null or upper(@monitor_server) != upper(@@servername))
        return 0
    --
    -- must be invoked from MSDB
    --
    if (db_name() != N'msdb')
    begin
        raiserror (21482, 16, -1, N'sp_processlogshippingretentioncleanup', N'msdb')
        return 1
    end
    --
    -- call the internal proc now
    --
    exec @retcode = sys.sp_MSprocesslogshippingretentioncleanup
                    @agent_id = @agent_id
                    ,@agent_type = @agent_type
                    ,@monitor_server = @monitor_server
                    ,@monitor_server_security_mode = @monitor_server_security_mode
                    ,@history_retention_period = @history_retention_period
                    ,@curdate_utc = @curdate_utc
    if (@retcode != 0 or @@error != 0)
        return 1
    --
    -- all done
    --
    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

