## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MScheck_subscription\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MScheck_subscription**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -790793461 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@pub_type| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|(No column name)|int|4|

---
### Objects that depend on \[sys\].\[sp_MScheck_subscription\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MScheck_subscription\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_MScheck_subscription
(
    @publication    sysname,
    @pub_type       int,
    @publisher        sysname = NULL
)
AS
BEGIN
    declare    @publisher_type sysname,
            @merge_pubid    uniqueidentifier,
            @tran_pubid     int,
            @result         int,
            @retcode        int

    -- Initialize
    SET @result = 0

    --
    -- Security Check.
    --
    IF IS_MEMBER('db_owner') &lt;&gt; 1 
        AND IS_MEMBER('replmonitor') &lt;&gt; 1
    BEGIN
        SELECT 0
        RETURN 0
    END

    -- Check to see if database is activated for publication
    IF sys.fn_MSrepl_ispublished(DB_NAME()) &lt;&gt; 1
    BEGIN
        RAISERROR (14013, 16, -1)
        RETURN (1)
    END

    -- Get publisher info
    EXEC @retcode = sys.sp_MSrepl_getdistributorinfo  @publisher        = @publisher,
                                                      @publisher_type   = @publisher_type OUTPUT
    IF @@error &lt;&gt; 0
    BEGIN
         RAISERROR (14071, 16, -1)
         RETURN (1)
    END

    IF @pub_type = 2
    BEGIN
        IF @publisher_type != N'MSSQLSERVER'
        BEGIN
            RAISERROR (14071, 16, -1)
            RETURN (1)
        END
        
        -- Merge publications
        IF OBJECT_ID('sysmergepublications', 'U') IS NULL
        BEGIN
            RAISERROR(20054, 16, -1)
            RETURN (1)
        END
        
        SELECT    @merge_pubid = pubid
        FROM    dbo.sysmergepublications
        WHERE    name = @publication
          AND    publisher = publishingservername()
          AND    publisher_db = db_name()

        IF @merge_pubid IS NULL
        BEGIN
            RAISERROR(20026, 16, -1, @publication)
            RETURN (1)
        END
        
        IF EXISTS
        (
            SELECT    *
            FROM    dbo.sysmergesubscriptions
            WHERE    pubid = @merge_pubid
              AND    subid != pubid
        )
        BEGIN
            SET @result = 1
        END
    END
    ELSE
    BEGIN
        --
        -- If not merge, it has to be tran level.
        -- For other level, a generic error will be returned.
        --
        
        IF OBJECT_ID('syspublications', 'U') IS NULL AND OBJECT_ID('syspublications', 'V') IS NULL
        BEGIN
            RAISERROR(20054, 16, -1)
            RETURN (1)
        END

        -- Get publication id
        SELECT @tran_pubid = sys.fn_MSrepl_getpubid(@publication, @publisher, @publisher_type)

        IF @tran_pubid IS NULL 
        BEGIN
            RAISERROR(20026, 16, -1, @publication)
            RETURN (1)
        END
        
        IF EXISTS
        (
            SELECT    *
            FROM    syssubscriptions
            WHERE    srvid != -1
              AND    artid IN 
                    (
                        SELECT    artid
                        FROM    sysextendedarticlesview
                        WHERE    pubid = @tran_pubid
                    )
        )
        BEGIN
            SET @result = 1
        END
    END

    SELECT @result
    RETURN (0)
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

