## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_articleview\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_articleview**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -793559676 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@article| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@view_name| |nvarchar|386|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@filter_clause| |ntext|1073741823|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@change_active| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@force_invalidate_snapshot| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@force_reinit_subscription| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@refreshsynctranprocs| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@internal| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_articleview\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_articleview\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_articleview
(
    @publication                sysname,                /* Publication name */
    @article                    sysname,                /* Article name */
    @view_name                    nvarchar (386) = NULL,    /* View name */
    @filter_clause                ntext = NULL,            /* Article's filter clause */
    @change_active                int = 0,
    @force_invalidate_snapshot    bit = 0,                /* Force invalidate existing snapshot */
    @force_reinit_subscription    bit = 0,                /* Force reinit subscription */
    @publisher                    sysname = NULL,
    @refreshsynctranprocs         bit = 1,    -- 1 = regenerate synctran procedures inside this SP for filter change
    @internal                     bit = 0
)
AS
BEGIN
    set nocount on
    DECLARE @cmd            nvarchar(4000)
                ,@retcode        int
                ,@publisher_type    sysname

    if (@publisher is NULL)
    begin
        EXEC @retcode = sys.sp_MSrepl_articleview
                    @publication,
                    @article,
                    @view_name,
                    @filter_clause,
                    @change_active,
                    @force_invalidate_snapshot,
                    @force_reinit_subscription,
                    @refreshsynctranprocs,
                    @internal
    end
    else
    begin
        -- Heterogeneous articles are handled directly by sp_IHarticleview
        EXEC @retcode = sys.sp_MSrepl_getpublisherinfo   @publisher        = @publisher,
                                                                            @publisher_type    = @publisher_type OUTPUT,
                                                                            @rpcheader        = @cmd OUTPUT
        IF @retcode &lt;&gt; 0
            RETURN (@retcode)
            
        SET @publisher = UPPER(@publisher)
        
        set @cmd = @cmd + N'dbo.sp_IHarticleview '
        EXEC @retcode = @cmd
                    @publication,
                    @article,
                    @view_name,
                    @filter_clause,
                    @change_active,
                    @force_invalidate_snapshot,
                    @force_reinit_subscription,
                    @publisher,
                    @publisher_type
    end    

    RETURN (@retcode)
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

