## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_addumpdevice\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_addumpdevice**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -794916572 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@devtype| |varchar|20|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@logicalname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@physicalname| |nvarchar|260|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@cntrltype| |smallint|2|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@devstatus| |varchar|40|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_addumpdevice\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_addumpdevice\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_addumpdevice    -- 1995/09/07 12:01
    @devtype varchar(20),                -- disk, tape, or virtual_device
    @logicalname   sysname,                -- logical name of the device
    @physicalname  nvarchar(260),        -- physical name of the device
    @cntrltype  smallint = null,        -- obsolete: controller type - ignored.
    @devstatus  varchar(40) = null      -- obsolete: device characteristics -ignored
as
    declare @type_enum    smallint -- devtype enumeration value
    declare @returncode int
    declare @devtypeIn varchar(20)
    select @devtypeIn = @devtype
           ,@devtype = LOWER (@devtype collate Latin1_General_CI_AS)
    -- An open txn might jeopardize a recovery.
    set implicit_transactions off
    if @@trancount &gt; 0
    begin
        raiserror(15002,-1,-1,'sys.sp_addumpdevice')
        return (1)
    end

    -- You must be SA to execute this sproc.
    if (not is_srvrolemember('diskadmin') = 1)
    begin
        raiserror(15247,-1,-1)
        return (1)
    end

    -- Check out the @devtype.
    select @type_enum = (case @devtype
        when 'disk'                then 2
        when 'tape'                then 5
        when 'virtual_device'    then 7
        end)

    if @type_enum is null
    begin
        raiserror(15044,-1,-1,@devtypeIn)
        return (1)
    end

    -- Check the args are not NULL.
    if @logicalname is null
    begin
        raiserror(15045,-1,-1)
        return(1)
    end

    -- Check to see that the @logicalname is valid.
    EXEC @returncode = sys.sp_validname @logicalname
    if @returncode &lt;&gt; 0
        return(1)

    if @physicalname is null
    begin
        raiserror(15046,-1,-1)
        return(1)
    end

    -- Prohibit certain special english words from being logical names.
    if (@logicalname IN ('disk', 'tape', 'virtual_device'))
    begin
        raiserror(15285,-1,-1,@logicalname)
        return (1)
    end

    BEGIN TRANSACTION
    -- Make sure that a device with @logicalname doesn't already exist.
    --  Always turn on the dump status bit, ignore @skip_tape (not in use)
    EXEC %%Device().NewDevice(Name = @logicalname, PhysicalName = @physicalname,
        Type = @type_enum, Size = 0)
    if @@error &lt;&gt; 0    -- duplicate logical name
    begin
        ROLLBACK TRANSACTION
        raiserror(15026,-1,-1,@logicalname)
        return (1)
    end

    -- Make sure physical file name would be unique among devices.
    if (select count(*) from master.dbo.sysdevices where phyname = @physicalname) &gt; 1
    begin
        ROLLBACK TRANSACTION
        raiserror(15061,-1,-1,@physicalname)
        return (1)
    end

    COMMIT TRANSACTION

    return (0) -- sp_addumpdevice
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

