## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[xp_logininfo\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.xp_logininfo**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -795691164 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@acctname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@option| |varchar|10|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@privilege| |varchar|10|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|account name|nvarchar|128|
|type|varchar|8|
|privilege|varchar|8|
|mapped login name|nvarchar|128|
|permission path|nvarchar|128|

|Name |Datatype |Max length |
|-|-|-|
|account name|nvarchar|127|
|type|varchar|8|
|privilege|varchar|8|
|mapped login name|nvarchar|127|
|permission path|nvarchar|128|

|Name |Datatype |Max length |
|-|-|-|
|account name|nvarchar|128|
|type|varchar|8|
|privilege|varchar|8|
|mapped login name|nvarchar|128|
|permission path|nvarchar|128|

---
### Objects that depend on \[sys\].\[xp_logininfo\]
 No dependencies exist

---
### Objects that \[sys\].\[xp_logininfo\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

------------------------------- xp_logininfo ----------------------------------

create procedure sys.xp_logininfo
    @acctname        sysname = null,                -- IN: NT login name
    @option            varchar(10) = null,            -- IN: 'all' | 'members' | null
    @privilege        varchar(10) = 'Not wanted' OUTPUT    -- OUT: 'admin' | 'user' | null
as
    set nocount on

    declare @ret        int

    -- VALIDATE PARAMETERS --
    if (@acctname is null AND (@option is not null OR (@privilege is null OR @privilege &lt;&gt; 'Not wanted')))
        OR ((@option is null OR @option &lt;&gt; 'all') AND (@privilege is null OR @privilege &lt;&gt; 'Not wanted'))
        OR (@option is not null and @option not in ('all', 'members'))
    begin
        raiserror(15600,-1,-1,'sys.xp_logininfo')
        return 1
    end


    -- HANDLE case where NO @acctname GIVEN --
    if (@acctname is null)
    begin
        select    'account name' = loginname,
                'type' = convert(varchar(8), case when isntuser = 1 then 'user' else 'group' end),
                'privilege' = convert(varchar(8), case when sysadmin = 1 then 'admin' else 'user' end),
                'mapped login name' = loginname,
                'permission path' = convert(sysname, null)
        from master..syslogins where isntname = 1 and hasaccess = 1
        order by 3, 1
        return @@error
    end

    -- HANDLE 'members' QUERY --
    if (@option = 'members')
    begin
        declare @priv varchar(8)
        select @priv = case when sysadmin = 1 then 'admin' else 'user' end
            from master..syslogins where isntname = 1 and loginname = @acctname and hasaccess = 1
        if @priv is not null
            select    'account name' = domain+N'\'+name,
                    'type' = convert(varchar(8), case when sidtype = 1 then 'user' else 'group' end),
                    'privilege' = @priv,
                    'mapped login name' = domain+N'\'+name,
                    'permission path' = @acctname
            from OpenRowset(TABLE NETGROUPGETMEMBERS, @acctname) order by 3, 1
        else
            select    'account name' = convert(sysname, null),
                    'type' = convert(varchar(8), null),
                    'privilege' = @priv,
                    'mapped login name' = convert(sysname, null),
                    'permission path' = convert(sysname, null)
            where 0=1    -- empty result set
        return @@error
    end


    -- CREATE TEMP TABLE AND POPULATE WITH THE REQUIRED DATA --
    CREATE TABLE #nt (name sysname collate catalog_default, sid varbinary(85), sidtype int)
    insert #nt select loginname, sid, isntgroup + 1 from master..syslogins
            where isntname = 1 and loginname = @acctname
    insert #nt select distinct domain+N'\'+name, sid, sidtype
            from OpenRowset(TABLE NETUSERGETGROUPS, @acctname)
    select @ret = @@error
    if @ret &lt;&gt; 0
        return @ret
    -- IF ANY DENY, THEN NO ACCESS --
    if exists (select * from master..syslogins where sid in (select #nt.sid from #nt) and denylogin = 1)
        delete #nt


    -- HANDLE case where OUTPUT REQUESTED --
    if (@privilege is null OR @privilege &lt;&gt; 'Not wanted')
    begin
        select @privilege = case max(sysadmin)
            when 1 then 'admin'
            when 0 then 'user'
            else NULL end
        from master..syslogins where isntname = 1 and hasaccess = 1
            AND sid in (select sid from #nt)
        return @@error
    end


    -- GET NT TYPE FOR NEXT OPTIONS --
    declare @type varchar(8)
    select @type = case when get_sid('\U'+@acctname) is null then 'group' else 'user' end

    -- HANDLE 'all' QUERY --
    if (@option = 'all')
    begin
        select    'account name' = @acctname,
                'type' = @type,
                'privilege' = convert(varchar(8), case when sysadmin = 1 then 'admin' else 'user' end),
                'mapped login name' = @acctname,
                'permission path' = case when l.loginname = @acctname then NULL else l.loginname end
        from master..syslogins l join #nt n on l.isntname = 1 and l.sid = n.sid
        where l.loginname = n.name and hasaccess = 1
        order by 3, 5
        return @@error
    end


    -- HANDLE DEFAULT QUERY --
    select    TOP 1
            'account name' = @acctname,
            'type' = @type,
            'privilege' = convert(varchar(8), case when sysadmin = 1 then 'admin' else 'user' end),
            'mapped login name' = @acctname,
            'permission path' = case when l.loginname = @acctname then NULL else l.loginname end
    from master..syslogins l join #nt n on l.isntname = 1 and l.sid = n.sid
    where l.loginname = n.name and hasaccess = 1
    order by 3, 5
    return @@error
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

