## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_views_rowset\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_views_rowset**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -795719974 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@view_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@view_schema| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|TABLE_CATALOG|nvarchar|128|
|TABLE_SCHEMA|nvarchar|128|
|TABLE_NAME|nvarchar|128|
|VIEW_DEFINITION|nvarchar|1|
|CHECK_OPTION|bit|1|
|IS_UPDATABLE|bit|1|
|DESCRIPTION|nvarchar|1|
|DATE_CREATED|datetime|8|
|DATE_MODIFIED|datetime|8|

---
### Objects that depend on \[sys\].\[sp_views_rowset\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_views_rowset\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_views_rowset
(
    @view_name      sysname,
    @view_schema    sysname = null
)
as
    select
        TABLE_CATALOG   = db_name(),
        TABLE_SCHEMA    = schema_name(a_v.schema_id),
        TABLE_NAME      = a_v.name,
        VIEW_DEFINITION = convert(nvarchar(1),null),
        CHECK_OPTION    = convert(bit, NULL),
        IS_UPDATABLE    = convert(bit, NULL),
        DESCRIPTION     = convert(nvarchar(1),null),
        DATE_CREATED    = a_v.create_date,
        DATE_MODIFIED   = convert(datetime,null)
    from
        sys.all_views a_v
    where
        (
            (@view_schema is null and a_v.name = @view_name) or
            object_id(quotename(@view_schema) + '.' + quotename(@view_name)) = a_v.object_id
        ) and
        has_perms_by_name(quotename(schema_name(a_v.schema_id)) + '.' + quotename(@view_name),
                          'object',
                          'select') = 1
    order by 1, 2, 3
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

