## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_dbcmptlevel\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_dbcmptlevel**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -796040647 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@dbname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@new_cmptlevel| |tinyint|1|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|Available databases:|nvarchar|128|

---
### Objects that depend on \[sys\].\[sp_dbcmptlevel\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_dbcmptlevel\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_dbcmptlevel            -- 1997/04/15
    @dbname sysname = NULL,                    -- database name to change
    @new_cmptlevel tinyint = NULL OUTPUT    -- the new compatibility level to change to
as
    set nocount    on

    declare @exec_stmt nvarchar(max)
    declare @returncode    int
    declare @comptlevel    float(8)
    declare @dbid int                    -- dbid of the database
    declare @dbsid varbinary(85)        -- id of the owner of the database
    declare @orig_cmptlevel tinyint        -- original compatibility level
    declare @input_cmptlevel tinyint    -- compatibility level passed in by user
        ,@cmptlvl100 tinyint                -- compatibility to SQL Server Version 10.0
        ,@cmptlvl110 tinyint                -- compatibility to SQL Server Version 11.0
        ,@cmptlvl120 tinyint                -- compatibility to SQL Server Version 12.0
        ,@cmptlvl130 tinyint                -- compatibility to SQL Server Version 13.0
        ,@cmptlvl140 tinyint                -- compatibility to SQL Server Version 14.0
        
    select  @cmptlvl100 = 100,
            @cmptlvl110 = 110,
            @cmptlvl120 = 120,
            @cmptlvl130 = 130,
            @cmptlvl140 = 140

    -- SP MUST BE CALLED AT ADHOC LEVEL --
    if (@@nestlevel &gt; 1)
    begin
        raiserror(15432,-1,-1,'sys.sp_dbcmptlevel')
        return (1)
    end

    -- If no @dbname given, just list the valid compatibility level values.
    if @dbname is null
    begin
       raiserror (15048, -1, -1, @cmptlvl100, @cmptlvl110, @cmptlvl120, @cmptlvl130, @cmptlvl140)
       return (0)
    end
    
    --  Verify the database name and get info
    select @dbid = dbid, @dbsid = sid ,@orig_cmptlevel = cmptlevel
        from master.dbo.sysdatabases
        where name = @dbname

    --  If @dbname not found, say so and list the databases.
    if @dbid is null
    begin
        raiserror(15010,-1,-1,@dbname)
        print ' '
        select name as 'Available databases:'
            from master.dbo.sysdatabases
        return (1)
    end

    -- Now save the input compatibility level and initialize the return clevel
    -- to be the current clevel
    select @input_cmptlevel = @new_cmptlevel
    select @new_cmptlevel = @orig_cmptlevel

    -- If no clevel was supplied, display and output current level.
    if @input_cmptlevel is null
    begin
        raiserror(15054, -1, -1, @orig_cmptlevel)
        return(0)
    end

    -- If invalid clevel given, print usage and return error code
    -- 'usage: sp_dbcmptlevel [dbname [, compatibilitylevel]]'
    if @input_cmptlevel not in (@cmptlvl100, @cmptlvl110, @cmptlvl120, @cmptlvl130, @cmptlvl140)
    begin
        raiserror(15416, -1, -1)
        print ' '
        raiserror (15048, -1, -1, @cmptlvl100, @cmptlvl110, @cmptlvl120, @cmptlvl130, @cmptlvl140)
        return (1)
    end

    --  Only the SA or the dbo of @dbname can execute the update part
    --  of this procedure sys.so check.
    if (not (is_srvrolemember('sysadmin') = 1)) and suser_sid() &lt;&gt; @dbsid
        -- ALSO ALLOW db_owner ONLY IF DB REQUESTED IS CURRENT DB
        and (@dbid &lt;&gt; db_id() or is_member('db_owner') &lt;&gt; 1)
    begin
        raiserror(15418,-1,-1)
        return (1)
    end

    -- If we're in a transaction, disallow this since it might make recovery impossible.
    set implicit_transactions off
    if @@trancount &gt; 0
    begin
        raiserror(15002,-1,-1,'sys.sp_dbcmptlevel')
        return (1)
    end

    set @exec_stmt = 'ALTER DATABASE ' + quotename(@dbname, '[') + ' SET COMPATIBILITY_LEVEL = ' + cast(@input_cmptlevel as nvarchar(128))

    -- Note: database @dbname may not exist anymore
    exec(@exec_stmt)

    select @new_cmptlevel = @input_cmptlevel

    return (0) -- sp_dbcmptlevel
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

