## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_defaultdb\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_defaultdb**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -796297816 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@loginame| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@defdb| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_defaultdb\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_defaultdb\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_defaultdb
    @loginame   sysname,    -- login name
    @defdb      sysname     -- default db
as
    -- SETUP RUNTIME OPTIONS / DECLARE VARIABLES --
    set nocount on
    declare @exec_stmt nvarchar(4000)
    declare @ret    int    -- return value of sp call

    -- DISALLOW USER TRANSACTION --
    set implicit_transactions off
    IF (@@trancount &gt; 0)
    begin
        raiserror(15002,-1,-1,'sys.sp_defaultdb')
        return (1)
    end

    -- VALIDATE LOGIN NAME:
    execute @ret = sys.sp_validname @loginame
    if (@ret &lt;&gt; 0)
        return (1)

    -- VALIDATE DATABASE NAME --
    if @defdb is null
    begin
        raiserror(15010,-1,-1,@defdb)
        return (1)
    end

    BEGIN TRANSACTION
        -- LOCK LOGIN --
    EXEC %%LocalLogin(Name = @loginame).Lock(Exclusive = 0)

    -- ADD ROW FOR NT LOGIN IF NEEDED --
    if @@error &lt;&gt; 0    -- not found
    begin
        execute @ret = sys.sp_MSaddlogin_implicit_ntlogin @loginame
        if (@ret &lt;&gt; 0)
        begin
            ROLLBACK TRANSACTION
            raiserror(15007,-1,-1,@loginame)
            return (1)
        end
        -- login locked
    end

    -- CHANGE DEFAULT DATABASE --
    set @exec_stmt = 'alter login ' + quotename(@loginame) +
                ' with default_database = ' + quotename(@defdb)

    exec (@exec_stmt)

    if @@error &lt;&gt; 0
    begin
        ROLLBACK TRANSACTION
        return (1)
    end

    COMMIT TRANSACTION

    -- RETURN SUCCESS --
    return (0) -- sp_defaultdb
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

