## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_sqlagent_write_jobstep_log\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_sqlagent_write_jobstep_log**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -800368290 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@job_id| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@step_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@log_text| |nvarchar|1073741823|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_sqlagent_write_jobstep_log\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_sqlagent_write_jobstep_log\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE sys.sp_sqlagent_write_jobstep_log
    @job_id    UNIQUEIDENTIFIER, 
    @step_id   INT,
    @log_text  NVARCHAR(MAX)
AS
BEGIN
    DECLARE @retval INT

    -- Validate if current db context is supported
    EXEC @retval = sys.sp_sqlagent_verify_database_context
    IF (@retval &lt;&gt; 0)
    BEGIN
        RETURN(@retval)
    END

    -- If  job_id is null, then throw validation error
    IF(@job_id IS NULL)
    BEGIN
        RAISERROR(14262, -1, -1, '@job_id', 'NULL')
        RETURN(1) --Failure
    END

    -- Validate if given job_id exists in agent_jobs
    IF NOT EXISTS (SELECT name
                FROM sys.sqlagent_jobs
                WHERE job_id = @job_id)
    BEGIN
        DECLARE @job_id_as_char VARCHAR(36)
        SET @job_id_as_char = CONVERT(VARCHAR(36), @job_id)
        RAISERROR(14262, -1, -1, '@job_id', @job_id_as_char)
        RETURN(1) -- Failure
    END

    DECLARE @step_uid UNIQUEIDENTIFIER
        
    SELECT @step_uid = js.step_uid
    FROM sys.sqlagent_jobs j
    JOIN sys.sqlagent_jobsteps js
    ON js.job_id = j.job_id
    WHERE j.job_id = @job_id

    INSERT INTO sys.sqlagent_jobsteps_logs
    ([log_text], [date_created], [step_uid])
    VALUES(@log_text, GETDATE(), @step_uid)

    SET @retval = @@ERROR

    RETURN(@retval) -- 0 means success 
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

