## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_addextendedproperty\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_addextendedproperty**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -806860202 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@value| |sql_variant|8016|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@level0type| |varchar|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@level0name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@level1type| |varchar|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@level1name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@level2type| |varchar|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@level2name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_addextendedproperty\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_addextendedproperty\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_addextendedproperty
    @name sysname,
    @value sql_variant            = NULL,
    @level0type    varchar(128)    = NULL,
    @level0name    sysname            = NULL,
    @level1type    varchar(128)    = NULL,
    @level1name    sysname            = NULL,
    @level2type    varchar(128)    = NULL,
    @level2name    sysname            = NULL
as

    declare @ret int

    if datalength(@value) &gt; 7500
    begin
        raiserror(15097,-1,-1)
        return 1
    end
    
    if @name is null
    begin
        raiserror(15600,-1,-1,'sp_addextendedproperty')
        return (1)
    end

    execute @ret = sys.sp_validname @name
    if (@ret &lt;&gt; 0)
    begin
        raiserror(15600,-1,-1,'sp_addextendedproperty')
        return (1)
    end
        

    BEGIN TRANSACTION
    
    BEGIN TRY
        EXEC %%ExtendedPropertySet().AddValue(Name = @name, Value = @value, Level0type = @level0type, Level0name = @level0name, Level1type = @level1type, Level1name = @level1name, Level2type = @level2type, Level2name = @level2name) 
    END TRY

    BEGIN CATCH
        if (xact_state() &lt;&gt; 0) ROLLBACK TRANSACTION;
        THROW
    END CATCH
    
    COMMIT TRANSACTION
    return (0)
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

