## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSpeersendresponse\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSpeersendresponse**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -807018961 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@request_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@originator| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@originator_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@originator_publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSpeersendresponse\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSpeersendresponse\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSpeersendresponse
(
    @request_id                int,
    @originator                sysname,
    @originator_db            sysname,
    @originator_publication    sysname
)
as
begin
    set nocount on

    declare @retcode        int,
            @cmd            nvarchar(4000),
            @response_srvr    sysname,
            @response_db    sysname

    -- security check for subscriber
    -- Though the work below is related to a publisher, we use 
    -- a check for the subscriber because this is normally executed
    -- by the distribution agent at a subscriber (republisher).
    -- this should only be used by peer to peer subscribers.
    exec @retcode = sys.sp_MSreplcheck_subscribe 
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0 
    begin
        return 1
    end

    select @cmd = NULL,
            @response_srvr = publishingservername(),
            @response_db = db_name()

    -- if are on the originator then no-op
    if UPPER(@originator) = UPPER(@response_srvr)
            and @originator_db = @response_db
    begin
        return 0
    end
            
    begin transaction tr_sp_MSpeersendresponse
    save transaction tr_sp_MSpeersendresponse

    select @cmd = N'exec sys.sp_MSpeerapplyresponse @request_id=' + cast(@request_id as nvarchar) +
                                                N',@originator=N' + quotename(@originator, '''') +
                                                N',@originator_db=N' + quotename(@originator_db, '''') +
                                                N',@response_srvr=N' + quotename(@response_srvr, '''') +
                                                N',@response_db=N' + quotename(@response_db, '''')

    exec @retcode = sys.sp_MSpeertopeerfwdingexec @command = @cmd,
                                                    @publication = @originator_publication
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
        goto FAILURE

    commit transaction tr_sp_MSpeersendresponse

    return 0
FAILURE:
    rollback transaction tr_sp_MSpeersendresponse
    commit transaction

    return 1
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

