## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_adddatatypemapping\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_adddatatypemapping**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -814516740 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@source_dbms| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_version| |varchar|10|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_type| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_length_min| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_length_max| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_precision_min| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_precision_max| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_scale_min| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_scale_max| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_nullable| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@destination_dbms| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@destination_version| |varchar|10|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@destination_type| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@destination_length| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@destination_precision| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@destination_scale| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@destination_nullable| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@destination_createparams| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@dataloss| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@is_default| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_adddatatypemapping\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_adddatatypemapping\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

--
-- Name:
--        sp_adddatatypemapping
--
-- Description:
--        Add source/destination data type mapping
--
-- Returns:
--        0 if successful
--        1 if failed
--
-- Security:
--        public
--
-- Notes:
--        Implicitly will create a DBMS map if it doesn't
--        currently exist.  DBMS types must exist before
--        adding a mapping.  If no default currently
--        exists, this is set as the default mapping
--

CREATE PROCEDURE sys.sp_adddatatypemapping
(
    @source_dbms                sysname,
    @source_version                varchar(10) = NULL,
    @source_type                sysname,
    @source_length_min            bigint = NULL,
    @source_length_max            bigint = NULL,
    @source_precision_min        bigint = NULL,
    @source_precision_max        bigint = NULL,
    @source_scale_min            int = NULL,
    @source_scale_max            int = NULL,
    @source_nullable            bit = NULL,
    @destination_dbms            sysname,
    @destination_version        varchar(10) = NULL,
    @destination_type            sysname,
    @destination_length            bigint = NULL,
    @destination_precision        bigint = NULL,
    @destination_scale            int = NULL,
    @destination_nullable        bit = NULL,
    @destination_createparams    int = NULL,
    @dataloss                    bit = 0,
    @is_default                    bit = 0
)
AS
BEGIN
    DECLARE @retcode    int

    -- Issue unsupported warning
    RAISERROR(21769, 10, -1)

    -- Do data type mapping
    EXEC @retcode = sp_MSrepl_adddatatypemapping    @source_dbms                = @source_dbms,
                                                    @source_version                = @source_version,
                                                    @source_type                = @source_type,
                                                    @source_length_min            = @source_length_min,
                                                    @source_length_max            = @source_length_max,
                                                    @source_precision_min        = @source_precision_min,
                                                    @source_precision_max        = @source_precision_max,
                                                    @source_scale_min            = @source_scale_min,
                                                    @source_scale_max            = @source_scale_max,
                                                    @source_nullable            = @source_nullable,
                                                    @destination_dbms            = @destination_dbms,
                                                    @destination_version        = @destination_version,
                                                    @destination_type            = @destination_type,
                                                    @destination_length            = @destination_length,
                                                    @destination_precision        = @destination_precision,
                                                    @destination_scale            = @destination_scale,
                                                    @destination_nullable        = @destination_nullable,
                                                    @destination_createparams    = @destination_createparams,
                                                    @dataloss                    = @dataloss,
                                                    @is_default                    = @is_default

    RETURN @retcode
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

