## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSenum_qreader_sd\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSenum_qreader_sd**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -822478103 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@time| |datetime|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSenum_qreader_sd\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSenum_qreader_sd\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSenum_qreader_sd 
(
    @publication_id int = 0, 
    @time datetime = NULL
)
as
begin
    set nocount on

    declare @time_up datetime
                ,@agent_id int
                ,@final_ts timestamp
                ,@initial_ts timestamp
                ,@session_start timestamp
                ,@next_session_start timestamp
                ,@session_end timestamp

    --
    -- security check
    -- only replmonitor can execute this
    --
    if not (is_member(N'db_owner') = 1 or isnull(is_member(N'replmonitor'),0) = 1)
    begin
        raiserror(14260, 16, -1)
        return (1)
    end

    if (@publication_id = 0)
        select @publication_id = NULL
        
    IF @time IS NULL
        select @time = GETDATE()

    /*
    ** Minute-approximate @time can be used.
    ** Note: The select only return datetime data with minute precision
    */
    IF ( (DATEPART(second, @time) = 0) AND
            (DATEPART(millisecond, @time) = 0) )
    BEGIN
        SELECT @time_up = DATEADD(second, +59, @time)
        SELECT @time_up = DATEADD(millisecond, +999, @time)
    END
    ELSE
        SELECT @time_up = @time

    --
    -- Get the agent id
    --
    select TOP 1 @agent_id = agent_id from MSqreader_history with (READPAST)

    --
    -- Get the session start, next session start timestamps
    --
    select @initial_ts = min(timestamp), @final_ts = max(timestamp) from MSqreader_history with (READPAST)
    
    select @session_start = ISNULL(max(timestamp), @initial_ts) from MSqreader_history with (READPAST)
            where agent_id = @agent_id and time &lt;= @time_up and runstatus = 1
            
    select @next_session_start = ISNULL(min(timestamp), @final_ts) from MSqreader_history
            where agent_id = @agent_id and timestamp &gt; @session_start and runstatus = 1

    --
    -- find session end based on @next_session_start
    --
    if (@next_session_start = @final_ts)
        select @session_end = @final_ts
    else
    begin
        select @session_end = max(timestamp)
        from MSqreader_history
        where agent_id = @agent_id and
            timestamp &gt; @session_start and 
            timestamp &lt; @next_session_start
    end
    
    --
    -- Do the select now
    --
    select  runstatus, 
        'time' = sys.fn_replformatdatetime(time), 
        comments, 
        transaction_id, 
        transaction_status,
        commands_processed,
        subscriber,
        subscriberdb,
        'error_id' = ISNULL(error_id, 0)
    from MSqreader_history with (READPAST)
    where
        agent_id = @agent_id and
        timestamp &gt;= @session_start and
        timestamp &lt;= @session_end
     and comments not like N'&lt;stats state%'
 order by timestamp desc
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

