## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSupdate_singlelogicalrecordmetadata\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSupdate_singlelogicalrecordmetadata**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -82268673 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@logical_record_parent_nickname| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@logical_record_parent_rowguid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@replnick| |binary|6|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@parent_row_inserted| |bit|1|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSupdate_singlelogicalrecordmetadata\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSupdate_singlelogicalrecordmetadata\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

-- Requires Certificate signature for catalog access
create procedure sys.sp_MSupdate_singlelogicalrecordmetadata    @logical_record_parent_nickname int, 
                                                                @logical_record_parent_rowguid uniqueidentifier, 
                                                                @replnick binary(6),
                                                                @parent_row_inserted bit output
as
    declare @logical_record_parent_oldmaxversion int, 
            @logical_record_lineage varbinary(311), 
            @logical_record_parent_regular_lineage varbinary(311), 
            @logical_record_parent_gencur bigint,
            @rows_updated int,
            @error int,
            @logical_record_parent_pubid uniqueidentifier,
            @logical_record_parent_objid int,
            @unqual_sourcename nvarchar(540),
            @source_object nvarchar(270)

    select top 1 @logical_record_parent_pubid = pubid, @logical_record_parent_objid = objid 
    from dbo.sysmergearticles 
    where nickname = @logical_record_parent_nickname

    select @source_object = QUOTENAME(SCHEMA_NAME(schema_id)) + '.' + QUOTENAME(name) 
    from sys.objects 
    where object_id = @logical_record_parent_objid
                
    select @unqual_sourcename = sys.fn_replreplacesinglequote(@source_object)
    
    if ((object_name(@logical_record_parent_objid) is null
            or (has_perms_by_name(@unqual_sourcename, 'OBJECT', 'SELECT') 
                |has_perms_by_name(@unqual_sourcename, 'OBJECT', 'UPDATE')
                |has_perms_by_name(@unqual_sourcename, 'OBJECT', 'INSERT')
                |has_perms_by_name(@unqual_sourcename, 'OBJECT', 'DELETE')=0))
        and {fn ISPALUSER(@logical_record_parent_pubid)} &lt;&gt; 1)
    begin
        raiserror(15247, 11, -1)
        return 1
    end
    
    select @parent_row_inserted = 0
    
    if @logical_record_parent_rowguid is null
        return 0
    
    select top 1    @logical_record_parent_oldmaxversion = maxversion_at_cleanup
    from dbo.sysmergearticles 
    where nickname = @logical_record_parent_nickname

    exec sys.sp_MSmerge_getgencur @logical_record_parent_nickname, 1, @logical_record_parent_gencur output
    
    update dbo.MSmerge_tombstone 
        set logical_record_lineage = { fn UPDATELINEAGE(logical_record_lineage, @replnick, @logical_record_parent_oldmaxversion+1) }
        where tablenick = @logical_record_parent_nickname
        and rowguid = @logical_record_parent_rowguid
    select @rows_updated = @@rowcount, @error = @@error
    
    if @error &lt;&gt; 0
        return 1
        
    if @rows_updated = 1
        return 0 -- no need to insert tombstone if rows_updated = 0. This proc is never called to insert a parent's tombstone.
    
    update dbo.MSmerge_contents 
        set logical_record_lineage = { fn UPDATELINEAGE(logical_record_lineage, @replnick, @logical_record_parent_oldmaxversion+1) }
        where tablenick = @logical_record_parent_nickname
        and rowguid = @logical_record_parent_rowguid
    select @rows_updated = @@rowcount, @error = @@error
    
    if @error &lt;&gt; 0
        return 1
        
    if @rows_updated = 0
    begin
        select @logical_record_lineage = { fn UPDATELINEAGE(0x0, @replnick, @logical_record_parent_oldmaxversion+1) }
        
        -- if no cleanup done yet, use 1 as the version.
        if @logical_record_parent_oldmaxversion = 1
            select @logical_record_parent_regular_lineage = { fn UPDATELINEAGE(0x0, @replnick, 1) }
        else 
            select @logical_record_parent_regular_lineage = @logical_record_lineage
            
        insert into dbo.MSmerge_contents (tablenick, rowguid, lineage, colv1, generation, partchangegen,                                            
                logical_record_parent_rowguid, logical_record_lineage) 
            values (@logical_record_parent_nickname, @logical_record_parent_rowguid, @logical_record_parent_regular_lineage, 
                0x00, @logical_record_parent_gencur, NULL, @logical_record_parent_rowguid, @logical_record_lineage)
        if @@error &lt;&gt; 0
            return 1
        
        select @parent_row_inserted = 1
    end
    
    return 0

GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

