## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_cdc_vupgrade_databases\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_cdc_vupgrade_databases**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -824212303 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
 No parameters exist

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_cdc_vupgrade_databases\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_cdc_vupgrade_databases\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure [sys].[sp_cdc_vupgrade_databases]
as
begin
    declare @db_name sysname
        ,@stmt nvarchar(max)
        ,@raised_error int
        ,@raised_message nvarchar(4000)

    set nocount on

    -- Upgrade all CDC enabled databases
    declare #c_cdc_databases CURSOR LOCAL FORWARD_ONLY for 
        
        SELECT name
        FROM sys.databases
        WHERE is_cdc_enabled = 1 and is_read_only = 0

    open #c_cdc_databases
    fetch #c_cdc_databases into @db_name
    while (@@fetch_status != -1)
    begin 
        -- Call sp_cdc_vupgrade for the CDC enabled database
        set @stmt = quotename(@db_name) + N'.sys.sp_cdc_vupgrade'
        
        begin try
            exec sp_executesql @stmt
        end try
        
        begin catch
            -- Report error as information message and keep going
            select @raised_error = ERROR_NUMBER()
            select @raised_message = ERROR_MESSAGE()
            raiserror(22861, 10, -1, @db_name, @raised_error, @raised_message)  
        end catch
        
        fetch #c_cdc_databases into @db_name

    end -- while cursor

    close #c_cdc_databases
    deallocate #c_cdc_databases
    
    return 0

end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

