## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSpeerdbinfo\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSpeerdbinfo**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -825440453 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@is_p2p| |bit|1|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@current_version| |int|4|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSpeerdbinfo\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSpeerdbinfo\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
--
-- Name: 
--        sp_MSpeerdbinfo
-- 
-- Description: 
--        Checks to see if this database contains any peer to peer publications. If so, it
--        will also output the guid restore version value as an int.
--     
-- Parameters: 
--         See the procedure definition.
--
-- Returns: 
--        0 - succeeded
--      1 - failed
--
-- Result: 
--        None
--
-- Security: 
--        Called by logreader agents  (must be made public).
--        SYSADMIN or DBO of publisher db
--
create procedure sys.sp_MSpeerdbinfo
(
    @is_p2p                bit output,
    @current_version     int output
)
as
begin
    declare @retcode int
    
    declare @OPT_ENABLED_FOR_P2P int
    
    select @OPT_ENABLED_FOR_P2P = 0x1

    -- Security Check
    exec @retcode = sys.sp_MSreplcheck_publish
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
    begin
        return 1
    end
    
    -- only retrieve the data if the database is published. return 
    -- error since this should not be called on non-published db
    if sys.fn_MSrepl_istranpublished(db_name(),0) != 1
    begin
        select @is_p2p = 0,
                @current_version = 0

        return 1
    end

    -- check if any publication is enabled for P2P
    if exists (select *
                from syspublications 
                where (options &amp; @OPT_ENABLED_FOR_P2P) = @OPT_ENABLED_FOR_P2P)
    begin
        select @is_p2p = 1

        exec @retcode = sys.sp_MSgetdbversion @current_version = @current_version output
        if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
            return 1
    end
    else
    begin
        select @is_p2p = 0,
            @current_version = 0
    end

    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

