## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_publication_validation\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_publication_validation**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -8272502 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@rowcount_only| |smallint|2|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@full_or_fast| |tinyint|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@shutdown_agent| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_publication_validation\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_publication_validation\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE sys.sp_publication_validation
(
    @publication     sysname,    /* publication name */
    @rowcount_only     smallint = 1,    /* type of check requested */       
    @full_or_fast     tinyint = 2,    /* full (0) fast (1), or conditional fast (2)  method to calculate rowcount */
    @shutdown_agent bit = 0,    /* shut down agent after validation if 1 */
    @publisher     sysname = NULL    /* only non-null for heterogeneous publishers */    
)
AS
BEGIN
    DECLARE @cmd            nvarchar(4000)
    DECLARE @retcode        int
    DECLARE @publisher_type    sysname

    SET @retcode = 0

    
    -- Security Check
    -- No reason anyone but Sysadmin or dbo of publishing db should run this
    exec @retcode = sys.sp_MSreplcheck_publish
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
    begin
        return (1)
    end
    
    EXEC @retcode = sys.sp_MSrepl_getpublisherinfo    @publisher      = @publisher,
                                                    @publisher_type    = @publisher_type OUTPUT,
                                                    @rpcheader      = @cmd OUTPUT
    
    IF @retcode &lt;&gt; 0
        RETURN (@retcode)

    if (@publisher_type = 'MSSQLSERVER')
    begin
        
        SET @cmd = @cmd + N'dbo.sp_MSpublication_validation '

        EXEC @retcode = @cmd
                @publication,
                @rowcount_only,
                @full_or_fast,
                @shutdown_agent
                    
    end
    else
    begin
        -- Heterogeneous articles are handled directly by sp_IHpublication_validation
        SET @publisher = UPPER(@publisher) COLLATE DATABASE_DEFAULT
        set @cmd = @cmd + N'sys.sp_IHpublication_validation '

        EXEC @retcode = @cmd
                @publication,
                @rowcount_only,
                @full_or_fast,
                @shutdown_agent,
                @publisher
    end    

    RETURN (@retcode)
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

