## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_helprole\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_helprole**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -827901970 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@rolename| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|RoleName|nvarchar|128|
|RoleId|int|4|
|IsAppRole|int|4|

|Name |Datatype |Max length |
|-|-|-|
|RoleName|nvarchar|128|
|RoleId|int|4|
|IsAppRole|int|4|

---
### Objects that depend on \[sys\].\[sp_helprole\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_helprole\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_helprole
    @rolename       sysname = NULL
AS
    if @rolename is not null
    begin
        -- VALIDATE GIVEN NAME
        if not exists (select * from sys.database_principals where name = @rolename and (type = 'R' or type = 'A'))
        begin
            raiserror(15409, -1, -1, @rolename)
            return (1)
        end

        -- RESULT SET FOR SINGLE ROLE
        select 'RoleName' = name, 'RoleId' = principal_id, 'IsAppRole' = case type when 'A' then 1 else 0 end
            from sys.database_principals
            where (name = @rolename) and (type = 'R' or type = 'A')
    end
    else
    begin
        -- RESULT SET FOR ALL ROLES
        select 'RoleName' = name, 'RoleId' = principal_id, 'IsAppRole' = case type when 'A' then 1 else 0 end
            from sys.database_principals where (type = 'R' or type = 'A')
    end

    return (0) -- sp_helprole
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

