## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MShelpmergedynamicsnapshotjob\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MShelpmergedynamicsnapshotjob**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -82836045 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@dynamic_snapshot_jobname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@dynamic_snapshot_jobid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MShelpmergedynamicsnapshotjob\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MShelpmergedynamicsnapshotjob\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
--
-- Name: sp_MShelpmergedynamicsnapshotjob
--
-- Description: This procedure returns a listing of dynamic snapshot jobs.
--                
-- Parameters: @publication sysname (optional, default '%'): When @publication
--               is '%', all dynamic snapshot jobs with the matching 
--               @dynamic_snapshot_jobid and @dynamic_snapshot_jobname will be 
--               returned.
--               @dynamic_snapshot_jobname sysname (optional, default '%'): When 
--               @dynamic_snapshot_jobname is '%', all dynamic snapshot jobs that
--               belong to @publication with the matching @dynamic_snapshot_jobid
--               will be returned.  
--               @dynamic_snapshot_jobid (optional, default null): When 
--               @dynamic_snapshot_jobid is null, all dynamic snapshot jobs 
--               that belong to @publication with the matching 
--               @dynamic_snapshot_jobname will be returned.
--
-- Notes: If all parameters are left unspecified when this procedure is called,
--          all dynamic snapshot jobs for the current database will be returned.
--
-- Result: id int
--           job_name sysname 
--           job_id uniqueidentifier -- job id of the dynamic snapshot job
--           dynamic_filter_login sysname 
--           dynamic_filter_hostname sysname
--           dynamic_snapshot_location nvarchar(255) 
-- Returns: 0 - succeeded
--            1 - failed
--
-- Security: Execute permission of this stored procedure is granted to public
-- Requires Certificate signature for catalog access
--
create procedure sys.sp_MShelpmergedynamicsnapshotjob (
    @publication sysname = N'%',
    @dynamic_snapshot_jobname sysname = N'%',
    @dynamic_snapshot_jobid uniqueidentifier = null
    )
as
begin
    set nocount on
    declare @retcode int

    exec @retcode = sys.sp_MSreplcheck_publish
    if @@error&lt;&gt;0 or @retcode&lt;&gt;0
        return 1
    
    if object_id('sysmergepublications') is NULL
    begin
        return 0
    end

    select 'id' = j.id,
           'job_name' = j.name,
           'job_id' = j.job_id, 
           'suser_sname' = j.dynamic_filter_login,
           'host_name' = j.dynamic_filter_hostname,
           'dynamic_snapshot_location' = j.dynamic_snapshot_location
      from dbo.sysmergepublications p
     inner join MSdynamicsnapshotjobs j
        on p.pubid = j.pubid
     where (p.name = @publication or @publication = N'%')
       and (j.name = @dynamic_snapshot_jobname or @dynamic_snapshot_jobname = N'%')
       and (j.job_id = @dynamic_snapshot_jobid or @dynamic_snapshot_jobid is null) 

    if @@error &lt;&gt; 0
        return (1)
    else
        return (0)

end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

