## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MScreatedisabledmltrigger\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MScreatedisabledmltrigger**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -835496152 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@source_object| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_owner| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MScreatedisabledmltrigger\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MScreatedisabledmltrigger\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MScreatedisabledmltrigger
    @source_object sysname,
    @source_owner sysname
as
    declare @artid uniqueidentifier
    declare @cmd nvarchar(1000)
    declare @triggername nvarchar(130)
    declare @guidstr nchar(32)
    declare @retcode int
    declare @qualified_tablename nvarchar(517)
    declare @qualified_trig_name nvarchar(517)
    declare @objid int

    /*
    ** Security Check
    */
    EXEC @retcode = sys.sp_MSreplcheck_publish
    IF @@ERROR &lt;&gt; 0 or @retcode &lt;&gt; 0
        return (1)

    select @qualified_tablename = quotename(@source_owner) + '.' + quotename(@source_object)

    select @objid = object_id(@qualified_tablename)
    if @objid is NULL
        return 1

    select top 1 @artid = artid from dbo.sysmergearticles where objid=@objid
    if @artid is NULL
        return 1
    
    exec @retcode=sys.sp_MSguidtostr @artid, @guidstr out
    if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0 
        return (1)

    -- remove disable dml trigger, if it exists
    set @triggername= 'MSmerge_disabledml_' + @guidstr
    if @source_owner is not NULL
        select @qualified_trig_name = quotename(@source_owner) + '.' + quotename(@triggername)
    else
        select @qualified_trig_name = quotename(@triggername)
    
    if object_id(@qualified_trig_name, 'TR') is not null
    begin
        set @cmd= 'drop trigger ' + @qualified_trig_name 
        exec sys.sp_executesql @cmd
        if @@error &lt;&gt; 0 
            return 1
    end

    set @cmd='
    create trigger ' + quotename(@triggername) + ' on ' + @qualified_tablename + ' for update, insert, delete
        not for replication
    as
        set nocount on

        if @@trancount &gt; 0 rollback tran
        raiserror (20092, 16, -1, ''' + sys.fn_replreplacesinglequote(@qualified_tablename) + ''')

        return'

    exec sys.sp_executesql @cmd
    if @@error &lt;&gt; 0 
        return 1

    -- Only mark the trigger as system object if it is owned by dbo.
    if exists (select * from sys.objects where name = @triggername and SCHEMA_NAME(schema_id) = 'dbo')
    begin
        exec @retcode = sys.sp_MS_marksystemobject  @triggername 
        if @@ERROR&lt;&gt;0 OR @retcode &lt;&gt;0 
            return 1
    end

    return 0
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

