## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSrequestreenumeration_lightweight\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSrequestreenumeration_lightweight**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -837731001 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@tablenick| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@rowguid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSrequestreenumeration_lightweight\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSrequestreenumeration_lightweight\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSrequestreenumeration_lightweight
                        @tablenick int,
                        @rowguid uniqueidentifier
                        
as
    declare @retcode int
    declare @err int
    declare @rc int
    declare @METADATA_ACTION_ForceReenumeration tinyint

    set @METADATA_ACTION_ForceReenumeration= 5

    -- security check
    exec @retcode = sys.sp_MSreplcheck_subscribe 
    if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0 return 1

    update dbo.MSmerge_metadataaction_request
        set action= @METADATA_ACTION_ForceReenumeration,
            generation=null,
            changed= sys.fn_MSdayasnumber(getdate())
        where tablenick=@tablenick and rowguid=@rowguid

    select @err= @@error, @rc=@@rowcount
    if @err&lt;&gt;0 return 1
    if @rc&gt;0 return 0

    insert into dbo.MSmerge_metadataaction_request
                        (tablenick,
                         rowguid,
                         action,
                         generation,
                         changed)
                    values
                        (@tablenick,
                         @rowguid,
                         @METADATA_ACTION_ForceReenumeration,
                         null,
                         sys.fn_MSdayasnumber(getdate()))
                         
    if @err&lt;&gt;0 return 1
    return 0
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

