## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_helpsubscription\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_helpsubscription**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -838912217 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@article| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscriber| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@destination_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@found| |int|4|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_helpsubscription\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_helpsubscription\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

--
-- Name:    
--          sp_helpsubscription
--          
-- Description: 
--          Lists subscription information associated with a particular publication, article,
--            Subscriber, or set of subscriptions. This stored procedure is executed at a Publisher
--            on the publication database.
--  
-- Security: 
--          Public
--
-- Returns:
--          Result set of subscription properties
--      
-- Owner:   
--          &lt;current owner&gt; 

create procedure sys.sp_helpsubscription
(
    @publication    sysname = '%',
    @article        sysname = '%',
    @subscriber        sysname = N'%',
    @destination_db    sysname = '%',
    @found            int = 23456 OUTPUT,
    @publisher        sysname = NULL
)
AS
BEGIN
    DECLARE @cmd            nvarchar(4000)
    DECLARE @retcode        int
    DECLARE @publisher_type    sysname

    SET @retcode = 0

    EXEC @retcode = sys.sp_MSrepl_getpublisherinfo    @publisher            = @publisher,
                                                    @publisher_type        = @publisher_type OUTPUT,
                                                    @rpcheader            = @cmd OUTPUT,
                                                    @skipSecurityCheck    = 1

    IF @retcode &lt;&gt; 0
        RETURN (@retcode)

    SET @publisher = UPPER(@publisher) COLLATE DATABASE_DEFAULT
    set @cmd = @cmd + N'sys.sp_MSrepl_helpsubscription'
    
    EXEC @retcode = @cmd
                    @publication,
                    @article,
                    @subscriber,
                    @destination_db,
                    @found OUTPUT,
                    @publisher,
                    @publisher_type

    RETURN (@retcode)
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

