## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_objectfilegroup\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_objectfilegroup**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -8414153 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@objid| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|Data_located_on_filegroup|nvarchar|128|

|Name |Datatype |Max length |
|-|-|-|
|Data_located_on_filegroup|varchar|14|

---
### Objects that depend on \[sys\].\[sp_objectfilegroup\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_objectfilegroup\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_objectfilegroup --- 1996/08/30 17:44
@objid    int
as
    /*
    ** Print out the object's data filegroup if applicable.
    */
    if exists (select * from sys.objects$
            where object_id = @objid
            and type in ('S ','U ')
            and is_memory_optimized = 0)
        begin
            select Data_located_on_filegroup = d.name
            from sys.data_spaces d
            where d.data_space_id =
            (select i.data_space_id from sys.indexes i
             where i.object_id = @objid and i.index_id &lt; 2)
        end

    /*
    **  It's not a table (or it's a memory optimized table) so segment is not applicable.
    */
    else
        select Data_located_on_filegroup = 'not applicable'

return (0) -- sp_objectfilegroup
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

