## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSchange_mergepublication\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSchange_mergepublication**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -845880397 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@pubid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@property| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@value| |nvarchar|2000|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSchange_mergepublication\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSchange_mergepublication\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSchange_mergepublication (
    @pubid uniqueidentifier,
    @property sysname = NULL,
    @value nvarchar(2000) = NULL
    ) AS

    set nocount on

    declare @value_numeric int
    declare @value_bit bit
    -- Security check
    if 1 &lt;&gt; is_member('db_owner')
    begin    
        RAISERROR (15247, 11, -1)
        return (1)
    end

    /*
    ** Parameter Check:     @property.
    ** Check to make sure that @property is a valid property
    */
    if @property IS NULL OR LOWER(@property collate SQL_Latin1_General_CP1_CS_AS) NOT in 
                                                    ('allow_subscription_copy',
                                                    'centralized_conflicts',
                                                    'conflict_logging',
                                                    'generation_leveling_threshold',
                                                    'automatic_reinitialization_policy')
    begin
        raiserror (21053, 16, -1, @property)
        return (1)
    end

    BEGIN TRAN MSchange_mergepublication    
    save tran MSchange_mergepublication
        
    if lower(@property collate SQL_Latin1_General_CP1_CS_AS) = 'allow_subscription_copy'
    begin
        if LOWER(@value collate SQL_Latin1_General_CP1_CS_AS) = 'true'
            select @value_bit = 1
        else 
            select @value_bit = 0

        UPDATE dbo.sysmergepublications 
            SET allow_subscription_copy = @value_bit
            WHERE pubid = @pubid
        if @@error &lt;&gt; 0
        BEGIN
           GOTO UNDO
        END
    end
    else if lower(@property collate SQL_Latin1_General_CP1_CS_AS) = 'centralized_conflicts'
    begin
        if LOWER(@value collate SQL_Latin1_General_CP1_CS_AS) = 'true'
            select @value_numeric = 1
        else 
            select @value_numeric = 0
    
        UPDATE dbo.sysmergepublications 
            SET centralized_conflicts = @value_numeric,
                decentralized_conflicts = case @value_numeric
                                            when 1 then 0
                                            else 0
                                          end
            WHERE pubid = @pubid
        if @@error &lt;&gt; 0
        BEGIN
           GOTO UNDO
        END
    end
    else if lower(@property collate SQL_Latin1_General_CP1_CS_AS) = 'conflict_logging'
    begin
        if LOWER(@value collate SQL_Latin1_General_CP1_CS_AS) = 'publisher'
            select @value_numeric = 1
        else if LOWER(@value collate SQL_Latin1_General_CP1_CS_AS) = 'both'
            select @value_numeric = 2
        else 
            select @value_numeric = 0
    
        UPDATE dbo.sysmergepublications 
            SET centralized_conflicts = case @value_numeric
                                            when 1 then 1
                                            when 2 then 1
                                            else 0
                                        end,
                decentralized_conflicts = case @value_numeric
                                            when 1 then 0
                                            when 2 then 1
                                            else 0
                                          end
            WHERE pubid = @pubid
        if @@error &lt;&gt; 0
        BEGIN
           GOTO UNDO
        END
    end
    else if lower(@property collate SQL_Latin1_General_CP1_CS_AS) = 'generation_leveling_threshold'
    begin
        select @value_numeric = convert(int, @value)
        
        UPDATE dbo.sysmergepublications 
            SET generation_leveling_threshold = @value_numeric
            WHERE pubid = @pubid
        if @@error &lt;&gt; 0
        BEGIN
           GOTO UNDO
        END
    end
    else if lower(@property collate SQL_Latin1_General_CP1_CS_AS) = 'automatic_reinitialization_policy'
    begin
        UPDATE dbo.sysmergepublications 
            SET automatic_reinitialization_policy = @value
            WHERE pubid = @pubid
        if @@error &lt;&gt; 0 GOTO UNDO
    end
                    
    COMMIT TRAN
    return 0

UNDO: 
    if @@TRANCOUNT &gt; 0
    begin
        ROLLBACK TRANSACTION MSchange_mergepublication
        COMMIT TRANSACTION
    end
    
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

