## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_getVolumeFreeSpace\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_getVolumeFreeSpace**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -853689781 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@database_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@file_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|(No column name)|bigint|8|

---
### Objects that depend on \[sys\].\[sp_getVolumeFreeSpace\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_getVolumeFreeSpace\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE sys.sp_getVolumeFreeSpace
@database_name sysname,
@file_id int
AS
BEGIN

    IF(DB_NAME() != 'msdb')
    BEGIN
        RAISERROR(14416,-1,-1)
        RETURN 14416
    END
    IF ( HAS_PERMS_BY_NAME(null, null, 'VIEW SERVER STATE') != 1 )
    BEGIN
        RAISERROR(38002, -1, -1, 'View Server State')
        RETURN 38002
    END
    DECLARE @physicalfilename nvarchar(260)
    SELECT @physicalfilename = physical_name FROM sys.master_files WHERE database_id = DB_ID(@database_name) AND file_id = @file_id
    IF(@physicalfilename IS NULL)
    BEGIN
        RAISERROR(38001,-1,-1,@file_id,@database_name)
        RETURN 38001
    END
    SELECT sys.fn_getVolumeFreeSpace_internal(@physicalfilename)
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

