## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_assembly_dependencies_rowset\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_assembly_dependencies_rowset**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -858873152 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@assembly_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@assembly_schema| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@assembly_referenced| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|ASSEMBLY_CATALOG|nvarchar|128|
|ASSEMBLY_SCHEMA|nvarchar|128|
|ASSEMBLY_ID|int|4|
|REFERENCED_ASSEMBLY_ID|int|4|

---
### Objects that depend on \[sys\].\[sp_assembly_dependencies_rowset\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_assembly_dependencies_rowset\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_assembly_dependencies_rowset
(
    @assembly_id            int = null,
    @assembly_schema        sysname = null,
    @assembly_referenced    int = null
)
as
    select
        ASSEMBLY_CATALOG        = db_name(),
        ASSEMBLY_SCHEMA         = user_name(a.principal_id),
        ASSEMBLY_ID             = ar.assembly_id,
        REFERENCED_ASSEMBLY_ID  = ar.referenced_assembly_id
    from
        sys.assembly_references ar inner join
        sys.assemblies a on
            (
                a.assembly_id = ar.assembly_id
            )
    where
        ar.assembly_id = @assembly_id and
        (@assembly_schema is null or a.principal_id = user_id(@assembly_schema)) and
        (@assembly_referenced is null or @assembly_referenced = 0 or @assembly_referenced = ar.referenced_assembly_id)
    order by 1, 2
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

