## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSrepl_setNFR\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSrepl_setNFR**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -865569767 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@schema| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@object_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSrepl_setNFR\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSrepl_setNFR\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_MSrepl_setNFR
(
    @schema         sysname,
    @object_name     sysname
)
AS
BEGIN
    DECLARE @retcode    int,
            @fkid        int

    -- security check for subscriber
    EXEC @retcode = sys.sp_MSreplcheck_subscribe 
    IF @@ERROR &lt;&gt; 0 OR @retcode &lt;&gt; 0 
    BEGIN
        RETURN 1
    END
    
    DECLARE #hForeignKeys CURSOR LOCAL FAST_FORWARD FOR
        SELECT object_id
            FROM sys.foreign_keys
            WHERE is_not_for_replication = 0
                AND referenced_object_id = OBJECT_ID(QUOTENAME(@schema) + '.' + QUOTENAME(@object_name))
            ORDER BY object_id
            
    OPEN #hForeignKeys

    FETCH #hForeignKeys INTO @fkid

    WHILE @@FETCH_STATUS != -1
    BEGIN
        EXEC %%Object(ID = @fkid).SetConstraintNotForRepl(Value = 1)
        IF @@ERROR &lt;&gt; 0
            RETURN 1

        FETCH #hForeignKeys INTO @fkid
    END

    CLOSE #hForeignKeys

    RETURN 0
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

