## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_identitycolumnforreplication\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_identitycolumnforreplication**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -867778948 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@object_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@value| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_identitycolumnforreplication\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_identitycolumnforreplication\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
--
-- Name:
--         sp_identitycolumnforreplication
--
-- Description:
--      This procedure allows customers to set the NFR on
--        identity columns for a particular table.
--    
-- Returns:
--      0-Success 1-Failure
--
-- Security: DBO check
--
-- Requires Certificate signature for catalog access
--
CREATE PROCEDURE sys.sp_identitycolumnforreplication
(
    @object_id    int,
    @value        bit
)
AS
BEGIN
    DECLARE @identity_column sysname

    IF IS_SRVROLEMEMBER('sysadmin') = 0
        AND IS_MEMBER('db_owner') = 0
    BEGIN
        RAISERROR(21050, 14, -1)
        RETURN 1
    END

    SELECT @identity_column = NULL

    SELECT @identity_column = name 
        FROM sys.columns
        WHERE object_id = @object_id
            AND COLUMNPROPERTY(object_id, name, 'IsIdentity') = 1
    IF @identity_column IS NOT NULL
    BEGIN
        EXEC %%ColumnEx(ObjectID = @object_id, Name = @identity_column).SetIdentityNotForRepl(Value = @value)
        IF @@ERROR &lt;&gt; 0 
            RETURN 1
    END

    RETURN 0
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

