## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_help_log_shipping_secondary_primary\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_help_log_shipping_secondary_primary**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -86946328 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@primary_server| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@primary_database| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|secondary_id|uniqueidentifier|16|
|primary_server|nvarchar|128|
|primary_database|nvarchar|128|
|backup_source_directory|nvarchar|500|
|backup_destination_directory|nvarchar|500|
|file_retention_period|int|4|
|copy_job_id|uniqueidentifier|16|
|restore_job_id|uniqueidentifier|16|
|monitor_server|nvarchar|128|
|monitor_server_security_mode|bit|1|

---
### Objects that depend on \[sys\].\[sp_help_log_shipping_secondary_primary\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_help_log_shipping_secondary_primary\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_help_log_shipping_secondary_primary 
(
    @primary_server sysname -- cannot be NULL
    ,@primary_database sysname -- cannot be NULL
)
as
begin
    set nocount on
    declare @retcode int

    --
    -- security check
    --
    exec @retcode = sys.sp_MSlogshippingsysadmincheck
    if (@retcode != 0 or @@error != 0)
        return 1
    --
    -- must be invoked from master db
    --
    if (db_name() != N'master')
    begin
        raiserror(5001, 16,-1)
        return 1
    end
    --
    -- select the result from log_shipping_secondary
    --
    select 
        secondary_id
        ,primary_server
        ,primary_database
        ,backup_source_directory
        ,backup_destination_directory
        ,file_retention_period
        ,copy_job_id
        ,restore_job_id
        ,'monitor_server' = case when (user_specified_monitor = 1) then monitor_server else cast(NULL as sysname) end
        ,'monitor_server_security_mode' = case when (user_specified_monitor = 1) then monitor_server_security_mode else cast(NULL as bit) end
    from msdb.dbo.log_shipping_secondary
    where primary_server = upper(@primary_server)
        and primary_database = @primary_database 
    --
    -- all done
    --
    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

