## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSinsertdeleteconflict\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSinsertdeleteconflict**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -879099726 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@tablenick| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@rowguid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@conflict_type| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@reason_code| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@reason_text| |nvarchar|720|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@origin_datasource| |nvarchar|255|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@pubid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@lineage| |varbinary|311|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@conflicts_logged| |int|4|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@compatlevel| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@source_id| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSinsertdeleteconflict\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSinsertdeleteconflict\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSinsertdeleteconflict(  
    @tablenick          int,
    @rowguid            uniqueidentifier,
    @conflict_type      int,
    @reason_code        int,
    @reason_text        nvarchar(720),
    @origin_datasource  nvarchar(255),
    @pubid              uniqueidentifier,
    @lineage            varbinary(311) = NULL,
    @conflicts_logged   INT = NULL OUTPUT,
    @compatlevel int = 10,  
    @source_id                  uniqueidentifier = NULL) -- backward compatibility level, default=Sphinx
as
    declare @retcode int
    
    select @source_id = newid()
    /*
    ** Check to see if current publication has permission
    */
    if ({fn ISPALUSER(@pubid)} &lt;&gt; 1)
    begin
        if (@pubid is NULL)
        begin
                RAISERROR (21723, 16, -1, 'sp_MSinsertdeleteconflict')
                return 1
        end
        else
        begin
                RAISERROR (14126, 11, -1)
                return 1
        end
    end

    /* Parameter validation */
    if (@tablenick is null)
    begin
        RAISERROR(14043, 16, -1, '@tablenick', 'sp_MSinsertdeleteconflict')
        return (1)
    end
    if (@rowguid is null)
    begin
        RAISERROR(14043, 16, -1, '@rowguid', 'sp_MSinsertdeleteconflict')
        return (1)
    end

        if object_id('sysmergearticles') is NULL
        begin
            RAISERROR(20054 , 16, -1)
            return (1)
        end
        
        /*if @conflict_type not in (4,7,8,12)
        begin
                raiserror(21344, 16, -1, '@conflict_type')
                return 1
        end*/

        /* Don't insert a duplicate row */
        if not exists (select * from MSmerge_conflicts_info where tablenick = @tablenick and
                rowguid = @rowguid and origin_datasource = @origin_datasource
                and conflict_type in (4,7,8,12))
        begin
                insert into MSmerge_conflicts_info
                        (tablenick, rowguid, conflict_type, reason_code, reason_text, origin_datasource, pubid, origin_datasource_id) values
                        (@tablenick, @rowguid, @conflict_type, @reason_code, @reason_text, @origin_datasource, @pubid, @source_id)
                select @conflicts_logged = @@ROWCOUNT
                if @@ERROR &lt;&gt; 0 return (1)
        end
        /* Update the existing row - but do not use a generic message to update an error */
        else if (exists (select * from MSmerge_conflicts_info where tablenick = @tablenick and
                                rowguid = @rowguid and origin_datasource = @origin_datasource and 
                                (conflict_type&lt;5 or @conflict_type&gt;4)))
        begin                           
                update MSmerge_conflicts_info set conflict_type = @conflict_type, reason_code = @reason_code,
                        reason_text = @reason_text, origin_datasource_id=@source_id where tablenick = @tablenick and
                        rowguid = @rowguid and origin_datasource = @origin_datasource
                        and conflict_type in (4,7,8,12)
                select @conflicts_logged = @@ROWCOUNT
                if @@ERROR &lt;&gt; 0 return (1)
        end                     
        
        -- If this is an error, add to MSmerge_errorlineage table
        if (@conflict_type in (7, 8) and @lineage is not null)
        begin
                exec @retcode = sys.sp_MSinserterrorlineage @tablenick=@tablenick, @rowguid=@rowguid, @lineage=@lineage, @compatlevel=@compatlevel
                if @retcode&lt;&gt;0 or @@ERROR&lt;&gt;0 return (1)
        end
        
        return (0)
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

