## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_syspolicy_execute_policy\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_syspolicy_execute_policy**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -887594060 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@policy_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@event_data| |xml|2147483647|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@synchronous| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_syspolicy_execute_policy\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_syspolicy_execute_policy\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_syspolicy_execute_policy 
    @policy_name sysname,
    @event_data xml,
    @synchronous bit = 0
AS
BEGIN

    IF(DB_NAME() != 'msdb')
    BEGIN
        RAISERROR(14416,-1,-1)
        RETURN 14416
    END

    -- make sure that the caller is dbo or PolicyAdministratorRole
    IF ( IS_MEMBER('PolicyAdministratorRole') != 1 AND UPPER(USER_NAME())!= 'DBO')
    BEGIN
        RAISERROR(15003, -1, -1, 'PolicyAdministratorRole')
        RETURN 15003
    END

    DECLARE @retval int    
    DECLARE @history_id bigint
    SET @history_id = 0

    EXEC @retval = sys.sp_execute_policy @policy_name, @event_data, @history_id OUTPUT

    IF( (@synchronous = 1) AND (@retval=1))
    BEGIN

        -- the policy failed so we are going to abort the transaction

        -- make sure we get the log information so that we can recreate 
        -- the log entry
        DECLARE @policy_id int
        DECLARE @start_date datetime
        DECLARE @end_date datetime 
        DECLARE @result bit 
        
        SELECT @policy_id = policy_id,
                @start_date = start_date,
                @end_date = end_date,
                @result = result
        FROM msdb.dbo.syspolicy_policy_execution_history_internal
        WHERE history_id = @history_id
        
        DECLARE @target_query_expression nvarchar(max)
        DECLARE @execution_date datetime
        DECLARE @target_result bit
        DECLARE @result_detail nvarchar(max)

        -- there is only one target
        SELECT TOP 1 @target_query_expression = target_query_expression,
               @execution_date = execution_date,
               @target_result = result,
               @result_detail = result_detail
        FROM msdb.dbo.syspolicy_policy_execution_history_details_internal
        WHERE history_id = @history_id

        ROLLBACK TRANSACTION

        IF( @policy_id IS NOT NULL)
        BEGIN
            SET IDENTITY_INSERT msdb.dbo.syspolicy_policy_execution_history_internal ON
            INSERT INTO msdb.dbo.syspolicy_policy_execution_history_internal(history_id, policy_id, start_date, end_date, result)
                VALUES (@history_id, @policy_id, @start_date, @end_date, @result)
            SET IDENTITY_INSERT msdb.dbo.syspolicy_policy_execution_history_internal OFF
            -- insert empty string because the expression is no longer valid
            -- once the transaction has been rolled back
            INSERT INTO msdb.dbo.syspolicy_policy_execution_history_details_internal (history_id, target_query_expression, target_query_expression_with_id, execution_date, result, result_detail)
                VALUES (@history_id, @target_query_expression, N'', @execution_date, @target_result, @result_detail)
        END
    END

    RETURN @retval
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

