## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSpeerconflictdetection_statuscollection_applyresponse\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSpeerconflictdetection_statuscollection_applyresponse**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -889606347 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@request_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@peer_node| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@peer_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@peer_db_version| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@conflictdetection_enabled| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@peer_originator_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@peer_conflict_retention| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@peer_continue_onconflict| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@peer_histids| |nvarchar|1073741823|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@originator_node| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@originator_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSpeerconflictdetection_statuscollection_applyresponse\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSpeerconflictdetection_statuscollection_applyresponse\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSpeerconflictdetection_statuscollection_applyresponse (
    @request_id    int,
    @peer_node    sysname, 
    @peer_db    sysname,
    @peer_db_version int,
    @conflictdetection_enabled bit,
    @peer_originator_id    int,
    @peer_conflict_retention int,
    @peer_continue_onconflict bit, 
    @peer_histids nvarchar(max), --content of MSpeer_originatorid_history in xml format
    @originator_node sysname,
    @originator_db sysname
)
as
begin
    -- security check - should be dbo or sysadmin
    declare @retcode int
    exec @retcode = sp_MSreplcheck_subscribe
    if @@ERROR != 0 or @retcode != 0
        return
    
    if sys.fn_MSrepl_istranpublished(db_name(), 1) &lt;&gt; 1
        return

    if publishingservername() &lt;&gt; @originator_node or db_name() &lt;&gt; @originator_db
        return

    declare @publication sysname
    select @publication  = publication
    from MSpeer_conflictdetectionconfigrequest 
    where id = @request_id

    if @publication is NULL  --request does not exists
        return;

    begin tran
    save tran tr_statuscollection_applyresp
    
    update MSpeer_conflictdetectionconfigresponse
    set    peer_db_version = @peer_db_version,
        conflictdetection_enabled = @conflictdetection_enabled,
        originator_id = @peer_originator_id,
        peer_conflict_retention = @peer_conflict_retention,
        peer_continue_onconflict = @peer_continue_onconflict,
        progress_phase = N'status collected',
        modified_date = GETDATE()
    where request_id = @request_id
        and peer_node = @peer_node
        and peer_db = @peer_db
        and progress_phase = N'peer version collected'
    if @@error &lt;&gt; 0
        goto UNDO
    
       --incorporate historical originator IDs into MSpeer_originatorid_history
       --@peer_histids contains the root : /peer_histids
    declare @DocHandle int
    exec sp_xml_preparedocument @DocHandle OUTPUT, @peer_histids
    if @@error &lt;&gt; 0
        goto UNDO
    
    insert MSpeer_originatorid_history (originator_publication, originator_id, originator_node, originator_db,  originator_db_version, originator_version)
    select @publication, originator_id, originator_node, originator_db, originator_db_version, originator_version
    from (    select  *
             from OPENXML (@DocHandle, N'/peer_histids/histid', 1)
             with (originator_id int,  originator_node sysname,  originator_db sysname,  originator_db_version int, originator_version int)
         ) as A
    where not exists (select * from MSpeer_originatorid_history
                     where originator_publication = @publication and originator_id = A.originator_id 
                         and originator_node = A.originator_node and originator_db = A.originator_db
                         and originator_db_version = A.originator_db_version)
    
    if @@error &lt;&gt; 0
        goto UNDO

    exec sp_xml_removedocument @DocHandle
    if @@error &lt;&gt; 0
        goto UNDO

    commit tran
    return

UNDO:
    rollback tran tr_statuscollection_applyres
    commit tran
    return

end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

