## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MScheckidentityrange\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MScheckidentityrange**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -891552577 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@pubid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@artname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@next_seed| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@range| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@threshold| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@checkonly| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MScheckidentityrange\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MScheckidentityrange\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_MScheckidentityrange 
    @pubid              uniqueidentifier,
    @artname            sysname,
    @next_seed          bigint,
    @range              bigint,
    @threshold          int,
    @checkonly          int
AS
    declare @colid              int
    declare @colname            sysname
    declare @retcode            int
    declare @objid              int
    declare @identity_so_far    bigint
    declare @current_max        bigint
    declare @max_identity       bigint
    declare @tablename          sysname
    declare @pub_range          bigint
    declare @lightweight                bit
    
    declare @xe_message varbinary(1000)

        /*
        ** Check to see if current publication has permission
        */
        if ({ fn ISPALUSER(@pubid)} &lt;&gt; 1)
        begin   
                RAISERROR (14126, 11, -1)
                return (1)
        end

    -- this proc will never be called in yukon except for light weight subscribers
        set @lightweight=sys.fn_MSuselightweightreplication(null, null, null, @pubid, null, null, null)
        if @lightweight = 0
        begin
            raiserror('sp_MScheckidentityrange should not have been called', 16, -1)
            return 1
        end

    select @objid = objid from dbo.sysmergearticles where pubid=@pubid and name=@artname
    if @objid is NULL
        begin
            raiserror(20027, 16, -1, @artname)
            return 1
        end
    
    select @tablename=object_name(@objid)

        begin tran
    save TRAN sp_MScheckidentityrange

        if @checkonly=1
        begin
                select @max_identity= max_identity from MSmerge_idrange where objid=@objid
                if @max_identity is null goto FAILURE

                set @identity_so_far= isnull(ident_current(@tablename), ident_seed(@tablename))

                select @xe_message = CAST('Article: ' + @artname + ', max_identity: ' + convert(nvarchar(100), @max_identity) + ', identity_current: ' + convert(nvarchar(100), @identity_so_far) AS varbinary(1000))
                exec master..sp_repl_generateevent 1, N'Event : identity_range_check', @xe_message

                select case
                        when (@max_identity - @identity_so_far) * 100 / @range &lt; (100 - @threshold) then 1 -- needs bump up
                        else 0 -- no need to bump up
                end
        end
    else
    begin
        update MSmerge_idrange set max_identity=@next_seed + @range
                where objid = @objid

        select @xe_message = CAST('Article: ' + @artname + ', next_seed: ' + convert(nvarchar(100), @next_seed) + ', range: ' + convert(nvarchar(100), @range) AS varbinary(1000))
        exec master..sp_repl_generateevent 1, N'Event : identity_range_check', @xe_message
        
        exec sys.sp_MSreseed @objid, @next_seed, @range 
        if @@ERROR &lt;&gt; 0 
            goto FAILURE
    end

        commit tran
        return 0
        
FAILURE:
   select 0
        if @@TRANCOUNT &gt; 0
    begin
        ROLLBACK TRAN sp_MScheckidentityrange
        COMMIT TRAN
    end
    return(1)
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

