## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_deletepeerrequesthistory\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_deletepeerrequesthistory**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -897802122 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@request_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@cutoff_date| |datetime|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_deletepeerrequesthistory\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_deletepeerrequesthistory\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_deletepeerrequesthistory
(
    @publication    sysname,
    @request_id        int = NULL,
    @cutoff_date    datetime = NULL
)
as
begin
    declare @retcode        int,
            @publisher        sysname,
            @publisher_db    sysname

    select @publisher = publishingservername(),
            @publisher_db = db_name()

    -- Publisher Security Check.
    exec @retcode = sys.sp_MSreplcheck_publish
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
        return 1

    -- check this db is published
    if sys.fn_MSrepl_istranpublished(db_name(),0) &lt;&gt; 1
    begin
        -- "The database is not published."
        raiserror (18757, 16, -1)
        return 1
    end

    -- parameter checks
    if @request_id is null and @cutoff_date is null
    begin
        -- "The parameter @request_id and @cutoff_date cannot be NULL."
        raiserror (14043, 16, -1, '@request_id and @cutoff_date', 'sp_deletepeerrequesthistory')
        return 1
    end
    else if @request_id is not null and @cutoff_date is not null
    begin
        -- "There must be one and only one of '@request_id' and '@cut_off' that is not NULL."
        raiserror(21314, 16, -1, '@request_id', '@cut_off')
        return 1
    end
    
    -- exit with no error if the tables are not found
    if object_id('MSpeer_request', 'U') is null
        or object_id('MSpeer_response', 'U') is null
    begin
        return 0
    end

    begin transaction
    save transaction tr_delete_peer_request

    if @request_id is not null
    begin
        if not exists(select * 
                        from MSpeer_request
                        where id = @request_id
                            and (publication = @publication
                                or @publication is null))
        begin
            -- The @request_id (%d) could not be found for publisher:%s, database:%s, publication:%s.
            raiserror(20688, 16, -1, '@request_id', @request_id, @publisher, @publisher_db, @publication)
            goto UNDO
        end

        delete MSpeer_response
            where request_id = @request_id
        if @@error &lt;&gt; 0 goto UNDO

        delete MSpeer_request
            where id = @request_id
        if @@error &lt;&gt; 0 goto UNDO
    end
    else
    begin
        delete MSpeer_response 
            where request_id in (select id
                                    from MSpeer_request
                                    where sent_date &lt;= @cutoff_date
                                        and (publication = @publication
                                            or @publication is null))
        if @@error &lt;&gt; 0 goto UNDO

        delete MSpeer_request
            where sent_date &lt;= @cutoff_date
                and (publication = @publication
                    or @publication is null)
        if @@error &lt;&gt; 0 goto UNDO
    end

    commit transaction tr_delete_peer_request

    return 0
UNDO:
    rollback transaction tr_delete_peer_request
    commit transaction

    return 1
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

