## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MScleanupdynamicsnapshotfolder\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MScleanupdynamicsnapshotfolder**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -904348324 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@dynamic_filter_login| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@dynamic_filter_hostname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@dynamic_snapshot_location| |nvarchar|260|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@partition_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MScleanupdynamicsnapshotfolder\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MScleanupdynamicsnapshotfolder\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
--
-- Name: sp_MScleanupdynamicsnapshotfolder
--
-- Description: This procedure is used to cleanup the specified dynamic 
--              snapshot folder. It is designed to be called through the 
--              distributor RPC link.
--
-- Parameters: @publisher                   sysname
--             @publisher_db                sysname
--             @publication                 sysname
--             @dynamic_filter_login        sysname
--             @dynamic_filter_hostname     sysname
--             @dynamic_snapshot_location   nvarchar(260)
--             @partition_id                int
--
--
-- Security: Public procedure invoked via RPC. db_owner check
-- Requires Certificate signature for catalog access
-- 
CREATE PROCEDURE sys.sp_MScleanupdynamicsnapshotfolder
(
    @publisher                   sysname,
    @publisher_db                sysname,
    @publication                 sysname,
    @dynamic_filter_login        sysname,
    @dynamic_filter_hostname     sysname,
    @dynamic_snapshot_location   nvarchar(260),
    @partition_id                int
)
as
begin
    set nocount on
    declare @retcode int
    declare @publisher_id int
    declare @publication_id int
    
    set @retcode = 0
    set @publisher_id = null
    set @publication_id = null

    set @dynamic_filter_login = coalesce(@dynamic_filter_login, N'')
    set @dynamic_filter_hostname = coalesce(@dynamic_filter_hostname, N'')

    --
    -- security check
    -- only db_owner can execute this
    --
    if (is_member('db_owner') != 1)
    begin
        raiserror(14260, 16, -1)
        return (1)
    end
    --
    -- security check
    -- Has to be executed from distribution database
    --
    if (sys.fn_MSrepl_isdistdb (db_name()) != 1)
    begin
        raiserror(21482, 16, -1, 'sp_MSdrop_publication', 'distribution')
        return (1)
    end
    
    -- Check if publisher is a defined as a distribution publisher in the current database
    exec @retcode = sys.sp_MSvalidate_distpublisher @publisher, @publisher_id OUTPUT
    if @retcode &lt;&gt; 0
    begin
        return(1)
    end

    -- Make sure publication exists
    select @publication_id = publication_id
        from dbo.MSpublications where publication = @publication and
        publisher_id = @publisher_id and publisher_db = @publisher_db
    if @publication_id is NULL
    begin
        -- We don't know whether or not it is a third party or not so we can not 
        -- return error.
        -- raiserror(20026, 16, -1, @publication)
        -- return (1)
        return (0)
    end
   
    if @dynamic_snapshot_location is null or rtrim(@dynamic_snapshot_location) = N''
        return (0)

    declare @publication_snapshot_folder nvarchar(260)


    if substring(@dynamic_snapshot_location, len(@dynamic_snapshot_location), 1) &lt;&gt; N'\'
    begin
        set @dynamic_snapshot_location = @dynamic_snapshot_location + N'\'
    end
    
    exec @retcode = sys.sp_MSreplremoveuncdir @dynamic_snapshot_location
    if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
               return(1)    

    return (0)
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

