## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSgetisvalidwindowsloginfromdistributor\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSgetisvalidwindowsloginfromdistributor**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -904610653 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@login| |nvarchar|257|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@isvalid| |bit|1|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSgetisvalidwindowsloginfromdistributor\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSgetisvalidwindowsloginfromdistributor\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_MSgetisvalidwindowsloginfromdistributor
(
    @login         nvarchar(257),
    @isvalid    bit output,
    @publisher    sysname = NULL
)
AS
BEGIN
    SET NOCOUNT ON
    
    DECLARE @retcode             int,
            @dbname             sysname,
            @distproc            nvarchar(4000),
            @distributor_rpc    sysname,
            @distribution_db    sysname

    SELECT @isvalid = 0,
            @dbname = DB_NAME()
    
    -- if db is publisher we will reroute to distributor
    IF sys.fn_MSrepl_ispublished(@dbname) = 1
    BEGIN
        -- Security Check
        EXEC @retcode = sys.sp_MSreplcheck_publish
        IF @@ERROR &lt;&gt; 0 OR @retcode &lt;&gt; 0
            RETURN 1

        -- retrieve the distributor db information
        EXEC @retcode = sys.sp_helpdistributor @rpcsrvname = @distributor_rpc OUTPUT,
                                                @distribdb = @distribution_db OUTPUT,
                                                @publisher = @publisher
        IF @@ERROR &lt;&gt; 0 OR @retcode &lt;&gt; 0 OR @distributor_rpc IS NULL OR @distribution_db IS NULL
        BEGIN
            -- "The Distributor has not been installed correctly."
            RAISERROR (20036, 16, -1)
            RETURN 1
        END

        SELECT @distproc = QUOTENAME(@distributor_rpc) + '.' + QUOTENAME(@distribution_db) + '.sys.sp_MSgetisvalidwindowsloginfromdistributor'

        EXEC @retcode = @distproc @login = @login,
                                    @isvalid = @isvalid OUTPUT
        
        IF @@ERROR &lt;&gt; 0 OR @retcode &lt;&gt; 0
            RETURN 1
    END
    -- if we are at the distributor db then return the value
    ELSE IF sys.fn_MSrepl_isdistdb (@dbname) = 1
    BEGIN
        -- Security Check
        IF IS_MEMBER('db_owner') != 1 
        BEGIN
            RAISERROR(14260, 16, -1)
            RETURN 1
        END
        
        SELECT @isvalid = sys.fn_replisvalidwindowsloginformat(@login)
    END
    -- else raise an error
    ELSE
    BEGIN
        -- The database is not published.
        RAISERROR (18757, 16, -1)
        RETURN 1
    END

    RETURN 0
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

