## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_helpsrvrole\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_helpsrvrole**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -906683713 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@srvrolename| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|ServerRole|nvarchar|35|
|Description|nvarchar|35|

|Name |Datatype |Max length |
|-|-|-|
|ServerRole|nvarchar|35|
|Description|nvarchar|35|

---
### Objects that depend on \[sys\].\[sp_helpsrvrole\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_helpsrvrole\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_helpsrvrole
    @srvrolename        sysname = NULL
AS
    if @srvrolename is not null
    begin
        -- VALIDATE GIVEN NAME
        if not exists (select * from master.dbo.spt_values
                where name = @srvrolename and low = 0 and type = 'SRV')
        begin
            raiserror(15412, -1, -1, @srvrolename)
            return (1)
        end

        -- RESULT SET FOR SINGLE SERVER-ROLE
        -- UNDONE: REMOVE THE "Description" OUTPUT (should be BOL only)
        select 'ServerRole' = v1.name, 'Description' = v2.name
            from master.dbo.spt_values v1, master.dbo.spt_values v2
            where v1.name = @srvrolename and
                  v1.low = 0 and
                  v1.type = 'SRV' and
                  v2.low = -1 and
                  v2.type = 'SRV' and
                  v1.number = v2.number
    end
    else
    begin
        -- RESULT SET FOR ALL SERVER-ROLES
        -- UNDONE: REMOVE THE "Description" OUTPUT (should be BOL only)
        select 'ServerRole' = v1.name, 'Description' = v2.name
            from master.dbo.spt_values v1, master.dbo.spt_values v2
            where v1.low = 0 and
                  v1.type = 'SRV' and
                  v2.low = -1 and
                  v2.type = 'SRV' and
                  v1.number = v2.number
    end

    return (0) -- sp_helpsrvrole
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

