## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_processlogshippingmonitorprimary\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_processlogshippingmonitorprimary**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -907891019 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@mode| |tinyint|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@primary_id| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@primary_server| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@monitor_server| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@monitor_server_security_mode| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@primary_database| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@backup_threshold| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@threshold_alert| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@threshold_alert_enabled| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@last_backup_file| |nvarchar|500|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@last_backup_date| |datetime|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@last_backup_date_utc| |datetime|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@history_retention_period| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_processlogshippingmonitorprimary\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_processlogshippingmonitorprimary\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_processlogshippingmonitorprimary 
(
    @mode tinyint -- 1 = add, 2 = delete, 3 = update
    ,@primary_id uniqueidentifier
    ,@primary_server sysname = NULL -- needed for add
    ,@monitor_server sysname 
    ,@monitor_server_security_mode bit 
    ,@primary_database sysname = NULL -- needed for add
    ,@backup_threshold int = NULL 
    ,@threshold_alert int = NULL
    ,@threshold_alert_enabled bit = NULL
    ,@last_backup_file nvarchar(500) = NULL
    ,@last_backup_date datetime = NULL
    ,@last_backup_date_utc datetime = NULL
    ,@history_retention_period int = NULL
)
as
begin
    set nocount on
    declare @retcode int
    
    --
    -- security check
    --
    exec @retcode = sys.sp_MSlogshippingsysadmincheck
    if (@retcode != 0 or @@error != 0)
        return 1
    --
    -- This should be called only on the remote monitor server
    --
    if (@monitor_server is null or upper(@monitor_server) != upper(@@servername) 
            or upper(@monitor_server) = upper(@primary_server))
        return 0
    --
    -- must be invoked from MSDB
    --
    if (db_name() != N'msdb')
    begin
        raiserror (21482, 16, -1, N'sp_processlogshippingmonitorprimary', N'msdb')
        return 1
    end
    --
    -- call the internal proc now
    --
    exec @retcode = sys.sp_MSprocesslogshippingmonitorprimary @mode = @mode
                ,@primary_id = @primary_id
                ,@primary_server = @primary_server
                ,@monitor_server = @monitor_server
                ,@monitor_server_security_mode = @monitor_server_security_mode
                ,@primary_database = @primary_database
                ,@backup_threshold = @backup_threshold
                ,@threshold_alert = @threshold_alert
                ,@threshold_alert_enabled = @threshold_alert_enabled
                ,@last_backup_file = @last_backup_file
                ,@last_backup_date = @last_backup_date
                ,@last_backup_date_utc = @last_backup_date_utc
                ,@history_retention_period = @history_retention_period
    if (@retcode != 0 or @@error != 0)
        return 1
    --
    -- all done
    --
    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

