## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSvalidate_dest_recgen\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSvalidate_dest_recgen**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -909209322 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@pubid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@recguid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@recgen| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSvalidate_dest_recgen\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSvalidate_dest_recgen\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_MSvalidate_dest_recgen @pubid uniqueidentifier, @recguid uniqueidentifier, @recgen bigint as
begin
    declare @retcode int, @has_subbased bit, @has_downloadonly bit, @is_publisher bit, @min_sentgen bigint
    
    exec @retcode = sys.sp_MSrepl_PAL_rolecheck @pubid=@pubid
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
        return 1
    
    select @has_subbased = 0, @has_downloadonly = 0, @is_publisher = 0
    
    exec @retcode = sys.sp_MSvalidatecommongen @commongen = @recgen, @commongenguid = @recguid
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
        return 1
    
    if exists (select distinct * from dbo.sysmergepartitioninfoview 
                where partition_options = 3
                and pubid = @pubid)
        select @has_subbased = 1
               
     if exists (select * from dbo.sysmergepartitioninfoview smpi1
                    where (upload_options = 1 or upload_options = 2)
                    and pubid = @pubid)
        select @has_downloadonly = 1
        
    if sys.fn_MSmerge_islocalpubid(@pubid) = 1
        select @is_publisher = 1
        
    if @is_publisher = 1
    begin
        if @has_subbased = 1 or @has_downloadonly = 1
        begin
            select @min_sentgen = isnull(min(sentgen),0) from dbo.sysmergesubscriptions
            where pubid = @pubid 
            and subid &lt;&gt; @pubid
            
            if @recgen &lt; @min_sentgen
            begin
                RAISERROR(21800 , 16, -1)
                return 1
            end
        end
    end
    else
    begin
        if @has_subbased = 1
        begin
            select @min_sentgen = isnull(min(sentgen),0) from dbo.sysmergesubscriptions
            where pubid = @pubid 
            and subid = @pubid
            
            if @recgen &lt; @min_sentgen
            begin
                RAISERROR(21800 , 16, -1)
                return 1
            end
        end
    end
    
    if exists (select * from dbo.sysmergepublications where isnull(retention,0) = 0)
        return 0
    
    declare @curdate datetime, @cutoffdate datetime
    
    select @curdate = getdate()
    
    select @cutoffdate = min(sys.fn_subtract_units_from_date(isnull(retention,0), retention_period_unit, @curdate))
    from dbo.sysmergepublications
        
    if @recgen = 0 or exists (select * from dbo.MSmerge_genhistory where generation = @recgen and coldate &lt;= @cutoffdate)
    begin
        RAISERROR(21800 , 16, -1)
        return 1
    end
    
    return 0
    
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

