## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSpeerapplytopologyinfo\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSpeerapplytopologyinfo**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -911016661 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@request_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@originator| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@originator_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@response_srvr| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@response_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@connection_info| |xml|2147483647|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@response_srvr_version| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@response_originator_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@response_conflict_retention| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSpeerapplytopologyinfo\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSpeerapplytopologyinfo\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSpeerapplytopologyinfo
(
    @request_id        int,
    @originator        sysname,
    @originator_db    sysname,
    @response_srvr    sysname,
    @response_db        sysname,
    @connection_info    XML = NULL,
    @response_srvr_version    int,
    @response_originator_id int,
    @response_conflict_retention int
)
as
begin
    set nocount on    
    
    declare @retcode int
    
    -- security check for subscriber
    exec @retcode = sys.sp_MSreplcheck_subscribe 
       if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0 
       begin
           return 1
       end

    -- we will exit in either of these conditions since this means we
    -- are not at the correct node and we should treat this as a noop
    -- the conditions are as follows:
    --    1. Any of the user provided information is NULL
    --    2. We are not on the originator server
    --    3. (NOT USED) The originator and reponse_srvr are the same
    --
    -- section 1 
    if @request_id is NULL
        or @originator is NULL
        or @originator_db is NULL
        or @response_srvr is NULL
        or @response_db is NULL
        -- section 2
        or UPPER(@originator) &lt;&gt; UPPER(publishingservername())
        or @originator_db &lt;&gt; db_name()
        -- we do not need the 3rd condition since we want topology from the originator as well
        ---- section 3
        --or (UPPER(@originator) = UPPER(@response_srvr)
        --    and @originator_db = @response_db)
    begin
        return 0
    end
    
    begin transaction tr_sp_MSpeerapplytopologyinfo
    save transaction tr_sp_MSpeerapplytopologyinfo

    if @response_originator_id = 0 
    begin
        select @response_originator_id = NULL
        select @response_conflict_retention = NULL
    end
    
    update MSpeer_topologyresponse
        set received_date = getdate(),
            connection_info = @connection_info,
            peer_version = @response_srvr_version,
            originator_id = @response_originator_id,
            peer_conflict_retention = @response_conflict_retention
        where request_id = @request_id
            and peer = @response_srvr
            and peer_db = @response_db
    if @@error &lt;&gt; 0
    begin
        -- The procedure sys.MSpeer_topologyresponse failed to UPDATE the resource MSpeer_topologyresponse Server error =  0.
        raiserror (21499, 16, -1, 'sys.sp_MSpeerapplytopologyinfo', 'UPDATE', 'MSpeer_topologyresponse.', @@error)
        goto FAILURE
    end

    --update the peer node version inside MSpeer_lsns
    if @response_srvr_version is not null
    begin
        update MSpeer_lsns
        set originator_version = @response_srvr_version
        where originator = @response_srvr 
            and originator_db = @response_db
            and originator_publication = (select  publication from MSpeer_topologyrequest where id = @request_id)
            and originator_version &lt;&gt; @response_srvr_version
    end
    
    commit transaction tr_sp_MSpeerapplytopologyinfo

    return 0
FAILURE:
    rollback transaction tr_sp_MSpeerapplytopologyinfo
    commit transaction 
    
    return 1
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

