## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSset_new_identity_range\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSset_new_identity_range**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -924934239 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@subid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@artid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@range_type| |tinyint|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@ranges_given| |tinyint|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@range_begin| |numeric|17|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@range_end| |numeric|17|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@next_range_begin| |numeric|17|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@next_range_end| |numeric|17|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSset_new_identity_range\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSset_new_identity_range\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSset_new_identity_range
    @subid uniqueidentifier,
    @artid uniqueidentifier,
    @range_type tinyint, -- 1=publisher range, 2=subscriber range
    @ranges_given tinyint, -- 0=none, 1=one range given, 2=both ranges given
    @range_begin numeric(38,0),
    @range_end numeric(38,0),
    @next_range_begin numeric(38,0),
    @next_range_end numeric(38,0)
as
    declare @max_used numeric(38,0)
    declare @retcode int
    declare @is_pub_range bit
    declare @objid int
    declare @qualified_table_name nvarchar(517)
    declare @ident_increment numeric(38,0)

    exec @retcode = sys.sp_MSreplcheck_subscribe
    if (@retcode &lt;&gt; 0) or (@@error &lt;&gt; 0)
        return 1

    if @range_type = 1
    begin
        select @is_pub_range = 1
        select @max_used = @range_begin
    end
    else
    begin
        select @is_pub_range = 0
        select @max_used = NULL
    end
    
    exec @retcode = sys.sp_MScheck_article_auto_identity @artid, @objid output, @qualified_table_name output
    if @retcode&lt;&gt;0 or @@error&lt;&gt;0
        return 1

    if @range_begin is NULL or @range_end is NULL or @next_range_begin is NULL or @next_range_end is NULL 
    begin
        RAISERROR(20675, 16, -1)
        return (1)
    end
 
    select @ident_increment = IDENT_INCR(@qualified_table_name)
    
    if not exists (select * from dbo.MSmerge_identity_range where subid=@subid and artid=@artid and is_pub_range=@is_pub_range)
    begin
        -- we did not find the entry to get information about it. The entry should be present
        -- when this proc is called. sp_MSsetup_identity_range proc called during the initial
        -- merge should have created the entry.

        -- however if this is an incrementally added article so insert an empty entry here
        if exists (select * from dbo.sysmergearticles 
                    where artid=@artid and (status = 5 or status = 6) and 
                          pubid in (select pubid from dbo.sysmergesubscriptions where subid=@subid))
        begin
            insert dbo.MSmerge_identity_range values (@subid, @artid, @range_begin, @range_end, @next_range_begin, @next_range_end, @is_pub_range, @max_used)
            if @@error&lt;&gt; 0
                return 1
            if @range_type = 2
            begin
                exec @retcode = sys.sp_MSrefresh_idrange_check_constraint 
                                        @qualified_table_name,
                                        @artid,
                                        @range_begin,
                                        @range_end,
                                        @next_range_begin,
                                        @next_range_end,
                                        @ranges_given
                if @@ERROR&lt;&gt;0 or @retcode&lt;&gt;0
                begin
                    RAISERROR(20670, 16, -1, @qualified_table_name)
                    return (1)
                end
            end
        end
        else
        begin
            RAISERROR(20671, 16, -1)
            return (1)
        end
    end
    else
    begin
        if @range_type = 2
        begin
            update dbo.MSmerge_identity_range 
                set range_begin = @range_begin, 
                    range_end = @range_end, 
                    next_range_begin = @next_range_begin, 
                    next_range_end = @next_range_end,
                    max_used = @max_used
                where subid = @subid and artid = @artid and is_pub_range = @is_pub_range
            if @@error&lt;&gt; 0
                return 1

            exec @retcode = sys.sp_MSrefresh_idrange_check_constraint 
                                    @qualified_table_name,
                                    @artid,
                                    @range_begin,
                                    @range_end,
                                    @next_range_begin,
                                    @next_range_end,
                                    @ranges_given
            if @@ERROR&lt;&gt;0 or @retcode&lt;&gt;0
            begin
                RAISERROR(20670, 16, -1, @qualified_table_name)
                return (1)
            end
        end
        else
        begin
            if @ranges_given = 2
            begin
                update dbo.MSmerge_identity_range 
                    set range_begin = @range_begin, 
                        range_end = @range_end, 
                        next_range_begin = @next_range_begin, 
                        next_range_end = @next_range_end,
                        max_used = @max_used
                    where subid = @subid and artid = @artid and is_pub_range = @is_pub_range
                if @@error&lt;&gt; 0
                    return 1
            end
            else
            begin
                -- set the current range to be the next range and newly given range to be the next range
                update dbo.MSmerge_identity_range 
                    set range_begin = next_range_begin, 
                        range_end = next_range_end
                    where subid = @subid and artid = @artid and is_pub_range = @is_pub_range
                if @@error&lt;&gt; 0
                    return 1
            
                -- if we are getting only one new range we should not change the max_used column
                update dbo.MSmerge_identity_range 
                    set next_range_begin = @next_range_begin, 
                        next_range_end = @next_range_end
                    where subid = @subid and artid = @artid and is_pub_range = @is_pub_range
                if @@error&lt;&gt; 0
                    return 1
            end
        end
    end

    return 0
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

