## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_tables_rowset_rmt\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_tables_rowset_rmt**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -926793034 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@table_server| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@table_catalog| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@table_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@table_schema| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@table_type| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|TABLE_CATALOG|nvarchar|128|
|TABLE_SCHEMA|nvarchar|128|
|TABLE_NAME|nvarchar|128|
|TABLE_TYPE|nvarchar|128|
|TABLE_GUID|uniqueidentifier|16|
|DESCRIPTION|nvarchar|4000|
|TABLE_PROPID|int|4|
|DATE_CREATED|int|4|
|DATE_MODIFIED|int|4|

---
### Objects that depend on \[sys\].\[sp_tables_rowset_rmt\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_tables_rowset_rmt\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_tables_rowset_rmt
(
    @table_server       sysname,
    @table_catalog      sysname = null,
    @table_name     sysname = null,
    @table_schema       sysname = null,
    @table_type     sysname = null
)
as
    select
        TABLE_CATALOG,
        TABLE_SCHEMA,
        TABLE_NAME,
        TABLE_TYPE,
        TABLE_GUID,
        DESCRIPTION,
        TABLE_PROPID = null,    -- ISSUE these 3 columns must be exported by the server
        DATE_CREATED = null,    -- in \yukon\sql\ntdbms\msql\ddl\sysoledb.cpp :
        DATE_MODIFIED = null    -- const SCHEMA_COLUMNS xCol_TABLES = {
    from
        sys.fn_remote_tables (@table_server,
                              @table_catalog,
                              @table_schema,
                              @table_name,
                              @table_type)
    order by 4,1,2,3
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

