## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_helpsrvrolemember\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_helpsrvrolemember**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -93184835 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@srvrolename| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|ServerRole|nvarchar|128|
|MemberName|nvarchar|128|
|MemberSID|varbinary|85|

|Name |Datatype |Max length |
|-|-|-|
|ServerRole|nvarchar|128|
|MemberName|nvarchar|128|
|MemberSID|varbinary|85|

---
### Objects that depend on \[sys\].\[sp_helpsrvrolemember\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_helpsrvrolemember\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_helpsrvrolemember
    @srvrolename       sysname = NULL
AS
    if @srvrolename is not null
    begin
        -- VALIDATE GIVEN NAME
        if not exists (select * from sys.server_principals
                where name = @srvrolename and principal_id &gt;= suser_id('sysadmin') and principal_id &lt;= suser_id('bulkadmin'))
        begin
            raiserror(15412, -1, -1, @srvrolename)
            return (1)
        end

        -- RESULT SET FOR SINGLE SERVER-ROLE
        select 'ServerRole' = SUSER_NAME(rm.role_principal_id), 'MemberName' = lgn.name , 'MemberSID' = lgn.sid
            from sys.server_role_members rm, sys.server_principals lgn
            where rm.role_principal_id = SUSER_ID(@srvrolename) AND
                  rm.member_principal_id = lgn.principal_id
    end
    else
    begin
        -- RESULT SET FOR ALL FIXED SERVER-ROLES
        select 'ServerRole' = SUSER_NAME(rm.role_principal_id), 'MemberName' = lgn.name, 'MemberSID' = lgn.sid
            from sys.server_role_members rm, sys.server_principals lgn
            where rm.role_principal_id &gt;=3 AND rm.role_principal_id &lt;=10 AND
                  rm.member_principal_id = lgn.principal_id
    end

    return (0) -- sp_helpsrvrolemember
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

