## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_droptype\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_droptype**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -933567912 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@typename| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_droptype\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_droptype\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_droptype
    @typename sysname        -- the user type to drop
as
    
    declare @schid int

--  Find the user type with @typename.  It must be a user type (xusertype &gt; 256)
--  and you must be db_owner, db_ddladmin or sa (covered by db_owner check) to
-- drop the type. Only types owned by dbo are accessible thru sp_droptype.
    select @schid = schema_id from sys.types
            where name = @typename and user_type_id &gt; 256 and schema_id = 1
    if (@schid is null)
        begin
            raiserror(15036,-1,-1, @typename)
            return (1)
        end
        
    if (is_member('db_owner') = 0 AND
        is_member('db_ddladmin') = 0)
    begin
        raiserror(15036,-1,-1, @typename)
        return (1)
    end

    declare @stmt nvarchar(384)

    select @stmt = 'drop type [dbo].' + quotename(@typename)
        
    -- Drop user defined type
    EXEC(@stmt)

    return (@@error) -- sp_droptype
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

