## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_adddynamicsnapshot_job\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_adddynamicsnapshot_job**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -936500527 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@suser_sname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@host_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@dynamic_snapshot_jobname| |sysname|128|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@dynamic_snapshot_jobid| |uniqueidentifier|16|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_type| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_interval| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_subday| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_subday_interval| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_relative_interval| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@frequency_recurrence_factor| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@active_start_date| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@active_end_date| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@active_start_time_of_day| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@active_end_time_of_day| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_adddynamicsnapshot_job\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_adddynamicsnapshot_job\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_adddynamicsnapshot_job (
    @publication sysname,
    @suser_sname sysname = null,
    @host_name sysname = null,
    @dynamic_snapshot_jobname sysname = null output,
    @dynamic_snapshot_jobid uniqueidentifier = null output,

    -- Scheduling information
    @frequency_type              int = 2, -- 2 means OnDemand
    @frequency_interval          int = 1,
    @frequency_subday            int = 1,
    @frequency_subday_interval   int = 1,
    @frequency_relative_interval int = 1, 
    @frequency_recurrence_factor int = 1,
    @active_start_date           int = 0,
    @active_end_date             int = 0,
    @active_start_time_of_day    int = 0, 
    @active_end_time_of_day      int = 0
)
as
    declare @retcode int
    
    exec @retcode = sys.sp_MSreplcheck_publish
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
        return (1)

    if @suser_sname is NULL or ltrim(rtrim(@suser_sname)) = N''
        select @suser_sname = NULL
    if @host_name is NULL or ltrim(rtrim(@host_name)) = N''
        select @host_name = NULL
        
    exec @retcode = sys.sp_MSaddmergedynamicsnapshotjob 
            @publication = @publication, 
            @dynamic_filter_login = @suser_sname, 
            @dynamic_filter_hostname = @host_name, 
            @dynamic_snapshot_location = NULL, 
            @dynamic_snapshot_jobname = @dynamic_snapshot_jobname output,
            @dynamic_snapshot_jobid = @dynamic_snapshot_jobid output,
            @frequency_type = @frequency_type,
            @frequency_interval = @frequency_interval,
            @frequency_subday = @frequency_subday,
            @frequency_subday_interval = @frequency_subday_interval,
            @frequency_relative_interval = @frequency_relative_interval, 
            @frequency_recurrence_factor = @frequency_recurrence_factor,
            @active_start_date = @active_start_date,
            @active_end_date = @active_end_date,
            @active_start_time_of_day = @active_start_time_of_day, 
            @active_end_time_of_day = @active_end_time_of_day
     return @retcode
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

