## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSgetmergeadminapplock\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSgetmergeadminapplock**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -942121329 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@timeout| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@lockmode| |nvarchar|32|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@lock_acquired| |int|4|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@lockowner| |nvarchar|32|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSgetmergeadminapplock\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSgetmergeadminapplock\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSgetmergeadminapplock
    @timeout int = -1,
    @lockmode nvarchar(32) = N'Exclusive',
    @lock_acquired int = NULL OUTPUT,
    @lockowner nvarchar(32) = N'Session'
as
    set nocount on

    declare @retcode smallint
    declare @lock_resource nvarchar(255)
    declare @publisher sysname
    declare @publisher_db sysname
    declare @DbPrincipal sysname

    select @publisher = publishingservername() 
    select @publisher_db = DB_NAME() 

    select @retcode = 0
    select @lock_acquired = -1

    exec @retcode = sys.sp_MSreplcheck_publish
    if @retcode&lt;&gt;0 or @@ERROR&lt;&gt;0
        return 1

    -- use the dbowner role
    select @DbPrincipal = N'db_owner'
    select @lock_resource = N'MSinternal_repl_merge_admin_' + convert(nvarchar(6), db_id()) 

    exec @retcode = sp_getapplock @Resource = @lock_resource,
                                  @LockMode = @lockmode,
                                  @LockOwner = @lockowner,
                                  @LockTimeout = @timeout, -- wait till the the given @timeout time to get it
                                  @DbPrincipal = @DbPrincipal
    if @@error&lt;&gt;0 or @retcode&lt;0 -- lock was not acquired
    begin
        raiserror(20712, 16, -1, @publisher_db)
        select @retcode = 1
        select @lock_acquired = -1
    end
    else
        select @lock_acquired = 1

    return @retcode
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

