## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_add_log_file_recover_suspect_db\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_add_log_file_recover_suspect_db**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -943997115 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@dbName| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@name| |nvarchar|260|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@filename| |nvarchar|260|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@size| |nvarchar|20|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@maxsize| |nvarchar|20|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@filegrowth| |nvarchar|20|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_add_log_file_recover_suspect_db\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_add_log_file_recover_suspect_db\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
--
-- Name: sp_add_log_file_recover_suspect_db
-- Purpose: Adds a log file to a suspect database and runs
--         recovery on the database.  This SP should only be used
--        on databases that have been marked suspect due to
--        insufficient data (error 1105) or log (error 9002) space.
--
create procedure sys.sp_add_log_file_recover_suspect_db
    @dbName     sysname            -- database name
    ,@name        nvarchar(260)        -- logical file name
    ,@filename    nvarchar(260)        -- OS file name
    ,@size        nvarchar(20)     = NULL    -- initial file size
    ,@maxsize    nvarchar(20)     = NULL    -- maximum file size
    ,@filegrowth    nvarchar(20)     = NULL    -- growth increment
as
    if (SERVERPROPERTY('IsMatrix') = 1)
    begin
        raiserror (28401, -1, -1, N'sys.sp_add_log_file_recover_suspect_db')
        return (1)
    end

    EXEC sys.sp_add_file_recover_suspect_db @dbName, 'LOG', NULL, @name, @filename, @size, @maxsize, @filegrowth
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

