## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_helpntgroup\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_helpntgroup**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -945991693 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@ntname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|NTGroupName|nvarchar|128|
|NtGroupId|int|4|
|SID|varbinary|85|
|HasDbAccess|int|4|

|Name |Datatype |Max length |
|-|-|-|
|NTGroupName|nvarchar|128|
|NtGroupId|int|4|
|SID|varbinary|85|
|HasDbAccess|int|4|

---
### Objects that depend on \[sys\].\[sp_helpntgroup\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_helpntgroup\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_helpntgroup
    @ntname       sysname = NULL
AS
    if @ntname is not null
    begin
        -- VALIDATE GIVEN NAME
        if not exists (select * from sysusers where name = @ntname and isntgroup = 1)
        begin
            raiserror(15420, -1, -1, @ntname)
            return (1)
        end

        -- RESULT SET FOR SINGLE GROUP
        select 'NTGroupName' = u.name, 'NtGroupId' = u.principal_id, 'SID' = u.sid, 'HasDbAccess' = case when p.state in ('G','W') then 1 else 0 end
            from sys.database_principals u
            left join sys.database_permissions p on p.class = 0 and p.major_id = 0 and p.minor_id = 0
                and p.grantee_principal_id = u.principal_id AND p.grantor_principal_id = 1 AND p.type = 'CO'
            where u.name = @ntname and u.type = 'G'
    end
    else
    begin
        -- RESULT SET FOR ALL GROUPS
        select 'NTGroupName' = u.name, 'NtGroupId' = u.principal_id, 'SID' = u.sid, 'HasDbAccess' = case when p.state in ('G','W') then 1 else 0 end
            from sys.database_principals u
            left join sys.database_permissions p on p.class = 0 and p.major_id = 0 and p.minor_id = 0
                and p.grantee_principal_id = u.principal_id AND p.grantor_principal_id = 1 AND p.type = 'CO'
            where u.type = 'G'
    end

    return (0) -- sp_helpntgroup
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

