## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_srvrolepermission\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_srvrolepermission**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -957338681 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@srvrolename| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|ServerRole|nvarchar|128|
|Permission|nvarchar|35|

|Name |Datatype |Max length |
|-|-|-|
|ServerRole|nvarchar|128|
|Permission|nvarchar|35|

---
### Objects that depend on \[sys\].\[sp_srvrolepermission\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_srvrolepermission\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_srvrolepermission
    @srvrolename       sysname = NULL
AS
    if @srvrolename is not null
    begin
        -- VALIDATE GIVEN NAME
        if not exists (select * from sys.server_principals
                where name = @srvrolename and principal_id &gt;= suser_id('sysadmin') and principal_id &lt;= suser_id('bulkadmin'))
        begin
            raiserror(15412, -1, -1, @srvrolename)
            return (1)
        end

        -- RESULT SET FOR SINGLE SERVER-ROLE
        select distinct 'ServerRole' = l.name, 'Permission' = p.name collate catalog_default
            from sys.server_principals l, sys.role_permissions p
            where l.name = @srvrolename and p.low &gt; 0 and
                  ((p.type = 'SRV' and (p.number = l.principal_id or l.principal_id = suser_id('sysadmin'))) or
                  (p.type = 'DBR' and l.principal_id = suser_id('sysadmin') and not (p.name like N'No %')))
            order by l.name, p.name collate catalog_default
    end
    else
    begin
        -- RESULT SET FOR ALL SERVER-ROLES
        select distinct 'ServerRole' = l.name, 'Permission' = p.name collate catalog_default
            from sys.server_principals l, sys.role_permissions p
            where p.low &gt; 0 and
                ((p.type = 'SRV' and (p.number = l.principal_id or l.principal_id = suser_id('sysadmin'))) or
                  (p.type = 'DBR' and l.principal_id = suser_id('sysadmin') and not (p.name like N'No %')))
            order by l.name, p.name collate catalog_default
    end

    return (0) -- sp_srvrolepermission
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

