## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MScheck_tran_retention\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MScheck_tran_retention**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -957701186 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@xact_seqno| |varbinary|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@agent_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MScheck_tran_retention\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MScheck_tran_retention\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE sys.sp_MScheck_tran_retention
(
    @xact_seqno varbinary(16),
    @agent_id int
)
as
begin
    set nocount on

    declare @retcode tinyint    
    declare @date datetime
    declare @retention int
    declare    @expired int
    declare @publisher_database_id int

    -- Security Check
    exec @retcode = sys.sp_MScheck_pull_access @agent_id = @agent_id,    -- agent id
                                                @agent_type = 0         -- only called by distribution agent
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
    begin
        return (1)
    end
    
    select @publisher_database_id = publisher_database_id from MSdistribution_agents
        where id = @agent_id

    select @date = entry_time from MSrepl_transactions where
        xact_seqno = @xact_seqno and
        publisher_database_id = @publisher_database_id

    select @retention = max_distretention from msdb..MSdistributiondbs where
        name = db_name()

    if (@date is not null and datediff(minute, @date, getdate()) &lt; @retention*60) or
        -- For 'sync with backup' dist db where
        -- the dist db might be restored to a previous version so that the subscriber's
        -- xact_seqno is larger.
       (@date is null and not exists (select * from MSrepl_transactions where
        xact_seqno &gt;= @xact_seqno and
        publisher_database_id = @publisher_database_id))
        select @expired = 0
    else
        select @expired = 1
    
    select N'expired' = @expired
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

