## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_helparticle\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_helparticle**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -957865496 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@article| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@returnfilter| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@found| |int|4|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_helparticle\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_helparticle\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

--
-- Name:    
--          sp_helparticle
--          
-- Description: 
--          Returns information about a publication article.  If the article
--          name is not specified, it returns information for all publication
--          articles.
--
--          For a SQL Server publication, this stored procedure is executed
--          at the Publisher on the publication database.  For a heterogeneous
--          publication, this stored procedure may be executed in any database
--          at the distributor for the associated publisher.
--  
-- Security: 
--          SQL Server publication:     'sysadmin', db_owner of publishing database, PAL
--          Heterogeneous publication:  'sysadmin', db_owner of distribution database, PAL
--
-- Returns:
--          Result set of article properties
--      
-- Owner:   
--          &lt;current owner&gt; 
--

create procedure sys.sp_helparticle
(
    @publication sysname,         /* The publication name */
    @article sysname = '%',       /* The article name */
    @returnfilter bit = 1,        /* Return filter flag */
    @publisher sysname = NULL,
    @found    int  = 0 OUTPUT
)
AS
BEGIN
    DECLARE @cmd nvarchar(4000)
    DECLARE @retcode int
    DECLARE @publisher_type sysname

    select @retcode = 0

    EXEC @retcode = sys.sp_MSrepl_getpublisherinfo    @publisher            = @publisher,
                                                    @publisher_type        = @publisher_type OUTPUT,
                                                    @rpcheader            = @cmd OUTPUT,
                                                    @skipSecurityCheck    = 1
                                                    
    IF @retcode &lt;&gt; 0
        RETURN (@retcode)

    SET @publisher = UPPER(@publisher) COLLATE DATABASE_DEFAULT

    IF @publisher_type &lt;&gt; N'MSSQLSERVER'
    BEGIN
        select @cmd = @cmd + N'sys.sp_IHhelparticle'

        EXEC @retcode = @cmd
                        @publication,
                        @article,
                        @returnfilter,
                        @publisher,
                        @publisher_type,
                        @found OUTPUT
    END
    ELSE
    BEGIN
        select @cmd = @cmd + N'sys.sp_MSrepl_helparticle'

        EXEC @retcode = @cmd
                @publication,
                @article,
                @returnfilter,
                @publisher,
                @found OUTPUT
    END
    
    RETURN (@retcode)
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

