## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSreset_queued_reinit\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSreset_queued_reinit**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -964658649 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@subscriber| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscriber_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@artid| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSreset_queued_reinit\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSreset_queued_reinit\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSreset_queued_reinit 
(
    @subscriber      sysname,                    -- subscriber server name
    @subscriber_db   sysname,                -- subscribing database name. 
    @artid    int                                   -- article id
)
as
begin
    set nocount on
    declare @retcode int
                ,@publication sysname
    --
    -- PAL security check
    -- Get publication name using artid
    --
    select @publication = p.name
    from syspublications p join sysarticles a on p.pubid = a.pubid
    where a.artid = @artid
    if (@publication is null)
    begin
        return (1)
    end
    exec @retcode = sys.sp_MSreplcheck_pull @publication = @publication
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
    begin
        return (1)
    end
    --
    -- Validate @subscriber
    --
    --
    -- validate @subscriber_db, @artid
    --
    if exists (select * 
        from dbo.syssubscriptions
        where artid = @artid 
            and srvname = UPPER(@subscriber) 
            and dest_db = @subscriber_db)
    begin
        --
        -- set the reinit flag
        --
        update dbo.syssubscriptions
        set queued_reinit = 0
        where artid = @artid 
            and srvname = UPPER(@subscriber) 
            and dest_db = @subscriber_db
        if (@@error != 0)
            return (1)
    end
    else
    begin
        return (1)
    end
    --
    -- all done
    --
    return (0)
end            
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

