## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_reinitpullsubscription\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_reinitpullsubscription**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -966398499 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_reinitpullsubscription\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_reinitpullsubscription\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_reinitpullsubscription (
    @publisher sysname,
    @publisher_db sysname = NULL,
    @publication sysname = 'all'                       /* publication name */
    )AS

    SET NOCOUNT ON
    
    declare @subscription_type int    
    declare @sync_type tinyint
    
    /*
    ** Security Check
    */
    
      declare @retcode     int  
    EXEC @retcode = sys.sp_MSreplcheck_subscribe
    IF @@ERROR &lt;&gt; 0 or @retcode &lt;&gt; 0
        RETURN(1)

    /*
    ** Initializations.
    */
   
    /*
    ** Parameter Check: @publisher
    ** Check to make sure that the publisher is define
    */
    IF @publisher IS NULL
    BEGIN
        RAISERROR (14043, 16, -1, '@publisher', 'sp_reinitpullsubscription')
        RETURN (1)
    END

    IF @publisher = 'all'
    BEGIN
        RAISERROR (14136, 16, -1)
        RETURN (1)
    END

    EXECUTE @retcode = sys.sp_validname @publisher

    IF @@ERROR &lt;&gt; 0 OR @retcode &lt;&gt; 0
       RETURN (1)
    
    /*
    ** Parameter Check: @publisher_db
    */
    IF @publisher_db = 'all'
    BEGIN
        RAISERROR (14136, 16, -1)
        RETURN (1)
    END

    IF @publisher_db IS NOT NULL
    BEGIN
        EXECUTE @retcode = sys.sp_validname @publisher_db
        IF @@ERROR &lt;&gt; 0 OR @retcode &lt;&gt; 0
            RETURN (1)
    END
    ELSE
    BEGIN
        -- @publisher_db is NULL for Oracle publishers only
        SET @publisher_db = @publisher
    END

    /*
    ** Parameter Check: @publication
    ** 
    */
    IF @publication IS NULL
    BEGIN
        RAISERROR (14043, 16, -1, '@publication', 'sp_reinitpullsubscription')
        RETURN (1)
    END

    IF LOWER(@publication) = 'all'
        select @publication = '%'
    ELSE
    BEGIN
        EXECUTE @retcode = sys.sp_validname @publication

        IF @@ERROR &lt;&gt; 0 OR @retcode &lt;&gt; 0
        RETURN (1)
    END

    -- Peer-To-Peer subscriptions cannot be reinited
    IF OBJECT_ID(N'MSpeer_lsns', 'U') is not NULL
    BEGIN
        -- Check if we should raise an
        IF exists(select * 
                    from MSpeer_lsns
                    where originator = UPPER(@publisher)
                        and originator_db = @publisher_db
                        and originator_publication like @publication)
        BEGIN
            -- Subscriptions to publications that are enabled for ''Peer-To-Peer'' cannot be reinitialized.
            raiserror(20801, 16, -1)
            return (1)
        END        
    END
    
    IF NOT EXISTS (SELECT * FROM  MSreplication_subscriptions 
                WHERE UPPER(publisher) = UPPER(@publisher) AND
                      publisher_db  = @publisher_db AND
                      publication like @publication )
    BEGIN
            RAISERROR(14135, 11, -1,  @publisher, @publisher_db, @publication)
            RETURN(1)
    END
        
    select @sync_type = immediate_sync 
        from MSreplication_subscriptions
        WHERE UPPER(publisher) = UPPER(@publisher) AND publisher_db  = @publisher_db AND publication like @publication 

    IF @sync_type = 0
    BEGIN
        raiserror(21059, 16, -1)
        return (1)
    END
    
    -- 
    -- Since it is the user's desire to reinitialize the pull subscriptions,
    -- we should make sure that new snapshots are delivered from scratch
    -- to this subscription database by resetting the snapshot delivery
    -- progress table.
    --
    exec @retcode = sys.sp_resetsnapshotdeliveryprogress
    if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
        return (1)

    UPDATE MSreplication_subscriptions set 
        transaction_timestamp = cast(0x00 as binary(15)) + cast(substring(transaction_timestamp, 16, 1) as binary(1))
        WHERE UPPER(publisher) = UPPER(@publisher) AND
                      publisher_db  = @publisher_db AND
                      publication like @publication
    if @@ERROR&lt;&gt;0 
        RETURN (1)

    -- Reset the attach state so that the distribution agent will not adjust attach state.
    if @publication &lt;&gt; '%'
    begin
        select @subscription_type = subscription_type from MSreplication_subscriptions
            WHERE UPPER(publisher) = UPPER(@publisher) AND
                          publisher_db  = @publisher_db AND
                          publication = @publication and
                          -- Don't do this for push
                          subscription_type &lt;&gt; 0
        if @subscription_type is not null
        begin
            exec @retcode = sys.sp_MSreset_attach_state 
                @publisher = @publisher,
                @publisher_db = @publisher_db,
                @publication = @publication,
                @subscription_type = @subscription_type
            if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
                return (1)
        end
    end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

