## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_linkedservers_rowset\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_linkedservers_rowset**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -968069831 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@srvname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
|Name |Datatype |Max length |
|-|-|-|
|SVR_NAME|nvarchar|128|
|SVR_PRODUCT|nvarchar|128|
|SVR_PROVIDERNAME|nvarchar|128|
|SVR_DATASOURCE|nvarchar|4000|
|SVR_PROVIDERSTRING|nvarchar|4000|
|SVR_LOCATION|nvarchar|4000|
|SVR_CATALOG|nvarchar|128|

---
### Objects that depend on \[sys\].\[sp_linkedservers_rowset\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_linkedservers_rowset\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

create procedure sys.sp_linkedservers_rowset
(
    @srvname    sysname
)
as
    select
        SVR_NAME            = s_s.name,
        SVR_PRODUCT         = s_s.product,
        SVR_PROVIDERNAME    = s_s.provider,
        SVR_DATASOURCE      = s_s.data_source,
        SVR_PROVIDERSTRING  = s_s.provider_string,
        SVR_LOCATION        = s_s.location,
        SVR_CATALOG         = s_s.catalog
    from
        sys.servers s_s
    where
        s_s.name = @srvname and
        -- Don't use s_s.is_linked, because 0 there means old-style linked server, 1 means new-style.
        s_s.is_data_access_enabled = 1
    order by 1
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

