## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSscriptforeignkeyrestore\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSscriptforeignkeyrestore**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -96815055 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@program_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@constraint_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@parent_schema| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@parent_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@referenced_object_schema| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@referenced_object_name| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@is_not_for_replication| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@is_not_trusted| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@delete_referential_action| |tinyint|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@update_referential_action| |tinyint|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSscriptforeignkeyrestore\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSscriptforeignkeyrestore\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSscriptforeignkeyrestore (
    @program_name               sysname,
    @constraint_name            sysname,
    @parent_schema              sysname,
    @parent_name                sysname,
    @referenced_object_schema   sysname,
    @referenced_object_name     sysname,
    @is_not_for_replication     bit,
    @is_not_trusted             bit,
    @delete_referential_action  tinyint,
    @update_referential_action  tinyint
    )
as
begin
    set nocount on

    declare @retcode int
    declare @number_of_key_columns int

    declare @script table (line_number int identity primary key, line nvarchar(4000))

    exec @retcode = sys.sp_MSreplcheck_subscribe
    if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
        return 1

    select @number_of_key_columns = count(*)
      from dbo.MSsavedforeignkeycolumns
     where program_name = @program_name
       and constraint_name = @constraint_name
       and parent_schema = @parent_schema 

    insert into @script (line) values (N'alter table ' + quotename(@parent_schema) + N'.' + quotename(@parent_name))
    if @is_not_trusted = 1
    begin
        insert into @script (line) values (N'with nocheck')    
    end
    insert into @script (line) values (N'add constraint ' + quotename(@constraint_name) + N' foreign key (' )

    insert into @script (line) 
        select quotename(referencing_column_name)
          from dbo.MSsavedforeignkeycolumns
         where program_name = @program_name
           and constraint_name = @constraint_name
           and parent_schema = @parent_schema
           and constraint_column_id = 1

    insert into @script (line)
        select N', ' + quotename(referencing_column_name)
          from dbo.MSsavedforeignkeycolumns
         where program_name = @program_name
           and constraint_name = @constraint_name
           and parent_schema = @parent_schema
           and constraint_column_id &gt; 1
        order by constraint_column_id asc

    insert into @script (line) values (N') references ' + quotename(@referenced_object_schema) + N'.' + quotename(@referenced_object_name) + N' (')

    insert into @script (line) 
        select quotename(referenced_column_name)
          from dbo.MSsavedforeignkeycolumns
         where program_name = @program_name
           and constraint_name = @constraint_name
           and parent_schema = @parent_schema
           and constraint_column_id = 1

    insert into @script (line)
        select N', ' + quotename(referenced_column_name)
          from dbo.MSsavedforeignkeycolumns
         where program_name = @program_name
           and constraint_name = @constraint_name
           and parent_schema = @parent_schema
           and constraint_column_id &gt; 1
        order by constraint_column_id asc

    insert into @script (line)
    select N') on delete ' + 
        case @delete_referential_action 
            when 1 then N'cascade '
            when 2 then N'set null '
            when 3 then N'set default '
            else N'no action '
        end +
        'on update ' +
        case @update_referential_action
            when 1 then N'cascade '
            when 2 then N'set null '
            when 3 then N'set default '
            else N'no action '
        end +
        case when @is_not_for_replication = 1 then N'not for replication'
             else N''
        end

    select line from @script order by line_number asc    

end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

