## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_changearticlecolumndatatype\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_changearticlecolumndatatype**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -970591485 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@article| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@column| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@mapping_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@type| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@length| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@precision| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@scale| |bigint|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_changearticlecolumndatatype\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_changearticlecolumndatatype\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

--
-- Name:    
--          sp_chagnearticlecolumndatatype
--          
-- Description: 
--            Sets article column datatype mapping
--  
-- Security: 
--          Public
--
-- Returns:
--          Success (0) or failure (1)
--      
-- Owner:   
--          &lt;current owner&gt; 
--

create procedure sys.sp_changearticlecolumndatatype
(
    @publication    sysname,
    @article        sysname,
    @column            sysname,
    @mapping_id        int = NULL,
    @type            sysname = NULL,
    @length            bigint = NULL,
    @precision        bigint = NULL,
    @scale            bigint = NULL,
    @publisher        sysname = NULL
) 
AS
BEGIN
    DECLARE @cmd            nvarchar(4000)
    DECLARE @retcode        int
    DECLARE    @publisher_type    sysname
    
    SET @retcode = 0
    
    EXEC @retcode = sys.sp_MSrepl_getpublisherinfo    @publisher        = @publisher,
                                                    @rpcheader        = @cmd OUTPUT,
                                                    @publisher_type    = @publisher_type OUTPUT
    
    IF @retcode &lt;&gt; 0
        RETURN (@retcode)
        
    IF @publisher_type = N'MSSQLSERVER'
    BEGIN    
        RAISERROR (21659, 16, -1)
        RETURN (1)
    END

    -- Add sp
    SET @publisher = UPPER(@publisher) COLLATE DATABASE_DEFAULT
    set @cmd = @cmd + N'sys.sp_MSrepl_changearticlecolumndatatype'

    EXEC @retcode = @cmd
                @publication,
                @article,
                @column,
                @mapping_id,
                @type,
                @length,
                @precision,
                @scale,
                1,
                @publisher,
                @publisher_type

    RETURN (@retcode)
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

