## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MScleanup_subscription_distside_entry\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MScleanup_subscription_distside_entry**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -977782787 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscriber| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@subscriber_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MScleanup_subscription_distside_entry\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MScleanup_subscription_distside_entry\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create proc sys.sp_MScleanup_subscription_distside_entry 
    @publisher sysname,
    @publisher_db sysname,
    @publication sysname,
    @subscriber sysname,
    @subscriber_db sysname
as 
begin

    declare @min_valid_day         datetime
    , @publisher_id         int
    , @publication_id        int
    , @retention             int
    , @agent_id            int
    , @retcode int
    , @retention_period_unit tinyint

    -- Security Check: require sysadmin/dbo of dist 
    IF IS_MEMBER('db_owner') != 1
    BEGIN
        RAISERROR(21089,16,-1) 
        RETURN 1
    END

    -- database must be distribution db
    IF sys.fn_MSrepl_isdistdb(DB_NAME()) &lt;&gt; 1
    BEGIN
        RAISERROR (21482, 16, -1, 'sp_MScleanup_subscription_distside_entry', 'distribution')
        RETURN 1
    END

    select @publisher_id = srvid from master.dbo.sysservers where UPPER(srvname) = UPPER(@publisher) 
    if @publisher_id is NULL
        return 0
        
    select @publication_id = publication_id, @retention = retention, @retention_period_unit = retention_period_unit
        from dbo.MSpublications
        where publisher_id = @publisher_id
        and publisher_db = @publisher_db
        and publication = @publication
        and publication_type = 2
        and retention&lt;&gt;0
        
    if @publication_id is null
        return 0

    select @min_valid_day = sys.fn_add_units_to_date(-@retention, @retention_period_unit, getdate())

    select @agent_id = msa.id from dbo.MSmerge_agents msa
    where msa.creation_date &lt; @min_valid_day
    and msa.publisher_id = @publisher_id
    and msa.publisher_db = @publisher_db
    and msa.publication = @publication   
    and upper(msa.subscriber_name) = upper(@subscriber) collate database_default
    and msa.subscriber_db = @subscriber_db
       
    if @agent_id is not null and not exists (
                                                select * from dbo.MSmerge_sessions sess
                                                where sess.agent_id = @agent_id
                                                and sess.end_time &gt; @min_valid_day
                                            )
    begin
        exec @retcode = sys.sp_MSdrop_merge_agentid @agent_id
        if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
            return 1
    end
    
    return 0
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

