## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSprep_exclusive\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSprep_exclusive**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -978110975 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@objname| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@objid| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSprep_exclusive\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSprep_exclusive\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSprep_exclusive 
    @objname sysname
    ,@objid int = NULL
as
    set nocount on
    declare @retcode int
                ,@tran_pubname sysname

    EXEC @retcode = sys.sp_MSreplcheck_publish
    IF @@ERROR &lt;&gt; 0 or @retcode &lt;&gt; 0
        return (1)

    if @objname is NULL
    begin
        RAISERROR (14043, 16, -1, '@objname', 'sp_MSprep_exclusive')
        return (1)
    end

    if(@objid is NULL)
    begin
        select @objid = object_id(@objname)
        if @objid is NULL
        begin
            raiserror(14027, 16, -1, @objname)
            return (1)
        end

        exec sys.sp_replupdateschema @objname
        if @@ERROR&lt;&gt;0
            return (1)
    end

    declare #trancolumn CURSOR LOCAL FAST_FORWARD for 
            select p.name from sysarticles a join 
                                                syspublications p on p.pubid = a.pubid
                                    where a.objid=@objid
    open #trancolumn
    fetch #trancolumn into @tran_pubname
    while (@@fetch_status &lt;&gt; -1)
    BEGIN
        EXEC @retcode = sys.sp_getapplock   @Resource = @tran_pubname, 
                        @LockMode = N'Exclusive', 
                        @LockOwner = N'Transaction', 
                        @LockTimeout = 0,
                        @DbPrincipal = N'db_owner' -- Note that we already require db_owner due to security check at the beginning of the stored procedure.
        if @retcode = -1
        begin 
            raiserror(21386, 16, -1, @objname)
            goto FAILURE    
        end 
        if @@ERROR&lt;&gt;0 or @retcode &lt; 0
            goto FAILURE
        fetch #trancolumn into @tran_pubname            
    END
    close #trancolumn
    deallocate #trancolumn
    return 0
FAILURE:
    return (1)
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

