## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSenumcolumns\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSenumcolumns**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -980854298 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@pubid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@artid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@maxschemaguidforarticle| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@show_filtering_columns| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSenumcolumns\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSenumcolumns\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSenumcolumns
    @pubid uniqueidentifier,
    @artid uniqueidentifier,
    @maxschemaguidforarticle uniqueidentifier = NULL,
    @show_filtering_columns bit = 0
AS
    declare @retcode            int
    declare @procname            sysname
    declare @nickname            int

    -- security check
    if ({fn ISPALUSER(@pubid)} &lt;&gt; 1)
    begin
        if (@pubid is NULL)
        begin
            RAISERROR (21723, 16, -1, 'sp_MSenumcolumns')
            return 1
        end
        else
        begin
            RAISERROR (14126, 11, -1)
            return 1
        end
    end
    
    --
    -- For security: break ownership chain as
    -- we have no control over the proc name is
    --
    declare @spretcode int
            ,@spcall nvarchar(256)
    select @procname = 'dbo.' + select_proc from dbo.sysmergearticles where pubid = @pubid and artid = @artid
    select @spcall = N'exec @p1 = ' + @procname + N' @maxschemaguidforarticle = '

    if @maxschemaguidforarticle is NULL
        select @spcall = @spcall + 'NULL'
    else
        select @spcall = @spcall + '''' + convert(nvarchar(40),@maxschemaguidforarticle) +  ''''

    select @spcall = @spcall + ', @type = 6 '
    
    exec @retcode = sys.sp_executesql @stmt = @spcall
        ,@params = N'@p1 int output'
        ,@p1 = @spretcode output
    IF @@error&lt;&gt;0 or @retcode&lt;&gt;0 or @spretcode != 0 
        return 1
    
    -- SQL2000 and lower agents pass @show_filtering_columns as 0. 
    if @show_filtering_columns = 1
    begin
        select @nickname = nickname from dbo.sysmergearticles
        where pubid = @pubid 
        and artid = @artid
        
        exec @retcode = sys.sp_MSgetfilteringcolumns @pubid = @pubid, @nickname = @nickname
        if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
            return 1
    end
    
    return 0

GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

