## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSupdatepeerlsn\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSupdatepeerlsn**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -982620125 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@originator| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@originator_db| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@originator_publication_id| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@originator_db_version| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@originator_lsn| |varbinary|10|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSupdatepeerlsn\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSupdatepeerlsn\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSupdatepeerlsn
(
    @originator                    sysname,
    @originator_db                sysname,
    @originator_publication_id        int,
    @originator_db_version        int,
    @originator_lsn                varbinary(10)                    
)
as
begin
    declare @retcode         bit,
            @error            int,
            @rows_affected    int
    
    -- security check for subscriber
    exec @retcode = sys.sp_MSreplcheck_subscribe 
    if @@error &lt;&gt; 0 or  @retcode &lt;&gt; 0 
    begin
        return 1
    end

    begin transaction tran_sp_MSupdatepeerlsn
    save transaction tran_sp_MSupdatepeerlsn
    
    -- update the peer_lsn
    update MSpeer_lsns
        set last_updated     = getdate(),
            originator_lsn     = @originator_lsn
        from MSpeer_lsns with (index(uci_MSpeer_lsns))
        where originator                    = UPPER(@originator)
            and originator_db                 = @originator_db
            and originator_publication_id    = @originator_publication_id 
            and originator_db_version        = @originator_db_version
            and originator_lsn                &lt;= @originator_lsn

    -- cache the row count and error
    select @rows_affected     = @@rowcount,
            @error            = @@error

    -- if we hit an error let the user know and exit
    if @error &lt;&gt; 0
    begin
        goto FAILURE
    end

    -- if row count is 0 then we know we are not a peer and the subcription is not found.
    if @rows_affected &lt;&gt; 1
    begin
        declare @pub_id varchar(10)

        select @pub_id = cast(@originator_publication_id as varchar)

        -- No peers were found for %s:%s:%s.
        raiserror(20807, 16, -1, @originator, @originator_db, @pub_id)
        goto FAILURE
    end

    commit transaction tran_sp_MSupdatepeerlsn
    
    return 0
FAILURE:
    rollback transaction tran_sp_MSupdatepeerlsn
    commit transaction tran_sp_MSupdatepeerlsn

    -- The procedure sys.sp_MSupdatepeerlsn failed to UPDATE the resource MSpeer_lsns. Server error =  0.
    raiserror (21499, 16, -1, 'sys.sp_MSupdatepeerlsn', 'UPDATE', 'MSpeer_lsns.', @error)

    
    return 1
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

