## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSacquiresnapshotdeliverysessionlock\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSacquiresnapshotdeliverysessionlock**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -985925458 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
 No parameters exist

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSacquiresnapshotdeliverysessionlock\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSacquiresnapshotdeliverysessionlock\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
--
-- Name: sp_MSacquiresnapshotdeliverysessionlock
--
-- Description: This procedure is used by the distribution/merge agent to 
--              acquire a subscription database specific application lock
--              during snapshot delivery. This application lock can be used for
--              coordination with any user application that does not wish to 
--              be exposed to inconsistent data at the subscription database
--              while a snapshot is being delivered.
-- 
-- Returns: 0 - succeeded
--          1 - failed
--
-- Notes: i) This procedure should be executed by the distribution/merge agent
--        at the subscription database.
--        ii) This procedure will block until the application lock is acquired.
--
-- Security: Execute permission of this procedure is granted to public;
--           procedural security check will be performed to make sure
--           that the caller is either a db_owner of the current database
--           or a sysadmin. 
--
create procedure sys.sp_MSacquiresnapshotdeliverysessionlock
as
begin
    set nocount on
    declare @retcode int
    declare @resource nvarchar(255)
    select @retcode = 0    
    select @resource = N'snapshot_delivery_in_progress_' + 
                       db_name() collate database_default
    exec @retcode = sys.sp_MSreplcheck_subscribe
    if @retcode &lt;&gt; 0 or @@error &lt;&gt; 0
    begin
        select @retcode = 1
        goto FAILURE
    end
    
    -- Try to create the snapshot delivery progress table here so multiple
    -- bcp threads in DTS snapshot are guaranteed to be able to access
    -- the snapshot progress table
    if object_id('dbo.MSsnapshotdeliveryprogress') is null
    begin
        create table dbo.MSsnapshotdeliveryprogress 
        (
           session_token nvarchar(260) not null,
           progress_token_hash int not null,
           progress_token nvarchar(500) not null,
           progress_timestamp datetime default getdate()
        )
        if @@ERROR &lt;&gt; 0
        begin 
            select @retcode = 1
            goto FAILURE
        end        
        create index ci_MSsnapshotdeliveryprogress_progress_token_hash 
            on dbo.MSsnapshotdeliveryprogress(progress_token_hash)
        if @@ERROR &lt;&gt; 0
        begin 
            select @retcode = 1
            goto FAILURE
        end        
        create index nci_MSsnapshotdeliveryprogress_session_token
            on dbo.MSsnapshotdeliveryprogress(session_token)
        if @@ERROR &lt;&gt; 0
        begin 
            select @retcode = 1
            goto FAILURE
        end        
        exec @retcode = dbo.sp_MS_marksystemobject 'dbo.MSsnapshotdeliveryprogress'
        if @retcode &lt;&gt; 0 or @@ERROR &lt;&gt; 0
        begin 
            select @retcode = 1
            goto FAILURE
        end        
    end 

    exec @retcode = sys.sp_getapplock @Resource = @resource,
                                             @LockMode = 'Shared',    
                                             @LockOwner = 'Session',
                                             @LockTimeout = -1,
                                             @DbPrincipal = N'db_owner'
    if @@error &lt;&gt; 0 or @retcode &lt; 0
    begin
        select @retcode = 1
        goto FAILURE
    end
    select @retcode = 0
FAILURE:
    return @retcode
end
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

