## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MSactivate_auto_sub\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MSactivate_auto_sub**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -993696157 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@publication| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@article| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@status| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@skipobjectactivation| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@publisher| |sysname|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MSactivate_auto_sub\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MSactivate_auto_sub\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MSactivate_auto_sub
(
    @publication            sysname,
    @article                sysname,
    @status                    sysname = 'active',
    @skipobjectactivation    int = 0,
    @publisher                sysname = null
)
AS
BEGIN
    SET NOCOUNT ON

    DECLARE @retcode        int
    DECLARE    @publisher_type    sysname
    DECLARE @pubid          int
    DECLARE @from_auto_sync    int

    EXEC @retcode = sys.sp_MSrepl_getpublisherinfo    @publisher        = @publisher,
                                                    @publisher_type    = @publisher_type OUTPUT,
                                                    @skipSecurityCheck    = 1
    
    IF @retcode &lt;&gt; 0
        RETURN (@retcode)

    SET @publisher = UPPER(@publisher) COLLATE DATABASE_DEFAULT

    /*
    ** Security Check.
    */
    exec @retcode = sys.sp_MSreplcheck_publish
    if @@ERROR &lt;&gt; 0 or @retcode &lt;&gt; 0
        return(1)

    /*
    ** Check to see if the database has been activated for publication.
    */
    IF sys.fn_MSrepl_istranpublished(DB_NAME(),1) &lt;&gt; 1
    BEGIN
        RAISERROR (14013, 16, -1)
        RETURN (1)
    END

    -- parameter check: @status:  

    IF LOWER(@status collate SQL_Latin1_General_CP1_CS_AS) not in (N'active', N'initiated')
    BEGIN
        RAISERROR(21156, 16, -1)
        RETURN 1
    END

    /*
    ** Parameter Check:  @publication.
    ** Make sure that the publication exists and the publication is not push type
    */

    IF @publication IS NULL
        BEGIN
            RAISERROR (14043, 16, -1, '@publication', 'sp_MSactivate_auto_sub')
            RETURN (1)
        END

    --
    -- Verify publication exists
    --
    SELECT @pubid = sys.fn_MSrepl_getpubid(@publication, @publisher, @publisher_type)

    IF (@pubid IS NULL)
    BEGIN
        RAISERROR (20026, 11, -1, @publication)
        RETURN (1)
    END
    
    BEGIN TRAN

    IF @status = N'active'
    BEGIN
        UPDATE    syspublications
        SET        immediate_sync_ready = 1 
        WHERE    immediate_sync = 1
          AND    immediate_sync_ready &lt;&gt; 1
          AND    pubid = @pubid
        
        IF @@ERROR &lt;&gt; 0
        BEGIN
            GOTO UNDO
            RETURN (1)
        END
    END
    
    SET @from_auto_sync = 1

    EXECUTE @retcode =    sys.sp_changesubstatus 
                        @publication = @publication,
                        @article = @article,
                        @status = @status,
                        @from_auto_sync = @from_auto_sync,
                        @skipobjectactivation = @skipobjectactivation,
                        @publisher = @publisher

    IF @@ERROR &lt;&gt; 0 OR @retcode &lt;&gt; 0
    BEGIN
        GOTO UNDO
        RETURN (1)
    END
    
    COMMIT TRAN
    RETURN(0)

UNDO:
    IF @@TRANCOUNT = 1
        ROLLBACK TRAN
    ELSE
        COMMIT TRAN
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

