## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[sys\].\[sp_MScreate_tempgenhistorytable\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **sys.sp_MScreate_tempgenhistorytable**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -99405635 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@pubid| |uniqueidentifier|16|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[sys\].\[sp_MScreate_tempgenhistorytable\]
 No dependencies exist

---
### Objects that \[sys\].\[sp_MScreate_tempgenhistorytable\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
create procedure sys.sp_MScreate_tempgenhistorytable
    @pubid uniqueidentifier
as

    declare @retcode int
    declare @temp_genhistory_table sysname
    declare @qual_temp_genhistory_table sysname
    declare @guidstr varchar(100)
    declare @cmd nvarchar(4000)
    declare @objid sysname
    declare @is_system_object bit

    -- Security check
    exec @retcode = sys.sp_MSrepl_PAL_rolecheck 
    if (@retcode &lt;&gt; 0) or (@@error &lt;&gt; 0)
            return 1

    select @guidstr = sys.fn_MSguidtostr(@pubid)
    select @temp_genhistory_table = 'MSmerge_genhistory_' + LOWER(@guidstr)
    select @qual_temp_genhistory_table = 'dbo.' + @temp_genhistory_table

    select @objid = object_id, @is_system_object = is_ms_shipped from sys.objects where name = @temp_genhistory_table

    if (@objid is null)
    begin
        select @cmd = 'select * into ' + @qual_temp_genhistory_table + ' from dbo.MSmerge_genhistory where 1=2'

        exec @retcode = sys.sp_executesql @cmd
        if @@error &lt;&gt; 0 or @retcode &lt;&gt; 0
            goto Failure

        exec @retcode = sys.sp_MS_marksystemobject @temp_genhistory_table
        if @@error&lt;&gt;0 or @retcode&lt;&gt;0
            goto Failure        
    end
    else if (@is_system_object = 0)
    begin
        -- temp_genhistory table is probably a user table.
        raiserror(20008, 16, -1)
        return 1
    end   
    return (0)
    
Failure:  
    return(1)
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

