## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[Sales\].\[usp_UpdateSalesOrderShipInfo_native\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **Sales.usp_UpdateSalesOrderShipInfo_native**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[Sales\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md) |
| Owner | [\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md) |
| Creation date | 10/23/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | 1508200423 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/CHECK_OUT.png "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@SalesOrderID| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@ShipDate| |datetime2|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@Comment| |nvarchar|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@Status| |tinyint|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@TaxRate| |smallmoney|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@Freight| |money|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@CarrierTrackingNumber| |nvarchar|25|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[Sales\].\[usp_UpdateSalesOrderShipInfo_native\]
|Object name|Object type|Dep level|
|-|-|-|
|[\[Sales\].\[usp_UpdateSalesOrderShipInfo_inmem\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1524200480.md)|Procedure|1|

 Total 1 object(s)

---
### Objects that \[Sales\].\[usp_UpdateSalesOrderShipInfo_native\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Sales\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md)|Schema|1|

 Total 1 object(s)

---
### Column level dependencies
 No dependencies exist

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1508200423_gr.md) to view dependencies graphically

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE Sales.usp_UpdateSalesOrderShipInfo_native
    @SalesOrderID int , 
    @ShipDate datetime2,
    @Comment nvarchar(128),
    @Status tinyint,
    @TaxRate smallmoney,
    @Freight money,
    @CarrierTrackingNumber nvarchar(25)
WITH NATIVE_COMPILATION, SCHEMABINDING
AS
BEGIN ATOMIC WITH
  (TRANSACTION ISOLATION LEVEL = SNAPSHOT,
   LANGUAGE = N'us_english')

    DECLARE @now datetime2 = SYSDATETIME()

    UPDATE Sales.SalesOrderDetail_inmem 
    SET CarrierTrackingNumber = @CarrierTrackingNumber, ModifiedDate = @now
    WHERE SalesOrderID = @SalesOrderID

    UPDATE Sales.SalesOrderHeader_inmem
    SET RevisionNumber = RevisionNumber + 1,
        ShipDate = @ShipDate,
        Status = @Status,
        TaxAmt = SubTotal * @TaxRate,
        Freight = @Freight,
        ModifiedDate = @now
    WHERE SalesOrderID = @SalesOrderID

END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

