## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[Sales\].\[usp_UpdateSalesOrderShipInfo_inmem\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **Sales.usp_UpdateSalesOrderShipInfo_inmem**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[Sales\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md) |
| Owner | [\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md) |
| Creation date | 10/23/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | 1524200480 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@SalesOrderID| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@ShipDate| |datetime2|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@Comment| |nvarchar|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@Status| |tinyint|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@TaxRate| |smallmoney|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@Freight| |money|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@CarrierTrackingNumber| |nvarchar|25|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[Sales\].\[usp_UpdateSalesOrderShipInfo_inmem\]
 No dependencies exist

---
### Objects that \[Sales\].\[usp_UpdateSalesOrderShipInfo_inmem\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Sales\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md)|Schema|1|
|[\[Sales\].\[usp_UpdateSalesOrderShipInfo_native\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1508200423.md)|Procedure|1|

 Total 2 object(s)

---
### Column level dependencies
 No dependencies exist

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1524200480_gr.md) to view dependencies graphically

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
-- wrapper stored procedure that contains retry logic to deal with update conflicts
-- alternatively, the client can perform retries in case of conflicts

-- for simplicity, we assume all items in the order are shipped in the same package, and thus have the same carrier tracking number
CREATE PROCEDURE Sales.usp_UpdateSalesOrderShipInfo_inmem
    @SalesOrderID int , 
    @ShipDate datetime2 = NULL,
    @Comment nvarchar(128) = NULL,
    @Status tinyint,
    @TaxRate smallmoney = 0,
    @Freight money,
    @CarrierTrackingNumber nvarchar(25)
AS
BEGIN

  DECLARE @retry INT = 10
  SET @ShipDate = ISNULL(@ShipDate, SYSDATETIME())

  WHILE (@retry &gt; 0)
  BEGIN
    BEGIN TRY

      EXEC Sales.usp_UpdateSalesOrderShipInfo_native
        @SalesOrderID = @SalesOrderID, 
        @ShipDate = @ShipDate,
        @Comment = @Comment,
        @Status = @Status,
        @TaxRate = @TaxRate,
        @Freight = @Freight,
        @CarrierTrackingNumber = @CarrierTrackingNumber


      SET @retry = 0
    END TRY
    BEGIN CATCH
      SET @retry -= 1
  
      IF (@retry &gt; 0 AND error_number() in (41302, 41305, 41325, 41301))
      BEGIN

        IF XACT_STATE() &lt;&gt; 0 
          ROLLBACK TRANSACTION

      END
      ELSE
      BEGIN
        ;THROW
      END
    END CATCH
  END
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

