## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[Sales\].\[usp_UpdateSalesOrderShipInfo_ondisk\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **Sales.usp_UpdateSalesOrderShipInfo_ondisk**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[Sales\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md) |
| Owner | [\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md) |
| Creation date | 10/23/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | 1540200537 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@SalesOrderID| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@ShipDate| |datetime2|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@Comment| |nvarchar|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@Status| |tinyint|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@TaxRate| |smallmoney|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@Freight| |money|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@CarrierTrackingNumber| |nvarchar|25|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[Sales\].\[usp_UpdateSalesOrderShipInfo_ondisk\]
 No dependencies exist

---
### Objects that \[Sales\].\[usp_UpdateSalesOrderShipInfo_ondisk\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Sales\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md)|Schema|1|
|[\[Sales\].\[SalesOrderDetail_ondisk\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1332199796.md)|Table|1|
|[\[Sales\].\[SalesOrderHeader_ondisk\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1092198941.md)|Table|1|

 Total 3 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[Sales\].\[SalesOrderDetail_ondisk\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1332199796.md)|SalesOrderID|Table|
|[\[Sales\].\[SalesOrderDetail_ondisk\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1332199796.md)|CarrierTrackingNumber|Table|
|[\[Sales\].\[SalesOrderDetail_ondisk\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1332199796.md)|ModifiedDate|Table|
|[\[Sales\].\[SalesOrderHeader_ondisk\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1092198941.md)|SalesOrderID|Table|
|[\[Sales\].\[SalesOrderHeader_ondisk\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1092198941.md)|RevisionNumber|Table|
|[\[Sales\].\[SalesOrderHeader_ondisk\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1092198941.md)|ShipDate|Table|
|[\[Sales\].\[SalesOrderHeader_ondisk\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1092198941.md)|Status|Table|
|[\[Sales\].\[SalesOrderHeader_ondisk\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1092198941.md)|TaxAmt|Table|
|[\[Sales\].\[SalesOrderHeader_ondisk\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1092198941.md)|Freight|Table|
|[\[Sales\].\[SalesOrderHeader_ondisk\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1092198941.md)|ModifiedDate|Table|
|[\[Sales\].\[SalesOrderHeader_ondisk\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1092198941.md)|SubTotal|Table|

 Total 11 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1540200537_gr.md) to view dependencies graphically

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
-- for simplicity, we assume all items in the order are shipped in the same package, and thus have the same carrier tracking number
CREATE PROCEDURE Sales.usp_UpdateSalesOrderShipInfo_ondisk
    @SalesOrderID int , 
    @ShipDate datetime2 = NULL,
    @Comment nvarchar(128) = NULL,
    @Status tinyint,
    @TaxRate smallmoney = 0,
    @Freight money,
    @CarrierTrackingNumber nvarchar(25)
AS
BEGIN
  SET @ShipDate = ISNULL(@ShipDate, SYSDATETIME())

  BEGIN TRAN
    DECLARE @now datetime2 = SYSDATETIME()

    UPDATE Sales.SalesOrderDetail_ondisk 
    SET CarrierTrackingNumber = @CarrierTrackingNumber, ModifiedDate = @now
    WHERE SalesOrderID = @SalesOrderID

    UPDATE Sales.SalesOrderHeader_ondisk
    SET RevisionNumber = RevisionNumber + 1,
        ShipDate = @ShipDate,
        Status = @Status,
        TaxAmt = SubTotal * @TaxRate,
        Freight = @Freight,
        ModifiedDate = @now
    WHERE SalesOrderID = @SalesOrderID
  COMMIT

END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

