## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[HumanResources\].\[uspUpdateEmployeeLogin\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **HumanResources.uspUpdateEmployeeLogin**

---
###  Description  
 Updates the Employee table with the values specified in the input parameters for the given BusinessEntityID. 



---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[HumanResources\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/5.md) |
| Owner | [\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md) |
| Creation date | 11/16/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | 1581248688 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@BusinessEntityID|Input parameter for the stored procedure uspUpdateEmployeeLogin. Enter a valid EmployeeID from the Employee table.|int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@OrganizationNode|Input parameter for the stored procedure uspUpdateEmployeeHireInfo. Enter a valid ManagerID for the employee.|hierarchyid|892|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@LoginID|Input parameter for the stored procedure uspUpdateEmployeeHireInfo. Enter a valid login for the employee.|nvarchar|256|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@JobTitle|Input parameter for the stored procedure uspUpdateEmployeeHireInfo. Enter a title for the employee.|nvarchar|50|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@HireDate|Input parameter for the stored procedure uspUpdateEmployeeHireInfo. Enter a hire date for the employee.|datetime|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@CurrentFlag|Input parameter for the stored procedure uspUpdateEmployeeHireInfo. Enter the current flag for the employee.|[\[dbo\].\[Flag\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/258.md)|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[HumanResources\].\[uspUpdateEmployeeLogin\]
 No dependencies exist

---
### Objects that \[HumanResources\].\[uspUpdateEmployeeLogin\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[HumanResources\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/5.md)|Schema|1|
|[\[dbo\].\[uspLogError\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/661577395.md)|Procedure|1|
|[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|Table|1|
|[\[dbo\].\[Flag\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/258.md)|Datatype|1|

 Total 4 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|BusinessEntityID|Table|
|[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|OrganizationNode|Table|
|[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|LoginID|Table|
|[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|JobTitle|Table|
|[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|HireDate|Table|
|[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|CurrentFlag|Table|

 Total 6 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1581248688_gr.md) to view dependencies graphically

---
###  Permissions
No permissions defined

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Updates the Employee table with the values specified in the input parameters for the given BusinessEntityID.|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [HumanResources].[uspUpdateEmployeeLogin]
    @BusinessEntityID [int], 
    @OrganizationNode [hierarchyid],
    @LoginID [nvarchar](256),
    @JobTitle [nvarchar](50),
    @HireDate [datetime],
    @CurrentFlag [dbo].[Flag]
WITH EXECUTE AS CALLER
AS
BEGIN
    SET NOCOUNT ON;

    BEGIN TRY
        UPDATE [HumanResources].[Employee] 
        SET [OrganizationNode] = @OrganizationNode 
            ,[LoginID] = @LoginID 
            ,[JobTitle] = @JobTitle 
            ,[HireDate] = @HireDate 
            ,[CurrentFlag] = @CurrentFlag 
        WHERE [BusinessEntityID] = @BusinessEntityID;
    END TRY
    BEGIN CATCH
        EXECUTE [dbo].[uspLogError];
    END CATCH;
END;
GO
EXEC sp_addextendedproperty N'MS_Description', N'Updates the Employee table with the values specified in the input parameters for the given BusinessEntityID.', 'SCHEMA', N'HumanResources', 'PROCEDURE', N'uspUpdateEmployeeLogin', NULL, NULL
GO
EXEC sp_addextendedproperty N'MS_Description', N'Input parameter for the stored procedure uspUpdateEmployeeLogin. Enter a valid EmployeeID from the Employee table.', 'SCHEMA', N'HumanResources', 'PROCEDURE', N'uspUpdateEmployeeLogin', 'PARAMETER', N'@BusinessEntityID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Input parameter for the stored procedure uspUpdateEmployeeHireInfo. Enter a valid ManagerID for the employee.', 'SCHEMA', N'HumanResources', 'PROCEDURE', N'uspUpdateEmployeeLogin', 'PARAMETER', N'@OrganizationNode'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Input parameter for the stored procedure uspUpdateEmployeeHireInfo. Enter a valid login for the employee.', 'SCHEMA', N'HumanResources', 'PROCEDURE', N'uspUpdateEmployeeLogin', 'PARAMETER', N'@LoginID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Input parameter for the stored procedure uspUpdateEmployeeHireInfo. Enter a title for the employee.', 'SCHEMA', N'HumanResources', 'PROCEDURE', N'uspUpdateEmployeeLogin', 'PARAMETER', N'@JobTitle'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Input parameter for the stored procedure uspUpdateEmployeeHireInfo. Enter a hire date for the employee.', 'SCHEMA', N'HumanResources', 'PROCEDURE', N'uspUpdateEmployeeLogin', 'PARAMETER', N'@HireDate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Input parameter for the stored procedure uspUpdateEmployeeHireInfo. Enter the current flag for the employee.', 'SCHEMA', N'HumanResources', 'PROCEDURE', N'uspUpdateEmployeeLogin', 'PARAMETER', N'@CurrentFlag'
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

