## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[Demo\].\[usp_DemoInitSeed\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **Demo.usp_DemoInitSeed**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[Demo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/11.md) |
| Owner | [\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md) |
| Creation date | 10/23/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | 1620200822 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@items_per_order| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[Demo\].\[usp_DemoInitSeed\]
 No dependencies exist

---
### Objects that \[Demo\].\[usp_DemoInitSeed\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Demo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/11.md)|Schema|1|
|[\[Demo\].\[DemoSalesOrderDetailSeed\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1556200594.md)|Table|1|
|[\[Demo\].\[DemoSalesOrderHeaderSeed\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1588200708.md)|Table|1|
|[\[Sales\].\[SalesOrderHeader_inmem\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/212195806.md)|Table|1|
|[\[Sales\].\[SpecialOfferProduct_inmem\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/132195521.md)|Table|1|

 Total 5 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[Sales\].\[SpecialOfferProduct_inmem\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/132195521.md)|ProductID|Table|
|[\[Sales\].\[SpecialOfferProduct_inmem\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/132195521.md)|SpecialOfferID|Table|
|[\[Demo\].\[DemoSalesOrderHeaderSeed\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1588200708.md)|*|Table|
|[\[Sales\].\[SalesOrderHeader_inmem\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/212195806.md)|BillToAddressID|Table|
|[\[Sales\].\[SalesOrderHeader_inmem\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/212195806.md)|CustomerID|Table|
|[\[Sales\].\[SalesOrderHeader_inmem\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/212195806.md)|SalesPersonID|Table|
|[\[Sales\].\[SalesOrderHeader_inmem\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/212195806.md)|ShipToAddressID|Table|
|[\[Sales\].\[SalesOrderHeader_inmem\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/212195806.md)|ShipMethodID|Table|
|[\[Demo\].\[DemoSalesOrderDetailSeed\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1556200594.md)|*|Table|

 Total 9 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1620200822_gr.md) to view dependencies graphically

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE Demo.usp_DemoInitSeed @items_per_order int = 5
AS
BEGIN
    DECLARE @ProductID int, @SpecialOfferID int,
        @i int = 1
    DECLARE @seed_order_count int = (SELECT COUNT(*)/@items_per_order FROM Sales.SpecialOfferProduct_inmem)

    DECLARE seed_cursor CURSOR FOR 
        SELECT 
            ProductID,
            SpecialOfferID 
        FROM Sales.SpecialOfferProduct_inmem

    OPEN seed_cursor

    FETCH NEXT FROM seed_cursor 
    INTO @ProductID, @SpecialOfferID

    BEGIN TRAN

        DELETE FROM Demo.DemoSalesOrderHeaderSeed

        INSERT INTO Demo.DemoSalesOrderHeaderSeed
        (
            DueDate,
            CustomerID,
            SalesPersonID,
            BillToAddressID,
            ShipToAddressID,
            ShipMethodID
        )
        SELECT
            dateadd(d, (rand(BillToAddressID*CustomerID)*10)+1,cast(sysdatetime() as date)),
            CustomerID,
            SalesPersonID,
            BillToAddressID,
            ShipToAddressID,
            ShipMethodID
        FROM Sales.SalesOrderHeader_inmem


        WHILE @@FETCH_STATUS = 0
        BEGIN
            INSERT Demo.DemoSalesOrderDetailSeed
            SELECT 
                @i % 6 + 1,
                @ProductID,
                @SpecialOfferID,
                @i % (@seed_order_count+1)

            SET @i += 1

            FETCH NEXT FROM seed_cursor 
            INTO @ProductID, @SpecialOfferID
        END

        CLOSE seed_cursor
        DEALLOCATE seed_cursor
    COMMIT

    UPDATE STATISTICS Demo.DemoSalesOrderDetailSeed
    WITH FULLSCAN, NORECOMPUTE
END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

