## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[Sales\].\[usp_InsertSalesOrder_inmem\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **Sales.usp_InsertSalesOrder_inmem**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[Sales\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md) |
| Owner | [\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md) |
| Creation date | 10/23/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | 1780201392 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/CHECK_OUT.png "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@SalesOrderID| |int|4|Input/output or output|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@DueDate| |datetime2|8|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@CustomerID| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@BillToAddressID| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@ShipToAddressID| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@ShipMethodID| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@SalesOrderDetails| |[\[Sales\].\[SalesOrderDetailType_inmem\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/264.md)|0|Input|![](../../../../ImagesMetro/CHECK_OUT.png "")|
|@Status| |tinyint|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@OnlineOrderFlag| |bit|1|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@PurchaseOrderNumber| |nvarchar|25|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@AccountNumber| |nvarchar|15|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@SalesPersonID| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@TerritoryID| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@CreditCardID| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@CreditCardApprovalCode| |varchar|15|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@CurrencyRateID| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@Comment| |nvarchar|128|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[Sales\].\[usp_InsertSalesOrder_inmem\]
 No dependencies exist

---
### Objects that \[Sales\].\[usp_InsertSalesOrder_inmem\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Sales\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md)|Schema|1|
|[\[Sales\].\[SalesOrderDetailType_inmem\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/264.md)|Datatype|1|

 Total 2 object(s)

---
### Column level dependencies
 No dependencies exist

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1780201392_gr.md) to view dependencies graphically

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE Sales.usp_InsertSalesOrder_inmem
    @SalesOrderID int OUTPUT,
    @DueDate [datetime2](7) NOT NULL,
    @CustomerID [int] NOT NULL,
    @BillToAddressID [int] NOT NULL,
    @ShipToAddressID [int] NOT NULL,
    @ShipMethodID [int] NOT NULL,
    @SalesOrderDetails Sales.SalesOrderDetailType_inmem READONLY,
    @Status [tinyint] NOT NULL = 1,
    @OnlineOrderFlag [bit] NOT NULL = 1,
    @PurchaseOrderNumber [nvarchar](25) = NULL,
    @AccountNumber [nvarchar](15) = NULL,
    @SalesPersonID [int] NOT NULL = -1,
    @TerritoryID [int] = NULL,
    @CreditCardID [int] = NULL,
    @CreditCardApprovalCode [varchar](15) = NULL,
    @CurrencyRateID [int] = NULL,
    @Comment nvarchar(128) = NULL
WITH NATIVE_COMPILATION, SCHEMABINDING
AS
BEGIN ATOMIC WITH
  (TRANSACTION ISOLATION LEVEL = SNAPSHOT,
   LANGUAGE = N'us_english')

    DECLARE @OrderDate datetime2 NOT NULL = SYSDATETIME()

    DECLARE @SubTotal money NOT NULL = 0

    SELECT @SubTotal = ISNULL(SUM(p.ListPrice * (1 - ISNULL(so.DiscountPct, 0))),0)
    FROM @SalesOrderDetails od 
        JOIN Production.Product_inmem p on od.ProductID=p.ProductID
        LEFT JOIN Sales.SpecialOffer_inmem so on od.SpecialOfferID=so.SpecialOfferID

    INSERT INTO Sales.SalesOrderHeader_inmem
    (    DueDate,
        Status,
        OnlineOrderFlag,
        PurchaseOrderNumber,
        AccountNumber,
        CustomerID,
        SalesPersonID,
        TerritoryID,
        BillToAddressID,
        ShipToAddressID,
        ShipMethodID,
        CreditCardID,
        CreditCardApprovalCode,
        CurrencyRateID,
        Comment,
        OrderDate,
        SubTotal,
        ModifiedDate)
    VALUES
    (    
        @DueDate,
        @Status,
        @OnlineOrderFlag,
        @PurchaseOrderNumber,
        @AccountNumber,
        @CustomerID,
        @SalesPersonID,
        @TerritoryID,
        @BillToAddressID,
        @ShipToAddressID,
        @ShipMethodID,
        @CreditCardID,
        @CreditCardApprovalCode,
        @CurrencyRateID,
        @Comment,
        @OrderDate,
        @SubTotal,
        @OrderDate
    )

    SET @SalesOrderID = SCOPE_IDENTITY()

    INSERT INTO Sales.SalesOrderDetail_inmem
    (
        SalesOrderID,
        OrderQty,
        ProductID,
        SpecialOfferID,
        UnitPrice,
        UnitPriceDiscount,
        ModifiedDate
    )
    SELECT 
        @SalesOrderID,
        od.OrderQty,
        od.ProductID,
        od.SpecialOfferID,
        p.ListPrice,
        ISNULL(p.ListPrice * so.DiscountPct, 0),
        @OrderDate
    FROM @SalesOrderDetails od 
        JOIN Production.Product_inmem p on od.ProductID=p.ProductID
        LEFT JOIN Sales.SpecialOffer_inmem so on od.SpecialOfferID=so.SpecialOfferID

END
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

