## ![](../../../../Images32x32Metro/OBJECT_PROCEDURE.png "") Procedure:\[AdventureWorks2016CTP3\].\[dbo\].\[uspAddOrderTrackingEvent\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Procedures](../../../../DbEngine/(local)/AdventureWorks2016CTP3/procedures.md) > **uspAddOrderTrackingEvent**

---
###  Description  




---
### Procedure properties
| Name | Value |
|-|-|
| Schema | [\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/1.md) |
| Owner | [\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md) |
| Creation date | 11/16/2015 |
| Type | P |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | 2029250284 |
| Implementation type | Transact SQL |
| Is native compiled |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Parameters
|Name |Description|Datatype |Max length |Type |ReadOnly|
|-|-|-|-|-|-|
|@SalesOrderID| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@TrackingEventID| |int|4|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|
|@EventDetails| |nvarchar|2000|Input|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Recordsets returned
 No recordsets returned

---
### Objects that depend on \[dbo\].\[uspAddOrderTrackingEvent\]
 No dependencies exist

---
### Objects that \[dbo\].\[uspAddOrderTrackingEvent\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[dbo\].\[uspLogError\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/661577395.md)|Procedure|1|
|[\[Sales\].\[OrderTracking\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1997250170.md)|Table|1|

 Total 2 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[Sales\].\[OrderTracking\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1997250170.md)|CarrierTrackingNumber|Table|
|[\[Sales\].\[OrderTracking\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1997250170.md)|SalesOrderID|Table|
|[\[Sales\].\[OrderTracking\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1997250170.md)|*|Table|

 Total 3 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/2029250284_gr.md) to view dependencies graphically

---
###  Permissions
No permissions defined

---
###  Extended properties  
No extended properties defined

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

----------------------------------------------------------------
-- Create supporting stored procedures
----------------------------------------------------------------
CREATE PROCEDURE [dbo].[uspAddOrderTrackingEvent]
   @SalesOrderID INT,
   @TrackingEventID INT,
   @EventDetails NVARCHAR(2000)
AS
BEGIN
/* Example:
      exec dbo.uspGetOrderTrackingBySalesOrderID 53498
      exec dbo.uspAddOrderTrackingEvent 53498, 7, 'invalid address, package is undeleverable'
      exec dbo.uspGetOrderTrackingBySalesOrderID 53498
*/
   SET NOCOUNT ON;

   BEGIN TRY
      BEGIN TRANSACTION;

      DECLARE @TrackingNumber NVARCHAR(25);

      SET @TrackingNumber = (
         SELECT TOP 1 ot.CarrierTrackingNumber 
           FROM Sales.OrderTracking ot
          WHERE ot.SalesOrderID = @SalesOrderID);

      IF (@TrackingNumber IS NULL)
      BEGIN
         SET @TrackingNumber = SUBSTRING(CONVERT(CHAR(255), NEWID()),2,25);
      END;

      INSERT INTO Sales.OrderTracking
         (SalesOrderID, CarrierTrackingNumber, TrackingEventID, EventDetails, EventDateTime)
      VALUES
         (@SalesOrderID, @TrackingNumber, @TrackingEventID, @EventDetails, GETDATE());

      COMMIT TRANSACTION;
   END TRY
   BEGIN CATCH
      -- Rollback any active or uncommittable transactions before
      -- inserting information in the ErrorLog
      IF @@TRANCOUNT &gt; 0
      BEGIN
         ROLLBACK TRANSACTION;
      END

      EXECUTE [dbo].[uspLogError];
   END CATCH;
END;
GO
  
~~~

---
### See also
[List of procedures](../procedures.md)

