## ![](../../../../Images32x32Metro/OBJECT_TABLE.png "") Table:\[AdventureWorks2016CTP3\].\[Purchasing\].\[Vendor\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > **Purchasing.Vendor**

---
###  Description  
 Companies from whom Adventure Works Cycles purchases parts or other goods. 



---
### Table properties
|Name |Value |
|-|-|
| Schema |[\[Purchasing\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/8.md)|
| Owner |[\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md)|
| Table is replicated |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Creation date |10/23/2015|
| ID |1086626914|
| Located on |PRIMARY|
| Data size KB |16 KB|
| Index size KB |32 KB|
| Rows |104 |
| ChangeTrackingEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| FileStreamFileGroup | |
| FileStreamPartitionScheme | |
| LockEscalation |TABLE|
| TrackColumnsUpdatedEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Table is filetable |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Filetable directory | |
| Filetable collate | |
| Filetable primary key |\[PK_Vendor_BusinessEntityID\]|
| Filetable streamid unique | |
| Filetable fullpath unique | |
| Filetable is enabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is memory optimized |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Durability |SCHEMA_AND_DATA|

---
### Creation options
|Name |Value |
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|
|ANSI_PADDING|ON|

---
### Columns
| | |Name |Description |IsComputed|Data type |Max length |Nullable |Default|IsGUID |SPARSE|Computed value|
|-|-|-|-|-|-|-|-|-|-|-|-|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1086626914_FK_Vendor_BusinessEntity_BusinessEntityID.md)|BusinessEntityID|Primary key for Vendor records.  Foreign key to BusinessEntity.BusinessEntityID| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |AccountNumber|Vendor account (identification) number.| |[\[dbo\].\[AccountNumber\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/257.md)|15|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |Name|Company name.| |[\[dbo\].\[Name\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/260.md)|50|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |CreditRating|1 = Superior, 2 = Excellent, 3 = Above average, 4 = Average, 5 = Below average| |tinyint|1|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |PreferredVendorStatus|0 = Do not use if another vendor is available. 1 = Preferred over other vendors supplying the same product.| |[\[dbo\].\[Flag\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/258.md)|1|![](../../../../ImagesMetro/RED_CROSS.gif "")|((1))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |ActiveFlag|0 = Vendor no longer used. 1 = Vendor is actively used.| |[\[dbo\].\[Flag\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/258.md)|1|![](../../../../ImagesMetro/RED_CROSS.gif "")|((1))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |PurchasingWebServiceURL|Vendor URL.| |nvarchar|1024|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |ModifiedDate|Date and time the record was last updated.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|(getdate())|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|

 Total: 8 column(s)

---
### Text column statistics
|Name |Data type |Avg. length |Min. length |Max. length |Usage rating |
|-|-|-|-|-|-|
|AccountNumber|nvarchar(15) |11|9|12|0.40000000000000|
|Name|nvarchar(50) |18|5|33|0.33000000000000|
|PurchasingWebServiceURL|nvarchar(1024)   |1|15|27|0.01318359375000|

 Total: 3 text column(s)

---
### Indexes
|Index |Key columns |Description |Primary |Unique |Size KB |Fill factor |
|-|-|-|-|-|-|-|
|[\[PK_Vendor_BusinessEntityID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1086626914_PK_Vendor_BusinessEntityID.md)|BusinessEntityID|Primary key (clustered) constraint|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|48|0|
|[\[AK_Vendor_AccountNumber\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1086626914_AK_Vendor_AccountNumber.md)|AccountNumber|Unique nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|16|0|

 Total: 2 Index/indexes

---
### Columnstore indexes
 No columnstore indexes exist

---
### Fulltext index
 No fulltext index exist

---
### Statistics
 No statistics exist

---
### Check constraints
|Name |Expression |
|-|-|
|CK_Vendor_CreditRating|(\[CreditRating\]&gt;=(1) AND \[CreditRating\]&lt;=(5))|

---
### Identity column
 No identity column exists

---
### Referencing tables
|Table |Foreign key |Primary key or unique constraint |
|-|-|-|
|[\[Purchasing\].\[ProductVendor\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1042102753.md)|[FK_ProductVendor_Vendor_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1042102753_FK_ProductVendor_Vendor_BusinessEntityID.md)|[PK_Vendor_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1086626914_PK_Vendor_BusinessEntityID.md)|
|[\[Purchasing\].\[PurchaseOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1266103551.md)|[FK_PurchaseOrderHeader_Vendor_VendorID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1266103551_FK_PurchaseOrderHeader_Vendor_VendorID.md)|[PK_Vendor_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1086626914_PK_Vendor_BusinessEntityID.md)|

 Total: 2 table(s)

---
### Referenced tables
|Table |Primary key or unique constraint |Foreign key |
|-|-|-|
|[\[Person\].\[BusinessEntity\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/949578421.md)|[PK_BusinessEntity_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/949578421_PK_BusinessEntity_BusinessEntityID.md)|[FK_Vendor_BusinessEntity_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1086626914_FK_Vendor_BusinessEntity_BusinessEntityID.md)|

 Total: 1 table(s)

---
### Triggers
|Name |Schema |Description |Instead of |For insert |For update |For delete |Table/view |
|-|-|-|-|-|-|-|-|
|[\[Purchasing\].\[dVendor\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/973246522.md)|[\[Purchasing\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/8.md)| 
|![](../../../../ImagesMetro/CHECK_OUT.png "")| | |![For Delete](../../../../ImagesMetro/AUDIT_trigger_delete.gif "")|[\[Purchasing\].\[Vendor\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1086626914.md)|

 Total: 1 triggers(s)

---
### Data models
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1086626914_dm.md) to view data model

---
### Objects that depend on \[Purchasing\].\[Vendor\]
|Object name|Object type|Dep level|
|-|-|-|
|[\[Purchasing\].\[ProductVendor\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1042102753.md)|Table|1|
|[\[Purchasing\].\[PurchaseOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1266103551.md)|Table|1|
|[\[Purchasing\].\[dVendor\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/973246522.md)|Trigger|1|
|[\[dbo\].\[ufnGetContactInformation\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Functions/1373247947.md)|Function|1|
|[\[Purchasing\].\[vVendorWithAddresses\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1325247776.md)|View|1|
|[\[Purchasing\].\[vVendorWithContacts\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1309247719.md)|View|1|

 Total 6 object(s)

---
### Objects that \[Purchasing\].\[Vendor\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Purchasing\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/8.md)|Schema|1|
|[\[Person\].\[BusinessEntity\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/949578421.md)|Table|1|
|[\[dbo\].\[AccountNumber\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/257.md)|Datatype|1|
|[\[dbo\].\[Flag\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/258.md)|Datatype|1|
|[\[dbo\].\[Name\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/260.md)|Datatype|1|

 Total 5 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[Person\].\[BusinessEntity\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/949578421.md)|BusinessEntityID|Table|

 Total 1 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1086626914_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Companies from whom Adventure Works Cycles purchases parts or other goods.|

---
###  Permissions
No permissions defined

---
### Table options
|Name |Value |
|-|-|
|Pintable|OFF|
|Table lock on bulk load|OFF|
|Insert row lock|OFF|
|Text in row|0|
|Large value types out of row|OFF|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING ON
GO
CREATE TABLE [Purchasing].[Vendor] (
        [BusinessEntityID]            [int] NOT NULL,
        [AccountNumber]               [dbo].[AccountNumber] NOT NULL,
        [Name]                        [dbo].[Name] NOT NULL,
        [CreditRating]                [tinyint] NOT NULL,
        [PreferredVendorStatus]       [dbo].[Flag] NOT NULL,
        [ActiveFlag]                  [dbo].[Flag] NOT NULL,
        [PurchasingWebServiceURL]     [nvarchar](1024) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        [ModifiedDate]                [datetime] NOT NULL,
        CONSTRAINT [PK_Vendor_BusinessEntityID]
        PRIMARY KEY
        CLUSTERED
        ([BusinessEntityID])
    ON [PRIMARY]
) ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Clustered index created by a primary key constraint.', 'SCHEMA', N'Purchasing', 'TABLE', N'Vendor', 'INDEX', N'PK_Vendor_BusinessEntityID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key (clustered) constraint', 'SCHEMA', N'Purchasing', 'TABLE', N'Vendor', 'CONSTRAINT', N'PK_Vendor_BusinessEntityID'
GO
ALTER TABLE [Purchasing].[Vendor]
    ADD
    CONSTRAINT [CK_Vendor_CreditRating]
    CHECK
    ([CreditRating]&gt;=(1) AND [CreditRating]&lt;=(5))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [CreditRating] BETWEEN (1) AND (5)', 'SCHEMA', N'Purchasing', 'TABLE', N'Vendor', 'CONSTRAINT', N'CK_Vendor_CreditRating'
GO
ALTER TABLE [Purchasing].[Vendor]
CHECK CONSTRAINT [CK_Vendor_CreditRating]
GO
ALTER TABLE [Purchasing].[Vendor]
    ADD
    CONSTRAINT [DF_Vendor_PreferredVendorStatus]
    DEFAULT ((1)) FOR [PreferredVendorStatus]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of 1 (TRUE)', 'SCHEMA', N'Purchasing', 'TABLE', N'Vendor', 'CONSTRAINT', N'DF_Vendor_PreferredVendorStatus'
GO
ALTER TABLE [Purchasing].[Vendor]
    ADD
    CONSTRAINT [DF_Vendor_ActiveFlag]
    DEFAULT ((1)) FOR [ActiveFlag]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of 1 (TRUE)', 'SCHEMA', N'Purchasing', 'TABLE', N'Vendor', 'CONSTRAINT', N'DF_Vendor_ActiveFlag'
GO
ALTER TABLE [Purchasing].[Vendor]
    ADD
    CONSTRAINT [DF_Vendor_ModifiedDate]
    DEFAULT (getdate()) FOR [ModifiedDate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of GETDATE()', 'SCHEMA', N'Purchasing', 'TABLE', N'Vendor', 'CONSTRAINT', N'DF_Vendor_ModifiedDate'
GO
ALTER TABLE [Purchasing].[Vendor]
    WITH CHECK
    ADD CONSTRAINT [FK_Vendor_BusinessEntity_BusinessEntityID]
    FOREIGN KEY ([BusinessEntityID]) REFERENCES [Person].[BusinessEntity] ([BusinessEntityID])
ALTER TABLE [Purchasing].[Vendor]
    CHECK CONSTRAINT [FK_Vendor_BusinessEntity_BusinessEntityID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing BusinessEntity.BusinessEntityID', 'SCHEMA', N'Purchasing', 'TABLE', N'Vendor', 'CONSTRAINT', N'FK_Vendor_BusinessEntity_BusinessEntityID'
GO
CREATE UNIQUE NONCLUSTERED INDEX [AK_Vendor_AccountNumber]
    ON [Purchasing].[Vendor] ([AccountNumber])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique nonclustered index.', 'SCHEMA', N'Purchasing', 'TABLE', N'Vendor', 'INDEX', N'AK_Vendor_AccountNumber'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Companies from whom Adventure Works Cycles purchases parts or other goods.', 'SCHEMA', N'Purchasing', 'TABLE', N'Vendor', NULL, NULL
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key for Vendor records.  Foreign key to BusinessEntity.BusinessEntityID', 'SCHEMA', N'Purchasing', 'TABLE', N'Vendor', 'COLUMN', N'BusinessEntityID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Vendor account (identification) number.', 'SCHEMA', N'Purchasing', 'TABLE', N'Vendor', 'COLUMN', N'AccountNumber'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Company name.', 'SCHEMA', N'Purchasing', 'TABLE', N'Vendor', 'COLUMN', N'Name'
GO
EXEC sp_addextendedproperty N'MS_Description', N'1 = Superior, 2 = Excellent, 3 = Above average, 4 = Average, 5 = Below average', 'SCHEMA', N'Purchasing', 'TABLE', N'Vendor', 'COLUMN', N'CreditRating'
GO
EXEC sp_addextendedproperty N'MS_Description', N'0 = Do not use if another vendor is available. 1 = Preferred over other vendors supplying the same product.', 'SCHEMA', N'Purchasing', 'TABLE', N'Vendor', 'COLUMN', N'PreferredVendorStatus'
GO
EXEC sp_addextendedproperty N'MS_Description', N'0 = Vendor no longer used. 1 = Vendor is actively used.', 'SCHEMA', N'Purchasing', 'TABLE', N'Vendor', 'COLUMN', N'ActiveFlag'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Vendor URL.', 'SCHEMA', N'Purchasing', 'TABLE', N'Vendor', 'COLUMN', N'PurchasingWebServiceURL'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date and time the record was last updated.', 'SCHEMA', N'Purchasing', 'TABLE', N'Vendor', 'COLUMN', N'ModifiedDate'
GO
  
~~~

---
### See also
[List of tables](../tables.md)

