## ![](../../../../Images32x32Metro/OBJECT_TABLE.png "") Table:\[AdventureWorks2016CTP3\].\[Person\].\[CountryRegion\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > **Person.CountryRegion**

---
###  Description  
 Lookup table containing the ISO standard codes for countries and regions. 



---
### Table properties
|Name |Value |
|-|-|
| Schema |[\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/6.md)|
| Owner |[\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md)|
| Table is replicated |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Creation date |10/23/2015|
| ID |1157579162|
| Located on |PRIMARY|
| Data size KB |16 KB|
| Index size KB |48 KB|
| Rows |238 |
| ChangeTrackingEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| FileStreamFileGroup | |
| FileStreamPartitionScheme | |
| LockEscalation |TABLE|
| TrackColumnsUpdatedEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Table is filetable |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Filetable directory | |
| Filetable collate | |
| Filetable primary key |\[PK_CountryRegion_CountryRegionCode\]|
| Filetable streamid unique | |
| Filetable fullpath unique | |
| Filetable is enabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is memory optimized |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Durability |SCHEMA_AND_DATA|

---
### Creation options
|Name |Value |
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|
|ANSI_PADDING|ON|

---
### Columns
| |Name |Description |IsComputed|Data type |Max length |Nullable |Default|IsGUID |SPARSE|Computed value|
|-|-|-|-|-|-|-|-|-|-|-|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|CountryRegionCode|ISO standard code for countries and regions.| |nvarchar|3|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| |Name|Country or region name.| |[\[dbo\].\[Name\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/260.md)|50|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| |ModifiedDate|Date and time the record was last updated.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|(getdate())|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|

 Total: 3 column(s)

---
### Text column statistics
|Name |Data type |Avg. length |Min. length |Max. length |Usage rating |
|-|-|-|-|-|-|
|CountryRegionCode|nvarchar(3)  |2|2|2|0.33333333333333|
|Name|nvarchar(50) |10|4|44|0.44000000000000|

 Total: 2 text column(s)

---
### Indexes
|Index |Key columns |Description |Primary |Unique |Size KB |Fill factor |
|-|-|-|-|-|-|-|
|[\[PK_CountryRegion_CountryRegionCode\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1157579162_PK_CountryRegion_CountryRegionCode.md)|CountryRegionCode|Primary key (clustered) constraint|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|64|0|
|[\[AK_CountryRegion_Name\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1157579162_AK_CountryRegion_Name.md)|Name|Unique nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|32|0|

 Total: 2 Index/indexes

---
### Columnstore indexes
 No columnstore indexes exist

---
### Fulltext index
 No fulltext index exist

---
### Statistics
 No statistics exist

---
### Check constraints
 No check constraints exist

---
### Identity column
 No identity column exists

---
### Referencing tables
|Table |Foreign key |Primary key or unique constraint |
|-|-|-|
|[\[Sales\].\[SalesTerritory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/94623380.md)|[FK_SalesTerritory_CountryRegion_CountryRegionCode](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_94623380_FK_SalesTerritory_CountryRegion_CountryRegionCode.md)|[PK_CountryRegion_CountryRegionCode](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1157579162_PK_CountryRegion_CountryRegionCode.md)|
|[\[Person\].\[StateProvince\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/782625831.md)|[FK_StateProvince_CountryRegion_CountryRegionCode](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_782625831_FK_StateProvince_CountryRegion_CountryRegionCode.md)|[PK_CountryRegion_CountryRegionCode](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1157579162_PK_CountryRegion_CountryRegionCode.md)|
|[\[Sales\].\[CountryRegionCurrency\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1125579048.md)|[FK_CountryRegionCurrency_CountryRegion_CountryRegionCode](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1125579048_FK_CountryRegionCurrency_CountryRegion_CountryRegionCode.md)|[PK_CountryRegion_CountryRegionCode](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1157579162_PK_CountryRegion_CountryRegionCode.md)|

 Total: 3 table(s)

---
### Referenced tables
 No referenced tables exist

---
### Triggers
 No triggers exist

---
### Data models
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1157579162_dm.md) to view data model

---
### Objects that depend on \[Person\].\[CountryRegion\]
|Object name|Object type|Dep level|
|-|-|-|
|[\[Sales\].\[CountryRegionCurrency\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1125579048.md)|Table|1|
|[\[Sales\].\[SalesTerritory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/94623380.md)|Table|1|
|[\[Person\].\[StateProvince\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/782625831.md)|Table|1|
|[\[HumanResources\].\[vEmployee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1037246750.md)|View|1|
|[\[Sales\].\[vIndividualCustomer\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1085246921.md)|View|1|
|[\[Sales\].\[vSalesPerson\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1213247377.md)|View|1|
|[\[Person\].\[vStateProvinceCountryRegion\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1245247491.md)|View|1|
|[\[Sales\].\[vStoreWithAddresses\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1293247662.md)|View|1|
|[\[Purchasing\].\[vVendorWithAddresses\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1325247776.md)|View|1|

 Total 9 object(s)

---
### Objects that \[Person\].\[CountryRegion\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/6.md)|Schema|1|
|[\[dbo\].\[Name\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/260.md)|Datatype|1|

 Total 2 object(s)

---
### Column level dependencies
 No dependencies exist

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1157579162_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Lookup table containing the ISO standard codes for countries and regions.|

---
###  Permissions
No permissions defined

---
### Table options
|Name |Value |
|-|-|
|Pintable|OFF|
|Table lock on bulk load|OFF|
|Insert row lock|OFF|
|Text in row|0|
|Large value types out of row|OFF|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING ON
GO
CREATE TABLE [Person].[CountryRegion] (
        [CountryRegionCode]     [nvarchar](3) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [Name]                  [dbo].[Name] NOT NULL,
        [ModifiedDate]          [datetime] NOT NULL,
        CONSTRAINT [PK_CountryRegion_CountryRegionCode]
        PRIMARY KEY
        CLUSTERED
        ([CountryRegionCode])
    ON [PRIMARY]
) ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Clustered index created by a primary key constraint.', 'SCHEMA', N'Person', 'TABLE', N'CountryRegion', 'INDEX', N'PK_CountryRegion_CountryRegionCode'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key (clustered) constraint', 'SCHEMA', N'Person', 'TABLE', N'CountryRegion', 'CONSTRAINT', N'PK_CountryRegion_CountryRegionCode'
GO
ALTER TABLE [Person].[CountryRegion]
    ADD
    CONSTRAINT [DF_CountryRegion_ModifiedDate]
    DEFAULT (getdate()) FOR [ModifiedDate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of GETDATE()', 'SCHEMA', N'Person', 'TABLE', N'CountryRegion', 'CONSTRAINT', N'DF_CountryRegion_ModifiedDate'
GO
CREATE UNIQUE NONCLUSTERED INDEX [AK_CountryRegion_Name]
    ON [Person].[CountryRegion] ([Name])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique nonclustered index.', 'SCHEMA', N'Person', 'TABLE', N'CountryRegion', 'INDEX', N'AK_CountryRegion_Name'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Lookup table containing the ISO standard codes for countries and regions.', 'SCHEMA', N'Person', 'TABLE', N'CountryRegion', NULL, NULL
GO
EXEC sp_addextendedproperty N'MS_Description', N'ISO standard code for countries and regions.', 'SCHEMA', N'Person', 'TABLE', N'CountryRegion', 'COLUMN', N'CountryRegionCode'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Country or region name.', 'SCHEMA', N'Person', 'TABLE', N'CountryRegion', 'COLUMN', N'Name'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date and time the record was last updated.', 'SCHEMA', N'Person', 'TABLE', N'CountryRegion', 'COLUMN', N'ModifiedDate'
GO
  
~~~

---
### See also
[List of tables](../tables.md)

