## ![](../../../../Images32x32Metro/OBJECT_TABLE.png "") Table:\[AdventureWorks2016CTP3\].\[Production\].\[WorkOrder\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > **Production.WorkOrder**

---
###  Description  
 Manufacturing work orders. 



---
### Table properties
|Name |Value |
|-|-|
| Schema |[\[Production\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/7.md)|
| Owner |[\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md)|
| Table is replicated |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Creation date |10/23/2015|
| ID |1166627199|
| Located on |PRIMARY|
| Data size KB |4232 KB|
| Index size KB |2408 KB|
| Rows |72591   |
| ChangeTrackingEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| FileStreamFileGroup | |
| FileStreamPartitionScheme | |
| LockEscalation |TABLE|
| TrackColumnsUpdatedEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Table is filetable |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Filetable directory | |
| Filetable collate | |
| Filetable primary key |\[PK_WorkOrder_WorkOrderID\]|
| Filetable streamid unique | |
| Filetable fullpath unique | |
| Filetable is enabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is memory optimized |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Durability |SCHEMA_AND_DATA|

---
### Creation options
|Name |Value |
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|
|ANSI_PADDING|ON|

---
### Columns
| | | |Name |Description |IsComputed|Data type |Max length |Nullable |Default|IsGUID |SPARSE|Computed value|
|-|-|-|-|-|-|-|-|-|-|-|-|-|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|![Identity](../../../../ImagesMetro/FILTER_Identity.gif "")| |WorkOrderID|Primary key for WorkOrder records.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1166627199_FK_WorkOrder_Product_ProductID.md)|ProductID|Product identification number. Foreign key to Product.ProductID.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |OrderQty|Product quantity to build.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |StockedQty|Quantity built and put in inventory.|True|int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|(isnull(\[OrderQty\]-\[ScrappedQty\],(0)))|
| | | |ScrappedQty|Quantity that failed inspection.| |smallint|2|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |StartDate|Work order start date.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |EndDate|Work order end date.| |datetime|8|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |DueDate|Work order due date.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1166627199_FK_WorkOrder_ScrapReason_ScrapReasonID.md)|ScrapReasonID|Reason for inspection failure.| |smallint|2|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |ModifiedDate|Date and time the record was last updated.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|(getdate())|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|

 Total: 10 column(s)

---
### Indexes
|Index |Key columns |Description |Primary |Unique |Size KB |Fill factor |
|-|-|-|-|-|-|-|
|[\[PK_WorkOrder_WorkOrderID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1166627199_PK_WorkOrder_WorkOrderID.md)|WorkOrderID|Primary key (clustered) constraint|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|6640|0|
|[\[IX_WorkOrder_ScrapReasonID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1166627199_IX_WorkOrder_ScrapReasonID.md)|ScrapReasonID|Nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|880|0|
|[\[IX_WorkOrder_ProductID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1166627199_IX_WorkOrder_ProductID.md)|ProductID|Nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|1320|0|

 Total: 3 Index/indexes

---
### Columnstore indexes
 No columnstore indexes exist

---
### Fulltext index
 No fulltext index exist

---
### Statistics
 No statistics exist

---
### Check constraints
|Name |Expression |
|-|-|
|CK_WorkOrder_OrderQty|(\[OrderQty\]&gt;(0))|
|CK_WorkOrder_ScrappedQty|(\[ScrappedQty\]&gt;=(0))|
|CK_WorkOrder_EndDate|(\[EndDate\]&gt;=\[StartDate\] OR \[EndDate\] IS NULL)|

---
### Identity column
| |Name |Seed |Increment |Not for replication |
|-|-|-|-|-|
|![](../../../../ImagesMetro/FILTER_Identity.gif "")| WorkOrderID | 1 | 1 |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Referencing tables
|Table |Foreign key |Primary key or unique constraint |
|-|-|-|
|[\[Production\].\[WorkOrderRouting\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1246627484.md)|[FK_WorkOrderRouting_WorkOrder_WorkOrderID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1246627484_FK_WorkOrderRouting_WorkOrder_WorkOrderID.md)|[PK_WorkOrder_WorkOrderID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1166627199_PK_WorkOrder_WorkOrderID.md)|

 Total: 1 table(s)

---
### Referenced tables
|Table |Primary key or unique constraint |Foreign key |
|-|-|-|
|[\[Production\].\[Product\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/146099561.md)|[PK_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/146099561_PK_Product_ProductID.md)|[FK_WorkOrder_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1166627199_FK_WorkOrder_Product_ProductID.md)|
|[\[Production\].\[ScrapReason\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/334624235.md)|[PK_ScrapReason_ScrapReasonID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/334624235_PK_ScrapReason_ScrapReasonID.md)|[FK_WorkOrder_ScrapReason_ScrapReasonID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1166627199_FK_WorkOrder_ScrapReason_ScrapReasonID.md)|

 Total: 2 table(s)

---
### Triggers
|Name |Schema |Description |Instead of |For insert |For update |For delete |Table/view |
|-|-|-|-|-|-|-|-|
|[\[Production\].\[iWorkOrder\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/989246579.md)|[\[Production\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/7.md)| 
|![](../../../../ImagesMetro/RED_CROSS.gif "")|![For Insert](../../../../ImagesMetro/AUDIT_trigger_insert.gif "")| | |[\[Production\].\[WorkOrder\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1166627199.md)|
|[\[Production\].\[uWorkOrder\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/1005246636.md)|[\[Production\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/7.md)| 
|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![For Update](../../../../ImagesMetro/AUDIT_trigger_update.gif "")| |[\[Production\].\[WorkOrder\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1166627199.md)|

 Total: 2 triggers(s)

---
### Data models
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1166627199_dm.md) to view data model

---
### Objects that depend on \[Production\].\[WorkOrder\]
|Object name|Object type|Dep level|
|-|-|-|
|[\[Production\].\[WorkOrderRouting\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1246627484.md)|Table|1|
|[\[Production\].\[iWorkOrder\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/989246579.md)|Trigger|1|
|[\[Production\].\[uWorkOrder\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/1005246636.md)|Trigger|1|

 Total 3 object(s)

---
### Objects that \[Production\].\[WorkOrder\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Production\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/7.md)|Schema|1|
|[\[Production\].\[Product\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/146099561.md)|Table|1|
|[\[Production\].\[ScrapReason\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/334624235.md)|Table|1|

 Total 3 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[Production\].\[Product\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/146099561.md)|ProductID|Table|
|[\[Production\].\[ScrapReason\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/334624235.md)|ScrapReasonID|Table|

 Total 2 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1166627199_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Manufacturing work orders.|

---
###  Permissions
No permissions defined

---
### Table options
|Name |Value |
|-|-|
|Pintable|OFF|
|Table lock on bulk load|OFF|
|Insert row lock|OFF|
|Text in row|0|
|Large value types out of row|OFF|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING ON
GO
CREATE TABLE [Production].[WorkOrder] (
        [WorkOrderID]       [int] IDENTITY(1, 1) NOT NULL,
        [ProductID]         [int] NOT NULL,
        [OrderQty]          [int] NOT NULL,
        [StockedQty]        AS (isnull([OrderQty]-[ScrappedQty],(0))),
        [ScrappedQty]       [smallint] NOT NULL,
        [StartDate]         [datetime] NOT NULL,
        [EndDate]           [datetime] NULL,
        [DueDate]           [datetime] NOT NULL,
        [ScrapReasonID]     [smallint] NULL,
        [ModifiedDate]      [datetime] NOT NULL,
        CONSTRAINT [PK_WorkOrder_WorkOrderID]
        PRIMARY KEY
        CLUSTERED
        ([WorkOrderID])
    ON [PRIMARY]
) ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Clustered index created by a primary key constraint.', 'SCHEMA', N'Production', 'TABLE', N'WorkOrder', 'INDEX', N'PK_WorkOrder_WorkOrderID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key (clustered) constraint', 'SCHEMA', N'Production', 'TABLE', N'WorkOrder', 'CONSTRAINT', N'PK_WorkOrder_WorkOrderID'
GO
ALTER TABLE [Production].[WorkOrder]
    ADD
    CONSTRAINT [CK_WorkOrder_OrderQty]
    CHECK
    ([OrderQty]&gt;(0))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [OrderQty] &gt; (0)', 'SCHEMA', N'Production', 'TABLE', N'WorkOrder', 'CONSTRAINT', N'CK_WorkOrder_OrderQty'
GO
ALTER TABLE [Production].[WorkOrder]
CHECK CONSTRAINT [CK_WorkOrder_OrderQty]
GO
ALTER TABLE [Production].[WorkOrder]
    ADD
    CONSTRAINT [CK_WorkOrder_ScrappedQty]
    CHECK
    ([ScrappedQty]&gt;=(0))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [ScrappedQty] &gt;= (0)', 'SCHEMA', N'Production', 'TABLE', N'WorkOrder', 'CONSTRAINT', N'CK_WorkOrder_ScrappedQty'
GO
ALTER TABLE [Production].[WorkOrder]
CHECK CONSTRAINT [CK_WorkOrder_ScrappedQty]
GO
ALTER TABLE [Production].[WorkOrder]
    ADD
    CONSTRAINT [CK_WorkOrder_EndDate]
    CHECK
    ([EndDate]&gt;=[StartDate] OR [EndDate] IS NULL)
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [EndDate] &gt;= [StartDate] OR [EndDate] IS NULL', 'SCHEMA', N'Production', 'TABLE', N'WorkOrder', 'CONSTRAINT', N'CK_WorkOrder_EndDate'
GO
ALTER TABLE [Production].[WorkOrder]
CHECK CONSTRAINT [CK_WorkOrder_EndDate]
GO
ALTER TABLE [Production].[WorkOrder]
    ADD
    CONSTRAINT [DF_WorkOrder_ModifiedDate]
    DEFAULT (getdate()) FOR [ModifiedDate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of GETDATE()', 'SCHEMA', N'Production', 'TABLE', N'WorkOrder', 'CONSTRAINT', N'DF_WorkOrder_ModifiedDate'
GO
ALTER TABLE [Production].[WorkOrder]
    WITH CHECK
    ADD CONSTRAINT [FK_WorkOrder_Product_ProductID]
    FOREIGN KEY ([ProductID]) REFERENCES [Production].[Product] ([ProductID])
ALTER TABLE [Production].[WorkOrder]
    CHECK CONSTRAINT [FK_WorkOrder_Product_ProductID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing Product.ProductID.', 'SCHEMA', N'Production', 'TABLE', N'WorkOrder', 'CONSTRAINT', N'FK_WorkOrder_Product_ProductID'
GO
ALTER TABLE [Production].[WorkOrder]
    WITH CHECK
    ADD CONSTRAINT [FK_WorkOrder_ScrapReason_ScrapReasonID]
    FOREIGN KEY ([ScrapReasonID]) REFERENCES [Production].[ScrapReason] ([ScrapReasonID])
ALTER TABLE [Production].[WorkOrder]
    CHECK CONSTRAINT [FK_WorkOrder_ScrapReason_ScrapReasonID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing ScrapReason.ScrapReasonID.', 'SCHEMA', N'Production', 'TABLE', N'WorkOrder', 'CONSTRAINT', N'FK_WorkOrder_ScrapReason_ScrapReasonID'
GO
CREATE NONCLUSTERED INDEX [IX_WorkOrder_ScrapReasonID]
    ON [Production].[WorkOrder] ([ScrapReasonID])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Nonclustered index.', 'SCHEMA', N'Production', 'TABLE', N'WorkOrder', 'INDEX', N'IX_WorkOrder_ScrapReasonID'
GO
CREATE NONCLUSTERED INDEX [IX_WorkOrder_ProductID]
    ON [Production].[WorkOrder] ([ProductID])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Nonclustered index.', 'SCHEMA', N'Production', 'TABLE', N'WorkOrder', 'INDEX', N'IX_WorkOrder_ProductID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Manufacturing work orders.', 'SCHEMA', N'Production', 'TABLE', N'WorkOrder', NULL, NULL
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key for WorkOrder records.', 'SCHEMA', N'Production', 'TABLE', N'WorkOrder', 'COLUMN', N'WorkOrderID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Product identification number. Foreign key to Product.ProductID.', 'SCHEMA', N'Production', 'TABLE', N'WorkOrder', 'COLUMN', N'ProductID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Product quantity to build.', 'SCHEMA', N'Production', 'TABLE', N'WorkOrder', 'COLUMN', N'OrderQty'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Quantity built and put in inventory.', 'SCHEMA', N'Production', 'TABLE', N'WorkOrder', 'COLUMN', N'StockedQty'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Quantity that failed inspection.', 'SCHEMA', N'Production', 'TABLE', N'WorkOrder', 'COLUMN', N'ScrappedQty'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Work order start date.', 'SCHEMA', N'Production', 'TABLE', N'WorkOrder', 'COLUMN', N'StartDate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Work order end date.', 'SCHEMA', N'Production', 'TABLE', N'WorkOrder', 'COLUMN', N'EndDate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Work order due date.', 'SCHEMA', N'Production', 'TABLE', N'WorkOrder', 'COLUMN', N'DueDate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Reason for inspection failure.', 'SCHEMA', N'Production', 'TABLE', N'WorkOrder', 'COLUMN', N'ScrapReasonID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date and time the record was last updated.', 'SCHEMA', N'Production', 'TABLE', N'WorkOrder', 'COLUMN', N'ModifiedDate'
GO
  
~~~

---
### See also
[List of tables](../tables.md)

