## ![](../../../../Images32x32Metro/OBJECT_TABLE.png "") Table:\[AdventureWorks2016CTP3\].\[Purchasing\].\[PurchaseOrderDetail\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > **Purchasing.PurchaseOrderDetail**

---
###  Description  
 Individual products associated with a specific purchase order. See PurchaseOrderHeader. 



---
### Table properties
|Name |Value |
|-|-|
| Schema |[\[Purchasing\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/8.md)|
| Owner |[\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md)|
| Table is replicated |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Creation date |10/23/2015|
| ID |1170103209|
| Located on |PRIMARY|
| Data size KB |512 KB|
| Index size KB |192 KB|
| Rows |8845|
| ChangeTrackingEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| FileStreamFileGroup | |
| FileStreamPartitionScheme | |
| LockEscalation |TABLE|
| TrackColumnsUpdatedEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Table is filetable |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Filetable directory | |
| Filetable collate | |
| Filetable primary key |\[PK_PurchaseOrderDetail_PurchaseOrderID_PurchaseOrderDetailID\]|
| Filetable streamid unique | |
| Filetable fullpath unique | |
| Filetable is enabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is memory optimized |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Durability |SCHEMA_AND_DATA|

---
### Creation options
|Name |Value |
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|
|ANSI_PADDING|ON|

---
### Columns
| | | |Name |Description |IsComputed|Data type |Max length |Nullable |Default|IsGUID |SPARSE|Computed value|
|-|-|-|-|-|-|-|-|-|-|-|-|-|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")| |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1170103209_FK_PurchaseOrderDetail_PurchaseOrderHeader_PurchaseOrderID.md)|PurchaseOrderID|Primary key. Foreign key to PurchaseOrderHeader.PurchaseOrderID.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|![Identity](../../../../ImagesMetro/FILTER_Identity.gif "")| |PurchaseOrderDetailID|Primary key. One line number per purchased product.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |DueDate|Date the product is expected to be received.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |OrderQty|Quantity ordered.| |smallint|2|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1170103209_FK_PurchaseOrderDetail_Product_ProductID.md)|ProductID|Product identification number. Foreign key to Product.ProductID.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |UnitPrice|Vendor's selling price of a single product.| |money|8|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |LineTotal|Per product subtotal. Computed as OrderQty * UnitPrice.|True|money|8|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|(isnull(\[OrderQty\]*\[UnitPrice\],(0.00)))|
| | | |ReceivedQty|Quantity actually received from the vendor.| |decimal|5|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |RejectedQty|Quantity rejected during inspection.| |decimal|5|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |StockedQty|Quantity accepted into inventory. Computed as ReceivedQty - RejectedQty.|True|decimal|5|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|(isnull(\[ReceivedQty\]-\[RejectedQty\],(0.00)))|
| | | |ModifiedDate|Date and time the record was last updated.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|(getdate())|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|

 Total: 11 column(s)

---
### Indexes
|Index |Key columns |Description |Primary |Unique |Size KB |Fill factor |
|-|-|-|-|-|-|-|
|[\[PK_PurchaseOrderDetail_PurchaseOrderID_PurchaseOrderDetailID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1170103209_PK_PurchaseOrderDetail_PurchaseOrderID_PurchaseOrderDetailID.md)|PurchaseOrderID, PurchaseOrderDetailID|Primary key (clustered) constraint|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|704|0|
|[\[IX_PurchaseOrderDetail_ProductID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1170103209_IX_PurchaseOrderDetail_ProductID.md)|ProductID|Nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|176|0|

 Total: 2 Index/indexes

---
### Columnstore indexes
 No columnstore indexes exist

---
### Fulltext index
 No fulltext index exist

---
### Statistics
 No statistics exist

---
### Check constraints
|Name |Expression |
|-|-|
|CK_PurchaseOrderDetail_OrderQty|(\[OrderQty\]&gt;(0))|
|CK_PurchaseOrderDetail_UnitPrice|(\[UnitPrice\]&gt;=(0.00))|
|CK_PurchaseOrderDetail_ReceivedQty|(\[ReceivedQty\]&gt;=(0.00))|
|CK_PurchaseOrderDetail_RejectedQty|(\[RejectedQty\]&gt;=(0.00))|

---
### Identity column
| |Name |Seed |Increment |Not for replication |
|-|-|-|-|-|
|![](../../../../ImagesMetro/FILTER_Identity.gif "")| PurchaseOrderDetailID | 1 | 1 |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Referencing tables
 No referencing tables exist

---
### Referenced tables
|Table |Primary key or unique constraint |Foreign key |
|-|-|-|
|[\[Production\].\[Product\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/146099561.md)|[PK_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/146099561_PK_Product_ProductID.md)|[FK_PurchaseOrderDetail_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1170103209_FK_PurchaseOrderDetail_Product_ProductID.md)|
|[\[Purchasing\].\[PurchaseOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1266103551.md)|[PK_PurchaseOrderHeader_PurchaseOrderID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1266103551_PK_PurchaseOrderHeader_PurchaseOrderID.md)|[FK_PurchaseOrderDetail_PurchaseOrderHeader_PurchaseOrderID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1170103209_FK_PurchaseOrderDetail_PurchaseOrderHeader_PurchaseOrderID.md)|

 Total: 2 table(s)

---
### Triggers
|Name |Schema |Description |Instead of |For insert |For update |For delete |Table/view |
|-|-|-|-|-|-|-|-|
|[\[Purchasing\].\[iPurchaseOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/893246237.md)|[\[Purchasing\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/8.md)| 
|![](../../../../ImagesMetro/RED_CROSS.gif "")|![For Insert](../../../../ImagesMetro/AUDIT_trigger_insert.gif "")| | |[\[Purchasing\].\[PurchaseOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1170103209.md)|
|[\[Purchasing\].\[uPurchaseOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/909246294.md)|[\[Purchasing\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/8.md)| 
|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![For Update](../../../../ImagesMetro/AUDIT_trigger_update.gif "")| |[\[Purchasing\].\[PurchaseOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1170103209.md)|

 Total: 2 triggers(s)

---
### Data models
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1170103209_dm.md) to view data model

---
### Objects that depend on \[Purchasing\].\[PurchaseOrderDetail\]
|Object name|Object type|Dep level|
|-|-|-|
|[\[Purchasing\].\[iPurchaseOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/893246237.md)|Trigger|1|
|[\[Purchasing\].\[uPurchaseOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/909246294.md)|Trigger|1|

 Total 2 object(s)

---
### Objects that \[Purchasing\].\[PurchaseOrderDetail\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Purchasing\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/8.md)|Schema|1|
|[\[Production\].\[Product\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/146099561.md)|Table|1|
|[\[Purchasing\].\[PurchaseOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1266103551.md)|Table|1|

 Total 3 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[Production\].\[Product\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/146099561.md)|ProductID|Table|
|[\[Purchasing\].\[PurchaseOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1266103551.md)|PurchaseOrderID|Table|

 Total 2 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1170103209_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Individual products associated with a specific purchase order. See PurchaseOrderHeader.|

---
###  Permissions
No permissions defined

---
### Table options
|Name |Value |
|-|-|
|Pintable|OFF|
|Table lock on bulk load|OFF|
|Insert row lock|OFF|
|Text in row|0|
|Large value types out of row|OFF|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING ON
GO
CREATE TABLE [Purchasing].[PurchaseOrderDetail] (
        [PurchaseOrderID]           [int] NOT NULL,
        [PurchaseOrderDetailID]     [int] IDENTITY(1, 1) NOT NULL,
        [DueDate]                   [datetime] NOT NULL,
        [OrderQty]                  [smallint] NOT NULL,
        [ProductID]                 [int] NOT NULL,
        [UnitPrice]                 [money] NOT NULL,
        [LineTotal]                 AS (isnull([OrderQty]*[UnitPrice],(0.00))),
        [ReceivedQty]               [decimal](8, 2) NOT NULL,
        [RejectedQty]               [decimal](8, 2) NOT NULL,
        [StockedQty]                AS (isnull([ReceivedQty]-[RejectedQty],(0.00))),
        [ModifiedDate]              [datetime] NOT NULL,
        CONSTRAINT [PK_PurchaseOrderDetail_PurchaseOrderID_PurchaseOrderDetailID]
        PRIMARY KEY
        CLUSTERED
        ([PurchaseOrderID], [PurchaseOrderDetailID])
    ON [PRIMARY]
) ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Clustered index created by a primary key constraint.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderDetail', 'INDEX', N'PK_PurchaseOrderDetail_PurchaseOrderID_PurchaseOrderDetailID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key (clustered) constraint', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderDetail', 'CONSTRAINT', N'PK_PurchaseOrderDetail_PurchaseOrderID_PurchaseOrderDetailID'
GO
ALTER TABLE [Purchasing].[PurchaseOrderDetail]
    ADD
    CONSTRAINT [CK_PurchaseOrderDetail_OrderQty]
    CHECK
    ([OrderQty]&gt;(0))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [OrderQty] &gt; (0)', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderDetail', 'CONSTRAINT', N'CK_PurchaseOrderDetail_OrderQty'
GO
ALTER TABLE [Purchasing].[PurchaseOrderDetail]
CHECK CONSTRAINT [CK_PurchaseOrderDetail_OrderQty]
GO
ALTER TABLE [Purchasing].[PurchaseOrderDetail]
    ADD
    CONSTRAINT [CK_PurchaseOrderDetail_UnitPrice]
    CHECK
    ([UnitPrice]&gt;=(0.00))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [UnitPrice] &gt;= (0.00)', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderDetail', 'CONSTRAINT', N'CK_PurchaseOrderDetail_UnitPrice'
GO
ALTER TABLE [Purchasing].[PurchaseOrderDetail]
CHECK CONSTRAINT [CK_PurchaseOrderDetail_UnitPrice]
GO
ALTER TABLE [Purchasing].[PurchaseOrderDetail]
    ADD
    CONSTRAINT [CK_PurchaseOrderDetail_ReceivedQty]
    CHECK
    ([ReceivedQty]&gt;=(0.00))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [ReceivedQty] &gt;= (0.00)', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderDetail', 'CONSTRAINT', N'CK_PurchaseOrderDetail_ReceivedQty'
GO
ALTER TABLE [Purchasing].[PurchaseOrderDetail]
CHECK CONSTRAINT [CK_PurchaseOrderDetail_ReceivedQty]
GO
ALTER TABLE [Purchasing].[PurchaseOrderDetail]
    ADD
    CONSTRAINT [CK_PurchaseOrderDetail_RejectedQty]
    CHECK
    ([RejectedQty]&gt;=(0.00))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [RejectedQty] &gt;= (0.00)', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderDetail', 'CONSTRAINT', N'CK_PurchaseOrderDetail_RejectedQty'
GO
ALTER TABLE [Purchasing].[PurchaseOrderDetail]
CHECK CONSTRAINT [CK_PurchaseOrderDetail_RejectedQty]
GO
ALTER TABLE [Purchasing].[PurchaseOrderDetail]
    ADD
    CONSTRAINT [DF_PurchaseOrderDetail_ModifiedDate]
    DEFAULT (getdate()) FOR [ModifiedDate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of GETDATE()', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderDetail', 'CONSTRAINT', N'DF_PurchaseOrderDetail_ModifiedDate'
GO
ALTER TABLE [Purchasing].[PurchaseOrderDetail]
    WITH CHECK
    ADD CONSTRAINT [FK_PurchaseOrderDetail_Product_ProductID]
    FOREIGN KEY ([ProductID]) REFERENCES [Production].[Product] ([ProductID])
ALTER TABLE [Purchasing].[PurchaseOrderDetail]
    CHECK CONSTRAINT [FK_PurchaseOrderDetail_Product_ProductID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing Product.ProductID.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderDetail', 'CONSTRAINT', N'FK_PurchaseOrderDetail_Product_ProductID'
GO
ALTER TABLE [Purchasing].[PurchaseOrderDetail]
    WITH CHECK
    ADD CONSTRAINT [FK_PurchaseOrderDetail_PurchaseOrderHeader_PurchaseOrderID]
    FOREIGN KEY ([PurchaseOrderID]) REFERENCES [Purchasing].[PurchaseOrderHeader] ([PurchaseOrderID])
ALTER TABLE [Purchasing].[PurchaseOrderDetail]
    CHECK CONSTRAINT [FK_PurchaseOrderDetail_PurchaseOrderHeader_PurchaseOrderID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing PurchaseOrderHeader.PurchaseOrderID.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderDetail', 'CONSTRAINT', N'FK_PurchaseOrderDetail_PurchaseOrderHeader_PurchaseOrderID'
GO
CREATE NONCLUSTERED INDEX [IX_PurchaseOrderDetail_ProductID]
    ON [Purchasing].[PurchaseOrderDetail] ([ProductID])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Nonclustered index.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderDetail', 'INDEX', N'IX_PurchaseOrderDetail_ProductID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Individual products associated with a specific purchase order. See PurchaseOrderHeader.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderDetail', NULL, NULL
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key. Foreign key to PurchaseOrderHeader.PurchaseOrderID.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderDetail', 'COLUMN', N'PurchaseOrderID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key. One line number per purchased product.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderDetail', 'COLUMN', N'PurchaseOrderDetailID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date the product is expected to be received.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderDetail', 'COLUMN', N'DueDate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Quantity ordered.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderDetail', 'COLUMN', N'OrderQty'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Product identification number. Foreign key to Product.ProductID.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderDetail', 'COLUMN', N'ProductID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Vendor''s selling price of a single product.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderDetail', 'COLUMN', N'UnitPrice'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Per product subtotal. Computed as OrderQty * UnitPrice.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderDetail', 'COLUMN', N'LineTotal'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Quantity actually received from the vendor.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderDetail', 'COLUMN', N'ReceivedQty'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Quantity rejected during inspection.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderDetail', 'COLUMN', N'RejectedQty'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Quantity accepted into inventory. Computed as ReceivedQty - RejectedQty.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderDetail', 'COLUMN', N'StockedQty'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date and time the record was last updated.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderDetail', 'COLUMN', N'ModifiedDate'
GO
  
~~~

---
### See also
[List of tables](../tables.md)

