## ![](../../../../Images32x32Metro/OBJECT_TABLE.png "") Table:\[AdventureWorks2016CTP3\].\[Sales\].\[CreditCard\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > **Sales.CreditCard**

---
###  Description  
 Customer credit card information. 



---
### Table properties
|Name |Value |
|-|-|
| Schema |[\[Sales\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md)|
| Owner |[\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md)|
| Table is replicated |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Creation date |10/23/2015|
| ID |1189579276|
| Located on |PRIMARY|
| Data size KB |1496 KB|
| Index size KB |832 KB|
| Rows |19118   |
| ChangeTrackingEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| FileStreamFileGroup | |
| FileStreamPartitionScheme | |
| LockEscalation |TABLE|
| TrackColumnsUpdatedEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Table is filetable |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Filetable directory | |
| Filetable collate | |
| Filetable primary key |\[PK_CreditCard_CreditCardID\]|
| Filetable streamid unique | |
| Filetable fullpath unique | |
| Filetable is enabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is memory optimized |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Durability |SCHEMA_AND_DATA|

---
### Creation options
|Name |Value |
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|
|ANSI_PADDING|ON|

---
### Columns
| | |Name |Description |IsComputed|Data type |Max length |Nullable |Default|IsGUID |SPARSE|Computed value|
|-|-|-|-|-|-|-|-|-|-|-|-|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|![Identity](../../../../ImagesMetro/FILTER_Identity.gif "")|CreditCardID|Primary key for CreditCard records.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |CardType|Credit card name.| |nvarchar|50|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |CardNumber|Credit card number.| |nvarchar|25|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |ExpMonth|Credit card expiration month.| |tinyint|1|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |ExpYear|Credit card expiration year.| |smallint|2|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |ModifiedDate|Date and time the record was last updated.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|(getdate())|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|

 Total: 6 column(s)

---
### Text column statistics
|Name |Data type |Avg. length |Min. length |Max. length |Usage rating |
|-|-|-|-|-|-|
|CardType|nvarchar(50) |10|5|13|0.13000000000000|
|CardNumber|nvarchar(25) |14|14|14|0.28000000000000|

 Total: 2 text column(s)

---
### Indexes
|Index |Key columns |Description |Primary |Unique |Size KB |Fill factor |
|-|-|-|-|-|-|-|
|[\[PK_CreditCard_CreditCardID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1189579276_PK_CreditCard_CreditCardID.md)|CreditCardID|Primary key (clustered) constraint|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|2328|0|
|[\[AK_CreditCard_CardNumber\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1189579276_AK_CreditCard_CardNumber.md)|CardNumber|Unique nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|816|0|

 Total: 2 Index/indexes

---
### Columnstore indexes
 No columnstore indexes exist

---
### Fulltext index
 No fulltext index exist

---
### Statistics
 No statistics exist

---
### Check constraints
 No check constraints exist

---
### Identity column
| |Name |Seed |Increment |Not for replication |
|-|-|-|-|-|
|![](../../../../ImagesMetro/FILTER_Identity.gif "")| CreditCardID | 1 | 1 |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Referencing tables
|Table |Foreign key |Primary key or unique constraint |
|-|-|-|
|[\[Sales\].\[PersonCreditCard\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/50099219.md)|[FK_PersonCreditCard_CreditCard_CreditCardID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_50099219_FK_PersonCreditCard_CreditCard_CreditCardID.md)|[PK_CreditCard_CreditCardID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1189579276_PK_CreditCard_CreditCardID.md)|
|[\[Sales\].\[SalesOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691.md)|[FK_SalesOrderHeader_CreditCard_CreditCardID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1586104691_FK_SalesOrderHeader_CreditCard_CreditCardID.md)|[PK_CreditCard_CreditCardID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1189579276_PK_CreditCard_CreditCardID.md)|

 Total: 2 table(s)

---
### Referenced tables
 No referenced tables exist

---
### Triggers
 No triggers exist

---
### Data models
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1189579276_dm.md) to view data model

---
### Objects that depend on \[Sales\].\[CreditCard\]
|Object name|Object type|Dep level|
|-|-|-|
|[\[Sales\].\[PersonCreditCard\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/50099219.md)|Table|1|
|[\[Sales\].\[SalesOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691.md)|Table|1|

 Total 2 object(s)

---
### Objects that \[Sales\].\[CreditCard\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Sales\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md)|Schema|1|

 Total 1 object(s)

---
### Column level dependencies
 No dependencies exist

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1189579276_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Customer credit card information.|

---
###  Permissions
No permissions defined

---
### Table options
|Name |Value |
|-|-|
|Pintable|OFF|
|Table lock on bulk load|OFF|
|Insert row lock|OFF|
|Text in row|0|
|Large value types out of row|OFF|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING ON
GO
CREATE TABLE [Sales].[CreditCard] (
        [CreditCardID]     [int] IDENTITY(1, 1) NOT NULL,
        [CardType]         [nvarchar](50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [CardNumber]       [nvarchar](25) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [ExpMonth]         [tinyint] NOT NULL,
        [ExpYear]          [smallint] NOT NULL,
        [ModifiedDate]     [datetime] NOT NULL,
        CONSTRAINT [PK_CreditCard_CreditCardID]
        PRIMARY KEY
        CLUSTERED
        ([CreditCardID])
    ON [PRIMARY]
) ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Clustered index created by a primary key constraint.', 'SCHEMA', N'Sales', 'TABLE', N'CreditCard', 'INDEX', N'PK_CreditCard_CreditCardID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key (clustered) constraint', 'SCHEMA', N'Sales', 'TABLE', N'CreditCard', 'CONSTRAINT', N'PK_CreditCard_CreditCardID'
GO
ALTER TABLE [Sales].[CreditCard]
    ADD
    CONSTRAINT [DF_CreditCard_ModifiedDate]
    DEFAULT (getdate()) FOR [ModifiedDate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of GETDATE()', 'SCHEMA', N'Sales', 'TABLE', N'CreditCard', 'CONSTRAINT', N'DF_CreditCard_ModifiedDate'
GO
CREATE UNIQUE NONCLUSTERED INDEX [AK_CreditCard_CardNumber]
    ON [Sales].[CreditCard] ([CardNumber])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique nonclustered index.', 'SCHEMA', N'Sales', 'TABLE', N'CreditCard', 'INDEX', N'AK_CreditCard_CardNumber'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Customer credit card information.', 'SCHEMA', N'Sales', 'TABLE', N'CreditCard', NULL, NULL
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key for CreditCard records.', 'SCHEMA', N'Sales', 'TABLE', N'CreditCard', 'COLUMN', N'CreditCardID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Credit card name.', 'SCHEMA', N'Sales', 'TABLE', N'CreditCard', 'COLUMN', N'CardType'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Credit card number.', 'SCHEMA', N'Sales', 'TABLE', N'CreditCard', 'COLUMN', N'CardNumber'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Credit card expiration month.', 'SCHEMA', N'Sales', 'TABLE', N'CreditCard', 'COLUMN', N'ExpMonth'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Credit card expiration year.', 'SCHEMA', N'Sales', 'TABLE', N'CreditCard', 'COLUMN', N'ExpYear'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date and time the record was last updated.', 'SCHEMA', N'Sales', 'TABLE', N'CreditCard', 'COLUMN', N'ModifiedDate'
GO
  
~~~

---
### See also
[List of tables](../tables.md)

