## ![](../../../../Images32x32Metro/OBJECT_TABLE.png "") Table:\[AdventureWorks2016CTP3\].\[Purchasing\].\[PurchaseOrderHeader\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > **Purchasing.PurchaseOrderHeader**

---
###  Description  
 General purchase order information. See PurchaseOrderDetail. 



---
### Table properties
|Name |Value |
|-|-|
| Schema |[\[Purchasing\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/8.md)|
| Owner |[\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md)|
| Table is replicated |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Creation date |10/23/2015|
| ID |1266103551|
| Located on |PRIMARY|
| Data size KB |336 KB|
| Index size KB |160 KB|
| Rows |4012|
| ChangeTrackingEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| FileStreamFileGroup | |
| FileStreamPartitionScheme | |
| LockEscalation |TABLE|
| TrackColumnsUpdatedEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Table is filetable |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Filetable directory | |
| Filetable collate | |
| Filetable primary key |\[PK_PurchaseOrderHeader_PurchaseOrderID\]|
| Filetable streamid unique | |
| Filetable fullpath unique | |
| Filetable is enabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is memory optimized |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Durability |SCHEMA_AND_DATA|

---
### Creation options
|Name |Value |
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|
|ANSI_PADDING|ON|

---
### Columns
| | | |Name |Description |IsComputed|Data type |Max length |Nullable |Default|IsGUID |SPARSE|Computed value|
|-|-|-|-|-|-|-|-|-|-|-|-|-|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|![Identity](../../../../ImagesMetro/FILTER_Identity.gif "")| |PurchaseOrderID|Primary key.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |RevisionNumber|Incremental number to track changes to the purchase order over time.| |tinyint|1|![](../../../../ImagesMetro/RED_CROSS.gif "")|((0))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |Status|Order current status. 1 = Pending; 2 = Approved; 3 = Rejected; 4 = Complete| |tinyint|1|![](../../../../ImagesMetro/RED_CROSS.gif "")|((1))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1266103551_FK_PurchaseOrderHeader_Employee_EmployeeID.md)|EmployeeID|Employee who created the purchase order. Foreign key to Employee.BusinessEntityID.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1266103551_FK_PurchaseOrderHeader_Vendor_VendorID.md)|VendorID|Vendor with whom the purchase order is placed. Foreign key to Vendor.BusinessEntityID.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1266103551_FK_PurchaseOrderHeader_ShipMethod_ShipMethodID.md)|ShipMethodID|Shipping method. Foreign key to ShipMethod.ShipMethodID.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |OrderDate|Purchase order creation date.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|(getdate())|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |ShipDate|Estimated shipment date from the vendor.| |datetime|8|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |SubTotal|Purchase order subtotal. Computed as SUM(PurchaseOrderDetail.LineTotal)for the appropriate PurchaseOrderID.| |money|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|((0.00))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |TaxAmt|Tax amount.| |money|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|((0.00))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |Freight|Shipping cost.| |money|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|((0.00))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |TotalDue|Total due to vendor. Computed as Subtotal + TaxAmt + Freight.|True|money|8|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|(isnull((\[SubTotal\]+\[TaxAmt\])+\[Freight\],(0)))|
| | | |ModifiedDate|Date and time the record was last updated.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|(getdate())|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|

 Total: 13 column(s)

---
### Indexes
|Index |Key columns |Description |Primary |Unique |Size KB |Fill factor |
|-|-|-|-|-|-|-|
|[\[PK_PurchaseOrderHeader_PurchaseOrderID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1266103551_PK_PurchaseOrderHeader_PurchaseOrderID.md)|PurchaseOrderID|Primary key (clustered) constraint|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|496|0|
|[\[IX_PurchaseOrderHeader_VendorID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1266103551_IX_PurchaseOrderHeader_VendorID.md)|VendorID|Nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|72|0|
|[\[IX_PurchaseOrderHeader_EmployeeID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1266103551_IX_PurchaseOrderHeader_EmployeeID.md)|EmployeeID|Nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|72|0|

 Total: 3 Index/indexes

---
### Columnstore indexes
 No columnstore indexes exist

---
### Fulltext index
 No fulltext index exist

---
### Statistics
 No statistics exist

---
### Check constraints
|Name |Expression |
|-|-|
|CK_PurchaseOrderHeader_Status|(\[Status\]&gt;=(1) AND \[Status\]&lt;=(4))|
|CK_PurchaseOrderHeader_ShipDate|(\[ShipDate\]&gt;=\[OrderDate\] OR \[ShipDate\] IS NULL)|
|CK_PurchaseOrderHeader_SubTotal|(\[SubTotal\]&gt;=(0.00))|
|CK_PurchaseOrderHeader_TaxAmt|(\[TaxAmt\]&gt;=(0.00))|
|CK_PurchaseOrderHeader_Freight|(\[Freight\]&gt;=(0.00))|

---
### Identity column
| |Name |Seed |Increment |Not for replication |
|-|-|-|-|-|
|![](../../../../ImagesMetro/FILTER_Identity.gif "")| PurchaseOrderID | 1 | 1 |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Referencing tables
|Table |Foreign key |Primary key or unique constraint |
|-|-|-|
|[\[Purchasing\].\[PurchaseOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1170103209.md)|[FK_PurchaseOrderDetail_PurchaseOrderHeader_PurchaseOrderID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1170103209_FK_PurchaseOrderDetail_PurchaseOrderHeader_PurchaseOrderID.md)|[PK_PurchaseOrderHeader_PurchaseOrderID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1266103551_PK_PurchaseOrderHeader_PurchaseOrderID.md)|

 Total: 1 table(s)

---
### Referenced tables
|Table |Primary key or unique constraint |Foreign key |
|-|-|-|
|[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|[PK_Employee_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1557580587_PK_Employee_BusinessEntityID.md)|[FK_PurchaseOrderHeader_Employee_EmployeeID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1266103551_FK_PurchaseOrderHeader_Employee_EmployeeID.md)|
|[\[Purchasing\].\[Vendor\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1086626914.md)|[PK_Vendor_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1086626914_PK_Vendor_BusinessEntityID.md)|[FK_PurchaseOrderHeader_Vendor_VendorID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1266103551_FK_PurchaseOrderHeader_Vendor_VendorID.md)|
|[\[Purchasing\].\[ShipMethod\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/398624463.md)|[PK_ShipMethod_ShipMethodID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/398624463_PK_ShipMethod_ShipMethodID.md)|[FK_PurchaseOrderHeader_ShipMethod_ShipMethodID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1266103551_FK_PurchaseOrderHeader_ShipMethod_ShipMethodID.md)|

 Total: 3 table(s)

---
### Triggers
|Name |Schema |Description |Instead of |For insert |For update |For delete |Table/view |
|-|-|-|-|-|-|-|-|
|[\[Purchasing\].\[uPurchaseOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/925246351.md)|[\[Purchasing\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/8.md)| 
|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![For Update](../../../../ImagesMetro/AUDIT_trigger_update.gif "")| |[\[Purchasing\].\[PurchaseOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1266103551.md)|

 Total: 1 triggers(s)

---
### Data models
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1266103551_dm.md) to view data model

---
### Objects that depend on \[Purchasing\].\[PurchaseOrderHeader\]
|Object name|Object type|Dep level|
|-|-|-|
|[\[Purchasing\].\[PurchaseOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1170103209.md)|Table|1|
|[\[Purchasing\].\[iPurchaseOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/893246237.md)|Trigger|1|
|[\[Purchasing\].\[uPurchaseOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/909246294.md)|Trigger|1|
|[\[Purchasing\].\[uPurchaseOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/925246351.md)|Trigger|1|

 Total 4 object(s)

---
### Objects that \[Purchasing\].\[PurchaseOrderHeader\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Purchasing\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/8.md)|Schema|1|
|[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|Table|1|
|[\[Purchasing\].\[ShipMethod\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/398624463.md)|Table|1|
|[\[Purchasing\].\[Vendor\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1086626914.md)|Table|1|

 Total 4 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|BusinessEntityID|Table|
|[\[Purchasing\].\[Vendor\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1086626914.md)|BusinessEntityID|Table|
|[\[Purchasing\].\[ShipMethod\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/398624463.md)|ShipMethodID|Table|

 Total 3 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1266103551_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|General purchase order information. See PurchaseOrderDetail.|

---
###  Permissions
No permissions defined

---
### Table options
|Name |Value |
|-|-|
|Pintable|OFF|
|Table lock on bulk load|OFF|
|Insert row lock|OFF|
|Text in row|0|
|Large value types out of row|OFF|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING ON
GO
CREATE TABLE [Purchasing].[PurchaseOrderHeader] (
        [PurchaseOrderID]     [int] IDENTITY(1, 1) NOT NULL,
        [RevisionNumber]      [tinyint] NOT NULL,
        [Status]              [tinyint] NOT NULL,
        [EmployeeID]          [int] NOT NULL,
        [VendorID]            [int] NOT NULL,
        [ShipMethodID]        [int] NOT NULL,
        [OrderDate]           [datetime] NOT NULL,
        [ShipDate]            [datetime] NULL,
        [SubTotal]            [money] NOT NULL,
        [TaxAmt]              [money] NOT NULL,
        [Freight]             [money] NOT NULL,
        [TotalDue]            AS (isnull(([SubTotal]+[TaxAmt])+[Freight],(0))) PERSISTED NOT NULL,
        [ModifiedDate]        [datetime] NOT NULL,
        CONSTRAINT [PK_PurchaseOrderHeader_PurchaseOrderID]
        PRIMARY KEY
        CLUSTERED
        ([PurchaseOrderID])
    ON [PRIMARY]
) ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Clustered index created by a primary key constraint.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'INDEX', N'PK_PurchaseOrderHeader_PurchaseOrderID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key (clustered) constraint', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'CONSTRAINT', N'PK_PurchaseOrderHeader_PurchaseOrderID'
GO
ALTER TABLE [Purchasing].[PurchaseOrderHeader]
    ADD
    CONSTRAINT [CK_PurchaseOrderHeader_Status]
    CHECK
    ([Status]&gt;=(1) AND [Status]&lt;=(4))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [Status] BETWEEN (1) AND (4)', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'CONSTRAINT', N'CK_PurchaseOrderHeader_Status'
GO
ALTER TABLE [Purchasing].[PurchaseOrderHeader]
CHECK CONSTRAINT [CK_PurchaseOrderHeader_Status]
GO
ALTER TABLE [Purchasing].[PurchaseOrderHeader]
    ADD
    CONSTRAINT [CK_PurchaseOrderHeader_ShipDate]
    CHECK
    ([ShipDate]&gt;=[OrderDate] OR [ShipDate] IS NULL)
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [ShipDate] &gt;= [OrderDate] OR [ShipDate] IS NULL', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'CONSTRAINT', N'CK_PurchaseOrderHeader_ShipDate'
GO
ALTER TABLE [Purchasing].[PurchaseOrderHeader]
CHECK CONSTRAINT [CK_PurchaseOrderHeader_ShipDate]
GO
ALTER TABLE [Purchasing].[PurchaseOrderHeader]
    ADD
    CONSTRAINT [CK_PurchaseOrderHeader_SubTotal]
    CHECK
    ([SubTotal]&gt;=(0.00))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [SubTotal] &gt;= (0.00)', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'CONSTRAINT', N'CK_PurchaseOrderHeader_SubTotal'
GO
ALTER TABLE [Purchasing].[PurchaseOrderHeader]
CHECK CONSTRAINT [CK_PurchaseOrderHeader_SubTotal]
GO
ALTER TABLE [Purchasing].[PurchaseOrderHeader]
    ADD
    CONSTRAINT [CK_PurchaseOrderHeader_TaxAmt]
    CHECK
    ([TaxAmt]&gt;=(0.00))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [TaxAmt] &gt;= (0.00)', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'CONSTRAINT', N'CK_PurchaseOrderHeader_TaxAmt'
GO
ALTER TABLE [Purchasing].[PurchaseOrderHeader]
CHECK CONSTRAINT [CK_PurchaseOrderHeader_TaxAmt]
GO
ALTER TABLE [Purchasing].[PurchaseOrderHeader]
    ADD
    CONSTRAINT [CK_PurchaseOrderHeader_Freight]
    CHECK
    ([Freight]&gt;=(0.00))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [Freight] &gt;= (0.00)', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'CONSTRAINT', N'CK_PurchaseOrderHeader_Freight'
GO
ALTER TABLE [Purchasing].[PurchaseOrderHeader]
CHECK CONSTRAINT [CK_PurchaseOrderHeader_Freight]
GO
ALTER TABLE [Purchasing].[PurchaseOrderHeader]
    ADD
    CONSTRAINT [DF_PurchaseOrderHeader_RevisionNumber]
    DEFAULT ((0)) FOR [RevisionNumber]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of 0', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'CONSTRAINT', N'DF_PurchaseOrderHeader_RevisionNumber'
GO
ALTER TABLE [Purchasing].[PurchaseOrderHeader]
    ADD
    CONSTRAINT [DF_PurchaseOrderHeader_Status]
    DEFAULT ((1)) FOR [Status]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of 1', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'CONSTRAINT', N'DF_PurchaseOrderHeader_Status'
GO
ALTER TABLE [Purchasing].[PurchaseOrderHeader]
    ADD
    CONSTRAINT [DF_PurchaseOrderHeader_OrderDate]
    DEFAULT (getdate()) FOR [OrderDate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of GETDATE()', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'CONSTRAINT', N'DF_PurchaseOrderHeader_OrderDate'
GO
ALTER TABLE [Purchasing].[PurchaseOrderHeader]
    ADD
    CONSTRAINT [DF_PurchaseOrderHeader_SubTotal]
    DEFAULT ((0.00)) FOR [SubTotal]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of 0.0', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'CONSTRAINT', N'DF_PurchaseOrderHeader_SubTotal'
GO
ALTER TABLE [Purchasing].[PurchaseOrderHeader]
    ADD
    CONSTRAINT [DF_PurchaseOrderHeader_TaxAmt]
    DEFAULT ((0.00)) FOR [TaxAmt]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of 0.0', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'CONSTRAINT', N'DF_PurchaseOrderHeader_TaxAmt'
GO
ALTER TABLE [Purchasing].[PurchaseOrderHeader]
    ADD
    CONSTRAINT [DF_PurchaseOrderHeader_Freight]
    DEFAULT ((0.00)) FOR [Freight]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of 0.0', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'CONSTRAINT', N'DF_PurchaseOrderHeader_Freight'
GO
ALTER TABLE [Purchasing].[PurchaseOrderHeader]
    ADD
    CONSTRAINT [DF_PurchaseOrderHeader_ModifiedDate]
    DEFAULT (getdate()) FOR [ModifiedDate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of GETDATE()', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'CONSTRAINT', N'DF_PurchaseOrderHeader_ModifiedDate'
GO
ALTER TABLE [Purchasing].[PurchaseOrderHeader]
    WITH CHECK
    ADD CONSTRAINT [FK_PurchaseOrderHeader_Employee_EmployeeID]
    FOREIGN KEY ([EmployeeID]) REFERENCES [HumanResources].[Employee] ([BusinessEntityID])
ALTER TABLE [Purchasing].[PurchaseOrderHeader]
    CHECK CONSTRAINT [FK_PurchaseOrderHeader_Employee_EmployeeID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing Employee.EmployeeID.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'CONSTRAINT', N'FK_PurchaseOrderHeader_Employee_EmployeeID'
GO
ALTER TABLE [Purchasing].[PurchaseOrderHeader]
    WITH CHECK
    ADD CONSTRAINT [FK_PurchaseOrderHeader_Vendor_VendorID]
    FOREIGN KEY ([VendorID]) REFERENCES [Purchasing].[Vendor] ([BusinessEntityID])
ALTER TABLE [Purchasing].[PurchaseOrderHeader]
    CHECK CONSTRAINT [FK_PurchaseOrderHeader_Vendor_VendorID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing Vendor.VendorID.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'CONSTRAINT', N'FK_PurchaseOrderHeader_Vendor_VendorID'
GO
ALTER TABLE [Purchasing].[PurchaseOrderHeader]
    WITH CHECK
    ADD CONSTRAINT [FK_PurchaseOrderHeader_ShipMethod_ShipMethodID]
    FOREIGN KEY ([ShipMethodID]) REFERENCES [Purchasing].[ShipMethod] ([ShipMethodID])
ALTER TABLE [Purchasing].[PurchaseOrderHeader]
    CHECK CONSTRAINT [FK_PurchaseOrderHeader_ShipMethod_ShipMethodID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing ShipMethod.ShipMethodID.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'CONSTRAINT', N'FK_PurchaseOrderHeader_ShipMethod_ShipMethodID'
GO
CREATE NONCLUSTERED INDEX [IX_PurchaseOrderHeader_VendorID]
    ON [Purchasing].[PurchaseOrderHeader] ([VendorID])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Nonclustered index.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'INDEX', N'IX_PurchaseOrderHeader_VendorID'
GO
CREATE NONCLUSTERED INDEX [IX_PurchaseOrderHeader_EmployeeID]
    ON [Purchasing].[PurchaseOrderHeader] ([EmployeeID])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Nonclustered index.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'INDEX', N'IX_PurchaseOrderHeader_EmployeeID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'General purchase order information. See PurchaseOrderDetail.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', NULL, NULL
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'COLUMN', N'PurchaseOrderID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Incremental number to track changes to the purchase order over time.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'COLUMN', N'RevisionNumber'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Order current status. 1 = Pending; 2 = Approved; 3 = Rejected; 4 = Complete', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'COLUMN', N'Status'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Employee who created the purchase order. Foreign key to Employee.BusinessEntityID.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'COLUMN', N'EmployeeID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Vendor with whom the purchase order is placed. Foreign key to Vendor.BusinessEntityID.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'COLUMN', N'VendorID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Shipping method. Foreign key to ShipMethod.ShipMethodID.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'COLUMN', N'ShipMethodID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Purchase order creation date.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'COLUMN', N'OrderDate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Estimated shipment date from the vendor.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'COLUMN', N'ShipDate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Purchase order subtotal. Computed as SUM(PurchaseOrderDetail.LineTotal)for the appropriate PurchaseOrderID.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'COLUMN', N'SubTotal'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Tax amount.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'COLUMN', N'TaxAmt'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Shipping cost.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'COLUMN', N'Freight'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Total due to vendor. Computed as Subtotal + TaxAmt + Freight.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'COLUMN', N'TotalDue'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date and time the record was last updated.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderHeader', 'COLUMN', N'ModifiedDate'
GO
  
~~~

---
### See also
[List of tables](../tables.md)

