## ![](../../../../Images32x32Metro/OBJECT_TABLE.png "") Table:\[AdventureWorks2016CTP3\].\[Production\].\[Product\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > **Production.Product**

---
###  Description  
 Products sold or used in the manfacturing of sold products. 



---
### Table properties
|Name |Value |
|-|-|
| Schema |[\[Production\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/7.md)|
| Owner |[\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md)|
| Table is replicated |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Creation date |10/23/2015|
| ID |146099561|
| Located on |PRIMARY|
| Data size KB |104 KB|
| Index size KB |128 KB|
| Rows |504 |
| ChangeTrackingEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| FileStreamFileGroup | |
| FileStreamPartitionScheme | |
| LockEscalation |TABLE|
| TrackColumnsUpdatedEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Table is filetable |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Filetable directory | |
| Filetable collate | |
| Filetable primary key |\[PK_Product_ProductID\]|
| Filetable streamid unique | |
| Filetable fullpath unique | |
| Filetable is enabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is memory optimized |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Durability |SCHEMA_AND_DATA|

---
### Creation options
|Name |Value |
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|
|ANSI_PADDING|ON|

---
### Columns
| | | |Name |Description |IsComputed|Data type |Max length |Nullable |Default|IsGUID |SPARSE|Computed value|
|-|-|-|-|-|-|-|-|-|-|-|-|-|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|![Identity](../../../../ImagesMetro/FILTER_Identity.gif "")| |ProductID|Primary key for Product records.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |Name|Name of the product.| |[\[dbo\].\[Name\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/260.md)|50|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |ProductNumber|Unique product identification number.| |nvarchar|25|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |MakeFlag|0 = Product is purchased, 1 = Product is manufactured in-house.| |[\[dbo\].\[Flag\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/258.md)|1|![](../../../../ImagesMetro/RED_CROSS.gif "")|((1))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |FinishedGoodsFlag|0 = Product is not a salable item. 1 = Product is salable.| |[\[dbo\].\[Flag\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/258.md)|1|![](../../../../ImagesMetro/RED_CROSS.gif "")|((1))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |Color|Product color.| |nvarchar|15|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |SafetyStockLevel|Minimum inventory quantity. | |smallint|2|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |ReorderPoint|Inventory level that triggers a purchase order or work order. | |smallint|2|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |StandardCost|Standard cost of the product.| |money|8|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |ListPrice|Selling price.| |money|8|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |Size|Product size.| |nvarchar|5|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_146099561_FK_Product_UnitMeasure_SizeUnitMeasureCode.md)|SizeUnitMeasureCode|Unit of measure for Size column.| |nchar|3|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_146099561_FK_Product_UnitMeasure_WeightUnitMeasureCode.md)|WeightUnitMeasureCode|Unit of measure for Weight column.| |nchar|3|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |Weight|Product weight.| |decimal|5|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |DaysToManufacture|Number of days required to manufacture the product.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |ProductLine|R = Road, M = Mountain, T = Touring, S = Standard| |nchar|2|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |Class|H = High, M = Medium, L = Low| |nchar|2|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |Style|W = Womens, M = Mens, U = Universal| |nchar|2|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_146099561_FK_Product_ProductSubcategory_ProductSubcategoryID.md)|ProductSubcategoryID|Product is a member of this product subcategory. Foreign key to ProductSubCategory.ProductSubCategoryID. | |int|4|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_146099561_FK_Product_ProductModel_ProductModelID.md)|ProductModelID|Product is a member of this product model. Foreign key to ProductModel.ProductModelID.| |int|4|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |SellStartDate|Date the product was available for sale.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |SellEndDate|Date the product was no longer available for sale.| |datetime|8|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |DiscontinuedDate|Date the product was discontinued.| |datetime|8|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |rowguid|ROWGUIDCOL number uniquely identifying the record. Used to support a merge replication sample.| |uniqueidentifier|16|![](../../../../ImagesMetro/RED_CROSS.gif "")|(newid())|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |ModifiedDate|Date and time the record was last updated.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|(getdate())|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|

 Total: 25 column(s)

---
### Text column statistics
|Name |Data type |Avg. length |Min. length |Max. length |Usage rating |
|-|-|-|-|-|-|
|Name|nvarchar(50) |18|4|32|0.32000000000000|
|ProductNumber|nvarchar(25) |8|7|10|0.20000000000000|
|Color|nvarchar(15) |2|3|12|0.40000000000000|
|Size|nvarchar(5)  |0|1|2|0.20000000000000|
|SizeUnitMeasureCode|nchar(3) |0|2|2|0.33333333333333|
|WeightUnitMeasureCode|nchar(3) |0|1|2|0.33333333333333|
|ProductLine|nchar(2) |0|1|1|0.25000000000000|
|Class|nchar(2) |0|1|1|0.25000000000000|
|Style|nchar(2) |0|1|1|0.25000000000000|

 Total: 9 text column(s)

---
### Indexes
|Index |Key columns |Description |Primary |Unique |Size KB |Fill factor |
|-|-|-|-|-|-|-|
|[\[PK_Product_ProductID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/146099561_PK_Product_ProductID.md)|ProductID|Primary key (clustered) constraint|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|232|0|
|[\[AK_Product_ProductNumber\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/146099561_AK_Product_ProductNumber.md)|ProductNumber|Unique nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|32|0|
|[\[AK_Product_Name\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/146099561_AK_Product_Name.md)|Name|Unique nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|48|0|
|[\[AK_Product_rowguid\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/146099561_AK_Product_rowguid.md)|rowguid|Unique nonclustered index. Used to support replication samples.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|32|0|

 Total: 4 Index/indexes

---
### Columnstore indexes
 No columnstore indexes exist

---
### Fulltext index
 No fulltext index exist

---
### Statistics
 No statistics exist

---
### Check constraints
|Name |Expression |
|-|-|
|CK_Product_SafetyStockLevel|(\[SafetyStockLevel\]&gt;(0))|
|CK_Product_ReorderPoint|(\[ReorderPoint\]&gt;(0))|
|CK_Product_StandardCost|(\[StandardCost\]&gt;=(0.00))|
|CK_Product_ListPrice|(\[ListPrice\]&gt;=(0.00))|
|CK_Product_Weight|(\[Weight\]&gt;(0.00))|
|CK_Product_DaysToManufacture|(\[DaysToManufacture\]&gt;=(0))|
|CK_Product_ProductLine|(upper(\[ProductLine\])=&#39;R&#39; OR upper(\[ProductLine\])=&#39;M&#39; OR upper(\[ProductLine\])=&#39;T&#39; OR upper(\[ProductLine\])=&#39;S&#39; OR \[ProductLine\] IS NULL)|
|CK_Product_Class|(upper(\[Class\])=&#39;H&#39; OR upper(\[Class\])=&#39;M&#39; OR upper(\[Class\])=&#39;L&#39; OR \[Class\] IS NULL)|
|CK_Product_Style|(upper(\[Style\])=&#39;U&#39; OR upper(\[Style\])=&#39;M&#39; OR upper(\[Style\])=&#39;W&#39; OR \[Style\] IS NULL)|
|CK_Product_SellEndDate|(\[SellEndDate\]&gt;=\[SellStartDate\] OR \[SellEndDate\] IS NULL)|

---
### Identity column
| |Name |Seed |Increment |Not for replication |
|-|-|-|-|-|
|![](../../../../ImagesMetro/FILTER_Identity.gif "")| ProductID | 1 | 1 |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Referencing tables
|Table |Foreign key |Primary key or unique constraint |
|-|-|-|
|[\[Production\].\[ProductCostHistory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/434100587.md)|[FK_ProductCostHistory_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_434100587_FK_ProductCostHistory_Product_ProductID.md)|[PK_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/146099561_PK_Product_ProductID.md)|
|[\[Sales\].\[ShoppingCartItem\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/510624862.md)|[FK_ShoppingCartItem_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_510624862_FK_ShoppingCartItem_Product_ProductID.md)|[PK_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/146099561_PK_Product_ProductID.md)|
|[\[Production\].\[ProductDocument\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/546100986.md)|[FK_ProductDocument_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_546100986_FK_ProductDocument_Product_ProductID.md)|[PK_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/146099561_PK_Product_ProductID.md)|
|[\[Production\].\[ProductInventory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/578101100.md)|[FK_ProductInventory_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_578101100_FK_ProductInventory_Product_ProductID.md)|[PK_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/146099561_PK_Product_ProductID.md)|
|[\[Production\].\[ProductListPriceHistory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/674101442.md)|[FK_ProductListPriceHistory_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_674101442_FK_ProductListPriceHistory_Product_ProductID.md)|[PK_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/146099561_PK_Product_ProductID.md)|
|[\[Sales\].\[SpecialOfferProduct\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/734625660.md)|[FK_SpecialOfferProduct_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_734625660_FK_SpecialOfferProduct_Product_ProductID.md)|[PK_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/146099561_PK_Product_ProductID.md)|
|[\[Production\].\[BillOfMaterials\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/821577965.md)|[FK_BillOfMaterials_Product_ProductAssemblyID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_821577965_FK_BillOfMaterials_Product_ProductAssemblyID.md)|[PK_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/146099561_PK_Product_ProductID.md)|
|[\[Production\].\[BillOfMaterials\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/821577965.md)|[FK_BillOfMaterials_Product_ComponentID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_821577965_FK_BillOfMaterials_Product_ComponentID.md)|[PK_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/146099561_PK_Product_ProductID.md)|
|[\[Production\].\[ProductProductPhoto\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/882102183.md)|[FK_ProductProductPhoto_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_882102183_FK_ProductProductPhoto_Product_ProductID.md)|[PK_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/146099561_PK_Product_ProductID.md)|
|[\[Production\].\[TransactionHistory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/894626230.md)|[FK_TransactionHistory_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_894626230_FK_TransactionHistory_Product_ProductID.md)|[PK_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/146099561_PK_Product_ProductID.md)|
|[\[Production\].\[ProductReview\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/930102354.md)|[FK_ProductReview_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_930102354_FK_ProductReview_Product_ProductID.md)|[PK_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/146099561_PK_Product_ProductID.md)|
|[\[Purchasing\].\[ProductVendor\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1042102753.md)|[FK_ProductVendor_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1042102753_FK_ProductVendor_Product_ProductID.md)|[PK_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/146099561_PK_Product_ProductID.md)|
|[\[Production\].\[WorkOrder\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1166627199.md)|[FK_WorkOrder_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1166627199_FK_WorkOrder_Product_ProductID.md)|[PK_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/146099561_PK_Product_ProductID.md)|
|[\[Purchasing\].\[PurchaseOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1170103209.md)|[FK_PurchaseOrderDetail_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1170103209_FK_PurchaseOrderDetail_Product_ProductID.md)|[PK_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/146099561_PK_Product_ProductID.md)|

 Total: 14 table(s)

---
### Referenced tables
|Table |Primary key or unique constraint |Foreign key |
|-|-|-|
|[\[Production\].\[UnitMeasure\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1054626800.md)|[PK_UnitMeasure_UnitMeasureCode](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1054626800_PK_UnitMeasure_UnitMeasureCode.md)|[FK_Product_UnitMeasure_SizeUnitMeasureCode](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_146099561_FK_Product_UnitMeasure_SizeUnitMeasureCode.md)|
|[\[Production\].\[UnitMeasure\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1054626800.md)|[PK_UnitMeasure_UnitMeasureCode](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1054626800_PK_UnitMeasure_UnitMeasureCode.md)|[FK_Product_UnitMeasure_WeightUnitMeasureCode](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_146099561_FK_Product_UnitMeasure_WeightUnitMeasureCode.md)|
|[\[Production\].\[ProductModel\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/738101670.md)|[PK_ProductModel_ProductModelID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/738101670_PK_ProductModel_ProductModelID.md)|[FK_Product_ProductModel_ProductModelID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_146099561_FK_Product_ProductModel_ProductModelID.md)|
|[\[Production\].\[ProductSubcategory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/994102582.md)|[PK_ProductSubcategory_ProductSubcategoryID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/994102582_PK_ProductSubcategory_ProductSubcategoryID.md)|[FK_Product_ProductSubcategory_ProductSubcategoryID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_146099561_FK_Product_ProductSubcategory_ProductSubcategoryID.md)|

 Total: 4 table(s)

---
### Triggers
 No triggers exist

---
### Data models
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/146099561_dm.md) to view data model

---
### Objects that depend on \[Production\].\[Product\]
|Object name|Object type|Dep level|
|-|-|-|
|[\[dbo\].\[uspGetBillOfMaterials\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1501248403.md)|Procedure|1|
|[\[dbo\].\[uspGetWhereUsedProductID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1549248574.md)|Procedure|1|
|[\[Production\].\[BillOfMaterials\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/821577965.md)|Table|1|
|[\[Production\].\[ProductCostHistory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/434100587.md)|Table|1|
|[\[Production\].\[ProductDocument\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/546100986.md)|Table|1|
|[\[Production\].\[ProductInventory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/578101100.md)|Table|1|
|[\[Production\].\[ProductListPriceHistory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/674101442.md)|Table|1|
|[\[Production\].\[ProductProductPhoto\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/882102183.md)|Table|1|
|[\[Production\].\[ProductReview\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/930102354.md)|Table|1|
|[\[Purchasing\].\[ProductVendor\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1042102753.md)|Table|1|
|[\[Purchasing\].\[PurchaseOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1170103209.md)|Table|1|
|[\[Sales\].\[ShoppingCartItem\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/510624862.md)|Table|1|
|[\[Sales\].\[SpecialOfferProduct\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/734625660.md)|Table|1|
|[\[Production\].\[TransactionHistory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/894626230.md)|Table|1|
|[\[Production\].\[WorkOrder\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1166627199.md)|Table|1|
|[\[dbo\].\[ufnGetProductDealerPrice\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Functions/1389248004.md)|Function|1|
|[\[dbo\].\[ufnGetProductListPrice\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Functions/1405248061.md)|Function|1|
|[\[dbo\].\[ufnGetProductStandardCost\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Functions/1421248118.md)|Function|1|
|[\[Production\].\[vProductAndDescription\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1165247206.md)|View|1|

 Total 19 object(s)

---
### Objects that \[Production\].\[Product\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Production\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/7.md)|Schema|1|
|[\[Production\].\[ProductModel\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/738101670.md)|Table|1|
|[\[Production\].\[ProductSubcategory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/994102582.md)|Table|1|
|[\[Production\].\[UnitMeasure\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1054626800.md)|Table|1|
|[\[dbo\].\[Flag\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/258.md)|Datatype|1|
|[\[dbo\].\[Name\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/260.md)|Datatype|1|

 Total 6 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[Production\].\[UnitMeasure\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1054626800.md)|UnitMeasureCode|Table|
|[\[Production\].\[ProductModel\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/738101670.md)|ProductModelID|Table|
|[\[Production\].\[ProductSubcategory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/994102582.md)|ProductSubcategoryID|Table|

 Total 3 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/146099561_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Products sold or used in the manfacturing of sold products.|

---
###  Permissions
No permissions defined

---
### Table options
|Name |Value |
|-|-|
|Pintable|OFF|
|Table lock on bulk load|OFF|
|Insert row lock|OFF|
|Text in row|0|
|Large value types out of row|OFF|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING ON
GO
CREATE TABLE [Production].[Product] (
        [ProductID]                 [int] IDENTITY(1, 1) NOT NULL,
        [Name]                      [dbo].[Name] NOT NULL,
        [ProductNumber]             [nvarchar](25) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [MakeFlag]                  [dbo].[Flag] NOT NULL,
        [FinishedGoodsFlag]         [dbo].[Flag] NOT NULL,
        [Color]                     [nvarchar](15) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        [SafetyStockLevel]          [smallint] NOT NULL,
        [ReorderPoint]              [smallint] NOT NULL,
        [StandardCost]              [money] NOT NULL,
        [ListPrice]                 [money] NOT NULL,
        [Size]                      [nvarchar](5) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        [SizeUnitMeasureCode]       [nchar](3) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        [WeightUnitMeasureCode]     [nchar](3) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        [Weight]                    [decimal](8, 2) NULL,
        [DaysToManufacture]         [int] NOT NULL,
        [ProductLine]               [nchar](2) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        [Class]                     [nchar](2) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        [Style]                     [nchar](2) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        [ProductSubcategoryID]      [int] NULL,
        [ProductModelID]            [int] NULL,
        [SellStartDate]             [datetime] NOT NULL,
        [SellEndDate]               [datetime] NULL,
        [DiscontinuedDate]          [datetime] NULL,
        [rowguid]                   [uniqueidentifier] NOT NULL ROWGUIDCOL,
        [ModifiedDate]              [datetime] NOT NULL,
        CONSTRAINT [PK_Product_ProductID]
        PRIMARY KEY
        CLUSTERED
        ([ProductID])
    ON [PRIMARY]
) ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Clustered index created by a primary key constraint.', 'SCHEMA', N'Production', 'TABLE', N'Product', 'INDEX', N'PK_Product_ProductID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key (clustered) constraint', 'SCHEMA', N'Production', 'TABLE', N'Product', 'CONSTRAINT', N'PK_Product_ProductID'
GO
ALTER TABLE [Production].[Product]
    ADD
    CONSTRAINT [CK_Product_SafetyStockLevel]
    CHECK
    ([SafetyStockLevel]&gt;(0))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [SafetyStockLevel] &gt; (0)', 'SCHEMA', N'Production', 'TABLE', N'Product', 'CONSTRAINT', N'CK_Product_SafetyStockLevel'
GO
ALTER TABLE [Production].[Product]
CHECK CONSTRAINT [CK_Product_SafetyStockLevel]
GO
ALTER TABLE [Production].[Product]
    ADD
    CONSTRAINT [CK_Product_ReorderPoint]
    CHECK
    ([ReorderPoint]&gt;(0))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [ReorderPoint] &gt; (0)', 'SCHEMA', N'Production', 'TABLE', N'Product', 'CONSTRAINT', N'CK_Product_ReorderPoint'
GO
ALTER TABLE [Production].[Product]
CHECK CONSTRAINT [CK_Product_ReorderPoint]
GO
ALTER TABLE [Production].[Product]
    ADD
    CONSTRAINT [CK_Product_StandardCost]
    CHECK
    ([StandardCost]&gt;=(0.00))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [SafetyStockLevel] &gt; (0)', 'SCHEMA', N'Production', 'TABLE', N'Product', 'CONSTRAINT', N'CK_Product_StandardCost'
GO
ALTER TABLE [Production].[Product]
CHECK CONSTRAINT [CK_Product_StandardCost]
GO
ALTER TABLE [Production].[Product]
    ADD
    CONSTRAINT [CK_Product_ListPrice]
    CHECK
    ([ListPrice]&gt;=(0.00))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [ListPrice] &gt;= (0.00)', 'SCHEMA', N'Production', 'TABLE', N'Product', 'CONSTRAINT', N'CK_Product_ListPrice'
GO
ALTER TABLE [Production].[Product]
CHECK CONSTRAINT [CK_Product_ListPrice]
GO
ALTER TABLE [Production].[Product]
    ADD
    CONSTRAINT [CK_Product_Weight]
    CHECK
    ([Weight]&gt;(0.00))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [Weight] &gt; (0.00)', 'SCHEMA', N'Production', 'TABLE', N'Product', 'CONSTRAINT', N'CK_Product_Weight'
GO
ALTER TABLE [Production].[Product]
CHECK CONSTRAINT [CK_Product_Weight]
GO
ALTER TABLE [Production].[Product]
    ADD
    CONSTRAINT [CK_Product_DaysToManufacture]
    CHECK
    ([DaysToManufacture]&gt;=(0))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [DaysToManufacture] &gt;= (0)', 'SCHEMA', N'Production', 'TABLE', N'Product', 'CONSTRAINT', N'CK_Product_DaysToManufacture'
GO
ALTER TABLE [Production].[Product]
CHECK CONSTRAINT [CK_Product_DaysToManufacture]
GO
ALTER TABLE [Production].[Product]
    ADD
    CONSTRAINT [CK_Product_ProductLine]
    CHECK
    (upper([ProductLine])='R' OR upper([ProductLine])='M' OR upper([ProductLine])='T' OR upper([ProductLine])='S' OR [ProductLine] IS NULL)
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [ProductLine]=''r'' OR [ProductLine]=''m'' OR [ProductLine]=''t'' OR [ProductLine]=''s'' OR [ProductLine]=''R'' OR [ProductLine]=''M'' OR [ProductLine]=''T'' OR [ProductLine]=''S'' OR [ProductLine] IS NULL', 'SCHEMA', N'Production', 'TABLE', N'Product', 'CONSTRAINT', N'CK_Product_ProductLine'
GO
ALTER TABLE [Production].[Product]
CHECK CONSTRAINT [CK_Product_ProductLine]
GO
ALTER TABLE [Production].[Product]
    ADD
    CONSTRAINT [CK_Product_Class]
    CHECK
    (upper([Class])='H' OR upper([Class])='M' OR upper([Class])='L' OR [Class] IS NULL)
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [Class]=''h'' OR [Class]=''m'' OR [Class]=''l'' OR [Class]=''H'' OR [Class]=''M'' OR [Class]=''L'' OR [Class] IS NULL', 'SCHEMA', N'Production', 'TABLE', N'Product', 'CONSTRAINT', N'CK_Product_Class'
GO
ALTER TABLE [Production].[Product]
CHECK CONSTRAINT [CK_Product_Class]
GO
ALTER TABLE [Production].[Product]
    ADD
    CONSTRAINT [CK_Product_Style]
    CHECK
    (upper([Style])='U' OR upper([Style])='M' OR upper([Style])='W' OR [Style] IS NULL)
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [Style]=''u'' OR [Style]=''m'' OR [Style]=''w'' OR [Style]=''U'' OR [Style]=''M'' OR [Style]=''W'' OR [Style] IS NULL', 'SCHEMA', N'Production', 'TABLE', N'Product', 'CONSTRAINT', N'CK_Product_Style'
GO
ALTER TABLE [Production].[Product]
CHECK CONSTRAINT [CK_Product_Style]
GO
ALTER TABLE [Production].[Product]
    ADD
    CONSTRAINT [CK_Product_SellEndDate]
    CHECK
    ([SellEndDate]&gt;=[SellStartDate] OR [SellEndDate] IS NULL)
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [SellEndDate] &gt;= [SellStartDate] OR [SellEndDate] IS NULL', 'SCHEMA', N'Production', 'TABLE', N'Product', 'CONSTRAINT', N'CK_Product_SellEndDate'
GO
ALTER TABLE [Production].[Product]
CHECK CONSTRAINT [CK_Product_SellEndDate]
GO
ALTER TABLE [Production].[Product]
    ADD
    CONSTRAINT [DF_Product_MakeFlag]
    DEFAULT ((1)) FOR [MakeFlag]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of  1', 'SCHEMA', N'Production', 'TABLE', N'Product', 'CONSTRAINT', N'DF_Product_MakeFlag'
GO
ALTER TABLE [Production].[Product]
    ADD
    CONSTRAINT [DF_Product_FinishedGoodsFlag]
    DEFAULT ((1)) FOR [FinishedGoodsFlag]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of  1', 'SCHEMA', N'Production', 'TABLE', N'Product', 'CONSTRAINT', N'DF_Product_FinishedGoodsFlag'
GO
ALTER TABLE [Production].[Product]
    ADD
    CONSTRAINT [DF_Product_rowguid]
    DEFAULT (newid()) FOR [rowguid]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of NEWID()', 'SCHEMA', N'Production', 'TABLE', N'Product', 'CONSTRAINT', N'DF_Product_rowguid'
GO
ALTER TABLE [Production].[Product]
    ADD
    CONSTRAINT [DF_Product_ModifiedDate]
    DEFAULT (getdate()) FOR [ModifiedDate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of GETDATE()', 'SCHEMA', N'Production', 'TABLE', N'Product', 'CONSTRAINT', N'DF_Product_ModifiedDate'
GO
ALTER TABLE [Production].[Product]
    WITH CHECK
    ADD CONSTRAINT [FK_Product_UnitMeasure_SizeUnitMeasureCode]
    FOREIGN KEY ([SizeUnitMeasureCode]) REFERENCES [Production].[UnitMeasure] ([UnitMeasureCode])
ALTER TABLE [Production].[Product]
    CHECK CONSTRAINT [FK_Product_UnitMeasure_SizeUnitMeasureCode]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing UnitMeasure.UnitMeasureCode.', 'SCHEMA', N'Production', 'TABLE', N'Product', 'CONSTRAINT', N'FK_Product_UnitMeasure_SizeUnitMeasureCode'
GO
ALTER TABLE [Production].[Product]
    WITH CHECK
    ADD CONSTRAINT [FK_Product_UnitMeasure_WeightUnitMeasureCode]
    FOREIGN KEY ([WeightUnitMeasureCode]) REFERENCES [Production].[UnitMeasure] ([UnitMeasureCode])
ALTER TABLE [Production].[Product]
    CHECK CONSTRAINT [FK_Product_UnitMeasure_WeightUnitMeasureCode]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing UnitMeasure.UnitMeasureCode.', 'SCHEMA', N'Production', 'TABLE', N'Product', 'CONSTRAINT', N'FK_Product_UnitMeasure_WeightUnitMeasureCode'
GO
ALTER TABLE [Production].[Product]
    WITH CHECK
    ADD CONSTRAINT [FK_Product_ProductModel_ProductModelID]
    FOREIGN KEY ([ProductModelID]) REFERENCES [Production].[ProductModel] ([ProductModelID])
ALTER TABLE [Production].[Product]
    CHECK CONSTRAINT [FK_Product_ProductModel_ProductModelID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing ProductModel.ProductModelID.', 'SCHEMA', N'Production', 'TABLE', N'Product', 'CONSTRAINT', N'FK_Product_ProductModel_ProductModelID'
GO
ALTER TABLE [Production].[Product]
    WITH CHECK
    ADD CONSTRAINT [FK_Product_ProductSubcategory_ProductSubcategoryID]
    FOREIGN KEY ([ProductSubcategoryID]) REFERENCES [Production].[ProductSubcategory] ([ProductSubcategoryID])
ALTER TABLE [Production].[Product]
    CHECK CONSTRAINT [FK_Product_ProductSubcategory_ProductSubcategoryID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing ProductSubcategory.ProductSubcategoryID.', 'SCHEMA', N'Production', 'TABLE', N'Product', 'CONSTRAINT', N'FK_Product_ProductSubcategory_ProductSubcategoryID'
GO
CREATE UNIQUE NONCLUSTERED INDEX [AK_Product_ProductNumber]
    ON [Production].[Product] ([ProductNumber])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique nonclustered index.', 'SCHEMA', N'Production', 'TABLE', N'Product', 'INDEX', N'AK_Product_ProductNumber'
GO
CREATE UNIQUE NONCLUSTERED INDEX [AK_Product_Name]
    ON [Production].[Product] ([Name])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique nonclustered index.', 'SCHEMA', N'Production', 'TABLE', N'Product', 'INDEX', N'AK_Product_Name'
GO
CREATE UNIQUE NONCLUSTERED INDEX [AK_Product_rowguid]
    ON [Production].[Product] ([rowguid])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique nonclustered index. Used to support replication samples.', 'SCHEMA', N'Production', 'TABLE', N'Product', 'INDEX', N'AK_Product_rowguid'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Products sold or used in the manfacturing of sold products.', 'SCHEMA', N'Production', 'TABLE', N'Product', NULL, NULL
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key for Product records.', 'SCHEMA', N'Production', 'TABLE', N'Product', 'COLUMN', N'ProductID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Name of the product.', 'SCHEMA', N'Production', 'TABLE', N'Product', 'COLUMN', N'Name'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique product identification number.', 'SCHEMA', N'Production', 'TABLE', N'Product', 'COLUMN', N'ProductNumber'
GO
EXEC sp_addextendedproperty N'MS_Description', N'0 = Product is purchased, 1 = Product is manufactured in-house.', 'SCHEMA', N'Production', 'TABLE', N'Product', 'COLUMN', N'MakeFlag'
GO
EXEC sp_addextendedproperty N'MS_Description', N'0 = Product is not a salable item. 1 = Product is salable.', 'SCHEMA', N'Production', 'TABLE', N'Product', 'COLUMN', N'FinishedGoodsFlag'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Product color.', 'SCHEMA', N'Production', 'TABLE', N'Product', 'COLUMN', N'Color'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Minimum inventory quantity. ', 'SCHEMA', N'Production', 'TABLE', N'Product', 'COLUMN', N'SafetyStockLevel'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Inventory level that triggers a purchase order or work order. ', 'SCHEMA', N'Production', 'TABLE', N'Product', 'COLUMN', N'ReorderPoint'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Standard cost of the product.', 'SCHEMA', N'Production', 'TABLE', N'Product', 'COLUMN', N'StandardCost'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Selling price.', 'SCHEMA', N'Production', 'TABLE', N'Product', 'COLUMN', N'ListPrice'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Product size.', 'SCHEMA', N'Production', 'TABLE', N'Product', 'COLUMN', N'Size'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unit of measure for Size column.', 'SCHEMA', N'Production', 'TABLE', N'Product', 'COLUMN', N'SizeUnitMeasureCode'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unit of measure for Weight column.', 'SCHEMA', N'Production', 'TABLE', N'Product', 'COLUMN', N'WeightUnitMeasureCode'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Product weight.', 'SCHEMA', N'Production', 'TABLE', N'Product', 'COLUMN', N'Weight'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Number of days required to manufacture the product.', 'SCHEMA', N'Production', 'TABLE', N'Product', 'COLUMN', N'DaysToManufacture'
GO
EXEC sp_addextendedproperty N'MS_Description', N'R = Road, M = Mountain, T = Touring, S = Standard', 'SCHEMA', N'Production', 'TABLE', N'Product', 'COLUMN', N'ProductLine'
GO
EXEC sp_addextendedproperty N'MS_Description', N'H = High, M = Medium, L = Low', 'SCHEMA', N'Production', 'TABLE', N'Product', 'COLUMN', N'Class'
GO
EXEC sp_addextendedproperty N'MS_Description', N'W = Womens, M = Mens, U = Universal', 'SCHEMA', N'Production', 'TABLE', N'Product', 'COLUMN', N'Style'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Product is a member of this product subcategory. Foreign key to ProductSubCategory.ProductSubCategoryID. ', 'SCHEMA', N'Production', 'TABLE', N'Product', 'COLUMN', N'ProductSubcategoryID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Product is a member of this product model. Foreign key to ProductModel.ProductModelID.', 'SCHEMA', N'Production', 'TABLE', N'Product', 'COLUMN', N'ProductModelID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date the product was available for sale.', 'SCHEMA', N'Production', 'TABLE', N'Product', 'COLUMN', N'SellStartDate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date the product was no longer available for sale.', 'SCHEMA', N'Production', 'TABLE', N'Product', 'COLUMN', N'SellEndDate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date the product was discontinued.', 'SCHEMA', N'Production', 'TABLE', N'Product', 'COLUMN', N'DiscontinuedDate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'ROWGUIDCOL number uniquely identifying the record. Used to support a merge replication sample.', 'SCHEMA', N'Production', 'TABLE', N'Product', 'COLUMN', N'rowguid'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date and time the record was last updated.', 'SCHEMA', N'Production', 'TABLE', N'Product', 'COLUMN', N'ModifiedDate'
GO
  
~~~

---
### See also
[List of tables](../tables.md)

