## ![](../../../../Images32x32Metro/OBJECT_TABLE.png "") Table:\[AdventureWorks2016CTP3\].\[Sales\].\[SalesTaxRate\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > **Sales.SalesTaxRate**

---
###  Description  
 Tax rate lookup table. 



---
### Table properties
|Name |Value |
|-|-|
| Schema |[\[Sales\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md)|
| Owner |[\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md)|
| Table is replicated |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Creation date |10/23/2015|
| ID |14623095|
| Located on |PRIMARY|
| Data size KB |8 KB|
| Index size KB |40 KB|
| Rows |29  |
| ChangeTrackingEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| FileStreamFileGroup | |
| FileStreamPartitionScheme | |
| LockEscalation |TABLE|
| TrackColumnsUpdatedEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Table is filetable |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Filetable directory | |
| Filetable collate | |
| Filetable primary key |\[PK_SalesTaxRate_SalesTaxRateID\]|
| Filetable streamid unique | |
| Filetable fullpath unique | |
| Filetable is enabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is memory optimized |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Durability |SCHEMA_AND_DATA|

---
### Creation options
|Name |Value |
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|
|ANSI_PADDING|ON|

---
### Columns
| | | |Name |Description |IsComputed|Data type |Max length |Nullable |Default|IsGUID |SPARSE|Computed value|
|-|-|-|-|-|-|-|-|-|-|-|-|-|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|![Identity](../../../../ImagesMetro/FILTER_Identity.gif "")| |SalesTaxRateID|Primary key for SalesTaxRate records.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_14623095_FK_SalesTaxRate_StateProvince_StateProvinceID.md)|StateProvinceID|State, province, or country/region the sales tax applies to.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |TaxType|1 = Tax applied to retail transactions, 2 = Tax applied to wholesale transactions, 3 = Tax applied to all sales (retail and wholesale) transactions.| |tinyint|1|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |TaxRate|Tax rate amount.| |smallmoney|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|((0.00))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |Name|Tax rate description.| |[\[dbo\].\[Name\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/260.md)|50|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |rowguid|ROWGUIDCOL number uniquely identifying the record. Used to support a merge replication sample.| |uniqueidentifier|16|![](../../../../ImagesMetro/RED_CROSS.gif "")|(newid())|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |ModifiedDate|Date and time the record was last updated.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|(getdate())|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|

 Total: 7 column(s)

---
### Text column statistics
|Name |Data type |Avg. length |Min. length |Max. length |Usage rating |
|-|-|-|-|-|-|
|Name|nvarchar(50) |19|12|37|0.37000000000000|

 Total: 1 text column(s)

---
### Indexes
|Index |Key columns |Description |Primary |Unique |Size KB |Fill factor |
|-|-|-|-|-|-|-|
|[\[PK_SalesTaxRate_SalesTaxRateID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/14623095_PK_SalesTaxRate_SalesTaxRateID.md)|SalesTaxRateID|Primary key (clustered) constraint|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|48|0|
|[\[AK_SalesTaxRate_StateProvinceID_TaxType\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/14623095_AK_SalesTaxRate_StateProvinceID_TaxType.md)|StateProvinceID, TaxType|Unique nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|16|0|
|[\[AK_SalesTaxRate_rowguid\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/14623095_AK_SalesTaxRate_rowguid.md)|rowguid|Unique nonclustered index. Used to support replication samples.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|16|0|

 Total: 3 Index/indexes

---
### Columnstore indexes
 No columnstore indexes exist

---
### Fulltext index
 No fulltext index exist

---
### Statistics
 No statistics exist

---
### Check constraints
|Name |Expression |
|-|-|
|CK_SalesTaxRate_TaxType|(\[TaxType\]&gt;=(1) AND \[TaxType\]&lt;=(3))|

---
### Identity column
| |Name |Seed |Increment |Not for replication |
|-|-|-|-|-|
|![](../../../../ImagesMetro/FILTER_Identity.gif "")| SalesTaxRateID | 1 | 1 |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Referencing tables
 No referencing tables exist

---
### Referenced tables
|Table |Primary key or unique constraint |Foreign key |
|-|-|-|
|[\[Person\].\[StateProvince\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/782625831.md)|[PK_StateProvince_StateProvinceID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/782625831_PK_StateProvince_StateProvinceID.md)|[FK_SalesTaxRate_StateProvince_StateProvinceID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_14623095_FK_SalesTaxRate_StateProvince_StateProvinceID.md)|

 Total: 1 table(s)

---
### Triggers
 No triggers exist

---
### Data models
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/14623095_dm.md) to view data model

---
### Objects that depend on \[Sales\].\[SalesTaxRate\]
 No dependencies exist

---
### Objects that \[Sales\].\[SalesTaxRate\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Sales\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md)|Schema|1|
|[\[Person\].\[StateProvince\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/782625831.md)|Table|1|
|[\[dbo\].\[Name\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/260.md)|Datatype|1|

 Total 3 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[Person\].\[StateProvince\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/782625831.md)|StateProvinceID|Table|

 Total 1 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/14623095_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Tax rate lookup table.|

---
###  Permissions
No permissions defined

---
### Table options
|Name |Value |
|-|-|
|Pintable|OFF|
|Table lock on bulk load|OFF|
|Insert row lock|OFF|
|Text in row|0|
|Large value types out of row|OFF|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING ON
GO
CREATE TABLE [Sales].[SalesTaxRate] (
        [SalesTaxRateID]      [int] IDENTITY(1, 1) NOT NULL,
        [StateProvinceID]     [int] NOT NULL,
        [TaxType]             [tinyint] NOT NULL,
        [TaxRate]             [smallmoney] NOT NULL,
        [Name]                [dbo].[Name] NOT NULL,
        [rowguid]             [uniqueidentifier] NOT NULL ROWGUIDCOL,
        [ModifiedDate]        [datetime] NOT NULL,
        CONSTRAINT [PK_SalesTaxRate_SalesTaxRateID]
        PRIMARY KEY
        CLUSTERED
        ([SalesTaxRateID])
    ON [PRIMARY]
) ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Clustered index created by a primary key constraint.', 'SCHEMA', N'Sales', 'TABLE', N'SalesTaxRate', 'INDEX', N'PK_SalesTaxRate_SalesTaxRateID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key (clustered) constraint', 'SCHEMA', N'Sales', 'TABLE', N'SalesTaxRate', 'CONSTRAINT', N'PK_SalesTaxRate_SalesTaxRateID'
GO
ALTER TABLE [Sales].[SalesTaxRate]
    ADD
    CONSTRAINT [CK_SalesTaxRate_TaxType]
    CHECK
    ([TaxType]&gt;=(1) AND [TaxType]&lt;=(3))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [TaxType] BETWEEN (1) AND (3)', 'SCHEMA', N'Sales', 'TABLE', N'SalesTaxRate', 'CONSTRAINT', N'CK_SalesTaxRate_TaxType'
GO
ALTER TABLE [Sales].[SalesTaxRate]
CHECK CONSTRAINT [CK_SalesTaxRate_TaxType]
GO
ALTER TABLE [Sales].[SalesTaxRate]
    ADD
    CONSTRAINT [DF_SalesTaxRate_TaxRate]
    DEFAULT ((0.00)) FOR [TaxRate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of 0.0', 'SCHEMA', N'Sales', 'TABLE', N'SalesTaxRate', 'CONSTRAINT', N'DF_SalesTaxRate_TaxRate'
GO
ALTER TABLE [Sales].[SalesTaxRate]
    ADD
    CONSTRAINT [DF_SalesTaxRate_rowguid]
    DEFAULT (newid()) FOR [rowguid]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of NEWID()', 'SCHEMA', N'Sales', 'TABLE', N'SalesTaxRate', 'CONSTRAINT', N'DF_SalesTaxRate_rowguid'
GO
ALTER TABLE [Sales].[SalesTaxRate]
    ADD
    CONSTRAINT [DF_SalesTaxRate_ModifiedDate]
    DEFAULT (getdate()) FOR [ModifiedDate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of GETDATE()', 'SCHEMA', N'Sales', 'TABLE', N'SalesTaxRate', 'CONSTRAINT', N'DF_SalesTaxRate_ModifiedDate'
GO
ALTER TABLE [Sales].[SalesTaxRate]
    WITH CHECK
    ADD CONSTRAINT [FK_SalesTaxRate_StateProvince_StateProvinceID]
    FOREIGN KEY ([StateProvinceID]) REFERENCES [Person].[StateProvince] ([StateProvinceID])
ALTER TABLE [Sales].[SalesTaxRate]
    CHECK CONSTRAINT [FK_SalesTaxRate_StateProvince_StateProvinceID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing StateProvince.StateProvinceID.', 'SCHEMA', N'Sales', 'TABLE', N'SalesTaxRate', 'CONSTRAINT', N'FK_SalesTaxRate_StateProvince_StateProvinceID'
GO
CREATE UNIQUE NONCLUSTERED INDEX [AK_SalesTaxRate_StateProvinceID_TaxType]
    ON [Sales].[SalesTaxRate] ([StateProvinceID], [TaxType])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique nonclustered index.', 'SCHEMA', N'Sales', 'TABLE', N'SalesTaxRate', 'INDEX', N'AK_SalesTaxRate_StateProvinceID_TaxType'
GO
CREATE UNIQUE NONCLUSTERED INDEX [AK_SalesTaxRate_rowguid]
    ON [Sales].[SalesTaxRate] ([rowguid])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique nonclustered index. Used to support replication samples.', 'SCHEMA', N'Sales', 'TABLE', N'SalesTaxRate', 'INDEX', N'AK_SalesTaxRate_rowguid'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Tax rate lookup table.', 'SCHEMA', N'Sales', 'TABLE', N'SalesTaxRate', NULL, NULL
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key for SalesTaxRate records.', 'SCHEMA', N'Sales', 'TABLE', N'SalesTaxRate', 'COLUMN', N'SalesTaxRateID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'State, province, or country/region the sales tax applies to.', 'SCHEMA', N'Sales', 'TABLE', N'SalesTaxRate', 'COLUMN', N'StateProvinceID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'1 = Tax applied to retail transactions, 2 = Tax applied to wholesale transactions, 3 = Tax applied to all sales (retail and wholesale) transactions.', 'SCHEMA', N'Sales', 'TABLE', N'SalesTaxRate', 'COLUMN', N'TaxType'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Tax rate amount.', 'SCHEMA', N'Sales', 'TABLE', N'SalesTaxRate', 'COLUMN', N'TaxRate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Tax rate description.', 'SCHEMA', N'Sales', 'TABLE', N'SalesTaxRate', 'COLUMN', N'Name'
GO
EXEC sp_addextendedproperty N'MS_Description', N'ROWGUIDCOL number uniquely identifying the record. Used to support a merge replication sample.', 'SCHEMA', N'Sales', 'TABLE', N'SalesTaxRate', 'COLUMN', N'rowguid'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date and time the record was last updated.', 'SCHEMA', N'Sales', 'TABLE', N'SalesTaxRate', 'COLUMN', N'ModifiedDate'
GO
  
~~~

---
### See also
[List of tables](../tables.md)

