## ![](../../../../Images32x32Metro/OBJECT_TABLE.png "") Table:\[AdventureWorks2016CTP3\].\[Sales\].\[SalesOrderDetail\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > **Sales.SalesOrderDetail**

---
###  Description  
 Individual products associated with a specific sales order. See SalesOrderHeader. 



---
### Table properties
|Name |Value |
|-|-|
| Schema |[\[Sales\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md)|
| Owner |[\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md)|
| Table is replicated |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Creation date |10/23/2015|
| ID |1474104292|
| Located on |PRIMARY|
| Data size KB |9968 KB|
| Index size KB |6776 KB|
| Rows |121317  |
| ChangeTrackingEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| FileStreamFileGroup | |
| FileStreamPartitionScheme | |
| LockEscalation |TABLE|
| TrackColumnsUpdatedEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Table is filetable |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Filetable directory | |
| Filetable collate | |
| Filetable primary key |\[PK_SalesOrderDetail_SalesOrderID_SalesOrderDetailID\]|
| Filetable streamid unique | |
| Filetable fullpath unique | |
| Filetable is enabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is memory optimized |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Durability |SCHEMA_AND_DATA|

---
### Creation options
|Name |Value |
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|
|ANSI_PADDING|ON|

---
### Columns
| | | |Name |Description |IsComputed|Data type |Max length |Nullable |Default|IsGUID |SPARSE|Computed value|
|-|-|-|-|-|-|-|-|-|-|-|-|-|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")| |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1474104292_FK_SalesOrderDetail_SalesOrderHeader_SalesOrderID.md)|SalesOrderID|Primary key. Foreign key to SalesOrderHeader.SalesOrderID.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|![Identity](../../../../ImagesMetro/FILTER_Identity.gif "")| |SalesOrderDetailID|Primary key. One incremental unique number per product sold.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |CarrierTrackingNumber|Shipment tracking number supplied by the shipper.| |nvarchar|25|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |OrderQty|Quantity ordered per product.| |smallint|2|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1474104292_FK_SalesOrderDetail_SpecialOfferProduct_SpecialOfferIDProductID.md)|ProductID|Product sold to customer. Foreign key to Product.ProductID.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1474104292_FK_SalesOrderDetail_SpecialOfferProduct_SpecialOfferIDProductID.md)|SpecialOfferID|Promotional code. Foreign key to SpecialOffer.SpecialOfferID.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |UnitPrice|Selling price of a single product.| |money|8|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |UnitPriceDiscount|Discount amount.| |money|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|((0.0))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |LineTotal|Per product subtotal. Computed as UnitPrice * (1 - UnitPriceDiscount) * OrderQty.|True|numeric|17|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|(isnull((\[UnitPrice\]*((1.0)-\[UnitPriceDiscount\]))*\[OrderQty\],(0.0)))|
| | | |rowguid|ROWGUIDCOL number uniquely identifying the record. Used to support a merge replication sample.| |uniqueidentifier|16|![](../../../../ImagesMetro/RED_CROSS.gif "")|(newid())|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |ModifiedDate|Date and time the record was last updated.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|(getdate())|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|

 Total: 11 column(s)

---
### Text column statistics
|Name |Data type |Avg. length |Min. length |Max. length |Usage rating |
|-|-|-|-|-|-|
|CarrierTrackingNumber|nvarchar(25) |6|12|12|0.24000000000000|

 Total: 1 text column(s)

---
### Indexes
|Index |Key columns |Description |Primary |Unique |Size KB |Fill factor |
|-|-|-|-|-|-|-|
|[\[PK_SalesOrderDetail_SalesOrderID_SalesOrderDetailID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1474104292_PK_SalesOrderDetail_SalesOrderID_SalesOrderDetailID.md)|SalesOrderID, SalesOrderDetailID|Primary key (clustered) constraint|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|16744|0|
|[\[AK_SalesOrderDetail_rowguid\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1474104292_AK_SalesOrderDetail_rowguid.md)|rowguid|Unique nonclustered index. Used to support replication samples.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|3960|0|
|[\[IX_SalesOrderDetail_ProductID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1474104292_IX_SalesOrderDetail_ProductID.md)|ProductID|Nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|2464|0|

 Total: 3 Index/indexes

---
### Columnstore indexes
 No columnstore indexes exist

---
### Fulltext index
 No fulltext index exist

---
### Statistics
 No statistics exist

---
### Check constraints
|Name |Expression |
|-|-|
|CK_SalesOrderDetail_OrderQty|(\[OrderQty\]&gt;(0))|
|CK_SalesOrderDetail_UnitPrice|(\[UnitPrice\]&gt;=(0.00))|
|CK_SalesOrderDetail_UnitPriceDiscount|(\[UnitPriceDiscount\]&gt;=(0.00))|

---
### Identity column
| |Name |Seed |Increment |Not for replication |
|-|-|-|-|-|
|![](../../../../ImagesMetro/FILTER_Identity.gif "")| SalesOrderDetailID | 1 | 1 |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Referencing tables
 No referencing tables exist

---
### Referenced tables
|Table |Primary key or unique constraint |Foreign key |
|-|-|-|
|[\[Sales\].\[SalesOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691.md)|[PK_SalesOrderHeader_SalesOrderID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1586104691_PK_SalesOrderHeader_SalesOrderID.md)|[FK_SalesOrderDetail_SalesOrderHeader_SalesOrderID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1474104292_FK_SalesOrderDetail_SalesOrderHeader_SalesOrderID.md)|
|[\[Sales\].\[SpecialOfferProduct\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/734625660.md)|[PK_SpecialOfferProduct_SpecialOfferID_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/734625660_PK_SpecialOfferProduct_SpecialOfferID_ProductID.md)|[FK_SalesOrderDetail_SpecialOfferProduct_SpecialOfferIDProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1474104292_FK_SalesOrderDetail_SpecialOfferProduct_SpecialOfferIDProductID.md)|

 Total: 2 table(s)

---
### Triggers
|Name |Schema |Description |Instead of |For insert |For update |For delete |Table/view |
|-|-|-|-|-|-|-|-|
|[\[Sales\].\[iduSalesOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/941246408.md)|[\[Sales\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md)| 
|![](../../../../ImagesMetro/RED_CROSS.gif "")|![For Insert](../../../../ImagesMetro/AUDIT_trigger_insert.gif "")|![For Update](../../../../ImagesMetro/AUDIT_trigger_update.gif "")|![For Delete](../../../../ImagesMetro/AUDIT_trigger_delete.gif "")|[\[Sales\].\[SalesOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1474104292.md)|

 Total: 1 triggers(s)

---
### Data models
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1474104292_dm.md) to view data model

---
### Objects that depend on \[Sales\].\[SalesOrderDetail\]
|Object name|Object type|Dep level|
|-|-|-|
|[\[Demo\].\[usp_DemoReset\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1636200879.md)|Procedure|1|
|[\[Sales\].\[iduSalesOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/941246408.md)|Trigger|1|

 Total 2 object(s)

---
### Objects that \[Sales\].\[SalesOrderDetail\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Sales\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md)|Schema|1|
|[\[Sales\].\[SalesOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691.md)|Table|1|
|[\[Sales\].\[SpecialOfferProduct\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/734625660.md)|Table|1|

 Total 3 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[Sales\].\[SalesOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691.md)|SalesOrderID|Table|
|[\[Sales\].\[SpecialOfferProduct\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/734625660.md)|SpecialOfferID|Table|
|[\[Sales\].\[SpecialOfferProduct\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/734625660.md)|ProductID|Table|

 Total 3 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1474104292_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Individual products associated with a specific sales order. See SalesOrderHeader.|

---
###  Permissions
No permissions defined

---
### Table options
|Name |Value |
|-|-|
|Pintable|OFF|
|Table lock on bulk load|OFF|
|Insert row lock|OFF|
|Text in row|0|
|Large value types out of row|OFF|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING ON
GO
CREATE TABLE [Sales].[SalesOrderDetail] (
        [SalesOrderID]              [int] NOT NULL,
        [SalesOrderDetailID]        [int] IDENTITY(1, 1) NOT NULL,
        [CarrierTrackingNumber]     [nvarchar](25) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        [OrderQty]                  [smallint] NOT NULL,
        [ProductID]                 [int] NOT NULL,
        [SpecialOfferID]            [int] NOT NULL,
        [UnitPrice]                 [money] NOT NULL,
        [UnitPriceDiscount]         [money] NOT NULL,
        [LineTotal]                 AS (isnull(([UnitPrice]*((1.0)-[UnitPriceDiscount]))*[OrderQty],(0.0))),
        [rowguid]                   [uniqueidentifier] NOT NULL ROWGUIDCOL,
        [ModifiedDate]              [datetime] NOT NULL,
        CONSTRAINT [PK_SalesOrderDetail_SalesOrderID_SalesOrderDetailID]
        PRIMARY KEY
        CLUSTERED
        ([SalesOrderID], [SalesOrderDetailID])
    ON [PRIMARY]
) ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Clustered index created by a primary key constraint.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderDetail', 'INDEX', N'PK_SalesOrderDetail_SalesOrderID_SalesOrderDetailID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key (clustered) constraint', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderDetail', 'CONSTRAINT', N'PK_SalesOrderDetail_SalesOrderID_SalesOrderDetailID'
GO
ALTER TABLE [Sales].[SalesOrderDetail]
    ADD
    CONSTRAINT [CK_SalesOrderDetail_OrderQty]
    CHECK
    ([OrderQty]&gt;(0))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [OrderQty] &gt; (0)', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderDetail', 'CONSTRAINT', N'CK_SalesOrderDetail_OrderQty'
GO
ALTER TABLE [Sales].[SalesOrderDetail]
CHECK CONSTRAINT [CK_SalesOrderDetail_OrderQty]
GO
ALTER TABLE [Sales].[SalesOrderDetail]
    ADD
    CONSTRAINT [CK_SalesOrderDetail_UnitPrice]
    CHECK
    ([UnitPrice]&gt;=(0.00))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [UnitPrice] &gt;= (0.00)', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderDetail', 'CONSTRAINT', N'CK_SalesOrderDetail_UnitPrice'
GO
ALTER TABLE [Sales].[SalesOrderDetail]
CHECK CONSTRAINT [CK_SalesOrderDetail_UnitPrice]
GO
ALTER TABLE [Sales].[SalesOrderDetail]
    ADD
    CONSTRAINT [CK_SalesOrderDetail_UnitPriceDiscount]
    CHECK
    ([UnitPriceDiscount]&gt;=(0.00))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [UnitPriceDiscount] &gt;= (0.00)', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderDetail', 'CONSTRAINT', N'CK_SalesOrderDetail_UnitPriceDiscount'
GO
ALTER TABLE [Sales].[SalesOrderDetail]
CHECK CONSTRAINT [CK_SalesOrderDetail_UnitPriceDiscount]
GO
ALTER TABLE [Sales].[SalesOrderDetail]
    ADD
    CONSTRAINT [DF_SalesOrderDetail_UnitPriceDiscount]
    DEFAULT ((0.0)) FOR [UnitPriceDiscount]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of 0.0', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderDetail', 'CONSTRAINT', N'DF_SalesOrderDetail_UnitPriceDiscount'
GO
ALTER TABLE [Sales].[SalesOrderDetail]
    ADD
    CONSTRAINT [DF_SalesOrderDetail_rowguid]
    DEFAULT (newid()) FOR [rowguid]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of NEWID()', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderDetail', 'CONSTRAINT', N'DF_SalesOrderDetail_rowguid'
GO
ALTER TABLE [Sales].[SalesOrderDetail]
    ADD
    CONSTRAINT [DF_SalesOrderDetail_ModifiedDate]
    DEFAULT (getdate()) FOR [ModifiedDate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of GETDATE()', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderDetail', 'CONSTRAINT', N'DF_SalesOrderDetail_ModifiedDate'
GO
ALTER TABLE [Sales].[SalesOrderDetail]
    WITH CHECK
    ADD CONSTRAINT [FK_SalesOrderDetail_SalesOrderHeader_SalesOrderID]
    FOREIGN KEY ([SalesOrderID]) REFERENCES [Sales].[SalesOrderHeader] ([SalesOrderID])
    ON DELETE CASCADE
ALTER TABLE [Sales].[SalesOrderDetail]
    CHECK CONSTRAINT [FK_SalesOrderDetail_SalesOrderHeader_SalesOrderID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing SalesOrderHeader.PurchaseOrderID.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderDetail', 'CONSTRAINT', N'FK_SalesOrderDetail_SalesOrderHeader_SalesOrderID'
GO
ALTER TABLE [Sales].[SalesOrderDetail]
    WITH CHECK
    ADD CONSTRAINT [FK_SalesOrderDetail_SpecialOfferProduct_SpecialOfferIDProductID]
    FOREIGN KEY ([SpecialOfferID], [ProductID]) REFERENCES [Sales].[SpecialOfferProduct] ([SpecialOfferID], [ProductID])
ALTER TABLE [Sales].[SalesOrderDetail]
    CHECK CONSTRAINT [FK_SalesOrderDetail_SpecialOfferProduct_SpecialOfferIDProductID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing SpecialOfferProduct.SpecialOfferIDProductID.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderDetail', 'CONSTRAINT', N'FK_SalesOrderDetail_SpecialOfferProduct_SpecialOfferIDProductID'
GO
CREATE UNIQUE NONCLUSTERED INDEX [AK_SalesOrderDetail_rowguid]
    ON [Sales].[SalesOrderDetail] ([rowguid])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique nonclustered index. Used to support replication samples.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderDetail', 'INDEX', N'AK_SalesOrderDetail_rowguid'
GO
CREATE NONCLUSTERED INDEX [IX_SalesOrderDetail_ProductID]
    ON [Sales].[SalesOrderDetail] ([ProductID])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Nonclustered index.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderDetail', 'INDEX', N'IX_SalesOrderDetail_ProductID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Individual products associated with a specific sales order. See SalesOrderHeader.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderDetail', NULL, NULL
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key. Foreign key to SalesOrderHeader.SalesOrderID.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderDetail', 'COLUMN', N'SalesOrderID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key. One incremental unique number per product sold.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderDetail', 'COLUMN', N'SalesOrderDetailID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Shipment tracking number supplied by the shipper.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderDetail', 'COLUMN', N'CarrierTrackingNumber'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Quantity ordered per product.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderDetail', 'COLUMN', N'OrderQty'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Product sold to customer. Foreign key to Product.ProductID.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderDetail', 'COLUMN', N'ProductID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Promotional code. Foreign key to SpecialOffer.SpecialOfferID.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderDetail', 'COLUMN', N'SpecialOfferID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Selling price of a single product.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderDetail', 'COLUMN', N'UnitPrice'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Discount amount.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderDetail', 'COLUMN', N'UnitPriceDiscount'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Per product subtotal. Computed as UnitPrice * (1 - UnitPriceDiscount) * OrderQty.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderDetail', 'COLUMN', N'LineTotal'
GO
EXEC sp_addextendedproperty N'MS_Description', N'ROWGUIDCOL number uniquely identifying the record. Used to support a merge replication sample.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderDetail', 'COLUMN', N'rowguid'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date and time the record was last updated.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderDetail', 'COLUMN', N'ModifiedDate'
GO
  
~~~

---
### See also
[List of tables](../tables.md)

