## ![](../../../../Images32x32Metro/OBJECT_TABLE.png "") Table:\[AdventureWorks2016CTP3\].\[HumanResources\].\[Employee\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > **HumanResources.Employee**

---
###  Description  
 Employee information such as salary, department, and title. 



---
### Table properties
|Name |Value |
|-|-|
| Schema |[\[HumanResources\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/5.md)|
| Owner |[\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md)|
| Table is replicated |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Creation date |10/23/2015|
| ID |1557580587|
| Located on |PRIMARY|
| Data size KB |56 KB|
| Index size KB |136 KB|
| Rows |290 |
| ChangeTrackingEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| FileStreamFileGroup | |
| FileStreamPartitionScheme | |
| LockEscalation |TABLE|
| TrackColumnsUpdatedEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Table is filetable |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Filetable directory | |
| Filetable collate | |
| Filetable primary key |\[PK_Employee_BusinessEntityID\]|
| Filetable streamid unique | |
| Filetable fullpath unique | |
| Filetable is enabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is memory optimized |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Durability |SCHEMA_AND_DATA|

---
### Creation options
|Name |Value |
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|
|ANSI_PADDING|ON|

---
### Columns
| | |Name |Description |IsComputed|Data type |Max length |Nullable |Default|IsGUID |SPARSE|Computed value|
|-|-|-|-|-|-|-|-|-|-|-|-|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1557580587_FK_Employee_Person_BusinessEntityID.md)|BusinessEntityID|Primary key for Employee records.  Foreign key to BusinessEntity.BusinessEntityID.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |NationalIDNumber|Unique national identification number such as a social security number.| |nvarchar|15|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |LoginID|Network login.| |nvarchar|256|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |OrganizationNode|Where the employee is located in corporate hierarchy.| |hierarchyid|892|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |OrganizationLevel|The depth of the employee in the corporate hierarchy.|True|smallint|2|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|(\[OrganizationNode\].\[GetLevel\]())|
| | |JobTitle|Work title such as Buyer or Sales Representative.| |nvarchar|50|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |BirthDate|Date of birth.| |date|3|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |MaritalStatus|M = Married, S = Single| |nchar|1|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |Gender|M = Male, F = Female| |nchar|1|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |HireDate|Employee hired on this date.| |date|3|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |SalariedFlag|Job classification. 0 = Hourly, not exempt from collective bargaining. 1 = Salaried, exempt from collective bargaining.| |[\[dbo\].\[Flag\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/258.md)|1|![](../../../../ImagesMetro/RED_CROSS.gif "")|((1))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |VacationHours|Number of available vacation hours.| |smallint|2|![](../../../../ImagesMetro/RED_CROSS.gif "")|((0))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |SickLeaveHours|Number of available sick leave hours.| |smallint|2|![](../../../../ImagesMetro/RED_CROSS.gif "")|((0))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |CurrentFlag|0 = Inactive, 1 = Active| |[\[dbo\].\[Flag\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/258.md)|1|![](../../../../ImagesMetro/RED_CROSS.gif "")|((1))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |rowguid|ROWGUIDCOL number uniquely identifying the record. Used to support a merge replication sample.| |uniqueidentifier|16|![](../../../../ImagesMetro/RED_CROSS.gif "")|(newid())|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |ModifiedDate|Date and time the record was last updated.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|(getdate())|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|

 Total: 16 column(s)

---
### Text column statistics
|Name |Data type |Avg. length |Min. length |Max. length |Usage rating |
|-|-|-|-|-|-|
|NationalIDNumber|nvarchar(15) |8|5|9|0.30000000000000|
|LoginID|nvarchar(256)|22|19|28|0.05468750000000|
|JobTitle|nvarchar(50) |24|5|40|0.40000000000000|
|MaritalStatus|nchar(1) |1|1|1|0.50000000000000|
|Gender|nchar(1) |1|1|1|0.50000000000000|

 Total: 5 text column(s)

---
### Indexes
|Index |Key columns |Description |Primary |Unique |Size KB |Fill factor |
|-|-|-|-|-|-|-|
|[\[PK_Employee_BusinessEntityID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1557580587_PK_Employee_BusinessEntityID.md)|BusinessEntityID|Primary key (clustered) constraint|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|192|0|
|[\[IX_Employee_OrganizationNode\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1557580587_IX_Employee_OrganizationNode.md)|OrganizationNode|Unique nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|16|0|
|[\[IX_Employee_OrganizationLevel_OrganizationNode\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1557580587_IX_Employee_OrganizationLevel_OrganizationNode.md)|OrganizationLevel, OrganizationNode|Unique nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|16|0|
|[\[AK_Employee_LoginID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1557580587_AK_Employee_LoginID.md)|LoginID|Unique nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|40|0|
|[\[AK_Employee_NationalIDNumber\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1557580587_AK_Employee_NationalIDNumber.md)|NationalIDNumber|Unique nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|32|0|
|[\[AK_Employee_rowguid\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1557580587_AK_Employee_rowguid.md)|rowguid|Unique nonclustered index. Used to support replication samples.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|16|0|

 Total: 6 Index/indexes

---
### Columnstore indexes
 No columnstore indexes exist

---
### Fulltext index
 No fulltext index exist

---
### Statistics
 No statistics exist

---
### Check constraints
|Name |Expression |
|-|-|
|CK_Employee_BirthDate|(\[BirthDate\]&gt;=&#39;1930-01-01&#39; AND \[BirthDate\]&lt;=dateadd(year,(-18),getdate()))|
|CK_Employee_MaritalStatus|(upper(\[MaritalStatus\])=&#39;S&#39; OR upper(\[MaritalStatus\])=&#39;M&#39;)|
|CK_Employee_HireDate|(\[HireDate\]&gt;=&#39;1996-07-01&#39; AND \[HireDate\]&lt;=dateadd(day,(1),getdate()))|
|CK_Employee_Gender|(upper(\[Gender\])=&#39;F&#39; OR upper(\[Gender\])=&#39;M&#39;)|
|CK_Employee_VacationHours|(\[VacationHours\]&gt;=(-40) AND \[VacationHours\]&lt;=(240))|
|CK_Employee_SickLeaveHours|(\[SickLeaveHours\]&gt;=(0) AND \[SickLeaveHours\]&lt;=(120))|

---
### Identity column
 No identity column exists

---
### Referencing tables
|Table |Foreign key |Primary key or unique constraint |
|-|-|-|
|[\[Purchasing\].\[PurchaseOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1266103551.md)|[FK_PurchaseOrderHeader_Employee_EmployeeID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1266103551_FK_PurchaseOrderHeader_Employee_EmployeeID.md)|[PK_Employee_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1557580587_PK_Employee_BusinessEntityID.md)|
|[\[Production\].\[Document\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1397580017.md)|[FK_Document_Employee_Owner](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1397580017_FK_Document_Employee_Owner.md)|[PK_Employee_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1557580587_PK_Employee_BusinessEntityID.md)|
|[\[HumanResources\].\[EmployeeDepartmentHistory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1765581328.md)|[FK_EmployeeDepartmentHistory_Employee_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1765581328_FK_EmployeeDepartmentHistory_Employee_BusinessEntityID.md)|[PK_Employee_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1557580587_PK_Employee_BusinessEntityID.md)|
|[\[HumanResources\].\[EmployeePayHistory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1813581499.md)|[FK_EmployeePayHistory_Employee_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1813581499_FK_EmployeePayHistory_Employee_BusinessEntityID.md)|[PK_Employee_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1557580587_PK_Employee_BusinessEntityID.md)|
|[\[Sales\].\[SalesPerson\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1874105717.md)|[FK_SalesPerson_Employee_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1874105717_FK_SalesPerson_Employee_BusinessEntityID.md)|[PK_Employee_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1557580587_PK_Employee_BusinessEntityID.md)|
|[\[HumanResources\].\[JobCandidate\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1909581841.md)|[FK_JobCandidate_Employee_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1909581841_FK_JobCandidate_Employee_BusinessEntityID.md)|[PK_Employee_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1557580587_PK_Employee_BusinessEntityID.md)|

 Total: 6 table(s)

---
### Referenced tables
|Table |Primary key or unique constraint |Foreign key |
|-|-|-|
|[\[Person\].\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|[PK_Person_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/2085582468_PK_Person_BusinessEntityID.md)|[FK_Employee_Person_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1557580587_FK_Employee_Person_BusinessEntityID.md)|

 Total: 1 table(s)

---
### Triggers
|Name |Schema |Description |Instead of |For insert |For update |For delete |Table/view |
|-|-|-|-|-|-|-|-|
|[\[HumanResources\].\[dEmployee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/861246123.md)|[\[HumanResources\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/5.md)| 
|![](../../../../ImagesMetro/CHECK_OUT.png "")| | |![For Delete](../../../../ImagesMetro/AUDIT_trigger_delete.gif "")|[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|

 Total: 1 triggers(s)

---
### Data models
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587_dm.md) to view data model

---
### Objects that depend on \[HumanResources\].\[Employee\]
|Object name|Object type|Dep level|
|-|-|-|
|[\[dbo\].\[uspGetEmployeeManagers\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1517248460.md)|Procedure|1|
|[\[dbo\].\[uspGetManagerEmployees\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1533248517.md)|Procedure|1|
|[\[HumanResources\].\[uspUpdateEmployeeHireInfo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1565248631.md)|Procedure|1|
|[\[HumanResources\].\[uspUpdateEmployeeLogin\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1581248688.md)|Procedure|1|
|[\[HumanResources\].\[uspUpdateEmployeePersonalInfo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1597248745.md)|Procedure|1|
|[\[Production\].\[Document\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1397580017.md)|Table|1|
|[\[HumanResources\].\[EmployeeDepartmentHistory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1765581328.md)|Table|1|
|[\[HumanResources\].\[EmployeePayHistory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1813581499.md)|Table|1|
|[\[HumanResources\].\[JobCandidate\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1909581841.md)|Table|1|
|[\[Purchasing\].\[PurchaseOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1266103551.md)|Table|1|
|[\[Sales\].\[SalesPerson\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1874105717.md)|Table|1|
|[\[HumanResources\].\[dEmployee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/861246123.md)|Trigger|1|
|[\[Security\].\[customerAccessPredicate\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Functions/1678629023.md)|Function|1|
|[\[dbo\].\[ufnGetContactInformation\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Functions/1373247947.md)|Function|1|
|[\[HumanResources\].\[vEmployee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1037246750.md)|View|1|
|[\[HumanResources\].\[vEmployeeDepartment\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1053246807.md)|View|1|
|[\[HumanResources\].\[vEmployeeDepartmentHistory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1069246864.md)|View|1|
|[\[Sales\].\[vSalesPerson\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1213247377.md)|View|1|
|[\[Sales\].\[vSalesPersonSalesByFiscalYears\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1229247434.md)|View|1|

 Total 19 object(s)

---
### Objects that \[HumanResources\].\[Employee\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[HumanResources\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/5.md)|Schema|1|
|[\[Person\].\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|Table|1|
|[\[dbo\].\[Flag\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/258.md)|Datatype|1|

 Total 3 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[Person\].\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|BusinessEntityID|Table|

 Total 1 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Employee information such as salary, department, and title.|

---
###  Permissions
No permissions defined

---
### Table options
|Name |Value |
|-|-|
|Pintable|OFF|
|Table lock on bulk load|OFF|
|Insert row lock|OFF|
|Text in row|0|
|Large value types out of row|OFF|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING ON
GO
CREATE TABLE [HumanResources].[Employee] (
        [BusinessEntityID]      [int] NOT NULL,
        [NationalIDNumber]      [nvarchar](15) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [LoginID]               [nvarchar](256) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [OrganizationNode]      [hierarchyid] NULL,
        [OrganizationLevel]     AS ([OrganizationNode].[GetLevel]()),
        [JobTitle]              [nvarchar](50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [BirthDate]             [date] NOT NULL,
        [MaritalStatus]         [nchar](1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [Gender]                [nchar](1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [HireDate]              [date] NOT NULL,
        [SalariedFlag]          [dbo].[Flag] NOT NULL,
        [VacationHours]         [smallint] NOT NULL,
        [SickLeaveHours]        [smallint] NOT NULL,
        [CurrentFlag]           [dbo].[Flag] NOT NULL,
        [rowguid]               [uniqueidentifier] NOT NULL ROWGUIDCOL,
        [ModifiedDate]          [datetime] NOT NULL,
        CONSTRAINT [PK_Employee_BusinessEntityID]
        PRIMARY KEY
        CLUSTERED
        ([BusinessEntityID])
    ON [PRIMARY]
) ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Clustered index created by a primary key constraint.', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'INDEX', N'PK_Employee_BusinessEntityID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key (clustered) constraint', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'CONSTRAINT', N'PK_Employee_BusinessEntityID'
GO
ALTER TABLE [HumanResources].[Employee]
    ADD
    CONSTRAINT [CK_Employee_BirthDate]
    CHECK
    ([BirthDate]&gt;='1930-01-01' AND [BirthDate]&lt;=dateadd(year,(-18),getdate()))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [BirthDate] &gt;= ''1930-01-01'' AND [BirthDate] &lt;= dateadd(year,(-18),GETDATE())', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'CONSTRAINT', N'CK_Employee_BirthDate'
GO
ALTER TABLE [HumanResources].[Employee]
CHECK CONSTRAINT [CK_Employee_BirthDate]
GO
ALTER TABLE [HumanResources].[Employee]
    ADD
    CONSTRAINT [CK_Employee_MaritalStatus]
    CHECK
    (upper([MaritalStatus])='S' OR upper([MaritalStatus])='M')
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [MaritalStatus]=''s'' OR [MaritalStatus]=''m'' OR [MaritalStatus]=''S'' OR [MaritalStatus]=''M''', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'CONSTRAINT', N'CK_Employee_MaritalStatus'
GO
ALTER TABLE [HumanResources].[Employee]
CHECK CONSTRAINT [CK_Employee_MaritalStatus]
GO
ALTER TABLE [HumanResources].[Employee]
    ADD
    CONSTRAINT [CK_Employee_HireDate]
    CHECK
    ([HireDate]&gt;='1996-07-01' AND [HireDate]&lt;=dateadd(day,(1),getdate()))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [HireDate] &gt;= ''1996-07-01'' AND [HireDate] &lt;= dateadd(day,(1),GETDATE())', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'CONSTRAINT', N'CK_Employee_HireDate'
GO
ALTER TABLE [HumanResources].[Employee]
CHECK CONSTRAINT [CK_Employee_HireDate]
GO
ALTER TABLE [HumanResources].[Employee]
    ADD
    CONSTRAINT [CK_Employee_Gender]
    CHECK
    (upper([Gender])='F' OR upper([Gender])='M')
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [Gender]=''f'' OR [Gender]=''m'' OR [Gender]=''F'' OR [Gender]=''M''', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'CONSTRAINT', N'CK_Employee_Gender'
GO
ALTER TABLE [HumanResources].[Employee]
CHECK CONSTRAINT [CK_Employee_Gender]
GO
ALTER TABLE [HumanResources].[Employee]
    ADD
    CONSTRAINT [CK_Employee_VacationHours]
    CHECK
    ([VacationHours]&gt;=(-40) AND [VacationHours]&lt;=(240))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [VacationHours] &gt;= (-40) AND [VacationHours] &lt;= (240)', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'CONSTRAINT', N'CK_Employee_VacationHours'
GO
ALTER TABLE [HumanResources].[Employee]
CHECK CONSTRAINT [CK_Employee_VacationHours]
GO
ALTER TABLE [HumanResources].[Employee]
    ADD
    CONSTRAINT [CK_Employee_SickLeaveHours]
    CHECK
    ([SickLeaveHours]&gt;=(0) AND [SickLeaveHours]&lt;=(120))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [SickLeaveHours] &gt;= (0) AND [SickLeaveHours] &lt;= (120)', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'CONSTRAINT', N'CK_Employee_SickLeaveHours'
GO
ALTER TABLE [HumanResources].[Employee]
CHECK CONSTRAINT [CK_Employee_SickLeaveHours]
GO
ALTER TABLE [HumanResources].[Employee]
    ADD
    CONSTRAINT [DF_Employee_SalariedFlag]
    DEFAULT ((1)) FOR [SalariedFlag]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of 1 (TRUE)', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'CONSTRAINT', N'DF_Employee_SalariedFlag'
GO
ALTER TABLE [HumanResources].[Employee]
    ADD
    CONSTRAINT [DF_Employee_VacationHours]
    DEFAULT ((0)) FOR [VacationHours]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of 0', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'CONSTRAINT', N'DF_Employee_VacationHours'
GO
ALTER TABLE [HumanResources].[Employee]
    ADD
    CONSTRAINT [DF_Employee_SickLeaveHours]
    DEFAULT ((0)) FOR [SickLeaveHours]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of 0', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'CONSTRAINT', N'DF_Employee_SickLeaveHours'
GO
ALTER TABLE [HumanResources].[Employee]
    ADD
    CONSTRAINT [DF_Employee_CurrentFlag]
    DEFAULT ((1)) FOR [CurrentFlag]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of 1', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'CONSTRAINT', N'DF_Employee_CurrentFlag'
GO
ALTER TABLE [HumanResources].[Employee]
    ADD
    CONSTRAINT [DF_Employee_rowguid]
    DEFAULT (newid()) FOR [rowguid]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of NEWID()', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'CONSTRAINT', N'DF_Employee_rowguid'
GO
ALTER TABLE [HumanResources].[Employee]
    ADD
    CONSTRAINT [DF_Employee_ModifiedDate]
    DEFAULT (getdate()) FOR [ModifiedDate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of GETDATE()', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'CONSTRAINT', N'DF_Employee_ModifiedDate'
GO
ALTER TABLE [HumanResources].[Employee]
    WITH CHECK
    ADD CONSTRAINT [FK_Employee_Person_BusinessEntityID]
    FOREIGN KEY ([BusinessEntityID]) REFERENCES [Person].[Person] ([BusinessEntityID])
ALTER TABLE [HumanResources].[Employee]
    CHECK CONSTRAINT [FK_Employee_Person_BusinessEntityID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing Person.BusinessEntityID.', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'CONSTRAINT', N'FK_Employee_Person_BusinessEntityID'
GO
CREATE NONCLUSTERED INDEX [IX_Employee_OrganizationNode]
    ON [HumanResources].[Employee] ([OrganizationNode])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique nonclustered index.', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'INDEX', N'IX_Employee_OrganizationNode'
GO
CREATE NONCLUSTERED INDEX [IX_Employee_OrganizationLevel_OrganizationNode]
    ON [HumanResources].[Employee] ([OrganizationLevel], [OrganizationNode])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique nonclustered index.', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'INDEX', N'IX_Employee_OrganizationLevel_OrganizationNode'
GO
CREATE UNIQUE NONCLUSTERED INDEX [AK_Employee_LoginID]
    ON [HumanResources].[Employee] ([LoginID])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique nonclustered index.', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'INDEX', N'AK_Employee_LoginID'
GO
CREATE UNIQUE NONCLUSTERED INDEX [AK_Employee_NationalIDNumber]
    ON [HumanResources].[Employee] ([NationalIDNumber])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique nonclustered index.', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'INDEX', N'AK_Employee_NationalIDNumber'
GO
CREATE UNIQUE NONCLUSTERED INDEX [AK_Employee_rowguid]
    ON [HumanResources].[Employee] ([rowguid])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique nonclustered index. Used to support replication samples.', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'INDEX', N'AK_Employee_rowguid'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Employee information such as salary, department, and title.', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', NULL, NULL
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key for Employee records.  Foreign key to BusinessEntity.BusinessEntityID.', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'COLUMN', N'BusinessEntityID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique national identification number such as a social security number.', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'COLUMN', N'NationalIDNumber'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Network login.', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'COLUMN', N'LoginID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Where the employee is located in corporate hierarchy.', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'COLUMN', N'OrganizationNode'
GO
EXEC sp_addextendedproperty N'MS_Description', N'The depth of the employee in the corporate hierarchy.', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'COLUMN', N'OrganizationLevel'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Work title such as Buyer or Sales Representative.', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'COLUMN', N'JobTitle'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date of birth.', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'COLUMN', N'BirthDate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'M = Married, S = Single', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'COLUMN', N'MaritalStatus'
GO
EXEC sp_addextendedproperty N'MS_Description', N'M = Male, F = Female', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'COLUMN', N'Gender'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Employee hired on this date.', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'COLUMN', N'HireDate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Job classification. 0 = Hourly, not exempt from collective bargaining. 1 = Salaried, exempt from collective bargaining.', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'COLUMN', N'SalariedFlag'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Number of available vacation hours.', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'COLUMN', N'VacationHours'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Number of available sick leave hours.', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'COLUMN', N'SickLeaveHours'
GO
EXEC sp_addextendedproperty N'MS_Description', N'0 = Inactive, 1 = Active', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'COLUMN', N'CurrentFlag'
GO
EXEC sp_addextendedproperty N'MS_Description', N'ROWGUIDCOL number uniquely identifying the record. Used to support a merge replication sample.', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'COLUMN', N'rowguid'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date and time the record was last updated.', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'COLUMN', N'ModifiedDate'
GO
  
~~~

---
### See also
[List of tables](../tables.md)

