## ![](../../../../Images32x32Metro/OBJECT_TABLE.png "") Table:\[AdventureWorks2016CTP3\].\[Sales\].\[SalesOrderHeader\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > **Sales.SalesOrderHeader**

---
###  Description  
 General sales order information. 



---
### Table properties
|Name |Value |
|-|-|
| Schema |[\[Sales\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md)|
| Owner |[\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md)|
| Table is replicated |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Creation date |10/23/2015|
| ID |1586104691|
| Located on |PRIMARY|
| Data size KB |5536 KB|
| Index size KB |2872 KB|
| Rows |31465   |
| ChangeTrackingEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| FileStreamFileGroup | |
| FileStreamPartitionScheme | |
| LockEscalation |TABLE|
| TrackColumnsUpdatedEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Table is filetable |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Filetable directory | |
| Filetable collate | |
| Filetable primary key |\[PK_SalesOrderHeader_SalesOrderID\]|
| Filetable streamid unique | |
| Filetable fullpath unique | |
| Filetable is enabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is memory optimized |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Durability |SCHEMA_AND_DATA|

---
### Creation options
|Name |Value |
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|
|ANSI_PADDING|ON|

---
### Columns
| | | |Name |Description |IsComputed|Data type |Max length |Nullable |Default|IsGUID |SPARSE|Computed value|
|-|-|-|-|-|-|-|-|-|-|-|-|-|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|![Identity](../../../../ImagesMetro/FILTER_Identity.gif "")| |SalesOrderID|Primary key.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |RevisionNumber|Incremental number to track changes to the sales order over time.| |tinyint|1|![](../../../../ImagesMetro/RED_CROSS.gif "")|((0))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |OrderDate|Dates the sales order was created.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|(getdate())|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |DueDate|Date the order is due to the customer.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |ShipDate|Date the order was shipped to the customer.| |datetime|8|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |Status|Order current status. 1 = In process; 2 = Approved; 3 = Backordered; 4 = Rejected; 5 = Shipped; 6 = Cancelled| |tinyint|1|![](../../../../ImagesMetro/RED_CROSS.gif "")|((1))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |OnlineOrderFlag|0 = Order placed by sales person. 1 = Order placed online by customer.| |[\[dbo\].\[Flag\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/258.md)|1|![](../../../../ImagesMetro/RED_CROSS.gif "")|((1))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |SalesOrderNumber|Unique sales order identification number.|True|nvarchar|25|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|(isnull(N'SO'+CONVERT(\[nvarchar\](23),\[SalesOrderID\]),N'*** ERROR ***'))|
| | | |PurchaseOrderNumber|Customer purchase order number reference. | |[\[dbo\].\[OrderNumber\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/261.md)|25|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |AccountNumber|Financial accounting number reference.| |[\[dbo\].\[AccountNumber\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/257.md)|15|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1586104691_FK_SalesOrderHeader_Customer_CustomerID.md)|CustomerID|Customer identification number. Foreign key to Customer.BusinessEntityID.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1586104691_FK_SalesOrderHeader_SalesPerson_SalesPersonID.md)|SalesPersonID|Sales person who created the sales order. Foreign key to SalesPerson.BusinessEntityID.| |int|4|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1586104691_FK_SalesOrderHeader_SalesTerritory_TerritoryID.md)|TerritoryID|Territory in which the sale was made. Foreign key to SalesTerritory.SalesTerritoryID.| |int|4|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1586104691_FK_SalesOrderHeader_Address_BillToAddressID.md)|BillToAddressID|Customer billing address. Foreign key to Address.AddressID.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1586104691_FK_SalesOrderHeader_Address_ShipToAddressID.md)|ShipToAddressID|Customer shipping address. Foreign key to Address.AddressID.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1586104691_FK_SalesOrderHeader_ShipMethod_ShipMethodID.md)|ShipMethodID|Shipping method. Foreign key to ShipMethod.ShipMethodID.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1586104691_FK_SalesOrderHeader_CreditCard_CreditCardID.md)|CreditCardID|Credit card identification number. Foreign key to CreditCard.CreditCardID.| |int|4|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |CreditCardApprovalCode|Approval code provided by the credit card company.| |varchar|15|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1586104691_FK_SalesOrderHeader_CurrencyRate_CurrencyRateID.md)|CurrencyRateID|Currency exchange rate used. Foreign key to CurrencyRate.CurrencyRateID.| |int|4|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |SubTotal|Sales subtotal. Computed as SUM(SalesOrderDetail.LineTotal)for the appropriate SalesOrderID.| |money|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|((0.00))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |TaxAmt|Tax amount.| |money|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|((0.00))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |Freight|Shipping cost.| |money|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|((0.00))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |TotalDue|Total due from customer. Computed as Subtotal + TaxAmt + Freight.|True|money|8|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|(isnull((\[SubTotal\]+\[TaxAmt\])+\[Freight\],(0)))|
| | | |Comment|Sales representative comments.| |nvarchar|128|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |rowguid|ROWGUIDCOL number uniquely identifying the record. Used to support a merge replication sample.| |uniqueidentifier|16|![](../../../../ImagesMetro/RED_CROSS.gif "")|(newid())|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |ModifiedDate|Date and time the record was last updated.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|(getdate())|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|

 Total: 26 column(s)

---
### Text column statistics
|Name |Data type |Avg. length |Min. length |Max. length |Usage rating |
|-|-|-|-|-|-|
|SalesOrderNumber|nvarchar(25) |7|7|7|0.14000000000000|
|PurchaseOrderNumber|nvarchar(25) |1|10|13|0.26000000000000|
|AccountNumber|nvarchar(15) |14|14|14|0.46666666666666|
|CreditCardApprovalCode|varchar(15)  |12|9|15|1.00000000000000|
|Comment|nvarchar(128)|0|0|0|0|

 Total: 5 text column(s)

---
### Indexes
|Index |Key columns |Description |Primary |Unique |Size KB |Fill factor |
|-|-|-|-|-|-|-|
|[\[PK_SalesOrderHeader_SalesOrderID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1586104691_PK_SalesOrderHeader_SalesOrderID.md)|SalesOrderID|Primary key (clustered) constraint|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|8408|0|
|[\[AK_SalesOrderHeader_rowguid\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1586104691_AK_SalesOrderHeader_rowguid.md)|rowguid|Unique nonclustered index. Used to support replication samples.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|832|0|
|[\[AK_SalesOrderHeader_SalesOrderNumber\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1586104691_AK_SalesOrderHeader_SalesOrderNumber.md)|SalesOrderNumber|Unique nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|888|0|
|[\[IX_SalesOrderHeader_CustomerID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1586104691_IX_SalesOrderHeader_CustomerID.md)|CustomerID|Nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|456|0|
|[\[IX_SalesOrderHeader_SalesPersonID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1586104691_IX_SalesOrderHeader_SalesPersonID.md)|SalesPersonID|Nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|456|0|

 Total: 5 Index/indexes

---
### Columnstore indexes
 No columnstore indexes exist

---
### Fulltext index
 No fulltext index exist

---
### Statistics
 No statistics exist

---
### Check constraints
|Name |Expression |
|-|-|
|CK_SalesOrderHeader_Status|(\[Status\]&gt;=(0) AND \[Status\]&lt;=(8))|
|CK_SalesOrderHeader_DueDate|(\[DueDate\]&gt;=\[OrderDate\])|
|CK_SalesOrderHeader_ShipDate|(\[ShipDate\]&gt;=\[OrderDate\] OR \[ShipDate\] IS NULL)|
|CK_SalesOrderHeader_SubTotal|(\[SubTotal\]&gt;=(0.00))|
|CK_SalesOrderHeader_TaxAmt|(\[TaxAmt\]&gt;=(0.00))|
|CK_SalesOrderHeader_Freight|(\[Freight\]&gt;=(0.00))|

---
### Identity column
| |Name |Seed |Increment |Not for replication |
|-|-|-|-|-|
|![](../../../../ImagesMetro/FILTER_Identity.gif "")| SalesOrderID | 1 | 1 |![](../../../../ImagesMetro/CHECK_OUT.png "")|

---
### Referencing tables
|Table |Foreign key |Primary key or unique constraint |
|-|-|-|
|[\[Sales\].\[SalesOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1474104292.md)|[FK_SalesOrderDetail_SalesOrderHeader_SalesOrderID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1474104292_FK_SalesOrderDetail_SalesOrderHeader_SalesOrderID.md)|[PK_SalesOrderHeader_SalesOrderID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1586104691_PK_SalesOrderHeader_SalesOrderID.md)|
|[\[Sales\].\[SalesOrderHeaderSalesReason\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1842105603.md)|[FK_SalesOrderHeaderSalesReason_SalesOrderHeader_SalesOrderID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1842105603_FK_SalesOrderHeaderSalesReason_SalesOrderHeader_SalesOrderID.md)|[PK_SalesOrderHeader_SalesOrderID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1586104691_PK_SalesOrderHeader_SalesOrderID.md)|

 Total: 2 table(s)

---
### Referenced tables
|Table |Primary key or unique constraint |Foreign key |
|-|-|-|
|[\[Person\].\[Address\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/693577509.md)|[PK_Address_AddressID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/693577509_PK_Address_AddressID.md)|[FK_SalesOrderHeader_Address_BillToAddressID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1586104691_FK_SalesOrderHeader_Address_BillToAddressID.md)|
|[\[Person\].\[Address\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/693577509.md)|[PK_Address_AddressID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/693577509_PK_Address_AddressID.md)|[FK_SalesOrderHeader_Address_ShipToAddressID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1586104691_FK_SalesOrderHeader_Address_ShipToAddressID.md)|
|[\[Sales\].\[CreditCard\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1189579276.md)|[PK_CreditCard_CreditCardID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1189579276_PK_CreditCard_CreditCardID.md)|[FK_SalesOrderHeader_CreditCard_CreditCardID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1586104691_FK_SalesOrderHeader_CreditCard_CreditCardID.md)|
|[\[Sales\].\[CurrencyRate\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1285579618.md)|[PK_CurrencyRate_CurrencyRateID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1285579618_PK_CurrencyRate_CurrencyRateID.md)|[FK_SalesOrderHeader_CurrencyRate_CurrencyRateID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1586104691_FK_SalesOrderHeader_CurrencyRate_CurrencyRateID.md)|
|[\[Sales\].\[Customer\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1317579732.md)|[PK_Customer_CustomerID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1317579732_PK_Customer_CustomerID.md)|[FK_SalesOrderHeader_Customer_CustomerID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1586104691_FK_SalesOrderHeader_Customer_CustomerID.md)|
|[\[Sales\].\[SalesPerson\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1874105717.md)|[PK_SalesPerson_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1874105717_PK_SalesPerson_BusinessEntityID.md)|[FK_SalesOrderHeader_SalesPerson_SalesPersonID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1586104691_FK_SalesOrderHeader_SalesPerson_SalesPersonID.md)|
|[\[Purchasing\].\[ShipMethod\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/398624463.md)|[PK_ShipMethod_ShipMethodID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/398624463_PK_ShipMethod_ShipMethodID.md)|[FK_SalesOrderHeader_ShipMethod_ShipMethodID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1586104691_FK_SalesOrderHeader_ShipMethod_ShipMethodID.md)|
|[\[Sales\].\[SalesTerritory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/94623380.md)|[PK_SalesTerritory_TerritoryID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/94623380_PK_SalesTerritory_TerritoryID.md)|[FK_SalesOrderHeader_SalesTerritory_TerritoryID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1586104691_FK_SalesOrderHeader_SalesTerritory_TerritoryID.md)|

 Total: 8 table(s)

---
### Triggers
|Name |Schema |Description |Instead of |For insert |For update |For delete |Table/view |
|-|-|-|-|-|-|-|-|
|[\[Sales\].\[uSalesOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/957246465.md)|[\[Sales\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md)| 
|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![For Update](../../../../ImagesMetro/AUDIT_trigger_update.gif "")| |[\[Sales\].\[SalesOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691.md)|

 Total: 1 triggers(s)

---
### Data models
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691_dm.md) to view data model

---
### Objects that depend on \[Sales\].\[SalesOrderHeader\]
|Object name|Object type|Dep level|
|-|-|-|
|[\[Demo\].\[usp_DemoReset\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1636200879.md)|Procedure|1|
|[\[Sales\].\[SalesOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1474104292.md)|Table|1|
|[\[Sales\].\[SalesOrderHeaderSalesReason\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1842105603.md)|Table|1|
|[\[Sales\].\[iduSalesOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/941246408.md)|Trigger|1|
|[\[Sales\].\[uSalesOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/957246465.md)|Trigger|1|
|[\[Sales\].\[vSalesPersonSalesByFiscalYears\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1229247434.md)|View|1|

 Total 6 object(s)

---
### Objects that \[Sales\].\[SalesOrderHeader\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Sales\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md)|Schema|1|
|[\[Person\].\[Address\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/693577509.md)|Table|1|
|[\[Sales\].\[CreditCard\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1189579276.md)|Table|1|
|[\[Sales\].\[CurrencyRate\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1285579618.md)|Table|1|
|[\[Sales\].\[Customer\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1317579732.md)|Table|1|
|[\[Sales\].\[SalesPerson\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1874105717.md)|Table|1|
|[\[Sales\].\[SalesTerritory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/94623380.md)|Table|1|
|[\[Purchasing\].\[ShipMethod\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/398624463.md)|Table|1|
|[\[dbo\].\[AccountNumber\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/257.md)|Datatype|1|
|[\[dbo\].\[Flag\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/258.md)|Datatype|1|
|[\[dbo\].\[OrderNumber\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/261.md)|Datatype|1|

 Total 11 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[Person\].\[Address\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/693577509.md)|AddressID|Table|
|[\[Sales\].\[CreditCard\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1189579276.md)|CreditCardID|Table|
|[\[Sales\].\[CurrencyRate\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1285579618.md)|CurrencyRateID|Table|
|[\[Sales\].\[Customer\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1317579732.md)|CustomerID|Table|
|[\[Sales\].\[SalesPerson\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1874105717.md)|BusinessEntityID|Table|
|[\[Purchasing\].\[ShipMethod\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/398624463.md)|ShipMethodID|Table|
|[\[Sales\].\[SalesTerritory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/94623380.md)|TerritoryID|Table|

 Total 7 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|General sales order information.|

---
###  Permissions
No permissions defined

---
### Table options
|Name |Value |
|-|-|
|Pintable|OFF|
|Table lock on bulk load|OFF|
|Insert row lock|OFF|
|Text in row|0|
|Large value types out of row|OFF|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING ON
GO
CREATE TABLE [Sales].[SalesOrderHeader] (
        [SalesOrderID]               [int] IDENTITY(1, 1) NOT FOR REPLICATION NOT NULL,
        [RevisionNumber]             [tinyint] NOT NULL,
        [OrderDate]                  [datetime] NOT NULL,
        [DueDate]                    [datetime] NOT NULL,
        [ShipDate]                   [datetime] NULL,
        [Status]                     [tinyint] NOT NULL,
        [OnlineOrderFlag]            [dbo].[Flag] NOT NULL,
        [SalesOrderNumber]           AS (isnull(N'SO'+CONVERT([nvarchar](23),[SalesOrderID]),N'*** ERROR ***')),
        [PurchaseOrderNumber]        [dbo].[OrderNumber] NULL,
        [AccountNumber]              [dbo].[AccountNumber] NULL,
        [CustomerID]                 [int] NOT NULL,
        [SalesPersonID]              [int] NULL,
        [TerritoryID]                [int] NULL,
        [BillToAddressID]            [int] NOT NULL,
        [ShipToAddressID]            [int] NOT NULL,
        [ShipMethodID]               [int] NOT NULL,
        [CreditCardID]               [int] NULL,
        [CreditCardApprovalCode]     [varchar](15) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        [CurrencyRateID]             [int] NULL,
        [SubTotal]                   [money] NOT NULL,
        [TaxAmt]                     [money] NOT NULL,
        [Freight]                    [money] NOT NULL,
        [TotalDue]                   AS (isnull(([SubTotal]+[TaxAmt])+[Freight],(0))),
        [Comment]                    [nvarchar](128) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        [rowguid]                    [uniqueidentifier] NOT NULL ROWGUIDCOL,
        [ModifiedDate]               [datetime] NOT NULL,
        CONSTRAINT [PK_SalesOrderHeader_SalesOrderID]
        PRIMARY KEY
        CLUSTERED
        ([SalesOrderID])
    ON [PRIMARY]
) ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Clustered index created by a primary key constraint.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'INDEX', N'PK_SalesOrderHeader_SalesOrderID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key (clustered) constraint', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'CONSTRAINT', N'PK_SalesOrderHeader_SalesOrderID'
GO
ALTER TABLE [Sales].[SalesOrderHeader]
    ADD
    CONSTRAINT [CK_SalesOrderHeader_Status]
    CHECK
    ([Status]&gt;=(0) AND [Status]&lt;=(8))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [Status] BETWEEN (0) AND (8)', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'CONSTRAINT', N'CK_SalesOrderHeader_Status'
GO
ALTER TABLE [Sales].[SalesOrderHeader]
CHECK CONSTRAINT [CK_SalesOrderHeader_Status]
GO
ALTER TABLE [Sales].[SalesOrderHeader]
    ADD
    CONSTRAINT [CK_SalesOrderHeader_DueDate]
    CHECK
    ([DueDate]&gt;=[OrderDate])
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [DueDate] &gt;= [OrderDate]', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'CONSTRAINT', N'CK_SalesOrderHeader_DueDate'
GO
ALTER TABLE [Sales].[SalesOrderHeader]
CHECK CONSTRAINT [CK_SalesOrderHeader_DueDate]
GO
ALTER TABLE [Sales].[SalesOrderHeader]
    ADD
    CONSTRAINT [CK_SalesOrderHeader_ShipDate]
    CHECK
    ([ShipDate]&gt;=[OrderDate] OR [ShipDate] IS NULL)
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [ShipDate] &gt;= [OrderDate] OR [ShipDate] IS NULL', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'CONSTRAINT', N'CK_SalesOrderHeader_ShipDate'
GO
ALTER TABLE [Sales].[SalesOrderHeader]
CHECK CONSTRAINT [CK_SalesOrderHeader_ShipDate]
GO
ALTER TABLE [Sales].[SalesOrderHeader]
    ADD
    CONSTRAINT [CK_SalesOrderHeader_SubTotal]
    CHECK
    ([SubTotal]&gt;=(0.00))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [SubTotal] &gt;= (0.00)', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'CONSTRAINT', N'CK_SalesOrderHeader_SubTotal'
GO
ALTER TABLE [Sales].[SalesOrderHeader]
CHECK CONSTRAINT [CK_SalesOrderHeader_SubTotal]
GO
ALTER TABLE [Sales].[SalesOrderHeader]
    ADD
    CONSTRAINT [CK_SalesOrderHeader_TaxAmt]
    CHECK
    ([TaxAmt]&gt;=(0.00))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [TaxAmt] &gt;= (0.00)', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'CONSTRAINT', N'CK_SalesOrderHeader_TaxAmt'
GO
ALTER TABLE [Sales].[SalesOrderHeader]
CHECK CONSTRAINT [CK_SalesOrderHeader_TaxAmt]
GO
ALTER TABLE [Sales].[SalesOrderHeader]
    ADD
    CONSTRAINT [CK_SalesOrderHeader_Freight]
    CHECK
    ([Freight]&gt;=(0.00))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [Freight] &gt;= (0.00)', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'CONSTRAINT', N'CK_SalesOrderHeader_Freight'
GO
ALTER TABLE [Sales].[SalesOrderHeader]
CHECK CONSTRAINT [CK_SalesOrderHeader_Freight]
GO
ALTER TABLE [Sales].[SalesOrderHeader]
    ADD
    CONSTRAINT [DF_SalesOrderHeader_RevisionNumber]
    DEFAULT ((0)) FOR [RevisionNumber]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of 0', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'CONSTRAINT', N'DF_SalesOrderHeader_RevisionNumber'
GO
ALTER TABLE [Sales].[SalesOrderHeader]
    ADD
    CONSTRAINT [DF_SalesOrderHeader_OrderDate]
    DEFAULT (getdate()) FOR [OrderDate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of GETDATE()', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'CONSTRAINT', N'DF_SalesOrderHeader_OrderDate'
GO
ALTER TABLE [Sales].[SalesOrderHeader]
    ADD
    CONSTRAINT [DF_SalesOrderHeader_Status]
    DEFAULT ((1)) FOR [Status]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of 1', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'CONSTRAINT', N'DF_SalesOrderHeader_Status'
GO
ALTER TABLE [Sales].[SalesOrderHeader]
    ADD
    CONSTRAINT [DF_SalesOrderHeader_OnlineOrderFlag]
    DEFAULT ((1)) FOR [OnlineOrderFlag]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of 1 (TRUE)', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'CONSTRAINT', N'DF_SalesOrderHeader_OnlineOrderFlag'
GO
ALTER TABLE [Sales].[SalesOrderHeader]
    ADD
    CONSTRAINT [DF_SalesOrderHeader_SubTotal]
    DEFAULT ((0.00)) FOR [SubTotal]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of 0.0', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'CONSTRAINT', N'DF_SalesOrderHeader_SubTotal'
GO
ALTER TABLE [Sales].[SalesOrderHeader]
    ADD
    CONSTRAINT [DF_SalesOrderHeader_TaxAmt]
    DEFAULT ((0.00)) FOR [TaxAmt]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of 0.0', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'CONSTRAINT', N'DF_SalesOrderHeader_TaxAmt'
GO
ALTER TABLE [Sales].[SalesOrderHeader]
    ADD
    CONSTRAINT [DF_SalesOrderHeader_Freight]
    DEFAULT ((0.00)) FOR [Freight]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of 0.0', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'CONSTRAINT', N'DF_SalesOrderHeader_Freight'
GO
ALTER TABLE [Sales].[SalesOrderHeader]
    ADD
    CONSTRAINT [DF_SalesOrderHeader_rowguid]
    DEFAULT (newid()) FOR [rowguid]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of NEWID()', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'CONSTRAINT', N'DF_SalesOrderHeader_rowguid'
GO
ALTER TABLE [Sales].[SalesOrderHeader]
    ADD
    CONSTRAINT [DF_SalesOrderHeader_ModifiedDate]
    DEFAULT (getdate()) FOR [ModifiedDate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of GETDATE()', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'CONSTRAINT', N'DF_SalesOrderHeader_ModifiedDate'
GO
ALTER TABLE [Sales].[SalesOrderHeader]
    WITH CHECK
    ADD CONSTRAINT [FK_SalesOrderHeader_Address_BillToAddressID]
    FOREIGN KEY ([BillToAddressID]) REFERENCES [Person].[Address] ([AddressID])
ALTER TABLE [Sales].[SalesOrderHeader]
    CHECK CONSTRAINT [FK_SalesOrderHeader_Address_BillToAddressID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing Address.AddressID.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'CONSTRAINT', N'FK_SalesOrderHeader_Address_BillToAddressID'
GO
ALTER TABLE [Sales].[SalesOrderHeader]
    WITH CHECK
    ADD CONSTRAINT [FK_SalesOrderHeader_Address_ShipToAddressID]
    FOREIGN KEY ([ShipToAddressID]) REFERENCES [Person].[Address] ([AddressID])
ALTER TABLE [Sales].[SalesOrderHeader]
    CHECK CONSTRAINT [FK_SalesOrderHeader_Address_ShipToAddressID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing Address.AddressID.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'CONSTRAINT', N'FK_SalesOrderHeader_Address_ShipToAddressID'
GO
ALTER TABLE [Sales].[SalesOrderHeader]
    WITH CHECK
    ADD CONSTRAINT [FK_SalesOrderHeader_CreditCard_CreditCardID]
    FOREIGN KEY ([CreditCardID]) REFERENCES [Sales].[CreditCard] ([CreditCardID])
ALTER TABLE [Sales].[SalesOrderHeader]
    CHECK CONSTRAINT [FK_SalesOrderHeader_CreditCard_CreditCardID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing CreditCard.CreditCardID.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'CONSTRAINT', N'FK_SalesOrderHeader_CreditCard_CreditCardID'
GO
ALTER TABLE [Sales].[SalesOrderHeader]
    WITH CHECK
    ADD CONSTRAINT [FK_SalesOrderHeader_CurrencyRate_CurrencyRateID]
    FOREIGN KEY ([CurrencyRateID]) REFERENCES [Sales].[CurrencyRate] ([CurrencyRateID])
ALTER TABLE [Sales].[SalesOrderHeader]
    CHECK CONSTRAINT [FK_SalesOrderHeader_CurrencyRate_CurrencyRateID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing CurrencyRate.CurrencyRateID.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'CONSTRAINT', N'FK_SalesOrderHeader_CurrencyRate_CurrencyRateID'
GO
ALTER TABLE [Sales].[SalesOrderHeader]
    WITH CHECK
    ADD CONSTRAINT [FK_SalesOrderHeader_Customer_CustomerID]
    FOREIGN KEY ([CustomerID]) REFERENCES [Sales].[Customer] ([CustomerID])
ALTER TABLE [Sales].[SalesOrderHeader]
    CHECK CONSTRAINT [FK_SalesOrderHeader_Customer_CustomerID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing Customer.CustomerID.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'CONSTRAINT', N'FK_SalesOrderHeader_Customer_CustomerID'
GO
ALTER TABLE [Sales].[SalesOrderHeader]
    WITH CHECK
    ADD CONSTRAINT [FK_SalesOrderHeader_SalesPerson_SalesPersonID]
    FOREIGN KEY ([SalesPersonID]) REFERENCES [Sales].[SalesPerson] ([BusinessEntityID])
ALTER TABLE [Sales].[SalesOrderHeader]
    CHECK CONSTRAINT [FK_SalesOrderHeader_SalesPerson_SalesPersonID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing SalesPerson.SalesPersonID.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'CONSTRAINT', N'FK_SalesOrderHeader_SalesPerson_SalesPersonID'
GO
ALTER TABLE [Sales].[SalesOrderHeader]
    WITH CHECK
    ADD CONSTRAINT [FK_SalesOrderHeader_ShipMethod_ShipMethodID]
    FOREIGN KEY ([ShipMethodID]) REFERENCES [Purchasing].[ShipMethod] ([ShipMethodID])
ALTER TABLE [Sales].[SalesOrderHeader]
    CHECK CONSTRAINT [FK_SalesOrderHeader_ShipMethod_ShipMethodID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing ShipMethod.ShipMethodID.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'CONSTRAINT', N'FK_SalesOrderHeader_ShipMethod_ShipMethodID'
GO
ALTER TABLE [Sales].[SalesOrderHeader]
    WITH CHECK
    ADD CONSTRAINT [FK_SalesOrderHeader_SalesTerritory_TerritoryID]
    FOREIGN KEY ([TerritoryID]) REFERENCES [Sales].[SalesTerritory] ([TerritoryID])
ALTER TABLE [Sales].[SalesOrderHeader]
    CHECK CONSTRAINT [FK_SalesOrderHeader_SalesTerritory_TerritoryID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing SalesTerritory.TerritoryID.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'CONSTRAINT', N'FK_SalesOrderHeader_SalesTerritory_TerritoryID'
GO
CREATE UNIQUE NONCLUSTERED INDEX [AK_SalesOrderHeader_rowguid]
    ON [Sales].[SalesOrderHeader] ([rowguid])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique nonclustered index. Used to support replication samples.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'INDEX', N'AK_SalesOrderHeader_rowguid'
GO
CREATE UNIQUE NONCLUSTERED INDEX [AK_SalesOrderHeader_SalesOrderNumber]
    ON [Sales].[SalesOrderHeader] ([SalesOrderNumber])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique nonclustered index.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'INDEX', N'AK_SalesOrderHeader_SalesOrderNumber'
GO
CREATE NONCLUSTERED INDEX [IX_SalesOrderHeader_CustomerID]
    ON [Sales].[SalesOrderHeader] ([CustomerID])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Nonclustered index.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'INDEX', N'IX_SalesOrderHeader_CustomerID'
GO
CREATE NONCLUSTERED INDEX [IX_SalesOrderHeader_SalesPersonID]
    ON [Sales].[SalesOrderHeader] ([SalesPersonID])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Nonclustered index.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'INDEX', N'IX_SalesOrderHeader_SalesPersonID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'General sales order information.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', NULL, NULL
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'COLUMN', N'SalesOrderID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Incremental number to track changes to the sales order over time.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'COLUMN', N'RevisionNumber'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Dates the sales order was created.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'COLUMN', N'OrderDate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date the order is due to the customer.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'COLUMN', N'DueDate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date the order was shipped to the customer.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'COLUMN', N'ShipDate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Order current status. 1 = In process; 2 = Approved; 3 = Backordered; 4 = Rejected; 5 = Shipped; 6 = Cancelled', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'COLUMN', N'Status'
GO
EXEC sp_addextendedproperty N'MS_Description', N'0 = Order placed by sales person. 1 = Order placed online by customer.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'COLUMN', N'OnlineOrderFlag'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique sales order identification number.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'COLUMN', N'SalesOrderNumber'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Customer purchase order number reference. ', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'COLUMN', N'PurchaseOrderNumber'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Financial accounting number reference.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'COLUMN', N'AccountNumber'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Customer identification number. Foreign key to Customer.BusinessEntityID.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'COLUMN', N'CustomerID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Sales person who created the sales order. Foreign key to SalesPerson.BusinessEntityID.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'COLUMN', N'SalesPersonID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Territory in which the sale was made. Foreign key to SalesTerritory.SalesTerritoryID.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'COLUMN', N'TerritoryID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Customer billing address. Foreign key to Address.AddressID.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'COLUMN', N'BillToAddressID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Customer shipping address. Foreign key to Address.AddressID.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'COLUMN', N'ShipToAddressID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Shipping method. Foreign key to ShipMethod.ShipMethodID.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'COLUMN', N'ShipMethodID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Credit card identification number. Foreign key to CreditCard.CreditCardID.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'COLUMN', N'CreditCardID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Approval code provided by the credit card company.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'COLUMN', N'CreditCardApprovalCode'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Currency exchange rate used. Foreign key to CurrencyRate.CurrencyRateID.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'COLUMN', N'CurrencyRateID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Sales subtotal. Computed as SUM(SalesOrderDetail.LineTotal)for the appropriate SalesOrderID.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'COLUMN', N'SubTotal'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Tax amount.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'COLUMN', N'TaxAmt'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Shipping cost.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'COLUMN', N'Freight'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Total due from customer. Computed as Subtotal + TaxAmt + Freight.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'COLUMN', N'TotalDue'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Sales representative comments.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'COLUMN', N'Comment'
GO
EXEC sp_addextendedproperty N'MS_Description', N'ROWGUIDCOL number uniquely identifying the record. Used to support a merge replication sample.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'COLUMN', N'rowguid'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date and time the record was last updated.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'COLUMN', N'ModifiedDate'
GO
  
~~~

---
### See also
[List of tables](../tables.md)

