## ![](../../../../Images32x32Metro/OBJECT_TABLE.png "") Table:\[AdventureWorks2016CTP3\].\[HumanResources\].\[EmployeeDepartmentHistory\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > **HumanResources.EmployeeDepartmentHistory**

---
###  Description  
 Employee department transfers. 



---
### Table properties
|Name |Value |
|-|-|
| Schema |[\[HumanResources\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/5.md)|
| Owner |[\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md)|
| Table is replicated |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Creation date |10/23/2015|
| ID |1765581328|
| Located on |PRIMARY|
| Data size KB |16 KB|
| Index size KB |48 KB|
| Rows |296 |
| ChangeTrackingEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| FileStreamFileGroup | |
| FileStreamPartitionScheme | |
| LockEscalation |TABLE|
| TrackColumnsUpdatedEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Table is filetable |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Filetable directory | |
| Filetable collate | |
| Filetable primary key |\[PK_EmployeeDepartmentHistory_BusinessEntityID_StartDate_DepartmentID\]|
| Filetable streamid unique | |
| Filetable fullpath unique | |
| Filetable is enabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is memory optimized |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Durability |SCHEMA_AND_DATA|

---
### Creation options
|Name |Value |
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|
|ANSI_PADDING|OFF|

---
### Columns
| | |Name |Description |IsComputed|Data type |Max length |Nullable |Default|IsGUID |SPARSE|Computed value|
|-|-|-|-|-|-|-|-|-|-|-|-|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1765581328_FK_EmployeeDepartmentHistory_Employee_BusinessEntityID.md)|BusinessEntityID|Employee identification number. Foreign key to Employee.BusinessEntityID.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1765581328_FK_EmployeeDepartmentHistory_Department_DepartmentID.md)|DepartmentID|Department in which the employee worked including currently. Foreign key to Department.DepartmentID.| |smallint|2|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1765581328_FK_EmployeeDepartmentHistory_Shift_ShiftID.md)|ShiftID|Identifies which 8-hour shift the employee works. Foreign key to Shift.Shift.ID.| |tinyint|1|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")| |StartDate|Date the employee started work in the department.| |date|3|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |EndDate|Date the employee left the department. NULL = Current department.| |date|3|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |ModifiedDate|Date and time the record was last updated.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|(getdate())|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|

 Total: 6 column(s)

---
### Indexes
|Index |Key columns |Description |Primary |Unique |Size KB |Fill factor |
|-|-|-|-|-|-|-|
|[\[PK_EmployeeDepartmentHistory_BusinessEntityID_StartDate_DepartmentID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1765581328_PK_EmployeeDepartmentHistory_BusinessEntityID_StartDate_DepartmentID.md)|BusinessEntityID, StartDate, DepartmentID, ShiftID|Primary key (clustered) constraint|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|64|0|
|[\[IX_EmployeeDepartmentHistory_DepartmentID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1765581328_IX_EmployeeDepartmentHistory_DepartmentID.md)|DepartmentID|Nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|16|0|
|[\[IX_EmployeeDepartmentHistory_ShiftID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1765581328_IX_EmployeeDepartmentHistory_ShiftID.md)|ShiftID|Nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|16|0|

 Total: 3 Index/indexes

---
### Columnstore indexes
 No columnstore indexes exist

---
### Fulltext index
 No fulltext index exist

---
### Statistics
 No statistics exist

---
### Check constraints
|Name |Expression |
|-|-|
|CK_EmployeeDepartmentHistory_EndDate|(\[EndDate\]&gt;=\[StartDate\] OR \[EndDate\] IS NULL)|

---
### Identity column
 No identity column exists

---
### Referencing tables
 No referencing tables exist

---
### Referenced tables
|Table |Primary key or unique constraint |Foreign key |
|-|-|-|
|[\[HumanResources\].\[Department\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1365579903.md)|[PK_Department_DepartmentID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1365579903_PK_Department_DepartmentID.md)|[FK_EmployeeDepartmentHistory_Department_DepartmentID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1765581328_FK_EmployeeDepartmentHistory_Department_DepartmentID.md)|
|[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|[PK_Employee_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1557580587_PK_Employee_BusinessEntityID.md)|[FK_EmployeeDepartmentHistory_Employee_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1765581328_FK_EmployeeDepartmentHistory_Employee_BusinessEntityID.md)|
|[\[HumanResources\].\[Shift\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/366624349.md)|[PK_Shift_ShiftID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/366624349_PK_Shift_ShiftID.md)|[FK_EmployeeDepartmentHistory_Shift_ShiftID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1765581328_FK_EmployeeDepartmentHistory_Shift_ShiftID.md)|

 Total: 3 table(s)

---
### Triggers
 No triggers exist

---
### Data models
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1765581328_dm.md) to view data model

---
### Objects that depend on \[HumanResources\].\[EmployeeDepartmentHistory\]
|Object name|Object type|Dep level|
|-|-|-|
|[\[HumanResources\].\[vEmployeeDepartment\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1053246807.md)|View|1|
|[\[HumanResources\].\[vEmployeeDepartmentHistory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1069246864.md)|View|1|

 Total 2 object(s)

---
### Objects that \[HumanResources\].\[EmployeeDepartmentHistory\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[HumanResources\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/5.md)|Schema|1|
|[\[HumanResources\].\[Department\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1365579903.md)|Table|1|
|[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|Table|1|
|[\[HumanResources\].\[Shift\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/366624349.md)|Table|1|

 Total 4 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[HumanResources\].\[Department\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1365579903.md)|DepartmentID|Table|
|[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|BusinessEntityID|Table|
|[\[HumanResources\].\[Shift\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/366624349.md)|ShiftID|Table|

 Total 3 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1765581328_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Employee department transfers.|

---
###  Permissions
No permissions defined

---
### Table options
|Name |Value |
|-|-|
|Pintable|OFF|
|Table lock on bulk load|OFF|
|Insert row lock|OFF|
|Text in row|0|
|Large value types out of row|OFF|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING OFF
GO
CREATE TABLE [HumanResources].[EmployeeDepartmentHistory] (
        [BusinessEntityID]     [int] NOT NULL,
        [DepartmentID]         [smallint] NOT NULL,
        [ShiftID]              [tinyint] NOT NULL,
        [StartDate]            [date] NOT NULL,
        [EndDate]              [date] NULL,
        [ModifiedDate]         [datetime] NOT NULL,
        CONSTRAINT [PK_EmployeeDepartmentHistory_BusinessEntityID_StartDate_DepartmentID]
        PRIMARY KEY
        CLUSTERED
        ([BusinessEntityID], [StartDate], [DepartmentID], [ShiftID])
    ON [PRIMARY]
) ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Clustered index created by a primary key constraint.', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeeDepartmentHistory', 'INDEX', N'PK_EmployeeDepartmentHistory_BusinessEntityID_StartDate_DepartmentID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key (clustered) constraint', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeeDepartmentHistory', 'CONSTRAINT', N'PK_EmployeeDepartmentHistory_BusinessEntityID_StartDate_DepartmentID'
GO
ALTER TABLE [HumanResources].[EmployeeDepartmentHistory]
    ADD
    CONSTRAINT [CK_EmployeeDepartmentHistory_EndDate]
    CHECK
    ([EndDate]&gt;=[StartDate] OR [EndDate] IS NULL)
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [EndDate] &gt;= [StartDate] OR [EndDate] IS NUL', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeeDepartmentHistory', 'CONSTRAINT', N'CK_EmployeeDepartmentHistory_EndDate'
GO
ALTER TABLE [HumanResources].[EmployeeDepartmentHistory]
CHECK CONSTRAINT [CK_EmployeeDepartmentHistory_EndDate]
GO
ALTER TABLE [HumanResources].[EmployeeDepartmentHistory]
    ADD
    CONSTRAINT [DF_EmployeeDepartmentHistory_ModifiedDate]
    DEFAULT (getdate()) FOR [ModifiedDate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of GETDATE()', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeeDepartmentHistory', 'CONSTRAINT', N'DF_EmployeeDepartmentHistory_ModifiedDate'
GO
ALTER TABLE [HumanResources].[EmployeeDepartmentHistory]
    WITH CHECK
    ADD CONSTRAINT [FK_EmployeeDepartmentHistory_Department_DepartmentID]
    FOREIGN KEY ([DepartmentID]) REFERENCES [HumanResources].[Department] ([DepartmentID])
ALTER TABLE [HumanResources].[EmployeeDepartmentHistory]
    CHECK CONSTRAINT [FK_EmployeeDepartmentHistory_Department_DepartmentID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing Department.DepartmentID.', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeeDepartmentHistory', 'CONSTRAINT', N'FK_EmployeeDepartmentHistory_Department_DepartmentID'
GO
ALTER TABLE [HumanResources].[EmployeeDepartmentHistory]
    WITH CHECK
    ADD CONSTRAINT [FK_EmployeeDepartmentHistory_Employee_BusinessEntityID]
    FOREIGN KEY ([BusinessEntityID]) REFERENCES [HumanResources].[Employee] ([BusinessEntityID])
ALTER TABLE [HumanResources].[EmployeeDepartmentHistory]
    CHECK CONSTRAINT [FK_EmployeeDepartmentHistory_Employee_BusinessEntityID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing Employee.EmployeeID.', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeeDepartmentHistory', 'CONSTRAINT', N'FK_EmployeeDepartmentHistory_Employee_BusinessEntityID'
GO
ALTER TABLE [HumanResources].[EmployeeDepartmentHistory]
    WITH CHECK
    ADD CONSTRAINT [FK_EmployeeDepartmentHistory_Shift_ShiftID]
    FOREIGN KEY ([ShiftID]) REFERENCES [HumanResources].[Shift] ([ShiftID])
ALTER TABLE [HumanResources].[EmployeeDepartmentHistory]
    CHECK CONSTRAINT [FK_EmployeeDepartmentHistory_Shift_ShiftID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing Shift.ShiftID', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeeDepartmentHistory', 'CONSTRAINT', N'FK_EmployeeDepartmentHistory_Shift_ShiftID'
GO
CREATE NONCLUSTERED INDEX [IX_EmployeeDepartmentHistory_DepartmentID]
    ON [HumanResources].[EmployeeDepartmentHistory] ([DepartmentID])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Nonclustered index.', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeeDepartmentHistory', 'INDEX', N'IX_EmployeeDepartmentHistory_DepartmentID'
GO
CREATE NONCLUSTERED INDEX [IX_EmployeeDepartmentHistory_ShiftID]
    ON [HumanResources].[EmployeeDepartmentHistory] ([ShiftID])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Nonclustered index.', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeeDepartmentHistory', 'INDEX', N'IX_EmployeeDepartmentHistory_ShiftID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Employee department transfers.', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeeDepartmentHistory', NULL, NULL
GO
EXEC sp_addextendedproperty N'MS_Description', N'Employee identification number. Foreign key to Employee.BusinessEntityID.', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeeDepartmentHistory', 'COLUMN', N'BusinessEntityID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Department in which the employee worked including currently. Foreign key to Department.DepartmentID.', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeeDepartmentHistory', 'COLUMN', N'DepartmentID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Identifies which 8-hour shift the employee works. Foreign key to Shift.Shift.ID.', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeeDepartmentHistory', 'COLUMN', N'ShiftID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date the employee started work in the department.', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeeDepartmentHistory', 'COLUMN', N'StartDate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date the employee left the department. NULL = Current department.', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeeDepartmentHistory', 'COLUMN', N'EndDate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date and time the record was last updated.', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeeDepartmentHistory', 'COLUMN', N'ModifiedDate'
GO
  
~~~

---
### See also
[List of tables](../tables.md)

