## ![](../../../../Images32x32Metro/OBJECT_TABLE.png "") Table:\[AdventureWorks2016CTP3\].\[HumanResources\].\[EmployeePayHistory\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > **HumanResources.EmployeePayHistory**

---
###  Description  
 Employee pay history. 



---
### Table properties
|Name |Value |
|-|-|
| Schema |[\[HumanResources\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/5.md)|
| Owner |[\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md)|
| Table is replicated |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Creation date |10/23/2015|
| ID |1813581499|
| Located on |PRIMARY|
| Data size KB |16 KB|
| Index size KB |16 KB|
| Rows |316 |
| ChangeTrackingEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| FileStreamFileGroup | |
| FileStreamPartitionScheme | |
| LockEscalation |TABLE|
| TrackColumnsUpdatedEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Table is filetable |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Filetable directory | |
| Filetable collate | |
| Filetable primary key |\[PK_EmployeePayHistory_BusinessEntityID_RateChangeDate\]|
| Filetable streamid unique | |
| Filetable fullpath unique | |
| Filetable is enabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is memory optimized |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Durability |SCHEMA_AND_DATA|

---
### Creation options
|Name |Value |
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|
|ANSI_PADDING|OFF|

---
### Columns
| | |Name |Description |IsComputed|Data type |Max length |Nullable |Default|IsGUID |SPARSE|Computed value|
|-|-|-|-|-|-|-|-|-|-|-|-|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1813581499_FK_EmployeePayHistory_Employee_BusinessEntityID.md)|BusinessEntityID|Employee identification number. Foreign key to Employee.BusinessEntityID.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")| |RateChangeDate|Date the change in pay is effective| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |Rate|Salary hourly rate.| |money|8|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |PayFrequency|1 = Salary received monthly, 2 = Salary received biweekly| |tinyint|1|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |ModifiedDate|Date and time the record was last updated.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|(getdate())|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|

 Total: 5 column(s)

---
### Indexes
|Index |Key columns |Description |Primary |Unique |Size KB |Fill factor |
|-|-|-|-|-|-|-|
|[\[PK_EmployeePayHistory_BusinessEntityID_RateChangeDate\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1813581499_PK_EmployeePayHistory_BusinessEntityID_RateChangeDate.md)|BusinessEntityID, RateChangeDate|Primary key (clustered) constraint|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|32|0|

 Total: 1 Index/indexes

---
### Columnstore indexes
 No columnstore indexes exist

---
### Fulltext index
 No fulltext index exist

---
### Statistics
 No statistics exist

---
### Check constraints
|Name |Expression |
|-|-|
|CK_EmployeePayHistory_PayFrequency|(\[PayFrequency\]=(2) OR \[PayFrequency\]=(1))|
|CK_EmployeePayHistory_Rate|(\[Rate\]&gt;=(6.50) AND \[Rate\]&lt;=(200.00))|

---
### Identity column
 No identity column exists

---
### Referencing tables
 No referencing tables exist

---
### Referenced tables
|Table |Primary key or unique constraint |Foreign key |
|-|-|-|
|[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|[PK_Employee_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1557580587_PK_Employee_BusinessEntityID.md)|[FK_EmployeePayHistory_Employee_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1813581499_FK_EmployeePayHistory_Employee_BusinessEntityID.md)|

 Total: 1 table(s)

---
### Triggers
 No triggers exist

---
### Data models
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1813581499_dm.md) to view data model

---
### Objects that depend on \[HumanResources\].\[EmployeePayHistory\]
|Object name|Object type|Dep level|
|-|-|-|
|[\[HumanResources\].\[uspUpdateEmployeeHireInfo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1565248631.md)|Procedure|1|

 Total 1 object(s)

---
### Objects that \[HumanResources\].\[EmployeePayHistory\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[HumanResources\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/5.md)|Schema|1|
|[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|Table|1|

 Total 2 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|BusinessEntityID|Table|

 Total 1 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1813581499_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Employee pay history.|

---
###  Permissions
No permissions defined

---
### Table options
|Name |Value |
|-|-|
|Pintable|OFF|
|Table lock on bulk load|OFF|
|Insert row lock|OFF|
|Text in row|0|
|Large value types out of row|OFF|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING OFF
GO
CREATE TABLE [HumanResources].[EmployeePayHistory] (
        [BusinessEntityID]     [int] NOT NULL,
        [RateChangeDate]       [datetime] NOT NULL,
        [Rate]                 [money] NOT NULL,
        [PayFrequency]         [tinyint] NOT NULL,
        [ModifiedDate]         [datetime] NOT NULL,
        CONSTRAINT [PK_EmployeePayHistory_BusinessEntityID_RateChangeDate]
        PRIMARY KEY
        CLUSTERED
        ([BusinessEntityID], [RateChangeDate])
    ON [PRIMARY]
) ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Clustered index created by a primary key constraint.', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeePayHistory', 'INDEX', N'PK_EmployeePayHistory_BusinessEntityID_RateChangeDate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key (clustered) constraint', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeePayHistory', 'CONSTRAINT', N'PK_EmployeePayHistory_BusinessEntityID_RateChangeDate'
GO
ALTER TABLE [HumanResources].[EmployeePayHistory]
    ADD
    CONSTRAINT [CK_EmployeePayHistory_PayFrequency]
    CHECK
    ([PayFrequency]=(2) OR [PayFrequency]=(1))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [PayFrequency]=(3) OR [PayFrequency]=(2) OR [PayFrequency]=(1)', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeePayHistory', 'CONSTRAINT', N'CK_EmployeePayHistory_PayFrequency'
GO
ALTER TABLE [HumanResources].[EmployeePayHistory]
CHECK CONSTRAINT [CK_EmployeePayHistory_PayFrequency]
GO
ALTER TABLE [HumanResources].[EmployeePayHistory]
    ADD
    CONSTRAINT [CK_EmployeePayHistory_Rate]
    CHECK
    ([Rate]&gt;=(6.50) AND [Rate]&lt;=(200.00))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [Rate] &gt;= (6.50) AND [Rate] &lt;= (200.00)', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeePayHistory', 'CONSTRAINT', N'CK_EmployeePayHistory_Rate'
GO
ALTER TABLE [HumanResources].[EmployeePayHistory]
CHECK CONSTRAINT [CK_EmployeePayHistory_Rate]
GO
ALTER TABLE [HumanResources].[EmployeePayHistory]
    ADD
    CONSTRAINT [DF_EmployeePayHistory_ModifiedDate]
    DEFAULT (getdate()) FOR [ModifiedDate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of GETDATE()', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeePayHistory', 'CONSTRAINT', N'DF_EmployeePayHistory_ModifiedDate'
GO
ALTER TABLE [HumanResources].[EmployeePayHistory]
    WITH CHECK
    ADD CONSTRAINT [FK_EmployeePayHistory_Employee_BusinessEntityID]
    FOREIGN KEY ([BusinessEntityID]) REFERENCES [HumanResources].[Employee] ([BusinessEntityID])
ALTER TABLE [HumanResources].[EmployeePayHistory]
    CHECK CONSTRAINT [FK_EmployeePayHistory_Employee_BusinessEntityID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing Employee.EmployeeID.', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeePayHistory', 'CONSTRAINT', N'FK_EmployeePayHistory_Employee_BusinessEntityID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Employee pay history.', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeePayHistory', NULL, NULL
GO
EXEC sp_addextendedproperty N'MS_Description', N'Employee identification number. Foreign key to Employee.BusinessEntityID.', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeePayHistory', 'COLUMN', N'BusinessEntityID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date the change in pay is effective', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeePayHistory', 'COLUMN', N'RateChangeDate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Salary hourly rate.', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeePayHistory', 'COLUMN', N'Rate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'1 = Salary received monthly, 2 = Salary received biweekly', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeePayHistory', 'COLUMN', N'PayFrequency'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date and time the record was last updated.', 'SCHEMA', N'HumanResources', 'TABLE', N'EmployeePayHistory', 'COLUMN', N'ModifiedDate'
GO
  
~~~

---
### See also
[List of tables](../tables.md)

