## ![](../../../../Images32x32Metro/OBJECT_TABLE.png "") Table:\[AdventureWorks2016CTP3\].\[Sales\].\[TrackingEvent\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > **Sales.TrackingEvent**

---
###  Description  
 Tracking event lookup table. 



---
### Table properties
|Name |Value |
|-|-|
| Schema |[\[Sales\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md)|
| Owner |[\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md)|
| Table is replicated |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Creation date |11/16/2015|
| ID |1965250056|
| Located on |PRIMARY|
| Data size KB |8 KB|
| Index size KB |8 KB|
| Rows |7   |
| ChangeTrackingEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| FileStreamFileGroup | |
| FileStreamPartitionScheme | |
| LockEscalation |TABLE|
| TrackColumnsUpdatedEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Table is filetable |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Filetable directory | |
| Filetable collate | |
| Filetable primary key |\[PK_TrackingEvent_TrackingEventID\]|
| Filetable streamid unique | |
| Filetable fullpath unique | |
| Filetable is enabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is memory optimized |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Durability |SCHEMA_AND_DATA|

---
### Creation options
|Name |Value |
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|
|ANSI_PADDING|ON|

---
### Columns
| | |Name |Description |IsComputed|Data type |Max length |Nullable |Default|IsGUID |SPARSE|Computed value|
|-|-|-|-|-|-|-|-|-|-|-|-|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|![Identity](../../../../ImagesMetro/FILTER_Identity.gif "")|TrackingEventID|Primary key.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |EventName|Tracking event name.| |nvarchar|255|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|

 Total: 2 column(s)

---
### Text column statistics
|Name |Data type |Avg. length |Min. length |Max. length |Usage rating |
|-|-|-|-|-|-|
|EventName|nvarchar(255)|18|10|33|0.06470588235294|

 Total: 1 text column(s)

---
### Indexes
|Index |Key columns |Description |Primary |Unique |Size KB |Fill factor |
|-|-|-|-|-|-|-|
|[\[PK_TrackingEvent_TrackingEventID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1965250056_PK_TrackingEvent_TrackingEventID.md)|TrackingEventID|Primary key (clustered) constraint|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|16|0|

 Total: 1 Index/indexes

---
### Columnstore indexes
 No columnstore indexes exist

---
### Fulltext index
 No fulltext index exist

---
### Statistics
 No statistics exist

---
### Check constraints
 No check constraints exist

---
### Identity column
| |Name |Seed |Increment |Not for replication |
|-|-|-|-|-|
|![](../../../../ImagesMetro/FILTER_Identity.gif "")| TrackingEventID | 1 | 1 |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Referencing tables
 No referencing tables exist

---
### Referenced tables
 No referenced tables exist

---
### Triggers
 No triggers exist

---
### Data models
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1965250056_dm.md) to view data model

---
### Objects that depend on \[Sales\].\[TrackingEvent\]
|Object name|Object type|Dep level|
|-|-|-|
|[\[dbo\].\[uspGetOrderTrackingBySalesOrderID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/2061250398.md)|Procedure|1|
|[\[dbo\].\[uspGetOrderTrackingByTrackingNumber\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/2045250341.md)|Procedure|1|

 Total 2 object(s)

---
### Objects that \[Sales\].\[TrackingEvent\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Sales\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md)|Schema|1|

 Total 1 object(s)

---
### Column level dependencies
 No dependencies exist

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1965250056_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Tracking event lookup table.|

---
###  Permissions
No permissions defined

---
### Table options
|Name |Value |
|-|-|
|Pintable|OFF|
|Table lock on bulk load|OFF|
|Insert row lock|OFF|
|Text in row|0|
|Large value types out of row|OFF|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING ON
GO
CREATE TABLE [Sales].[TrackingEvent] (
        [TrackingEventID]     [int] IDENTITY(1, 1) NOT NULL,
        [EventName]           [nvarchar](255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        CONSTRAINT [PK_TrackingEvent_TrackingEventID]
        PRIMARY KEY
        CLUSTERED
        ([TrackingEventID])
    ON [PRIMARY]
) ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key (clustered) constraint', 'SCHEMA', N'Sales', 'TABLE', N'TrackingEvent', 'CONSTRAINT', N'PK_TrackingEvent_TrackingEventID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Tracking event lookup table.', 'SCHEMA', N'Sales', 'TABLE', N'TrackingEvent', NULL, NULL
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key.', 'SCHEMA', N'Sales', 'TABLE', N'TrackingEvent', 'COLUMN', N'TrackingEventID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Tracking event name.', 'SCHEMA', N'Sales', 'TABLE', N'TrackingEvent', 'COLUMN', N'EventName'
GO
  
~~~

---
### See also
[List of tables](../tables.md)

