## ![](../../../../Images32x32Metro/OBJECT_TABLE.png "") Table:\[AdventureWorks2016CTP3\].\[Sales\].\[OrderTracking\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > **Sales.OrderTracking**

---
###  Description  
 Individual tracking events associated with a specific sales order. 



---
### Table properties
|Name |Value |
|-|-|
| Schema |[\[Sales\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md)|
| Owner |[\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md)|
| Table is replicated |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Creation date |11/16/2015|
| ID |1997250170|
| Located on |PRIMARY|
| Data size KB |35352 KB|
| Index size KB |19056 KB|
| Rows |188790  |
| ChangeTrackingEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| FileStreamFileGroup | |
| FileStreamPartitionScheme | |
| LockEscalation |TABLE|
| TrackColumnsUpdatedEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Table is filetable |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Filetable directory | |
| Filetable collate | |
| Filetable primary key |\[PK_OrderTracking\]|
| Filetable streamid unique | |
| Filetable fullpath unique | |
| Filetable is enabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is memory optimized |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Durability |SCHEMA_AND_DATA|

---
### Creation options
|Name |Value |
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|
|ANSI_PADDING|ON|

---
### Columns
| | |Name |Description |IsComputed|Data type |Max length |Nullable |Default|IsGUID |SPARSE|Computed value|
|-|-|-|-|-|-|-|-|-|-|-|-|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|![Identity](../../../../ImagesMetro/FILTER_Identity.gif "")|OrderTrackingID|Primary key.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |SalesOrderID|Sales order identification number.  Foreign key to SalesOrderHeader.SalesOrderID.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |CarrierTrackingNumber|Shipment tracking number supplied by the shipper.| |nvarchar|25|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |TrackingEventID|Tracking delivery event for Order shipped to customer. Foreign key to TrackingEvent.TrackingEventID.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |EventDetails|Details for a delivery tracking event.| |nvarchar|2000|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |EventDateTime|The date and time that a tracking event has occurred.| |datetime2|8|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|

 Total: 6 column(s)

---
### Text column statistics
|Name |Data type |Avg. length |Min. length |Max. length |Usage rating |
|-|-|-|-|-|-|
|CarrierTrackingNumber|nvarchar(25) |23|12|25|0.50000000000000|
|EventDetails|nvarchar(2000)   |52|42|64|0.01600000000000|

 Total: 2 text column(s)

---
### Indexes
|Index |Key columns |Description |Primary |Unique |Size KB |Fill factor |
|-|-|-|-|-|-|-|
|[\[PK_OrderTracking\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1997250170_PK_OrderTracking.md)|OrderTrackingID|Primary key (clustered) constraint|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|54408|0|
|[\[IX_OrderTracking_SalesOrderID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1997250170_IX_OrderTracking_SalesOrderID.md)|SalesOrderID| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|3504|0|
|[\[IX_OrderTracking_CarrierTrackingNumber\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1997250170_IX_OrderTracking_CarrierTrackingNumber.md)|CarrierTrackingNumber| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|15408|0|

 Total: 3 Index/indexes

---
### Columnstore indexes
 No columnstore indexes exist

---
### Fulltext index
 No fulltext index exist

---
### Statistics
 No statistics exist

---
### Check constraints
 No check constraints exist

---
### Identity column
| |Name |Seed |Increment |Not for replication |
|-|-|-|-|-|
|![](../../../../ImagesMetro/FILTER_Identity.gif "")| OrderTrackingID | 1 | 1 |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Referencing tables
 No referencing tables exist

---
### Referenced tables
 No referenced tables exist

---
### Triggers
 No triggers exist

---
### Data models
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1997250170_dm.md) to view data model

---
### Objects that depend on \[Sales\].\[OrderTracking\]
|Object name|Object type|Dep level|
|-|-|-|
|[\[dbo\].\[uspAddOrderTrackingEvent\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/2029250284.md)|Procedure|1|
|[\[dbo\].\[uspGetOrderTrackingBySalesOrderID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/2061250398.md)|Procedure|1|
|[\[dbo\].\[uspGetOrderTrackingByTrackingNumber\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/2045250341.md)|Procedure|1|

 Total 3 object(s)

---
### Objects that \[Sales\].\[OrderTracking\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Sales\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md)|Schema|1|

 Total 1 object(s)

---
### Column level dependencies
 No dependencies exist

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1997250170_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Individual tracking events associated with a specific sales order.|

---
###  Permissions
No permissions defined

---
### Table options
|Name |Value |
|-|-|
|Pintable|OFF|
|Table lock on bulk load|OFF|
|Insert row lock|OFF|
|Text in row|0|
|Large value types out of row|OFF|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING ON
GO
CREATE TABLE [Sales].[OrderTracking] (
        [OrderTrackingID]           [int] IDENTITY(1, 1) NOT NULL,
        [SalesOrderID]              [int] NOT NULL,
        [CarrierTrackingNumber]     [nvarchar](25) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        [TrackingEventID]           [int] NOT NULL,
        [EventDetails]              [nvarchar](2000) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [EventDateTime]             [datetime2](7) NOT NULL,
        CONSTRAINT [PK_OrderTracking]
        PRIMARY KEY
        CLUSTERED
        ([OrderTrackingID])
    ON [PRIMARY]
) ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key (clustered) constraint', 'SCHEMA', N'Sales', 'TABLE', N'OrderTracking', 'CONSTRAINT', N'PK_OrderTracking'
GO
CREATE NONCLUSTERED INDEX [IX_OrderTracking_SalesOrderID]
    ON [Sales].[OrderTracking] ([SalesOrderID])
    ON [PRIMARY]
GO
CREATE NONCLUSTERED INDEX [IX_OrderTracking_CarrierTrackingNumber]
    ON [Sales].[OrderTracking] ([CarrierTrackingNumber])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Individual tracking events associated with a specific sales order.', 'SCHEMA', N'Sales', 'TABLE', N'OrderTracking', NULL, NULL
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key.', 'SCHEMA', N'Sales', 'TABLE', N'OrderTracking', 'COLUMN', N'OrderTrackingID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Sales order identification number.  Foreign key to SalesOrderHeader.SalesOrderID.', 'SCHEMA', N'Sales', 'TABLE', N'OrderTracking', 'COLUMN', N'SalesOrderID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Shipment tracking number supplied by the shipper.', 'SCHEMA', N'Sales', 'TABLE', N'OrderTracking', 'COLUMN', N'CarrierTrackingNumber'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Tracking delivery event for Order shipped to customer. Foreign key to TrackingEvent.TrackingEventID.', 'SCHEMA', N'Sales', 'TABLE', N'OrderTracking', 'COLUMN', N'TrackingEventID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Details for a delivery tracking event.', 'SCHEMA', N'Sales', 'TABLE', N'OrderTracking', 'COLUMN', N'EventDetails'
GO
EXEC sp_addextendedproperty N'MS_Description', N'The date and time that a tracking event has occurred.', 'SCHEMA', N'Sales', 'TABLE', N'OrderTracking', 'COLUMN', N'EventDateTime'
GO
  
~~~

---
### See also
[List of tables](../tables.md)

