## ![](../../../../Images32x32Metro/OBJECT_TABLE.png "") Table:\[AdventureWorks2016CTP3\].\[Person\].\[Person\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > **Person.Person**

---
###  Description  
 Human beings involved with AdventureWorks: employees, customer contacts, and vendor contacts. 



---
### Table properties
|Name |Value |
|-|-|
| Schema |[\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/6.md)|
| Owner |[\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md)|
| Table is replicated |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Creation date |10/23/2015|
| ID |2085582468|
| Located on |PRIMARY|
| Data size KB |30552 KB|
| Index size KB |53896 KB|
| Rows |19972   |
| ChangeTrackingEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| FileStreamFileGroup | |
| FileStreamPartitionScheme | |
| LockEscalation |TABLE|
| TrackColumnsUpdatedEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Table is filetable |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Filetable directory | |
| Filetable collate | |
| Filetable primary key |\[PK_Person_BusinessEntityID\]|
| Filetable streamid unique | |
| Filetable fullpath unique | |
| Filetable is enabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is memory optimized |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Durability |SCHEMA_AND_DATA|

---
### Creation options
|Name |Value |
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|
|ANSI_PADDING|ON|

---
### Columns
| | |Name |Description |IsComputed|Data type |Max length |Nullable |Default|IsGUID |SPARSE|Computed value|
|-|-|-|-|-|-|-|-|-|-|-|-|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_2085582468_FK_Person_BusinessEntity_BusinessEntityID.md)|BusinessEntityID|Primary key for Person records.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |PersonType|Primary type of person: SC = Store Contact, IN = Individual (retail) customer, SP = Sales person, EM = Employee (non-sales), VC = Vendor contact, GC = General contact| |nchar|2|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |NameStyle|0 = The data in FirstName and LastName are stored in western style (first name, last name) order.  1 = Eastern style (last name, first name) order.| |[\[dbo\].\[NameStyle\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/259.md)|1|![](../../../../ImagesMetro/RED_CROSS.gif "")|((0))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |Title|A courtesy title. For example, Mr. or Ms.| |nvarchar|8|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |FirstName|First name of the person.| |[\[dbo\].\[Name\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/260.md)|50|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |MiddleName|Middle name or middle initial of the person.| |[\[dbo\].\[Name\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/260.md)|50|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |LastName|Last name of the person.| |[\[dbo\].\[Name\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/260.md)|50|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |Suffix|Surname suffix. For example, Sr. or Jr.| |nvarchar|10|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |EmailPromotion|0 = Contact does not wish to receive e-mail promotions, 1 = Contact does wish to receive e-mail promotions from AdventureWorks, 2 = Contact does wish to receive e-mail promotions from AdventureWorks and selected partners. | |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|((0))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |AdditionalContactInfo|Additional contact information about the person stored in xml format. | |xml([\[Person\].\[AdditionalContactInfoSchemaCollection\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/XMLSchemaCollections/65536.md))|2147483647|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |Demographics|Personal information such as hobbies, and income collected from online shoppers. Used for sales analysis.| |xml([\[Person\].\[IndividualSurveySchemaCollection\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/XMLSchemaCollections/65537.md))|2147483647|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |rowguid|ROWGUIDCOL number uniquely identifying the record. Used to support a merge replication sample.| |uniqueidentifier|16|![](../../../../ImagesMetro/RED_CROSS.gif "")|(newid())|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |ModifiedDate|Date and time the record was last updated.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|(getdate())|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|

 Total: 13 column(s)

---
### Text column statistics
|Name |Data type |Avg. length |Min. length |Max. length |Usage rating |
|-|-|-|-|-|-|
|PersonType|nchar(2) |2|2|2|0.50000000000000|
|Title|nvarchar(8)  |0|2|4|0.25000000000000|
|FirstName|nvarchar(50) |5|2|24|0.24000000000000|
|MiddleName|nvarchar(50) |0|1|16|0.16000000000000|
|LastName|nvarchar(50) |5|2|22|0.22000000000000|
|Suffix|nvarchar(10) |0|2|3|0.15000000000000|

 Total: 6 text column(s)

---
### Indexes
|Index |Key columns |Description |Primary |Unique |Size KB |Fill factor |
|-|-|-|-|-|-|-|
|[\[PK_Person_BusinessEntityID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/2085582468_PK_Person_BusinessEntityID.md)|BusinessEntityID|Primary key (clustered) constraint|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|32560|0|
|[\[IX_Person_LastName_FirstName_MiddleName\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/2085582468_IX_Person_LastName_FirstName_MiddleName.md)|LastName, FirstName, MiddleName| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|1128|0|
|[\[AK_Person_rowguid\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/2085582468_AK_Person_rowguid.md)|rowguid|Unique nonclustered index. Used to support replication samples.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|536|0|
|[\[PXML_Person_AddContact\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/2085582468_PXML_Person_AddContact.md)| |Primary XML index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|40|0|
|[\[PXML_Person_Demographics\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/2085582468_PXML_Person_Demographics.md)| |Primary XML index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|51768|0|
|[\[XMLPATH_Person_Demographics\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/2085582468_XMLPATH_Person_Demographics.md)| |Secondary XML index for path.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|0|0|
|[\[XMLPROPERTY_Person_Demographics\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/2085582468_XMLPROPERTY_Person_Demographics.md)| |Secondary XML index for property.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|0|0|
|[\[XMLVALUE_Person_Demographics\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/2085582468_XMLVALUE_Person_Demographics.md)| |Secondary XML index for value.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|0|0|

 Total: 8 Index/indexes

---
### Columnstore indexes
 No columnstore indexes exist

---
### Fulltext index
 No fulltext index exist

---
### Statistics
 No statistics exist

---
### Check constraints
|Name |Expression |
|-|-|
|CK_Person_EmailPromotion|(\[EmailPromotion\]&gt;=(0) AND \[EmailPromotion\]&lt;=(2))|
|CK_Person_PersonType|(\[PersonType\] IS NULL OR (upper(\[PersonType\])=&#39;GC&#39; OR upper(\[PersonType\])=&#39;SP&#39; OR upper(\[PersonType\])=&#39;EM&#39; OR upper(\[PersonType\])=&#39;IN&#39; OR upper(\[PersonType\])=&#39;VC&#39; OR upper(\[PersonType\])=&#39;SC&#39;))|

---
### Identity column
 No identity column exists

---
### Referencing tables
|Table |Foreign key |Primary key or unique constraint |
|-|-|-|
|[\[Sales\].\[PersonCreditCard\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/50099219.md)|[FK_PersonCreditCard_Person_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_50099219_FK_PersonCreditCard_Person_BusinessEntityID.md)|[PK_Person_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/2085582468_PK_Person_BusinessEntityID.md)|
|[\[Person\].\[PersonPhone\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/82099333.md)|[FK_PersonPhone_Person_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_82099333_FK_PersonPhone_Person_BusinessEntityID.md)|[PK_Person_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/2085582468_PK_Person_BusinessEntityID.md)|
|[\[Person\].\[BusinessEntityContact\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1045578763.md)|[FK_BusinessEntityContact_Person_PersonID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1045578763_FK_BusinessEntityContact_Person_PersonID.md)|[PK_Person_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/2085582468_PK_Person_BusinessEntityID.md)|
|[\[Sales\].\[Customer\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1317579732.md)|[FK_Customer_Person_PersonID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1317579732_FK_Customer_Person_PersonID.md)|[PK_Person_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/2085582468_PK_Person_BusinessEntityID.md)|
|[\[Person\].\[EmailAddress\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1509580416.md)|[FK_EmailAddress_Person_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1509580416_FK_EmailAddress_Person_BusinessEntityID.md)|[PK_Person_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/2085582468_PK_Person_BusinessEntityID.md)|
|[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|[FK_Employee_Person_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1557580587_FK_Employee_Person_BusinessEntityID.md)|[PK_Person_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/2085582468_PK_Person_BusinessEntityID.md)|
|[\[Person\].\[Password\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2037582297.md)|[FK_Password_Person_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_2037582297_FK_Password_Person_BusinessEntityID.md)|[PK_Person_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/2085582468_PK_Person_BusinessEntityID.md)|

 Total: 7 table(s)

---
### Referenced tables
|Table |Primary key or unique constraint |Foreign key |
|-|-|-|
|[\[Person\].\[BusinessEntity\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/949578421.md)|[PK_BusinessEntity_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/949578421_PK_BusinessEntity_BusinessEntityID.md)|[FK_Person_BusinessEntity_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_2085582468_FK_Person_BusinessEntity_BusinessEntityID.md)|

 Total: 1 table(s)

---
### Triggers
|Name |Schema |Description |Instead of |For insert |For update |For delete |Table/view |
|-|-|-|-|-|-|-|-|
|[\[Person\].\[iuPerson\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/877246180.md)|[\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/6.md)| 
|![](../../../../ImagesMetro/RED_CROSS.gif "")|![For Insert](../../../../ImagesMetro/AUDIT_trigger_insert.gif "")|![For Update](../../../../ImagesMetro/AUDIT_trigger_update.gif "")| |[\[Person\].\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|

 Total: 1 triggers(s)

---
### Data models
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468_dm.md) to view data model

---
### Objects that depend on \[Person\].\[Person\]
|Object name|Object type|Dep level|
|-|-|-|
|[\[dbo\].\[uspGetEmployeeManagers\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1517248460.md)|Procedure|1|
|[\[dbo\].\[uspGetManagerEmployees\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1533248517.md)|Procedure|1|
|[\[Person\].\[BusinessEntityContact\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1045578763.md)|Table|1|
|[\[Sales\].\[Customer\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1317579732.md)|Table|1|
|[\[Person\].\[EmailAddress\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1509580416.md)|Table|1|
|[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|Table|1|
|[\[Person\].\[Password\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2037582297.md)|Table|1|
|[\[Sales\].\[PersonCreditCard\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/50099219.md)|Table|1|
|[\[Person\].\[PersonPhone\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/82099333.md)|Table|1|
|[\[Sales\].\[iduSalesOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/941246408.md)|Trigger|1|
|[\[Person\].\[iuPerson\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/877246180.md)|Trigger|1|
|[\[dbo\].\[ufnGetContactInformation\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Functions/1373247947.md)|Function|1|
|[\[Person\].\[vAdditionalContactInfo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1021246693.md)|View|1|
|[\[HumanResources\].\[vEmployee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1037246750.md)|View|1|
|[\[HumanResources\].\[vEmployeeDepartment\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1053246807.md)|View|1|
|[\[HumanResources\].\[vEmployeeDepartmentHistory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1069246864.md)|View|1|
|[\[Sales\].\[vIndividualCustomer\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1085246921.md)|View|1|
|[\[Sales\].\[vPersonDemographics\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1101246978.md)|View|1|
|[\[Sales\].\[vSalesPerson\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1213247377.md)|View|1|
|[\[Sales\].\[vSalesPersonSalesByFiscalYears\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1229247434.md)|View|1|
|[\[Sales\].\[vStoreWithContacts\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1277247605.md)|View|1|
|[\[Purchasing\].\[vVendorWithContacts\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1309247719.md)|View|1|

 Total 22 object(s)

---
### Objects that \[Person\].\[Person\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/6.md)|Schema|1|
|[\[Person\].\[BusinessEntity\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/949578421.md)|Table|1|
|[\[dbo\].\[Name\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/260.md)|Datatype|1|
|[\[dbo\].\[NameStyle\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/259.md)|Datatype|1|
|[\[Person\].\[AdditionalContactInfoSchemaCollection\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/XMLSchemaCollections/65536.md)|XML Schema Collection|1|
|[\[Person\].\[IndividualSurveySchemaCollection\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/XMLSchemaCollections/65537.md)|XML Schema Collection|1|

 Total 6 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[Person\].\[BusinessEntity\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/949578421.md)|BusinessEntityID|Table|

 Total 1 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Human beings involved with AdventureWorks: employees, customer contacts, and vendor contacts.|

---
###  Permissions
No permissions defined

---
### Table options
|Name |Value |
|-|-|
|Pintable|OFF|
|Table lock on bulk load|OFF|
|Insert row lock|OFF|
|Text in row|0|
|Large value types out of row|OFF|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING ON
GO
CREATE TABLE [Person].[Person] (
        [BusinessEntityID]          [int] NOT NULL,
        [PersonType]                [nchar](2) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [NameStyle]                 [dbo].[NameStyle] NOT NULL,
        [Title]                     [nvarchar](8) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        [FirstName]                 [dbo].[Name] NOT NULL,
        [MiddleName]                [dbo].[Name] NULL,
        [LastName]                  [dbo].[Name] NOT NULL,
        [Suffix]                    [nvarchar](10) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        [EmailPromotion]            [int] NOT NULL,
        [AdditionalContactInfo]     [xml](CONTENT [Person].[AdditionalContactInfoSchemaCollection]) NULL,
        [Demographics]              [xml](CONTENT [Person].[IndividualSurveySchemaCollection]) NULL,
        [rowguid]                   [uniqueidentifier] NOT NULL ROWGUIDCOL,
        [ModifiedDate]              [datetime] NOT NULL,
        CONSTRAINT [PK_Person_BusinessEntityID]
        PRIMARY KEY
        CLUSTERED
        ([BusinessEntityID])
    ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Clustered index created by a primary key constraint.', 'SCHEMA', N'Person', 'TABLE', N'Person', 'INDEX', N'PK_Person_BusinessEntityID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key (clustered) constraint', 'SCHEMA', N'Person', 'TABLE', N'Person', 'CONSTRAINT', N'PK_Person_BusinessEntityID'
GO
ALTER TABLE [Person].[Person]
    ADD
    CONSTRAINT [CK_Person_EmailPromotion]
    CHECK
    ([EmailPromotion]&gt;=(0) AND [EmailPromotion]&lt;=(2))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [EmailPromotion] &gt;= (0) AND [EmailPromotion] &lt;= (2)', 'SCHEMA', N'Person', 'TABLE', N'Person', 'CONSTRAINT', N'CK_Person_EmailPromotion'
GO
ALTER TABLE [Person].[Person]
CHECK CONSTRAINT [CK_Person_EmailPromotion]
GO
ALTER TABLE [Person].[Person]
    ADD
    CONSTRAINT [CK_Person_PersonType]
    CHECK
    ([PersonType] IS NULL OR (upper([PersonType])='GC' OR upper([PersonType])='SP' OR upper([PersonType])='EM' OR upper([PersonType])='IN' OR upper([PersonType])='VC' OR upper([PersonType])='SC'))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [PersonType] is one of SC, VC, IN, EM or SP.', 'SCHEMA', N'Person', 'TABLE', N'Person', 'CONSTRAINT', N'CK_Person_PersonType'
GO
ALTER TABLE [Person].[Person]
CHECK CONSTRAINT [CK_Person_PersonType]
GO
ALTER TABLE [Person].[Person]
    ADD
    CONSTRAINT [DF_Person_ModifiedDate]
    DEFAULT (getdate()) FOR [ModifiedDate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of GETDATE()', 'SCHEMA', N'Person', 'TABLE', N'Person', 'CONSTRAINT', N'DF_Person_ModifiedDate'
GO
ALTER TABLE [Person].[Person]
    ADD
    CONSTRAINT [DF_Person_NameStyle]
    DEFAULT ((0)) FOR [NameStyle]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of 0', 'SCHEMA', N'Person', 'TABLE', N'Person', 'CONSTRAINT', N'DF_Person_NameStyle'
GO
ALTER TABLE [Person].[Person]
    ADD
    CONSTRAINT [DF_Person_EmailPromotion]
    DEFAULT ((0)) FOR [EmailPromotion]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of 0', 'SCHEMA', N'Person', 'TABLE', N'Person', 'CONSTRAINT', N'DF_Person_EmailPromotion'
GO
ALTER TABLE [Person].[Person]
    ADD
    CONSTRAINT [DF_Person_rowguid]
    DEFAULT (newid()) FOR [rowguid]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of NEWID()', 'SCHEMA', N'Person', 'TABLE', N'Person', 'CONSTRAINT', N'DF_Person_rowguid'
GO
ALTER TABLE [Person].[Person]
    WITH CHECK
    ADD CONSTRAINT [FK_Person_BusinessEntity_BusinessEntityID]
    FOREIGN KEY ([BusinessEntityID]) REFERENCES [Person].[BusinessEntity] ([BusinessEntityID])
ALTER TABLE [Person].[Person]
    CHECK CONSTRAINT [FK_Person_BusinessEntity_BusinessEntityID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing BusinessEntity.BusinessEntityID.', 'SCHEMA', N'Person', 'TABLE', N'Person', 'CONSTRAINT', N'FK_Person_BusinessEntity_BusinessEntityID'
GO
CREATE NONCLUSTERED INDEX [IX_Person_LastName_FirstName_MiddleName]
    ON [Person].[Person] ([LastName], [FirstName], [MiddleName])
    ON [PRIMARY]
GO
CREATE UNIQUE NONCLUSTERED INDEX [AK_Person_rowguid]
    ON [Person].[Person] ([rowguid])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique nonclustered index. Used to support replication samples.', 'SCHEMA', N'Person', 'TABLE', N'Person', 'INDEX', N'AK_Person_rowguid'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Human beings involved with AdventureWorks: employees, customer contacts, and vendor contacts.', 'SCHEMA', N'Person', 'TABLE', N'Person', NULL, NULL
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key for Person records.', 'SCHEMA', N'Person', 'TABLE', N'Person', 'COLUMN', N'BusinessEntityID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary type of person: SC = Store Contact, IN = Individual (retail) customer, SP = Sales person, EM = Employee (non-sales), VC = Vendor contact, GC = General contact', 'SCHEMA', N'Person', 'TABLE', N'Person', 'COLUMN', N'PersonType'
GO
EXEC sp_addextendedproperty N'MS_Description', N'0 = The data in FirstName and LastName are stored in western style (first name, last name) order.  1 = Eastern style (last name, first name) order.', 'SCHEMA', N'Person', 'TABLE', N'Person', 'COLUMN', N'NameStyle'
GO
EXEC sp_addextendedproperty N'MS_Description', N'A courtesy title. For example, Mr. or Ms.', 'SCHEMA', N'Person', 'TABLE', N'Person', 'COLUMN', N'Title'
GO
EXEC sp_addextendedproperty N'MS_Description', N'First name of the person.', 'SCHEMA', N'Person', 'TABLE', N'Person', 'COLUMN', N'FirstName'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Middle name or middle initial of the person.', 'SCHEMA', N'Person', 'TABLE', N'Person', 'COLUMN', N'MiddleName'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Last name of the person.', 'SCHEMA', N'Person', 'TABLE', N'Person', 'COLUMN', N'LastName'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Surname suffix. For example, Sr. or Jr.', 'SCHEMA', N'Person', 'TABLE', N'Person', 'COLUMN', N'Suffix'
GO
EXEC sp_addextendedproperty N'MS_Description', N'0 = Contact does not wish to receive e-mail promotions, 1 = Contact does wish to receive e-mail promotions from AdventureWorks, 2 = Contact does wish to receive e-mail promotions from AdventureWorks and selected partners. ', 'SCHEMA', N'Person', 'TABLE', N'Person', 'COLUMN', N'EmailPromotion'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Additional contact information about the person stored in xml format. ', 'SCHEMA', N'Person', 'TABLE', N'Person', 'COLUMN', N'AdditionalContactInfo'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Personal information such as hobbies, and income collected from online shoppers. Used for sales analysis.', 'SCHEMA', N'Person', 'TABLE', N'Person', 'COLUMN', N'Demographics'
GO
EXEC sp_addextendedproperty N'MS_Description', N'ROWGUIDCOL number uniquely identifying the record. Used to support a merge replication sample.', 'SCHEMA', N'Person', 'TABLE', N'Person', 'COLUMN', N'rowguid'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date and time the record was last updated.', 'SCHEMA', N'Person', 'TABLE', N'Person', 'COLUMN', N'ModifiedDate'
GO
SET ANSI_PADDING ON
GO
CREATE PRIMARY XML INDEX [PXML_Person_AddContact]
    ON [Person].[Person] ([AdditionalContactInfo])
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary XML index.', 'SCHEMA', N'Person', 'TABLE', N'Person', 'INDEX', N'PXML_Person_AddContact'
GO
SET ANSI_PADDING ON
GO
CREATE PRIMARY XML INDEX [PXML_Person_Demographics]
    ON [Person].[Person] ([Demographics])
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary XML index.', 'SCHEMA', N'Person', 'TABLE', N'Person', 'INDEX', N'PXML_Person_Demographics'
GO
SET ANSI_PADDING ON
GO
CREATE XML INDEX [XMLPATH_Person_Demographics]
    ON [Person].[Person] ([Demographics])
    USING XML INDEX [PXML_Person_Demographics]
    FOR PATH
GO
EXEC sp_addextendedproperty N'MS_Description', N'Secondary XML index for path.', 'SCHEMA', N'Person', 'TABLE', N'Person', 'INDEX', N'XMLPATH_Person_Demographics'
GO
SET ANSI_PADDING ON
GO
CREATE XML INDEX [XMLPROPERTY_Person_Demographics]
    ON [Person].[Person] ([Demographics])
    USING XML INDEX [PXML_Person_Demographics]
    FOR PROPERTY
GO
EXEC sp_addextendedproperty N'MS_Description', N'Secondary XML index for property.', 'SCHEMA', N'Person', 'TABLE', N'Person', 'INDEX', N'XMLPROPERTY_Person_Demographics'
GO
SET ANSI_PADDING ON
GO
CREATE XML INDEX [XMLVALUE_Person_Demographics]
    ON [Person].[Person] ([Demographics])
    USING XML INDEX [PXML_Person_Demographics]
    FOR VALUE
GO
EXEC sp_addextendedproperty N'MS_Description', N'Secondary XML index for value.', 'SCHEMA', N'Person', 'TABLE', N'Person', 'INDEX', N'XMLVALUE_Person_Demographics'
GO
  
~~~

---
### See also
[List of tables](../tables.md)

