## ![](../../../../Images32x32Metro/OBJECT_TABLE.png "") Table:\[AdventureWorks2016CTP3\].\[Purchasing\].\[ShipMethod\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > **Purchasing.ShipMethod**

---
###  Description  
 Shipping company lookup table. 



---
### Table properties
|Name |Value |
|-|-|
| Schema |[\[Purchasing\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/8.md)|
| Owner |[\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md)|
| Table is replicated |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Creation date |10/23/2015|
| ID |398624463|
| Located on |PRIMARY|
| Data size KB |8 KB|
| Index size KB |40 KB|
| Rows |5   |
| ChangeTrackingEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| FileStreamFileGroup | |
| FileStreamPartitionScheme | |
| LockEscalation |TABLE|
| TrackColumnsUpdatedEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Table is filetable |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Filetable directory | |
| Filetable collate | |
| Filetable primary key |\[PK_ShipMethod_ShipMethodID\]|
| Filetable streamid unique | |
| Filetable fullpath unique | |
| Filetable is enabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is memory optimized |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Durability |SCHEMA_AND_DATA|

---
### Creation options
|Name |Value |
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|
|ANSI_PADDING|ON|

---
### Columns
| | |Name |Description |IsComputed|Data type |Max length |Nullable |Default|IsGUID |SPARSE|Computed value|
|-|-|-|-|-|-|-|-|-|-|-|-|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|![Identity](../../../../ImagesMetro/FILTER_Identity.gif "")|ShipMethodID|Primary key for ShipMethod records.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |Name|Shipping company name.| |[\[dbo\].\[Name\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/260.md)|50|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |ShipBase|Minimum shipping charge.| |money|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|((0.00))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |ShipRate|Shipping charge per pound.| |money|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|((0.00))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |rowguid|ROWGUIDCOL number uniquely identifying the record. Used to support a merge replication sample.| |uniqueidentifier|16|![](../../../../ImagesMetro/RED_CROSS.gif "")|(newid())|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |ModifiedDate|Date and time the record was last updated.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|(getdate())|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|

 Total: 6 column(s)

---
### Text column statistics
|Name |Data type |Avg. length |Min. length |Max. length |Usage rating |
|-|-|-|-|-|-|
|Name|nvarchar(50) |16|12|18|0.18000000000000|

 Total: 1 text column(s)

---
### Indexes
|Index |Key columns |Description |Primary |Unique |Size KB |Fill factor |
|-|-|-|-|-|-|-|
|[\[PK_ShipMethod_ShipMethodID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/398624463_PK_ShipMethod_ShipMethodID.md)|ShipMethodID|Primary key (clustered) constraint|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|48|0|
|[\[AK_ShipMethod_Name\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/398624463_AK_ShipMethod_Name.md)|Name|Unique nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|16|0|
|[\[AK_ShipMethod_rowguid\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/398624463_AK_ShipMethod_rowguid.md)|rowguid|Unique nonclustered index. Used to support replication samples.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|16|0|

 Total: 3 Index/indexes

---
### Columnstore indexes
 No columnstore indexes exist

---
### Fulltext index
 No fulltext index exist

---
### Statistics
 No statistics exist

---
### Check constraints
|Name |Expression |
|-|-|
|CK_ShipMethod_ShipBase|(\[ShipBase\]&gt;(0.00))|
|CK_ShipMethod_ShipRate|(\[ShipRate\]&gt;(0.00))|

---
### Identity column
| |Name |Seed |Increment |Not for replication |
|-|-|-|-|-|
|![](../../../../ImagesMetro/FILTER_Identity.gif "")| ShipMethodID | 1 | 1 |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Referencing tables
|Table |Foreign key |Primary key or unique constraint |
|-|-|-|
|[\[Purchasing\].\[PurchaseOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1266103551.md)|[FK_PurchaseOrderHeader_ShipMethod_ShipMethodID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1266103551_FK_PurchaseOrderHeader_ShipMethod_ShipMethodID.md)|[PK_ShipMethod_ShipMethodID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/398624463_PK_ShipMethod_ShipMethodID.md)|
|[\[Sales\].\[SalesOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691.md)|[FK_SalesOrderHeader_ShipMethod_ShipMethodID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1586104691_FK_SalesOrderHeader_ShipMethod_ShipMethodID.md)|[PK_ShipMethod_ShipMethodID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/398624463_PK_ShipMethod_ShipMethodID.md)|

 Total: 2 table(s)

---
### Referenced tables
 No referenced tables exist

---
### Triggers
 No triggers exist

---
### Data models
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/398624463_dm.md) to view data model

---
### Objects that depend on \[Purchasing\].\[ShipMethod\]
|Object name|Object type|Dep level|
|-|-|-|
|[\[Purchasing\].\[PurchaseOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1266103551.md)|Table|1|
|[\[Sales\].\[SalesOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691.md)|Table|1|

 Total 2 object(s)

---
### Objects that \[Purchasing\].\[ShipMethod\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Purchasing\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/8.md)|Schema|1|
|[\[dbo\].\[Name\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/260.md)|Datatype|1|

 Total 2 object(s)

---
### Column level dependencies
 No dependencies exist

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/398624463_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Shipping company lookup table.|

---
###  Permissions
No permissions defined

---
### Table options
|Name |Value |
|-|-|
|Pintable|OFF|
|Table lock on bulk load|OFF|
|Insert row lock|OFF|
|Text in row|0|
|Large value types out of row|OFF|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING ON
GO
CREATE TABLE [Purchasing].[ShipMethod] (
        [ShipMethodID]     [int] IDENTITY(1, 1) NOT NULL,
        [Name]             [dbo].[Name] NOT NULL,
        [ShipBase]         [money] NOT NULL,
        [ShipRate]         [money] NOT NULL,
        [rowguid]          [uniqueidentifier] NOT NULL ROWGUIDCOL,
        [ModifiedDate]     [datetime] NOT NULL,
        CONSTRAINT [PK_ShipMethod_ShipMethodID]
        PRIMARY KEY
        CLUSTERED
        ([ShipMethodID])
    ON [PRIMARY]
) ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Clustered index created by a primary key constraint.', 'SCHEMA', N'Purchasing', 'TABLE', N'ShipMethod', 'INDEX', N'PK_ShipMethod_ShipMethodID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key (clustered) constraint', 'SCHEMA', N'Purchasing', 'TABLE', N'ShipMethod', 'CONSTRAINT', N'PK_ShipMethod_ShipMethodID'
GO
ALTER TABLE [Purchasing].[ShipMethod]
    ADD
    CONSTRAINT [CK_ShipMethod_ShipBase]
    CHECK
    ([ShipBase]&gt;(0.00))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [ShipBase] &gt; (0.00)', 'SCHEMA', N'Purchasing', 'TABLE', N'ShipMethod', 'CONSTRAINT', N'CK_ShipMethod_ShipBase'
GO
ALTER TABLE [Purchasing].[ShipMethod]
CHECK CONSTRAINT [CK_ShipMethod_ShipBase]
GO
ALTER TABLE [Purchasing].[ShipMethod]
    ADD
    CONSTRAINT [CK_ShipMethod_ShipRate]
    CHECK
    ([ShipRate]&gt;(0.00))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [ShipRate] &gt; (0.00)', 'SCHEMA', N'Purchasing', 'TABLE', N'ShipMethod', 'CONSTRAINT', N'CK_ShipMethod_ShipRate'
GO
ALTER TABLE [Purchasing].[ShipMethod]
CHECK CONSTRAINT [CK_ShipMethod_ShipRate]
GO
ALTER TABLE [Purchasing].[ShipMethod]
    ADD
    CONSTRAINT [DF_ShipMethod_ShipBase]
    DEFAULT ((0.00)) FOR [ShipBase]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of 0.0', 'SCHEMA', N'Purchasing', 'TABLE', N'ShipMethod', 'CONSTRAINT', N'DF_ShipMethod_ShipBase'
GO
ALTER TABLE [Purchasing].[ShipMethod]
    ADD
    CONSTRAINT [DF_ShipMethod_ShipRate]
    DEFAULT ((0.00)) FOR [ShipRate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of 0.0', 'SCHEMA', N'Purchasing', 'TABLE', N'ShipMethod', 'CONSTRAINT', N'DF_ShipMethod_ShipRate'
GO
ALTER TABLE [Purchasing].[ShipMethod]
    ADD
    CONSTRAINT [DF_ShipMethod_rowguid]
    DEFAULT (newid()) FOR [rowguid]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of NEWID()', 'SCHEMA', N'Purchasing', 'TABLE', N'ShipMethod', 'CONSTRAINT', N'DF_ShipMethod_rowguid'
GO
ALTER TABLE [Purchasing].[ShipMethod]
    ADD
    CONSTRAINT [DF_ShipMethod_ModifiedDate]
    DEFAULT (getdate()) FOR [ModifiedDate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of GETDATE()', 'SCHEMA', N'Purchasing', 'TABLE', N'ShipMethod', 'CONSTRAINT', N'DF_ShipMethod_ModifiedDate'
GO
CREATE UNIQUE NONCLUSTERED INDEX [AK_ShipMethod_Name]
    ON [Purchasing].[ShipMethod] ([Name])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique nonclustered index.', 'SCHEMA', N'Purchasing', 'TABLE', N'ShipMethod', 'INDEX', N'AK_ShipMethod_Name'
GO
CREATE UNIQUE NONCLUSTERED INDEX [AK_ShipMethod_rowguid]
    ON [Purchasing].[ShipMethod] ([rowguid])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique nonclustered index. Used to support replication samples.', 'SCHEMA', N'Purchasing', 'TABLE', N'ShipMethod', 'INDEX', N'AK_ShipMethod_rowguid'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Shipping company lookup table.', 'SCHEMA', N'Purchasing', 'TABLE', N'ShipMethod', NULL, NULL
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key for ShipMethod records.', 'SCHEMA', N'Purchasing', 'TABLE', N'ShipMethod', 'COLUMN', N'ShipMethodID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Shipping company name.', 'SCHEMA', N'Purchasing', 'TABLE', N'ShipMethod', 'COLUMN', N'Name'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Minimum shipping charge.', 'SCHEMA', N'Purchasing', 'TABLE', N'ShipMethod', 'COLUMN', N'ShipBase'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Shipping charge per pound.', 'SCHEMA', N'Purchasing', 'TABLE', N'ShipMethod', 'COLUMN', N'ShipRate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'ROWGUIDCOL number uniquely identifying the record. Used to support a merge replication sample.', 'SCHEMA', N'Purchasing', 'TABLE', N'ShipMethod', 'COLUMN', N'rowguid'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date and time the record was last updated.', 'SCHEMA', N'Purchasing', 'TABLE', N'ShipMethod', 'COLUMN', N'ModifiedDate'
GO
  
~~~

---
### See also
[List of tables](../tables.md)

