## ![](../../../../Images32x32Metro/OBJECT_TABLE.png "") Table:\[AdventureWorks2016CTP3\].\[Production\].\[ProductInventory\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > **Production.ProductInventory**

---
###  Description  
 Product inventory information. 



---
### Table properties
|Name |Value |
|-|-|
| Schema |[\[Production\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/7.md)|
| Owner |[\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md)|
| Table is replicated |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Creation date |10/23/2015|
| ID |578101100|
| Located on |PRIMARY|
| Data size KB |56 KB|
| Index size KB |16 KB|
| Rows |1069|
| ChangeTrackingEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| FileStreamFileGroup | |
| FileStreamPartitionScheme | |
| LockEscalation |TABLE|
| TrackColumnsUpdatedEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Table is filetable |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Filetable directory | |
| Filetable collate | |
| Filetable primary key |\[PK_ProductInventory_ProductID_LocationID\]|
| Filetable streamid unique | |
| Filetable fullpath unique | |
| Filetable is enabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is memory optimized |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Durability |SCHEMA_AND_DATA|

---
### Creation options
|Name |Value |
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|
|ANSI_PADDING|ON|

---
### Columns
| | |Name |Description |IsComputed|Data type |Max length |Nullable |Default|IsGUID |SPARSE|Computed value|
|-|-|-|-|-|-|-|-|-|-|-|-|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_578101100_FK_ProductInventory_Product_ProductID.md)|ProductID|Product identification number. Foreign key to Product.ProductID.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_578101100_FK_ProductInventory_Location_LocationID.md)|LocationID|Inventory location identification number. Foreign key to Location.LocationID. | |smallint|2|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |Shelf|Storage compartment within an inventory location.| |nvarchar|10|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |Bin|Storage container on a shelf in an inventory location.| |tinyint|1|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |Quantity|Quantity of products in the inventory location.| |smallint|2|![](../../../../ImagesMetro/RED_CROSS.gif "")|((0))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |rowguid|ROWGUIDCOL number uniquely identifying the record. Used to support a merge replication sample.| |uniqueidentifier|16|![](../../../../ImagesMetro/RED_CROSS.gif "")|(newid())|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |ModifiedDate|Date and time the record was last updated.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|(getdate())|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|

 Total: 7 column(s)

---
### Text column statistics
|Name |Data type |Avg. length |Min. length |Max. length |Usage rating |
|-|-|-|-|-|-|
|Shelf|nvarchar(10) |1|1|3|0.15000000000000|

 Total: 1 text column(s)

---
### Indexes
|Index |Key columns |Description |Primary |Unique |Size KB |Fill factor |
|-|-|-|-|-|-|-|
|[\[PK_ProductInventory_ProductID_LocationID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/578101100_PK_ProductInventory_ProductID_LocationID.md)|ProductID, LocationID|Primary key (clustered) constraint|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|72|0|

 Total: 1 Index/indexes

---
### Columnstore indexes
 No columnstore indexes exist

---
### Fulltext index
 No fulltext index exist

---
### Statistics
 No statistics exist

---
### Check constraints
|Name |Expression |
|-|-|
|CK_ProductInventory_Shelf|(\[Shelf\] like &#39;\[A-Za-z\]&#39; OR \[Shelf\]=&#39;N/A&#39;)|
|CK_ProductInventory_Bin|(\[Bin\]&gt;=(0) AND \[Bin\]&lt;=(100))|

---
### Identity column
 No identity column exists

---
### Referencing tables
 No referencing tables exist

---
### Referenced tables
|Table |Primary key or unique constraint |Foreign key |
|-|-|-|
|[\[Production\].\[Location\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1941581955.md)|[PK_Location_LocationID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1941581955_PK_Location_LocationID.md)|[FK_ProductInventory_Location_LocationID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_578101100_FK_ProductInventory_Location_LocationID.md)|
|[\[Production\].\[Product\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/146099561.md)|[PK_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/146099561_PK_Product_ProductID.md)|[FK_ProductInventory_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_578101100_FK_ProductInventory_Product_ProductID.md)|

 Total: 2 table(s)

---
### Triggers
 No triggers exist

---
### Data models
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/578101100_dm.md) to view data model

---
### Objects that depend on \[Production\].\[ProductInventory\]
|Object name|Object type|Dep level|
|-|-|-|
|[\[dbo\].\[ufnGetStock\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Functions/1437248175.md)|Function|1|

 Total 1 object(s)

---
### Objects that \[Production\].\[ProductInventory\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Production\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/7.md)|Schema|1|
|[\[Production\].\[Location\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1941581955.md)|Table|1|
|[\[Production\].\[Product\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/146099561.md)|Table|1|

 Total 3 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[Production\].\[Location\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1941581955.md)|LocationID|Table|
|[\[Production\].\[Product\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/146099561.md)|ProductID|Table|

 Total 2 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/578101100_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Product inventory information.|

---
###  Permissions
No permissions defined

---
### Table options
|Name |Value |
|-|-|
|Pintable|OFF|
|Table lock on bulk load|OFF|
|Insert row lock|OFF|
|Text in row|0|
|Large value types out of row|OFF|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING ON
GO
CREATE TABLE [Production].[ProductInventory] (
        [ProductID]        [int] NOT NULL,
        [LocationID]       [smallint] NOT NULL,
        [Shelf]            [nvarchar](10) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [Bin]              [tinyint] NOT NULL,
        [Quantity]         [smallint] NOT NULL,
        [rowguid]          [uniqueidentifier] NOT NULL ROWGUIDCOL,
        [ModifiedDate]     [datetime] NOT NULL,
        CONSTRAINT [PK_ProductInventory_ProductID_LocationID]
        PRIMARY KEY
        CLUSTERED
        ([ProductID], [LocationID])
    ON [PRIMARY]
) ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Clustered index created by a primary key constraint.', 'SCHEMA', N'Production', 'TABLE', N'ProductInventory', 'INDEX', N'PK_ProductInventory_ProductID_LocationID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key (clustered) constraint', 'SCHEMA', N'Production', 'TABLE', N'ProductInventory', 'CONSTRAINT', N'PK_ProductInventory_ProductID_LocationID'
GO
ALTER TABLE [Production].[ProductInventory]
    ADD
    CONSTRAINT [CK_ProductInventory_Shelf]
    CHECK
    ([Shelf] like '[A-Za-z]' OR [Shelf]='N/A')
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [Shelf] like ''[A-Za-z]'' OR [Shelf]=''N/A''', 'SCHEMA', N'Production', 'TABLE', N'ProductInventory', 'CONSTRAINT', N'CK_ProductInventory_Shelf'
GO
ALTER TABLE [Production].[ProductInventory]
CHECK CONSTRAINT [CK_ProductInventory_Shelf]
GO
ALTER TABLE [Production].[ProductInventory]
    ADD
    CONSTRAINT [CK_ProductInventory_Bin]
    CHECK
    ([Bin]&gt;=(0) AND [Bin]&lt;=(100))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [Bin] BETWEEN (0) AND (100)', 'SCHEMA', N'Production', 'TABLE', N'ProductInventory', 'CONSTRAINT', N'CK_ProductInventory_Bin'
GO
ALTER TABLE [Production].[ProductInventory]
CHECK CONSTRAINT [CK_ProductInventory_Bin]
GO
ALTER TABLE [Production].[ProductInventory]
    ADD
    CONSTRAINT [DF_ProductInventory_Quantity]
    DEFAULT ((0)) FOR [Quantity]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of 0', 'SCHEMA', N'Production', 'TABLE', N'ProductInventory', 'CONSTRAINT', N'DF_ProductInventory_Quantity'
GO
ALTER TABLE [Production].[ProductInventory]
    ADD
    CONSTRAINT [DF_ProductInventory_rowguid]
    DEFAULT (newid()) FOR [rowguid]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of NEWID()', 'SCHEMA', N'Production', 'TABLE', N'ProductInventory', 'CONSTRAINT', N'DF_ProductInventory_rowguid'
GO
ALTER TABLE [Production].[ProductInventory]
    ADD
    CONSTRAINT [DF_ProductInventory_ModifiedDate]
    DEFAULT (getdate()) FOR [ModifiedDate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of GETDATE()', 'SCHEMA', N'Production', 'TABLE', N'ProductInventory', 'CONSTRAINT', N'DF_ProductInventory_ModifiedDate'
GO
ALTER TABLE [Production].[ProductInventory]
    WITH CHECK
    ADD CONSTRAINT [FK_ProductInventory_Location_LocationID]
    FOREIGN KEY ([LocationID]) REFERENCES [Production].[Location] ([LocationID])
ALTER TABLE [Production].[ProductInventory]
    CHECK CONSTRAINT [FK_ProductInventory_Location_LocationID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing Location.LocationID.', 'SCHEMA', N'Production', 'TABLE', N'ProductInventory', 'CONSTRAINT', N'FK_ProductInventory_Location_LocationID'
GO
ALTER TABLE [Production].[ProductInventory]
    WITH CHECK
    ADD CONSTRAINT [FK_ProductInventory_Product_ProductID]
    FOREIGN KEY ([ProductID]) REFERENCES [Production].[Product] ([ProductID])
ALTER TABLE [Production].[ProductInventory]
    CHECK CONSTRAINT [FK_ProductInventory_Product_ProductID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing Product.ProductID.', 'SCHEMA', N'Production', 'TABLE', N'ProductInventory', 'CONSTRAINT', N'FK_ProductInventory_Product_ProductID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Product inventory information.', 'SCHEMA', N'Production', 'TABLE', N'ProductInventory', NULL, NULL
GO
EXEC sp_addextendedproperty N'MS_Description', N'Product identification number. Foreign key to Product.ProductID.', 'SCHEMA', N'Production', 'TABLE', N'ProductInventory', 'COLUMN', N'ProductID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Inventory location identification number. Foreign key to Location.LocationID. ', 'SCHEMA', N'Production', 'TABLE', N'ProductInventory', 'COLUMN', N'LocationID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Storage compartment within an inventory location.', 'SCHEMA', N'Production', 'TABLE', N'ProductInventory', 'COLUMN', N'Shelf'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Storage container on a shelf in an inventory location.', 'SCHEMA', N'Production', 'TABLE', N'ProductInventory', 'COLUMN', N'Bin'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Quantity of products in the inventory location.', 'SCHEMA', N'Production', 'TABLE', N'ProductInventory', 'COLUMN', N'Quantity'
GO
EXEC sp_addextendedproperty N'MS_Description', N'ROWGUIDCOL number uniquely identifying the record. Used to support a merge replication sample.', 'SCHEMA', N'Production', 'TABLE', N'ProductInventory', 'COLUMN', N'rowguid'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date and time the record was last updated.', 'SCHEMA', N'Production', 'TABLE', N'ProductInventory', 'COLUMN', N'ModifiedDate'
GO
  
~~~

---
### See also
[List of tables](../tables.md)

