## ![](../../../../Images32x32Metro/OBJECT_TABLE.png "") Table:\[AdventureWorks2016CTP3\].\[Production\].\[ProductListPriceHistory\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > **Production.ProductListPriceHistory**

---
###  Description  
 Changes in the list price of a product over time. 



---
### Table properties
|Name |Value |
|-|-|
| Schema |[\[Production\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/7.md)|
| Owner |[\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md)|
| Table is replicated |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Creation date |10/23/2015|
| ID |674101442|
| Located on |PRIMARY|
| Data size KB |24 KB|
| Index size KB |16 KB|
| Rows |395 |
| ChangeTrackingEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| FileStreamFileGroup | |
| FileStreamPartitionScheme | |
| LockEscalation |TABLE|
| TrackColumnsUpdatedEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Table is filetable |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Filetable directory | |
| Filetable collate | |
| Filetable primary key |\[PK_ProductListPriceHistory_ProductID_StartDate\]|
| Filetable streamid unique | |
| Filetable fullpath unique | |
| Filetable is enabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is memory optimized |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Durability |SCHEMA_AND_DATA|

---
### Creation options
|Name |Value |
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|
|ANSI_PADDING|OFF|

---
### Columns
| | |Name |Description |IsComputed|Data type |Max length |Nullable |Default|IsGUID |SPARSE|Computed value|
|-|-|-|-|-|-|-|-|-|-|-|-|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_674101442_FK_ProductListPriceHistory_Product_ProductID.md)|ProductID|Product identification number. Foreign key to Product.ProductID| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")| |StartDate|List price start date.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |EndDate|List price end date| |datetime|8|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |ListPrice|Product list price.| |money|8|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |ModifiedDate|Date and time the record was last updated.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|(getdate())|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|

 Total: 5 column(s)

---
### Indexes
|Index |Key columns |Description |Primary |Unique |Size KB |Fill factor |
|-|-|-|-|-|-|-|
|[\[PK_ProductListPriceHistory_ProductID_StartDate\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/674101442_PK_ProductListPriceHistory_ProductID_StartDate.md)|ProductID, StartDate|Primary key (clustered) constraint|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|40|0|

 Total: 1 Index/indexes

---
### Columnstore indexes
 No columnstore indexes exist

---
### Fulltext index
 No fulltext index exist

---
### Statistics
 No statistics exist

---
### Check constraints
|Name |Expression |
|-|-|
|CK_ProductListPriceHistory_EndDate|(\[EndDate\]&gt;=\[StartDate\] OR \[EndDate\] IS NULL)|
|CK_ProductListPriceHistory_ListPrice|(\[ListPrice\]&gt;(0.00))|

---
### Identity column
 No identity column exists

---
### Referencing tables
 No referencing tables exist

---
### Referenced tables
|Table |Primary key or unique constraint |Foreign key |
|-|-|-|
|[\[Production\].\[Product\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/146099561.md)|[PK_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/146099561_PK_Product_ProductID.md)|[FK_ProductListPriceHistory_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_674101442_FK_ProductListPriceHistory_Product_ProductID.md)|

 Total: 1 table(s)

---
### Triggers
 No triggers exist

---
### Data models
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/674101442_dm.md) to view data model

---
### Objects that depend on \[Production\].\[ProductListPriceHistory\]
|Object name|Object type|Dep level|
|-|-|-|
|[\[dbo\].\[ufnGetProductDealerPrice\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Functions/1389248004.md)|Function|1|
|[\[dbo\].\[ufnGetProductListPrice\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Functions/1405248061.md)|Function|1|

 Total 2 object(s)

---
### Objects that \[Production\].\[ProductListPriceHistory\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Production\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/7.md)|Schema|1|
|[\[Production\].\[Product\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/146099561.md)|Table|1|

 Total 2 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[Production\].\[Product\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/146099561.md)|ProductID|Table|

 Total 1 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/674101442_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Changes in the list price of a product over time.|

---
###  Permissions
No permissions defined

---
### Table options
|Name |Value |
|-|-|
|Pintable|OFF|
|Table lock on bulk load|OFF|
|Insert row lock|OFF|
|Text in row|0|
|Large value types out of row|OFF|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING OFF
GO
CREATE TABLE [Production].[ProductListPriceHistory] (
        [ProductID]        [int] NOT NULL,
        [StartDate]        [datetime] NOT NULL,
        [EndDate]          [datetime] NULL,
        [ListPrice]        [money] NOT NULL,
        [ModifiedDate]     [datetime] NOT NULL,
        CONSTRAINT [PK_ProductListPriceHistory_ProductID_StartDate]
        PRIMARY KEY
        CLUSTERED
        ([ProductID], [StartDate])
    ON [PRIMARY]
) ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Clustered index created by a primary key constraint.', 'SCHEMA', N'Production', 'TABLE', N'ProductListPriceHistory', 'INDEX', N'PK_ProductListPriceHistory_ProductID_StartDate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key (clustered) constraint', 'SCHEMA', N'Production', 'TABLE', N'ProductListPriceHistory', 'CONSTRAINT', N'PK_ProductListPriceHistory_ProductID_StartDate'
GO
ALTER TABLE [Production].[ProductListPriceHistory]
    ADD
    CONSTRAINT [CK_ProductListPriceHistory_EndDate]
    CHECK
    ([EndDate]&gt;=[StartDate] OR [EndDate] IS NULL)
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [EndDate] &gt;= [StartDate] OR [EndDate] IS NULL', 'SCHEMA', N'Production', 'TABLE', N'ProductListPriceHistory', 'CONSTRAINT', N'CK_ProductListPriceHistory_EndDate'
GO
ALTER TABLE [Production].[ProductListPriceHistory]
CHECK CONSTRAINT [CK_ProductListPriceHistory_EndDate]
GO
ALTER TABLE [Production].[ProductListPriceHistory]
    ADD
    CONSTRAINT [CK_ProductListPriceHistory_ListPrice]
    CHECK
    ([ListPrice]&gt;(0.00))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [ListPrice] &gt; (0.00)', 'SCHEMA', N'Production', 'TABLE', N'ProductListPriceHistory', 'CONSTRAINT', N'CK_ProductListPriceHistory_ListPrice'
GO
ALTER TABLE [Production].[ProductListPriceHistory]
CHECK CONSTRAINT [CK_ProductListPriceHistory_ListPrice]
GO
ALTER TABLE [Production].[ProductListPriceHistory]
    ADD
    CONSTRAINT [DF_ProductListPriceHistory_ModifiedDate]
    DEFAULT (getdate()) FOR [ModifiedDate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of GETDATE()', 'SCHEMA', N'Production', 'TABLE', N'ProductListPriceHistory', 'CONSTRAINT', N'DF_ProductListPriceHistory_ModifiedDate'
GO
ALTER TABLE [Production].[ProductListPriceHistory]
    WITH CHECK
    ADD CONSTRAINT [FK_ProductListPriceHistory_Product_ProductID]
    FOREIGN KEY ([ProductID]) REFERENCES [Production].[Product] ([ProductID])
ALTER TABLE [Production].[ProductListPriceHistory]
    CHECK CONSTRAINT [FK_ProductListPriceHistory_Product_ProductID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing Product.ProductID.', 'SCHEMA', N'Production', 'TABLE', N'ProductListPriceHistory', 'CONSTRAINT', N'FK_ProductListPriceHistory_Product_ProductID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Changes in the list price of a product over time.', 'SCHEMA', N'Production', 'TABLE', N'ProductListPriceHistory', NULL, NULL
GO
EXEC sp_addextendedproperty N'MS_Description', N'Product identification number. Foreign key to Product.ProductID', 'SCHEMA', N'Production', 'TABLE', N'ProductListPriceHistory', 'COLUMN', N'ProductID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'List price start date.', 'SCHEMA', N'Production', 'TABLE', N'ProductListPriceHistory', 'COLUMN', N'StartDate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'List price end date', 'SCHEMA', N'Production', 'TABLE', N'ProductListPriceHistory', 'COLUMN', N'EndDate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Product list price.', 'SCHEMA', N'Production', 'TABLE', N'ProductListPriceHistory', 'COLUMN', N'ListPrice'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date and time the record was last updated.', 'SCHEMA', N'Production', 'TABLE', N'ProductListPriceHistory', 'COLUMN', N'ModifiedDate'
GO
  
~~~

---
### See also
[List of tables](../tables.md)

