## ![](../../../../Images32x32Metro/OBJECT_TABLE.png "") Table:\[AdventureWorks2016CTP3\].\[Person\].\[Address\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > **Person.Address**

---
###  Description  
 Street address information for customers, employees, and vendors. 



---
### Table properties
|Name |Value |
|-|-|
| Schema |[\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/6.md)|
| Owner |[\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md)|
| Table is replicated |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Creation date |10/23/2015|
| ID |693577509|
| Located on |PRIMARY|
| Data size KB |2904 KB|
| Index size KB |2752 KB|
| Rows |19614   |
| ChangeTrackingEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| FileStreamFileGroup | |
| FileStreamPartitionScheme | |
| LockEscalation |TABLE|
| TrackColumnsUpdatedEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Table is filetable |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Filetable directory | |
| Filetable collate | |
| Filetable primary key |\[PK_Address_AddressID\]|
| Filetable streamid unique | |
| Filetable fullpath unique | |
| Filetable is enabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is memory optimized |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Durability |SCHEMA_AND_DATA|

---
### Creation options
|Name |Value |
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|
|ANSI_PADDING|ON|

---
### Columns
| | | |Name |Description |IsComputed|Data type |Max length |Nullable |Default|IsGUID |SPARSE|Computed value|
|-|-|-|-|-|-|-|-|-|-|-|-|-|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|![Identity](../../../../ImagesMetro/FILTER_Identity.gif "")| |AddressID|Primary key for Address records.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |AddressLine1|First street address line.| |nvarchar|60|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |AddressLine2|Second street address line.| |nvarchar|60|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |City|Name of the city.| |nvarchar|30|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_693577509_FK_Address_StateProvince_StateProvinceID.md)|StateProvinceID|Unique identification number for the state or province. Foreign key to StateProvince table.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |PostalCode|Postal code for the street address.| |nvarchar|15|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |SpatialLocation|Latitude and longitude of this address.| |geography| |![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |rowguid|ROWGUIDCOL number uniquely identifying the record. Used to support a merge replication sample.| |uniqueidentifier|16|![](../../../../ImagesMetro/RED_CROSS.gif "")|(newid())|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |ModifiedDate|Date and time the record was last updated.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|(getdate())|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|

 Total: 9 column(s)

---
### Text column statistics
|Name |Data type |Avg. length |Min. length |Max. length |Usage rating |
|-|-|-|-|-|-|
|AddressLine1|nvarchar(60) |17|5|39|0.32500000000000|
|AddressLine2|nvarchar(60) |0|1|28|0.23333333333333|
|City|nvarchar(30) |8|3|21|0.35000000000000|
|PostalCode|nvarchar(15) |4|2|10|0.33333333333333|

 Total: 4 text column(s)

---
### Indexes
|Index |Key columns |Description |Primary |Unique |Size KB |Fill factor |
|-|-|-|-|-|-|-|
|[\[PK_Address_AddressID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/693577509_PK_Address_AddressID.md)|AddressID|Primary key (clustered) constraint|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|5624|0|
|[\[AK_Address_rowguid\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/693577509_AK_Address_rowguid.md)|rowguid|Unique nonclustered index. Used to support replication samples.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|528|0|
|[\[IX_Address_AddressLine1_AddressLine2_City_StateProvinceID_PostalCode\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/693577509_IX_Address_AddressLine1_AddressLine2_City_StateProvinceID_PostalCode.md)|AddressLine1, AddressLine2, City, StateProvinceID, PostalCode|Nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|1728|0|
|[\[IX_Address_StateProvinceID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/693577509_IX_Address_StateProvinceID.md)|StateProvinceID|Nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|288|0|

 Total: 4 Index/indexes

---
### Columnstore indexes
 No columnstore indexes exist

---
### Fulltext index
 No fulltext index exist

---
### Statistics
 No statistics exist

---
### Check constraints
 No check constraints exist

---
### Identity column
| |Name |Seed |Increment |Not for replication |
|-|-|-|-|-|
|![](../../../../ImagesMetro/FILTER_Identity.gif "")| AddressID | 1 | 1 |![](../../../../ImagesMetro/CHECK_OUT.png "")|

---
### Referencing tables
|Table |Foreign key |Primary key or unique constraint |
|-|-|-|
|[\[Person\].\[BusinessEntityAddress\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/997578592.md)|[FK_BusinessEntityAddress_Address_AddressID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_997578592_FK_BusinessEntityAddress_Address_AddressID.md)|[PK_Address_AddressID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/693577509_PK_Address_AddressID.md)|
|[\[Sales\].\[SalesOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691.md)|[FK_SalesOrderHeader_Address_BillToAddressID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1586104691_FK_SalesOrderHeader_Address_BillToAddressID.md)|[PK_Address_AddressID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/693577509_PK_Address_AddressID.md)|
|[\[Sales\].\[SalesOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691.md)|[FK_SalesOrderHeader_Address_ShipToAddressID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1586104691_FK_SalesOrderHeader_Address_ShipToAddressID.md)|[PK_Address_AddressID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/693577509_PK_Address_AddressID.md)|

 Total: 3 table(s)

---
### Referenced tables
|Table |Primary key or unique constraint |Foreign key |
|-|-|-|
|[\[Person\].\[StateProvince\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/782625831.md)|[PK_StateProvince_StateProvinceID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/782625831_PK_StateProvince_StateProvinceID.md)|[FK_Address_StateProvince_StateProvinceID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_693577509_FK_Address_StateProvince_StateProvinceID.md)|

 Total: 1 table(s)

---
### Triggers
 No triggers exist

---
### Data models
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/693577509_dm.md) to view data model

---
### Objects that depend on \[Person\].\[Address\]
|Object name|Object type|Dep level|
|-|-|-|
|[\[Person\].\[BusinessEntityAddress\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/997578592.md)|Table|1|
|[\[Sales\].\[SalesOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691.md)|Table|1|
|[\[HumanResources\].\[vEmployee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1037246750.md)|View|1|
|[\[Sales\].\[vIndividualCustomer\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1085246921.md)|View|1|
|[\[Sales\].\[vSalesPerson\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1213247377.md)|View|1|
|[\[Sales\].\[vStoreWithAddresses\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1293247662.md)|View|1|
|[\[Purchasing\].\[vVendorWithAddresses\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1325247776.md)|View|1|

 Total 7 object(s)

---
### Objects that \[Person\].\[Address\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/6.md)|Schema|1|
|[\[Person\].\[StateProvince\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/782625831.md)|Table|1|

 Total 2 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[Person\].\[StateProvince\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/782625831.md)|StateProvinceID|Table|

 Total 1 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/693577509_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Street address information for customers, employees, and vendors.|

---
###  Permissions
No permissions defined

---
### Table options
|Name |Value |
|-|-|
|Pintable|OFF|
|Table lock on bulk load|OFF|
|Insert row lock|OFF|
|Text in row|0|
|Large value types out of row|OFF|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING ON
GO
CREATE TABLE [Person].[Address] (
        [AddressID]           [int] IDENTITY(1, 1) NOT FOR REPLICATION NOT NULL,
        [AddressLine1]        [nvarchar](60) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [AddressLine2]        [nvarchar](60) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        [City]                [nvarchar](30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [StateProvinceID]     [int] NOT NULL,
        [PostalCode]          [nvarchar](15) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [SpatialLocation]     [geography] NULL,
        [rowguid]             [uniqueidentifier] NOT NULL ROWGUIDCOL,
        [ModifiedDate]        [datetime] NOT NULL,
        CONSTRAINT [PK_Address_AddressID]
        PRIMARY KEY
        CLUSTERED
        ([AddressID])
    ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Clustered index created by a primary key constraint.', 'SCHEMA', N'Person', 'TABLE', N'Address', 'INDEX', N'PK_Address_AddressID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key (clustered) constraint', 'SCHEMA', N'Person', 'TABLE', N'Address', 'CONSTRAINT', N'PK_Address_AddressID'
GO
ALTER TABLE [Person].[Address]
    ADD
    CONSTRAINT [DF_Address_rowguid]
    DEFAULT (newid()) FOR [rowguid]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of NEWID()', 'SCHEMA', N'Person', 'TABLE', N'Address', 'CONSTRAINT', N'DF_Address_rowguid'
GO
ALTER TABLE [Person].[Address]
    ADD
    CONSTRAINT [DF_Address_ModifiedDate]
    DEFAULT (getdate()) FOR [ModifiedDate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of GETDATE()', 'SCHEMA', N'Person', 'TABLE', N'Address', 'CONSTRAINT', N'DF_Address_ModifiedDate'
GO
ALTER TABLE [Person].[Address]
    WITH CHECK
    ADD CONSTRAINT [FK_Address_StateProvince_StateProvinceID]
    FOREIGN KEY ([StateProvinceID]) REFERENCES [Person].[StateProvince] ([StateProvinceID])
ALTER TABLE [Person].[Address]
    CHECK CONSTRAINT [FK_Address_StateProvince_StateProvinceID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing StateProvince.StateProvinceID.', 'SCHEMA', N'Person', 'TABLE', N'Address', 'CONSTRAINT', N'FK_Address_StateProvince_StateProvinceID'
GO
CREATE UNIQUE NONCLUSTERED INDEX [AK_Address_rowguid]
    ON [Person].[Address] ([rowguid])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique nonclustered index. Used to support replication samples.', 'SCHEMA', N'Person', 'TABLE', N'Address', 'INDEX', N'AK_Address_rowguid'
GO
CREATE UNIQUE NONCLUSTERED INDEX [IX_Address_AddressLine1_AddressLine2_City_StateProvinceID_PostalCode]
    ON [Person].[Address] ([AddressLine1], [AddressLine2], [City], [StateProvinceID], [PostalCode])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Nonclustered index.', 'SCHEMA', N'Person', 'TABLE', N'Address', 'INDEX', N'IX_Address_AddressLine1_AddressLine2_City_StateProvinceID_PostalCode'
GO
CREATE NONCLUSTERED INDEX [IX_Address_StateProvinceID]
    ON [Person].[Address] ([StateProvinceID])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Nonclustered index.', 'SCHEMA', N'Person', 'TABLE', N'Address', 'INDEX', N'IX_Address_StateProvinceID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Street address information for customers, employees, and vendors.', 'SCHEMA', N'Person', 'TABLE', N'Address', NULL, NULL
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key for Address records.', 'SCHEMA', N'Person', 'TABLE', N'Address', 'COLUMN', N'AddressID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'First street address line.', 'SCHEMA', N'Person', 'TABLE', N'Address', 'COLUMN', N'AddressLine1'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Second street address line.', 'SCHEMA', N'Person', 'TABLE', N'Address', 'COLUMN', N'AddressLine2'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Name of the city.', 'SCHEMA', N'Person', 'TABLE', N'Address', 'COLUMN', N'City'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique identification number for the state or province. Foreign key to StateProvince table.', 'SCHEMA', N'Person', 'TABLE', N'Address', 'COLUMN', N'StateProvinceID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Postal code for the street address.', 'SCHEMA', N'Person', 'TABLE', N'Address', 'COLUMN', N'PostalCode'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Latitude and longitude of this address.', 'SCHEMA', N'Person', 'TABLE', N'Address', 'COLUMN', N'SpatialLocation'
GO
EXEC sp_addextendedproperty N'MS_Description', N'ROWGUIDCOL number uniquely identifying the record. Used to support a merge replication sample.', 'SCHEMA', N'Person', 'TABLE', N'Address', 'COLUMN', N'rowguid'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date and time the record was last updated.', 'SCHEMA', N'Person', 'TABLE', N'Address', 'COLUMN', N'ModifiedDate'
GO
  
~~~

---
### See also
[List of tables](../tables.md)

