## ![](../../../../Images32x32Metro/OBJECT_TABLE.png "") Table:\[AdventureWorks2016CTP3\].\[Person\].\[StateProvince\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > **Person.StateProvince**

---
###  Description  
 State and province lookup table. 



---
### Table properties
|Name |Value |
|-|-|
| Schema |[\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/6.md)|
| Owner |[\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md)|
| Table is replicated |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Creation date |10/23/2015|
| ID |782625831|
| Located on |PRIMARY|
| Data size KB |16 KB|
| Index size KB |64 KB|
| Rows |181 |
| ChangeTrackingEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| FileStreamFileGroup | |
| FileStreamPartitionScheme | |
| LockEscalation |TABLE|
| TrackColumnsUpdatedEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Table is filetable |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Filetable directory | |
| Filetable collate | |
| Filetable primary key |\[PK_StateProvince_StateProvinceID\]|
| Filetable streamid unique | |
| Filetable fullpath unique | |
| Filetable is enabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is memory optimized |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Durability |SCHEMA_AND_DATA|

---
### Creation options
|Name |Value |
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|
|ANSI_PADDING|ON|

---
### Columns
| | | |Name |Description |IsComputed|Data type |Max length |Nullable |Default|IsGUID |SPARSE|Computed value|
|-|-|-|-|-|-|-|-|-|-|-|-|-|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|![Identity](../../../../ImagesMetro/FILTER_Identity.gif "")| |StateProvinceID|Primary key for StateProvince records.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |StateProvinceCode|ISO standard state or province code.| |nchar|3|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_782625831_FK_StateProvince_CountryRegion_CountryRegionCode.md)|CountryRegionCode|ISO standard country or region code. Foreign key to CountryRegion.CountryRegionCode. | |nvarchar|3|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |IsOnlyStateProvinceFlag|0 = StateProvinceCode exists. 1 = StateProvinceCode unavailable, using CountryRegionCode.| |[\[dbo\].\[Flag\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/258.md)|1|![](../../../../ImagesMetro/RED_CROSS.gif "")|((1))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |Name|State or province description.| |[\[dbo\].\[Name\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/260.md)|50|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_782625831_FK_StateProvince_SalesTerritory_TerritoryID.md)|TerritoryID|ID of the territory in which the state or province is located. Foreign key to SalesTerritory.SalesTerritoryID.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |rowguid|ROWGUIDCOL number uniquely identifying the record. Used to support a merge replication sample.| |uniqueidentifier|16|![](../../../../ImagesMetro/RED_CROSS.gif "")|(newid())|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |ModifiedDate|Date and time the record was last updated.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|(getdate())|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|

 Total: 8 column(s)

---
### Text column statistics
|Name |Data type |Avg. length |Min. length |Max. length |Usage rating |
|-|-|-|-|-|-|
|StateProvinceCode|nchar(3) |2|2|3|0.50000000000000|
|CountryRegionCode|nvarchar(3)  |2|2|2|0.33333333333333|
|Name|nvarchar(50) |9|3|24|0.24000000000000|

 Total: 3 text column(s)

---
### Indexes
|Index |Key columns |Description |Primary |Unique |Size KB |Fill factor |
|-|-|-|-|-|-|-|
|[\[PK_StateProvince_StateProvinceID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/782625831_PK_StateProvince_StateProvinceID.md)|StateProvinceID|Primary key (clustered) constraint|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|80|0|
|[\[AK_StateProvince_Name\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/782625831_AK_StateProvince_Name.md)|Name|Unique nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|16|0|
|[\[AK_StateProvince_StateProvinceCode_CountryRegionCode\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/782625831_AK_StateProvince_StateProvinceCode_CountryRegionCode.md)|StateProvinceCode, CountryRegionCode|Unique nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|16|0|
|[\[AK_StateProvince_rowguid\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/782625831_AK_StateProvince_rowguid.md)|rowguid|Unique nonclustered index. Used to support replication samples.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|16|0|

 Total: 4 Index/indexes

---
### Columnstore indexes
 No columnstore indexes exist

---
### Fulltext index
 No fulltext index exist

---
### Statistics
 No statistics exist

---
### Check constraints
 No check constraints exist

---
### Identity column
| |Name |Seed |Increment |Not for replication |
|-|-|-|-|-|
|![](../../../../ImagesMetro/FILTER_Identity.gif "")| StateProvinceID | 1 | 1 |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Referencing tables
|Table |Foreign key |Primary key or unique constraint |
|-|-|-|
|[\[Sales\].\[SalesTaxRate\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/14623095.md)|[FK_SalesTaxRate_StateProvince_StateProvinceID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_14623095_FK_SalesTaxRate_StateProvince_StateProvinceID.md)|[PK_StateProvince_StateProvinceID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/782625831_PK_StateProvince_StateProvinceID.md)|
|[\[Person\].\[Address\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/693577509.md)|[FK_Address_StateProvince_StateProvinceID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_693577509_FK_Address_StateProvince_StateProvinceID.md)|[PK_StateProvince_StateProvinceID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/782625831_PK_StateProvince_StateProvinceID.md)|

 Total: 2 table(s)

---
### Referenced tables
|Table |Primary key or unique constraint |Foreign key |
|-|-|-|
|[\[Person\].\[CountryRegion\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1157579162.md)|[PK_CountryRegion_CountryRegionCode](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1157579162_PK_CountryRegion_CountryRegionCode.md)|[FK_StateProvince_CountryRegion_CountryRegionCode](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_782625831_FK_StateProvince_CountryRegion_CountryRegionCode.md)|
|[\[Sales\].\[SalesTerritory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/94623380.md)|[PK_SalesTerritory_TerritoryID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/94623380_PK_SalesTerritory_TerritoryID.md)|[FK_StateProvince_SalesTerritory_TerritoryID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_782625831_FK_StateProvince_SalesTerritory_TerritoryID.md)|

 Total: 2 table(s)

---
### Triggers
 No triggers exist

---
### Data models
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/782625831_dm.md) to view data model

---
### Objects that depend on \[Person\].\[StateProvince\]
|Object name|Object type|Dep level|
|-|-|-|
|[\[Person\].\[Address\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/693577509.md)|Table|1|
|[\[Sales\].\[SalesTaxRate\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/14623095.md)|Table|1|
|[\[HumanResources\].\[vEmployee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1037246750.md)|View|1|
|[\[Sales\].\[vIndividualCustomer\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1085246921.md)|View|1|
|[\[Sales\].\[vSalesPerson\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1213247377.md)|View|1|
|[\[Person\].\[vStateProvinceCountryRegion\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1245247491.md)|View|1|
|[\[Sales\].\[vStoreWithAddresses\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1293247662.md)|View|1|
|[\[Purchasing\].\[vVendorWithAddresses\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1325247776.md)|View|1|

 Total 8 object(s)

---
### Objects that \[Person\].\[StateProvince\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/6.md)|Schema|1|
|[\[Person\].\[CountryRegion\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1157579162.md)|Table|1|
|[\[Sales\].\[SalesTerritory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/94623380.md)|Table|1|
|[\[dbo\].\[Flag\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/258.md)|Datatype|1|
|[\[dbo\].\[Name\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/260.md)|Datatype|1|

 Total 5 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[Person\].\[CountryRegion\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1157579162.md)|CountryRegionCode|Table|
|[\[Sales\].\[SalesTerritory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/94623380.md)|TerritoryID|Table|

 Total 2 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/782625831_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|State and province lookup table.|

---
###  Permissions
No permissions defined

---
### Table options
|Name |Value |
|-|-|
|Pintable|OFF|
|Table lock on bulk load|OFF|
|Insert row lock|OFF|
|Text in row|0|
|Large value types out of row|OFF|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING ON
GO
CREATE TABLE [Person].[StateProvince] (
        [StateProvinceID]             [int] IDENTITY(1, 1) NOT NULL,
        [StateProvinceCode]           [nchar](3) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [CountryRegionCode]           [nvarchar](3) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [IsOnlyStateProvinceFlag]     [dbo].[Flag] NOT NULL,
        [Name]                        [dbo].[Name] NOT NULL,
        [TerritoryID]                 [int] NOT NULL,
        [rowguid]                     [uniqueidentifier] NOT NULL ROWGUIDCOL,
        [ModifiedDate]                [datetime] NOT NULL,
        CONSTRAINT [PK_StateProvince_StateProvinceID]
        PRIMARY KEY
        CLUSTERED
        ([StateProvinceID])
    ON [PRIMARY]
) ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Clustered index created by a primary key constraint.', 'SCHEMA', N'Person', 'TABLE', N'StateProvince', 'INDEX', N'PK_StateProvince_StateProvinceID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key (clustered) constraint', 'SCHEMA', N'Person', 'TABLE', N'StateProvince', 'CONSTRAINT', N'PK_StateProvince_StateProvinceID'
GO
ALTER TABLE [Person].[StateProvince]
    ADD
    CONSTRAINT [DF_StateProvince_IsOnlyStateProvinceFlag]
    DEFAULT ((1)) FOR [IsOnlyStateProvinceFlag]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of 1 (TRUE)', 'SCHEMA', N'Person', 'TABLE', N'StateProvince', 'CONSTRAINT', N'DF_StateProvince_IsOnlyStateProvinceFlag'
GO
ALTER TABLE [Person].[StateProvince]
    ADD
    CONSTRAINT [DF_StateProvince_rowguid]
    DEFAULT (newid()) FOR [rowguid]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of NEWID()', 'SCHEMA', N'Person', 'TABLE', N'StateProvince', 'CONSTRAINT', N'DF_StateProvince_rowguid'
GO
ALTER TABLE [Person].[StateProvince]
    ADD
    CONSTRAINT [DF_StateProvince_ModifiedDate]
    DEFAULT (getdate()) FOR [ModifiedDate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of GETDATE()', 'SCHEMA', N'Person', 'TABLE', N'StateProvince', 'CONSTRAINT', N'DF_StateProvince_ModifiedDate'
GO
ALTER TABLE [Person].[StateProvince]
    WITH CHECK
    ADD CONSTRAINT [FK_StateProvince_CountryRegion_CountryRegionCode]
    FOREIGN KEY ([CountryRegionCode]) REFERENCES [Person].[CountryRegion] ([CountryRegionCode])
ALTER TABLE [Person].[StateProvince]
    CHECK CONSTRAINT [FK_StateProvince_CountryRegion_CountryRegionCode]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing CountryRegion.CountryRegionCode.', 'SCHEMA', N'Person', 'TABLE', N'StateProvince', 'CONSTRAINT', N'FK_StateProvince_CountryRegion_CountryRegionCode'
GO
ALTER TABLE [Person].[StateProvince]
    WITH CHECK
    ADD CONSTRAINT [FK_StateProvince_SalesTerritory_TerritoryID]
    FOREIGN KEY ([TerritoryID]) REFERENCES [Sales].[SalesTerritory] ([TerritoryID])
ALTER TABLE [Person].[StateProvince]
    CHECK CONSTRAINT [FK_StateProvince_SalesTerritory_TerritoryID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing SalesTerritory.TerritoryID.', 'SCHEMA', N'Person', 'TABLE', N'StateProvince', 'CONSTRAINT', N'FK_StateProvince_SalesTerritory_TerritoryID'
GO
CREATE UNIQUE NONCLUSTERED INDEX [AK_StateProvince_Name]
    ON [Person].[StateProvince] ([Name])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique nonclustered index.', 'SCHEMA', N'Person', 'TABLE', N'StateProvince', 'INDEX', N'AK_StateProvince_Name'
GO
CREATE UNIQUE NONCLUSTERED INDEX [AK_StateProvince_StateProvinceCode_CountryRegionCode]
    ON [Person].[StateProvince] ([StateProvinceCode], [CountryRegionCode])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique nonclustered index.', 'SCHEMA', N'Person', 'TABLE', N'StateProvince', 'INDEX', N'AK_StateProvince_StateProvinceCode_CountryRegionCode'
GO
CREATE UNIQUE NONCLUSTERED INDEX [AK_StateProvince_rowguid]
    ON [Person].[StateProvince] ([rowguid])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique nonclustered index. Used to support replication samples.', 'SCHEMA', N'Person', 'TABLE', N'StateProvince', 'INDEX', N'AK_StateProvince_rowguid'
GO
EXEC sp_addextendedproperty N'MS_Description', N'State and province lookup table.', 'SCHEMA', N'Person', 'TABLE', N'StateProvince', NULL, NULL
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key for StateProvince records.', 'SCHEMA', N'Person', 'TABLE', N'StateProvince', 'COLUMN', N'StateProvinceID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'ISO standard state or province code.', 'SCHEMA', N'Person', 'TABLE', N'StateProvince', 'COLUMN', N'StateProvinceCode'
GO
EXEC sp_addextendedproperty N'MS_Description', N'ISO standard country or region code. Foreign key to CountryRegion.CountryRegionCode. ', 'SCHEMA', N'Person', 'TABLE', N'StateProvince', 'COLUMN', N'CountryRegionCode'
GO
EXEC sp_addextendedproperty N'MS_Description', N'0 = StateProvinceCode exists. 1 = StateProvinceCode unavailable, using CountryRegionCode.', 'SCHEMA', N'Person', 'TABLE', N'StateProvince', 'COLUMN', N'IsOnlyStateProvinceFlag'
GO
EXEC sp_addextendedproperty N'MS_Description', N'State or province description.', 'SCHEMA', N'Person', 'TABLE', N'StateProvince', 'COLUMN', N'Name'
GO
EXEC sp_addextendedproperty N'MS_Description', N'ID of the territory in which the state or province is located. Foreign key to SalesTerritory.SalesTerritoryID.', 'SCHEMA', N'Person', 'TABLE', N'StateProvince', 'COLUMN', N'TerritoryID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'ROWGUIDCOL number uniquely identifying the record. Used to support a merge replication sample.', 'SCHEMA', N'Person', 'TABLE', N'StateProvince', 'COLUMN', N'rowguid'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date and time the record was last updated.', 'SCHEMA', N'Person', 'TABLE', N'StateProvince', 'COLUMN', N'ModifiedDate'
GO
  
~~~

---
### See also
[List of tables](../tables.md)

