## ![](../../../../Images32x32Metro/OBJECT_TABLE.png "") Table:\[AdventureWorks2016CTP3\].\[dbo\].\[AWBuildVersion\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > **AWBuildVersion**

---
###  Description  
 Current version number of the AdventureWorks 2014 sample database. 



---
### Table properties
|Name |Value |
|-|-|
| Schema |[\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/1.md)|
| Owner |[\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md)|
| Table is replicated |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Creation date |10/23/2015|
| ID |789577851|
| Located on |PRIMARY|
| Data size KB |8 KB|
| Index size KB |8 KB|
| Rows |1   |
| ChangeTrackingEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| FileStreamFileGroup | |
| FileStreamPartitionScheme | |
| LockEscalation |TABLE|
| TrackColumnsUpdatedEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Table is filetable |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Filetable directory | |
| Filetable collate | |
| Filetable primary key |\[PK_AWBuildVersion_SystemInformationID\]|
| Filetable streamid unique | |
| Filetable fullpath unique | |
| Filetable is enabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is memory optimized |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Durability |SCHEMA_AND_DATA|

---
### Creation options
|Name |Value |
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|
|ANSI_PADDING|ON|

---
### Columns
| | |Name |Description |IsComputed|Data type |Max length |Nullable |Default|IsGUID |SPARSE|Computed value|
|-|-|-|-|-|-|-|-|-|-|-|-|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|![Identity](../../../../ImagesMetro/FILTER_Identity.gif "")|SystemInformationID|Primary key for AWBuildVersion records.| |tinyint|1|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |Database Version|Version number of the database in 9.yy.mm.dd.00 format.| |nvarchar|25|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |VersionDate|Date and time the record was last updated.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |ModifiedDate|Date and time the record was last updated.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|(getdate())|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|

 Total: 4 column(s)

---
### Text column statistics
|Name |Data type |Avg. length |Min. length |Max. length |Usage rating |
|-|-|-|-|-|-|
|Database Version|nvarchar(25) |8|8|8|0.16000000000000|

 Total: 1 text column(s)

---
### Indexes
|Index |Key columns |Description |Primary |Unique |Size KB |Fill factor |
|-|-|-|-|-|-|-|
|[\[PK_AWBuildVersion_SystemInformationID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/789577851_PK_AWBuildVersion_SystemInformationID.md)|SystemInformationID|Primary key (clustered) constraint|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|16|0|

 Total: 1 Index/indexes

---
### Columnstore indexes
 No columnstore indexes exist

---
### Fulltext index
 No fulltext index exist

---
### Statistics
 No statistics exist

---
### Check constraints
 No check constraints exist

---
### Identity column
| |Name |Seed |Increment |Not for replication |
|-|-|-|-|-|
|![](../../../../ImagesMetro/FILTER_Identity.gif "")| SystemInformationID | 1 | 1 |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Referencing tables
 No referencing tables exist

---
### Referenced tables
 No referenced tables exist

---
### Triggers
 No triggers exist

---
### Data models
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/789577851_dm.md) to view data model

---
### Objects that depend on \[dbo\].\[AWBuildVersion\]
 No dependencies exist

---
### Objects that \[dbo\].\[AWBuildVersion\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Current version number of the AdventureWorks 2014 sample database. |

---
###  Permissions
No permissions defined

---
### Table options
|Name |Value |
|-|-|
|Pintable|OFF|
|Table lock on bulk load|OFF|
|Insert row lock|OFF|
|Text in row|0|
|Large value types out of row|OFF|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING ON
GO
CREATE TABLE [dbo].[AWBuildVersion] (
        [SystemInformationID]     [tinyint] IDENTITY(1, 1) NOT NULL,
        [Database Version]        [nvarchar](25) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [VersionDate]             [datetime] NOT NULL,
        [ModifiedDate]            [datetime] NOT NULL,
        CONSTRAINT [PK_AWBuildVersion_SystemInformationID]
        PRIMARY KEY
        CLUSTERED
        ([SystemInformationID])
    ON [PRIMARY]
) ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Clustered index created by a primary key constraint.', 'SCHEMA', N'dbo', 'TABLE', N'AWBuildVersion', 'INDEX', N'PK_AWBuildVersion_SystemInformationID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key (clustered) constraint', 'SCHEMA', N'dbo', 'TABLE', N'AWBuildVersion', 'CONSTRAINT', N'PK_AWBuildVersion_SystemInformationID'
GO
ALTER TABLE [dbo].[AWBuildVersion]
    ADD
    CONSTRAINT [DF_AWBuildVersion_ModifiedDate]
    DEFAULT (getdate()) FOR [ModifiedDate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of GETDATE()', 'SCHEMA', N'dbo', 'TABLE', N'AWBuildVersion', 'CONSTRAINT', N'DF_AWBuildVersion_ModifiedDate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Current version number of the AdventureWorks 2014 sample database. ', 'SCHEMA', N'dbo', 'TABLE', N'AWBuildVersion', NULL, NULL
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key for AWBuildVersion records.', 'SCHEMA', N'dbo', 'TABLE', N'AWBuildVersion', 'COLUMN', N'SystemInformationID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Version number of the database in 9.yy.mm.dd.00 format.', 'SCHEMA', N'dbo', 'TABLE', N'AWBuildVersion', 'COLUMN', N'Database Version'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date and time the record was last updated.', 'SCHEMA', N'dbo', 'TABLE', N'AWBuildVersion', 'COLUMN', N'VersionDate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date and time the record was last updated.', 'SCHEMA', N'dbo', 'TABLE', N'AWBuildVersion', 'COLUMN', N'ModifiedDate'
GO
  
~~~

---
### See also
[List of tables](../tables.md)

