## ![](../../../../Images32x32Metro/OBJECT_TABLE.png "") Table:\[AdventureWorks2016CTP3\].\[Production\].\[BillOfMaterials\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > **Production.BillOfMaterials**

---
###  Description  
 Items required to make bicycles and bicycle subassemblies. It identifies the heirarchical relationship between a parent product and its components. 



---
### Table properties
|Name |Value |
|-|-|
| Schema |[\[Production\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/7.md)|
| Owner |[\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md)|
| Table is replicated |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Creation date |10/23/2015|
| ID |821577965|
| Located on |PRIMARY|
| Data size KB |160 KB|
| Index size KB |200 KB|
| Rows |2679|
| ChangeTrackingEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| FileStreamFileGroup | |
| FileStreamPartitionScheme | |
| LockEscalation |TABLE|
| TrackColumnsUpdatedEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Table is filetable |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Filetable directory | |
| Filetable collate | |
| Filetable primary key |\[PK_BillOfMaterials_BillOfMaterialsID\]|
| Filetable streamid unique | |
| Filetable fullpath unique | |
| Filetable is enabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is memory optimized |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Durability |SCHEMA_AND_DATA|

---
### Creation options
|Name |Value |
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|
|ANSI_PADDING|ON|

---
### Columns
| | | |Name |Description |IsComputed|Data type |Max length |Nullable |Default|IsGUID |SPARSE|Computed value|
|-|-|-|-|-|-|-|-|-|-|-|-|-|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|![Identity](../../../../ImagesMetro/FILTER_Identity.gif "")| |BillOfMaterialsID|Primary key for BillOfMaterials records.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_821577965_FK_BillOfMaterials_Product_ProductAssemblyID.md)|ProductAssemblyID|Parent product identification number. Foreign key to Product.ProductID.| |int|4|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_821577965_FK_BillOfMaterials_Product_ComponentID.md)|ComponentID|Component identification number. Foreign key to Product.ProductID.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |StartDate|Date the component started being used in the assembly item.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|(getdate())|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |EndDate|Date the component stopped being used in the assembly item.| |datetime|8|![](../../../../ImagesMetro/CHECK_OUT.png "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |[](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_821577965_FK_BillOfMaterials_UnitMeasure_UnitMeasureCode.md)|UnitMeasureCode|Standard code identifying the unit of measure for the quantity.| |nchar|3|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |BOMLevel|Indicates the depth the component is from its parent (AssemblyID).| |smallint|2|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |PerAssemblyQty|Quantity of the component needed to create the assembly.| |decimal|5|![](../../../../ImagesMetro/RED_CROSS.gif "")|((1.00))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | | |ModifiedDate|Date and time the record was last updated.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|(getdate())|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|

 Total: 9 column(s)

---
### Text column statistics
|Name |Data type |Avg. length |Min. length |Max. length |Usage rating |
|-|-|-|-|-|-|
|UnitMeasureCode|nchar(3) |2|2|2|0.33333333333333|

 Total: 1 text column(s)

---
### Indexes
|Index |Key columns |Description |Primary |Unique |Size KB |Fill factor |
|-|-|-|-|-|-|-|
|[\[PK_BillOfMaterials_BillOfMaterialsID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/821577965_PK_BillOfMaterials_BillOfMaterialsID.md)|BillOfMaterialsID|Primary key (clustered) constraint|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|88|0|
|[\[AK_BillOfMaterials_ProductAssemblyID_ComponentID_StartDate\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/821577965_AK_BillOfMaterials_ProductAssemblyID_ComponentID_StartDate.md)|ProductAssemblyID, ComponentID, StartDate|Clustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|360|0|
|[\[IX_BillOfMaterials_UnitMeasureCode\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/821577965_IX_BillOfMaterials_UnitMeasureCode.md)|UnitMeasureCode|Nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|96|0|

 Total: 3 Index/indexes

---
### Columnstore indexes
 No columnstore indexes exist

---
### Fulltext index
 No fulltext index exist

---
### Statistics
 No statistics exist

---
### Check constraints
|Name |Expression |
|-|-|
|CK_BillOfMaterials_EndDate|(\[EndDate\]&gt;\[StartDate\] OR \[EndDate\] IS NULL)|
|CK_BillOfMaterials_ProductAssemblyID|(\[ProductAssemblyID\]&lt;&gt;\[ComponentID\])|
|CK_BillOfMaterials_BOMLevel|(\[ProductAssemblyID\] IS NULL AND \[BOMLevel\]=(0) AND \[PerAssemblyQty\]=(1.00) OR \[ProductAssemblyID\] IS NOT NULL AND \[BOMLevel\]&gt;=(1))|
|CK_BillOfMaterials_PerAssemblyQty|(\[PerAssemblyQty\]&gt;=(1.00))|

---
### Identity column
| |Name |Seed |Increment |Not for replication |
|-|-|-|-|-|
|![](../../../../ImagesMetro/FILTER_Identity.gif "")| BillOfMaterialsID | 1 | 1 |![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Referencing tables
 No referencing tables exist

---
### Referenced tables
|Table |Primary key or unique constraint |Foreign key |
|-|-|-|
|[\[Production\].\[Product\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/146099561.md)|[PK_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/146099561_PK_Product_ProductID.md)|[FK_BillOfMaterials_Product_ProductAssemblyID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_821577965_FK_BillOfMaterials_Product_ProductAssemblyID.md)|
|[\[Production\].\[Product\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/146099561.md)|[PK_Product_ProductID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/146099561_PK_Product_ProductID.md)|[FK_BillOfMaterials_Product_ComponentID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_821577965_FK_BillOfMaterials_Product_ComponentID.md)|
|[\[Production\].\[UnitMeasure\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1054626800.md)|[PK_UnitMeasure_UnitMeasureCode](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/1054626800_PK_UnitMeasure_UnitMeasureCode.md)|[FK_BillOfMaterials_UnitMeasure_UnitMeasureCode](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_821577965_FK_BillOfMaterials_UnitMeasure_UnitMeasureCode.md)|

 Total: 3 table(s)

---
### Triggers
 No triggers exist

---
### Data models
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/821577965_dm.md) to view data model

---
### Objects that depend on \[Production\].\[BillOfMaterials\]
|Object name|Object type|Dep level|
|-|-|-|
|[\[dbo\].\[uspGetBillOfMaterials\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1501248403.md)|Procedure|1|
|[\[dbo\].\[uspGetWhereUsedProductID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1549248574.md)|Procedure|1|

 Total 2 object(s)

---
### Objects that \[Production\].\[BillOfMaterials\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Production\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/7.md)|Schema|1|
|[\[Production\].\[Product\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/146099561.md)|Table|1|
|[\[Production\].\[UnitMeasure\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1054626800.md)|Table|1|

 Total 3 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[Production\].\[Product\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/146099561.md)|ProductID|Table|
|[\[Production\].\[UnitMeasure\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1054626800.md)|UnitMeasureCode|Table|

 Total 2 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/821577965_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Items required to make bicycles and bicycle subassemblies. It identifies the heirarchical relationship between a parent product and its components.|

---
###  Permissions
No permissions defined

---
### Table options
|Name |Value |
|-|-|
|Pintable|OFF|
|Table lock on bulk load|OFF|
|Insert row lock|OFF|
|Text in row|0|
|Large value types out of row|OFF|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING ON
GO
CREATE TABLE [Production].[BillOfMaterials] (
        [BillOfMaterialsID]     [int] IDENTITY(1, 1) NOT NULL,
        [ProductAssemblyID]     [int] NULL,
        [ComponentID]           [int] NOT NULL,
        [StartDate]             [datetime] NOT NULL,
        [EndDate]               [datetime] NULL,
        [UnitMeasureCode]       [nchar](3) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [BOMLevel]              [smallint] NOT NULL,
        [PerAssemblyQty]        [decimal](8, 2) NOT NULL,
        [ModifiedDate]          [datetime] NOT NULL,
        CONSTRAINT [PK_BillOfMaterials_BillOfMaterialsID]
        PRIMARY KEY
        NONCLUSTERED
        ([BillOfMaterialsID])
    ON [PRIMARY]
) ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Nonclustered index created by a primary key constraint.', 'SCHEMA', N'Production', 'TABLE', N'BillOfMaterials', 'INDEX', N'PK_BillOfMaterials_BillOfMaterialsID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key (clustered) constraint', 'SCHEMA', N'Production', 'TABLE', N'BillOfMaterials', 'CONSTRAINT', N'PK_BillOfMaterials_BillOfMaterialsID'
GO
ALTER TABLE [Production].[BillOfMaterials]
    ADD
    CONSTRAINT [CK_BillOfMaterials_EndDate]
    CHECK
    ([EndDate]&gt;[StartDate] OR [EndDate] IS NULL)
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint EndDate] &gt; [StartDate] OR [EndDate] IS NULL', 'SCHEMA', N'Production', 'TABLE', N'BillOfMaterials', 'CONSTRAINT', N'CK_BillOfMaterials_EndDate'
GO
ALTER TABLE [Production].[BillOfMaterials]
CHECK CONSTRAINT [CK_BillOfMaterials_EndDate]
GO
ALTER TABLE [Production].[BillOfMaterials]
    ADD
    CONSTRAINT [CK_BillOfMaterials_ProductAssemblyID]
    CHECK
    ([ProductAssemblyID]&lt;&gt;[ComponentID])
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [ProductAssemblyID] &lt;&gt; [ComponentID]', 'SCHEMA', N'Production', 'TABLE', N'BillOfMaterials', 'CONSTRAINT', N'CK_BillOfMaterials_ProductAssemblyID'
GO
ALTER TABLE [Production].[BillOfMaterials]
CHECK CONSTRAINT [CK_BillOfMaterials_ProductAssemblyID]
GO
ALTER TABLE [Production].[BillOfMaterials]
    ADD
    CONSTRAINT [CK_BillOfMaterials_BOMLevel]
    CHECK
    ([ProductAssemblyID] IS NULL AND [BOMLevel]=(0) AND [PerAssemblyQty]=(1.00) OR [ProductAssemblyID] IS NOT NULL AND [BOMLevel]&gt;=(1))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [ProductAssemblyID] IS NULL AND [BOMLevel] = (0) AND [PerAssemblyQty] = (1) OR [ProductAssemblyID] IS NOT NULL AND [BOMLevel] &gt;= (1)', 'SCHEMA', N'Production', 'TABLE', N'BillOfMaterials', 'CONSTRAINT', N'CK_BillOfMaterials_BOMLevel'
GO
ALTER TABLE [Production].[BillOfMaterials]
CHECK CONSTRAINT [CK_BillOfMaterials_BOMLevel]
GO
ALTER TABLE [Production].[BillOfMaterials]
    ADD
    CONSTRAINT [CK_BillOfMaterials_PerAssemblyQty]
    CHECK
    ([PerAssemblyQty]&gt;=(1.00))
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [PerAssemblyQty] &gt;= (1.00)', 'SCHEMA', N'Production', 'TABLE', N'BillOfMaterials', 'CONSTRAINT', N'CK_BillOfMaterials_PerAssemblyQty'
GO
ALTER TABLE [Production].[BillOfMaterials]
CHECK CONSTRAINT [CK_BillOfMaterials_PerAssemblyQty]
GO
ALTER TABLE [Production].[BillOfMaterials]
    ADD
    CONSTRAINT [DF_BillOfMaterials_StartDate]
    DEFAULT (getdate()) FOR [StartDate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of GETDATE()', 'SCHEMA', N'Production', 'TABLE', N'BillOfMaterials', 'CONSTRAINT', N'DF_BillOfMaterials_StartDate'
GO
ALTER TABLE [Production].[BillOfMaterials]
    ADD
    CONSTRAINT [DF_BillOfMaterials_PerAssemblyQty]
    DEFAULT ((1.00)) FOR [PerAssemblyQty]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of 1.0', 'SCHEMA', N'Production', 'TABLE', N'BillOfMaterials', 'CONSTRAINT', N'DF_BillOfMaterials_PerAssemblyQty'
GO
ALTER TABLE [Production].[BillOfMaterials]
    ADD
    CONSTRAINT [DF_BillOfMaterials_ModifiedDate]
    DEFAULT (getdate()) FOR [ModifiedDate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of GETDATE()', 'SCHEMA', N'Production', 'TABLE', N'BillOfMaterials', 'CONSTRAINT', N'DF_BillOfMaterials_ModifiedDate'
GO
ALTER TABLE [Production].[BillOfMaterials]
    WITH CHECK
    ADD CONSTRAINT [FK_BillOfMaterials_Product_ProductAssemblyID]
    FOREIGN KEY ([ProductAssemblyID]) REFERENCES [Production].[Product] ([ProductID])
ALTER TABLE [Production].[BillOfMaterials]
    CHECK CONSTRAINT [FK_BillOfMaterials_Product_ProductAssemblyID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing Product.ProductAssemblyID.', 'SCHEMA', N'Production', 'TABLE', N'BillOfMaterials', 'CONSTRAINT', N'FK_BillOfMaterials_Product_ProductAssemblyID'
GO
ALTER TABLE [Production].[BillOfMaterials]
    WITH CHECK
    ADD CONSTRAINT [FK_BillOfMaterials_Product_ComponentID]
    FOREIGN KEY ([ComponentID]) REFERENCES [Production].[Product] ([ProductID])
ALTER TABLE [Production].[BillOfMaterials]
    CHECK CONSTRAINT [FK_BillOfMaterials_Product_ComponentID]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing Product.ComponentID.', 'SCHEMA', N'Production', 'TABLE', N'BillOfMaterials', 'CONSTRAINT', N'FK_BillOfMaterials_Product_ComponentID'
GO
ALTER TABLE [Production].[BillOfMaterials]
    WITH CHECK
    ADD CONSTRAINT [FK_BillOfMaterials_UnitMeasure_UnitMeasureCode]
    FOREIGN KEY ([UnitMeasureCode]) REFERENCES [Production].[UnitMeasure] ([UnitMeasureCode])
ALTER TABLE [Production].[BillOfMaterials]
    CHECK CONSTRAINT [FK_BillOfMaterials_UnitMeasure_UnitMeasureCode]

GO
EXEC sp_addextendedproperty N'MS_Description', N'Foreign key constraint referencing UnitMeasure.UnitMeasureCode.', 'SCHEMA', N'Production', 'TABLE', N'BillOfMaterials', 'CONSTRAINT', N'FK_BillOfMaterials_UnitMeasure_UnitMeasureCode'
GO
CREATE UNIQUE CLUSTERED INDEX [AK_BillOfMaterials_ProductAssemblyID_ComponentID_StartDate]
    ON [Production].[BillOfMaterials] ([ProductAssemblyID], [ComponentID], [StartDate])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Clustered index.', 'SCHEMA', N'Production', 'TABLE', N'BillOfMaterials', 'INDEX', N'AK_BillOfMaterials_ProductAssemblyID_ComponentID_StartDate'
GO
CREATE NONCLUSTERED INDEX [IX_BillOfMaterials_UnitMeasureCode]
    ON [Production].[BillOfMaterials] ([UnitMeasureCode])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Nonclustered index.', 'SCHEMA', N'Production', 'TABLE', N'BillOfMaterials', 'INDEX', N'IX_BillOfMaterials_UnitMeasureCode'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Items required to make bicycles and bicycle subassemblies. It identifies the heirarchical relationship between a parent product and its components.', 'SCHEMA', N'Production', 'TABLE', N'BillOfMaterials', NULL, NULL
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key for BillOfMaterials records.', 'SCHEMA', N'Production', 'TABLE', N'BillOfMaterials', 'COLUMN', N'BillOfMaterialsID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Parent product identification number. Foreign key to Product.ProductID.', 'SCHEMA', N'Production', 'TABLE', N'BillOfMaterials', 'COLUMN', N'ProductAssemblyID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Component identification number. Foreign key to Product.ProductID.', 'SCHEMA', N'Production', 'TABLE', N'BillOfMaterials', 'COLUMN', N'ComponentID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date the component started being used in the assembly item.', 'SCHEMA', N'Production', 'TABLE', N'BillOfMaterials', 'COLUMN', N'StartDate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date the component stopped being used in the assembly item.', 'SCHEMA', N'Production', 'TABLE', N'BillOfMaterials', 'COLUMN', N'EndDate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Standard code identifying the unit of measure for the quantity.', 'SCHEMA', N'Production', 'TABLE', N'BillOfMaterials', 'COLUMN', N'UnitMeasureCode'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Indicates the depth the component is from its parent (AssemblyID).', 'SCHEMA', N'Production', 'TABLE', N'BillOfMaterials', 'COLUMN', N'BOMLevel'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Quantity of the component needed to create the assembly.', 'SCHEMA', N'Production', 'TABLE', N'BillOfMaterials', 'COLUMN', N'PerAssemblyQty'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date and time the record was last updated.', 'SCHEMA', N'Production', 'TABLE', N'BillOfMaterials', 'COLUMN', N'ModifiedDate'
GO
  
~~~

---
### See also
[List of tables](../tables.md)

