## ![](../../../../Images32x32Metro/OBJECT_TABLE.png "") Table:\[AdventureWorks2016CTP3\].\[Person\].\[BusinessEntity\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > **Person.BusinessEntity**

---
###  Description  
 Source of the ID that connects vendors, customers, and employees with address and contact information. 



---
### Table properties
|Name |Value |
|-|-|
| Schema |[\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/6.md)|
| Owner |[\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md)|
| Table is replicated |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Creation date |10/23/2015|
| ID |949578421|
| Located on |PRIMARY|
| Data size KB |768 KB|
| Index size KB |568 KB|
| Rows |20777   |
| ChangeTrackingEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| FileStreamFileGroup | |
| FileStreamPartitionScheme | |
| LockEscalation |TABLE|
| TrackColumnsUpdatedEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Table is filetable |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Filetable directory | |
| Filetable collate | |
| Filetable primary key |\[PK_BusinessEntity_BusinessEntityID\]|
| Filetable streamid unique | |
| Filetable fullpath unique | |
| Filetable is enabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is memory optimized |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Durability |SCHEMA_AND_DATA|

---
### Creation options
|Name |Value |
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|
|ANSI_PADDING|OFF|

---
### Columns
| | |Name |Description |IsComputed|Data type |Max length |Nullable |Default|IsGUID |SPARSE|Computed value|
|-|-|-|-|-|-|-|-|-|-|-|-|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|![Identity](../../../../ImagesMetro/FILTER_Identity.gif "")|BusinessEntityID|Primary key for all customers, vendors, and employees.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |rowguid|ROWGUIDCOL number uniquely identifying the record. Used to support a merge replication sample.| |uniqueidentifier|16|![](../../../../ImagesMetro/RED_CROSS.gif "")|(newid())|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| | |ModifiedDate|Date and time the record was last updated.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|(getdate())|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|

 Total: 3 column(s)

---
### Indexes
|Index |Key columns |Description |Primary |Unique |Size KB |Fill factor |
|-|-|-|-|-|-|-|
|[\[PK_BusinessEntity_BusinessEntityID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/949578421_PK_BusinessEntity_BusinessEntityID.md)|BusinessEntityID|Primary key (clustered) constraint|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|1336|0|
|[\[AK_BusinessEntity_rowguid\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/949578421_AK_BusinessEntity_rowguid.md)|rowguid|Unique nonclustered index. Used to support replication samples.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|552|0|

 Total: 2 Index/indexes

---
### Columnstore indexes
 No columnstore indexes exist

---
### Fulltext index
 No fulltext index exist

---
### Statistics
 No statistics exist

---
### Check constraints
 No check constraints exist

---
### Identity column
| |Name |Seed |Increment |Not for replication |
|-|-|-|-|-|
|![](../../../../ImagesMetro/FILTER_Identity.gif "")| BusinessEntityID | 1 | 1 |![](../../../../ImagesMetro/CHECK_OUT.png "")|

---
### Referencing tables
|Table |Foreign key |Primary key or unique constraint |
|-|-|-|
|[\[Sales\].\[Store\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/846626059.md)|[FK_Store_BusinessEntity_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_846626059_FK_Store_BusinessEntity_BusinessEntityID.md)|[PK_BusinessEntity_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/949578421_PK_BusinessEntity_BusinessEntityID.md)|
|[\[Person\].\[BusinessEntityAddress\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/997578592.md)|[FK_BusinessEntityAddress_BusinessEntity_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_997578592_FK_BusinessEntityAddress_BusinessEntity_BusinessEntityID.md)|[PK_BusinessEntity_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/949578421_PK_BusinessEntity_BusinessEntityID.md)|
|[\[Person\].\[BusinessEntityContact\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1045578763.md)|[FK_BusinessEntityContact_BusinessEntity_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1045578763_FK_BusinessEntityContact_BusinessEntity_BusinessEntityID.md)|[PK_BusinessEntity_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/949578421_PK_BusinessEntity_BusinessEntityID.md)|
|[\[Purchasing\].\[Vendor\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1086626914.md)|[FK_Vendor_BusinessEntity_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_1086626914_FK_Vendor_BusinessEntity_BusinessEntityID.md)|[PK_BusinessEntity_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/949578421_PK_BusinessEntity_BusinessEntityID.md)|
|[\[Person\].\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|[FK_Person_BusinessEntity_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Relationships/relationship_2085582468_FK_Person_BusinessEntity_BusinessEntityID.md)|[PK_BusinessEntity_BusinessEntityID](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/949578421_PK_BusinessEntity_BusinessEntityID.md)|

 Total: 5 table(s)

---
### Referenced tables
 No referenced tables exist

---
### Triggers
 No triggers exist

---
### Data models
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/949578421_dm.md) to view data model

---
### Objects that depend on \[Person\].\[BusinessEntity\]
|Object name|Object type|Dep level|
|-|-|-|
|[\[Person\].\[BusinessEntityAddress\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/997578592.md)|Table|1|
|[\[Person\].\[BusinessEntityContact\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1045578763.md)|Table|1|
|[\[Person\].\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|Table|1|
|[\[Sales\].\[Store\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/846626059.md)|Table|1|
|[\[Purchasing\].\[Vendor\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1086626914.md)|Table|1|

 Total 5 object(s)

---
### Objects that \[Person\].\[BusinessEntity\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/6.md)|Schema|1|

 Total 1 object(s)

---
### Column level dependencies
 No dependencies exist

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/949578421_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Source of the ID that connects vendors, customers, and employees with address and contact information.|

---
###  Permissions
No permissions defined

---
### Table options
|Name |Value |
|-|-|
|Pintable|OFF|
|Table lock on bulk load|OFF|
|Insert row lock|OFF|
|Text in row|0|
|Large value types out of row|OFF|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING OFF
GO
CREATE TABLE [Person].[BusinessEntity] (
        [BusinessEntityID]     [int] IDENTITY(1, 1) NOT FOR REPLICATION NOT NULL,
        [rowguid]              [uniqueidentifier] NOT NULL ROWGUIDCOL,
        [ModifiedDate]         [datetime] NOT NULL,
        CONSTRAINT [PK_BusinessEntity_BusinessEntityID]
        PRIMARY KEY
        CLUSTERED
        ([BusinessEntityID])
    ON [PRIMARY]
) ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Clustered index created by a primary key constraint.', 'SCHEMA', N'Person', 'TABLE', N'BusinessEntity', 'INDEX', N'PK_BusinessEntity_BusinessEntityID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key (clustered) constraint', 'SCHEMA', N'Person', 'TABLE', N'BusinessEntity', 'CONSTRAINT', N'PK_BusinessEntity_BusinessEntityID'
GO
ALTER TABLE [Person].[BusinessEntity]
    ADD
    CONSTRAINT [DF_BusinessEntity_rowguid]
    DEFAULT (newid()) FOR [rowguid]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of NEWID()', 'SCHEMA', N'Person', 'TABLE', N'BusinessEntity', 'CONSTRAINT', N'DF_BusinessEntity_rowguid'
GO
ALTER TABLE [Person].[BusinessEntity]
    ADD
    CONSTRAINT [DF_BusinessEntity_ModifiedDate]
    DEFAULT (getdate()) FOR [ModifiedDate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of GETDATE()', 'SCHEMA', N'Person', 'TABLE', N'BusinessEntity', 'CONSTRAINT', N'DF_BusinessEntity_ModifiedDate'
GO
CREATE UNIQUE NONCLUSTERED INDEX [AK_BusinessEntity_rowguid]
    ON [Person].[BusinessEntity] ([rowguid])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Unique nonclustered index. Used to support replication samples.', 'SCHEMA', N'Person', 'TABLE', N'BusinessEntity', 'INDEX', N'AK_BusinessEntity_rowguid'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Source of the ID that connects vendors, customers, and employees with address and contact information.', 'SCHEMA', N'Person', 'TABLE', N'BusinessEntity', NULL, NULL
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key for all customers, vendors, and employees.', 'SCHEMA', N'Person', 'TABLE', N'BusinessEntity', 'COLUMN', N'BusinessEntityID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'ROWGUIDCOL number uniquely identifying the record. Used to support a merge replication sample.', 'SCHEMA', N'Person', 'TABLE', N'BusinessEntity', 'COLUMN', N'rowguid'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date and time the record was last updated.', 'SCHEMA', N'Person', 'TABLE', N'BusinessEntity', 'COLUMN', N'ModifiedDate'
GO
  
~~~

---
### See also
[List of tables](../tables.md)

