## ![](../../../../Images32x32Metro/OBJECT_TABLE.png "") Table:\[AdventureWorks2016CTP3\].\[Production\].\[TransactionHistoryArchive\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > **Production.TransactionHistoryArchive**

---
###  Description  
 Transactions for previous years. 



---
### Table properties
|Name |Value |
|-|-|
| Schema |[\[Production\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/7.md)|
| Owner |[\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md)|
| Table is replicated |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Creation date |10/23/2015|
| ID |974626515|
| Located on |PRIMARY|
| Data size KB |5000 KB|
| Index size KB |3680 KB|
| Rows |89253   |
| ChangeTrackingEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| FileStreamFileGroup | |
| FileStreamPartitionScheme | |
| LockEscalation |TABLE|
| TrackColumnsUpdatedEnabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Table is filetable |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Filetable directory | |
| Filetable collate | |
| Filetable primary key |\[PK_TransactionHistoryArchive_TransactionID\]|
| Filetable streamid unique | |
| Filetable fullpath unique | |
| Filetable is enabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Is memory optimized |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Durability |SCHEMA_AND_DATA|

---
### Creation options
|Name |Value |
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|
|ANSI_PADDING|ON|

---
### Columns
| |Name |Description |IsComputed|Data type |Max length |Nullable |Default|IsGUID |SPARSE|Computed value|
|-|-|-|-|-|-|-|-|-|-|-|
|![Primary key](../../../../ImagesMetro/FIELD_NEW_PRIMARY.gif "")|TransactionID|Primary key for TransactionHistoryArchive records.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| |ProductID|Product identification number. Foreign key to Product.ProductID.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| |ReferenceOrderID|Purchase order, sales order, or work order identification number.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| |ReferenceOrderLineID|Line number associated with the purchase order, sales order, or work order.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")|((0))|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| |TransactionDate|Date and time of the transaction.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|(getdate())|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| |TransactionType|W = Work Order, S = Sales Order, P = Purchase Order| |nchar|1|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| |Quantity|Product quantity.| |int|4|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| |ActualCost|Product cost.| |money|8|![](../../../../ImagesMetro/RED_CROSS.gif "")| |![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|
| |ModifiedDate|Date and time the record was last updated.| |datetime|8|![](../../../../ImagesMetro/RED_CROSS.gif "")|(getdate())|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|&#xfeff;|

 Total: 9 column(s)

---
### Text column statistics
|Name |Data type |Avg. length |Min. length |Max. length |Usage rating |
|-|-|-|-|-|-|
|TransactionType|nchar(1) |1|1|1|0.50000000000000|

 Total: 1 text column(s)

---
### Indexes
|Index |Key columns |Description |Primary |Unique |Size KB |Fill factor |
|-|-|-|-|-|-|-|
|[\[PK_TransactionHistoryArchive_TransactionID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/974626515_PK_TransactionHistoryArchive_TransactionID.md)|TransactionID|Primary key (clustered) constraint|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|8680|0|
|[\[IX_TransactionHistoryArchive_ProductID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/974626515_IX_TransactionHistoryArchive_ProductID.md)|ProductID|Nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|1536|0|
|[\[IX_TransactionHistoryArchive_ReferenceOrderID_ReferenceOrderLineID\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/Indexes/974626515_IX_TransactionHistoryArchive_ReferenceOrderID_ReferenceOrderLineID.md)|ReferenceOrderID, ReferenceOrderLineID|Nonclustered index.|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|1920|0|

 Total: 3 Index/indexes

---
### Columnstore indexes
 No columnstore indexes exist

---
### Fulltext index
 No fulltext index exist

---
### Statistics
 No statistics exist

---
### Check constraints
|Name |Expression |
|-|-|
|CK_TransactionHistoryArchive_TransactionType|(upper(\[TransactionType\])=&#39;P&#39; OR upper(\[TransactionType\])=&#39;S&#39; OR upper(\[TransactionType\])=&#39;W&#39;)|

---
### Identity column
 No identity column exists

---
### Referencing tables
 No referencing tables exist

---
### Referenced tables
 No referenced tables exist

---
### Triggers
 No triggers exist

---
### Data models
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/974626515_dm.md) to view data model

---
### Objects that depend on \[Production\].\[TransactionHistoryArchive\]
 No dependencies exist

---
### Objects that \[Production\].\[TransactionHistoryArchive\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Production\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/7.md)|Schema|1|

 Total 1 object(s)

---
### Column level dependencies
 No dependencies exist

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/974626515_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Transactions for previous years.|

---
###  Permissions
No permissions defined

---
### Table options
|Name |Value |
|-|-|
|Pintable|OFF|
|Table lock on bulk load|OFF|
|Insert row lock|OFF|
|Text in row|0|
|Large value types out of row|OFF|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING ON
GO
CREATE TABLE [Production].[TransactionHistoryArchive] (
        [TransactionID]            [int] NOT NULL,
        [ProductID]                [int] NOT NULL,
        [ReferenceOrderID]         [int] NOT NULL,
        [ReferenceOrderLineID]     [int] NOT NULL,
        [TransactionDate]          [datetime] NOT NULL,
        [TransactionType]          [nchar](1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [Quantity]                 [int] NOT NULL,
        [ActualCost]               [money] NOT NULL,
        [ModifiedDate]             [datetime] NOT NULL,
        CONSTRAINT [PK_TransactionHistoryArchive_TransactionID]
        PRIMARY KEY
        CLUSTERED
        ([TransactionID])
    ON [PRIMARY]
) ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Clustered index created by a primary key constraint.', 'SCHEMA', N'Production', 'TABLE', N'TransactionHistoryArchive', 'INDEX', N'PK_TransactionHistoryArchive_TransactionID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key (clustered) constraint', 'SCHEMA', N'Production', 'TABLE', N'TransactionHistoryArchive', 'CONSTRAINT', N'PK_TransactionHistoryArchive_TransactionID'
GO
ALTER TABLE [Production].[TransactionHistoryArchive]
    ADD
    CONSTRAINT [CK_TransactionHistoryArchive_TransactionType]
    CHECK
    (upper([TransactionType])='P' OR upper([TransactionType])='S' OR upper([TransactionType])='W')
GO
EXEC sp_addextendedproperty N'MS_Description', N'Check constraint [TransactionType]=''p'' OR [TransactionType]=''s'' OR [TransactionType]=''w'' OR [TransactionType]=''P'' OR [TransactionType]=''S'' OR [TransactionType]=''W''', 'SCHEMA', N'Production', 'TABLE', N'TransactionHistoryArchive', 'CONSTRAINT', N'CK_TransactionHistoryArchive_TransactionType'
GO
ALTER TABLE [Production].[TransactionHistoryArchive]
CHECK CONSTRAINT [CK_TransactionHistoryArchive_TransactionType]
GO
ALTER TABLE [Production].[TransactionHistoryArchive]
    ADD
    CONSTRAINT [DF_TransactionHistoryArchive_ReferenceOrderLineID]
    DEFAULT ((0)) FOR [ReferenceOrderLineID]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of 0', 'SCHEMA', N'Production', 'TABLE', N'TransactionHistoryArchive', 'CONSTRAINT', N'DF_TransactionHistoryArchive_ReferenceOrderLineID'
GO
ALTER TABLE [Production].[TransactionHistoryArchive]
    ADD
    CONSTRAINT [DF_TransactionHistoryArchive_TransactionDate]
    DEFAULT (getdate()) FOR [TransactionDate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of GETDATE()', 'SCHEMA', N'Production', 'TABLE', N'TransactionHistoryArchive', 'CONSTRAINT', N'DF_TransactionHistoryArchive_TransactionDate'
GO
ALTER TABLE [Production].[TransactionHistoryArchive]
    ADD
    CONSTRAINT [DF_TransactionHistoryArchive_ModifiedDate]
    DEFAULT (getdate()) FOR [ModifiedDate]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Default constraint value of GETDATE()', 'SCHEMA', N'Production', 'TABLE', N'TransactionHistoryArchive', 'CONSTRAINT', N'DF_TransactionHistoryArchive_ModifiedDate'
GO
CREATE NONCLUSTERED INDEX [IX_TransactionHistoryArchive_ProductID]
    ON [Production].[TransactionHistoryArchive] ([ProductID])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Nonclustered index.', 'SCHEMA', N'Production', 'TABLE', N'TransactionHistoryArchive', 'INDEX', N'IX_TransactionHistoryArchive_ProductID'
GO
CREATE NONCLUSTERED INDEX [IX_TransactionHistoryArchive_ReferenceOrderID_ReferenceOrderLineID]
    ON [Production].[TransactionHistoryArchive] ([ReferenceOrderID], [ReferenceOrderLineID])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Nonclustered index.', 'SCHEMA', N'Production', 'TABLE', N'TransactionHistoryArchive', 'INDEX', N'IX_TransactionHistoryArchive_ReferenceOrderID_ReferenceOrderLineID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Transactions for previous years.', 'SCHEMA', N'Production', 'TABLE', N'TransactionHistoryArchive', NULL, NULL
GO
EXEC sp_addextendedproperty N'MS_Description', N'Primary key for TransactionHistoryArchive records.', 'SCHEMA', N'Production', 'TABLE', N'TransactionHistoryArchive', 'COLUMN', N'TransactionID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Product identification number. Foreign key to Product.ProductID.', 'SCHEMA', N'Production', 'TABLE', N'TransactionHistoryArchive', 'COLUMN', N'ProductID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Purchase order, sales order, or work order identification number.', 'SCHEMA', N'Production', 'TABLE', N'TransactionHistoryArchive', 'COLUMN', N'ReferenceOrderID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Line number associated with the purchase order, sales order, or work order.', 'SCHEMA', N'Production', 'TABLE', N'TransactionHistoryArchive', 'COLUMN', N'ReferenceOrderLineID'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date and time of the transaction.', 'SCHEMA', N'Production', 'TABLE', N'TransactionHistoryArchive', 'COLUMN', N'TransactionDate'
GO
EXEC sp_addextendedproperty N'MS_Description', N'W = Work Order, S = Sales Order, P = Purchase Order', 'SCHEMA', N'Production', 'TABLE', N'TransactionHistoryArchive', 'COLUMN', N'TransactionType'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Product quantity.', 'SCHEMA', N'Production', 'TABLE', N'TransactionHistoryArchive', 'COLUMN', N'Quantity'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Product cost.', 'SCHEMA', N'Production', 'TABLE', N'TransactionHistoryArchive', 'COLUMN', N'ActualCost'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Date and time the record was last updated.', 'SCHEMA', N'Production', 'TABLE', N'TransactionHistoryArchive', 'COLUMN', N'ModifiedDate'
GO
  
~~~

---
### See also
[List of tables](../tables.md)

