## ![](../../../../Images32x32Metro/OBJECT_TRIGGER.png "") Trigger:\[AdventureWorks2016CTP3\].\[Production\].\[uWorkOrder\]on Table WorkOrder
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > [Production.WorkOrder](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1166627199.md) > [Triggers](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/triggers_1166627199.md) > **Production.uWorkOrder**

---
###  Description  
 AFTER UPDATE trigger that inserts a row in the TransactionHistory table, updates ModifiedDate in the WorkOrder table. 



---
### Trigger properties
|Name |Value |
|-|-|
| Schema | [\[Production\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/7.md) |
| Owner | [\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md) |
| Creation date | 11/16/2015 |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Disabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | 1005246636 |
| Implementation type | Transact SQL |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Type
|Instead of|Insert|Update|Delete|
|-|-|-|-|
|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Objects that depend on \[Production\].\[uWorkOrder\]
 No dependencies exist

---
### Objects that \[Production\].\[uWorkOrder\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Production\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/7.md)|Schema|1|
|[\[dbo\].\[uspLogError\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/661577395.md)|Procedure|1|
|[\[dbo\].\[uspPrintError\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/645577338.md)|Procedure|1|
|[\[Production\].\[TransactionHistory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/894626230.md)|Table|1|
|[\[Production\].\[WorkOrder\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1166627199.md)|Table|1|

 Total 5 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[Production\].\[WorkOrder\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1166627199.md)|ProductID|Table|
|[\[Production\].\[WorkOrder\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1166627199.md)|WorkOrderID|Table|
|[\[Production\].\[WorkOrder\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1166627199.md)|OrderQty|Table|
|[\[Production\].\[TransactionHistory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/894626230.md)|*|Table|

 Total 4 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/1005246636_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|AFTER UPDATE trigger that inserts a row in the TransactionHistory table, updates ModifiedDate in the WorkOrder table.|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE TRIGGER [Production].[uWorkOrder] ON [Production].[WorkOrder] 
AFTER UPDATE AS 
BEGIN
    DECLARE @Count int;

    SET @Count = @@ROWCOUNT;
    IF @Count = 0 
        RETURN;

    SET NOCOUNT ON;

    BEGIN TRY
        IF UPDATE([ProductID]) OR UPDATE([OrderQty])
        BEGIN
            INSERT INTO [Production].[TransactionHistory](
                [ProductID]
                ,[ReferenceOrderID]
                ,[TransactionType]
                ,[TransactionDate]
                ,[Quantity])
            SELECT 
                inserted.[ProductID]
                ,inserted.[WorkOrderID]
                ,'W'
                ,GETDATE()
                ,inserted.[OrderQty]
            FROM inserted;
        END;
    END TRY
    BEGIN CATCH
        EXECUTE [dbo].[uspPrintError];

        -- Rollback any active or uncommittable transactions before
        -- inserting information in the ErrorLog
        IF @@TRANCOUNT &gt; 0
        BEGIN
            ROLLBACK TRANSACTION;
        END

        EXECUTE [dbo].[uspLogError];
    END CATCH;
END;
GO
EXEC sp_addextendedproperty N'MS_Description', N'AFTER UPDATE trigger that inserts a row in the TransactionHistory table, updates ModifiedDate in the WorkOrder table.', 'SCHEMA', N'Production', 'TABLE', N'WorkOrder', 'TRIGGER', N'uWorkOrder'
GO
  
~~~

---
### See also
[List of triggers](../triggers.md)

[\[Production\].\[WorkOrder\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1166627199.md)

