## ![](../../../../Images32x32Metro/OBJECT_TRIGGER.png "") Trigger:\[AdventureWorks2016CTP3\].\[HumanResources\].\[dEmployee\]on Table Employee
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > [HumanResources.Employee](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md) > [Triggers](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/triggers_1557580587.md) > **HumanResources.dEmployee**

---
###  Description  
 INSTEAD OF DELETE trigger which keeps Employees from being deleted. 



---
### Trigger properties
|Name |Value |
|-|-|
| Schema | [\[HumanResources\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/5.md) |
| Owner | [\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md) |
| Creation date | 11/16/2015 |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Disabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | 861246123 |
| Implementation type | Transact SQL |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Type
|Instead of|Insert|Update|Delete|
|-|-|-|-|
|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|

---
### Objects that depend on \[HumanResources\].\[dEmployee\]
 No dependencies exist

---
### Objects that \[HumanResources\].\[dEmployee\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[HumanResources\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/5.md)|Schema|1|
|[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|Table|1|

 Total 2 object(s)

---
### Column level dependencies
 No dependencies exist

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/861246123_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|INSTEAD OF DELETE trigger which keeps Employees from being deleted.|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE TRIGGER [HumanResources].[dEmployee] ON [HumanResources].[Employee] 
INSTEAD OF DELETE NOT FOR REPLICATION AS 
BEGIN
    DECLARE @Count int;

    SET @Count = @@ROWCOUNT;
    IF @Count = 0 
        RETURN;

    SET NOCOUNT ON;

    BEGIN
        RAISERROR
            (N'Employees cannot be deleted. They can only be marked as not current.', -- Message
            10, -- Severity.
            1); -- State.

        -- Rollback any active or uncommittable transactions
        IF @@TRANCOUNT &gt; 0
        BEGIN
            ROLLBACK TRANSACTION;
        END
    END;
END;
GO
EXEC sp_addextendedproperty N'MS_Description', N'INSTEAD OF DELETE trigger which keeps Employees from being deleted.', 'SCHEMA', N'HumanResources', 'TABLE', N'Employee', 'TRIGGER', N'dEmployee'
GO
  
~~~

---
### See also
[List of triggers](../triggers.md)

[\[HumanResources\].\[Employee\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)

