## ![](../../../../Images32x32Metro/OBJECT_TRIGGER.png "") Trigger:\[AdventureWorks2016CTP3\].\[Person\].\[iuPerson\]on Table Person
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > [Person.Person](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md) > [Triggers](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/triggers_2085582468.md) > **Person.iuPerson**

---
###  Description  
 AFTER INSERT, UPDATE trigger inserting Individual only if the Customer does not exist in the Store table and setting the ModifiedDate column in the Person table to the current date. 



---
### Trigger properties
|Name |Value |
|-|-|
| Schema | [\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/6.md) |
| Owner | [\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md) |
| Creation date | 11/16/2015 |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Disabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | 877246180 |
| Implementation type | Transact SQL |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Type
|Instead of|Insert|Update|Delete|
|-|-|-|-|
|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Objects that depend on \[Person\].\[iuPerson\]
 No dependencies exist

---
### Objects that \[Person\].\[iuPerson\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/6.md)|Schema|1|
|[\[Person\].\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|Table|1|

 Total 2 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[Person\].\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|BusinessEntityID|Table|
|[\[Person\].\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|Demographics|Table|

 Total 2 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/877246180_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|AFTER INSERT, UPDATE trigger inserting Individual only if the Customer does not exist in the Store table and setting the ModifiedDate column in the Person table to the current date.|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE TRIGGER [Person].[iuPerson] ON [Person].[Person] 
AFTER INSERT, UPDATE NOT FOR REPLICATION AS 
BEGIN
    DECLARE @Count int;

    SET @Count = @@ROWCOUNT;
    IF @Count = 0 
        RETURN;

    SET NOCOUNT ON;

    IF UPDATE([BusinessEntityID]) OR UPDATE([Demographics]) 
    BEGIN
        UPDATE [Person].[Person] 
        SET [Person].[Person].[Demographics] = N'&lt;IndividualSurvey xmlns="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/IndividualSurvey"&gt; 
            &lt;TotalPurchaseYTD&gt;0.00&lt;/TotalPurchaseYTD&gt; 
            &lt;/IndividualSurvey&gt;' 
        FROM inserted 
        WHERE [Person].[Person].[BusinessEntityID] = inserted.[BusinessEntityID] 
            AND inserted.[Demographics] IS NULL;
        
        UPDATE [Person].[Person] 
        SET [Demographics].modify(N'declare default element namespace "http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/IndividualSurvey"; 
            insert &lt;TotalPurchaseYTD&gt;0.00&lt;/TotalPurchaseYTD&gt; 
            as first 
            into (/IndividualSurvey)[1]') 
        FROM inserted 
        WHERE [Person].[Person].[BusinessEntityID] = inserted.[BusinessEntityID] 
            AND inserted.[Demographics] IS NOT NULL 
            AND inserted.[Demographics].exist(N'declare default element namespace 
                "http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/IndividualSurvey"; 
                /IndividualSurvey/TotalPurchaseYTD') &lt;&gt; 1;
    END;
END;
GO
EXEC sp_addextendedproperty N'MS_Description', N'AFTER INSERT, UPDATE trigger inserting Individual only if the Customer does not exist in the Store table and setting the ModifiedDate column in the Person table to the current date.', 'SCHEMA', N'Person', 'TABLE', N'Person', 'TRIGGER', N'iuPerson'
GO
  
~~~

---
### See also
[List of triggers](../triggers.md)

[\[Person\].\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)

