## ![](../../../../Images32x32Metro/OBJECT_TRIGGER.png "") Trigger:\[AdventureWorks2016CTP3\].\[Purchasing\].\[iPurchaseOrderDetail\]on Table PurchaseOrderDetail
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > [Purchasing.PurchaseOrderDetail](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1170103209.md) > [Triggers](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/triggers_1170103209.md) > **Purchasing.iPurchaseOrderDetail**

---
###  Description  
 AFTER INSERT trigger that inserts a row in the TransactionHistory table and updates the PurchaseOrderHeader.SubTotal column. 



---
### Trigger properties
|Name |Value |
|-|-|
| Schema | [\[Purchasing\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/8.md) |
| Owner | [\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md) |
| Creation date | 11/16/2015 |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Disabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | 893246237 |
| Implementation type | Transact SQL |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Type
|Instead of|Insert|Update|Delete|
|-|-|-|-|
|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Objects that depend on \[Purchasing\].\[iPurchaseOrderDetail\]
 No dependencies exist

---
### Objects that \[Purchasing\].\[iPurchaseOrderDetail\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Purchasing\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/8.md)|Schema|1|
|[\[dbo\].\[uspLogError\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/661577395.md)|Procedure|1|
|[\[dbo\].\[uspPrintError\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/645577338.md)|Procedure|1|
|[\[Purchasing\].\[PurchaseOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1170103209.md)|Table|1|
|[\[Purchasing\].\[PurchaseOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1266103551.md)|Table|1|
|[\[Production\].\[TransactionHistory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/894626230.md)|Table|1|

 Total 6 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[Purchasing\].\[PurchaseOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1170103209.md)|PurchaseOrderID|Table|
|[\[Purchasing\].\[PurchaseOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1170103209.md)|ProductID|Table|
|[\[Purchasing\].\[PurchaseOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1170103209.md)|PurchaseOrderDetailID|Table|
|[\[Purchasing\].\[PurchaseOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1170103209.md)|OrderQty|Table|
|[\[Purchasing\].\[PurchaseOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1170103209.md)|UnitPrice|Table|
|[\[Purchasing\].\[PurchaseOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1170103209.md)|LineTotal|Table|
|[\[Production\].\[TransactionHistory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/894626230.md)|*|Table|
|[\[Purchasing\].\[PurchaseOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1266103551.md)|PurchaseOrderID|Table|
|[\[Purchasing\].\[PurchaseOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1266103551.md)|SubTotal|Table|

 Total 9 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/893246237_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|AFTER INSERT trigger that inserts a row in the TransactionHistory table and updates the PurchaseOrderHeader.SubTotal column.|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE TRIGGER [Purchasing].[iPurchaseOrderDetail] ON [Purchasing].[PurchaseOrderDetail] 
AFTER INSERT AS
BEGIN
    DECLARE @Count int;

    SET @Count = @@ROWCOUNT;
    IF @Count = 0 
        RETURN;

    SET NOCOUNT ON;

    BEGIN TRY
        INSERT INTO [Production].[TransactionHistory]
            ([ProductID]
            ,[ReferenceOrderID]
            ,[ReferenceOrderLineID]
            ,[TransactionType]
            ,[TransactionDate]
            ,[Quantity]
            ,[ActualCost])
        SELECT 
            inserted.[ProductID]
            ,inserted.[PurchaseOrderID]
            ,inserted.[PurchaseOrderDetailID]
            ,'P'
            ,GETDATE()
            ,inserted.[OrderQty]
            ,inserted.[UnitPrice]
        FROM inserted 
            INNER JOIN [Purchasing].[PurchaseOrderHeader] 
            ON inserted.[PurchaseOrderID] = [Purchasing].[PurchaseOrderHeader].[PurchaseOrderID];

        -- Update SubTotal in PurchaseOrderHeader record. Note that this causes the 
        -- PurchaseOrderHeader trigger to fire which will update the RevisionNumber.
        UPDATE [Purchasing].[PurchaseOrderHeader]
        SET [Purchasing].[PurchaseOrderHeader].[SubTotal] = 
            (SELECT SUM([Purchasing].[PurchaseOrderDetail].[LineTotal])
                FROM [Purchasing].[PurchaseOrderDetail]
                WHERE [Purchasing].[PurchaseOrderHeader].[PurchaseOrderID] = [Purchasing].[PurchaseOrderDetail].[PurchaseOrderID])
        WHERE [Purchasing].[PurchaseOrderHeader].[PurchaseOrderID] IN (SELECT inserted.[PurchaseOrderID] FROM inserted);
    END TRY
    BEGIN CATCH
        EXECUTE [dbo].[uspPrintError];

        -- Rollback any active or uncommittable transactions before
        -- inserting information in the ErrorLog
        IF @@TRANCOUNT &gt; 0
        BEGIN
            ROLLBACK TRANSACTION;
        END

        EXECUTE [dbo].[uspLogError];
    END CATCH;
END;
GO
EXEC sp_addextendedproperty N'MS_Description', N'AFTER INSERT trigger that inserts a row in the TransactionHistory table and updates the PurchaseOrderHeader.SubTotal column.', 'SCHEMA', N'Purchasing', 'TABLE', N'PurchaseOrderDetail', 'TRIGGER', N'iPurchaseOrderDetail'
GO
  
~~~

---
### See also
[List of triggers](../triggers.md)

[\[Purchasing\].\[PurchaseOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1170103209.md)

