## ![](../../../../Images32x32Metro/OBJECT_TRIGGER.png "") Trigger:\[AdventureWorks2016CTP3\].\[Sales\].\[iduSalesOrderDetail\]on Table SalesOrderDetail
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > [Sales.SalesOrderDetail](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1474104292.md) > [Triggers](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/triggers_1474104292.md) > **Sales.iduSalesOrderDetail**

---
###  Description  
 AFTER INSERT, DELETE, UPDATE trigger that inserts a row in the TransactionHistory table, updates ModifiedDate in SalesOrderDetail and updates the SalesOrderHeader.SubTotal column. 



---
### Trigger properties
|Name |Value |
|-|-|
| Schema | [\[Sales\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md) |
| Owner | [\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md) |
| Creation date | 11/16/2015 |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Disabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | 941246408 |
| Implementation type | Transact SQL |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Type
|Instead of|Insert|Update|Delete|
|-|-|-|-|
|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|

---
### Objects that depend on \[Sales\].\[iduSalesOrderDetail\]
 No dependencies exist

---
### Objects that \[Sales\].\[iduSalesOrderDetail\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Sales\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md)|Schema|1|
|[\[dbo\].\[uspLogError\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/661577395.md)|Procedure|1|
|[\[dbo\].\[uspPrintError\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/645577338.md)|Procedure|1|
|[\[Sales\].\[Customer\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1317579732.md)|Table|1|
|[\[Person\].\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|Table|1|
|[\[Sales\].\[SalesOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1474104292.md)|Table|1|
|[\[Sales\].\[SalesOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691.md)|Table|1|
|[\[Production\].\[TransactionHistory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/894626230.md)|Table|1|

 Total 8 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[Sales\].\[SalesOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1474104292.md)|SalesOrderID|Table|
|[\[Sales\].\[SalesOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1474104292.md)|ProductID|Table|
|[\[Sales\].\[SalesOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1474104292.md)|SalesOrderDetailID|Table|
|[\[Sales\].\[SalesOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1474104292.md)|OrderQty|Table|
|[\[Sales\].\[SalesOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1474104292.md)|UnitPrice|Table|
|[\[Sales\].\[SalesOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1474104292.md)|LineTotal|Table|
|[\[Production\].\[TransactionHistory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/894626230.md)|*|Table|
|[\[Sales\].\[SalesOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691.md)|SalesOrderID|Table|
|[\[Sales\].\[SalesOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691.md)|CustomerID|Table|
|[\[Sales\].\[SalesOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691.md)|SubTotal|Table|
|[\[Sales\].\[Customer\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1317579732.md)|CustomerID|Table|
|[\[Sales\].\[Customer\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1317579732.md)|PersonID|Table|
|[\[Person\].\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|BusinessEntityID|Table|
|[\[Person\].\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|Demographics|Table|

 Total 14 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/941246408_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|AFTER INSERT, DELETE, UPDATE trigger that inserts a row in the TransactionHistory table, updates ModifiedDate in SalesOrderDetail and updates the SalesOrderHeader.SubTotal column.|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE TRIGGER [Sales].[iduSalesOrderDetail] ON [Sales].[SalesOrderDetail] 
AFTER INSERT, DELETE, UPDATE AS 
BEGIN
    DECLARE @Count int;

    SET @Count = @@ROWCOUNT;
    IF @Count = 0 
        RETURN;

    SET NOCOUNT ON;

    BEGIN TRY
        -- If inserting or updating these columns
        IF UPDATE([ProductID]) OR UPDATE([OrderQty]) OR UPDATE([UnitPrice]) OR UPDATE([UnitPriceDiscount]) 
        -- Insert record into TransactionHistory
        BEGIN
            INSERT INTO [Production].[TransactionHistory]
                ([ProductID]
                ,[ReferenceOrderID]
                ,[ReferenceOrderLineID]
                ,[TransactionType]
                ,[TransactionDate]
                ,[Quantity]
                ,[ActualCost])
            SELECT 
                inserted.[ProductID]
                ,inserted.[SalesOrderID]
                ,inserted.[SalesOrderDetailID]
                ,'S'
                ,GETDATE()
                ,inserted.[OrderQty]
                ,inserted.[UnitPrice]
            FROM inserted 
                INNER JOIN [Sales].[SalesOrderHeader] 
                ON inserted.[SalesOrderID] = [Sales].[SalesOrderHeader].[SalesOrderID];

            UPDATE [Person].[Person] 
            SET [Demographics].modify('declare default element namespace 
                "http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/IndividualSurvey"; 
                replace value of (/IndividualSurvey/TotalPurchaseYTD)[1] 
                with data(/IndividualSurvey/TotalPurchaseYTD)[1] + sql:column ("inserted.LineTotal")') 
            FROM inserted 
                INNER JOIN [Sales].[SalesOrderHeader] AS SOH
                ON inserted.[SalesOrderID] = SOH.[SalesOrderID] 
                INNER JOIN [Sales].[Customer] AS C
                ON SOH.[CustomerID] = C.[CustomerID]
            WHERE C.[PersonID] = [Person].[Person].[BusinessEntityID];
        END;

        -- Update SubTotal in SalesOrderHeader record. Note that this causes the 
        -- SalesOrderHeader trigger to fire which will update the RevisionNumber.
        UPDATE [Sales].[SalesOrderHeader]
        SET [Sales].[SalesOrderHeader].[SubTotal] = 
            (SELECT SUM([Sales].[SalesOrderDetail].[LineTotal])
                FROM [Sales].[SalesOrderDetail]
                WHERE [Sales].[SalesOrderHeader].[SalesOrderID] = [Sales].[SalesOrderDetail].[SalesOrderID])
        WHERE [Sales].[SalesOrderHeader].[SalesOrderID] IN (SELECT inserted.[SalesOrderID] FROM inserted);

        UPDATE [Person].[Person] 
        SET [Demographics].modify('declare default element namespace 
            "http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/IndividualSurvey"; 
            replace value of (/IndividualSurvey/TotalPurchaseYTD)[1] 
            with data(/IndividualSurvey/TotalPurchaseYTD)[1] - sql:column("deleted.LineTotal")') 
        FROM deleted 
            INNER JOIN [Sales].[SalesOrderHeader] 
            ON deleted.[SalesOrderID] = [Sales].[SalesOrderHeader].[SalesOrderID] 
            INNER JOIN [Sales].[Customer]
            ON [Sales].[Customer].[CustomerID] = [Sales].[SalesOrderHeader].[CustomerID]
        WHERE [Sales].[Customer].[PersonID] = [Person].[Person].[BusinessEntityID];
    END TRY
    BEGIN CATCH
        EXECUTE [dbo].[uspPrintError];

        -- Rollback any active or uncommittable transactions before
        -- inserting information in the ErrorLog
        IF @@TRANCOUNT &gt; 0
        BEGIN
            ROLLBACK TRANSACTION;
        END

        EXECUTE [dbo].[uspLogError];
    END CATCH;
END;
GO
EXEC sp_addextendedproperty N'MS_Description', N'AFTER INSERT, DELETE, UPDATE trigger that inserts a row in the TransactionHistory table, updates ModifiedDate in SalesOrderDetail and updates the SalesOrderHeader.SubTotal column.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderDetail', 'TRIGGER', N'iduSalesOrderDetail'
GO
  
~~~

---
### See also
[List of triggers](../triggers.md)

[\[Sales\].\[SalesOrderDetail\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1474104292.md)

