## ![](../../../../Images32x32Metro/OBJECT_TRIGGER.png "") Trigger:\[AdventureWorks2016CTP3\].\[Sales\].\[uSalesOrderHeader\]on Table SalesOrderHeader
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Tables](../../../../DbEngine/(local)/AdventureWorks2016CTP3/tables.md) > [Sales.SalesOrderHeader](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691.md) > [Triggers](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/triggers_1586104691.md) > **Sales.uSalesOrderHeader**

---
###  Description  
 AFTER UPDATE trigger that updates the RevisionNumber and ModifiedDate columns in the SalesOrderHeader table.Updates the SalesYTD column in the SalesPerson and SalesTerritory tables. 



---
### Trigger properties
|Name |Value |
|-|-|
| Schema | [\[Sales\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md) |
| Owner | [\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md) |
| Creation date | 11/16/2015 |
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Disabled |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | 957246465 |
| Implementation type | Transact SQL |

---
### Creation options
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
### Type
|Instead of|Insert|Update|Delete|
|-|-|-|-|
|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/RED_CROSS.gif "")|

---
### Objects that depend on \[Sales\].\[uSalesOrderHeader\]
 No dependencies exist

---
### Objects that \[Sales\].\[uSalesOrderHeader\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Sales\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md)|Schema|1|
|[\[dbo\].\[uspLogError\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/661577395.md)|Procedure|1|
|[\[dbo\].\[uspPrintError\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/645577338.md)|Procedure|1|
|[\[Sales\].\[SalesOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691.md)|Table|1|
|[\[Sales\].\[SalesPerson\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1874105717.md)|Table|1|
|[\[Sales\].\[SalesTerritory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/94623380.md)|Table|1|
|[\[dbo\].\[ufnGetAccountingEndDate\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Functions/1357247890.md)|Function|1|
|[\[dbo\].\[ufnGetAccountingStartDate\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Functions/1341247833.md)|Function|1|

 Total 8 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[Sales\].\[SalesOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691.md)|SalesOrderID|Table|
|[\[Sales\].\[SalesOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691.md)|SalesPersonID|Table|
|[\[Sales\].\[SalesOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691.md)|OrderDate|Table|
|[\[Sales\].\[SalesOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691.md)|TerritoryID|Table|
|[\[Sales\].\[SalesOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691.md)|RevisionNumber|Table|
|[\[Sales\].\[SalesOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691.md)|SubTotal|Table|
|[\[Sales\].\[SalesOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691.md)|Status|Table|
|[\[Sales\].\[SalesPerson\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1874105717.md)|BusinessEntityID|Table|
|[\[Sales\].\[SalesPerson\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1874105717.md)|SalesYTD|Table|
|[\[Sales\].\[SalesTerritory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/94623380.md)|TerritoryID|Table|
|[\[Sales\].\[SalesTerritory\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/94623380.md)|SalesYTD|Table|

 Total 11 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/957246465_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|AFTER UPDATE trigger that updates the RevisionNumber and ModifiedDate columns in the SalesOrderHeader table.Updates the SalesYTD column in the SalesPerson and SalesTerritory tables.|

---
### SQL
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE TRIGGER [Sales].[uSalesOrderHeader] ON [Sales].[SalesOrderHeader] 
AFTER UPDATE NOT FOR REPLICATION AS 
BEGIN
    DECLARE @Count int;

    SET @Count = @@ROWCOUNT;
    IF @Count = 0 
        RETURN;

    SET NOCOUNT ON;

    BEGIN TRY
        -- Update RevisionNumber for modification of any field EXCEPT the Status.
        IF NOT UPDATE([Status])
        BEGIN
            UPDATE [Sales].[SalesOrderHeader]
            SET [Sales].[SalesOrderHeader].[RevisionNumber] = 
                [Sales].[SalesOrderHeader].[RevisionNumber] + 1
            WHERE [Sales].[SalesOrderHeader].[SalesOrderID] IN 
                (SELECT inserted.[SalesOrderID] FROM inserted);
        END;

        -- Update the SalesPerson SalesYTD when SubTotal is updated
        IF UPDATE([SubTotal])
        BEGIN
            DECLARE @StartDate datetime,
                    @EndDate datetime

            SET @StartDate = [dbo].[ufnGetAccountingStartDate]();
            SET @EndDate = [dbo].[ufnGetAccountingEndDate]();

            UPDATE [Sales].[SalesPerson]
            SET [Sales].[SalesPerson].[SalesYTD] = 
                (SELECT SUM([Sales].[SalesOrderHeader].[SubTotal])
                FROM [Sales].[SalesOrderHeader] 
                WHERE [Sales].[SalesPerson].[BusinessEntityID] = [Sales].[SalesOrderHeader].[SalesPersonID]
                    AND ([Sales].[SalesOrderHeader].[Status] = 5) -- Shipped
                    AND [Sales].[SalesOrderHeader].[OrderDate] BETWEEN @StartDate AND @EndDate)
            WHERE [Sales].[SalesPerson].[BusinessEntityID] 
                IN (SELECT DISTINCT inserted.[SalesPersonID] FROM inserted 
                    WHERE inserted.[OrderDate] BETWEEN @StartDate AND @EndDate);

            -- Update the SalesTerritory SalesYTD when SubTotal is updated
            UPDATE [Sales].[SalesTerritory]
            SET [Sales].[SalesTerritory].[SalesYTD] = 
                (SELECT SUM([Sales].[SalesOrderHeader].[SubTotal])
                FROM [Sales].[SalesOrderHeader] 
                WHERE [Sales].[SalesTerritory].[TerritoryID] = [Sales].[SalesOrderHeader].[TerritoryID]
                    AND ([Sales].[SalesOrderHeader].[Status] = 5) -- Shipped
                    AND [Sales].[SalesOrderHeader].[OrderDate] BETWEEN @StartDate AND @EndDate)
            WHERE [Sales].[SalesTerritory].[TerritoryID] 
                IN (SELECT DISTINCT inserted.[TerritoryID] FROM inserted 
                    WHERE inserted.[OrderDate] BETWEEN @StartDate AND @EndDate);
        END;
    END TRY
    BEGIN CATCH
        EXECUTE [dbo].[uspPrintError];

        -- Rollback any active or uncommittable transactions before
        -- inserting information in the ErrorLog
        IF @@TRANCOUNT &gt; 0
        BEGIN
            ROLLBACK TRANSACTION;
        END

        EXECUTE [dbo].[uspLogError];
    END CATCH;
END;
GO
EXEC sp_addextendedproperty N'MS_Description', N'AFTER UPDATE trigger that updates the RevisionNumber and ModifiedDate columns in the SalesOrderHeader table.Updates the SalesYTD column in the SalesPerson and SalesTerritory tables.', 'SCHEMA', N'Sales', 'TABLE', N'SalesOrderHeader', 'TRIGGER', N'uSalesOrderHeader'
GO
  
~~~

---
### See also
[List of triggers](../triggers.md)

[\[Sales\].\[SalesOrderHeader\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691.md)

