## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[all_objects\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.all_objects**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -101 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|name| |sysname|128|
|object_id| |int|4|
|principal_id| |int|4|
|schema_id| |int|4|
|parent_object_id| |int|4|
|type| |char|2|
|type_desc| |nvarchar|60|
|create_date| |datetime|8|
|modify_date| |datetime|8|
|is_ms_shipped| |bit|1|
|is_published| |bit|1|
|is_schema_published| |bit|1|

Total: 12 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[all_objects\]
 No dependencies exist

---
### Objects that \[sys\].\[all_objects\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-101_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.all_objects AS
    SELECT 
        o.name, o.id AS object_id, r.indepid AS principal_id,
        o.nsid AS schema_id, o.pid AS parent_object_id,
        convert(char(2), case o.type when 'ET' then 'U' else o.type end) AS type,
        n.name AS type_desc,
        o.created AS create_date, o.modified AS modify_date,
        convert(bit, o.status &amp; 1) AS is_ms_shipped,        -- OBJALL_MSSHIPPED
        convert(bit, o.status &amp; 16) AS is_published,        -- OBJALL_RPL_PUBLISHED
        convert(bit, o.status &amp; 64) AS is_schema_published    -- OBJALL_RPL_PUB_SCHONLY
    FROM sys.sysschobjs$ o
    LEFT JOIN sys.syssingleobjrefs r ON r.depid = o.id AND r.class = 97 AND r.depsubid = 0    -- SRC_OBJOWNER
    LEFT JOIN sys.syspalnames n ON n.class = 'OBTY' AND n.value = o.type
    WHERE o.nsclass not in (20,21)        -- excluding DDL trigger
        AND HAS_ACCESS('AO', o.id) = 1
GO
GRANT SELECT
    ON [sys].[all_objects]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

