## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[INFORMATION_SCHEMA\].\[DOMAINS\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **INFORMATION_SCHEMA.DOMAINS**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[INFORMATION_SCHEMA\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/3.md) |
| Owner | \[INFORMATION_SCHEMA\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -1013821813 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|DOMAIN_CATALOG| |nvarchar|128|
|DOMAIN_SCHEMA| |nvarchar|128|
|DOMAIN_NAME| |sysname|128|
|DATA_TYPE| |nvarchar|128|
|CHARACTER_MAXIMUM_LENGTH| |int|4|
|CHARACTER_OCTET_LENGTH| |int|4|
|COLLATION_CATALOG| |sysname|128|
|COLLATION_SCHEMA| |sysname|128|
|COLLATION_NAME| |sysname|128|
|CHARACTER_SET_CATALOG| |sysname|128|
|CHARACTER_SET_SCHEMA| |sysname|128|
|CHARACTER_SET_NAME| |sysname|128|
|NUMERIC_PRECISION| |tinyint|1|
|NUMERIC_PRECISION_RADIX| |smallint|2|
|NUMERIC_SCALE| |int|4|
|DATETIME_PRECISION| |smallint|2|
|DOMAIN_DEFAULT| |nvarchar|4000|

Total: 17 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[INFORMATION_SCHEMA\].\[DOMAINS\]
 No dependencies exist

---
### Objects that \[INFORMATION_SCHEMA\].\[DOMAINS\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW INFORMATION_SCHEMA.DOMAINS
AS
SELECT
    DB_NAME()                    AS DOMAIN_CATALOG,
    SCHEMA_NAME(schema_id)        AS DOMAIN_SCHEMA,
    name                        AS DOMAIN_NAME,
    TYPE_NAME(system_type_id)     AS DATA_TYPE,
    convert(int, TypePropertyEx(user_type_id, 'charmaxlen'))    AS CHARACTER_MAXIMUM_LENGTH,
    convert(int, TypePropertyEx(user_type_id, 'octetmaxlen'))    AS CHARACTER_OCTET_LENGTH,
    convert(sysname, null)            AS COLLATION_CATALOG,
    convert(sysname, null) collate catalog_default        AS COLLATION_SCHEMA,
    collation_name                AS COLLATION_NAME,
    convert(sysname, null)            AS CHARACTER_SET_CATALOG,
    convert(sysname, null) collate catalog_default        AS CHARACTER_SET_SCHEMA,
    convert(sysname, CASE
        WHEN system_type_id IN (35, 167, 175) THEN SERVERPROPERTY('sqlcharsetname') -- char/varchar/text
        WHEN system_type_id IN (99, 231, 239) THEN N'UNICODE' END) AS CHARACTER_SET_NAME,        -- nchar/nvarchar/ntext
    convert(tinyint, CASE -- int/decimal/numeric/real/float/money
        WHEN system_type_id IN (48, 52, 56, 59, 60, 62, 106, 108, 122, 127) THEN precision
        END)                                    AS NUMERIC_PRECISION,
    convert(smallint, CASE    -- int/money/decimal/numeric
        WHEN system_type_id IN (48, 52, 56, 60, 106, 108, 122, 127) THEN 10
        WHEN system_type_id IN (59, 62) THEN 2 END)    AS NUMERIC_PRECISION_RADIX,
    convert(int, CASE    -- datetime/smalldatetime
        WHEN system_type_id IN (40, 41, 42, 43, 58, 61) THEN NULL
        ELSE ODBCSCALE(system_type_id, scale) END)    AS NUMERIC_SCALE,
    convert(smallint, CASE -- datetime/smalldatetime
        WHEN system_type_id IN (40, 41, 42, 43, 58, 61) THEN  ODBCSCALE(system_type_id, scale) END)    AS DATETIME_PRECISION,
    convert(nvarchar(4000),
        OBJECT_DEFINITION(default_object_id))            AS DOMAIN_DEFAULT
FROM
    sys.types
WHERE
    user_type_id &gt; 256    -- UDT
GO
  
~~~

---
###   See also  
[List of views](../views.md)

