## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[all_views\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.all_views**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -102 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|name| |sysname|128|
|object_id| |int|4|
|principal_id| |int|4|
|schema_id| |int|4|
|parent_object_id| |int|4|
|type| |char|2|
|type_desc| |nvarchar|60|
|create_date| |datetime|8|
|modify_date| |datetime|8|
|is_ms_shipped| |bit|1|
|is_published| |bit|1|
|is_schema_published| |bit|1|
|is_replicated| |bit|1|
|has_replication_filter| |bit|1|
|has_opaque_metadata| |bit|1|
|has_unchecked_assembly_data| |bit|1|
|with_check_option| |bit|1|
|is_date_correlation_view| |bit|1|
|is_tracked_by_cdc| |bit|1|

Total: 19 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[all_views\]
 No dependencies exist

---
### Objects that \[sys\].\[all_views\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-102_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.all_views AS
    SELECT o.name, o.id AS object_id,
        r.indepid AS principal_id, o.nsid AS schema_id,
        o.pid AS parent_object_id,
        o.type, n.name AS type_desc,
        o.created AS create_date, o.modified AS modify_date,
        convert(bit, o.status &amp; 1) AS is_ms_shipped,
        convert(bit, o.status &amp; 16) AS is_published,
        convert(bit, o.status &amp; 64) AS is_schema_published,
        convert(bit, o.status &amp; 0x1000) AS is_replicated,
        convert(bit, o.status &amp; 0x2000) AS has_replication_filter,
        convert(bit, o.status &amp; 512) AS has_opaque_metadata,
        convert(bit, o.status &amp; 2048) AS has_unchecked_assembly_data,
        convert(bit, o.status &amp; 1024) AS with_check_option,
        convert(bit, o.status &amp; 2) AS is_date_correlation_view,
        convert(bit, o.status &amp; 0x01000000) AS is_tracked_by_cdc
    FROM sys.sysschobjs$ o        
    LEFT JOIN sys.syssingleobjrefs r ON r.depid = o.id AND r.class = 97 AND r.depsubid = 0    -- SRC_OBJOWNER
    LEFT JOIN sys.syspalnames n ON n.class = 'OBTY' AND n.value = o.type
    WHERE o.nsclass = 0 -- x_eonc_Standard
        AND o.pclass = 1 AND type = 'V' -- x_eunc_Object
        AND has_access('AO', o.id) = 1
GO
GRANT SELECT
    ON [sys].[all_views]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

