## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[sysobjects\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.sysobjects**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -105 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|name| |sysname|128|
|id| |int|4|
|xtype| |char|2|
|uid| |smallint|2|
|info| |smallint|2|
|status| |int|4|
|base_schema_ver| |int|4|
|replinfo| |int|4|
|parent_obj| |int|4|
|crdate| |datetime|8|
|ftcatid| |smallint|2|
|schema_ver| |int|4|
|stats_schema_ver| |int|4|
|type| |char|2|
|userstat| |smallint|2|
|sysstat| |smallint|2|
|indexdel| |smallint|2|
|refdate| |datetime|8|
|version| |int|4|
|deltrig| |int|4|
|instrig| |int|4|
|updtrig| |int|4|
|seltrig| |int|4|
|category| |int|4|
|cache| |smallint|2|

Total: 25 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[sysobjects\]
 No dependencies exist

---
### Objects that \[sys\].\[sysobjects\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-105_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
-- Return visible system objects in master database context
CREATE VIEW sys.sysobjects AS
    SELECT name, 
        id,
        xtype = type collate catalog_default,
        uid = convert(smallint, nsid),
        info = convert(smallint, 0),
        status = convert(int, 0),
        base_schema_ver = convert(int, 0),
        replinfo = convert(int, 0),
        parent_obj = pid,
        crdate = created,
        ftcatid = convert(smallint, 
            case type when 'U' then OBJECTPROPERTY(id, 'TableFulltextCatalogId')
            else 0 end),
        schema_ver = convert(int, 0),
        stats_schema_ver = convert(int, 0),
        type = convert(char(2), 
            case type when 'UQ' then 'K' when 'PK' then 'K' when 'ET' then 'U'
            else type collate catalog_default end),
        userstat = convert(smallint, 
            case type when 'S' then 1 when 'U' then 1 when 'ET' then 1
            else 0 end),
        sysstat = convert(smallint, 
            case type when 'S' then 1 when 'V' then 2 when 'U' then 3 when 'P' then 4 when 'RF' then 4
            when 'X' then 4 when 'D' then 6 when 'R' then 7 when 'TR' then 8
            when 'PK' then 9 when 'UQ' then 9 when 'C' then 10 when 'F' then 11
            else 0 end),
        indexdel = convert(smallint, 0),
        refdate = created,
        version = convert(int, 0),
        deltrig = convert(int,
            case type when 'U' then OBJECTPROPERTY(id,'TableDeleteTrigger')
            when 'TR' then pid else 0 end),
        instrig = convert(int, 
            case type when 'U' then OBJECTPROPERTY(id,'TableInsertTrigger')
            else 0 end),
        updtrig = convert(int,
            case type when 'U' then OBJECTPROPERTY(id,'TableUpdateTrigger')
            else 0 end),
        seltrig = convert(int, 0),
        category = convert(int, 
            case when type = 'D' and pid &lt;&gt; 0 then 2048 
            else 0 end
            + 
            case when type = 'P' and (status &amp; 256) &lt;&gt; 0 then 16 
            else 0 end -- is_auto_executed
            + (status &amp; 1)*2 + (status &amp; 16)*2), -- is_ms_shipped * 2 + is_published * 32
        cache = convert(smallint, 0)
    FROM sys.sysschobjs$
    WHERE nsclass = 0 -- x_eonc_Standard
    AND pclass = 1 -- x_eunc_Object
    AND has_access('MO', id) = 1
GO
GRANT SELECT
    ON [sys].[sysobjects]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

