## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[syscolumns\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.syscolumns**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -106 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|name| |sysname|128|
|id| |int|4|
|xtype| |tinyint|1|
|typestat| |tinyint|1|
|xusertype| |smallint|2|
|length| |smallint|2|
|xprec| |tinyint|1|
|xscale| |tinyint|1|
|colid| |smallint|2|
|xoffset| |smallint|2|
|bitpos| |tinyint|1|
|reserved| |tinyint|1|
|colstat| |smallint|2|
|cdefault| |int|4|
|domain| |int|4|
|number| |smallint|2|
|colorder| |smallint|2|
|autoval| |varbinary|8000|
|offset| |smallint|2|
|collationid| |int|4|
|language| |int|4|
|status| |tinyint|1|
|type| |tinyint|1|
|usertype| |smallint|2|
|printfmt| |varchar|255|
|prec| |smallint|2|
|scale| |int|4|
|iscomputed| |int|4|
|isoutparam| |int|4|
|isnullable| |int|4|
|collation| |sysname|128|
|tdscollation| |binary|5|

Total: 32 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[syscolumns\]
 No dependencies exist

---
### Objects that \[sys\].\[syscolumns\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-106_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
-- Return visible system objects in master database context
CREATE VIEW sys.syscolumns AS
    SELECT c.name, c.id, c.xtype,
        typestat = convert(tinyint, c.status &amp; 3),    -- (1-is_nullable) + is_ansi_padded * 2
        xusertype = convert(smallint, c.utype),
        c.length, xprec = c.prec,
        xscale = c.scale,
        colid = convert(smallint, c.colid),
        xoffset = convert(smallint, 0),
        bitpos = convert(tinyint, 0),
        reserved = convert(tinyint, 0),
        colstat = convert(smallint,
            (c.status &amp; 4)/4                -- CPM_IDENTCOL (is_identity)
            + (c.status &amp; 8)/4            -- CPM_ROWGUIDCOL (is_rowguidcol * 2)
            + (case when sov4.value is null then (c.status &amp; 16)/4 else 0 end)            -- CPM_COMPUTED (is_computed * 4)
            + (c.status &amp; 512)/128        -- CPM_OUTPUT (is_output * 4)
            + (c.status &amp; 1024)/32        -- CPM_CURSORREF (is_cursor_ref * 32)                    
            + (c.status &amp; 0x20000)/32        -- CPM_REPLICAT (is_replicated * 4096)
            + (c.status &amp; 0x40000)/32        -- CPM_NONSQSSUB (is_non_sql_subscribed * 8192)
            + (c.status &amp; 0x80000)/32        -- CPM_MERGEREPL (is_merge_published * 16384)
            + (c.status &amp; 0x100000)/32),    -- CPM_REPLDTS (is_dts_replicated * 32768)
        cdefault = c.dflt,
        domain = c.chk,
        number = convert(smallint, case c.number when 1 then 1 - objectproperty(c.id, 'isscalarfunction') else c.number end),
        colorder = convert(smallint, c.colid),
        autoval = convert(varbinary(8000), null),
        offset  = convert(smallint, case c.number when 0 then columnproperty(c.id, c.name, 'sql65offset') else 0 end),
        c.collationid,
        language = case c.number when 0 then columnproperty(c.id, c.name, 'fulltextlcid') else 0 end,
        status = convert(tinyint,
            (1-(c.status &amp; 1))*8            -- CPM_NOTNULL (is_nullable * 8)
            + case when (c.status &amp; 2 &lt;&gt; 0) or (c.xtype in (34, 35) and c.status &amp; 0x20000 &lt;&gt; 0)    -- CPM_NOTRIM,CPM_REPLICAT
            then 16 else 0 end            -- image, text (is_ansi_padded &lt;&gt; 0 or (system_type_id in (34, 35) and is_replicated &lt;&gt; 0))
            + case when (c.xtype in (34, 35) and c.status &amp; 0x40000 &lt;&gt; 0) or (c.xtype in (173, 175, 189) and c.status &amp; 1 = 0)
            then 32 else 0 end            -- (is_non_sql_subscribed &lt;&gt; 0 and image/text) or is_nullable and timestamp/char/binary
            + (c.status &amp; 512)/8            -- CPM_OUTPUT (is_output * 64)
            + (case when sov4.value is null then ((c.status &amp; 16) * 4) else 0 end)            -- CPM_COMPUTED (is_computed*64)
            + (c.status &amp; 4)*32),            -- CPM_IDENTCOL (is_identity * 128)
        type = xtypetotds(c.xtype, 1 - (c.status &amp; 1)),    -- CPM_NOTNULL (is_nullable)
        usertype = convert(smallint, columnproperty(c.id, c.name, 'oldusertype')),
        printfmt = convert(varchar(255), null),
        prec = convert(smallint,
            case when c.xtype in (34, 35, 99) then null    -- ntext, image, text
            when c.xtype = 36 then c.prec                    -- uniqueidentifier
            when c.length = -1 then -1                    -- new style large objects
            else odbcprec(c.xtype, c.length, c.prec) end),
        scale = odbcscale(c.xtype, c.scale),
        iscomputed = convert(int, case when sov4.value is null then (c.status &amp; 16)/16 else 0 end),    -- CPM_COMPUTED (is_computed)
        isoutparam = convert(int, (c.status &amp; 512)/512),    -- CPM_OUTPUT (is_output)
        isnullable = convert(int, 1 - (c.status &amp; 1)),    -- CPM_NOTNULL (is_nullable)
        collation = convert(sysname, collationpropertyfromid(collationid, 'name')),
        tdscollation = convert(binary(5), collationpropertyfromid(collationid, 'tdscollation'))
    FROM sys.syscolpars c
    LEFT JOIN sys.sysobjvalues sov4 ON sov4.valclass = 128 /*SVC_GRAPHDB_COLUMN_TYPE*/ and sov4.objid = c.id and sov4.subobjid = c.colid and sov4.valnum = 0
    WHERE has_access('CO', c.id) = 1
    UNION ALL
    SELECT c.name collate catalog_default AS name,
        c.id, c.xtype, c.typestat, c.xusertype, c.length, c.xprec, c.xscale,
        c.colid, c.xoffset, c.bitpos, c.reserved, c.colstat, c.cdefault,
        c.domain, c.number, c.colorder, c.autoval, c.offset, c.collationid,
        c.language, c.status, c.type, c.usertype, c.printfmt, c.prec, c.scale,
        c.iscomputed, c.isoutparam, c.isnullable, c.collation, c.tdscollation
    FROM sys.syscolumns$ c
    WHERE has_access('RO', c.id) = 1
GO
GRANT SELECT
    ON [sys].[syscolumns]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

