## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[INFORMATION_SCHEMA\].\[COLUMN_PRIVILEGES\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **INFORMATION_SCHEMA.COLUMN_PRIVILEGES**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[INFORMATION_SCHEMA\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/3.md) |
| Owner | \[INFORMATION_SCHEMA\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -122239902 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|GRANTOR| |nvarchar|128|
|GRANTEE| |nvarchar|128|
|TABLE_CATALOG| |nvarchar|128|
|TABLE_SCHEMA| |nvarchar|128|
|TABLE_NAME| |sysname|128|
|COLUMN_NAME| |sysname|128|
|PRIVILEGE_TYPE| |varchar|10|
|IS_GRANTABLE| |varchar|3|

Total: 8 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[INFORMATION_SCHEMA\].\[COLUMN_PRIVILEGES\]
 No dependencies exist

---
### Objects that \[INFORMATION_SCHEMA\].\[COLUMN_PRIVILEGES\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW INFORMATION_SCHEMA.COLUMN_PRIVILEGES
AS
SELECT
    USER_NAME(p.grantor_principal_id)    AS GRANTOR,
    USER_NAME(p.grantee_principal_id)    AS GRANTEE,
    DB_NAME()                        AS TABLE_CATALOG,
    SCHEMA_NAME(o.schema_id)            AS TABLE_SCHEMA,
    o.name                            AS TABLE_NAME,
    c.name                            AS COLUMN_NAME,
    convert(varchar(10), CASE p.type
        WHEN 'SL' THEN 'SELECT'
        WHEN 'UP' THEN 'UPDATE'
        WHEN 'RF' THEN 'REFERENCES'
        END)                        AS PRIVILEGE_TYPE,
    convert(varchar(3), CASE p.state
        WHEN 'G' THEN 'NO'
        WHEN 'W' THEN 'YES'
        END)                        AS IS_GRANTABLE
FROM
    sys.database_permissions p,
    sys.objects o,
    sys.columns c
WHERE
    o.type IN ('U', 'V')
    AND o.object_id = c.object_id
    AND p.class = 1
    AND p.major_id = o.object_id
    AND p.minor_id = c.column_id
    AND p.type IN ('RF','SL','UP')
    AND p.state IN ('G', 'W')
    AND (p.grantee_principal_id = 0
        OR p.grantee_principal_id = DATABASE_PRINCIPAL_ID()
        OR p.grantor_principal_id = DATABASE_PRINCIPAL_ID())
GO
  
~~~

---
###   See also  
[List of views](../views.md)

