## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[syscomments\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.syscomments**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -129 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|id| |int|4|
|number| |smallint|2|
|colid| |smallint|2|
|status| |smallint|2|
|ctext| |varbinary|8000|
|texttype| |smallint|2|
|language| |smallint|2|
|encrypted| |bit|1|
|compressed| |bit|1|
|text| |nvarchar|4000|

Total: 10 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[syscomments\]
 No dependencies exist

---
### Objects that \[sys\].\[syscomments\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-129_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
-- Return system objects in master database context
CREATE VIEW sys.syscomments AS
    SELECT o.id AS id,
        convert(smallint, case when o.type in ('P', 'RF') then 1 else 0 end) AS number,
        s.colid, s.status,
        convert(varbinary(8000), s.text) AS ctext,
        convert(smallint, 2 + 4 * (s.status &amp; 1)) AS texttype,
        convert(smallint, 0) AS language,
        sysconv(bit, s.status &amp; 1) AS encrypted,
        sysconv(bit, 0) AS compressed,
        s.text
    FROM sys.sysschobjs$ o CROSS APPLY OpenRowset(TABLE SQLSRC, o.id, 0) s
    WHERE o.nsclass = 0 -- x_eonc_Standard
        AND o.pclass = 1 -- x_eunc_Object
        AND o.type IN ('C','D','P','R','V','X','FN','IF','TF','RF','IS','TR')
    AND (DB_ID() = 1 AND has_access('AO', o.id) = 1 OR has_access('CO', o.id) = 1)
    UNION ALL
    SELECT c.object_id AS id,
        convert(smallint, c.column_id) AS number,
        s.colid, s.status,
        convert(varbinary(8000), s.text) AS ctext,
        convert(smallint, 2 + 4 * (s.status &amp; 1)) AS texttype,
        convert(smallint, 0) AS language,
        sysconv(bit, s.status &amp; 1) AS encrypted,
        sysconv(bit, 0) AS compressed,
        s.text
    FROM sys.computed_columns c CROSS APPLY OpenRowset(TABLE SQLSRC, c.object_id, c.column_id) s
    UNION ALL
    SELECT p.object_id AS id,
        convert(smallint, p.procedure_number) AS number,
        s.colid, s.status,
        convert(varbinary(8000), s.text) AS ctext,
        convert(smallint, 2 + 4 * (s.status &amp; 1)) AS texttype,
        convert(smallint, 0) AS language,
        sysconv(bit, s.status &amp; 1) AS encrypted,
        sysconv(bit, 0) AS compressed,
        s.text
    FROM sys.numbered_procedures p CROSS APPLY OpenRowset(TABLE SQLSRC, p.object_id, p.procedure_number) s
GO
GRANT SELECT
    ON [sys].[syscomments]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

