## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[sysusers\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.sysusers**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -140 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|uid| |smallint|2|
|status| |smallint|2|
|name| |sysname|128|
|sid| |varbinary|85|
|roles| |varbinary|2048|
|createdate| |datetime|8|
|updatedate| |datetime|8|
|altuid| |smallint|2|
|password| |varbinary|256|
|gid| |smallint|2|
|environ| |varchar|255|
|hasdbaccess| |int|4|
|islogin| |int|4|
|isntname| |int|4|
|isntgroup| |int|4|
|isntuser| |int|4|
|issqluser| |int|4|
|isaliased| |int|4|
|issqlrole| |int|4|
|isapprole| |int|4|

Total: 20 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[sysusers\]
 No dependencies exist

---
### Objects that \[sys\].\[sysusers\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-140_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
-- Note: gid (max group id) not maintained, shiloh logic not correct anyway
--
CREATE VIEW sys.sysusers AS
    SELECT uid = convert(smallint, u.id),
        status = convert(smallint, case u.type
            when 'U' then 12 when 'G' then 4 when 'A' then 32 else 0 end),
        u.name, u.sid,
        roles = convert(varbinary(2048), null),
        createdate = u.created,
        updatedate = u.modified,
        altuid = convert(smallint, r.indepid),
        password = convert(varbinary(256), null),
        gid = convert(smallint, case u.type when 'R' then u.id else 0 end),
        environ = convert(varchar(255), null),
        hasdbaccess = convert(int, case when p.state in ('G','W') then 1 else 0 end),
        islogin = convert(int, case u.type when 'A' then 0 when 'R' then 0 else 1 end),
        isntname = convert(int, case u.type when 'U' then 1 when 'G' then 1 else 0 end),    -- USR_SID_EXTERNAL
        isntgroup = convert(int, case u.type when 'G' then 1 else 0 end),
        isntuser = convert(int, case u.type when 'U' then 1 else 0 end),    -- USR_SID_EXTERNAL
        issqluser = convert(int, case u.type when 'S' then 1 else 0 end),
        isaliased = convert(int, 0),   -- Aliases were deprecated and removed
        issqlrole = convert(int, case u.type when 'R' then 1 else 0 end),
        isapprole = convert(int, case u.type when 'A' then 1 else 0 end)
    FROM sys.sysowners u
    LEFT JOIN sys.sysprivs p ON p.class = 0 AND p.id = 0 AND p.subid = 0 AND p.grantee = u.id AND p.grantor = 1 AND p.type = 'CO'
    LEFT JOIN sys.syssingleobjrefs r ON r.depid = u.id AND r.depsubid = 0 AND r.class = case u.type when 'R' then 51 end -- SRC_ROLEOWNER
    WHERE has_access('US', u.id) = 1
GO
GRANT SELECT
    ON [sys].[sysusers]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

