## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[dm_db_tuning_recommendations\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.dm_db_tuning_recommendations**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 06/15/2019 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -185224994 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|name| |nvarchar|4000|
|type| |nvarchar|4000|
|reason| |nvarchar|4000|
|valid_since| |datetime2|8|
|last_refresh| |datetime2|8|
|state| |nvarchar|4000|
|is_executable_action| |bit|1|
|is_revertable_action| |bit|1|
|execute_action_start_time| |datetime2|8|
|execute_action_duration| |time|5|
|execute_action_initiated_by| |nvarchar|4000|
|execute_action_initiated_time| |datetime2|8|
|revert_action_start_time| |datetime2|8|
|revert_action_duration| |time|5|
|revert_action_initiated_by| |nvarchar|4000|
|revert_action_initiated_time| |datetime2|8|
|score| |int|4|
|details| |nvarchar|1073741823|

Total: 18 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[dm_db_tuning_recommendations\]
 No dependencies exist

---
### Objects that \[sys\].\[dm_db_tuning_recommendations\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE VIEW sys.dm_db_tuning_recommendations AS
    (SELECT
        [RecommendationName] AS [name],
        [AdvisorName] AS [type],
        [RecommendationReason] AS [reason],
        [ValidSince] AS [valid_since],
        [LastRefresh] AS [last_refresh],
        [State] AS [state],
        [IsExecutableAction] AS [is_executable_action],
        [IsRevertableAction] AS [is_revertable_action],
        [ExecuteActionStartTime] AS [execute_action_start_time],
        [ExecuteActionDuration] AS [execute_action_duration],
        [ExecuteActionInitiatedBy] AS [execute_action_initiated_by],
        [ExecuteActionInitiatedTime] AS [execute_action_initiated_time],
        [RevertActionStartTime] AS [revert_action_start_time],
        [RevertActionDuration] AS [revert_action_duration],
        [RevertActionInitiatedBy] AS [revert_action_initiated_by],
        [RevertActionInitiatedTime] AS [revert_action_initiated_time],
        [Score] AS [score],
        [Details] AS [details]
    FROM OpenRowset(TABLE DATABASE_TUNING_RECOMMENDATIONS)
    CROSS APPLY
        OPENJSON([json] Collate Database_Default) WITH (
            [RecommendationName] nvarchar(4000), [AdvisorName] nvarchar(4000), [RecommendationReason] nvarchar(4000), [ValidSince] datetime2, [LastRefresh] datetime2,
            [State] nvarchar(4000), [IsExecutableAction] bit, [IsRevertableAction] bit, [ExecuteActionStartTime] datetime2,
            [ExecuteActionDuration] time, [ExecuteActionInitiatedBy] nvarchar(4000), [ExecuteActionInitiatedTime] datetime2, [RevertActionStartTime] datetime2,
            [RevertActionDuration] time, [RevertActionInitiatedBy] nvarchar(4000), [RevertActionInitiatedTime] datetime2, [Score] int, [Details] nvarchar(max)
        ))
    UNION ALL
        (SELECT * FROM sys.dm_database_plan_correction_recommendations)
GO
  
~~~

---
###   See also  
[List of views](../views.md)

