## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[dm_db_missing_index_group_stats\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.dm_db_missing_index_group_stats**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -185662232 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|group_handle| |int|4|
|unique_compiles| |bigint|8|
|user_seeks| |bigint|8|
|user_scans| |bigint|8|
|last_user_seek| |datetime|8|
|last_user_scan| |datetime|8|
|avg_total_user_cost| |float|8|
|avg_user_impact| |float|8|
|system_seeks| |bigint|8|
|system_scans| |bigint|8|
|last_system_seek| |datetime|8|
|last_system_scan| |datetime|8|
|avg_total_system_cost| |float|8|
|avg_system_impact| |float|8|

Total: 14 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[dm_db_missing_index_group_stats\]
 No dependencies exist

---
### Objects that \[sys\].\[dm_db_missing_index_group_stats\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.dm_db_missing_index_group_stats AS

    SELECT
        -- key
        group_handle = index_id,
        
        -- number of compiles (same for all queries because stored at combo level)
        unique_compiles = MAX(unique_compiles),

        -- stats for user queries
        user_seeks = SUM(user_seeks),
        user_scans = SUM(user_scans),
        last_user_seek = NULLIF(MAX(ISNULL(last_user_seek, 0)), 0),
        last_user_scan = NULLIF(MAX(ISNULL(last_user_scan, 0)), 0),
        avg_total_user_cost =
            CASE 
                WHEN SUM(user_seeks + user_scans) &gt; 0 
                THEN SUM(total_user_cost) / SUM(user_seeks + user_scans)
                ELSE 0 
            END,
        avg_user_impact =
            CASE 
                WHEN SUM(user_seeks + user_scans) &gt; 0 AND SUM(total_user_improvement) &gt; 0 AND SUM(total_user_cost) &gt; 0
                THEN ROUND(100 * IIF(SUM(total_user_improvement) &gt; SUM(total_user_cost), 1, SUM(total_user_improvement) / SUM(total_user_cost)), 2)
                ELSE 0 
            END,

        -- stats for system queries
        system_seeks = SUM(system_seeks),
        system_scans = SUM(system_scans),
        last_system_seek = NULLIF(MAX(ISNULL(last_system_seek, 0)), 0),
        last_system_scan = NULLIF(MAX(ISNULL(last_system_scan, 0)), 0),
        avg_total_system_cost =
            CASE 
                WHEN SUM(system_seeks + system_scans) &gt; 0 
                THEN SUM(total_system_cost) / SUM(system_seeks + system_scans)
                ELSE 0 
            END,
        avg_system_impact =
            CASE 
                WHEN SUM(system_seeks + system_scans) &gt; 0 AND SUM(total_system_improvement) &gt; 0 AND SUM(total_system_cost) &gt; 0
                THEN ROUND(100 * IIF(SUM(total_system_improvement) &gt; SUM(total_system_cost), 1, SUM(total_system_improvement) / SUM(total_system_cost)), 2)
                ELSE 0 
            END
            
    FROM OpenRowset(TABLE LOGINDEXSTATS)
    WHERE status &lt;&gt; 0
    GROUP BY index_id
GO
  
~~~

---
###   See also  
[List of views](../views.md)

