## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[syscacheobjects\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.syscacheobjects**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -193 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|bucketid| |int|4|
|cacheobjtype| |nvarchar|50|
|objtype| |nvarchar|20|
|objid| |int|4|
|dbid| |smallint|2|
|dbidexec| |smallint|2|
|uid| |smallint|2|
|refcounts| |int|4|
|usecounts| |int|4|
|pagesused| |int|4|
|setopts| |int|4|
|langid| |smallint|2|
|dateformat| |smallint|2|
|status| |int|4|
|lasttime| |bigint|8|
|maxexectime| |bigint|8|
|avgexectime| |bigint|8|
|lastreads| |bigint|8|
|lastwrites| |bigint|8|
|sqlbytes| |int|4|
|sql| |nvarchar|3900|

Total: 21 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[syscacheobjects\]
 No dependencies exist

---
### Objects that \[sys\].\[syscacheobjects\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE VIEW sys.syscacheobjects (bucketid, cacheobjtype, objtype, objid, dbid, dbidexec, uid, refcounts, 
        usecounts, pagesused, setopts, langid, dateformat, status, lasttime, maxexectime, avgexectime, lastreads,
        lastwrites, sqlbytes, sql) AS
    SELECT     pvt.bucketid, pvt.cacheobjtype, pvt.objtype, 
            CONVERT(int, pvt.objectid), CONVERT(smallint, pvt.dbid),
            CONVERT(smallint, pvt.dbid_execute), CONVERT(smallint, pvt.user_id),
            pvt.refcounts, pvt.usecounts, pvt.size_in_bytes / 8192,
            CONVERT(int, pvt.set_options), CONVERT(smallint, pvt.language_id),
            CONVERT(smallint, pvt.date_format), CONVERT(int, pvt.status),
            CONVERT(bigint, 0), CONVERT(bigint, 0), CONVERT(bigint, 0), CONVERT(bigint, 0), CONVERT(bigint, 0), 
            CONVERT(int, LEN(CONVERT(nvarchar(max), fgs.text)) * 2), CONVERT(nvarchar(3900), fgs.text)
    FROM (SELECT ecp.*, epa.attribute, epa.value
        FROM sys.dm_exec_cached_plans ecp OUTER APPLY sys.dm_exec_plan_attributes(ecp.plan_handle) epa) as ecpa
    PIVOT (MAX(ecpa.value) for ecpa.attribute IN ("set_options", "objectid", "dbid", "dbid_execute", "user_id", "language_id", "date_format", "status")) as pvt
    OUTER APPLY sys.dm_exec_sql_text(pvt.plan_handle) fgs
GO
  
~~~

---
###   See also  
[List of views](../views.md)

