## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[syslogins\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.syslogins**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -205 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|sid| |varbinary|85|
|status| |smallint|2|
|createdate| |datetime|8|
|updatedate| |datetime|8|
|accdate| |datetime|8|
|totcpu| |int|4|
|totio| |int|4|
|spacelimit| |int|4|
|timelimit| |int|4|
|resultlimit| |int|4|
|name| |sysname|128|
|dbname| |sysname|128|
|password| |sysname|128|
|language| |sysname|128|
|denylogin| |int|4|
|hasaccess| |int|4|
|isntname| |int|4|
|isntgroup| |int|4|
|isntuser| |int|4|
|sysadmin| |int|4|
|securityadmin| |int|4|
|serveradmin| |int|4|
|setupadmin| |int|4|
|processadmin| |int|4|
|diskadmin| |int|4|
|dbcreator| |int|4|
|bulkadmin| |int|4|
|loginname| |sysname|128|

Total: 28 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[syslogins\]
 No dependencies exist

---
### Objects that \[sys\].\[syslogins\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.syslogins AS SELECT
    sid = p.sid,
    status = convert(smallint, 8 +
        CASE WHEN m.state in ('G','W') THEN 1 ELSE 2 END),
    createdate = p.create_date,
    updatedate = p.modify_date,
    accdate = p.create_date,
    totcpu = convert(int, 0),
    totio = convert(int, 0),
    spacelimit = convert(int, 0),
    timelimit = convert(int, 0),
    resultlimit = convert(int, 0),
    name = p.name,
    dbname = p.default_database_name,
    password = convert(sysname, LoginProperty(p.name, 'PasswordHash')),
    language = p.default_language_name,
    denylogin = convert(int, CASE WHEN m.state ='D' THEN 1 ELSE 0 END),
    hasaccess = convert(int, CASE WHEN m.state in ('G','W') THEN 1 ELSE 0 END),
    isntname = convert(int, CASE WHEN p.type in ('G','U') THEN 1 ELSE 0 END),
    isntgroup = convert(int, CASE WHEN p.type='G' THEN 1 ELSE 0 END),
    isntuser = convert(int, CASE WHEN p.type='U' THEN 1 ELSE 0 END),
    sysadmin = convert(int, ISNULL ((SELECT 1 FROM sys.server_role_members WHERE member_principal_id = p.principal_id
        AND role_principal_id = 3), 0)), --x_MDLoginIdSysAdmin
    securityadmin = convert(int, ISNULL ((SELECT 1 FROM sys.server_role_members WHERE member_principal_id = p.principal_id
        AND role_principal_id = 4), 0)), --x_MDLoginIdSecAdmin
    serveradmin = convert(int, ISNULL ((SELECT 1 FROM sys.server_role_members WHERE member_principal_id = p.principal_id
        AND role_principal_id = 5), 0)), --x_MDLoginIdServAdmin
    setupadmin = convert(int, ISNULL ((SELECT 1 FROM sys.server_role_members WHERE member_principal_id = p.principal_id
        AND role_principal_id = 6), 0)), --x_MDLoginIdSetupAdmin
    processadmin = convert(int, ISNULL ((SELECT 1 FROM sys.server_role_members WHERE member_principal_id = p.principal_id
        AND role_principal_id = 7), 0)), --x_MDLoginIdProcAdmin
    diskadmin = convert(int, ISNULL ((SELECT 1 FROM sys.server_role_members WHERE member_principal_id = p.principal_id
        AND role_principal_id = 8), 0)), --x_MDLoginIdDiskAdmin
    dbcreator = convert(int, ISNULL ((SELECT 1 FROM sys.server_role_members WHERE member_principal_id = p.principal_id
        AND role_principal_id = 9), 0)), --x_MDLoginIdDBCreator
    bulkadmin = convert(int, ISNULL ((SELECT 1 FROM sys.server_role_members WHERE member_principal_id = p.principal_id
        AND role_principal_id = 10), 0)), --x_MDLoginIdBulkAdmin
    loginname = p.name
FROM sys.server_principals p LEFT JOIN master.sys.sysprivs m
    ON m.class = 100 AND m.id = 0 AND m.subid = 0 AND m.grantee = p.principal_id AND m.grantor = 1 AND m.type = 'COSQ'
WHERE p.type &lt;&gt; 'R'
GO
  
~~~

---
###   See also  
[List of views](../views.md)

