## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[sysservers\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.sysservers**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -212 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|srvid| |smallint|2|
|srvstatus| |smallint|2|
|srvname| |sysname|128|
|srvproduct| |sysname|128|
|providername| |nvarchar|128|
|datasource| |nvarchar|4000|
|location| |nvarchar|4000|
|providerstring| |nvarchar|4000|
|schemadate| |datetime|8|
|topologyx| |int|4|
|topologyy| |int|4|
|catalog| |sysname|128|
|srvcollation| |sysname|128|
|connecttimeout| |int|4|
|querytimeout| |int|4|
|srvnetname| |char|30|
|isremote| |bit|1|
|rpc| |bit|1|
|pub| |bit|1|
|sub| |bit|1|
|dist| |bit|1|
|dpub| |bit|1|
|rpcout| |bit|1|
|dataaccess| |bit|1|
|collationcompatible| |bit|1|
|system| |bit|1|
|useremotecollation| |bit|1|
|lazyschemavalidation| |bit|1|
|collation| |sysname|128|
|nonsqlsub| |bit|1|

Total: 30 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[sysservers\]
 No dependencies exist

---
### Objects that \[sys\].\[sysservers\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.sysservers AS SELECT
    srvid = convert(smallint, server_id),
    srvstatus = convert(smallint,
        is_remote_login_enabled + is_publisher * 2
        + is_subscriber * 4 + is_distributor * 8
        + is_linked * 32 + is_rpc_out_enabled * 64
        + is_data_access_enabled * 128 + is_collation_compatible * 256
        + is_system * 512 + uses_remote_collation * 1024
        + lazy_schema_validation * 2048 + is_nonsql_subscriber * 4096),
    srvname = name,
    srvproduct = product,
    providername = case when UPPER(provider) = N'SQLNCLI' then N'SQLOLEDB' else provider end,
    datasource = data_source,
    location,
    providerstring = provider_string,
    schemadate = modify_date,
    topologyx = convert(int, 0),
    topologyy = convert(int, 0),
    catalog,
    srvcollation = convert(sysname, collationproperty(collation_name, 'collationid')),
    connecttimeout = connect_timeout,
    querytimeout = query_timeout,
    srvnetname = convert(char(30), case when (product = N'SQL Server') then data_source end),
    isremote = sysconv(bit, 1 - is_linked),
    rpc = is_remote_login_enabled,
    pub = is_publisher,
    sub = is_subscriber,
    dist = is_distributor,
    dpub = sysconv(bit, is_distributor &amp; is_publisher),
    rpcout = is_rpc_out_enabled,
    dataaccess = is_data_access_enabled,
    collationcompatible = is_collation_compatible,
    system = is_system,
    useremotecollation = uses_remote_collation,
    lazyschemavalidation = lazy_schema_validation,
    collation = collation_name,
    nonsqlsub = is_nonsql_subscriber
FROM sys.servers
GO
  
~~~

---
###   See also  
[List of views](../views.md)

