## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[database_mirroring_witnesses\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.database_mirroring_witnesses**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -214 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|database_name| |sysname|128|
|principal_server_name| |sysname|128|
|mirror_server_name| |sysname|128|
|safety_level| |tinyint|1|
|safety_level_desc| |nvarchar|60|
|safety_sequence_number| |int|4|
|role_sequence_number| |int|4|
|mirroring_guid| |uniqueidentifier|16|
|family_guid| |uniqueidentifier|16|
|is_suspended| |bit|1|
|is_suspended_sequence_number| |int|4|
|partner_sync_state| |tinyint|1|
|partner_sync_state_desc| |nvarchar|60|

Total: 13 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[database_mirroring_witnesses\]
 No dependencies exist

---
### Objects that \[sys\].\[database_mirroring_witnesses\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.database_mirroring_witnesses AS
    SELECT database_name = w.name,
        principal_server_name = w.psrv,
        mirror_server_name = w.ssrv,
        safety_level = w.safety,
        safety_level_desc = s.name,
        safety_sequence_number = w.safetysequence,
        role_sequence_number = w.rolesequence,
        mirroring_guid = w.logshippingid,
        family_guid = w.familyid,
        is_suspended = sysconv(bit, 1 - w.status &amp; 1),
        is_suspended_sequence_number = w.statussequence,
        partner_sync_state = dbmw.sync_state,
        partner_sync_state_desc = dbmw.sync_state_desc
    FROM master.sys.syslogshippers w
    LEFT JOIN sys.syspalvalues s ON s.class = 'DBSL' AND s.value = w.safety
    OUTER APPLY OpenRowset(TABLE DBMIRROR_WITNESS, w.logshippingid) dbmw
GO
  
~~~

---
###   See also  
[List of views](../views.md)

