## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[master_files\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.master_files**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -216 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|database_id| |int|4|
|file_id| |int|4|
|file_guid| |uniqueidentifier|16|
|type| |tinyint|1|
|type_desc| |nvarchar|60|
|data_space_id| |int|4|
|name| |sysname|128|
|physical_name| |nvarchar|260|
|state| |tinyint|1|
|state_desc| |nvarchar|60|
|size| |int|4|
|max_size| |int|4|
|growth| |int|4|
|is_media_read_only| |bit|1|
|is_read_only| |bit|1|
|is_sparse| |bit|1|
|is_percent_growth| |bit|1|
|is_name_reserved| |bit|1|
|is_persistent_log_buffer| |bit|1|
|create_lsn| |numeric|13|
|drop_lsn| |numeric|13|
|read_only_lsn| |numeric|13|
|read_write_lsn| |numeric|13|
|differential_base_lsn| |numeric|13|
|differential_base_guid| |uniqueidentifier|16|
|differential_base_time| |datetime|8|
|redo_start_lsn| |numeric|13|
|redo_start_fork_guid| |uniqueidentifier|16|
|redo_target_lsn| |numeric|13|
|redo_target_fork_guid| |uniqueidentifier|16|
|backup_lsn| |numeric|13|
|credential_id| |int|4|

Total: 32 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[master_files\]
 No dependencies exist

---
### Objects that \[sys\].\[master_files\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
 CREATE VIEW sys.master_files AS
    SELECT
        database_id     = f.dbid,
        file_id         = f.fileid,
        file_guid         = f.fileguid,
        type            = f.filetype,
        type_desc        = ft.name,
        data_space_id     = f.grpid,
        name             = f.lname,
        physical_name     = f.pname,
        state            = convert(tinyint, case f.filestate        -- Map enum EMDFileState to AvailablityStates
                                when 0 then 0 when 10 then 0    -- ONLINE
                                when 4 then 7    -- DEFUNCT
                                when 5 then 3 when 9 then 3    -- RECOVERY_PENDING
                                when 7 then 1 when 8 then 1 when 11 then 1    -- RESTORING
                                when 12 then 4    -- SUSPECT
                                else 6 end),    -- OFFLINE
        state_desc        = st.name,
        f.size,
        max_size             = f.maxsize,
        f.growth,
        is_media_read_only     = sysconv(bit, f.status &amp; 8),        -- FIL_READONLY_MEDIA
        is_read_only             = sysconv(bit, f.status &amp; 16),    -- FIL_READONLY
        is_sparse             = sysconv(bit, f.status &amp; 256),    -- FIL_SPARSE_FILE
        is_percent_growth     = sysconv(bit, f.status &amp; 32),    -- FIL_PERCENT_GROWTH
        is_name_reserved        = sysconv(bit, case f.filestate when 3 then 1 else 0 end), -- x_efs_DroppedReusePending
        is_persistent_log_buffer = sysconv(bit, f.status &amp; 2048), -- FIL_IS_PMM_METADATA
        create_lsn            = GetNumericLsn(f.createlsn),
        drop_lsn                = GetNumericLsn(f.droplsn),
        read_only_lsn            = GetNumericLsn(f.readonlylsn),
        read_write_lsn        = GetNumericLsn(f.readwritelsn),
        differential_base_lsn    = GetNumericLsn(f.diffbaselsn),
        differential_base_guid    = f.diffbaseguid,
        differential_base_time    = nullif(f.diffbasetime, 0),
        redo_start_lsn            = GetNumericLsn(f.redostartlsn),
        redo_start_fork_guid    = f.redostartforkguid,
        redo_target_lsn        = GetNumericLsn(f.redotargetlsn),
        redo_target_fork_guid    = f.forkguid,
        backup_lsn            = GetNumericLsn(f.backuplsn),
        credential_id        = cr.credential_id
    FROM sys.sysbrickfiles f
    LEFT JOIN sys.syspalvalues st ON st.class = 'DBFS' AND st.value = f.filestate
    LEFT JOIN sys.syspalvalues ft ON ft.class = 'DBFT' AND ft.value = f.filetype
    LEFT JOIN sys.credentials cr ON f.pname LIKE cr.name + N'%' COLLATE database_default
    WHERE f.dbid &lt; 0x7fff -- consistent with sys.databases
        AND f.pruid = 0
        AND f.filestate NOT IN (1, 2)    -- x_efs_Dummy, x_efs_Dropped
        AND has_access('MF', 1) = 1
GO
  
~~~

---
###   See also  
[List of views](../views.md)

