## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[server_principals\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.server_principals**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -217 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|name| |sysname|128|
|principal_id| |int|4|
|sid| |varbinary|85|
|type| |char|1|
|type_desc| |nvarchar|60|
|is_disabled| |bit|1|
|create_date| |datetime|8|
|modify_date| |datetime|8|
|default_database_name| |sysname|128|
|default_language_name| |sysname|128|
|credential_id| |int|4|
|owning_principal_id| |int|4|
|is_fixed_role| |bit|1|

Total: 13 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[server_principals\]
 No dependencies exist

---
### Objects that \[sys\].\[server_principals\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.server_principals AS
    SELECT p.name,
        p.id AS principal_id,
        p.sid, p.type,
        n.name AS type_desc,
        is_disabled = sysconv(bit, p.status &amp; 0x80),
        p.crdate AS create_date,
        p.modate AS modify_date,
        p.dbname AS default_database_name,
        p.lang AS default_language_name,
        r.indepid AS credential_id,
        (case when p.id &gt;= 2 and p.id &lt; 11 then 1 else ro.indepid end) AS owning_principal_id,
        sysconv(bit, case when p.id &gt;= 3 and p.id &lt; 11 then 1 else 0 end) AS is_fixed_role        
    FROM master.sys.sysxlgns p
    LEFT JOIN sys.syspalnames n ON n.class = 'LGTY' AND n.value = p.type
    LEFT JOIN sys.syssingleobjrefs r ON r.depid = p.id AND r.class = 63 AND r.depsubid = 0    -- SRC_LOGIN_CREDENTIAL
    LEFT JOIN sys.syssingleobjrefs ro ON ro.depid = p.id AND ro.class = 61 AND ro.depsubid = 0    -- SRC_SRVROLELOGINOWNER
    WHERE has_access('LG', p.id) = 1
        AND p.type &lt;&gt; 'M' -- exclude component logins
GO
  
~~~

---
###   See also  
[List of views](../views.md)

