## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[servers\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.servers**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -220 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|server_id| |int|4|
|name| |sysname|128|
|product| |sysname|128|
|provider| |sysname|128|
|data_source| |nvarchar|4000|
|location| |nvarchar|4000|
|provider_string| |nvarchar|4000|
|catalog| |sysname|128|
|connect_timeout| |int|4|
|query_timeout| |int|4|
|is_linked| |bit|1|
|is_remote_login_enabled| |bit|1|
|is_rpc_out_enabled| |bit|1|
|is_data_access_enabled| |bit|1|
|is_collation_compatible| |bit|1|
|uses_remote_collation| |bit|1|
|collation_name| |sysname|128|
|lazy_schema_validation| |bit|1|
|is_system| |bit|1|
|is_publisher| |bit|1|
|is_subscriber| |bit|1|
|is_distributor| |bit|1|
|is_nonsql_subscriber| |bit|1|
|is_remote_proc_transaction_promotion_enabled| |bit|1|
|modify_date| |datetime|8|
|is_rda_server| |bit|1|

Total: 26 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[servers\]
 No dependencies exist

---
### Objects that \[sys\].\[servers\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.servers AS
    SELECT s.id AS server_id,
        s.name, s.product, s.provider,
        data_source = convert(nvarchar(4000), v.value),
        location = convert(nvarchar(4000), l.value),
        provider_string = convert(nvarchar(4000), LinkedServerProperty(s.name, 'ProviderString')),
        s.catalog,
        s.connecttimeout AS connect_timeout,
        s.querytimeout AS query_timeout,
        sysconv(bit, s.status &amp; 4) AS is_linked,                -- SRV_NORPCMAP
        sysconv(bit, s.status &amp; 1) AS is_remote_login_enabled,    -- SRV_RPCIN
        sysconv(bit, s.status &amp; 2) AS is_rpc_out_enabled,        -- SRV_RPCOUT
        sysconv(bit, s.status &amp; 8) AS is_data_access_enabled,    -- SRV_DATA
        sysconv(bit, s.status &amp; 16) AS is_collation_compatible,    -- SRV_COLLATECOMPAT
        sysconv(bit, s.status &amp; 64) AS uses_remote_collation,    -- SRV_USERMTCOLLATE
        convert(sysname, collationpropertyfromid(s.cid,'name')) AS collation_name,
        sysconv(bit, s.status &amp; 128) AS lazy_schema_validation,    -- SRV_LAZYSCHCHECK
        sysconv(bit, s.status &amp; 32) AS is_system,                -- SRV_SYSTEM
        sysconv(bit, s.status &amp; 256) AS is_publisher,            -- SRV_PUB
        sysconv(bit, s.status &amp; 0x200) AS is_subscriber,        -- SRV_SUB
        sysconv(bit, s.status &amp; 0x400) AS is_distributor,        -- SRV_DIST
        sysconv(bit, s.status &amp; 0x800) AS is_nonsql_subscriber,    -- SRV_NONSQLSUB
        ~(sysconv(bit, s.status &amp; 0x1000)) AS is_remote_proc_transaction_promotion_enabled,    -- SRV_NODTCPROMOFORRPC
        s.modate AS modify_date,                            -- SRV80_USERMTCOLLATE
        sysconv(bit, s.status &amp; 0x2000) AS is_rda_server        -- SRV_REMOTEDATAARCHIVE
    FROM master.sys.sysxsrvs s
    LEFT JOIN sys.sysobjvalues v ON v.valclass = 25 AND v.objid = s.id AND v.subobjid = 1 AND v.valnum = 0    -- SRV_DATASRC
    LEFT JOIN sys.sysobjvalues l ON l.valclass = 25 AND l.objid = s.id AND l.subobjid = 2 AND l.valnum = 0    -- SRV_LOCATION
    WHERE s.id = 0 OR has_access('SR', s.id) = 1
GO
  
~~~

---
###   See also  
[List of views](../views.md)

