## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[sql_logins\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.sql_logins**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -223 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|name| |sysname|128|
|principal_id| |int|4|
|sid| |varbinary|85|
|type| |char|1|
|type_desc| |nvarchar|60|
|is_disabled| |bit|1|
|create_date| |datetime|8|
|modify_date| |datetime|8|
|default_database_name| |sysname|128|
|default_language_name| |sysname|128|
|credential_id| |int|4|
|is_policy_checked| |bit|1|
|is_expiration_checked| |bit|1|
|password_hash| |varbinary|256|

Total: 14 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[sql_logins\]
 No dependencies exist

---
### Objects that \[sys\].\[sql_logins\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.sql_logins AS
    SELECT p.name,
        p.id AS principal_id,
        p.sid, p.type,
        n.name AS type_desc,
        sysconv(bit, p.status &amp; 0x80) AS is_disabled,
        p.crdate AS create_date,
        p.modate AS modify_date,
        p.dbname AS default_database_name,
        p.lang AS default_language_name,
        r.indepid AS credential_id,
        sysconv(bit, p.status &amp; 0x10000) AS is_policy_checked,
        sysconv(bit, p.status &amp; 0x20000) AS is_expiration_checked,
        convert(varbinary(256), LoginProperty(p.name, 'PasswordHash')) AS password_hash
    FROM master.sys.sysxlgns p
    LEFT JOIN sys.syssingleobjrefs r ON r.depid = p.id AND r.class = 63 AND r.depsubid = 0    -- SRC_LOGIN_CREDENTIAL
    LEFT JOIN sys.syspalnames n ON n.class = 'LGTY' AND n.value = p.type
    WHERE type = 'S'
        AND has_access('LG', id) = 1
GO
  
~~~

---
###   See also  
[List of views](../views.md)

