## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[endpoints\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.endpoints**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -226 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|name| |sysname|128|
|endpoint_id| |int|4|
|principal_id| |int|4|
|protocol| |tinyint|1|
|protocol_desc| |nvarchar|60|
|type| |tinyint|1|
|type_desc| |nvarchar|60|
|state| |tinyint|1|
|state_desc| |nvarchar|60|
|is_admin_endpoint| |bit|1|

Total: 10 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[endpoints\]
 No dependencies exist

---
### Objects that \[sys\].\[endpoints\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.endpoints AS
    SELECT
        e.name, e.id AS endpoint_id,
        o.indepid AS principal_id,
        e.protocol, p.name AS protocol_desc,
        e.type, t.name AS type_desc,
        state = convert(tinyint, bstat &amp; 3),    -- BSTAT_STATEMASK
        s.name AS state_desc,
        sysconv(bit, case when e.affinity = -1 then 1 else 0 end) AS is_admin_endpoint
    FROM master.sys.sysendpts e
    LEFT JOIN sys.syssingleobjrefs o ON o.depid = e.id AND o.class = 60 AND o.depsubid = 0    -- SRC_ENDPTLOGINOWNER
    LEFT JOIN sys.syspalvalues p ON p.class = 'EPPR' AND p.value = e.protocol
    LEFT JOIN sys.syspalvalues t ON t.class = 'EPTY' AND t.value = e.type
    LEFT JOIN sys.syspalvalues s ON s.class = 'EPST' AND s.value = e.bstat &amp; 3
    WHERE has_access('HE', e.id) = 1
GO
  
~~~

---
###   See also  
[List of views](../views.md)

