## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[http_endpoints\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.http_endpoints**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -227 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|name| |sysname|128|
|endpoint_id| |int|4|
|principal_id| |int|4|
|protocol| |tinyint|1|
|protocol_desc| |nvarchar|60|
|type| |tinyint|1|
|type_desc| |nvarchar|60|
|state| |tinyint|1|
|state_desc| |nvarchar|60|
|is_admin_endpoint| |bit|1|
|site| |nvarchar|128|
|url_path| |nvarchar|4000|
|is_clear_port_enabled| |bit|1|
|clear_port| |int|4|
|is_ssl_port_enabled| |bit|1|
|ssl_port| |int|4|
|is_anonymous_enabled| |bit|1|
|is_basic_auth_enabled| |bit|1|
|is_digest_auth_enabled| |bit|1|
|is_kerberos_auth_enabled| |bit|1|
|is_ntlm_auth_enabled| |bit|1|
|is_integrated_auth_enabled| |bit|1|
|authorization_realm| |nvarchar|128|
|default_logon_domain| |nvarchar|128|
|is_compression_enabled| |bit|1|

Total: 25 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[http_endpoints\]
 No dependencies exist

---
### Objects that \[sys\].\[http_endpoints\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.http_endpoints AS
    SELECT e.name, e.id AS endpoint_id,
        o.indepid AS principal_id,
        e.protocol, p.name AS protocol_desc,
        e.type, t.name AS type_desc,
        convert(tinyint, e.bstat &amp; 3) AS state,    -- BSTAT_STATEMASK
        s.name AS state_desc,
        sysconv(bit, case when e.affinity = -1 then 1 else 0 end) AS is_admin_endpoint, 
        e.site,
        convert(nvarchar(4000), v.value) collate Latin1_General_CI_AS_KS_WS AS url_path,
        sysconv(bit, e.pstat &amp; 1) AS is_clear_port_enabled,        -- PSTAT_HTTP_CLEARPORT
        e.port1 AS clear_port,
        sysconv(bit, e.pstat &amp; 2) AS is_ssl_port_enabled,        -- PSTAT_HTTP_SSLPORT
        e.port2 AS ssl_port,
        sysconv(bit, 0) AS is_anonymous_enabled,                -- is_anonymous_enabled is always zero.
        sysconv(bit, e.pstat &amp; 8) AS is_basic_auth_enabled,        -- PSTAT_HTTP_BASICAUTH
        sysconv(bit, e.pstat &amp; 16) AS is_digest_auth_enabled,        -- PSTAT_HTTP_DIGESTAUTH
        sysconv(bit, (e.pstat &amp; (32|64))) AS is_kerberos_auth_enabled,    -- PSTAT_HTTP_INTEGAUTH | PSTAT_HTTP_KERBEROS
        sysconv(bit, (e.pstat &amp; (32|256))) AS is_ntlm_auth_enabled,    -- PSTAT_HTTP_INTEGAUTH |PSTAT_HTTP_NTLM
        sysconv(bit, case when (e.pstat &amp; 32) &lt;&gt; 0 or (e.pstat &amp; 320)=320 then 1 else 0 end) AS is_integrated_auth_enabled,    -- PSTAT_HTTP_INTEGAUTH | (PSTAT_HTTP_KERBEROS &amp; PSTAT_HTTP_NTLM)
        e.authrealm AS authorization_realm,
        e.dfltdm AS default_logon_domain,
        sysconv(bit, e.pstat &amp; 128) AS is_compression_enabled         -- PSTAT_HTTP_COMPRESS
    FROM master.sys.sysendpts e
    LEFT JOIN sys.syssingleobjrefs o ON o.depid = e.id AND o.class = 60 AND o.depsubid = 0    -- SRC_ENDPTLOGINOWNER
    LEFT JOIN sys.sysobjvalues v ON v.valclass = 46 AND v.objid = e.id AND v.subobjid = 0 AND v.valnum = 1    -- SVC_EP_PROPS
    LEFT JOIN sys.syspalvalues p ON p.class = 'EPPR' AND p.value = e.protocol
    LEFT JOIN sys.syspalvalues t ON t.class = 'EPTY' AND t.value = e.type
    LEFT JOIN sys.syspalvalues s ON s.class = 'EPST' AND s.value = e.bstat &amp; 3
    WHERE e.protocol = 1
        AND has_access('HE', e.id) = 1
GO
  
~~~

---
###   See also  
[List of views](../views.md)

