## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[soap_endpoints\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.soap_endpoints**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -230 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|name| |sysname|128|
|endpoint_id| |int|4|
|principal_id| |int|4|
|protocol| |tinyint|1|
|protocol_desc| |nvarchar|60|
|type| |tinyint|1|
|type_desc| |nvarchar|60|
|state| |tinyint|1|
|state_desc| |nvarchar|60|
|is_admin_endpoint| |bit|1|
|is_sql_language_enabled| |bit|1|
|wsdl_generator_procedure| |nvarchar|776|
|default_database| |sysname|128|
|default_namespace| |nvarchar|384|
|default_result_schema| |tinyint|1|
|default_result_schema_desc| |nvarchar|60|
|is_xml_charset_enforced| |bit|1|
|is_session_enabled| |bit|1|
|session_timeout| |int|4|
|login_type| |nvarchar|60|
|header_limit| |int|4|

Total: 21 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[soap_endpoints\]
 No dependencies exist

---
### Objects that \[sys\].\[soap_endpoints\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.soap_endpoints AS
    SELECT e.name,
        endpoint_id = e.id,
        principal_id = o.indepid,
        e.protocol,
        protocol_desc = p.name,
        e.type,
        type_desc = t.name,
        state = convert(tinyint, bstat &amp; 3),    -- BSTAT_STATEMASK
        state_desc = s.name,
        sysconv(bit, case when e.affinity = -1 then 1 else 0 end) AS is_admin_endpoint, 
        is_sql_language_enabled = sysconv(bit, e.tstat &amp; 8),        -- TSTAT_SOAP_SQL
        wsdl_generator_procedure = e.wsdlproc,
        default_database = e.dfltdb,
        default_namespace = e.dfltns,
        default_result_schema = convert(tinyint, e.tstat &amp; 7),        -- TSTAT_SOAP_RSLTSCHMASK
        default_result_schema_desc = rs.name,
        is_xml_charset_enforced = sysconv(bit, e.tstat &amp; 16),        -- TSTAT_SOAP_XMLCHARSET
        is_session_enabled = sysconv(bit, e.tstat &amp; 32),            -- TSTAT_SOAP_SESSION
        session_timeout = e.typeint,
        login_type = sl.name,
        header_limit = e.maxconn
    FROM master.sys.sysendpts e
    LEFT JOIN sys.syssingleobjrefs o ON o.depid = e.id AND o.class = 60 AND o.depsubid = 0    -- SRC_ENDPTLOGINOWNER
    LEFT JOIN sys.syspalvalues p ON p.class = 'EPPR' AND p.value = e.protocol
    LEFT JOIN sys.syspalvalues t ON t.class = 'EPTY' AND t.value = e.type
    LEFT JOIN sys.syspalvalues s ON s.class = 'EPST' AND s.value = e.bstat &amp; 3
    LEFT JOIN sys.syspalvalues rs ON rs.class = 'SPRS' AND rs.value = e.tstat &amp; 7
    LEFT JOIN sys.syspalvalues sl ON sl.class = 'SPSL' AND sl.value = e.tstat &amp; 64
    WHERE e.type = 1
        AND has_access('HE', e.id) = 1
GO
  
~~~

---
###   See also  
[List of views](../views.md)

