## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[server_event_sessions\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.server_event_sessions**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -252 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|event_session_id| |int|4|
|name| |nvarchar|128|
|event_retention_mode| |char|1|
|event_retention_mode_desc| |nvarchar|60|
|max_dispatch_latency| |int|4|
|max_memory| |int|4|
|max_event_size| |int|4|
|memory_partition_mode| |char|1|
|memory_partition_mode_desc| |nvarchar|60|
|track_causality| |bit|1|
|startup_state| |bit|1|

Total: 11 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[server_event_sessions\]
 No dependencies exist

---
### Objects that \[sys\].\[server_event_sessions\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.server_event_sessions AS
    SELECT 
        event_session_id            = c.id,
        name                        = convert(sysname, c.name) collate catalog_default,
        event_retention_mode        = char(v2.subobjid), -- EMDXEEventRetention
        event_retention_mode_desc    = xeer.name collate catalog_default,
        max_dispatch_latency        = convert(INT, v1.value),
        max_memory                    = v1.subobjid,
        max_event_size                = v1.valnum,
        memory_partition_mode        = char(v2.valnum), -- EMDXEMemoryPartition
        memory_partition_mode_desc    = xemp.name collate catalog_default,
        track_causality                = convert(bit, c.status &amp; 1), -- XE_SESSION_STATUS_BIT_CAUSALITY
        startup_state                = convert(bit, c.status &amp; 2)  -- XE_SESSION_STATUS_BIT_AUTOSTART
    FROM master.sys.sysclsobjs c
    LEFT JOIN master.sys.sysobjvalues v1 ON
        v1.valclass = 90 AND    -- SVC_XE_SESSION_PROP_1
        v1.objid = c.id
    LEFT JOIN master.sys.sysobjvalues v2 ON
        v2.valclass = 91 AND    -- SVC_XE_SESSION_PROP_2
        v2.objid = c.id
    LEFT JOIN sys.syspalnames xeer ON xeer.class = 'XEER' AND xeer.value = char(v2.subobjid)
    LEFT JOIN sys.syspalnames xemp ON xemp.class = 'XEMP' AND xemp.value = char(v2.valnum)
    WHERE c.class = 62            -- SOC_XESESSION
    AND convert(bit, c.status &amp; 4) = 0     -- filter out database scoped sessions    
    AND has_access ('ES', 0) = 1
GO
  
~~~

---
###   See also  
[List of views](../views.md)

