## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[resource_governor_workload_groups\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.resource_governor_workload_groups**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -254 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|group_id| |int|4|
|name| |sysname|128|
|importance| |sysname|128|
|request_max_memory_grant_percent| |int|4|
|request_max_cpu_time_sec| |int|4|
|request_memory_grant_timeout_sec| |int|4|
|max_dop| |int|4|
|group_max_requests| |int|4|
|pool_id| |int|4|
|external_pool_id| |int|4|

Total: 10 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[resource_governor_workload_groups\]
 No dependencies exist

---
### Objects that \[sys\].\[resource_governor_workload_groups\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.resource_governor_workload_groups
AS
    -- ISSUE - VSTS 83011
    -- Use isnull() below because Algebrizer doesn't properly
    -- determine these columns are non-nullable.
    SELECT
        group_id                    = co.id, -- group id
        name                        = co.name,
        importance                  = isnull(convert(sysname,case
                                                     when ((co.status / 0x100) % 0x100) = 1 then 'Low'    -- x_ergi_Low
                                                     when ((co.status / 0x100) % 0x100) = 3 then 'Medium' -- x_ergi_Medium
                                                     when ((co.status / 0x100) % 0x100) = 9 then 'High'   -- x_ergi_High
                                                     end),
                                              0),
        request_max_memory_grant_percent = isnull(co.status % 0x100, 0),
        request_max_cpu_time_sec         = co.intprop,
        request_memory_grant_timeout_sec = isnull(convert(int, convert(bigint, ov.value) % 0x100000000), 0),
        max_dop                          = isnull(convert(int, convert(bigint, ov_maxdop.value) % 0x100000000), 0),
        group_max_requests               = isnull(convert(int, convert(bigint, ov.value) / 0x100000000), 0),
        pool_id                          = sor.indepid,
        external_pool_id                 = isnull(sorex.indepid, 2)
    FROM
        master.sys.sysclsobjs co INNER JOIN
        master.sys.syssingleobjrefs sor ON
        (
            co.class = 53 AND   -- SOC_RG_GROUP
            co.id = sor.depid AND
            sor.class = 13 AND  -- SRC_RG_GROUP_TO_POOL
            sor.depsubid = 0 AND
            sor.indepsubid = 0
        ) LEFT JOIN
        master.sys.syssingleobjrefs sorex ON
        (
            co.class = 53 AND   -- SOC_RG_GROUP
            co.id = sorex.depid AND
            sorex.class = 120 AND  -- SRC_RG_GROUP_TO_EXTERNAL_POOL
            sorex.depsubid = 0 AND
            sorex.indepsubid = 0
        ) INNER JOIN
        master.sys.sysobjvalues ov ON
        (
            co.class = 53 AND   -- SOC_RG_GROUP
            co.id = ov.objid AND
            ov.valclass = 64 AND -- SVC_RG_GROUP
            ov.subobjid = 0 AND
            ov.valnum = 0
        ) LEFT JOIN
        master.sys.sysobjvalues ov_maxdop ON
        (
            co.class = 53 AND   -- SOC_RG_GROUP
            co.id = ov_maxdop.objid AND
            ov_maxdop.valclass = 64 AND -- SVC_RG_GROUP
            ov_maxdop.subobjid = 0 AND
            ov_maxdop.valnum = 1
        )
    WHERE
        has_access('RG', 0) = 1
GO
  
~~~

---
###   See also  
[List of views](../views.md)

