## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[change_tracking_databases\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.change_tracking_databases**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -258 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|database_id| |int|4|
|is_auto_cleanup_on| |tinyint|1|
|retention_period| |int|4|
|retention_period_units| |tinyint|1|
|retention_period_units_desc| |nvarchar|60|
|max_cleanup_version| |bigint|8|

Total: 6 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[change_tracking_databases\]
 No dependencies exist

---
### Objects that \[sys\].\[change_tracking_databases\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.change_tracking_databases AS
    SELECT 
        id AS database_id,
        -- UNDONE: reconcile this for Sterling if needed.
        -- case when d.name = db_name() then COALESCE(convert(int, dbprop(db_id(), 'logicaldbid')), d.id) else d.id end AS database_id,
        convert(tinyint, DatabasePropertyEx(name, 'IsChangeTrackingAutoCleanup')) as is_auto_cleanup_on,
        convert(int, DatabasePropertyEx(name, 'ChangeTrackingRetentionPeriod')) as retention_period,
        convert(tinyint, DatabasePropertyEx(name, 'ChangeTrackingRetentionUnits')) as retention_period_units,
        convert(nvarchar(60), DatabasePropertyEx(name, 'ChangeTrackingRetentionUnitsDesc')) as retention_period_units_desc,
        change_tracking_max_cleanup_version((case when serverproperty('EngineEdition') = 5 then DB_ID() else id end)) as max_cleanup_version
    FROM sys.sysdbreg
    WHERE id &lt; 0x7fff
        AND has_access('DB', (case when serverproperty('EngineEdition') = 5 then DB_ID() else id end)) = 1
        AND (category &amp; 128) = 128
GO
  
~~~

---
###   See also  
[List of views](../views.md)

