## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[server_file_audits\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.server_file_audits**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -260 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|audit_id| |int|4|
|name| |sysname|128|
|audit_guid| |uniqueidentifier|16|
|create_date| |datetime|8|
|modify_date| |datetime|8|
|principal_id| |int|4|
|type| |char|2|
|type_desc| |nvarchar|60|
|on_failure| |tinyint|1|
|on_failure_desc| |nvarchar|60|
|is_state_enabled| |bit|1|
|queue_delay| |int|4|
|predicate| |nvarchar|3000|
|max_file_size| |bigint|8|
|max_rollover_files| |int|4|
|max_files| |int|4|
|reserve_disk_space| |bit|1|
|log_file_path| |nvarchar|260|
|log_file_name| |nvarchar|260|

Total: 19 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[server_file_audits\]
 No dependencies exist

---
### Objects that \[sys\].\[server_file_audits\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.server_file_audits AS
    SELECT
        au.audit_id,
        au.name,
        au.audit_guid,
        au.create_date,
        au.modify_date,
        au.principal_id,
        au.type,
        au.type_desc,    
        au.on_failure,
        au.on_failure_desc,
        au.is_state_enabled,
        au.queue_delay,
        au.predicate,
        convert(bigint, ms.value) AS max_file_size,
        convert(int, mr.value) AS max_rollover_files,
        convert(int, mf.value) AS max_files,
        sysconv(bit, au.status &amp; 0x10000) AS reserve_disk_space,
        convert(nvarchar(260), pt.value) AS log_file_path,
        convert(nvarchar(260), nm.value) AS log_file_name
    FROM sys.server_audits$ au
    LEFT JOIN master.sys.sysobjvalues ms ON ms.valclass = 38 AND ms.objid = au.audit_id AND ms.subobjid = 0 AND ms.valnum = 50 -- SVC_AUDITPROPS/AUDIT_FL_MAX_SIZE
    LEFT JOIN master.sys.sysobjvalues mr ON mr.valclass = 38 AND mr.objid = au.audit_id AND mr.subobjid = 0 AND mr.valnum = 51 -- SVC_AUDITPROPS/AUDIT_FL_MAX_ROLLOVER
    LEFT JOIN master.sys.sysobjvalues nm ON nm.valclass = 38 AND nm.objid = au.audit_id AND nm.subobjid = 0 AND nm.valnum = 53 -- SVC_AUDITPROPS/AUDIT_FL_NAME
    LEFT JOIN master.sys.sysobjvalues pt ON pt.valclass = 38 AND pt.objid = au.audit_id AND pt.subobjid = 0 AND pt.valnum = 54 -- SVC_AUDITPROPS/AUDIT_FL_PATH
    LEFT JOIN master.sys.sysobjvalues mf ON mf.valclass = 38 AND mf.objid = au.audit_id AND mf.subobjid = 0 AND mf.valnum = 55 -- SVC_AUDITPROPS/AUDIT_FL_MAX_FILES
    WHERE au.type = 'FL'
GO
  
~~~

---
###   See also  
[List of views](../views.md)

