## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[resource_governor_external_resource_pools\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.resource_governor_external_resource_pools**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 06/15/2019 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -268 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|external_pool_id| |int|4|
|name| |sysname|128|
|max_cpu_percent| |int|4|
|max_memory_percent| |int|4|
|max_processes| |int|4|
|version| |bigint|8|

Total: 6 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[resource_governor_external_resource_pools\]
 No dependencies exist

---
### Objects that \[sys\].\[resource_governor_external_resource_pools\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.resource_governor_external_resource_pools
AS
    -- ISSUE - VSTS 83011
    -- Use isnull() below because Algebrizer doesn't properly
    -- determine these columns are non-nullable.
    SELECT
        external_pool_id             = co.id,
        name                = co.name,
        max_cpu_percent     = isnull((co.status/0x100)     % 0x100, 0),
        max_memory_percent  = isnull((co.status/0x1000000) % 0x100, 0),
        max_processes     = isnull( convert(int,co.intprop), 0),
        version = isnull(convert(bigint, ov.value), 0)
    FROM
        master.sys.sysclsobjs co LEFT JOIN
        master.sys.sysobjvalues ov ON
        (
            co.id = ov.objid AND
            ov.valclass = 125 AND -- SVC_RG_EXTERNAL_POOL
            ov.subobjid = 0 AND
            ov.valnum = 1
        )
    WHERE 
        co.class = 104 AND -- SOC_RG_EXTERNAL_POOL
        has_access('RG', 0) = 1 
GO
  
~~~

---
###   See also  
[List of views](../views.md)

