## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[INFORMATION_SCHEMA\].\[SEQUENCES\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **INFORMATION_SCHEMA.SEQUENCES**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[INFORMATION_SCHEMA\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/3.md) |
| Owner | \[INFORMATION_SCHEMA\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -331432826 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|SEQUENCE_CATALOG| |nvarchar|128|
|SEQUENCE_SCHEMA| |nvarchar|128|
|SEQUENCE_NAME| |sysname|128|
|DATA_TYPE| |nvarchar|128|
|NUMERIC_PRECISION| |tinyint|1|
|NUMERIC_PRECISION_RADIX| |smallint|2|
|NUMERIC_SCALE| |int|4|
|START_VALUE| |sql_variant|8016|
|MINIMUM_VALUE| |sql_variant|8016|
|MAXIMUM_VALUE| |sql_variant|8016|
|INCREMENT| |sql_variant|8016|
|CYCLE_OPTION| |bit|1|
|DECLARED_DATA_TYPE| |sysname|128|
|DECLARED_NUMERIC_PRECISION| |tinyint|1|
|DECLARED_NUMERIC_SCALE| |tinyint|1|

Total: 15 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[INFORMATION_SCHEMA\].\[SEQUENCES\]
 No dependencies exist

---
### Objects that \[INFORMATION_SCHEMA\].\[SEQUENCES\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE VIEW INFORMATION_SCHEMA.SEQUENCES
AS
SELECT
      DB_NAME() AS SEQUENCE_CATALOG,
      SCHEMA_NAME(s.schema_id) AS SEQUENCE_SCHEMA,
      s.name AS SEQUENCE_NAME,
      ISNULL(TYPE_NAME(s.system_type_id), t.name) AS DATA_TYPE,
      s.precision AS NUMERIC_PRECISION,
      convert(smallint, CASE  -- int/money/decimal/numeric
            WHEN s.system_type_id IN (48, 52, 56, 60, 106, 108, 122, 127) THEN 10
            WHEN s.system_type_id IN (59, 62) THEN 2
            END) AS NUMERIC_PRECISION_RADIX,    -- real/float
      ODBCSCALE(s.system_type_id, s.scale) AS NUMERIC_SCALE,
      s.start_value AS START_VALUE,
      s.minimum_value AS MINIMUM_VALUE,
      s.maximum_value AS MAXIMUM_VALUE,
      s.increment AS INCREMENT,
      s.is_cycling AS CYCLE_OPTION,
      t.name AS DECLARED_DATA_TYPE,
      t.precision AS DECLARED_NUMERIC_PRECISION,
      t.scale AS DECLARED_NUMERIC_SCALE
FROM
      sys.sequences as s
      JOIN sys.types t ON s.user_type_id = t.user_type_id;
GO
  
~~~

---
###   See also  
[List of views](../views.md)

