## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[columns\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.columns**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -391 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|object_id| |int|4|
|name| |sysname|128|
|column_id| |int|4|
|system_type_id| |tinyint|1|
|user_type_id| |int|4|
|max_length| |smallint|2|
|precision| |tinyint|1|
|scale| |tinyint|1|
|collation_name| |sysname|128|
|is_nullable| |bit|1|
|is_ansi_padded| |bit|1|
|is_rowguidcol| |bit|1|
|is_identity| |bit|1|
|is_computed| |bit|1|
|is_filestream| |bit|1|
|is_replicated| |bit|1|
|is_non_sql_subscribed| |bit|1|
|is_merge_published| |bit|1|
|is_dts_replicated| |bit|1|
|is_xml_document| |bit|1|
|xml_collection_id| |int|4|
|default_object_id| |int|4|
|rule_object_id| |int|4|
|is_sparse| |bit|1|
|is_column_set| |bit|1|
|generated_always_type| |tinyint|1|
|generated_always_type_desc| |nvarchar|60|
|encryption_type| |int|4|
|encryption_type_desc| |nvarchar|64|
|encryption_algorithm_name| |sysname|128|
|column_encryption_key_id| |int|4|
|column_encryption_key_database_name| |sysname|128|
|is_hidden| |bit|1|
|is_masked| |bit|1|
|graph_type| |int|4|
|graph_type_desc| |nvarchar|60|

Total: 36 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[columns\]
 No dependencies exist

---
### Objects that \[sys\].\[columns\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-391_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.columns AS
    SELECT c.id AS object_id,
        c.name, c.colid AS column_id,
        c.xtype AS system_type_id,
        c.utype AS user_type_id,
        c.length AS max_length,
        c.prec AS precision, c.scale,
        convert(sysname, CollationPropertyFromId(c.collationid, 'name')) AS collation_name,
        sysconv(bit, 1 - (c.status &amp; 1)) AS is_nullable,        -- CPM_NOTNULL
        sysconv(bit, c.status &amp; 2) AS is_ansi_padded,        -- CPM_NOTRIM
        sysconv(bit, c.status &amp; 8) AS is_rowguidcol,            -- CPM_ROWGUIDCOL
        sysconv(bit, c.status &amp; 4) AS is_identity,            -- CPM_IDENTCOL
        sysconv(bit, case when sov4.value is NULL then c.status &amp; 16 else 0 end) is_computed,            -- CPM_COMPUTED
        sysconv(bit, c.status &amp; 32) AS is_filestream,            -- CPM_FILESTREAM
        sysconv(bit, c.status &amp; 0x020000) AS is_replicated,            -- CPM_REPLICAT
        sysconv(bit, c.status &amp; 0x040000) AS is_non_sql_subscribed,    -- CPM_NONSQSSUB
        sysconv(bit, c.status &amp; 0x080000) AS is_merge_published,    -- CPM_MERGEREPL
        sysconv(bit, c.status &amp; 0x100000) AS is_dts_replicated,    -- CPM_REPLDTS
        sysconv(bit, c.status &amp; 2048) AS is_xml_document,        -- CPM_XML_DOC 
        c.xmlns AS xml_collection_id,
        c.dflt AS default_object_id,
        c.chk AS rule_object_id,
        sysconv(bit, c.status &amp; 0x1000000) AS is_sparse,    -- CPM_SPARSE
        sysconv(bit, c.status &amp; 0x2000000) AS is_column_set,    -- CPM_SPARSECOLUMNSET
        convert(tinyint, case when c.status &amp; 0x10000000 = 0x10000000 then 1 when c.status &amp; 0x20000000 = 0x20000000 then 2 when sov3.value &gt;= 3 AND sov3.value &lt;= 6 then sov3.value else 0 end) as generated_always_type, -- CPM_TEMPORALSYSSTARTCOLUMN CPM_TEMPORALSYSENDCOLUMN
        convert(nvarchar(60), case when c.status &amp; 0x10000000 = 0x10000000 then 'AS_ROW_START' when c.status &amp; 0x20000000 = 0x20000000 then 'AS_ROW_END' when sov3.value = 3 then 'AS_SUSER_SID_START' when sov3.value = 4 then 'AS_SUSER_SID_END' when sov3.value = 5 then 'AS_SUSER_SNAME_START' when sov3.value = 6 then 'AS_SUSER_SNAME_END' else 'NOT_APPLICABLE' end) collate Latin1_General_CI_AS_KS_WS as generated_always_type_desc, -- These _DESC columns should always be the fixed latin collation. Reason is that unlike other columns in system tables that can change depending on the collation setting of the database/instance, these are always fixed on all installations of SQL Server.
        convert(int, (convert(bigint, sov.value) / 0x100) % 0x100) as encryption_type,
        convert(nvarchar(64), v1.name) as encryption_type_desc,
        convert(sysname, v2.name) as encryption_algorithm_name,
        sor.indepid as column_encryption_key_id,
        convert(sysname, sov2.value) collate catalog_default as column_encryption_key_database_name,
        sysconv(bit, c.status &amp; 0x2000) AS is_hidden,        -- CPM_HIDDEN
        sysconv(bit, c.status &amp; 0x40000000) AS is_masked,            -- CPM_DATAMASKED
        convert(int, sov4.value) as graph_type,
        convert(nvarchar(60), v3.name) collate Latin1_General_CI_AS_KS_WS as graph_type_desc
    FROM sys.syscolpars c
    LEFT JOIN sys.sysobjvalues sov ON sov.valclass = 115 /*SVC_COL_ENCRYPTION_MD*/ and sov.objid = c.id and sov.subobjid = c.colid and sov.valnum = 0 -- TYPE_AND_ALGORITHM
    LEFT JOIN sys.sysobjvalues sov2 ON sov2.valclass = 115 /*SVC_COL_ENCRYPTION_MD*/ and sov2.objid = c.id and sov2.subobjid = c.colid and sov2.valnum = 2 -- CEK_DATABASE_NAME
    LEFT JOIN sys.sysobjvalues sov3 ON sov3.valclass = 119 /*SVC_GENERATED_ALWAYS_COLUMN_TYPE*/ and sov3.objid = c.id and sov3.subobjid = c.colid
    LEFT JOIN sys.sysobjvalues sov4 ON sov4.valclass = 128 /*SVC_GRAPHDB_COLUMN_TYPE*/ and sov4.objid = c.id and sov4.subobjid = c.colid and sov4.valnum = 0
    LEFT JOIN sys.syssingleobjrefs sor ON sor.class = 113 /*SRC_COLUMN_TO_COL_ENCRYPTION_KEY*/ and sov.objid = sor.depid and sov.subobjid = sor.depsubid
    LEFT JOIN sys.syspalvalues v1 ON v1.class = 'CET' AND v1.value = convert(int, (convert(bigint, sov.value) / 0x100) % 0x100)
    LEFT JOIN sys.syspalvalues v2 ON v2.class = 'CEA' AND v2.value = convert(int, convert(bigint, sov.value) % 0x100)
    LEFT JOIN sys.syspalvalues v3 ON v3.class = 'EGCT' AND v3.value = convert(int, sov4.value)
    WHERE number = 0 AND has_access('CO', c.id) = 1
GO
GRANT SELECT
    ON [sys].[columns]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

