## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[parameters\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.parameters**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -393 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|object_id| |int|4|
|name| |sysname|128|
|parameter_id| |int|4|
|system_type_id| |tinyint|1|
|user_type_id| |int|4|
|max_length| |smallint|2|
|precision| |tinyint|1|
|scale| |tinyint|1|
|is_output| |bit|1|
|is_cursor_ref| |bit|1|
|has_default_value| |bit|1|
|is_xml_document| |bit|1|
|default_value| |sql_variant|8016|
|xml_collection_id| |int|4|
|is_readonly| |bit|1|
|is_nullable| |bit|1|
|encryption_type| |int|4|
|encryption_type_desc| |nvarchar|64|
|encryption_algorithm_name| |sysname|128|
|column_encryption_key_id| |int|4|
|column_encryption_key_database_name| |sysname|128|

Total: 21 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[parameters\]
 No dependencies exist

---
### Objects that \[sys\].\[parameters\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-393_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.parameters AS
    SELECT object_id, p.name,
        parameter_id, system_type_id,
        user_type_id, max_length,
        precision, scale,
        is_output, is_cursor_ref,
        has_default_value, is_xml_document,
        default_value, xml_collection_id,
        is_readonly, is_nullable,
        convert(int, (convert(bigint, sov.value) / 0x100) % 0x100) as encryption_type,
        convert(nvarchar(64), v1.name) as encryption_type_desc,
        convert(sysname, v2.name) as encryption_algorithm_name,
        sor.indepid as column_encryption_key_id,
        convert(sysname, sov2.value) collate catalog_default as column_encryption_key_database_name
    FROM sys.parameters$ p
    LEFT JOIN sys.sysobjvalues sov ON sov.valclass = 121 /*SVC_PARAM_ENCRYPTION_MD*/ and sov.objid = p.object_id and sov.subobjid = p.parameter_id and sov.valnum = 0 -- TYPE_AND_ALGORITHM
    LEFT JOIN sys.sysobjvalues sov2 ON sov2.valclass = 121 /*SVC_PARAM_ENCRYPTION_MD*/ and sov2.objid = p.object_id and sov2.subobjid = p.parameter_id and sov2.valnum = 2 -- CEK_DATABASE_NAME
    LEFT JOIN sys.syssingleobjrefs sor ON sor.class = 114 /*SRC_PARAM_TO_COL_ENCRYPTION_KEY*/ and sov.objid = sor.depid and sov.subobjid = sor.depsubid
    LEFT JOIN sys.syspalvalues v1 ON v1.class = 'CET' AND v1.value = convert(int, (convert(bigint, sov.value) / 0x100) % 0x100)
    LEFT JOIN sys.syspalvalues v2 ON v2.class = 'CEA' AND v2.value = convert(int, convert(bigint, sov.value) % 0x100)
    WHERE number = 1
GO
GRANT SELECT
    ON [sys].[parameters]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

