## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[computed_columns\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.computed_columns**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -395 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|object_id| |int|4|
|name| |sysname|128|
|column_id| |int|4|
|system_type_id| |tinyint|1|
|user_type_id| |int|4|
|max_length| |smallint|2|
|precision| |tinyint|1|
|scale| |tinyint|1|
|collation_name| |sysname|128|
|is_nullable| |bit|1|
|is_ansi_padded| |bit|1|
|is_rowguidcol| |bit|1|
|is_identity| |bit|1|
|is_filestream| |bit|1|
|is_replicated| |bit|1|
|is_non_sql_subscribed| |bit|1|
|is_merge_published| |bit|1|
|is_dts_replicated| |bit|1|
|is_xml_document| |bit|1|
|xml_collection_id| |int|4|
|default_object_id| |int|4|
|rule_object_id| |int|4|
|definition| |nvarchar|1073741823|
|uses_database_collation| |bit|1|
|is_persisted| |bit|1|
|is_computed| |bit|1|
|is_sparse| |bit|1|
|is_column_set| |bit|1|
|generated_always_type| |tinyint|1|
|generated_always_type_desc| |nvarchar|60|
|encryption_type| |int|4|
|encryption_type_desc| |nvarchar|64|
|encryption_algorithm_name| |nvarchar|128|
|column_encryption_key_id| |int|4|
|column_encryption_key_database_name| |sysname|128|
|is_hidden| |bit|1|
|is_masked| |bit|1|
|graph_type| |int|4|
|graph_type_desc| |nvarchar|60|

Total: 39 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[computed_columns\]
 No dependencies exist

---
### Objects that \[sys\].\[computed_columns\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-395_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.computed_columns AS
    SELECT object_id = id,
        name = s.name,
        column_id = colid,
        system_type_id = xtype,
        user_type_id = utype,
        max_length = length,
        precision = prec,
        scale = scale,
        collation_name = convert(sysname,CollationPropertyFromId(collationid,'name')),
        is_nullable = sysconv(bit, 1 - (status &amp; 1)),         -- CPM_NOTNULL
        is_ansi_padded = sysconv(bit, status &amp; 2),         -- CPM_NOTRIM
        is_rowguidcol = sysconv(bit, status &amp; 8),         -- CPM_ROWGUIDCOL
        is_identity = sysconv(bit, status &amp; 4),         -- CPM_IDENTCOL
        is_filestream = sysconv(bit, status &amp; 32),         -- CPM_FILESTREAM
        is_replicated = sysconv(bit, status &amp; 0x20000),     -- CPM_REPLICAT
        is_non_sql_subscribed = sysconv(bit, status &amp; 0x40000),    -- CPM_NONSQSSUB
        is_merge_published = sysconv(bit, status &amp; 0x80000),     -- CPM_MERGEREPL
        is_dts_replicated = sysconv(bit, status &amp; 0x100000),     -- CPM_REPLDTS
        is_xml_document = sysconv(bit, status &amp; 2048),        -- CPM_XML_DOC         
        xml_collection_id = xmlns,
        default_object_id = dflt,
        rule_object_id = chk,
        definition = object_definition(id, colid),
        uses_database_collation = sysconv(bit, status &amp; 128),        -- CPM_USESDBCOLL
        is_persisted = sysconv(bit, status &amp; 64),            -- CPM_PERSISTEDCC    
        is_computed = sysconv(bit, status &amp; 16),            -- CPM_COMPUTED    
        sysconv(bit, 0) as is_sparse,
        sysconv(bit, 0) as is_column_set,
        convert(tinyint, 0) AS generated_always_type,
        convert(nvarchar(60), 'NOT_APPLICABLE') collate Latin1_General_CI_AS_KS_WS AS generated_always_type_desc,
        convert(int, NULL) as encryption_type,
        convert(nvarchar(64), NULL) COLLATE Latin1_General_CI_AS_KS_WS as encryption_type_desc,
        convert(sysname, NULL) COLLATE Latin1_General_CI_AS_KS_WS as encryption_algorithm_name,
        convert(int, NULL) as column_encryption_key_id,
        convert(sysname, NULL) collate catalog_default as column_encryption_key_database_name,
        sysconv(bit, 0) as is_hidden,
        sysconv(bit, 0) AS is_masked,
        convert(int, NULL) AS graph_type,
        convert(nvarchar(60), NULL) collate Latin1_General_CI_AS_KS_WS as graph_type_desc
    FROM sys.syscolpars s
    LEFT JOIN sys.sysobjvalues sov1 ON sov1.valclass = 128 /*SVC_GRAPHDB_COLUMN_TYPE*/ AND sov1.objid = id AND sov1.subobjid = colid AND sov1.valnum = 0 
    LEFT JOIN sys.syspalvalues v1 ON v1.class = 'EGCT' AND v1.value = convert(int, sov1.value)
    WHERE number = 0
        AND (status &amp; 16) = 16            -- CPM_COMPUTED
        AND sov1.value IS NULL
        AND has_access('CO', id) = 1
GO
GRANT SELECT
    ON [sys].[computed_columns]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

