## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[indexes\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.indexes**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -397 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|object_id| |int|4|
|name| |sysname|128|
|index_id| |int|4|
|type| |tinyint|1|
|type_desc| |nvarchar|60|
|is_unique| |bit|1|
|data_space_id| |int|4|
|ignore_dup_key| |bit|1|
|is_primary_key| |bit|1|
|is_unique_constraint| |bit|1|
|fill_factor| |tinyint|1|
|is_padded| |bit|1|
|is_disabled| |bit|1|
|is_hypothetical| |bit|1|
|is_ignored_in_optimization| |bit|1|
|allow_row_locks| |bit|1|
|allow_page_locks| |bit|1|
|has_filter| |bit|1|
|filter_definition| |nvarchar|1073741823|
|compression_delay| |int|4|
|suppress_dup_key_messages| |bit|1|
|auto_created| |bit|1|

Total: 22 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[indexes\]
 No dependencies exist

---
### Objects that \[sys\].\[indexes\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-397_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.indexes AS
    SELECT i.id AS object_id,
        i.name AS name,
        i.indid AS index_id,
        i.type,
        n.name AS type_desc,
        sysconv(bit, i.status &amp; 0x8) AS is_unique,            -- IS_IND_UNIQUE
        case when obj.status2 &amp; 0x00000008 != 0             -- OBJTAB2_HEKATON
           then 0 
           else isnull(ds.indepid, 1 - (i.status &amp; 0x100)/0x100) 
        end AS data_space_id,    -- IS_IND_ITWINDEX
        sysconv(bit, i.status &amp; 0x4) AS ignore_dup_key,            -- IS_IND_DPKEYS
        sysconv(bit, i.status &amp; 0x20) AS is_primary_key,        -- IS_IND_PRIMARY
        sysconv(bit, i.status &amp; 0x40) AS is_unique_constraint,        -- IS_IND_UNIQUE_CO
        i.fillfact AS fill_factor,
        sysconv(bit, i.status &amp; 0x10) AS is_padded,            -- IS_IND_PADINDEX
        sysconv(bit, i.status &amp; 0x80) AS is_disabled,            -- IS_IND_OFFLINE
        sysconv(bit, i.status &amp; 0x100) AS is_hypothetical,        -- IS_IND_ITWINDEX
        sysconv(bit, i.status &amp; 0x02000000) AS is_ignored_in_optimization,    -- IS_IND_IGNORE_IN_OPTIMIZATION
        case when obj.status2 &amp; 0x00000008 != 0             -- OBJTAB2_HEKATON
           then sysconv(bit, 0) 
          else sysconv(bit, 1 - (i.status &amp; 512)/512)            -- IS_IND_NO_ROWLOCK
        end as allow_row_locks,
        case when obj.status2 &amp; 0x00000008 != 0             -- OBJTAB2_HEKATON
           then sysconv(bit, 0)
          else sysconv(bit, 1 - (i.status &amp; 1024)/1024)            -- IS_IND_NO_PAGELOCK
        end AS allow_page_locks,
        sysconv(bit, i.status &amp; 0x20000) AS has_filter,            -- IS_HAS_FILTER
        case when (i.status &amp; 0x20000) != 0 then object_definition(i.id, i.indid, 7) else NULL end AS filter_definition, -- x_euncIndex
        case when (i.type = 5 or i.type = 6) and objval.value is null
            then 
                case when obj.status2 &amp; 0x00000008 != 0 -- OBJTAB2_HEKATON
                    then 60 -- default for HEKATON
                    else 0 -- default for disk based columnstore indexes
                end
            else cast(objval.value as int) 
        end as compression_delay, -- compression_delay
        sysconv(bit, i.status &amp; 0x1000000) AS suppress_dup_key_messages,    -- IS_IND_DPKEYMSG
        sysconv(bit, i.status &amp; 0x08000000) AS auto_created    -- IS_IND_AUTO_CREATED
    FROM sys.sysidxstats i
    LEFT JOIN sys.syssingleobjrefs ds ON ds.depid = i.id AND ds.class = 7 AND ds.depsubid = i.indid    -- SRC_INDEXTODS
    LEFT JOIN sys.syspalvalues n ON n.class = 'IDXT' and n.value = i.type
    INNER JOIN sys.sysschobjs$ obj ON obj.id = i.id
    LEFT JOIN sys.sysobjvalues objval ON objval.valclass = 124 AND i.id = objval.objid AND i.indid = objval.subobjid AND objval.valnum = 0 -- SVC_COLUMNSTORE_INDEX_ATTRIBUTES = 124; VALNUM_COMPRESSION_DELAY = 0
    WHERE (i.status &amp; 1) &lt;&gt; 0
        AND has_access('CO', i.id) = 1        -- IS_INDEX
        AND (i.status &amp; 0x04000000) = 0        -- !IS_IND_RESUMABLE
GO
GRANT SELECT
    ON [sys].[indexes]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

