## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[xml_indexes\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.xml_indexes**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -398 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|object_id| |int|4|
|name| |sysname|128|
|index_id| |int|4|
|type| |tinyint|1|
|type_desc| |nvarchar|60|
|is_unique| |bit|1|
|data_space_id| |int|4|
|ignore_dup_key| |bit|1|
|is_primary_key| |bit|1|
|is_unique_constraint| |bit|1|
|fill_factor| |tinyint|1|
|is_padded| |bit|1|
|is_disabled| |bit|1|
|is_hypothetical| |bit|1|
|is_ignored_in_optimization| |bit|1|
|allow_row_locks| |bit|1|
|allow_page_locks| |bit|1|
|using_xml_index_id| |int|4|
|secondary_type| |char|1|
|secondary_type_desc| |nvarchar|60|
|has_filter| |bit|1|
|filter_definition| |nvarchar|1073741823|
|xml_index_type| |tinyint|1|
|xml_index_type_description| |nvarchar|60|
|path_id| |int|4|
|auto_created| |bit|1|

Total: 26 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[xml_indexes\]
 No dependencies exist

---
### Objects that \[sys\].\[xml_indexes\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-398_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.xml_indexes AS
    SELECT i.id AS object_id,
        i.name AS name,
        i.indid AS index_id,
        i.type,
        n.name AS type_desc,
        sysconv(bit, i.status &amp; 0x8) AS is_unique,            -- IS_IND_UNIQUE
        isnull(ds.indepid, 1) AS data_space_id,
        sysconv(bit, i.status &amp; 0x4) AS ignore_dup_key,        -- IS_IND_DPKEYS
        sysconv(bit, i.status &amp; 0x20) AS is_primary_key,        -- IS_IND_PRIMARY
        sysconv(bit, i.status &amp; 0x40) AS is_unique_constraint,    -- IS_IND_UNIQUE_CO
        i.fillfact AS fill_factor,
        sysconv(bit, i.status &amp; 0x10) AS is_padded,                -- IS_IND_PADINDEX
        sysconv(bit, i.status &amp; 0x80) AS is_disabled,            -- IS_IND_OFFLINE
        sysconv(bit, i.status &amp; 0x100) AS is_hypothetical,        -- IS_IND_ITWINDEX
        sysconv(bit, i.status &amp; 0x02000000) AS is_ignored_in_optimization,    -- IS_IND_IGNORE_IN_OPTIMIZATION
        sysconv(bit, 1 - (i.status &amp; 512)/512) AS allow_row_locks,        -- IS_IND_NO_ROWLOCK
        sysconv(bit, 1 - (i.status &amp; 1024)/1024) AS allow_page_locks,    -- IS_IND_NO_PAGELOCK
        ui.indepsubid AS using_xml_index_id,
        char(CASE when (i.tinyprop = 80) OR (i.tinyprop = 82) OR (i.tinyprop = 86) then nullif(i.tinyprop, 0) else null end) AS secondary_type,
        CASE when (i.tinyprop = 80) OR (i.tinyprop = 82) OR (i.tinyprop = 86) then s.name else null end AS secondary_type_desc,
        sysconv(bit, 0) AS has_filter,
        convert(nvarchar(max), NULL) AS filter_definition,
        convert(tinyint, q.value) AS xml_index_type,
        convert(nvarchar(60), q.name) AS xml_index_type_description,
        convert(int, p.indepsubid) AS path_id,
        sysconv(bit, i.status &amp; 0x08000000) AS auto_created    -- IS_IND_AUTO_CREATED
    FROM sys.sysidxstats i
    LEFT JOIN sys.syssingleobjrefs ds ON ds.depid = i.id AND ds.class = 7 AND ds.depsubid = i.indid    -- SRC_INDEXTODS    
    LEFT JOIN sys.syssingleobjrefs ui ON ui.depid = i.id AND (ui.class = 100 OR ui.class = 110) AND ui.depsubid = i.indid    -- SRC_XMLUSINGINDEX or SRC_SELECTIVEXMLUSINGINDEX
    LEFT JOIN sys.syspalvalues n ON n.class = 'IDXT' and n.value = i.type
    LEFT JOIN sys.syspalvalues s ON s.class = 'XITY' AND s.value = i.tinyprop
    LEFT JOIN sys.syspalvalues q ON q.class = 'XIT2' AND q.value = (CASE i.tinyprop WHEN 0 THEN 0
                                                                                    WHEN 76 THEN 2
                                                                                    WHEN 80 THEN 1
                                                                                    WHEN 82 THEN 1
                                                                                    WHEN 86 THEN 1
                                                                                    WHEN 83 THEN 3
                                                                                    ELSE NULL END)
    LEFT JOIN sys.syssingleobjrefs p ON p.class = 111 AND p.depid = i.id AND p.depsubid = i.indid    -- SRC_SELECTIVEXMLINDEX_USINGPATH
    WHERE (i.indid &gt;= 256000 and i.indid &lt; 257000) -- is index id within XML index range?
        AND has_access('CO', i.id) = 1
GO
GRANT SELECT
    ON [sys].[xml_indexes]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

