## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[partitions\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.partitions**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -399 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|partition_id| |bigint|8|
|object_id| |int|4|
|index_id| |int|4|
|partition_number| |int|4|
|hobt_id| |bigint|8|
|rows| |bigint|8|
|filestream_filegroup_id| |smallint|2|
|data_compression| |tinyint|1|
|data_compression_desc| |nvarchar|60|

Total: 9 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[partitions\]
 No dependencies exist

---
### Objects that \[sys\].\[partitions\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-399_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.partitions AS
    WITH partitions_columnstore(partition_id, object_id, index_id, partition_number, hobt_id, 
                    rows, status, filestream_filegroup_id, data_compression, data_compression_desc)
    AS
    (
    SELECT
        rs.rowsetid AS partition_id,
        rs.idmajor AS object_id, -- The following 3 columns form a unique
        rs.idminor AS index_id,  -- Composite ID for a partition.
        rs.numpart AS partition_number, -- This is the third column
        rs.rowsetid AS hobt_id,
        -- To get the rows, we first check if ALUCOUNT has any rows related to the partition.
        -- ALUCOUNT is a tvf that fetches the row count for a partition.
        -- sysrowsets does not maintain the row count all the time for columnstore 
        -- e.g. when the tuple mover compresses row groups.
        -- So use ALUCOUNT to get the row count.
        isnull(ct.rows, rs.rcrows) as rows,
        rs.status as status,
        rs.fgidfs as filestream_filegroup_id,
        cmprlevel AS data_compression,
        cl.name AS data_compression_desc
    FROM sys.sysrowsets rs OUTER APPLY OpenRowset(TABLE ALUCOUNT, rs.rowsetid, 0, 0, 0) ct
        LEFT JOIN sys.syspalvalues cl ON cl.class = 'CMPL' AND cl.value = cmprlevel
        WHERE rs.ownertype = 1 and sysconv(bit, rs.status &amp; 0x00010000) = 1 -- Consider only columnstore base indexes
    ),
    partitions_rowstore(partition_id, object_id, index_id, partition_number, hobt_id, 
                rows, status, filestream_filegroup_id, data_compression, data_compression_desc)
    AS
    (
    SELECT
        rs.rowsetid AS partition_id,
        rs.idmajor AS object_id, -- The following 3 columns form a unique
        rs.idminor AS index_id,  -- Composite ID for a partition.
        rs.numpart AS partition_number, -- This is the third column
        rs.rowsetid AS hobt_id,
        rs.rcrows as rows,
        rs.status as status,
        rs.fgidfs as filestream_filegroup_id,
        cmprlevel AS data_compression,
        cl.name AS data_compression_desc
    FROM sys.sysrowsets rs 
        LEFT JOIN sys.syspalvalues cl ON cl.class = 'CMPL' AND cl.value = cmprlevel
        WHERE rs.ownertype = 1 and sysconv(bit, rs.status &amp; 0x00010000) = 0 -- Ignore columnstore base indexes and orphaned rows.
    )
    
    -- Result is a union of rowstore and columnstore partitions.
    
    -- Get rowstore partitions
    SELECT 
        partition_id,
        object_id,
        index_id,
        partition_number,
        hobt_id,
        isnull(ct.rows, p.rows) AS rows,
        filestream_filegroup_id,
        data_compression,
        data_compression_desc    
        from partitions_rowstore p OUTER APPLY OpenRowset(TABLE ALUCOUNT, p.partition_id, 0, 0, p.object_id) ct
    
    union all
    
    -- For columnstore the total rows in a partition is sum of the rows in 
    -- compressed row groups, deltastores, minus the rows in delete buffer and delete bitmap.
    -- P1 below gives the columnstore base index
    -- P2 gives the rows in delete bitmaps, delta stores and delete buffers
    -- 
    -- NOTE: While calculating rows, even though we use a LEFT JOIN we do NOT expect
    -- P2.rows to be NULL. This is because there will at least be a delete bitmap present which
    -- returns 0 for P2.rows. Hence the check isnull(P2.rows, 0) is not required.
    -- And by using LEFT JOIN we can SEEK on partition_id that offers better performance.
    SELECT 
        P1.partition_id,
        P1.object_id,
        P1.index_id,
        P1.partition_number,
        P1.hobt_id,
        (P1.rows + P2.rows) AS rows,
        P1.filestream_filegroup_id,
        P1.data_compression,
        P1.data_compression_desc
    FROM 
        partitions_columnstore as P1
    LEFT JOIN 
        (SELECT 
            rs.idmajor AS object_id,
            rs.idminor AS index_id,
            rs.numpart AS partition_number,
            SUM(CASE -- ownertype 2 corresponds to delete bitmaps and 4 to delete buffers
                    WHEN ownertype IN (2, 4) THEN -isnull(ct.rows, rs.rcrows) -- Flip sign of delete bitmaps and delete buffers
                    ELSE isnull(ct.rows, rs.rcrows) -- delta stores are ownertype 3 and included here.
                END)
                AS rows
        FROM sys.sysrowsets rs OUTER APPLY OpenRowset(TABLE ALUCOUNT, rs.rowsetid, 0, 0, 0) ct
        WHERE ownertype IN (2, 3, 4) -- delete bitmaps, delta stores and delete buffers
        GROUP BY rs.idmajor, rs.idminor, rs.numpart) as P2 
        
    ON P1.object_id = P2.object_id and P1.index_id = P2.index_id and P1.partition_number = P2.partition_number
GO
GRANT SELECT
    ON [sys].[partitions]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

