## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[index_columns\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.index_columns**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -401 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|object_id| |int|4|
|index_id| |int|4|
|index_column_id| |int|4|
|column_id| |int|4|
|key_ordinal| |tinyint|1|
|partition_ordinal| |tinyint|1|
|is_descending_key| |bit|1|
|is_included_column| |bit|1|

Total: 8 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[index_columns\]
 No dependencies exist

---
### Objects that \[sys\].\[index_columns\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-401_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.index_columns AS
    SELECT isc.idmajor AS object_id,
        isc.idminor AS index_id,
        isc.subid AS index_column_id,
        isc.intprop AS column_id,
          isc.tinyprop1 AS key_ordinal,
          isc.tinyprop2 AS partition_ordinal,
          convert (bit, isc.status &amp; 0x4) AS is_descending_key,    -- ISC_IC_DESC_KEY
        convert (bit, isc.status &amp; 0x10) AS is_included_column    -- ISC_IC_INCLUDED
    FROM sys.sysiscols isc
    INNER JOIN sys.sysschobjs$ obj ON obj.id = isc.idmajor
    INNER JOIN sys.sysidxstats idxstats ON obj.id = idxstats.id AND isc.idminor = idxstats.indid
    WHERE (isc.status &amp; 2) &lt;&gt; 0
        AND has_access('CO', isc.idmajor) = 1    -- ISC_IND_COL
        AND (isc.status &amp; 0x10 = 0 OR obj.status2 &amp; 0x00000008 = 0 OR isc.idminor = 1)    -- ISC_IC_INCLUDED, OBJTAB2_HEKATON, ISC_IC_IDMINOR
        AND (idxstats.status &amp; 0x04000000) = 0 -- !IS_IND_RESUMABLE
GO
GRANT SELECT
    ON [sys].[index_columns]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

