## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[stats\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.stats**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -402 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|object_id| |int|4|
|name| |nvarchar|128|
|stats_id| |int|4|
|auto_created| |bit|1|
|user_created| |bit|1|
|no_recompute| |bit|1|
|has_filter| |bit|1|
|filter_definition| |nvarchar|1073741823|
|is_temporary| |bit|1|
|is_incremental| |bit|1|

Total: 10 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[stats\]
 No dependencies exist

---
### Objects that \[sys\].\[stats\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-402_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.stats AS
    SELECT id AS object_id, name,
        indid AS stats_id,
        sysconv(bit, status &amp; 0x2000) AS auto_created,    -- IS_STATS_AUTO_CRT
        sysconv(bit, case when (status &amp; 0x2001) = 0 then 1 else 0 end) AS user_created,
          sysconv(bit, status &amp; 0x4000) AS no_recompute,    -- IS_STATS_NORECOMP
        sysconv(bit, status &amp; 0x20000) AS has_filter,    -- IS_HAS_FILTER
        case when (status &amp; 0x20000) != 0 then object_definition(id, indid, 9) else NULL end AS filter_definition, -- x_euncStats
        convert(bit, 0) as is_temporary,
        sysconv(bit, status &amp; 0x800000) AS is_incremental
    FROM sys.sysidxstats s 
    WHERE (status &amp; 2)  = 2            -- IS_STATS
        AND has_access('CO', id) = 1
        AND indid NOT IN 
        (
            SELECT t.valnum as stats_id
            FROM tempstatvals t
            WHERE t.valnum &lt; 0x40000
                AND t.subobjid = s.id
        )
        AND (s.status &amp; 0x04000000) = 0 -- !IS_IND_RESUMABLE
    UNION ALL
    SELECT    t.subobjid as object_id,
            v.name COLLATE catalog_default AS name,
            t.valnum as stats_id,
            v.auto_created, 
            v.user_created,
            v.no_recompute,
            convert(bit, 0) as has_filter,
            '' as filter_definition,
            convert(bit, 1) as is_temporary,
            convert(bit, 0) as is_incremental
    FROM    tempstatvals t   
            OUTER APPLY 
            OPENROWSET(TABLE TEMPSTATS, t.objid, t.subobjid, t.valnum, convert(bit, 0)) v 
    WHERE     has_access('CO', t.subobjid) = 1 
GO
GRANT SELECT
    ON [sys].[stats]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

