## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[fulltext_indexes\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.fulltext_indexes**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -404 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|object_id| |int|4|
|unique_index_id| |int|4|
|fulltext_catalog_id| |int|4|
|is_enabled| |bit|1|
|change_tracking_state| |char|1|
|change_tracking_state_desc| |nvarchar|60|
|has_crawl_completed| |bit|1|
|crawl_type| |char|1|
|crawl_type_desc| |nvarchar|60|
|crawl_start_date| |datetime|8|
|crawl_end_date| |datetime|8|
|incremental_timestamp| |binary|8|
|stoplist_id| |int|4|
|property_list_id| |int|4|
|data_space_id| |int|4|

Total: 15 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[fulltext_indexes\]
 No dependencies exist

---
### Objects that \[sys\].\[fulltext_indexes\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-404_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.fulltext_indexes AS
    SELECT fti.id AS object_id,
        fti.indid AS unique_index_id,
        ftc.indepid AS fulltext_catalog_id,
        sysconv(bit, fti.status &amp; 8) AS is_enabled,        --FTIND_ACTIVE
        convert(char(1), substring('OMxA',1+(fti.status&amp;3),1)) AS change_tracking_state,    --FTIND_CHANGETRACKING | FTIND_AUTOUPDATE
        ts.name AS change_tracking_state_desc,
        sysconv(bit, fti.status &amp; 16) AS has_crawl_completed,    --FTIND_CRAWLCOMPLETED
        fti.crtype AS crawl_type,
        ct.name AS crawl_type_desc,
        fti.crstart AS crawl_start_date,
        fti.crend AS crawl_end_date,
        fti.crtsnext AS incremental_timestamp,
        case ISNULL(fts.indepid,0)  -- NULL means using system default, change it to 0.
            WHEN -2 then NULL -- -2 means disabled, change it to null
            ELSE ISNULL(fts.indepid, 0)
        end AS stoplist_id,
        ftp.indepid AS property_list_id,
        fti.fgid AS data_space_id
    FROM sys.sysftinds fti
    LEFT JOIN sys.syssingleobjrefs ftc ON ftc.depid = fti.id AND ftc.class = 39 AND ftc.depsubid = 0 -- SRC_FTITABTOCAT
    LEFT JOIN sys.syssingleobjrefs fts ON fts.depid = fti.id AND fts.class = 41 AND fts.depsubid = 0 -- SRC_FTITABTOSTOP
    LEFT JOIN sys.syssingleobjrefs ftp ON ftp.depid = fti.id AND ftp.class = 103 AND ftp.depsubid = 0 
    LEFT JOIN sys.syspalvalues ts ON ts.class = 'FITS' AND ts.value = fti.status &amp; 3
    LEFT JOIN sys.syspalnames ct ON ct.class = 'FTCT' AND ct.value = fti.crtype
    WHERE has_access('CO', fti.id) = 1
GO
GRANT SELECT
    ON [sys].[fulltext_indexes]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

