## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[types\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.types**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -423 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|name| |sysname|128|
|system_type_id| |tinyint|1|
|user_type_id| |int|4|
|schema_id| |int|4|
|principal_id| |int|4|
|max_length| |smallint|2|
|precision| |tinyint|1|
|scale| |tinyint|1|
|collation_name| |sysname|128|
|is_nullable| |bit|1|
|is_user_defined| |bit|1|
|is_assembly_type| |bit|1|
|default_object_id| |int|4|
|rule_object_id| |int|4|
|is_table_type| |bit|1|

Total: 15 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[types\]
 No dependencies exist

---
### Objects that \[sys\].\[types\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-423_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.types AS
    SELECT t.name AS name,
        t.xtype AS system_type_id,
        t.id AS user_type_id,
        t.schid AS schema_id,
        o.indepid AS principal_id,
        t.length AS max_length,
        t.prec AS precision,
        t.scale AS scale,
        convert(sysname, collationpropertyfromid(t.collationid, 'name')) AS collation_name,
        sysconv(bit, 1 - (t.status &amp; 1)) AS is_nullable,    -- TYPE_NOTNULL
        sysconv(bit, case when t.id &gt; 256 then 1 else 0 end) AS is_user_defined,    -- x_utypSSNAME
        sysconv(bit, case when t.xtype = 240 then 1 else 0 end) AS is_assembly_type,    -- XVT_UDT
        t.dflt AS default_object_id,
        t.chk AS rule_object_id,
        sysconv(bit, case when t.xtype = 243 then 1 else 0 end) AS is_table_type    -- XVT_TABLETYPE
    FROM sys.sysscalartypes t
    LEFT JOIN sys.syssingleobjrefs o ON o.depid = t.id AND o.class = 44 AND o.depsubid = 0    -- SRC_TYPETOOWNER
    LEFT JOIN sys.syssingleobjrefs sor ON sor.depid = t.id AND sor.class = 36 AND sor.depsubid = 0    -- SRC_TYPETOTABLE 
    WHERE (t.id &lt;= 256 OR has_access('UT', t.id) = 1) 
GO
GRANT SELECT
    ON [sys].[types]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

