## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[assembly_types\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.assembly_types**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -424 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|name| |sysname|128|
|system_type_id| |tinyint|1|
|user_type_id| |int|4|
|schema_id| |int|4|
|principal_id| |int|4|
|max_length| |smallint|2|
|precision| |tinyint|1|
|scale| |tinyint|1|
|collation_name| |sysname|128|
|is_nullable| |bit|1|
|is_user_defined| |bit|1|
|is_assembly_type| |bit|1|
|default_object_id| |int|4|
|rule_object_id| |int|4|
|assembly_id| |int|4|
|assembly_class| |sysname|128|
|is_binary_ordered| |bit|1|
|is_fixed_length| |bit|1|
|prog_id| |nvarchar|40|
|assembly_qualified_name| |nvarchar|4000|
|is_table_type| |bit|1|

Total: 21 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[assembly_types\]
 No dependencies exist

---
### Objects that \[sys\].\[assembly_types\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-424_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.assembly_types AS
    SELECT t.name,
        t.xtype AS system_type_id,
        t.id AS user_type_id,
        t.schid AS schema_id,
        pr.indepid AS principal_id,
        t.length AS max_length,
        t.prec AS precision,
        t.scale,
        convert(sysname, collationpropertyfromid(t.collationid, 'name')) AS collation_name,
        sysconv(bit, 1 - (t.status &amp; 1)) AS is_nullable,    -- COL80_NOTNULL
        sysconv(bit, case when t.id &gt; 256 then 1 else 0 end) AS is_user_defined,     -- x_utypSSNAME
        sysconv(bit, 1) AS is_assembly_type,
        sysconv(int, 0) AS default_object_id,
        sysconv(int, 0) AS rule_object_id,
        r.indepid AS assembly_id,
        convert(sysname, v.name) collate Latin1_General_BIN AS assembly_class,
        sysconv(bit, typepropertyex(t.id,'is_binary_ordered')) AS is_binary_ordered,
        sysconv(bit, typepropertyex(t.id,'is_fixed_length')) AS is_fixed_length,
        convert(nvarchar(40), typepropertyex(t.id,'prog_id')) AS prog_id,
        convert(nvarchar(4000), typepropertyex(t.id,'assembly_qualified_name')) collate Latin1_General_BIN AS assembly_qualified_name,
        sysconv(bit, 0) AS is_table_type
    FROM sys.sysscalartypes t
    JOIN sys.syssingleobjrefs r ON r.depid = t.id AND r.class = 38 AND r.depsubid = 0    -- SRC_TYPETOASM
    LEFT JOIN sys.syssingleobjrefs pr ON pr.depid = t.id AND pr.class = 44 AND pr.depsubid = 0    -- SRC_TYPETOOWNER
    LEFT JOIN sys.sysbinsubobjs v ON v.class = 11 AND v.idmajor = r.indepid AND v.subid = t.id      -- SOC_ASSEMBLY_TYPE
    WHERE has_access('UT', t.id) = 1
GO
GRANT SELECT
    ON [sys].[assembly_types]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

