## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[database_principals\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.database_principals**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -426 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|name| |sysname|128|
|principal_id| |int|4|
|type| |char|1|
|type_desc| |nvarchar|60|
|default_schema_name| |sysname|128|
|create_date| |datetime|8|
|modify_date| |datetime|8|
|owning_principal_id| |int|4|
|sid| |varbinary|85|
|is_fixed_role| |bit|1|
|authentication_type| |int|4|
|authentication_type_desc| |nvarchar|60|
|default_language_name| |sysname|128|
|default_language_lcid| |int|4|
|allow_encrypted_value_modifications| |bit|1|

Total: 15 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[database_principals\]
 No dependencies exist

---
### Objects that \[sys\].\[database_principals\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-426_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.database_principals AS
    SELECT u.name,
        u.id AS principal_id,
        u.type,
        n.name AS type_desc,
        u.dfltsch AS default_schema_name,
        u.created AS create_date,
        u.modified AS modify_date,
        r.indepid AS owning_principal_id,
        u.sid,
        sysconv(bit, case when u.id &gt;= 16384 and u.id &lt; 16400 then 1 else 0 end) AS is_fixed_role,
        u.authentication_type,
        aty.name AS authentication_type_desc,
        u.deflanguage as default_language_name,
        l.lcid as default_language_lcid,
        sysconv(bit, IIF(u.status &amp; 0x20 = 0x20, 1, 0)) as allow_encrypted_value_modifications
    FROM (
        SELECT *,
            CASE 
                -- Guest is always authentication type none
                WHEN type = 'S' AND id = 2 THEN 0
                -- Users without password and without SQL SID prefix are instance auth
                WHEN type = 'S' AND password IS NULL AND cast(sid as binary(9)) &lt;&gt; 0x010500000000000903 THEN 1
                -- Users with passwords are database auth
                WHEN type = 'S' AND password IS NOT NULL THEN 2
                -- Windows users are always windows auth
                WHEN type = 'U' OR type = 'G' THEN 3
                -- External Users or External Groups
                WHEN type = 'E' OR type = 'X' THEN 4
                -- Users without passwords, certificate, key users, etc. have no authentication type
                ELSE 0
            END AS authentication_type
        FROM sys.sysowners) u
    LEFT JOIN sys.syssingleobjrefs r ON r.depid = u.id AND r.class = 51 AND r.depsubid = 0    -- SRC_ROLEOWNER
    LEFT JOIN sys.syspalnames n ON n.class = 'USTY' AND n.value = u.type
    LEFT JOIN sys.syspalnames aty ON aty.class = 'DBAT' AND aty.value = u.authentication_type
    LEFT JOIN sys.syslanguages l ON u.deflanguage COLLATE catalog_default = l.name COLLATE catalog_default
    WHERE u.type &lt;&gt; 'L'
        AND has_access('US', u.id) = 1    -- PR_ALIAS
GO
GRANT SELECT
    ON [sys].[database_principals]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

