## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[INFORMATION_SCHEMA\].\[PARAMETERS\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **INFORMATION_SCHEMA.PARAMETERS**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[INFORMATION_SCHEMA\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/3.md) |
| Owner | \[INFORMATION_SCHEMA\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -435799990 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|SPECIFIC_CATALOG| |nvarchar|128|
|SPECIFIC_SCHEMA| |nvarchar|128|
|SPECIFIC_NAME| |sysname|128|
|ORDINAL_POSITION| |int|4|
|PARAMETER_MODE| |nvarchar|10|
|IS_RESULT| |nvarchar|10|
|AS_LOCATOR| |nvarchar|10|
|PARAMETER_NAME| |sysname|128|
|DATA_TYPE| |nvarchar|128|
|CHARACTER_MAXIMUM_LENGTH| |int|4|
|CHARACTER_OCTET_LENGTH| |int|4|
|COLLATION_CATALOG| |sysname|128|
|COLLATION_SCHEMA| |sysname|128|
|COLLATION_NAME| |sysname|128|
|CHARACTER_SET_CATALOG| |sysname|128|
|CHARACTER_SET_SCHEMA| |sysname|128|
|CHARACTER_SET_NAME| |sysname|128|
|NUMERIC_PRECISION| |tinyint|1|
|NUMERIC_PRECISION_RADIX| |smallint|2|
|NUMERIC_SCALE| |int|4|
|DATETIME_PRECISION| |smallint|2|
|INTERVAL_TYPE| |nvarchar|30|
|INTERVAL_PRECISION| |smallint|2|
|USER_DEFINED_TYPE_CATALOG| |sysname|128|
|USER_DEFINED_TYPE_SCHEMA| |sysname|128|
|USER_DEFINED_TYPE_NAME| |sysname|128|
|SCOPE_CATALOG| |sysname|128|
|SCOPE_SCHEMA| |sysname|128|
|SCOPE_NAME| |sysname|128|

Total: 29 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[INFORMATION_SCHEMA\].\[PARAMETERS\]
 No dependencies exist

---
### Objects that \[INFORMATION_SCHEMA\].\[PARAMETERS\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW INFORMATION_SCHEMA.PARAMETERS
AS
SELECT
    DB_NAME()                        AS SPECIFIC_CATALOG,
    SCHEMA_NAME(o.schema_id)        AS SPECIFIC_SCHEMA,
    o.name                            AS SPECIFIC_NAME,
    c.parameter_id                    AS ORDINAL_POSITION,
    convert(nvarchar(10), CASE
        WHEN c.parameter_id = 0 THEN 'OUT'
        WHEN c.is_output = 1 THEN 'INOUT'
        ELSE 'IN' END)                    AS PARAMETER_MODE,
    convert(nvarchar(10), CASE WHEN
        c.parameter_id = 0 THEN 'YES' ELSE 'NO' END)    AS IS_RESULT,
    convert(nvarchar(10), 'NO')                AS AS_LOCATOR,
    c.name                            AS PARAMETER_NAME,
    ISNULL(TYPE_NAME(c.system_type_id), u.name)        AS DATA_TYPE,
    COLUMNPROPERTY(c.object_id, c.name, 'charmaxlen')    AS CHARACTER_MAXIMUM_LENGTH,
    COLUMNPROPERTY(c.object_id, c.name, 'octetmaxlen')    AS CHARACTER_OCTET_LENGTH,
    convert(sysname, null)                    AS COLLATION_CATALOG,
    convert(sysname, null) collate catalog_default            AS COLLATION_SCHEMA,
    convert(sysname, CASE
        WHEN c.system_type_id IN (35, 99, 167, 175, 231, 239) THEN    -- [n]char/[n]varchar/[n]text
        SERVERPROPERTY('collation') END)        AS COLLATION_NAME,
    convert( sysname, null)                    AS CHARACTER_SET_CATALOG,
    convert( sysname, null) collate catalog_default            AS CHARACTER_SET_SCHEMA,
    convert( sysname, CASE
        WHEN c.system_type_id IN (35, 167, 175) THEN SERVERPROPERTY('sqlcharsetname')    -- char/varchar/text
        WHEN c.system_type_id IN (99, 231, 239) THEN N'UNICODE'    -- nchar/nvarchar/ntext
        END)                        AS CHARACTER_SET_NAME,
    convert(tinyint, CASE -- int/decimal/numeric/real/float/money
        WHEN c.system_type_id IN (48, 52, 56, 59, 60, 62, 106, 108, 122, 127) THEN c.precision
        END)                                        AS NUMERIC_PRECISION,
    convert(smallint, CASE    -- int/money/decimal/numeric
        WHEN c.system_type_id IN (48, 52, 56, 60, 106, 108, 122, 127) THEN 10
        WHEN c.system_type_id IN (59, 62) THEN 2 END)    AS NUMERIC_PRECISION_RADIX, -- real/float
    convert(int, CASE    -- datetime/smalldatetime
        WHEN c.system_type_id IN (40, 41, 42, 43, 58, 61) THEN NULL
        ELSE ODBCSCALE(c.system_type_id, c.scale) END)    AS NUMERIC_SCALE,
    convert(smallint, CASE -- datetime/smalldatetime
        WHEN c.system_type_id IN (40, 41, 42, 43, 58, 61) THEN ODBCSCALE(c.system_type_id, c.scale) END)    AS DATETIME_PRECISION,
    convert(nvarchar(30), null)                AS INTERVAL_TYPE,
    convert(smallint, null)                    AS INTERVAL_PRECISION,
    convert(sysname, CASE WHEN u.schema_id &lt;&gt; 4
        THEN DB_NAME() END)                        AS USER_DEFINED_TYPE_CATALOG,
    convert(sysname, CASE WHEN u.schema_id &lt;&gt; 4
        THEN SCHEMA_NAME(u.schema_id) END)        AS USER_DEFINED_TYPE_SCHEMA,
    convert(sysname, CASE WHEN u.schema_id &lt;&gt; 4
        THEN u.name END)                            AS USER_DEFINED_TYPE_NAME,
    convert(sysname, null)                    AS SCOPE_CATALOG,
    convert(sysname, null) collate catalog_default        AS SCOPE_SCHEMA,
    convert(sysname, null) collate catalog_default        AS SCOPE_NAME
FROM
    sys.objects o JOIN sys.parameters c ON c.object_id = o.object_id
    JOIN sys.types u ON u.user_type_id = c.user_type_id
WHERE
    o.type IN ('P','FN','TF', 'IF', 'IS', 'AF','PC', 'FS', 'FT')
GO
  
~~~

---
###   See also  
[List of views](../views.md)

