## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[xml_schema_elements\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.xml_schema_elements**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -454 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|xml_component_id| |int|4|
|xml_collection_id| |int|4|
|xml_namespace_id| |int|4|
|is_qualified| |bit|1|
|name| |nvarchar|4000|
|symbol_space| |char|1|
|symbol_space_desc| |nvarchar|60|
|kind| |char|1|
|kind_desc| |nvarchar|60|
|derivation| |char|1|
|derivation_desc| |nvarchar|60|
|base_xml_component_id| |int|4|
|scoping_xml_component_id| |int|4|
|is_default_fixed| |bit|1|
|is_abstract| |bit|1|
|is_nillable| |bit|1|
|must_be_qualified| |bit|1|
|is_extension_blocked| |bit|1|
|is_restriction_blocked| |bit|1|
|is_substitution_blocked| |bit|1|
|is_final_extension| |bit|1|
|is_final_restriction| |bit|1|
|default_value| |nvarchar|4000|

Total: 23 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[xml_schema_elements\]
 No dependencies exist

---
### Objects that \[sys\].\[xml_schema_elements\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-454_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.xml_schema_elements AS
    SELECT xml_component_id = c.id,
        xml_collection_id = c.xsdid,
        xml_namespace_id = c.uriord,
        is_qualified = sysconv(bit, c.qual),
        name = q.name,
        symbol_space = c.symspace,
        s.name AS symbol_space_desc,
        c.kind,
        k.name AS kind_desc,
        derivation = c.deriv,
        d.name AS derivation_desc,
        b.indepid AS base_xml_component_id,
        o.indepid AS scoping_xml_component_id,
        sysconv(bit, c.status &amp; 1) AS is_default_fixed,
        sysconv(bit, c.status &amp; 2) AS is_abstract,
        sysconv(bit, c.status &amp; 8) AS is_nillable,
        sysconv(bit, c.status &amp; 16) AS must_be_qualified,
        sysconv(bit, c.status &amp; 32) AS is_extension_blocked,
        sysconv(bit, c.status &amp; 64) AS is_restriction_blocked,
        sysconv(bit, c.status &amp; 128) AS is_substitution_blocked,
        sysconv(bit, c.status &amp; 256) AS is_final_extension,
        sysconv(bit, c.status &amp; 512) AS is_final_restriction,
        c.defval AS default_value
    FROM sys.sysxmlcomponent c
    LEFT JOIN sys.sysqnames q ON c.nameid = q.nid
    LEFT JOIN sys.syssingleobjrefs b ON b.depid = c.id AND b.class = 82 AND b.depsubid = 0    -- SRC_XMLCOMPDERIVE
    LEFT JOIN sys.syssingleobjrefs o ON o.depid = c.id AND o.class = 81 AND o.depsubid = 0    -- SRC_XMLCOMPOWNCOMP
    LEFT JOIN sys.sysbinpals k ON k.class = 'XCKI' AND k.value = c.kind
    LEFT JOIN sys.sysbinpals d ON d.class = 'XCDR' AND d.value = c.deriv
    LEFT JOIN sys.sysbinpals s ON s.class = 'XCSS' AND s.value = c.symspace
    WHERE c.symspace = 'E'
        AND has_access('XC', c.id, c.xsdid) = 1
GO
GRANT SELECT
    ON [sys].[xml_schema_elements]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

