## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[transmission_queue\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.transmission_queue**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -462 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|conversation_handle| |uniqueidentifier|16|
|to_service_name| |nvarchar|256|
|to_broker_instance| |nvarchar|128|
|from_service_name| |nvarchar|256|
|service_contract_name| |nvarchar|256|
|enqueue_time| |datetime|8|
|message_sequence_number| |bigint|8|
|message_type_name| |nvarchar|256|
|is_conversation_error| |bit|1|
|is_end_of_dialog| |bit|1|
|message_body| |varbinary|2147483647|
|transmission_status| |nvarchar|4000|
|priority| |tinyint|1|

Total: 13 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[transmission_queue\]
 No dependencies exist

---
### Objects that \[sys\].\[transmission_queue\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-462_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.transmission_queue AS
    SELECT conversation_handle = S.handle,
        to_service_name = Q.tosvc,
        to_broker_instance = Q.tobrkrinst,
        from_service_name = Q.fromsvc,
        service_contract_name = Q.svccontr,
        enqueue_time = Q.enqtime,
        message_sequence_number = Q.msgseqnum,
        message_type_name = Q.msgtype,
        is_conversation_error = sysconv(bit, Q.status &amp; 2),
        is_end_of_dialog = sysconv(bit, Q.status &amp; 4),
        message_body = ISNULL(Q.msgbody, B.msgbody),
        transmission_status = GET_TRANSMISSION_STATUS (S.handle),
        priority = R.priority
    FROM sys.sysxmitqueue Q
    LEFT JOIN sys.sysxmitbody B WITH (NOLOCK) ON Q.msgref = B.msgref
    INNER JOIN sys.sysdesend S WITH (NOLOCK) on Q.dlgid = S.diagid AND Q.finitiator = S.initiator
    INNER JOIN sys.sysdercv R WITH (NOLOCK) ON Q.dlgid = R.diagid AND Q.finitiator = R.initiator
    WHERE is_member('db_owner') = 1
GO
GRANT SELECT
    ON [sys].[transmission_queue]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

