## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[symmetric_keys\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.symmetric_keys**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -464 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|name| |sysname|128|
|principal_id| |int|4|
|symmetric_key_id| |int|4|
|key_length| |int|4|
|key_algorithm| |char|2|
|algorithm_desc| |nvarchar|60|
|create_date| |datetime|8|
|modify_date| |datetime|8|
|key_guid| |uniqueidentifier|16|
|key_thumbprint| |sql_variant|8016|
|provider_type| |nvarchar|60|
|cryptographic_provider_guid| |uniqueidentifier|16|
|cryptographic_provider_algid| |sql_variant|8016|

Total: 13 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[symmetric_keys\]
 No dependencies exist

---
### Objects that \[sys\].\[symmetric_keys\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-464_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.symmetric_keys AS
    SELECT s.name AS name,
        r.indepid AS principal_id,
        s.id AS symmetric_key_id,
        s.intprop AS key_length,
        s.type AS key_algorithm,
        case when vpt.value = 6 then  -- x_emd_EKMProvider = 6
            convert(nvarchar(60),symkeyproperty(s.id, 'algorithm_desc'))
            else alg.name end AS algorithm_desc,
        s.created AS create_date,
        s.modified AS modify_date,
        g.guid AS key_guid,
        vph.value AS key_thumbprint,
        n.name as provider_type,
        convert(uniqueidentifier, vpg.value) AS cryptographic_provider_guid,
        vpa.value AS cryptographic_provider_algid
    FROM sys.sysclsobjs s
    LEFT JOIN sys.syssingleobjrefs r ON r.depid = s.id AND r.class = 47 AND r.depsubid = 0
    LEFT JOIN sys.sysguidrefs g ON g.id = s.id AND g.class = 2 AND g.subid = 0
    LEFT JOIN sys.syspalnames alg ON alg.class = 'ENAL' AND alg.value = s.type
    LEFT JOIN sys.sysobjvalues vpt ON vpt.valclass = 35 AND vpt.objid = s.id AND vpt.subobjid = 0 AND vpt.valnum = 1    -- SVC_OKEYPROVPROPS/PROV_TYPE_PROP
    LEFT JOIN sys.sysobjvalues vpg ON vpg.valclass = 35 AND vpg.objid = s.id AND vpg.subobjid = 0 AND vpg.valnum = 2    -- SVC_OKEYPROVPROPS/PROV_GUID_PROP
    LEFT JOIN sys.sysobjvalues vpa ON vpa.valclass = 35 AND vpa.objid = s.id AND vpa.subobjid = 0 AND vpa.valnum = 3    -- SVC_OKEYPROVPROPS/PROV_ALGID_PROP
    LEFT JOIN sys.sysobjvalues vph ON vph.valclass = 35 AND vph.objid = s.id AND vph.valnum = 4    -- SVC_OKEYPROVPROPS/PROV_THUMB_PROP
    LEFT JOIN sys.syspalvalues n ON n.class = 'CPKP' AND n.value = vpt.value
    WHERE s.class = 56
        AND has_access('OK', s.id) = 1
GO
GRANT SELECT
    ON [sys].[symmetric_keys]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

