## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[crypt_properties\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.crypt_properties**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -466 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|class| |tinyint|1|
|class_desc| |nvarchar|60|
|major_id| |int|4|
|thumbprint| |varbinary|32|
|crypt_type| |char|4|
|crypt_type_desc| |nvarchar|60|
|crypt_property| |varbinary|2147483647|

Total: 7 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[crypt_properties\]
 No dependencies exist

---
### Objects that \[sys\].\[crypt_properties\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-466_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.crypt_properties AS
    SELECT                        -- objects
        k.class AS class,
        un.name AS class_desc,
        s.id AS major_id,
        k.thumbprint AS thumbprint,
        k.type AS crypt_type,
        ct.name AS crypt_type_desc,
        k.crypto AS crypt_property
    FROM sys.sysschobjs$ s
    JOIN sys.sysobjkeycrypts k ON k.class = 1 AND k.id = s.id
    LEFT JOIN sys.syspalvalues un ON un.class = 'UNCL' AND un.value = k.class
    LEFT JOIN sys.syspalnames ct ON ct.class = 'CRTY' AND ct.value = k.type
    WHERE s.nsclass = 0 -- x_eonc_Standard
        AND s.pclass = 1 -- x_eunc_Object
        AND k.type &lt;&gt; 'INCP'
        AND has_access('SQ', s.id, s.pid, 0) = 1
    UNION
    SELECT                        -- assemblies
        k.class AS class,
        un.name AS class_desc,
        s.assembly_id AS major_id,
        k.thumbprint AS thumbprint,
        k.type AS crypt_type,
        ct.name AS crypt_type_desc,
        k.crypto AS crypt_property
    FROM sys.assemblies s
    JOIN sys.sysobjkeycrypts k ON k.class = 5 AND k.id = s.assembly_id
    LEFT JOIN sys.syspalvalues un ON un.class = 'UNCL' AND un.value = k.class
    LEFT JOIN sys.syspalnames ct ON ct.class = 'CRTY' AND ct.value = k.type
    WHERE k.type &lt;&gt; 'INCP'
GO
GRANT SELECT
    ON [sys].[crypt_properties]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

