## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[certificates\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.certificates**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -467 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|name| |sysname|128|
|certificate_id| |int|4|
|principal_id| |int|4|
|pvt_key_encryption_type| |char|2|
|pvt_key_encryption_type_desc| |nvarchar|60|
|is_active_for_begin_dialog| |bit|1|
|issuer_name| |nvarchar|442|
|cert_serial_number| |nvarchar|64|
|sid| |varbinary|85|
|string_sid| |nvarchar|128|
|subject| |nvarchar|4000|
|expiry_date| |datetime|8|
|start_date| |datetime|8|
|thumbprint| |varbinary|64|
|attested_by| |nvarchar|260|
|pvt_key_last_backup_date| |datetime|8|
|key_length| |int|4|

Total: 17 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[certificates\]
 No dependencies exist

---
### Objects that \[sys\].\[certificates\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-467_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.certificates AS
    SELECT c.name,
        c.id AS certificate_id,
        r.indepid AS principal_id,
        c.encrtype AS pvt_key_encryption_type,
        ce.name AS pvt_key_encryption_type_desc,
        sysconv(bit, ~c.status &amp; 0x1) AS is_active_for_begin_dialog,
        convert(nvarchar(442), certproperty(c.id, 'issuer_name')) AS issuer_name,
        convert(nvarchar(64),  certproperty(c.id, 'cert_serial_number')) AS cert_serial_number,
        convert(varbinary(85), certproperty(c.id, 'sid')) AS sid,
        convert(nvarchar(128), certproperty(c.id, 'string_sid')) AS string_sid,
        convert(nvarchar(4000),certproperty(c.id, 'subject')) AS subject,
        convert(datetime, certproperty(c.id, 'expiry_date')) AS expiry_date,
        convert(datetime, certproperty(c.id, 'start_date')) AS start_date,
        c.thumbprint AS thumbprint,
        convert(nvarchar(260), v.value) AS attested_by,
        c.lastpkeybackup AS pvt_key_last_backup_date,
        convert(int, certproperty(c.id, 'key_length')) AS key_length
    FROM sys.syscerts c
    LEFT JOIN sys.syssingleobjrefs r ON r.depid = c.id AND r.class = 62 AND r.depsubid = 0    -- SRC_CERTOWNER
    LEFT JOIN sys.syspalnames ce ON ce.class = 'CETY' AND ce.value = c.encrtype
    LEFT JOIN sys.sysobjvalues v ON v.valclass = 33 AND v.objid = c.id AND v.subobjid = 0 AND v.valnum = 0    -- SVC_CRATTESTINGDLLPATH
    WHERE has_access('CE', c.id) = 1
GO
GRANT SELECT
    ON [sys].[certificates]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

