## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[internal_tables\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.internal_tables**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -468 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|name| |sysname|128|
|object_id| |int|4|
|principal_id| |int|4|
|schema_id| |int|4|
|parent_object_id| |int|4|
|type| |char|2|
|type_desc| |nvarchar|60|
|create_date| |datetime|8|
|modify_date| |datetime|8|
|is_ms_shipped| |bit|1|
|is_published| |bit|1|
|is_schema_published| |bit|1|
|internal_type| |tinyint|1|
|internal_type_desc| |nvarchar|60|
|parent_id| |int|4|
|parent_minor_id| |int|4|
|lob_data_space_id| |int|4|
|filestream_data_space_id| |int|4|

Total: 18 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[internal_tables\]
 No dependencies exist

---
### Objects that \[sys\].\[internal_tables\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-468_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.internal_tables AS
    SELECT o.name, o.id AS object_id, convert(int, null) AS principal_id, o.nsid AS schema_id, o.pid AS parent_object_id,
        o.type, n.name AS type_desc, o.created AS create_date, o.modified AS modify_date,
        convert(bit, 0) AS is_ms_shipped, convert(bit, 0) AS is_published, convert(bit, 0) AS is_schema_published,
        convert(tinyint, par.depsubid) AS internal_type,
        itt.name AS internal_type_desc,
        par.indepid AS parent_id,
        par.indepsubid AS parent_minor_id,
        isnull(ds.indepid, 0) AS lob_data_space_id,
        rfs.indepid AS filestream_data_space_id
    FROM sys.sysschobjs$ o
    LEFT JOIN sys.syspalnames n ON n.class = 'OBTY' AND n.value = o.type
    LEFT JOIN sys.syssingleobjrefs par ON par.depid = o.id AND par.class = 40     -- SRC_INTLTAB_PARENT
    LEFT JOIN sys.syspalvalues itt ON itt.class = 'ITTY' AND itt.value = par.depsubid
    LEFT JOIN sys.syssingleobjrefs ds ON ds.depid = o.id AND ds.class = 8 AND ds.depsubid &lt;= 1    -- SRC_INDEXTOLOBDS    
    LEFT JOIN sys.syssingleobjrefs rfs ON rfs.depid = o.id AND rfs.class = 42 AND rfs.depsubid = 0    -- SRC_OBJTOFSDS
    WHERE o.nsclass = 0 -- x_eonc_Standard
        AND o.nsid = 4 AND o.pclass = 1 AND o.type = 'IT' -- x_eunc_Object
        AND has_access('IT', par.indepid, par.depsubid) = 1
GO
GRANT SELECT
    ON [sys].[internal_tables]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

