## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[asymmetric_keys\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.asymmetric_keys**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -469 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|name| |sysname|128|
|principal_id| |int|4|
|asymmetric_key_id| |int|4|
|pvt_key_encryption_type| |char|2|
|pvt_key_encryption_type_desc| |nvarchar|60|
|thumbprint| |varbinary|64|
|algorithm| |char|2|
|algorithm_desc| |nvarchar|60|
|key_length| |int|4|
|sid| |varbinary|85|
|string_sid| |nvarchar|128|
|public_key| |varbinary|2147483647|
|attested_by| |nvarchar|260|
|provider_type| |nvarchar|60|
|cryptographic_provider_guid| |uniqueidentifier|16|
|cryptographic_provider_algid| |sql_variant|8016|

Total: 16 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[asymmetric_keys\]
 No dependencies exist

---
### Objects that \[sys\].\[asymmetric_keys\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-469_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.asymmetric_keys AS
    SELECT a.name AS name,
        r.indepid AS principal_id,
        a.id AS asymmetric_key_id,
        a.encrtype AS pvt_key_encryption_type,
        ce.name AS pvt_key_encryption_type_desc,
        a.thumbprint AS thumbprint,
        a.algorithm AS algorithm,
        case when vpt.value = 6 then -- x_emd_EKMProvider = 6
            convert(varbinary(60),asymkeyproperty(a.id, 'algorithm_desc'))
            else alg.name end AS algorithm_desc,
        a.bitlength AS key_length,
        convert(varbinary(85), asymkeyproperty(a.id, 'sid')) AS sid,
        convert(nvarchar(128), asymkeyproperty(a.id, 'string_sid')) AS string_sid,
        a.pukey AS public_key,
        convert(nvarchar(260), v.value) AS attested_by,
        n.name as provider_type,
        convert (uniqueidentifier, vpg.value) AS cryptographic_provider_guid,
        vpa.value AS cryptographic_provider_algid
    FROM sys.sysasymkeys a
    LEFT JOIN sys.syssingleobjrefs r ON r.depid = a.id AND r.class = 64 AND r.depsubid = 0
    LEFT JOIN sys.syspalnames ce ON ce.class = 'CETY' AND ce.value = a.encrtype
    LEFT JOIN sys.syspalnames alg ON alg.class = 'ENAL' AND alg.value = a.algorithm
    LEFT JOIN sys.sysobjvalues v ON v.valclass = 34 AND v.objid = a.id AND v.subobjid = 0 AND v.valnum = 0    -- SVC_AKATTESTINGDLLPATH
    LEFT JOIN sys.sysobjvalues vpt ON vpt.valclass = 31 AND vpt.objid = a.id AND vpt.subobjid = 0 AND vpt.valnum = 1    -- SVC_AKPROVPROPS/PROV_TYPE_PROP
    LEFT JOIN sys.sysobjvalues vpg ON vpg.valclass = 31 AND vpg.objid = a.id AND vpg.subobjid = 0 AND vpg.valnum = 2    -- SVC_AKPROVPROPS/PROV_GUID_PROP
    LEFT JOIN sys.sysobjvalues vpa ON vpa.valclass = 31 AND vpa.objid = a.id AND vpa.subobjid = 0 AND vpa.valnum = 3    -- SVC_AKPROVPROPS/PROV_ALGID_PROP
    LEFT JOIN sys.sysobjvalues vpu ON vpu.valclass = 31 AND vpu.objid = a.id AND vpu.subobjid = 0 AND vpu.valnum = 5    -- SVC_AKPROVPROPS/PROV_URI_PROP
    LEFT JOIN sys.syspalvalues n ON n.class = 'CPKP' AND n.value = vpt.value
    WHERE has_access('AK', a.id) = 1
GO
GRANT SELECT
    ON [sys].[asymmetric_keys]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

