## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[plan_guides\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.plan_guides**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -485 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|plan_guide_id| |int|4|
|name| |sysname|128|
|create_date| |datetime|8|
|modify_date| |datetime|8|
|is_disabled| |bit|1|
|query_text| |nvarchar|1073741823|
|scope_type| |tinyint|1|
|scope_type_desc| |nvarchar|60|
|scope_object_id| |int|4|
|scope_batch| |nvarchar|1073741823|
|parameters| |nvarchar|1073741823|
|hints| |nvarchar|1073741823|

Total: 12 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[plan_guides\]
 No dependencies exist

---
### Objects that \[sys\].\[plan_guides\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-485_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.plan_guides AS
    SELECT 
        plan_guide_id     = g.id,
        name         = g.name, 
        create_date     = g.created,
        modify_date     = g.modified,
        is_disabled     = sysconv(bit, g.status &amp; 1),
        query_text     = convert(nvarchar(max), p.stmt),
        scope_type     = g.scopetype,
        scope_type_desc     = convert(nvarchar(60), case g.scopetype 
                                when  1 then 'OBJECT' 
                                when  2 then 'SQL'
                                else 'TEMPLATE' end),
        scope_object_id = sysconv(int, case g.scopetype when 1 then g.scopeid end), -- object-id is non-NULL only for module-scoped guide
        scope_batch     = convert(nvarchar(max), p.batch), -- for single-stmt batch, batch_text is always NULL
        parameters         = convert(nvarchar(max), p.params),
        hints             = convert(nvarchar(max), p.hints)
    FROM sys.syssqlguides g CROSS APPLY OpenRowset(TABLE PLANGUIDES, g.id, g.scopeid, g.scopetype) p    
    WHERE g.scopeid &lt;&gt; 0 -- filter-out batch entries
GO
GRANT SELECT
    ON [sys].[plan_guides]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

