## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[system_internals_partitions\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.system_internals_partitions**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -486 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|partition_id| |bigint|8|
|object_id| |int|4|
|index_id| |int|4|
|partition_number| |int|4|
|rows| |bigint|8|
|filestream_filegroup_id| |smallint|2|
|is_orphaned| |bit|1|
|dropped_lob_column_state| |tinyint|1|
|is_unique| |bit|1|
|is_replicated| |bit|1|
|is_logged_for_replication| |bit|1|
|is_sereplicated| |bit|1|
|max_null_bit_used| |smallint|2|
|max_leaf_length| |int|4|
|min_leaf_length| |smallint|2|
|max_internal_length| |smallint|2|
|min_internal_length| |smallint|2|
|allows_nullable_keys| |bit|1|
|allow_row_locks| |bit|1|
|allow_page_locks| |bit|1|
|is_data_row_format| |bit|1|
|is_not_versioned| |bit|1|
|filestream_guid| |uniqueidentifier|16|
|ownertype| |tinyint|1|
|is_columnstore| |bit|1|

Total: 25 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[system_internals_partitions\]
 No dependencies exist

---
### Objects that \[sys\].\[system_internals_partitions\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.system_internals_partitions AS
    SELECT rs.rowsetid AS partition_id,
        rs.idmajor AS object_id,
        rs.idminor AS index_id,
        rs.numpart AS partition_number,
        isnull(ct.rows, rs.rcrows) AS rows,
        rs.fgidfs AS filestream_filegroup_id,
        convert(bit, 1-rs.ownertype) AS is_orphaned,
        convert(tinyint, rs.status &amp; 3) AS dropped_lob_column_state,    --RS_LOBSTAT_*
        convert(bit, rs.status &amp; 4) AS is_unique,                    --RS_UNIQUE
        convert(bit, rs.status &amp; 8) AS is_replicated,                    --RS_REPLICATED
        convert(bit, rs.status &amp; 16) AS is_logged_for_replication,        --RS_LOG_OFFROW_FOR_REPL
        sysconv(bit, rs.status &amp; 1073741824) AS is_sereplicated,                --RS_SEREPLICATED
        rs.maxnullbit AS max_null_bit_used,
        rs.maxleaf AS max_leaf_length,
        rs.minleaf AS min_leaf_length,
        rs.maxint AS max_internal_length,
        rs.minint AS min_internal_length,
        convert(bit, rs.status &amp; 64) AS allows_nullable_keys,            --RS_NULLABLE_KEYS
        convert(bit, 1-(rs.status &amp; 128)/128) AS allow_row_locks,    --RS_NO_ROWLOCK
        convert(bit, 1-(rs.status &amp; 256)/256) AS allow_page_locks,    --RS_NO_PAGELOCK
        convert(bit, rs.status &amp; 512) AS is_data_row_format,            --RS_DATAROW_FRMT
        convert(bit, rs.status &amp; 2048) AS is_not_versioned,            --RS_NOTVERSIONED
        convert(uniqueidentifier, rs.rsguid) AS filestream_guid,
        rs.ownertype as ownertype,
        sysconv(bit, rs.status &amp; 0x00010000) AS is_columnstore
    FROM sys.sysrowsets rs OUTER APPLY OpenRowset(TABLE ALUCOUNT, rs.rowsetid, 0, 0, rs.idmajor) ct
GO
  
~~~

---
###   See also  
[List of views](../views.md)

