## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[system_internals_partition_columns\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.system_internals_partition_columns**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -487 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|partition_id| |bigint|8|
|partition_column_id| |int|4|
|modified_count| |bigint|8|
|max_inrow_length| |smallint|2|
|is_replicated| |bit|1|
|is_logged_for_replication| |bit|1|
|is_dropped| |bit|1|
|system_type_id| |tinyint|1|
|max_length| |smallint|2|
|precision| |tinyint|1|
|scale| |tinyint|1|
|collation_name| |sysname|128|
|is_filestream| |bit|1|
|key_ordinal| |smallint|2|
|is_nullable| |bit|1|
|is_descending_key| |bit|1|
|is_uniqueifier| |bit|1|
|leaf_offset| |smallint|2|
|internal_offset| |smallint|2|
|leaf_bit_position| |tinyint|1|
|internal_bit_position| |tinyint|1|
|leaf_null_bit| |smallint|2|
|internal_null_bit| |smallint|2|
|is_anti_matter| |bit|1|
|partition_column_guid| |uniqueidentifier|16|
|is_sparse| |bit|1|
|has_default| |bit|1|
|default_value| |sql_variant|8016|

Total: 28 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[system_internals_partition_columns\]
 No dependencies exist

---
### Objects that \[sys\].\[system_internals_partition_columns\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.system_internals_partition_columns AS
    SELECT c.rsid AS partition_id,
        c.rscolid AS partition_column_id,
        c.rcmodified AS modified_count,
        case c.maxinrowlen when 0 then p.length
            else c.maxinrowlen end AS max_inrow_length,
        convert(bit, c.status &amp; 1) AS is_replicated,                --RSC_REPLICATED
        convert(bit, c.status &amp; 4) AS is_logged_for_replication,    --RSC_LOG_FOR_REPL
        convert(bit, c.status &amp; 2) AS is_dropped,                --RSC_DROPPED
        p.xtype AS system_type_id,
        p.length AS max_length,
        p.prec AS precision,
        p.scale AS scale,
        convert(sysname, CollationPropertyFromId(c.cid, 'name')) AS collation_name,
        convert(bit, c.status &amp; 32) AS is_filestream,            --RSC_FILESTREAM
        c.ordkey AS key_ordinal,
        convert(bit, 1 - (c.status &amp; 128)/128) AS is_nullable,        -- RSC_NOTNULL        
        convert(bit, c.status &amp; 8) AS is_descending_key,        --RSC_DESC_KEY
        convert(bit, c.status &amp; 16) AS is_uniqueifier,            --RSC_UNIQUIFIER
        convert(smallint, convert(binary(2), c.offset &amp; 0xffff)) AS leaf_offset,
        convert(smallint, substring(convert(binary(4), c.offset), 1, 2)) AS internal_offset,
        convert(tinyint, c.bitpos &amp; 0xff) AS leaf_bit_position,
        convert(tinyint, c.bitpos/0x100) AS internal_bit_position,
        convert(smallint, convert(binary(2), c.nullbit &amp; 0xffff)) AS leaf_null_bit,
        convert(smallint, substring(convert(binary(4), c.nullbit), 1, 2)) AS internal_null_bit,
        convert(bit, c.status &amp; 64) AS is_anti_matter,            --RSC_ANTIMATTER
        convert(uniqueidentifier, c.colguid) AS partition_column_guid,
        sysconv(bit, c.status &amp; 0x00000100) AS is_sparse,    --RSC_SPARSE
        sysconv(bit, case when ov.value is NULL then 0 else 1 end) AS has_default,
        ov.value AS default_value
    FROM
        sys.sysrscols c OUTER APPLY
        OpenRowset(TABLE RSCPROP, c.ti) p LEFT OUTER JOIN -- It simply decodes ti into individual properties
        sys.sysseobjvalues ov ON
        (
            ov.valclass = 1 AND -- SEVC_OUT_OF_ROW_DEFAULT
            ov.id = c.rsid AND
            ov.subid = c.hbcolid AND
            ov.valnum = 0 -- SE_VALNUM_DEFAULT 
        )
    JOIN sys.sysrowsets rs ON c.rsid = rs.rowsetid
GO
  
~~~

---
###   See also  
[List of views](../views.md)

