## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[table_types\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.table_types**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -494 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|name| |sysname|128|
|system_type_id| |tinyint|1|
|user_type_id| |int|4|
|schema_id| |int|4|
|principal_id| |int|4|
|max_length| |smallint|2|
|precision| |tinyint|1|
|scale| |tinyint|1|
|collation_name| |sysname|128|
|is_nullable| |bit|1|
|is_user_defined| |bit|1|
|is_assembly_type| |bit|1|
|default_object_id| |int|4|
|rule_object_id| |int|4|
|is_table_type| |bit|1|
|type_table_object_id| |int|4|
|is_memory_optimized| |bit|1|

Total: 17 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[table_types\]
 No dependencies exist

---
### Objects that \[sys\].\[table_types\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-494_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.table_types AS
    SELECT t.name AS name,
        t.xtype AS system_type_id,
        t.id AS user_type_id,
        t.schid AS schema_id,
        own.indepid AS principal_id,
        t.length AS max_length,
        t.prec AS precision,
        t.scale AS scale,
        convert(sysname, collationpropertyfromid(t.collationid, 'name')) AS collation_name,
        sysconv(bit, 1 - (t.status &amp; 1)) AS is_nullable,    -- TYPE_NOTNULL
        sysconv(bit, 1) AS is_user_defined,
        sysconv(bit, 0) AS is_assembly_type,
        sysconv(int, 0) AS default_object_id,
        sysconv(int, 0) AS rule_object_id,
        sysconv(bit, 1) AS is_table_type,
        o.indepid AS type_table_object_id,
        sysconv(bit, obj.status2 &amp; 0x00000008) AS is_memory_optimized    -- OBJTAB2_HEKATON
    FROM sys.sysscalartypes t
    LEFT JOIN sys.syssingleobjrefs own ON own.depid = t.id AND own.class = 44 AND own.depsubid = 0    -- SRC_TYPETOOWNER
    INNER JOIN sys.syssingleobjrefs o ON o.depid = t.id AND o.class = 36 AND o.depsubid = 0    -- SRC_TYPETOTABLE
    INNER JOIN sys.sysschobjs$ obj ON o.indepid = obj.id
        -- 36==SRC_TYPETOTABLE, so only table types show up in this view
    WHERE has_access('UT', t.id) = 1
GO
GRANT SELECT
    ON [sys].[table_types]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

