## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[spatial_indexes\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.spatial_indexes**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -497 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|object_id| |int|4|
|name| |sysname|128|
|index_id| |int|4|
|type| |tinyint|1|
|type_desc| |nvarchar|60|
|is_unique| |bit|1|
|data_space_id| |int|4|
|ignore_dup_key| |bit|1|
|is_primary_key| |bit|1|
|is_unique_constraint| |bit|1|
|fill_factor| |tinyint|1|
|is_padded| |bit|1|
|is_disabled| |bit|1|
|is_hypothetical| |bit|1|
|is_ignored_in_optimization| |bit|1|
|allow_row_locks| |bit|1|
|allow_page_locks| |bit|1|
|spatial_index_type| |int|4|
|spatial_index_type_desc| |nvarchar|60|
|tessellation_scheme| |nvarchar|60|
|has_filter| |bit|1|
|filter_definition| |nvarchar|1073741823|
|auto_created| |bit|1|

Total: 23 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[spatial_indexes\]
 No dependencies exist

---
### Objects that \[sys\].\[spatial_indexes\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-497_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.spatial_indexes AS
    SELECT i.id AS object_id,
        i.name AS name,
        i.indid AS index_id,
        i.type,
        n.name AS type_desc,
        sysconv(bit, i.status &amp; 0x8) AS is_unique,            -- IS_IND_UNIQUE
        isnull(ds.indepid, 1) AS data_space_id,
        sysconv(bit, i.status &amp; 0x4) AS ignore_dup_key,        -- IS_IND_DPKEYS
        sysconv(bit, i.status &amp; 0x20) AS is_primary_key,        -- IS_IND_PRIMARY
        sysconv(bit, i.status &amp; 0x40) AS is_unique_constraint,    -- IS_IND_UNIQUE_CO
        i.fillfact AS fill_factor,
        sysconv(bit, i.status &amp; 0x10) AS is_padded,                -- IS_IND_PADINDEX
        sysconv(bit, i.status &amp; 0x80) AS is_disabled,            -- IS_IND_OFFLINE
        sysconv(bit, i.status &amp; 0x100) AS is_hypothetical,        -- IS_IND_ITWINDEX
        sysconv(bit, i.status &amp; 0x02000000) AS is_ignored_in_optimization,    -- IS_IND_IGNORE_IN_OPTIMIZATION
        sysconv(bit, 1 - (i.status &amp; 512)/512) AS allow_row_locks,        -- IS_IND_NO_ROWLOCK
        sysconv(bit, 1 - (i.status &amp; 1024)/1024) AS allow_page_locks,    -- IS_IND_NO_PAGELOCK
        i.intprop AS spatial_index_type,
        ei.name AS spatial_index_type_desc,
        tes.name AS tessellation_scheme,
        sysconv(bit, 0) AS has_filter,
        convert(nvarchar(max), NULL) AS filter_definition,
        sysconv(bit, i.status &amp; 0x08000000) AS auto_created    -- IS_IND_AUTO_CREATED
    FROM sys.sysidxstats i
    LEFT JOIN sys.syssingleobjrefs ds ON ds.depid = i.id AND ds.class = 7 AND ds.depsubid = i.indid    -- SRC_INDEXTODS    
    LEFT JOIN sys.syspalvalues n ON n.class = 'IDXT' and n.value = i.type
    LEFT JOIN sys.syspalvalues ei ON ei.class = 'EITP' and ei.value = i.intprop
    LEFT JOIN sys.syspalvalues tes ON tes.class = 'EISP' and tes.value = i.intprop
    WHERE i.indid &gt;= 384000 and i.indid &lt; 512000 --indid greater and equal than x_MDIndexStatsId_MinExtended(384000) and less than x_MDIndexStatsId_MinTemp(512000)
        AND has_access('CO', i.id) = 1
GO
GRANT SELECT
    ON [sys].[spatial_indexes]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

