## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[database_audit_specification_details\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.database_audit_specification_details**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -502 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|database_specification_id| |int|4|
|audit_action_id| |char|4|
|audit_action_name| |nvarchar|60|
|class| |tinyint|1|
|class_desc| |nvarchar|60|
|major_id| |int|4|
|minor_id| |int|4|
|audited_principal_id| |int|4|
|audited_result| |nvarchar|60|
|is_group| |bit|1|

Total: 10 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[database_audit_specification_details\]
 No dependencies exist

---
### Objects that \[sys\].\[database_audit_specification_details\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-502_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.database_audit_specification_details AS
    SELECT
        database_specification_id    = asp.id,
        audit_action_id             = saa.type, -- EDiskAuditActionType
        audit_action_name             = convert(nvarchar(60), 
                                            audit_action_property('name', saa.class, saa.type)),
        class                         = saa.class, -- EMDPermissionClass
        class_desc                     = n.name,
        major_id                     = saa.id,
        minor_id                     = saa.subid,
        audited_principal_id        = saa.grantee,
        audited_result                 = convert(nvarchar(60), 'SUCCESS AND FAILURE'),
        is_group                     = sysconv(bit, 
                                        audit_action_property('is_group', saa.class, saa.type))
    FROM
        sys.sysclsobjs asp INNER JOIN 
        sys.sysaudacts saa ON
            (
                saa.audit_spec_id = asp.id
            ) LEFT JOIN
        sys.syspalvalues n ON 
            (
                n.class = 'UNCL' AND
                n.value = saa.class
            )
    WHERE
        asp.class = 65 AND -- SOC_SECAUDITSPEC
        asp.type = 'DA'
        AND has_access('DA', 0) = 1 -- catalog security check
GO
GRANT SELECT
    ON [sys].[database_audit_specification_details]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

