## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[dm_db_mirroring_connections\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.dm_db_mirroring_connections**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -504273378 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|connection_id| |uniqueidentifier|16|
|transport_stream_id| |uniqueidentifier|16|
|state| |smallint|2|
|state_desc| |nvarchar|60|
|connect_time| |datetime|8|
|login_time| |datetime|8|
|authentication_method| |nvarchar|128|
|principal_name| |nvarchar|128|
|remote_user_name| |nvarchar|128|
|last_activity_time| |datetime|8|
|is_accept| |bit|1|
|login_state| |smallint|2|
|login_state_desc| |nvarchar|60|
|peer_certificate_id| |int|4|
|encryption_algorithm| |smallint|2|
|encryption_algorithm_desc| |nvarchar|60|
|receives_posted| |smallint|2|
|is_receive_flow_controlled| |bit|1|
|sends_posted| |smallint|2|
|is_send_flow_controlled| |bit|1|
|total_bytes_sent| |bigint|8|
|total_bytes_received| |bigint|8|
|total_fragments_sent| |bigint|8|
|total_fragments_received| |bigint|8|
|total_sends| |bigint|8|
|total_receives| |bigint|8|
|peer_arbitration_id| |uniqueidentifier|16|
|address| |nvarchar|256|

Total: 28 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[dm_db_mirroring_connections\]
 No dependencies exist

---
### Objects that \[sys\].\[dm_db_mirroring_connections\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.dm_db_mirroring_connections AS
    SELECT 
        connection_id,
        transport_stream_id,
        state,
        state_desc = sn.name,
        connect_time,
        login_time,
        authentication_method,
        principal_name,
        remote_user_name,
        last_activity_time,
        is_accept,
        login_state,
        login_state_desc = ln.name,
        peer_certificate_id,
        encryption_algorithm = encalg,
        encryption_algorithm_desc = ag.name,
        receives_posted,
        is_receive_flow_controlled,
        sends_posted,
        is_send_flow_controlled,
        total_bytes_sent,
        total_bytes_received,
        total_fragments_sent,
        total_fragments_received,
        total_sends,
        total_receives,
        peer_arbitration_id,
        address
    FROM OpenRowset (TABLE SBCONNECTIONENDPOINTS) as c
    LEFT OUTER JOIN sys.syspalvalues ag ON ag.class = 'EPET' AND ag.value = c.encalg
    LEFT OUTER JOIN sys.syspalvalues sn ON sn.class = 'EPCS' AND sn.value = c.state
    LEFT OUTER JOIN sys.syspalvalues ln ON ln.class = 'EPLS' AND ln.value = c.login_state
        WHERE c.endpoint_type = 1 -- x_eetDbMirroring
GO
  
~~~

---
###   See also  
[List of views](../views.md)

