## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[sequences\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.sequences**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -515 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|name| |sysname|128|
|object_id| |int|4|
|principal_id| |int|4|
|schema_id| |int|4|
|parent_object_id| |int|4|
|type| |char|2|
|type_desc| |nvarchar|60|
|create_date| |datetime|8|
|modify_date| |datetime|8|
|is_ms_shipped| |bit|1|
|is_published| |bit|1|
|is_schema_published| |bit|1|
|start_value| |sql_variant|8016|
|increment| |sql_variant|8016|
|minimum_value| |sql_variant|8016|
|maximum_value| |sql_variant|8016|
|is_cycling| |bit|1|
|is_cached| |bit|1|
|cache_size| |int|4|
|system_type_id| |tinyint|1|
|user_type_id| |int|4|
|precision| |tinyint|1|
|scale| |tinyint|1|
|current_value| |sql_variant|8016|
|is_exhausted| |bit|1|
|last_used_value| |sql_variant|8016|

Total: 26 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[sequences\]
 No dependencies exist

---
### Objects that \[sys\].\[sequences\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-515_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.sequences AS
    SELECT
        -- common fields
        o.name,
        o.object_id,
        o.principal_id,
        o.schema_id,
        o.parent_object_id,
        o.type,
        o.type_desc,
        o.create_date,
        o.modify_date,
        o.is_ms_shipped,
        o.is_published,
        o.is_schema_published,
        -- specific fields
        dmv.start_value,
        dmv.increment,
        dmv.minimum_value,
        dmv.maximum_value,
        is_cycling = o.is_cycling,
        is_cached = o.is_cached,
        cache_size = nullif (o.property, 0),
        dmv.system_type_id,
        user_type_id = isnull(udt.indepid, dmv.system_type_id),
        dmv.precision,
        scale = convert(tinyint, 0), -- The scale always returns 0 as only integer types are allowed.
        dmv.current_value,
        dmv.is_exhausted,
        dmv.last_used_value
    FROM sys.objects$ o
    CROSS APPLY OpenRowset(TABLE DM_DB_SEQUENCES, o.object_id) dmv
    LEFT JOIN sys.syssingleobjrefs udt ON udt.depid = o.object_id AND udt.class = 43 AND udt.depsubid = 0    -- SRC_OBJTOTYPE
    WHERE o.type = 'SO' -- MDOT_SEQUENCE
GO
GRANT SELECT
    ON [sys].[sequences]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

