## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[column_store_segments\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.column_store_segments**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -518 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|partition_id| |bigint|8|
|hobt_id| |bigint|8|
|column_id| |int|4|
|segment_id| |int|4|
|version| |int|4|
|encoding_type| |int|4|
|row_count| |int|4|
|has_nulls| |int|4|
|base_id| |bigint|8|
|magnitude| |float|8|
|primary_dictionary_id| |int|4|
|secondary_dictionary_id| |int|4|
|min_data_id| |bigint|8|
|max_data_id| |bigint|8|
|null_value| |bigint|8|
|on_disk_size| |bigint|8|

Total: 16 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[column_store_segments\]
 No dependencies exist

---
### Objects that \[sys\].\[column_store_segments\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-518_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.column_store_segments
AS
    SELECT s.hobt_id as partition_id,
        s.hobt_id,
        c.rscolid as column_id,
        s.segment_id,
        s.version,
        s.encoding_type,
        s.row_count,
        (case when has_perms_by_name(OBJECT_SCHEMA_NAME(p.idmajor) + '.' + OBJECT_NAME(p.idmajor), 'OBJECT', 'SELECT') = 1 then sysconv(bit, s.status &amp; 1) else NULL end) as has_nulls,
        (case when has_perms_by_name(OBJECT_SCHEMA_NAME(p.idmajor) + '.' + OBJECT_NAME(p.idmajor), 'OBJECT', 'SELECT') = 1 then s.base_id else NULL end) as base_id,
        (case when has_perms_by_name(OBJECT_SCHEMA_NAME(p.idmajor) + '.' + OBJECT_NAME(p.idmajor), 'OBJECT', 'SELECT') = 1 then s.magnitude else NULL end) as magnitude,
        s.primary_dictionary_id,
        s.secondary_dictionary_id,
        (case when has_perms_by_name(OBJECT_SCHEMA_NAME(p.idmajor) + '.' + OBJECT_NAME(p.idmajor), 'OBJECT', 'SELECT') = 1 then s.min_data_id else NULL end) as min_data_id,
        (case when has_perms_by_name(OBJECT_SCHEMA_NAME(p.idmajor) + '.' + OBJECT_NAME(p.idmajor), 'OBJECT', 'SELECT') = 1 then s.max_data_id else NULL end) as max_data_id,
        (case when has_perms_by_name(OBJECT_SCHEMA_NAME(p.idmajor) + '.' + OBJECT_NAME(p.idmajor), 'OBJECT', 'SELECT') = 1 then s.null_value else NULL end) as null_value,
        s.on_disk_size
    FROM sys.syscscolsegments s
    INNER JOIN sys.sysrowsets p ON s.hobt_id = p.rowsetid
    INNER JOIN sys.sysrscols c ON s.hobt_id = c.rsid and s.column_id = c.hbcolid
    WHERE has_access('CO', p.idmajor) = 1    
    
    UNION ALL
    
    SELECT sg.partition_id,
        sg.hobt_id,
        sg.column_id,
        sg.segment_id,
        sg.version,
        sg.encoding_type,
        sg.row_count,
        (case when has_perms_by_name(OBJECT_SCHEMA_NAME(sg.object_id) + '.' + OBJECT_NAME(sg.object_id), 'OBJECT', 'SELECT') = 1 then sg.has_nulls else NULL end) as has_nulls,
        (case when has_perms_by_name(OBJECT_SCHEMA_NAME(sg.object_id) + '.' + OBJECT_NAME(sg.object_id), 'OBJECT', 'SELECT') = 1 then sg.base_id else NULL end) as base_id,
        (case when has_perms_by_name(OBJECT_SCHEMA_NAME(sg.object_id) + '.' + OBJECT_NAME(sg.object_id), 'OBJECT', 'SELECT') = 1 then sg.magnitude else NULL end) as magnitude,
        sg.primary_dictionary_id,
        sg.secondary_dictionary_id,
        (case when has_perms_by_name(OBJECT_SCHEMA_NAME(sg.object_id) + '.' + OBJECT_NAME(sg.object_id), 'OBJECT', 'SELECT') = 1 then sg.min_data_id else NULL end) as min_data_id,
        (case when has_perms_by_name(OBJECT_SCHEMA_NAME(sg.object_id) + '.' + OBJECT_NAME(sg.object_id), 'OBJECT', 'SELECT') = 1 then sg.max_data_id else NULL end) as max_data_id,
        (case when has_perms_by_name(OBJECT_SCHEMA_NAME(sg.object_id) + '.' + OBJECT_NAME(sg.object_id), 'OBJECT', 'SELECT') = 1 then sg.null_value else NULL end) as null_value,                
        sg.on_disk_size
    FROM OpenRowset(TABLE HKCS_SEGMENTS) sg
    WHERE has_access('CO', sg.object_id) = 1
GO
GRANT SELECT
    ON [sys].[column_store_segments]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

