## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[column_store_dictionaries\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.column_store_dictionaries**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -519 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|partition_id| |bigint|8|
|hobt_id| |bigint|8|
|column_id| |int|4|
|dictionary_id| |int|4|
|version| |int|4|
|type| |int|4|
|last_id| |int|4|
|entry_count| |bigint|8|
|on_disk_size| |bigint|8|

Total: 9 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[column_store_dictionaries\]
 No dependencies exist

---
### Objects that \[sys\].\[column_store_dictionaries\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-519_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.column_store_dictionaries
AS
    SELECT d.hobt_id as partition_id,
        d.hobt_id,
        c.rscolid as column_id,
        d.dictionary_id,
        d.version,
        d.type,
        (case when has_perms_by_name(OBJECT_SCHEMA_NAME(p.idmajor) + '.' + OBJECT_NAME(p.idmajor), 'OBJECT', 'SELECT') = 1 then d.last_id else NULL end) as last_id,
        (case when has_perms_by_name(OBJECT_SCHEMA_NAME(p.idmajor) + '.' + OBJECT_NAME(p.idmajor), 'OBJECT', 'SELECT') = 1 then d.entry_count else NULL end) as entry_count,
        d.on_disk_size
    FROM sys.syscsdictionaries d
    INNER JOIN sys.sysrowsets p ON d.hobt_id = p.rowsetid
    INNER JOIN sys.sysrscols c ON d.hobt_id = c.rsid and d.column_id = c.hbcolid
    WHERE has_access('CO', p.idmajor) = 1
    
    UNION ALL

    SELECT dict.partition_id,
        dict.hobt_id,
        dict.column_id,
        dict.dictionary_id,
        dict.version,
        dict.type,
        (case when has_perms_by_name(OBJECT_SCHEMA_NAME(dict.object_id) + '.' + OBJECT_NAME(dict.object_id), 'OBJECT', 'SELECT') = 1 then dict.last_id else NULL end) as last_id,
        (case when has_perms_by_name(OBJECT_SCHEMA_NAME(dict.object_id) + '.' + OBJECT_NAME(dict.object_id), 'OBJECT', 'SELECT') = 1 then dict.entry_count else NULL end) as entry_count,        
        dict.on_disc_size
    FROM OpenRowset(TABLE HKCS_DICTIONARIES) dict
    WHERE has_access('CO', dict.object_id) = 1
GO
GRANT SELECT
    ON [sys].[column_store_dictionaries]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

