## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[hash_indexes\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.hash_indexes**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -535 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|object_id| |int|4|
|name| |sysname|128|
|index_id| |int|4|
|type| |tinyint|1|
|type_desc| |nvarchar|60|
|is_unique| |bit|1|
|data_space_id| |int|4|
|ignore_dup_key| |bit|1|
|is_primary_key| |bit|1|
|is_unique_constraint| |bit|1|
|fill_factor| |tinyint|1|
|is_padded| |bit|1|
|is_disabled| |bit|1|
|is_hypothetical| |bit|1|
|is_ignored_in_optimization| |bit|1|
|allow_row_locks| |bit|1|
|allow_page_locks| |bit|1|
|has_filter| |bit|1|
|filter_definition| |nvarchar|1073741823|
|bucket_count| |int|4|
|auto_created| |bit|1|

Total: 21 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[hash_indexes\]
 No dependencies exist

---
### Objects that \[sys\].\[hash_indexes\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-535_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.hash_indexes AS
    SELECT i.id AS object_id,
        i.name AS name,
        i.indid AS index_id,
        i.type,
        n.name AS type_desc,
        sysconv(bit, i.status &amp; 0x8) AS is_unique,            -- IS_IND_UNIQUE
        0 AS data_space_id,
        sysconv(bit, i.status &amp; 0x4) AS ignore_dup_key,        -- IS_IND_DPKEYS
        sysconv(bit, i.status &amp; 0x20) AS is_primary_key,    -- IS_IND_PRIMARY
        sysconv(bit, i.status &amp; 0x40) AS is_unique_constraint,    -- IS_IND_UNIQUE_CO
        i.fillfact AS fill_factor,
        sysconv(bit, i.status &amp; 0x10) AS is_padded,        -- IS_IND_PADINDEX
        sysconv(bit, i.status &amp; 0x80) AS is_disabled,        -- IS_IND_OFFLINE
        sysconv(bit, i.status &amp; 0x100) AS is_hypothetical,    -- IS_IND_ITWINDEX
        sysconv(bit, i.status &amp; 0x02000000) AS is_ignored_in_optimization,    -- IS_IND_IGNORE_IN_OPTIMIZATION
        sysconv(bit, 1 - (i.status &amp; 512)/512) AS allow_row_locks,        -- IS_IND_NO_ROWLOCK
        sysconv(bit, 1 - (i.status &amp; 1024)/1024) AS allow_page_locks,        -- IS_IND_NO_PAGELOCK
        sysconv(bit, i.status &amp; 0x20000) AS has_filter,    -- IS_HAS_FILTER
        case when (i.status &amp; 0x20000) != 0 then object_definition(i.id, i.indid, 7) else NULL end AS filter_definition, -- x_euncIndex
        i.intprop AS bucket_count,
        sysconv(bit, i.status &amp; 0x08000000) AS auto_created    -- IS_IND_AUTO_CREATED
    FROM sys.sysidxstats i
    LEFT JOIN sys.syssingleobjrefs ds ON ds.depid = i.id AND ds.class = 7 AND ds.depsubid = i.indid    -- SRC_INDEXTODS
    LEFT JOIN sys.syspalvalues n ON n.class = 'IDXT' and n.value = i.type
    WHERE (i.status &amp; 1) &lt;&gt; 0 AND i.type = 7 -- HASH indexes are type 7
        AND has_access('CO', i.id) = 1    -- IS_INDEX
GO
GRANT SELECT
    ON [sys].[hash_indexes]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

