## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[query_store_plan\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.query_store_plan**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -537 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|plan_id| |bigint|8|
|query_id| |bigint|8|
|plan_group_id| |bigint|8|
|engine_version| |nvarchar|32|
|compatibility_level| |smallint|2|
|query_plan_hash| |binary|8|
|query_plan| |nvarchar|1073741823|
|is_online_index_plan| |bit|1|
|is_trivial_plan| |bit|1|
|is_parallel_plan| |bit|1|
|is_forced_plan| |bit|1|
|is_natively_compiled| |bit|1|
|force_failure_count| |bigint|8|
|last_force_failure_reason| |int|4|
|last_force_failure_reason_desc| |nvarchar|128|
|count_compiles| |bigint|8|
|initial_compile_start_time| |datetimeoffset|10|
|last_compile_start_time| |datetimeoffset|10|
|last_execution_time| |datetimeoffset|10|
|avg_compile_duration| |float|8|
|last_compile_duration| |bigint|8|
|plan_forcing_type| |int|4|
|plan_forcing_type_desc| |nvarchar|60|

Total: 23 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[query_store_plan\]
 No dependencies exist

---
### Objects that \[sys\].\[query_store_plan\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-537_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.query_store_plan AS
    SELECT 
        plan_id,
        query_id,
        plan_group_id,
        convert(nvarchar(32), 
        REPLACE(STR((engine_version &amp; 0xff00000000 ) / 0x100000000), ' ', '') + '.'
        + REPLACE(STR((engine_version &amp; 0xff000000 ) / 0x1000000), ' ', '') + '.'
        + REPLACE(STR((engine_version &amp; 0xffff00 ) / 0x100), ' ', '') + '.'
        + REPLACE(STR(engine_version &amp; 0xff), ' ', '')
        ) as engine_version,
        compatibility_level,
        query_plan_hash,
        cast(showplanxmldecompress(query_plan) as nvarchar(max)) as query_plan,
        is_online_index_plan,
        is_trivial_plan,
        is_parallel_plan,
        is_forced_plan,
        is_natively_compiled,
        force_failure_count,
        last_force_failure_reason,
        convert(nvarchar(128), CASE last_force_failure_reason
            WHEN 0 THEN N'NONE'
            WHEN NULL THEN N'NONE'
            WHEN 8637 THEN N'ONLINE_INDEX_BUILD'
            WHEN 8683 THEN N'INVALID_STARJOIN'
            WHEN 8684 THEN N'TIME_OUT'
            WHEN 8689 THEN N'NO_DB'
            WHEN 8690 THEN N'HINT_CONFLICT'
            WHEN 8691 THEN N'SETOPT_CONFLICT'
            WHEN 8694 THEN N'DQ_NO_FORCING_SUPPORTED'
            WHEN 8698 THEN N'NO_PLAN'
            WHEN 8712 THEN N'NO_INDEX'
            WHEN 8713 THEN N'VIEW_COMPILE_FAILED'
            ELSE N'GENERAL_FAILURE'
            END) COLLATE Latin1_General_CI_AS_KS_WS as last_force_failure_reason_desc,
        count_compiles,
        initial_compile_start_time,
        last_compile_start_time,
        last_execution_time,
        CASE WHEN count_compiles = 0 THEN NULL ELSE convert(float, total_compile_duration) / count_compiles END as avg_compile_duration,
        last_compile_duration,
        plan_forcing_type,
        p.name as plan_forcing_type_desc
    FROM sys.plan_persist_plan_merged
    LEFT JOIN  sys.syspalvalues p ON p.class = 'PFT' AND p.value = plan_forcing_type
GO
GRANT SELECT
    ON [sys].[query_store_plan]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

