## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[query_store_query\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.query_store_query**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -538 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|query_id| |bigint|8|
|query_text_id| |bigint|8|
|context_settings_id| |bigint|8|
|object_id| |bigint|8|
|batch_sql_handle| |varbinary|44|
|query_hash| |binary|8|
|is_internal_query| |bit|1|
|query_parameterization_type| |tinyint|1|
|query_parameterization_type_desc| |nvarchar|60|
|initial_compile_start_time| |datetimeoffset|10|
|last_compile_start_time| |datetimeoffset|10|
|last_execution_time| |datetimeoffset|10|
|last_compile_batch_sql_handle| |varbinary|44|
|last_compile_batch_offset_start| |bigint|8|
|last_compile_batch_offset_end| |bigint|8|
|count_compiles| |bigint|8|
|avg_compile_duration| |float|8|
|last_compile_duration| |bigint|8|
|avg_bind_duration| |float|8|
|last_bind_duration| |bigint|8|
|avg_bind_cpu_time| |float|8|
|last_bind_cpu_time| |bigint|8|
|avg_optimize_duration| |float|8|
|last_optimize_duration| |bigint|8|
|avg_optimize_cpu_time| |float|8|
|last_optimize_cpu_time| |bigint|8|
|avg_compile_memory_kb| |float|8|
|last_compile_memory_kb| |bigint|8|
|max_compile_memory_kb| |bigint|8|
|is_clouddb_internal_query| |bit|1|

Total: 30 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[query_store_query\]
 No dependencies exist

---
### Objects that \[sys\].\[query_store_query\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-538_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.query_store_query AS
    SELECT 
        query_id,
        query_text_id,
        context_settings_id,
        object_id,
        CAST(batch_sql_handle AS VARBINARY(44)) as batch_sql_handle,
        query_hash,
        is_internal_query,
        query_param_type as query_parameterization_type,
        n.name as query_parameterization_type_desc,
        initial_compile_start_time,
        last_compile_start_time,
        last_execution_time,
        CAST(last_compile_batch_sql_handle AS VARBINARY(44)) as last_compile_batch_sql_handle,
        last_compile_batch_offset_start,
        last_compile_batch_offset_end,
        compile_count as count_compiles,
        CASE WHEN compile_count = 0 THEN NULL ELSE convert(float, total_compile_duration) / compile_count END as avg_compile_duration,
        last_compile_duration,
        CASE WHEN compile_count = 0 THEN NULL ELSE convert(float, total_bind_duration) / compile_count END as avg_bind_duration,
        last_bind_duration,
        CASE WHEN compile_count = 0 THEN NULL ELSE convert(float, total_bind_cpu_time) / compile_count END as avg_bind_cpu_time,
        last_bind_cpu_time,
        CASE WHEN compile_count = 0 THEN NULL ELSE convert(float, total_optimize_duration) / compile_count END as avg_optimize_duration,
        last_optimize_duration,
        CASE WHEN compile_count = 0 THEN NULL ELSE convert(float, total_optimize_cpu_time) / compile_count END as avg_optimize_cpu_time,
        last_optimize_cpu_time,
        CASE WHEN compile_count = 0 THEN NULL ELSE convert(float, total_compile_memory_kb) / compile_count END as avg_compile_memory_kb,
        last_compile_memory_kb,
        max_compile_memory_kb,
        CASE WHEN status IS NULL    THEN NULL ELSE convert(bit, status &amp; 0x01) END as is_clouddb_internal_query
    FROM sys.plan_persist_query_merged
    LEFT JOIN  sys.syspalvalues n ON n.class = 'QDPT' AND n.value = query_param_type
GO
GRANT SELECT
    ON [sys].[query_store_query]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

