## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[column_store_row_groups\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.column_store_row_groups**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -551 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|object_id| |int|4|
|index_id| |int|4|
|partition_number| |int|4|
|row_group_id| |int|4|
|delta_store_hobt_id| |bigint|8|
|state| |tinyint|1|
|state_description| |nvarchar|60|
|total_rows| |bigint|8|
|deleted_rows| |bigint|8|
|size_in_bytes| |bigint|8|

Total: 10 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[column_store_row_groups\]
 No dependencies exist

---
### Objects that \[sys\].\[column_store_row_groups\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-551_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE VIEW sys.column_store_row_groups AS

    SELECT rg.parent_object_id as [object_id],
        rg.parent_index_id as [index_id],
        rg.parent_part_number as [partition_number],
        rg.[row_group_id],
        rg.[delta_store_hobt_id],
        rg.[state],
        sd.[name] as state_description,
        rg.[total_rows],
        rg.[deleted_rows],
        rg.[size_in_bytes]
    FROM
    (sys.syspalvalues sd
    INNER hash JOIN
    -- First parameter determines which table to open
    -- Second parameter determines the object id passed in
    -- Third parameter determines which view to show,
    -- 1 is to show dm_db_column_store_row_group_physical_stats
    -- 0 is to show fn_column_store_row_groups or column_store_row_groups
    OpenRowset(TABLE COLUMNSTORE_ROW_GROUPS, 0, 0) rg
        ON sd.class = 'CSRG' AND sd.value = rg.state)
    WHERE has_access('CO', rg.parent_object_id) = 1;
GO
GRANT SELECT
    ON [sys].[column_store_row_groups]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

