## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[security_predicates\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.security_predicates**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -558 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|object_id| |int|4|
|security_predicate_id| |int|4|
|target_object_id| |int|4|
|predicate_definition| |nvarchar|1073741823|
|predicate_type| |int|4|
|predicate_type_desc| |nvarchar|60|
|operation| |int|4|
|operation_desc| |nvarchar|60|

Total: 8 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[security_predicates\]
 No dependencies exist

---
### Objects that \[sys\].\[security_predicates\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-558_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.security_predicates AS
    SELECT 
        mr.depid as object_id, 
        mr.depsubid as security_predicate_id, 
        mr.indepid as target_object_id, 
        object_definition(mr.depid, mr.depsubid) as predicate_definition,
        convert(int, mr.status % 0x10) as predicate_type,
        v1.name as predicate_type_desc,
        case when convert(int, mr.status / 0x10 % 0x10) = 0 then NULL else convert(int, mr.status / 0x10 % 0x10) end as operation,
        v2.name as operation_desc
    FROM sys.sysmultiobjrefs mr
    LEFT JOIN sys.syspalvalues v1 ON v1.class = 'SPT' AND v1.value = (mr.status % 0x10)
    LEFT JOIN sys.syspalvalues v2 ON v2.class = 'SPO' AND v2.value = (mr.status / 0x10 % 0x10)
    WHERE mr.class = 11 AND has_access('CO', mr.depid) = 1
GO
GRANT SELECT
    ON [sys].[security_predicates]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

