## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[external_tables\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.external_tables**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -559 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|name| |sysname|128|
|object_id| |int|4|
|principal_id| |int|4|
|schema_id| |int|4|
|parent_object_id| |int|4|
|type| |char|2|
|type_desc| |nvarchar|60|
|create_date| |datetime|8|
|modify_date| |datetime|8|
|is_ms_shipped| |bit|1|
|is_published| |bit|1|
|is_schema_published| |bit|1|
|max_column_id_used| |int|4|
|uses_ansi_nulls| |bit|1|
|data_source_id| |int|4|
|file_format_id| |int|4|
|location| |nvarchar|4000|
|reject_type| |nvarchar|20|
|reject_value| |float|8|
|reject_sample_value| |float|8|
|distribution_type| |tinyint|1|
|distribution_desc| |nvarchar|120|
|sharding_col_id| |int|4|
|remote_schema_name| |nvarchar|128|
|remote_object_name| |nvarchar|128|

Total: 25 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[external_tables\]
 No dependencies exist

---
### Objects that \[sys\].\[external_tables\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-559_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE VIEW sys.external_tables AS
    SELECT
        obj.name AS name,
        obj.object_id AS object_id,
        obj.principal_id AS principal_id,
        obj.schema_id AS schema_id,
        obj.parent_object_id AS parent_object_id,
        obj.type AS type,
        obj.type_desc AS type_desc,    
        obj.create_date AS create_date,
        obj.modify_date AS modify_date,
        obj.is_ms_shipped AS is_ms_shipped,    
        obj.is_published AS is_published,
        obj.is_schema_published AS is_schema_published,
        (SELECT TOP 1 column_id from sys.columns cols
            WHERE cols.object_id = et.object_id
            ORDER BY cols.column_id DESC) AS max_column_id_used,    
        obj.uses_ansi_nulls AS uses_ansi_nulls,
        et.data_source_id AS data_source_id,
        et.file_format_id AS file_format_id,
        et.location AS location,
        et.reject_type AS reject_type,
        et.reject_value AS reject_value,
        et.reject_sample_value AS reject_sample_value,
        CASE
            WHEN et.sharding_dist_type &lt; 3 THEN et.sharding_dist_type
            ELSE NULL
        END AS distribution_type,
        CASE 
            WHEN et.sharding_dist_type = 0 THEN CONVERT(NVARCHAR(120), 'SHARDED')
            WHEN et.sharding_dist_type = 1 THEN CONVERT(NVARCHAR(120), 'REPLICATED')
            WHEN et.sharding_dist_type = 2 THEN CONVERT(NVARCHAR(120), 'ROUND_ROBIN')
            ELSE NULL
        END AS distribution_desc,
        CASE 
            WHEN et.sharding_col_id &lt;&gt; -1 THEN et.sharding_col_id
            ELSE NULL
        END AS sharding_col_id,
        et.source_schema_name as remote_schema_name,
        et.source_table_name as remote_object_name
    FROM sys.sysexttables et 
        INNER JOIN sys.objects$ obj on et.object_id = obj.object_id
GO
GRANT SELECT
    ON [sys].[external_tables]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

