## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[memory_optimized_tables_internal_attributes\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.memory_optimized_tables_internal_attributes**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -560 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|object_id| |int|4|
|xtp_object_id| |int|4|
|type| |int|4|
|type_desc| |nvarchar|60|
|minor_id| |int|4|

Total: 5 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[memory_optimized_tables_internal_attributes\]
 No dependencies exist

---
### Objects that \[sys\].\[memory_optimized_tables_internal_attributes\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-560_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.memory_optimized_tables_internal_attributes AS
    SELECT 
        CASE 
            WHEN depr.class IS NULL THEN r.indepid
            ELSE depr.indepid
            END
        AS object_id,
            -- depr.class is NULL for tables that are not internal history tables. In that case we return the table's ID.
            -- If it's null, we return the current table's ID (retrieved in the JOIN).
        r.depid AS xtp_object_id,
        CASE 
            WHEN depr.class IS NULL THEN 
                CASE
                    WHEN r.class = 119 /* SRC_OFFROW_DATA_HKTABLEID */ THEN 5 /* Off-row table type */
                    ELSE r.indepsubid 
                    END
            ELSE depr.indepsubid
            END
        AS type,
        pv.name AS type_desc,
        CASE
            WHEN r.class = 119 /* SRC_OFFROW_DATA_HKTABLEID */ THEN r.indepsubid
            ELSE 0
            END
        AS minor_id
    FROM sys.syssingleobjrefs r    
        -- A specific case for this view is to show internal in memory history tables for Hekaton-Temporal tables.
        -- This relation is preserved as a link in sys.syssingleobjrefs that has class 118 - SRC_TEMPORAL_IN_MEMORY_HISTORY_INTERNAL_TABLE;
        -- the self join below is retrieving the information for internal in memory history tables.
    LEFT JOIN sys.syssingleobjrefs depr ON depr.depid = r.indepid AND depr.class = 118 /* SRC_TEMPORAL_IN_MEMORY_HISTORY_INTERNAL_TABLE */
    JOIN sys.syspalvalues pv ON 
           (r.class = 85 /* SRC_HKTABLEID_TO_OBJECTID */ AND depr.class IS NULL AND pv.class = 'HKCS' AND pv.value = r.indepsubid)
        OR (r.class = 119 /* SRC_OFFROW_DATA_HKTABLEID */ AND depr.class IS NULL AND pv.class = 'HKOD' AND pv.value = 0)
        OR (depr.class = 118 /* SRC_TEMPORAL_IN_MEMORY_HISTORY_INTERNAL_TABLE */ AND pv.class = 'ITTY' AND pv.value = depr.indepsubid)
    WHERE r.class = 85 /* SRC_HKTABLEID_TO_OBJECTID */ or r.class = 119 /* SRC_OFFROW_DATA_HKTABLEID */
GO
GRANT SELECT
    ON [sys].[memory_optimized_tables_internal_attributes]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

