## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[column_master_keys\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.column_master_keys**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -562 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|name| |sysname|128|
|column_master_key_id| |int|4|
|create_date| |datetime|8|
|modify_date| |datetime|8|
|key_store_provider_name| |sysname|128|
|key_path| |nvarchar|4000|

Total: 6 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[column_master_keys\]
 No dependencies exist

---
### Objects that \[sys\].\[column_master_keys\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-562_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.column_master_keys AS
    SELECT 
        sc.name as name, 
        sc.id as column_master_key_id,
        sc.created AS create_date,
        sc.modified AS modify_date,
        convert(sysname, sov2.value) collate catalog_default as key_store_provider_name,
        convert(nvarchar(4000), sov1.value) collate catalog_default as key_path
    FROM sys.sysclsobjs sc
    INNER JOIN sys.sysobjvalues sov1 ON sov1.valclass = 114 /*SVC_COL_MASTER_KEY_VERSION*/ and sov1.objid = sc.id and sov1.valnum = 0 -- KEY_PATH
    INNER JOIN sys.sysobjvalues sov2 ON sov2.valclass = 114 /*SVC_COL_MASTER_KEY_VERSION*/ and sov2.objid = sc.id and sov2.subobjid = sov1.subobjid and sov2.valnum = 1 -- KEY_STORE_NAME
    WHERE sc.class = 101 -- SOC_COLMASTERKEY
    AND has_access('CM', DB_ID()) = 1
GO
GRANT SELECT
    ON [sys].[column_master_keys]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

