## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[internal_partitions\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.internal_partitions**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -570 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|partition_id| |bigint|8|
|object_id| |int|4|
|index_id| |int|4|
|partition_number| |int|4|
|hobt_id| |bigint|8|
|internal_object_type| |tinyint|1|
|internal_object_type_desc| |nvarchar|60|
|row_group_id| |int|4|
|rows| |bigint|8|
|data_compression| |tinyint|1|
|data_compression_desc| |nvarchar|60|

Total: 11 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[internal_partitions\]
 No dependencies exist

---
### Objects that \[sys\].\[internal_partitions\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-570_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.internal_partitions AS
    WITH Group1(partition_id, object_id, index_id, partition_number, 
            hobt_id, internal_object_type, row_group_id, rows, data_compression)
    AS
    (
    SELECT
        rs.rowsetid AS partition_id,
        -- The next 4 columns form a unique Composite ID for internal partition.
        rs.idmajor AS object_id, -- This is the first column
        rs.idminor AS index_id,  -- This is the second column
        rs.numpart AS partition_number, -- This is the third column
        rs.rowsetid AS hobt_id, -- This is the fourth column
        MAX(rs.ownertype) as internal_object_type,
        NULL AS row_group_id, -- No rowgroup id for delete bitmaps, delete buffer or mapping index.
        SUM(isnull(ct.rows, rs.rcrows))    AS rows,
        MAX(rs.cmprlevel)    AS data_compression
    FROM sys.sysrowsets rs OUTER APPLY OpenRowset(TABLE ALUCOUNT, rs.rowsetid, 0, 0, 0) ct 
    WHERE rs.ownertype IN (2,4,5) -- delete bitmaps, delete buffer and mapping index.
    GROUP BY rs.rowsetid, rs.idmajor, rs.idminor, rs.numpart
    ),
    Group2(partition_id, object_id, index_id, partition_number, 
            hobt_id, internal_object_type, row_group_id, rows, data_compression )
    AS
    (
        SELECT
            rs.rowsetid AS partition_id, 
        -- The next 4 columns form a unique Composite ID for internal partition.
        rs.idmajor AS object_id, -- This is the first column
            rs.idminor AS index_id,  -- This is the second column
            rs.numpart AS partition_number, -- This is the third column
            rs.rowsetid AS hobt_id, -- This is the fourth column
            MAX(rs.ownertype) as internal_object_type,
        MAX(rg.row_group_id) AS row_group_id,
            SUM(isnull(ct.rows, rs.rcrows))    AS rows,
        MAX(rs.cmprlevel)    AS data_compression
        FROM sys.sysrowsets rs OUTER APPLY OpenRowset(TABLE ALUCOUNT, rs.rowsetid, 0, 0, 0) ct
    LEFT JOIN OpenRowset(TABLE COLUMNSTORE_ROW_GROUPS, 0, 0) rg ON 
        rs.idmajor = rg.parent_object_id AND rs.idminor = rg.parent_index_id AND rs.rowsetid = rg.delta_store_hobt_id
    WHERE rs.ownertype IN (3) -- deltastores
        GROUP BY rs.rowsetid, rs.idmajor, rs.idminor, rs.numpart
    )
    SELECT 
        P.partition_id,
        P.object_id,
        P.index_id,
        P.partition_number,
        P.hobt_id,
        P.internal_object_type,
        rst.name as internal_object_type_desc,
        P.row_group_id, 
        P.rows, 
        P.data_compression,
        cl.name AS data_compression_desc
    FROM (SELECT * from Group1
        UNION ALL
        SELECT * from Group2) AS P
    LEFT JOIN sys.syspalvalues cl ON cl.class = 'CMPL' AND cl.value = P.data_compression
    LEFT JOIN sys.syspalvalues rst ON rst.class = 'ROTY' AND rst.value = P.internal_object_type
GO
GRANT SELECT
    ON [sys].[internal_partitions]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

