## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[index_resumable_operations\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.index_resumable_operations**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 06/15/2019 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -587 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|object_id| |int|4|
|index_id| |int|4|
|name| |nvarchar|128|
|sql_text| |nvarchar|1073741823|
|last_max_dop_used| |smallint|2|
|partition_number| |int|4|
|state| |tinyint|1|
|state_desc| |nvarchar|60|
|start_time| |datetime|8|
|last_pause_time| |datetime|8|
|total_execution_time| |int|4|
|percent_complete| |float|8|
|page_count| |bigint|8|

Total: 13 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[index_resumable_operations\]
 No dependencies exist

---
### Objects that \[sys\].\[index_resumable_operations\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-587_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.index_resumable_operations AS
    SELECT 
        r.object_id,
        r.index_id,
        r.name,
        r.sql_text,
        r.last_max_dop_used,
        r.partition_number,
        r.state,
        val.name as state_desc,
        r.start_time,
        r.last_pause_time,
        r.total_execution_time,
        r.percent_complete,
        r.page_count
    FROM sys.sysidxstats i
            CROSS APPLY OpenRowset(TABLE INDEX_RESUMABLE_OPERATIONS, i.id, i.indid) r
            LEFT JOIN sys.syspalvalues val ON val.class = 'RIBS' AND val.value = r.state
    WHERE (i.status &amp; 1) = 1 -- IS_INDEX
        AND has_access('CO', i.id) = 1
        AND (i.status &amp; 0x04000000) = 0x04000000 -- IS_IND_RESUMABLE
        AND i.indid != 254 -- exclude mapping index
        AND i.indid != 896254 -- exclude resumable mapping index
GO
GRANT SELECT
    ON [sys].[index_resumable_operations]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

