## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[query_store_wait_stats\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.query_store_wait_stats**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 06/15/2019 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -596 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|wait_stats_id| |bigint|8|
|plan_id| |bigint|8|
|runtime_stats_interval_id| |bigint|8|
|wait_category| |smallint|2|
|wait_category_desc| |nvarchar|60|
|execution_type| |tinyint|1|
|execution_type_desc| |nvarchar|60|
|total_query_wait_time_ms| |bigint|8|
|avg_query_wait_time_ms| |float|8|
|last_query_wait_time_ms| |bigint|8|
|min_query_wait_time_ms| |bigint|8|
|max_query_wait_time_ms| |bigint|8|
|stdev_query_wait_time_ms| |float|8|

Total: 13 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[query_store_wait_stats\]
 No dependencies exist

---
### Objects that \[sys\].\[query_store_wait_stats\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
|User/role |Alter |Control |Select |Insert |Update |Delete |DRI |Takeownership |Viewdefinition |Columns |
|-|-|-|-|-|-|-|-|-|-|-|
|[\[dbo\].\[public\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Roles/0.md)|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|![](../../../../ImagesMetro/CHECKBOX_UNCHECKED_NEW.gif "")|[Columns](../Permissions/columns_t_-596_u_public.md)|

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.query_store_wait_stats AS
    SELECT
        wait_stats_id,
        plan_id,
        runtime_stats_interval_id,
        wait_category,
        c.name as wait_category_desc,
        execution_type,
        n.name as execution_type_desc,
        total_query_wait_time_ms,
        avg_query_wait_time_ms,
        last_query_wait_time_ms,
        min_query_wait_time_ms,
        max_query_wait_time_ms,
        CASE WHEN sqdiff_query_wait_time_ms &gt;= 0 THEN sqrt(sqdiff_query_wait_time_ms) ELSE NULL END as stdev_query_wait_time_ms
    FROM
    (
        SELECT
        *,
        round( convert(float, sumsquare_query_wait_time_ms) / count_executions - avg_query_wait_time_ms * avg_query_wait_time_ms,2) as sqdiff_query_wait_time_ms
        FROM
        (
            SELECT 
            ws.*,
            CONVERT(float, total_query_wait_time_ms) / count_executions AS avg_query_wait_time_ms
            FROM sys.plan_persist_wait_stats_merged ws
        ) AS AVG_VAL
    ) AS AVG_SQ_VAL
    LEFT JOIN sys.syspalvalues c ON c.class = 'WCAT' and c.value = wait_category
    LEFT JOIN sys.syspalvalues n ON n.class = 'QDXT' and n.value = execution_type
GO
GRANT SELECT
    ON [sys].[query_store_wait_stats]
    TO [public]
GO
  
~~~

---
###   See also  
[List of views](../views.md)

