## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[dm_hadr_availability_group_states\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.dm_hadr_availability_group_states**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -683019598 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|group_id| |uniqueidentifier|16|
|primary_replica| |nvarchar|128|
|primary_recovery_health| |tinyint|1|
|primary_recovery_health_desc| |nvarchar|60|
|secondary_recovery_health| |tinyint|1|
|secondary_recovery_health_desc| |nvarchar|60|
|synchronization_health| |tinyint|1|
|synchronization_health_desc| |nvarchar|60|

Total: 8 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[dm_hadr_availability_group_states\]
 No dependencies exist

---
### Objects that \[sys\].\[dm_hadr_availability_group_states\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.dm_hadr_availability_group_states AS
    SELECT
        ags.group_id,
        primary_replica = CAST (ags.primary_replica AS NVARCHAR(128)),
        primary_recovery_health = CASE
            WHEN ags.local_replica_role = 1 THEN ars.recovery_health_aggr
            ELSE NULL END,
        primary_recovery_health_desc = CASE
            WHEN (ags.local_replica_role = 1 AND ars.recovery_health_aggr = 0) THEN CAST ('ONLINE_IN_PROGRESS' AS NVARCHAR(60))
            WHEN (ags.local_replica_role = 1 AND ars.recovery_health_aggr &gt; 0) THEN CAST ('ONLINE' AS NVARCHAR(60))
            ELSE CAST (NULL AS NVARCHAR(60)) END,
        secondary_recovery_health = CASE
            WHEN ags.local_replica_role = 2 THEN ars.recovery_health_aggr
            ELSE NULL END,
        secondary_recovery_health_desc = CASE
            WHEN (ags.local_replica_role = 2 AND ars.recovery_health_aggr = 0) THEN CAST ('ONLINE_IN_PROGRESS' AS NVARCHAR(60))
            WHEN (ags.local_replica_role = 2 AND ars.recovery_health_aggr &gt; 0) THEN CAST ('ONLINE' AS NVARCHAR(60))
            ELSE CAST (NULL AS NVARCHAR(60)) END,
        synchronization_health = CASE
            WHEN ars.synchronization_health_aggr IS NULL THEN CAST (0 AS TINYINT)            -- NOT_HEALTHY
            WHEN (ags.local_replica_role = 1 AND ags.configured_replica_count &gt; ars.replica_count) THEN CAST (0 AS TINYINT)    -- NOT_HEALTHY (one or more replicas/DBs not joined)
            ELSE CAST (ars.synchronization_health_aggr AS TINYINT) END,
        synchronization_health_desc = CASE
            WHEN ars.synchronization_health_aggr IS NULL THEN CAST ('NOT_HEALTHY' AS NVARCHAR(60))
            WHEN (ags.local_replica_role = 1 AND ags.configured_replica_count &gt; ars.replica_count) THEN CAST ('NOT_HEALTHY' AS NVARCHAR(60))
            WHEN ars.synchronization_health_aggr = 2 THEN CAST ('HEALTHY' AS NVARCHAR(60))
            WHEN ars.synchronization_health_aggr = 1 THEN CAST ('PARTIALLY_HEALTHY' AS NVARCHAR(60))
            ELSE CAST ('NOT_HEALTHY' AS NVARCHAR(60)) END
    FROM
        sys.dm_hadr_internal_availability_group_states ags
        LEFT OUTER JOIN
        (
            SELECT
                group_id,
                replica_count = COUNT (*),
                recovery_health_aggr = MAX (recovery_health),
                synchronization_health_aggr = MIN (synchronization_health)
            FROM
                sys.dm_hadr_availability_replica_states
            GROUP BY group_id
        )
        AS ars
        ON ags.group_id = ars.group_id
GO
  
~~~

---
###   See also  
[List of views](../views.md)

