## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[dm_hadr_availability_replica_states\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.dm_hadr_availability_replica_states**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -744484871 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|replica_id| |uniqueidentifier|16|
|group_id| |uniqueidentifier|16|
|is_local| |bit|1|
|role| |tinyint|1|
|role_desc| |nvarchar|60|
|operational_state| |tinyint|1|
|operational_state_desc| |nvarchar|60|
|connected_state| |tinyint|1|
|connected_state_desc| |nvarchar|60|
|recovery_health| |tinyint|1|
|recovery_health_desc| |nvarchar|60|
|synchronization_health| |tinyint|1|
|synchronization_health_desc| |nvarchar|60|
|last_connect_error_number| |int|4|
|last_connect_error_description| |nvarchar|1024|
|last_connect_error_timestamp| |datetime|8|

Total: 16 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[dm_hadr_availability_replica_states\]
 No dependencies exist

---
### Objects that \[sys\].\[dm_hadr_availability_replica_states\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.dm_hadr_availability_replica_states AS
    SELECT
        ars.replica_id,
        ars.group_id,
        ars.is_local,
        ars.role,
        ars.role_desc,
        ars.operational_state,
        ars.operational_state_desc,
        ars.connected_state,
        ars.connected_state_desc,
        recovery_health = CASE
            WHEN dbs.database_state_aggr IS NULL THEN NULL
            WHEN ars.configured_database_count &gt; dbs.database_count THEN CAST (0 AS TINYINT)    -- ONLINE_IN_PROGRESS
            WHEN dbs.database_state_aggr = 0 THEN CAST (1 AS TINYINT)                            -- ONLINE
            ELSE CAST (0 AS TINYINT) END,                                                        -- ONLINE_IN_PROGRESS
        recovery_health_desc = CASE
            WHEN dbs.database_state_aggr IS NULL THEN CAST (NULL AS NVARCHAR(60))
            WHEN ars.configured_database_count &gt; dbs.database_count THEN CAST ('ONLINE_IN_PROGRESS' AS NVARCHAR(60))
            WHEN dbs.database_state_aggr = 0 THEN CAST ('ONLINE' AS NVARCHAR(60))
            ELSE CAST ('ONLINE_IN_PROGRESS' AS NVARCHAR(60)) END,
        synchronization_health = CASE
            WHEN dbs.synchronization_health_aggr IS NULL THEN CAST (0 AS TINYINT)                -- NOT_HEALTHY
            WHEN ars.configured_database_count &gt; dbs.database_count THEN CAST (0 AS TINYINT)    -- NOT_HEALTHY (one or more DBs not joined)
            ELSE CAST (dbs.synchronization_health_aggr AS TINYINT) END,
        synchronization_health_desc = CASE
            WHEN dbs.synchronization_health_aggr IS NULL THEN CAST ('NOT_HEALTHY' AS NVARCHAR(60))
            WHEN ars.configured_database_count &gt; dbs.database_count THEN CAST ('NOT_HEALTHY' AS NVARCHAR(60))
            WHEN dbs.synchronization_health_aggr = 2 THEN CAST ('HEALTHY' AS NVARCHAR(60))
            WHEN dbs.synchronization_health_aggr = 1 THEN CAST ('PARTIALLY_HEALTHY' AS NVARCHAR(60))
            ELSE CAST ('NOT_HEALTHY' AS NVARCHAR(60)) END,
        ars.last_connect_error_number,
        ars.last_connect_error_description,
        ars.last_connect_error_timestamp
    FROM
        sys.dm_hadr_internal_availability_replica_states ars
        LEFT OUTER JOIN
        (
            SELECT
                replica_id,
                database_count = COUNT (*),
                synchronization_health_aggr = MIN (synchronization_health),
                database_state_aggr = MAX (database_state)
            FROM
                sys.dm_hadr_database_replica_states
            GROUP BY replica_id
        )
        AS dbs
        ON (ars.real_replica_id = dbs.replica_id)
GO
  
~~~

---
###   See also  
[List of views](../views.md)

