## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[sys\].\[availability_replicas\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **sys.availability_replicas**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[sys\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/4.md) |
| Owner | \[sys\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -774096994 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|replica_id| |uniqueidentifier|16|
|group_id| |uniqueidentifier|16|
|replica_metadata_id| |int|4|
|replica_server_name| |nvarchar|256|
|owner_sid| |varbinary|85|
|endpoint_url| |nvarchar|256|
|availability_mode| |tinyint|1|
|availability_mode_desc| |nvarchar|60|
|failover_mode| |tinyint|1|
|failover_mode_desc| |nvarchar|60|
|session_timeout| |int|4|
|primary_role_allow_connections| |tinyint|1|
|primary_role_allow_connections_desc| |nvarchar|60|
|secondary_role_allow_connections| |tinyint|1|
|secondary_role_allow_connections_desc| |nvarchar|60|
|create_date| |datetime|8|
|modify_date| |datetime|8|
|backup_priority| |int|4|
|read_only_routing_url| |nvarchar|256|
|seeding_mode| |tinyint|1|
|seeding_mode_desc| |nvarchar|60|

Total: 21 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[sys\].\[availability_replicas\]
 No dependencies exist

---
### Objects that \[sys\].\[availability_replicas\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW sys.availability_replicas AS
    SELECT
        replica_id = CASE WHEN mr.replica_id is null THEN wr.ag_replica_id -- show remote replica
            ELSE mr.replica_id END,
        group_id = CASE WHEN mr.replica_id is null THEN wr.ag_id -- show remote group id
            ELSE mr.group_id END,
        replica_metadata_id = mr.internal_group_id,
        replica_server_name = CASE WHEN mr.replica_id is not null and wr.ag_replica_name is null THEN (select @@servername)
            ELSE wr.ag_replica_name END,
        owner_sid = mr.owner_sid,
        endpoint_url = wr.endpoint_url,
        availability_mode = wr.availability_mode,
        availability_mode_desc = CASE
            WHEN (wr.availability_mode = 1) THEN CAST('SYNCHRONOUS_COMMIT' AS nvarchar(60))
            WHEN (wr.availability_mode = 0) THEN CAST('ASYNCHRONOUS_COMMIT' AS nvarchar(60))
            ELSE CAST (NULL as nvarchar(60))
            END,
        failover_mode = wr.failover_mode,
        failover_mode_desc = CASE
            WHEN (wr.failover_mode = 0) THEN CAST('AUTOMATIC' AS nvarchar(60))
            WHEN (wr.failover_mode = 1) THEN CAST('MANUAL' AS nvarchar(60))
            WHEN (wr.failover_mode = 2) THEN CAST('EXTERNAL' AS nvarchar(60))
            ELSE CAST (NULL as nvarchar(60))
            END,
        session_timeout = wr.session_timeout,
        primary_role_allow_connections = wr.primary_role_allow_connections,
        primary_role_allow_connections_desc = wr.primary_role_allow_connections_desc,
        secondary_role_allow_connections = wr.secondary_role_allow_connections,
        secondary_role_allow_connections_desc = wr.secondary_role_allow_connections_desc,
        create_date = mr.create_date,
        modify_date = mr.modify_date,
        backup_priority = wr.backup_priority,
        read_only_routing_url = wr.read_only_routing_url,
        seeding_mode = wr.seeding_mode,
        seeding_mode_desc = CASE
            WHEN (wr.seeding_mode = 1) THEN CAST('MANUAL' AS nvarchar(60))
            WHEN (wr.seeding_mode = 0) THEN CAST('AUTOMATIC' AS nvarchar(60))
            ELSE CAST (NULL as nvarchar(60))
            END
    FROM sys.availability_replicas_internal AS mr
    FULL JOIN sys.dm_hadr_internal_wsfc_ag_replicas AS wr
        ON mr.group_id = wr.ag_id and mr.replica_id = wr.ag_replica_id
GO
  
~~~

---
###   See also  
[List of views](../views.md)

