## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[INFORMATION_SCHEMA\].\[ROUTINE_COLUMNS\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **INFORMATION_SCHEMA.ROUTINE_COLUMNS**

---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[INFORMATION_SCHEMA\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/3.md) |
| Owner | \[INFORMATION_SCHEMA\] |
| Creation date | 10/21/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | -986174672 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|TABLE_CATALOG| |nvarchar|128|
|TABLE_SCHEMA| |nvarchar|128|
|TABLE_NAME| |sysname|128|
|COLUMN_NAME| |sysname|128|
|ORDINAL_POSITION| |int|4|
|COLUMN_DEFAULT| |nvarchar|4000|
|IS_NULLABLE| |varchar|3|
|DATA_TYPE| |nvarchar|128|
|CHARACTER_MAXIMUM_LENGTH| |int|4|
|CHARACTER_OCTET_LENGTH| |int|4|
|NUMERIC_PRECISION| |tinyint|1|
|NUMERIC_PRECISION_RADIX| |smallint|2|
|NUMERIC_SCALE| |int|4|
|DATETIME_PRECISION| |smallint|2|
|CHARACTER_SET_CATALOG| |sysname|128|
|CHARACTER_SET_SCHEMA| |sysname|128|
|CHARACTER_SET_NAME| |sysname|128|
|COLLATION_CATALOG| |sysname|128|
|COLLATION_SCHEMA| |sysname|128|
|COLLATION_NAME| |sysname|128|
|DOMAIN_CATALOG| |sysname|128|
|DOMAIN_SCHEMA| |sysname|128|
|DOMAIN_NAME| |sysname|128|

Total: 23 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[INFORMATION_SCHEMA\].\[ROUTINE_COLUMNS\]
 No dependencies exist

---
### Objects that \[INFORMATION_SCHEMA\].\[ROUTINE_COLUMNS\] depends on
 No dependencies exist

---
### Column level dependencies
 No dependencies exist

---
###  Extended properties  
No extended properties defined

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW INFORMATION_SCHEMA.ROUTINE_COLUMNS
AS
SELECT
    DB_NAME()                        AS TABLE_CATALOG,
    SCHEMA_NAME(o.schema_id)            AS TABLE_SCHEMA,
    o.name                            AS TABLE_NAME,
    c.name                            AS COLUMN_NAME,
    c.column_id                        AS ORDINAL_POSITION,
    convert(nvarchar(4000),
        OBJECT_DEFINITION(c.default_object_id))            AS COLUMN_DEFAULT,
    convert(varchar(3),
        CASE WHEN c.is_nullable = 1 THEN 'YES'
        ELSE 'NO' END)                AS IS_NULLABLE,
    ISNULL(TYPE_NAME(c.system_type_id), t.name)        AS DATA_TYPE,
    COLUMNPROPERTY(c.object_id, c.name, 'charmaxlen')    AS CHARACTER_MAXIMUM_LENGTH,
    COLUMNPROPERTY(c.object_id, c.name, 'octetmaxlen')    AS CHARACTER_OCTET_LENGTH,
    convert(tinyint, CASE -- int/decimal/numeric/real/float/money
        WHEN c.system_type_id IN (48, 52, 56, 59, 60, 62, 106, 108, 122, 127) THEN c.precision
        END)                                        AS NUMERIC_PRECISION,
    convert(smallint, CASE    -- int/money/decimal/numeric
        WHEN c.system_type_id IN (48, 52, 56, 60, 106, 108, 122, 127) THEN 10
        WHEN c.system_type_id IN (59, 62) THEN 2 END)    AS NUMERIC_PRECISION_RADIX, -- real/float
    convert(int, CASE    -- datetime/smalldatetime
        WHEN c.system_type_id IN (40, 41, 42, 43, 58, 61) THEN NULL
        ELSE ODBCSCALE(c.system_type_id, c.scale) END)    AS NUMERIC_SCALE,
    convert(smallint, CASE -- datetime/smalldatetime
        WHEN c.system_type_id IN (40, 41, 42, 43, 58, 61) THEN ODBCSCALE(c.system_type_id, c.scale) END)    AS DATETIME_PRECISION,
    convert( sysname, null)                    AS CHARACTER_SET_CATALOG,
    convert( sysname, null) collate catalog_default            AS CHARACTER_SET_SCHEMA,
    convert( sysname, CASE
        WHEN c.system_type_id IN (35, 167, 175)    -- char/varchar/text
        THEN COLLATIONPROPERTY(c.collation_name, 'sqlcharsetname')
        WHEN c.system_type_id IN (99, 231, 239)    -- nchar/nvarchar/ntext
        THEN N'UNICODE'    END)                AS CHARACTER_SET_NAME,
    convert(sysname, null)                    AS COLLATION_CATALOG,
    convert(sysname, null) collate catalog_default        AS COLLATION_SCHEMA,
    c.collation_name                    AS COLLATION_NAME,
    convert(sysname,
        CASE WHEN c.user_type_id &gt; 256
        THEN DB_NAME() END)                AS DOMAIN_CATALOG,
    convert(sysname,
        CASE WHEN c.user_type_id &gt; 256 THEN
        SCHEMA_NAME(t.schema_id) END)            AS DOMAIN_SCHEMA,
    convert(sysname,
        CASE WHEN c.user_type_id &gt; 256 THEN
        TYPE_NAME(c.user_type_id) END)            AS DOMAIN_NAME
FROM
    sys.objects o JOIN sys.columns c ON c.object_id = o.object_id
    LEFT JOIN sys.types t ON c.user_type_id = t.user_type_id
WHERE
    o.type IN ('TF','IF', 'FT')
GO
  
~~~

---
###   See also  
[List of views](../views.md)

