## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[Person\].\[vAdditionalContactInfo\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **Person.vAdditionalContactInfo**

---
###  Description  
 Displays the contact name and content from each element in the xml column AdditionalContactInfo for that person. 



---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/6.md) |
| Owner | [\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md) |
| Creation date | 11/16/2015 |
| Is schema bound |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | 1021246693 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|BusinessEntityID| |int|4|
|FirstName| |[\[dbo\].\[Name\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/260.md)|50|
|MiddleName| |[\[dbo\].\[Name\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/260.md)|50|
|LastName| |[\[dbo\].\[Name\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/260.md)|50|
|TelephoneNumber| |nvarchar|50|
|TelephoneSpecialInstructions| |nvarchar|1073741823|
|Street| |nvarchar|50|
|City| |nvarchar|50|
|StateProvince| |nvarchar|50|
|PostalCode| |nvarchar|50|
|CountryRegion| |nvarchar|50|
|HomeAddressSpecialInstructions| |nvarchar|1073741823|
|EMailAddress| |nvarchar|128|
|EMailSpecialInstructions| |nvarchar|1073741823|
|EMailTelephoneNumber| |nvarchar|50|
|rowguid| |uniqueidentifier|16|
|ModifiedDate| |datetime|8|

Total: 17 column(s)

---
###   Indexes  
No indexes exist

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[Person\].\[vAdditionalContactInfo\]
 No dependencies exist

---
### Objects that \[Person\].\[vAdditionalContactInfo\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/6.md)|Schema|1|
|[\[Person\].\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|Table|1|

 Total 2 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[Person\].\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|AdditionalContactInfo|Table|
|[\[Person\].\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|BusinessEntityID|Table|
|[\[Person\].\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|FirstName|Table|
|[\[Person\].\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|MiddleName|Table|
|[\[Person\].\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|LastName|Table|
|[\[Person\].\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|rowguid|Table|
|[\[Person\].\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|ModifiedDate|Table|

 Total 7 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1021246693_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Displays the contact name and content from each element in the xml column AdditionalContactInfo for that person.|

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO

CREATE VIEW [Person].[vAdditionalContactInfo] 
AS 
SELECT 
    [BusinessEntityID] 
    ,[FirstName]
    ,[MiddleName]
    ,[LastName]
    ,[ContactInfo].ref.value(N'declare namespace ci="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ContactInfo"; 
        declare namespace act="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ContactTypes"; 
        (act:telephoneNumber)[1]/act:number', 'nvarchar(50)') AS [TelephoneNumber] 
    ,LTRIM(RTRIM([ContactInfo].ref.value(N'declare namespace ci="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ContactInfo"; 
        declare namespace act="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ContactTypes"; 
        (act:telephoneNumber/act:SpecialInstructions/text())[1]', 'nvarchar(max)'))) AS [TelephoneSpecialInstructions] 
    ,[ContactInfo].ref.value(N'declare namespace ci="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ContactInfo"; 
        declare namespace act="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ContactTypes";
        (act:homePostalAddress/act:Street)[1]', 'nvarchar(50)') AS [Street] 
    ,[ContactInfo].ref.value(N'declare namespace ci="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ContactInfo"; 
        declare namespace act="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ContactTypes"; 
        (act:homePostalAddress/act:City)[1]', 'nvarchar(50)') AS [City] 
    ,[ContactInfo].ref.value(N'declare namespace ci="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ContactInfo"; 
        declare namespace act="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ContactTypes"; 
        (act:homePostalAddress/act:StateProvince)[1]', 'nvarchar(50)') AS [StateProvince] 
    ,[ContactInfo].ref.value(N'declare namespace ci="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ContactInfo"; 
        declare namespace act="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ContactTypes"; 
        (act:homePostalAddress/act:PostalCode)[1]', 'nvarchar(50)') AS [PostalCode] 
    ,[ContactInfo].ref.value(N'declare namespace ci="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ContactInfo"; 
        declare namespace act="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ContactTypes"; 
        (act:homePostalAddress/act:CountryRegion)[1]', 'nvarchar(50)') AS [CountryRegion] 
    ,[ContactInfo].ref.value(N'declare namespace ci="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ContactInfo"; 
        declare namespace act="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ContactTypes"; 
        (act:homePostalAddress/act:SpecialInstructions/text())[1]', 'nvarchar(max)') AS [HomeAddressSpecialInstructions] 
    ,[ContactInfo].ref.value(N'declare namespace ci="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ContactInfo"; 
        declare namespace act="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ContactTypes"; 
        (act:eMail/act:eMailAddress)[1]', 'nvarchar(128)') AS [EMailAddress] 
    ,LTRIM(RTRIM([ContactInfo].ref.value(N'declare namespace ci="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ContactInfo"; 
        declare namespace act="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ContactTypes"; 
        (act:eMail/act:SpecialInstructions/text())[1]', 'nvarchar(max)'))) AS [EMailSpecialInstructions] 
    ,[ContactInfo].ref.value(N'declare namespace ci="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ContactInfo"; 
        declare namespace act="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ContactTypes"; 
        (act:eMail/act:SpecialInstructions/act:telephoneNumber/act:number)[1]', 'nvarchar(50)') AS [EMailTelephoneNumber] 
    ,[rowguid] 
    ,[ModifiedDate]
FROM [Person].[Person]
OUTER APPLY [AdditionalContactInfo].nodes(
    'declare namespace ci="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ContactInfo"; 
    /ci:AdditionalContactInfo') AS ContactInfo(ref) 
WHERE [AdditionalContactInfo] IS NOT NULL;
GO
EXEC sp_addextendedproperty N'MS_Description', N'Displays the contact name and content from each element in the xml column AdditionalContactInfo for that person.', 'SCHEMA', N'Person', 'VIEW', N'vAdditionalContactInfo', NULL, NULL
GO
  
~~~

---
###   See also  
[List of views](../views.md)

