## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[Production\].\[vProductAndDescription\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **Production.vProductAndDescription**

---
###  Description  
 Product names and descriptions. Product descriptions are provided in multiple languages. 



---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[Production\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/7.md) |
| Owner | [\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md) |
| Creation date | 11/16/2015 |
| Is schema bound |![](../../../../ImagesMetro/CHECK_OUT.png "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | 1165247206 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|ProductID| |int|4|
|Name| |[\[dbo\].\[Name\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/260.md)|50|
|ProductModel| |[\[dbo\].\[Name\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/260.md)|50|
|CultureID| |nchar|6|
|Description| |nvarchar|400|

Total: 5 column(s)

---
###   Indexes  
|Index |Description |Primary |Unique |Size KB |
|-|-|-|-|-|
|[\[IX_vProductAndDescription\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/Indexes/1165247206_IX_vProductAndDescription.md)|Clustered index on the view vProductAndDescription.|CultureID, ProductID|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|576|0|

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[Production\].\[vProductAndDescription\]
 No dependencies exist

---
### Objects that \[Production\].\[vProductAndDescription\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Production\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/7.md)|Schema|1|
|[\[Production\].\[Product\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/146099561.md)|Table|1|
|[\[Production\].\[ProductDescription\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/498100815.md)|Table|1|
|[\[Production\].\[ProductModel\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/738101670.md)|Table|1|
|[\[Production\].\[ProductModelProductDescriptionCulture\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/818101955.md)|Table|1|

 Total 5 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[Production\].\[Product\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/146099561.md)|ProductModelID|Table|
|[\[Production\].\[Product\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/146099561.md)|ProductID|Table|
|[\[Production\].\[Product\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/146099561.md)|Name|Table|
|[\[Production\].\[ProductModel\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/738101670.md)|ProductModelID|Table|
|[\[Production\].\[ProductModel\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/738101670.md)|Name|Table|
|[\[Production\].\[ProductModelProductDescriptionCulture\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/818101955.md)|ProductModelID|Table|
|[\[Production\].\[ProductModelProductDescriptionCulture\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/818101955.md)|ProductDescriptionID|Table|
|[\[Production\].\[ProductModelProductDescriptionCulture\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/818101955.md)|CultureID|Table|
|[\[Production\].\[ProductDescription\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/498100815.md)|ProductDescriptionID|Table|
|[\[Production\].\[ProductDescription\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/498100815.md)|Description|Table|

 Total 10 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1165247206_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Product names and descriptions. Product descriptions are provided in multiple languages.|

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO

CREATE VIEW [Production].[vProductAndDescription] 
WITH SCHEMABINDING 
AS 
-- View (indexed or standard) to display products and product descriptions by language.
SELECT 
    p.[ProductID] 
    ,p.[Name] 
    ,pm.[Name] AS [ProductModel] 
    ,pmx.[CultureID] 
    ,pd.[Description] 
FROM [Production].[Product] p 
    INNER JOIN [Production].[ProductModel] pm 
    ON p.[ProductModelID] = pm.[ProductModelID] 
    INNER JOIN [Production].[ProductModelProductDescriptionCulture] pmx 
    ON pm.[ProductModelID] = pmx.[ProductModelID] 
    INNER JOIN [Production].[ProductDescription] pd 
    ON pmx.[ProductDescriptionID] = pd.[ProductDescriptionID];
GO
EXEC sp_addextendedproperty N'MS_Description', N'Product names and descriptions. Product descriptions are provided in multiple languages.', 'SCHEMA', N'Production', 'VIEW', N'vProductAndDescription', NULL, NULL
GO
SET ANSI_PADDING ON
GO
CREATE UNIQUE CLUSTERED INDEX [IX_vProductAndDescription]
    ON [Production].[vProductAndDescription] ([CultureID], [ProductID])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Clustered index on the view vProductAndDescription.', 'SCHEMA', N'Production', 'VIEW', N'vProductAndDescription', 'INDEX', N'IX_vProductAndDescription'
GO
  
~~~

---
###   See also  
[List of views](../views.md)

