## ![](../../../../Images32x32Metro/OBJECT_VIEW.png "")     View:  \[AdventureWorks2016CTP3\].\[Person\].\[vStateProvinceCountryRegion\]  
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [Views](../../../../DbEngine/(local)/AdventureWorks2016CTP3/views.md) > **Person.vStateProvinceCountryRegion**

---
###  Description  
 Joins StateProvince table with CountryRegion table. 



---
###   View properties  
|Name |Value |
|-|-|
| Schema | [\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/6.md) |
| Owner | [\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md) |
| Creation date | 11/16/2015 |
| Is schema bound |![](../../../../ImagesMetro/CHECK_OUT.png "")|
| Encrypted |![](../../../../ImagesMetro/RED_CROSS.gif "")|
| ID | 1245247491 |

---
###   Creation options  
|Name|Value|
|-|-|
|QUOTED_IDENTIFIER|ON|
|ANSI_NULLS|ON|

---
###   Resultset  
|Name |Description|Data type|Max length|
|-|-|-|-|
|StateProvinceID| |int|4|
|StateProvinceCode| |nchar|3|
|IsOnlyStateProvinceFlag| |[\[dbo\].\[Flag\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/258.md)|1|
|StateProvinceName| |[\[dbo\].\[Name\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/260.md)|50|
|TerritoryID| |int|4|
|CountryRegionCode| |nvarchar|3|
|CountryRegionName| |[\[dbo\].\[Name\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Datatypes/260.md)|50|

Total: 7 column(s)

---
###   Indexes  
|Index |Description |Primary |Unique |Size KB |
|-|-|-|-|-|
|[\[IX_vStateProvinceCountryRegion\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/Indexes/1245247491_IX_vStateProvinceCountryRegion.md)|Clustered index on the view vStateProvinceCountryRegion.|StateProvinceID, CountryRegionCode|![](../../../../ImagesMetro/RED_CROSS.gif "")|![](../../../../ImagesMetro/CHECK_OUT.png "")|32|0|

---
###   Statistics  
No statistics exist

---
###   Triggers  
No triggers exist

---
### Objects that depend on \[Person\].\[vStateProvinceCountryRegion\]
 No dependencies exist

---
### Objects that \[Person\].\[vStateProvinceCountryRegion\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/6.md)|Schema|1|
|[\[Person\].\[CountryRegion\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1157579162.md)|Table|1|
|[\[Person\].\[StateProvince\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/782625831.md)|Table|1|

 Total 3 object(s)

---
### Column level dependencies
|Object name|Column|Object type|
|-|-|-|
|[\[Person\].\[StateProvince\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/782625831.md)|CountryRegionCode|Table|
|[\[Person\].\[StateProvince\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/782625831.md)|StateProvinceID|Table|
|[\[Person\].\[StateProvince\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/782625831.md)|StateProvinceCode|Table|
|[\[Person\].\[StateProvince\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/782625831.md)|IsOnlyStateProvinceFlag|Table|
|[\[Person\].\[StateProvince\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/782625831.md)|Name|Table|
|[\[Person\].\[StateProvince\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/782625831.md)|TerritoryID|Table|
|[\[Person\].\[CountryRegion\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1157579162.md)|CountryRegionCode|Table|
|[\[Person\].\[CountryRegion\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1157579162.md)|Name|Table|

 Total 8 column(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Views/1245247491_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Joins StateProvince table with CountryRegion table.|

---
###  Permissions
No permissions defined

---
###   SQL  
~~~SQL
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO

CREATE VIEW [Person].[vStateProvinceCountryRegion] 
WITH SCHEMABINDING 
AS 
SELECT 
    sp.[StateProvinceID] 
    ,sp.[StateProvinceCode] 
    ,sp.[IsOnlyStateProvinceFlag] 
    ,sp.[Name] AS [StateProvinceName] 
    ,sp.[TerritoryID] 
    ,cr.[CountryRegionCode] 
    ,cr.[Name] AS [CountryRegionName]
FROM [Person].[StateProvince] sp 
    INNER JOIN [Person].[CountryRegion] cr 
    ON sp.[CountryRegionCode] = cr.[CountryRegionCode];
GO
EXEC sp_addextendedproperty N'MS_Description', N'Joins StateProvince table with CountryRegion table.', 'SCHEMA', N'Person', 'VIEW', N'vStateProvinceCountryRegion', NULL, NULL
GO
SET ANSI_PADDING ON
GO
CREATE UNIQUE CLUSTERED INDEX [IX_vStateProvinceCountryRegion]
    ON [Person].[vStateProvinceCountryRegion] ([StateProvinceID], [CountryRegionCode])
    ON [PRIMARY]
GO
EXEC sp_addextendedproperty N'MS_Description', N'Clustered index on the view vStateProvinceCountryRegion.', 'SCHEMA', N'Person', 'VIEW', N'vStateProvinceCountryRegion', 'INDEX', N'IX_vStateProvinceCountryRegion'
GO
  
~~~

---
###   See also  
[List of views](../views.md)

