## ![](../../../../Images32x32Metro/OBJECT_XML_SCHEMA_COLLECTION.png "") XML schema collection:\[AdventureWorks2016CTP3\].\[Person\].\[IndividualSurveySchemaCollection\]
[Table of contents](../../../../index.md) > [Database engines](../../../../srv_index.md) > [(local)](../../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > [XML schema collections](../../../../DbEngine/(local)/AdventureWorks2016CTP3/XmlSchemaCollections.md) > **Person.IndividualSurveySchemaCollection**

---
###  Description  
 Collection of XML schemas for the Demographics column in the Person.Person table. 



---
### XML schema collection properties
|Name |Value |
|-|-|
| Schema | [\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/6.md) |
| Owner | [\[dbo\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Users/1.md) |
| ID | 65537 |

---
### Objects that depend on \[Person\].\[IndividualSurveySchemaCollection\]
|Object name|Object type|Dep level|
|-|-|-|
|[\[Person\].\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|Table|1|

 Total 1 object(s)

---
### Objects that \[Person\].\[IndividualSurveySchemaCollection\] depends on
|Object name|Object type|Dep level|
|-|-|-|
|[\[Person\]](../../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/6.md)|Schema|1|

 Total 1 object(s)

---
### Graphical dependencies
Click [here](../../../../DbEngine/(local)/AdventureWorks2016CTP3/XMLSchemaCollections/65537_gr.md) to view dependencies graphically

---
###  Extended properties  
|Name |Value |
|-|-|
|MS_Description|Collection of XML schemas for the Demographics column in the Person.Person table.|

---
###  Permissions
No permissions defined

---
### SQL
~~~SQL
CREATE XML SCHEMA COLLECTION [Person].[IndividualSurveySchemaCollection] AS
N'&lt;xsd:schema xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:t="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/IndividualSurvey" targetNamespace="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/IndividualSurvey" elementFormDefault="qualified"&gt;
  &lt;xsd:element name="IndividualSurvey"&gt;
    &lt;xsd:complexType&gt;
      &lt;xsd:complexContent&gt;
        &lt;xsd:restriction base="xsd:anyType"&gt;
          &lt;xsd:sequence&gt;
            &lt;xsd:element name="TotalPurchaseYTD" type="xsd:decimal" minOccurs="0" /&gt;
            &lt;xsd:element name="DateFirstPurchase" type="xsd:date" minOccurs="0" /&gt;
            &lt;xsd:element name="BirthDate" type="xsd:date" minOccurs="0" /&gt;
            &lt;xsd:element name="MaritalStatus" type="xsd:string" minOccurs="0" /&gt;
            &lt;xsd:element name="YearlyIncome" type="t:SalaryType" minOccurs="0" /&gt;
            &lt;xsd:element name="Gender" type="xsd:string" minOccurs="0" /&gt;
            &lt;xsd:element name="TotalChildren" type="xsd:int" minOccurs="0" /&gt;
            &lt;xsd:element name="NumberChildrenAtHome" type="xsd:int" minOccurs="0" /&gt;
            &lt;xsd:element name="Education" type="xsd:string" minOccurs="0" /&gt;
            &lt;xsd:element name="Occupation" type="xsd:string" minOccurs="0" /&gt;
            &lt;xsd:element name="HomeOwnerFlag" type="xsd:string" minOccurs="0" /&gt;
            &lt;xsd:element name="NumberCarsOwned" type="xsd:int" minOccurs="0" /&gt;
            &lt;xsd:element name="Hobby" type="xsd:string" minOccurs="0" maxOccurs="unbounded" /&gt;
            &lt;xsd:element name="CommuteDistance" type="t:MileRangeType" minOccurs="0" /&gt;
            &lt;xsd:element name="Comments" type="xsd:string" minOccurs="0" /&gt;
          &lt;/xsd:sequence&gt;
        &lt;/xsd:restriction&gt;
      &lt;/xsd:complexContent&gt;
    &lt;/xsd:complexType&gt;
  &lt;/xsd:element&gt;
  &lt;xsd:simpleType name="MileRangeType"&gt;
    &lt;xsd:restriction base="xsd:string"&gt;
      &lt;xsd:enumeration value="0-1 Miles" /&gt;
      &lt;xsd:enumeration value="1-2 Miles" /&gt;
      &lt;xsd:enumeration value="2-5 Miles" /&gt;
      &lt;xsd:enumeration value="5-10 Miles" /&gt;
      &lt;xsd:enumeration value="10+ Miles" /&gt;
    &lt;/xsd:restriction&gt;
  &lt;/xsd:simpleType&gt;
  &lt;xsd:simpleType name="SalaryType"&gt;
    &lt;xsd:restriction base="xsd:string"&gt;
      &lt;xsd:enumeration value="0-25000" /&gt;
      &lt;xsd:enumeration value="25001-50000" /&gt;
      &lt;xsd:enumeration value="50001-75000" /&gt;
      &lt;xsd:enumeration value="75001-100000" /&gt;
      &lt;xsd:enumeration value="greater than 100000" /&gt;
    &lt;/xsd:restriction&gt;
  &lt;/xsd:simpleType&gt;
&lt;/xsd:schema&gt;'
GO
EXEC sp_addextendedproperty N'MS_Description', N'Collection of XML schemas for the Demographics column in the Person.Person table.', 'SCHEMA', N'Person', 'XML SCHEMA COLLECTION', N'IndividualSurveySchemaCollection', NULL, NULL
GO
  
~~~

---
### See also
[List of XML schema collections](../XmlSchemaCollections.md)

