## ![](../../../Images32x32Metro/OBJECT_TRIGGER.png "")  List of triggers
[Table of contents](../../../index.md) > [Database engines](../../../srv_index.md) > [(local)](../../../DbEngine/(local)/db_index.md) > [AdventureWorks2016CTP3](../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index.md) > [Objects by type](../../../DbEngine/(local)/AdventureWorks2016CTP3/db_object_index_type_Objects%20by%20type.md) > **Triggers**

---
### Triggers
|Name |Schema |Description|Instead of |For insert|For update|For delete|Table/view|
|-|-|-|-|-|-|-|-|
|[\[dEmployee\]](../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/861246123.md)|[HumanResources](../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/5.md)|INSTEAD OF DELETE trigger which keeps Employees from being deleted.|![](../../../ImagesMetro/CHECK_OUT.png "")| | |![For Delete](../../../ImagesMetro/AUDIT_trigger_delete.gif "")|[\[HumanResources\].\[Employee\]](../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|
|[\[iuPerson\]](../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/877246180.md)|[Person](../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/6.md)|AFTER INSERT, UPDATE trigger inserting Individual only if the Customer does not exist in the Store table and setting the ModifiedDate column in the Person table to the current date.|![](../../../ImagesMetro/RED_CROSS.gif "")|![For Insert](../../../ImagesMetro/AUDIT_trigger_insert.gif "")|![For Update](../../../ImagesMetro/AUDIT_trigger_update.gif "")| |[\[Person\].\[Person\]](../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|
|[\[iWorkOrder\]](../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/989246579.md)|[Production](../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/7.md)|AFTER INSERT trigger that inserts a row in the TransactionHistory table.|![](../../../ImagesMetro/RED_CROSS.gif "")|![For Insert](../../../ImagesMetro/AUDIT_trigger_insert.gif "")| | |[\[Production\].\[WorkOrder\]](../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1166627199.md)|
|[\[uWorkOrder\]](../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/1005246636.md)|[Production](../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/7.md)|AFTER UPDATE trigger that inserts a row in the TransactionHistory table, updates ModifiedDate in the WorkOrder table.|![](../../../ImagesMetro/RED_CROSS.gif "")| |![For Update](../../../ImagesMetro/AUDIT_trigger_update.gif "")| |[\[Production\].\[WorkOrder\]](../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1166627199.md)|
|[\[dVendor\]](../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/973246522.md)|[Purchasing](../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/8.md)|INSTEAD OF DELETE trigger which keeps Vendors from being deleted.|![](../../../ImagesMetro/CHECK_OUT.png "")| | |![For Delete](../../../ImagesMetro/AUDIT_trigger_delete.gif "")|[\[Purchasing\].\[Vendor\]](../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1086626914.md)|
|[\[iPurchaseOrderDetail\]](../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/893246237.md)|[Purchasing](../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/8.md)|AFTER INSERT trigger that inserts a row in the TransactionHistory table and updates the PurchaseOrderHeader.SubTotal column.|![](../../../ImagesMetro/RED_CROSS.gif "")|![For Insert](../../../ImagesMetro/AUDIT_trigger_insert.gif "")| | |[\[Purchasing\].\[PurchaseOrderDetail\]](../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1170103209.md)|
|[\[uPurchaseOrderDetail\]](../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/909246294.md)|[Purchasing](../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/8.md)|AFTER UPDATE trigger that inserts a row in the TransactionHistory table, updates ModifiedDate in PurchaseOrderDetail and updates the PurchaseOrderHeader.SubTotal column.|![](../../../ImagesMetro/RED_CROSS.gif "")| |![For Update](../../../ImagesMetro/AUDIT_trigger_update.gif "")| |[\[Purchasing\].\[PurchaseOrderDetail\]](../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1170103209.md)|
|[\[uPurchaseOrderHeader\]](../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/925246351.md)|[Purchasing](../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/8.md)|AFTER UPDATE trigger that updates the RevisionNumber and ModifiedDate columns in the PurchaseOrderHeader table.|![](../../../ImagesMetro/RED_CROSS.gif "")| |![For Update](../../../ImagesMetro/AUDIT_trigger_update.gif "")| |[\[Purchasing\].\[PurchaseOrderHeader\]](../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1266103551.md)|
|[\[iduSalesOrderDetail\]](../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/941246408.md)|[Sales](../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md)|AFTER INSERT, DELETE, UPDATE trigger that inserts a row in the TransactionHistory table, updates ModifiedDate in SalesOrderDetail and updates the SalesOrderHeader.SubTotal column.|![](../../../ImagesMetro/RED_CROSS.gif "")|![For Insert](../../../ImagesMetro/AUDIT_trigger_insert.gif "")|![For Update](../../../ImagesMetro/AUDIT_trigger_update.gif "")|![For Delete](../../../ImagesMetro/AUDIT_trigger_delete.gif "")|[\[Sales\].\[SalesOrderDetail\]](../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1474104292.md)|
|[\[uSalesOrderHeader\]](../../../DbEngine/(local)/AdventureWorks2016CTP3/Triggers/957246465.md)|[Sales](../../../DbEngine/(local)/AdventureWorks2016CTP3/Schemas/9.md)|AFTER UPDATE trigger that updates the RevisionNumber and ModifiedDate columns in the SalesOrderHeader table.Updates the SalesYTD column in the SalesPerson and SalesTerritory tables.|![](../../../ImagesMetro/RED_CROSS.gif "")| |![For Update](../../../ImagesMetro/AUDIT_trigger_update.gif "")| |[\[Sales\].\[SalesOrderHeader\]](../../../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1586104691.md)|

 Total: 10  trigger(s)

---
### See also
[Tables](tables.md)

[Views](views.md)

[Database overview](dboverview.md)

