## Usage ofBusinessEntityID
[Table of contents](../index.md) > [Dictionary](../Glossary/glossary_index.md) > **BusinessEntityID**

---
### BusinessEntityID
|Object name |Description |Data type |Length |Parent object type|Type|
|-|-|-|-|-|-|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Person\].\[BusinessEntityAddress\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/997578592.md)|Primary key. Foreign key to BusinessEntity.BusinessEntityID.|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Person\].\[BusinessEntity\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/949578421.md)|Primary key for all customers, vendors, and employees.|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Person\].\[BusinessEntityContact\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1045578763.md)|Primary key. Foreign key to BusinessEntity.BusinessEntityID.|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Person\].\[EmailAddress\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1509580416.md)|Primary key. Person associated with this email address.  Foreign key to Person.BusinessEntityID|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[HumanResources\].\[Employee_Temporal_History\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1902629821.md)| |int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[HumanResources\].\[Employee_Temporal\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1870629707.md)| |int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[HumanResources\].\[Employee\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1557580587.md)|Primary key for Employee records.  Foreign key to BusinessEntity.BusinessEntityID.|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[HumanResources\].\[EmployeeDepartmentHistory\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1765581328.md)|Employee identification number. Foreign key to Employee.BusinessEntityID.|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[HumanResources\].\[EmployeePayHistory\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1813581499.md)|Employee identification number. Foreign key to Employee.BusinessEntityID.|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[HumanResources\].\[JobCandidate\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1909581841.md)|Employee identification number if applicant was hired. Foreign key to Employee.BusinessEntityID.|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Person\].\[Password\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2037582297.md)| |int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Person\].\[Person_Temporal_History\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1854629650.md)| |int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Person\].\[Person_Temporal\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1822629536.md)| |int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Person\].\[Person\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2085582468.md)|Primary key for Person records.|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Sales\].\[PersonCreditCard\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/50099219.md)|Business entity identification number. Foreign key to Person.BusinessEntityID.|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Person\].\[PersonPhone\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/82099333.md)|Business entity identification number. Foreign key to Person.BusinessEntityID.|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Purchasing\].\[ProductVendor\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1042102753.md)|Primary key. Foreign key to Vendor.BusinessEntityID.|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Sales\].\[SalesPerson\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1874105717.md)|Primary key for SalesPerson records. Foreign key to Employee.BusinessEntityID|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Sales\].\[SalesPersonQuotaHistory\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2066106401.md)|Sales person identification number. Foreign key to SalesPerson.BusinessEntityID.|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Sales\].\[SalesTerritoryHistory\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/270624007.md)|Primary key. The sales rep.  Foreign key to SalesPerson.BusinessEntityID.|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Person\].\[sp_DeletePerson_Temporal\]](../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1950629992.md)| |int|4|Procedure|Parameter|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[HumanResources\].\[sp_UpdateEmployee_Temporal\]](../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1966630049.md)| |int|4|Procedure|Parameter|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Person\].\[sp_UpdatePerson_Temporal\]](../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1934629935.md)| |int|4|Procedure|Parameter|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Sales\].\[Store\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/846626059.md)|Primary key. Foreign key to Customer.BusinessEntityID.|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[dbo\].\[uspGetEmployeeManagers\]](../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1517248460.md)|Input parameter for the stored procedure uspGetEmployeeManagers. Enter a valid BusinessEntityID from the HumanResources.Employee table.|int|4|Procedure|Parameter|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[dbo\].\[uspGetManagerEmployees\]](../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1533248517.md)|Input parameter for the stored procedure uspGetManagerEmployees. Enter a valid BusinessEntityID of the manager from the HumanResources.Employee table.|int|4|Procedure|Parameter|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[HumanResources\].\[uspUpdateEmployeeHireInfo\]](../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1565248631.md)|Input parameter for the stored procedure uspUpdateEmployeeHireInfo. Enter a valid BusinessEntityID from the Employee table.|int|4|Procedure|Parameter|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[HumanResources\].\[uspUpdateEmployeeLogin\]](../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1581248688.md)|Input parameter for the stored procedure uspUpdateEmployeeLogin. Enter a valid EmployeeID from the Employee table.|int|4|Procedure|Parameter|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[HumanResources\].\[uspUpdateEmployeePersonalInfo\]](../DbEngine/(local)/AdventureWorks2016CTP3/Procedures/1597248745.md)|Input parameter for the stored procedure uspUpdateEmployeePersonalInfo. Enter a valid BusinessEntityID from the HumanResources.Employee table.|int|4|Procedure|Parameter|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Person\].\[vAdditionalContactInfo\]](../DbEngine/(local)/AdventureWorks2016CTP3/Views/1021246693.md)| |int|4|View|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[HumanResources\].\[vEmployee\]](../DbEngine/(local)/AdventureWorks2016CTP3/Views/1037246750.md)| |int|4|View|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[HumanResources\].\[vEmployeeDepartment\]](../DbEngine/(local)/AdventureWorks2016CTP3/Views/1053246807.md)| |int|4|View|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[HumanResources\].\[vEmployeeDepartmentHistory\]](../DbEngine/(local)/AdventureWorks2016CTP3/Views/1069246864.md)| |int|4|View|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[HumanResources\].\[vEmployeePersonTemporalInfo\]](../DbEngine/(local)/AdventureWorks2016CTP3/Views/1918629878.md)| |int|4|View|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Purchasing\].\[Vendor\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1086626914.md)|Primary key for Vendor records.  Foreign key to BusinessEntity.BusinessEntityID|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Sales\].\[vIndividualCustomer\]](../DbEngine/(local)/AdventureWorks2016CTP3/Views/1085246921.md)| |int|4|View|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[HumanResources\].\[vJobCandidate\]](../DbEngine/(local)/AdventureWorks2016CTP3/Views/1117247035.md)| |int|4|View|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Sales\].\[vPersonDemographics\]](../DbEngine/(local)/AdventureWorks2016CTP3/Views/1101246978.md)| |int|4|View|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Sales\].\[vSalesPerson\]](../DbEngine/(local)/AdventureWorks2016CTP3/Views/1213247377.md)| |int|4|View|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Sales\].\[vStoreWithAddresses\]](../DbEngine/(local)/AdventureWorks2016CTP3/Views/1293247662.md)| |int|4|View|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Sales\].\[vStoreWithContacts\]](../DbEngine/(local)/AdventureWorks2016CTP3/Views/1277247605.md)| |int|4|View|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Sales\].\[vStoreWithDemographics\]](../DbEngine/(local)/AdventureWorks2016CTP3/Views/1261247548.md)| |int|4|View|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Purchasing\].\[vVendorWithAddresses\]](../DbEngine/(local)/AdventureWorks2016CTP3/Views/1325247776.md)| |int|4|View|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Purchasing\].\[vVendorWithContacts\]](../DbEngine/(local)/AdventureWorks2016CTP3/Views/1309247719.md)| |int|4|View|Column|

 Total: 44 objects

---
### See also
[Server index](../srv_index.md)

