## Usage ofProductID
[Table of contents](../index.md) > [Dictionary](../Glossary/glossary_index.md) > **ProductID**

---
### ProductID
|Object name |Description |Data type |Length |Parent object type|Type|
|-|-|-|-|-|-|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Demo\].\[DemoSalesOrderDetailSeed\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1556200594.md)| |int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Production\].\[Product_inmem\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/2039678314.md)| |int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Production\].\[Product_ondisk\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/772197801.md)| |int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Production\].\[Product\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/146099561.md)|Primary key for Product records.|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Production\].\[ProductCostHistory\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/434100587.md)|Product identification number. Foreign key to Product.ProductID|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Production\].\[ProductDocument\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/546100986.md)|Product identification number. Foreign key to Product.ProductID.|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Production\].\[ProductInventory\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/578101100.md)|Product identification number. Foreign key to Product.ProductID.|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Production\].\[ProductListPriceHistory\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/674101442.md)|Product identification number. Foreign key to Product.ProductID|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Production\].\[ProductProductPhoto\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/882102183.md)|Product identification number. Foreign key to Product.ProductID.|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Production\].\[ProductReview\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/930102354.md)|Product identification number. Foreign key to Product.ProductID.|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Purchasing\].\[ProductVendor\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1042102753.md)|Primary key. Foreign key to Product.ProductID.|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Purchasing\].\[PurchaseOrderDetail\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1170103209.md)|Product identification number. Foreign key to Product.ProductID.|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Sales\].\[SalesOrderDetail_inmem\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/468196718.md)| |int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Sales\].\[SalesOrderDetail_ondisk\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1332199796.md)| |int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Sales\].\[SalesOrderDetail\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1474104292.md)|Product sold to customer. Foreign key to Product.ProductID.|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Sales\].\[ShoppingCartItem\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/510624862.md)|Product ordered. Foreign key to Product.ProductID.|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Sales\].\[SpecialOfferProduct_inmem\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/132195521.md)| |int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Sales\].\[SpecialOfferProduct_ondisk\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1012198656.md)| |int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Sales\].\[SpecialOfferProduct\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/734625660.md)|Product identification number. Foreign key to Product.ProductID.|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Production\].\[TransactionHistory\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/894626230.md)|Product identification number. Foreign key to Product.ProductID.|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Production\].\[TransactionHistoryArchive\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/974626515.md)|Product identification number. Foreign key to Product.ProductID.|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[dbo\].\[ufnGetProductDealerPrice\]](../DbEngine/(local)/AdventureWorks2016CTP3/Functions/1389248004.md)|Input parameter for the scalar function ufnGetProductDealerPrice. Enter a valid ProductID from the Production.Product table.|int|4|Function|Parameter|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[dbo\].\[ufnGetProductListPrice\]](../DbEngine/(local)/AdventureWorks2016CTP3/Functions/1405248061.md)|Input parameter for the scalar function ufnGetProductListPrice. Enter a valid ProductID from the Production.Product table.|int|4|Function|Parameter|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[dbo\].\[ufnGetProductStandardCost\]](../DbEngine/(local)/AdventureWorks2016CTP3/Functions/1421248118.md)|Input parameter for the scalar function ufnGetProductStandardCost. Enter a valid ProductID from the Production.Product table.|int|4|Function|Parameter|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[dbo\].\[ufnGetStock\]](../DbEngine/(local)/AdventureWorks2016CTP3/Functions/1437248175.md)|Input parameter for the scalar function ufnGetStock. Enter a valid ProductID from the Production.ProductInventory table.|int|4|Function|Parameter|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Production\].\[vProductAndDescription\]](../DbEngine/(local)/AdventureWorks2016CTP3/Views/1165247206.md)| |int|4|View|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Production\].\[WorkOrder\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1166627199.md)|Product identification number. Foreign key to Product.ProductID.|int|4|Table|Column|
|[\[(local)\].\[AdventureWorks2016CTP3\].\[Production\].\[WorkOrderRouting\]](../DbEngine/(local)/AdventureWorks2016CTP3/Tables/1246627484.md)|Primary key. Foreign key to Product.ProductID.|int|4|Table|Column|

 Total: 28 objects

---
### See also
[Server index](../srv_index.md)

