##  Package element:Slowly Changing Dimension
[Table of contents](../../index.md) > [Package Files](../../package_index.md) > [TestPckg](../../PackageFiles/3/p3.md) > [Executables](../../PackageFiles/3/Executables.md) > [sparten](../../PackageFiles/3/108.md) > **Slowly Changing Dimension**

---
### Properties
| Name | Value |
|-|-|
|AreInputColumnsValid|True|
|ComponentClassID|{61985042-EBA1-4FB2-B616-83EA93D9D35B}|
|ContactInfo|Slowly Changing Dimension;Microsoft Corporation; Microsoft SQL Server; (C) Microsoft Corporation; All Rights Reserved; http&#58;//www.microsoft.com/sql/support;3|
|Description|Updates a SQL Server Analysis Services data warehouse dimension. Update dimension records that are already present and  insert dimension records that aren't. For example, update the DimProduct table of the AdventureWorksDW OLAP database with data from the Products table in the AdventureWorks OLTP database.|
|ID|119|
|IdentificationString|Slowly Changing Dimension|
|IsDefaultLocale|True|
|LocaleID|German (Germany)|
|Name|Slowly Changing Dimension|
|ObjectType|12|
|PipelineVersion|0|
|UsesDispositions|False|
|ValidateExternalMetadata|True|
|Version|3|

---
### Elements
| Name | Description | Type |
|-|-|-|
|[SqlCommand](../../PackageFiles/3/659.md)|Specifies the SELECT statement used to create a schema rowset.|CustomPropertyCollection|
|[CurrentRowWhere](../../PackageFiles/3/660.md)|Specifies the WHERE clause in the SELECT statement that selects the current row among rows with identical business keys.|CustomPropertyCollection|
|[UpdateChangingAttributeHistory](../../PackageFiles/3/661.md)|Indicates whether historical attribute updates are directed to the transformation output for changing attribute updates.|CustomPropertyCollection|
|[FailOnFixedAttributeChange](../../PackageFiles/3/662.md)|Indicates whether the transformation fails when columns with fixed attributes contain changes.|CustomPropertyCollection|
|[InferredMemberIndicator](../../PackageFiles/3/663.md)|Specifies the column name for the inferred member.|CustomPropertyCollection|
|[EnableInferredMember](../../PackageFiles/3/664.md)|Indicates whether inferred member updates are detected.|CustomPropertyCollection|
|[FailOnLookupFailure](../../PackageFiles/3/665.md)|Indicates whether the transformation fails when a lookup of an existing record fails.|CustomPropertyCollection|
|[IncomingRowChangeType](../../PackageFiles/3/666.md)|Specifies that all rows in the input are new or the transformation detects the change type.|CustomPropertyCollection|
|[DefaultCodePage](../../PackageFiles/3/667.md)|Specifies the column code page to use when code page information is unavailable from the data source.|CustomPropertyCollection|
|[Slowly Changing Dimension Input](../../PackageFiles/3/668.md)| |InputCollection|
|[Unchanged Output](../../PackageFiles/3/669.md)|Unchanged rows|OutputCollection|
|[New Output](../../PackageFiles/3/670.md)|New rows|OutputCollection|
|[Fixed Attribute Output](../../PackageFiles/3/671.md)|Rows with changes in columns tagged FixedAttribute|OutputCollection|
|[Changing Attribute Updates Output](../../PackageFiles/3/672.md)|These rows contain new information for ChangingAttribute (Type 1) column changes|OutputCollection|
|[Historical Attribute Inserts Output](../../PackageFiles/3/673.md)|HistoricalAttribute (Type 2) changes result in these new rows|OutputCollection|
|[Inferred Member Updates Output](../../PackageFiles/3/674.md)|Information to update unpopulated initial dimension row|OutputCollection|
|[LookupConnection](../../PackageFiles/3/675.md)|Defines the connection to use for lookups in the dimension table|RuntimeConnectionCollection|

---
### See also
[Package index](../../package_index.md)

