##  Package element:ADO Import Active Data From IMS to Staging Import Table
[Table of contents](../../index.md) > [Package Files](../../package_index.md) > [TheatresETL](../../PackageFiles/4/p4.md) > [Executables](../../PackageFiles/4/Executables.md) > **ADO Import Active Data From IMS to Staging Import Table**

---
### Properties
| Name | Value |
|-|-|
|\[ADO NET Source\].\[SqlCommand\]|SELECT DISTINCT sba.patient as Demographic_id,{LF}sba.ID as SurgCID, {LF}sba.ID as CDSUniqueID,{LF}sba.patient as PersonID, {LF}CAST(cpci.c_val as varchar(10)) as nhsnumber, {LF}CAST(cp.namesurname as varchar(40)) As \[PatientSurname\],{LF}CAST(cp.nameforename as varchar(40)) As \[PatientForename\],{LF}convert(datetime,convert(varchar(10),cp.dob),112) as \[DateOfBirth\],{LF}--CAST(cpi.c_val as varchar(101)) As MRN, {LF}(SELECT top 1 CAST(cpi.c_val as varchar(101)){LF}FROM core_patient_c_identifi cpi{LF}WHERE cpi.lkp_c_ty = -2404 AND cpi.id = sba.patient{LF}ORDER BY cpi.c_val) as MRN,{LF}ccr.id \[FIN\], {LF}cp.id As EncounterID, {LF}--COALESCE(cadIPT.id,cadDIS.id) As HospitalProvSpellNo,{LF}cad.id as HospitalProvSpellNo,{LF}sba.sys_creation_datetime As \[DateAdded\], {LF}sba.sys_lastupdate_datetime As \[DateUpdated\],{LF}sss.sessiondat SessionDate, {LF}CONVERT(DATETIME, CONVERT(CHAR(8), sss.sessiondat, 112) + ' ' + CONVERT(CHAR(8), sss.starttm, 108)) As \[SessionStartDate\],{LF}spp.patientarr CheckinDTTM, {LF}--(case {LF}--when spepr.id is not null then 1{LF}--else 0 end) as SurgCompleteInd, -- Re-mapped - see below 8/8/2016{LF}CONVERT(DATETIME, CONVERT(CHAR(8), sss.sessiondat, 112) + ' ' + CONVERT(CHAR(8), sss.endtm, 108)) AS SessionEndDateTime, {LF}sss.name SessionTemplate,{LF}sba.idx \[ScheduleSeq\], {LF}sba.id \[SchEventID\],{LF}aliDir.text Directorate,{LF}csNEW.servicenam TemplateTreatmentFunction,{LF}--aliTTF.text TemplateTreatmentFunction,{LF}--cs1.servicenam as TreatmentFunction,{LF}--New coding to get the most recent TreatmentFunction 20/5/2016{LF}(SELECT Top 1 cs1.servicenam {LF}FROM care_patientwaitin4 cpw4New{LF}left outer join core_waitinglistcon cwlc on cpw4New.electiveli = cwlc.id{LF}left outer join core_services cs1 on cwlc.service = cs1.id{LF}WHERE cpw4New.lkp_electivel4 = '-2620' AND cpw4new.lkp_admissiont = -3003 and cpw4New.referral = sba.care_catsreferral_appointmen ORDER BY cpw4New.sys_creation_datetime desc) as TreatmentFunction,{LF}CAST(clcm.taxonomyco as varchar(50)) as \[SchSurgicalArea\], {LF}sba.appointmen \[SchSurgeryDate\], {LF}CAST(sba.apptstartt As varchar(255)) as \[SchSurgeryTime\], {LF}sba.id \[SchSessionID\], {LF}sss.id \[TemplateID\], {LF}CONVERT(DATETIME, CONVERT(CHAR(8), sss.sessiondat, 112) + ' ' + CONVERT(CHAR(8), sss.starttm, 108)) As TemplateBegDTTM,{LF}CONVERT(DATETIME, CONVERT(CHAR(8), sss.sessiondat, 112) + ' ' + CONVERT(CHAR(8), sss.endtm, 108)) As TemplateEndDTTM,{LF}CAST(cl.name As varchar(255)) As SchOperatingRoom, {LF}COALESCE (sss.safetybri2, aliLSR.text) as \[Late Start Reason\],{LF}cms.namesurname + ', ' + cms.nameforename As \[Supervising Surgeon\],{LF}cms.namesurname + ', ' + cms.nameforename As EventConsultantSurgeon,{LF}cms.namesurname + ', ' + cms.nameforename As \[SurgeonInCharge\],{LF}(CASE WHEN cms.namesurname is not null THEN cms.namesurname + ', ' + cms.nameforename {LF}ELSE cmsECS.namesurname + ', ' + cmsECS.nameforename {LF}END) As PrimarySurgeon,{LF}cmsECS.namesurname + ', ' + cmsECS.nameforename As \[Operating Surgeon\],{LF}cmsAS.namesurname + ', ' + cmsAS.nameforename As \[Assisting Surgeon\],{LF}cmsSA.namesurname + ', ' + cmsSA.nameforename \[Supervising Anaesthetist\],{LF}cmsAP.namesurname + ', ' + cmsAP.nameforename \[Anaethesist Practitioner\],{LF}cmsAM.namesurname + ', ' + cmsAM.nameforename As \[Anaesthetist Main\],{LF}cmsAO.namesurname + ', ' + cmsAO.nameforename As \[Anaesthetist Other\],{LF}cmsAS.namesurname + ', ' + cmsAS.nameforename As \[Scrub Practitioner\],{LF}cmsAS.namesurname + ', ' + cmsAS.nameforename As \[First Assistant\],{LF}cmsCSN.namesurname + ', ' + cmsCSN.nameforename As \[Circulator\],{LF}cmsECS.namesurname + ', ' + cmsECS.nameforename As EventOperatingSurgeon,{LF}CAST(sioc.other as varchar(101)) as \[Other\],{LF}aliSuSp.text \[SurgSpecialty\],{LF}aliATNew.text as \[AnesthType\],{LF}aliAS.text As \[ApptStatus\],{LF}sats.asaclass As \[ASAClass\],{LF}aliSdTy.text SchedType,{LF}aliInMa.text SchedPatType,{LF}cmsCIB.namesurname + ', ' + cmsCIB.nameforename As \[CheckInBy\],{LF}cproc.proceduren \[IntendedPrimaryProc\],{LF}cmsLO.namesurname + ' ' + cmsLO.nameforename \[Laser Operator\],{LF}aliMOD.text \[Modifier\],{LF}(CASE LTRIM(aliNCENew.Text){LF}WHEN '1a - Life Saving' THEN 'Immediate'{LF}WHEN '1b - Limb/Organ Saving' THEN 'Immediate'{LF}WHEN '2 - Urgent' THEN 'Urgent'{LF}WHEN '3 - Unscheduled Emergency' THEN 'Expedited'{LF}WHEN '4 - Elective' THEN 'Elective'{LF}ELSE NULL{LF}END) as NCEPOD,{LF}sss.id \[OpOrder\],{LF}cmsPP.namesurname + ', ' + cmsPP.nameforename As \[PACU Practitioner\],{LF}spos.surgerysta AS \[ProcStartDTTM\],{LF}spstop.surgerysto AS \[ProcEndDTTM\], {LF}aliMOD.text \[ProcModifier\],{LF}cptproc.sys_creation_datetime ProcUPdateDTTM,{LF}alCL.text CaseLevel,{LF}sba.idx \[ProcSeq\],{LF}coalesce(lkSpecS2.text, lkSpecOS.text) as \[ProcSurgSpecialty\],{LF}cptproc.isprimary PrimaryProcInd,{LF}sba.comments ProcedureText,{LF}cptproc.procedured ProcedureDesc,{LF}cproctax.taxonomyco MappedOPCS,{LF}--aliWC.text WoundClass,{LF}(SELECT top 1 (aliWC.text){LF}FROM shcl_skinclosureint ssci{LF}LEFT OUTER JOIN applookup_instance aliWC ON ssci.lkp_procedurew = aliWC.id{LF}ORDER BY ssci.sys_creation_datetime desc) as WoundClass,{LF}coalesce(sba.customproc, cproc.durationin) \[SchDur1\],{LF}spps.patientsen \[SN - Preop - CTm - Time Patient Sent For\],{LF}spp.patientarr \[SN - Preop - CTm - Time Patient Arrived\],{LF}spr4s.anaestheti \[SN - Preop - CTm - Patient Ready for Sur\],{LF}pto.timeoutcom \[SN - CTm - Patient - In Room Time\], --New fieldmapping 2612016{LF}spp.patientarr \[SN - CTm - Anaesthesia - In Room Time\],{LF}spa.anaestheti \[SN - CTm - Anesthesia - Start Time\],{LF}spa.anaestheti SessionStartCalc,{LF}spss.surgerysta \[SN - CTm - Surgery - Start Time\],{LF}spstop.surgerysto \[SN - CTm - Surgery - Stop Time\],{LF}sppl.patientlef \[SN - CTm - Patient - Out Room Time\],{LF}sptir.timeintore \[SN - Rec - CTm - In Rec\],{LF}sptir.timeintore \[SN - Recovery - CAt - Time In\],{LF}sppto.timeoutofr \[SN - Recovery - CAt - Time Out\],{LF}sppto.timeoutofr \[SN - Rec - CTm - Ready for Rec Discharge\],{LF}sprs.readyfordi \[SN - Rec - CTm - Discharge from Rec\],{LF}psb.safetybrie SafetyBrief,{LF}aliSSS.text SessionStatus,{LF}--New 28/6/16{LF}COALESCE(cmsRHCP.namesurname + ', ' + cmsRHCP.nameforename, cmsRHCPNew.namesurname + ', ' + cmsRHCPNew.nameforename) as \[Responsible HCP\], {LF}(CASE WHEN slo.listowner = '1' THEN 'True' ELSE 'False' END) as \[List Owner\],{LF}(CASE WHEN slo.attendingc = '1' THEN 'True' ELSE 'False' END) as \[Attending Clinician\],{LF}--NEW 28/7/16{LF}ctfp.datetcioff as TCIDateGiven, {LF}CASE {LF}WHEN cdd.wastreatme = 1 AND DateDiff(d, CONVERT(date, cto4p.statusdate),CONVERT(date,ctfp.tcidate)) = 0 THEN 'True'{LF}WHEN (cto4p.lkp_outcome = -3455 OR cto4p.lkp_outcome = -2677 OR cto4p.lkp_outcome = -2643) AND DateDiff(d, CONVERT(date, cto4p.statusdate),CONVERT(date,ctfp.tcidate)) = 0 THEN 'True'{LF}WHEN (cto4p.lkp_outcome = -2641 OR cto4p.lkp_outcome = -2640 OR cto4p.lkp_outcome = -2639) AND DateDiff(d, CONVERT(date, cto4p.statusdate),CONVERT(date,ctfp.tcidate)) = 0 THEN 'True'{LF}WHEN sah.lkp_status &lt;&gt; -568 OR sah.lkp_status is null THEN 'NA'{LF}ELSE 'False'{LF}END As Last_Min_CancelledFlag,{LF}CASE WHEN cto4p.lkp_outcome = -3455 OR cto4p.lkp_outcome = -2677 OR cto4p.lkp_outcome = -2643 THEN 'C'{LF}WHEN cto4p.lkp_outcome = -2641 OR cto4p.lkp_outcome = -2640 OR cto4p.lkp_outcome = -2639 THEN 'C'{LF}WHEN cdd.wastreatme = 1 THEN 'C'{LF}WHEN cto4p.lkp_outcome = -2642 THEN 'D'{LF}WHEN cto4p.lkp_outcome = -2650 OR cto4p.lkp_outcome = -2638  OR cto4p.lkp_outcome = -2637 THEN 'A'{LF}when spepr.id is not null then 'A' -- we have a procedure record for this appointment{LF}WHEN spss.surgerysta is not null then 'A' --We have a time stamp for when this op started{LF}ELSE NULL --unknown outcome - leave blank - can't count unknown outcomes{LF}END as ProcOutcomeFlag,{LF}(case {LF}when cto4p.lkp_outcome = -2650 OR cto4p.lkp_outcome = -2638  OR cto4p.lkp_outcome = -2637 then 1{LF}when spepr.id is not null then 1  -- we have a procedure record for this appointment{LF}WHEN spss.surgerysta is not null then 1 --We have a time stamp for when this op started{LF}else 0 end) as SurgCompleteInd,{LF}aliSSR.Text as SessionStatusReason, --NEW Field 18/8/16{LF}sba.procedured as ActualProcedurePerformed --NEW field 18/8/16{LF}FROM schl_booking_appoin sba{LF}LEFT OUTER JOIN core_patient cp ON sba.patient = cp.id{LF}--taken out 17/2 and replaced MRN a Select above{LF}--LEFT OUTER JOIN core_patient_c_identifi cpi ON cp.id = cpi.id AND cpi.lkp_c_ty = -2404 AND merged = 1 --merged = 1 15/2{LF}LEFT OUTER Join dbo.core_patient_c_identifi cpci ON cp.id = cpci.id and cpci.lkp_c_ty = -9{LF}LEFT OUTER JOIN schl_sch_session sss ON sba.c_sessi = sss.id{LF}LEFT OUTER JOIN core_hcp chRCHP ON sss.responsibl = chRCHP.id{LF}LEFT OUTER JOIN core_memberofstaff cmsRHCP ON chRCHP.id = cmsRHCP.hcp{LF}LEFT OUTER JOIN schl_session_listow slo on sss.id = slo.schl_sch_session_listowners {LF}LEFT OUTER JOIN applookup_instance aliLSR ON sss.lkp_safetybri3 = aliLSR.id{LF}LEFT OUTER JOIN applookup_instance aliSSS ON sss.lkp_sessionsta = aliSSS.id{LF}LEFT OUTER JOIN applookup_instance aliSSR ON sss.lkp_cancellati = aliSSR.id{LF}LEFT OUTER JOIN shcl_perioppatienta spp ON spp.theatreapp = sba.id{LF}LEFT OUTER JOIN shcl_perioppatsenti spps ON spps.theatreapp = sba.id{LF}LEFT OUTER JOIN shcl_periopreadyfor spr4s ON spr4s.theatreapp = sba.id{LF}LEFT OUTER JOIN shcl_periopanaestht spa ON spa.theatreapp = sba.id{LF}LEFT OUTER JOIN shcl_periopsurgerys spss ON spss.theatreapp = sba.id{LF}LEFT OUTER JOIN shcl_perioppatientl sppl ON sppl.theatreapp = sba.id{LF}LEFT OUTER JOIN shcl_perioptimeinto sptir ON sptir.theatreapp = sba.id{LF}LEFT OUTER JOIN shcl_periopreadydis sprs ON sprs.theatreapp = sba.id{LF}LEFT OUTER JOIN shcl_perioptimeoutc pto ON pto.theatreapp = sba.id -- for new mapping 26116{LF}LEFT OUTER JOIN care_catsreferral ccr ON sba.care_catsreferral_appointmen = ccr.id{LF}LEFT OUTER JOIN schl_prof spf ON sss.sch_profil = spf.id{LF}LEFT OUTER JOIN core_services csNEW ON spf.service = csNEW.id {LF}--LEFT OUTER JOIN core_referralletter crl ON ccr.referralde = crl.id {LF}--LEFT OUTER JOIN core_servicefunctio csf ON crl.c_functi = csf.id {LF}--LEFT OUTER JOIN applookup_instance aliTTF ON csf.lkp_c_functi = aliTTF.id{LF}LEFT OUTER JOIN core_pas_event cpe ON sba.pasevent = cpe.id{LF}LEFT OUTER JOIN core_location cl ON sss.schlocatio = cl.id{LF}LEFT OUTER JOIN core_location_codemappin clcm ON cl.id = clcm.id AND clcm.lkp_taxonomyna = -286 --To get the PAS Location{LF}LEFT OUTER JOIN shcl_intraopcasesta sioc ON sba.id = sioc.theatreapp{TAB}{LF}LEFT OUTER JOIN core_hcp ch ON sioc.supervisi2 = ch.id{TAB}{LF}LEFT OUTER JOIN core_memberofstaff cms ON ch.id = cms.hcp{LF}LEFT OUTER JOIN core_hcp ch2 ON sioc.operatings = ch2.id {LF}LEFT OUTER JOIN core_memberofstaff cmsECS ON ch2.id = cmsECS.hcp {LF}LEFT OUTER JOIN shcl_intraopcasesta_assistings sia ON sioc.id = sia.from_side AND sia.idx = 0 --NEW added 5/2/2016 {LF}LEFT OUTER JOIN core_hcp ch3 ON sia.to_side = ch3.id {LF}LEFT OUTER JOIN core_memberofstaff cmsAS ON ch3.id = cmsAS.hcp{LF}LEFT OUTER JOIN core_hcp ch4 ON sioc.supervisin = ch4.id {LF}LEFT OUTER JOIN core_memberofstaff cmsSA ON ch4.id = cmsSA.hcp{LF}LEFT OUTER JOIN core_hcp ch5 ON sioc.anaesthet3 = ch5.id {LF}LEFT OUTER JOIN core_memberofstaff cmsAP ON ch5.id = cmsAP.hcp{LF}LEFT OUTER JOIN core_hcp ch6 ON sioc.anaesthet2 = ch6.id {LF}LEFT OUTER JOIN core_memberofstaff cmsAM ON ch6.id = cmsAM.hcp {LF}LEFT OUTER JOIN core_hcp ch7 ON sioc.assistinga = ch7.id {LF}LEFT OUTER JOIN core_memberofstaff cmsAO ON ch7.id = cmsAO.hcp{LF}LEFT OUTER JOIN shcl_circulatorscru scsn ON sioc.id = scsn.shcl_intraopcasesta_circulator AND scsn.lkp_circulator = -3232 AND scsn.idx = 1 {LF}LEFT OUTER JOIN core_hcp ch10 ON scsn.nurse = ch10.id {LF}LEFT OUTER JOIN core_memberofstaff cmsCSN ON ch10.id = cmsCSN.hcp AND scsn.lkp_circulator = -3232{LF}--LEFT OUTER JOIN applookup_instance aliATNew ON cpw4New.lkp_anaestheti = aliATNew.id - OLD giving duplicates{LF}LEFT OUTER JOIN schl_appt_history_s sah ON sba.currentsta = sah.id AND sah.c_sessi = sba.c_sessi{LF}LEFT OUTER JOIN applookup_instance aliAS ON sah.lkp_status = aliAS.id{LF}LEFT OUTER JOIN shcl_anaestheticsig sats ON sba.id = sats.theatreapp{LF}LEFT OUTER JOIN core_memberofstaff cmsCIB ON spp.recordedby = cmsCIB.id{LF}LEFT OUTER JOIN schl_theatrebooking stb ON sba.theatreboo = stb.id{LF}LEFT OUTER JOIN core_hcp chRHCPNew ON stb.consultant  = chRHCPNew.id --NEW 28/6/16{LF}LEFT OUTER JOIN core_memberofstaff cmsRHCPNew ON chRHCPNew.id = cmsRHCPNew.hcp --NEW 28/6/16{LF}LEFT OUTER JOIN applookup_instance aliATNew ON stb.lkp_anaestheti = aliATNew.id -- NEW 9/2/2016{LF}LEFT OUTER JOIN shcl_periopsafetybr psb ON psb.theatreapp = sba.id {LF}LEFT OUTER JOIN core_procedure cproc ON stb.c_procedu = cproc.id{LF}LEFT OUTER JOIN shcl_laserdetailint sldi ON sba.id = sldi.theatreapp{LF}LEFT OUTER JOIN applookup_instance alCL ON cproc.lkp_surgeoncat = alCL.id{LF}LEFT OUTER JOIN core_hcp ch8 ON sldi.laseropera = ch8.id {LF}LEFT OUTER JOIN core_memberofstaff cmsLO ON ch8.id = cmsLO.hcp{LF}LEFT OUTER JOIN applookup_instance aliMOD ON stb.lkp_proclatera = aliMOD.id{LF}--LEFT OUTER JOIN care_tciforpatiente ctfp ON sba.id = ctfp.appointmen AND ctfp.care_patientwaitin4_tcihistory is not null and sba.c_sessi = ctfp.c_sessi{LF}--UPDATE 18/8/16 - following sample data from Laura - removed the care AND ctfp.care_patientwaitin4_tcihistory is not null{LF}LEFT OUTER JOIN care_tciforpatiente ctfp ON sba.id = ctfp.appointmen AND sba.c_sessi = ctfp.c_sessi {LF}LEFT OUTER JOIN care_patientwaitin4 cpw4 ON ctfp.vstp = cpw4.tcidetails AND cpw4.lkp_electivel4 = '-2620'{LF}LEFT OUTER JOIN shcl_perioptimeouto sppto ON sba.id = sppto.theatreapp{LF}LEFT OUTER JOIN core_memberofstaff cmsPP ON sppto.recordedby = cmsPP.id{LF}LEFT OUTER JOIN shcl_periopsurgerys spos ON sba.id = spos.theatreapp{LF}LEFT OUTER JOIN shcl_periopsurgstop spstop ON sba.id = spstop.theatreapp{LF}LEFT OUTER JOIN core_services css on sioc.caseservic = css.id{LF}LEFT OUTER JOIN applookup_instance aliDir ON css.lkp_servicecat = aliDir.id {LF}LEFT OUTER JOIN core_hcp ch9 ON sioc.operatings = ch9.id {LF}LEFT OUTER JOIN applookup_instance aliSuSp ON ch9.lkp_specialty = aliSuSp.id{LF}LEFT OUTER JOIN care_patientwaitin4 cpw42 ON ctfp.care_patientwaitin4_tcihistory = cpw42.id  AND cpw42.lkp_electivel4 = '-2620'{LF}LEFT OUTER JOIN applookup_instance aliSdTy ON cpw42.lkp_priority = aliSdTy.id{LF}LEFT OUTER JOIN applookup_instance aliInMa ON cpw42.lkp_intendedma = aliInMa.id{LF}LEFT OUTER JOIN schl_sessiontheatre sst ON sba.id = sst.appointmen {LF}--Removed next line as not used!{LF}--LEFT OUTER JOIN schl_sch_session sss1 ON sst.c_sessi = sss1.id AND (sss1.theatrepro is not null AND sss1.lkp_cancellati is null){LF}LEFT OUTER JOIN shcl_performedproce spepr on spepr.theatreapp = sba.id{LF}LEFT OUTER JOIN core_patprocedure cptproc ON spepr.performedp = cptproc.id AND cptproc.isprimary = 1{LF}--LEFT OUTER JOIN shcl_skinclosureint ssci ON sba.id = ssci.theatreapp{LF}--LEFT OUTER JOIN applookup_instance aliWC ON ssci.lkp_procedurew = aliWC.id{LF}LEFT OUTER JOIN core_procedure cproc1 ON cptproc.c_procedu = cproc1.id AND cptproc.isprimary = 1{LF}LEFT OUTER JOIN core_procedure_taxonomyma cproctax ON cproc1.id = cproctax.id AND cproctax.lkp_taxonomyna = -1513 --To get the OPCS code{LF}LEFT OUTER JOIN core_dischargedepis cdd ON cpe.id = cdd.pasevent{LF}LEFT OUTER JOIN core_inpat_epis cie on cpe.id = cie.pasevent{LF}--LEFT OUTER JOIN core_admissiondetai cadIPT ON cie.pasevent = cadIPT.pasevent{LF}--LEFT OUTER JOIN core_admissiondetai cadDIS ON cdd.pasevent = cadDIS.pasevent{LF}LEFT OUTER JOIN core_admissiondetai cad ON cad.care_catsreferral_admissions = ccr.id{LF}AND CONVERT(date,sba.appointmen ,103) = CONVERT(date,cad.admissiond,103) --NEW JOIN 30/6{LF}LEFT OUTER JOIN schl_pendingemergen spe on ccr.id = spe.catsreferr AND spe.theatreapp = sba.id --Changed 2/8/2016{LF}LEFT OUTER JOIN applookup_instance aliNCENew ON spe.lkp_urgencycat = aliNCENew.id{LF}LEFT OUTER JOIN core_hcp chs2 ON sioc.supervisi2 = chs2.id{LF}LEFT OUTER JOIN core_hcp chOS ON sioc.operatings = chOS.id{LF}LEFT OUTER JOIN applookup_instance lkSpecS2 ON chs2.lkp_specialty = lkSpecS2.id{LF}LEFT OUTER JOIN applookup_instance lkSpecOS ON chOS.lkp_specialty = lkSpecOS.id{LF}-- now only 3 JOINS FOR TreatmentFunction 15022016{LF}LEFT OUTER JOIN care_patientwaitin4 cpw4New ON sba.care_catsreferral_appointmen = cpw4New.referral AND cpw4New.lkp_electivel4 = '-2620' AND cpw4new.lkp_admissiont = -3003 --added lkp_admissiont = -3003 15/2{LF}left outer join core_waitinglistcon cwlc on cpw4New.electiveli = cwlc.id{LF}left outer join core_services cs1 on cwlc.service = cs1.id{LF}left outer join core_services_taxonomyma cst1 on cs1.id = cst1.id and cst1.lkp_taxonomyna=-286{LF}--New join 8/8/16{LF}LEFT OUTER JOIN care_tcioutcomeforp cto4p ON ctfp.currentout = cto4p.id{LF}WHERE sba.theatreboo &gt; 0{LF}ORDER BY sba.id|
|\[ADO NET Source\].\[TableOrViewName\]| |
|ApartmentThreaded|False|
|AutoAdjustBufferSize|False|
|AutoGenerateIDForNewObjects|True|
|BLOBTempStoragePath| |
|BufferTempStoragePath| |
|CreationName|SSIS.Pipeline.7|
|DebugMode|False|
|DefaultBufferMaxRows|10000|
|DefaultBufferSize|10485760|
|DelayValidation|False|
|Description|Import Active Data From IMS to Staging Import Table|
|Disable|True|
|DisableEventHandlers|False|
|EnableCacheUpdate|True|
|EnableDisconnectedColumns|False|
|EngineThreads|10|
|ExecutionDuration|0|
|ExecutionResult|Success|
|ExecutionStatus|None|
|FailPackageOnFailure|False|
|FailParentOnFailure|False|
|ForcedExecutionValue|0|
|ForceExecutionResult|None|
|ForceExecutionValue|False|
|HasExpressions|False|
|HostType|Task|
|ID|{fe9f959e-dcbd-4fb5-8bcc-4f0d7490d367}|
|IsDefaultLocaleID|True|
|IsolationLevel|Serializable|
|IsSavingXml|False|
|LocaleID|English (United Kingdom)|
|LoggingMode|UseParentSetting|
|MaximumErrorCount|1|
|Name|ADO Import Active Data From IMS to Staging Import Table|
|RunInOptimizedMode|True|
|SuspendRequired|False|
|TransactionOption|Supported|

---
### Elements
| Name | Description | Type |
|-|-|-|
|[ADO NET Source](../../PackageFiles/4/41.md)|Consumes data from SQL Server, OLE DB, ODBC, or Oracle, using the corresponding .NET Framework data provider. Use a Transact-SQL statement to define the result set. For example, extract data from SQL Server with the .NET Framework data provider for SQL Server.|ComponentMetaDataCollection|
|[Data Conversion 1](../../PackageFiles/4/42.md)|Data Conversion|ComponentMetaDataCollection|
|[OLE DB Destination 1](../../PackageFiles/4/43.md)|OLE DB Destination|ComponentMetaDataCollection|
|[BufferSizeTuning](../../PackageFiles/4/44.md)|The Data Flow changed the size of a buffer away from the default values. The event text includes the sizes and the reasons.|LogEntryInfos|
|[PipelineBufferLeak](../../PackageFiles/4/45.md)|After execution, some buffers were left outstanding. Some transform is hanging onto buffer references and if it freed them we would use a lot less memory. The logged text includes information about the transform that owned the buffer, and the ID of the buffer.|LogEntryInfos|
|[PipelineComponentTime](../../PackageFiles/4/46.md)|Information about each phase of validation and execution for each data flow component. The processing time of each phase is specified.|LogEntryInfos|
|[PipelineExecutionPlan](../../PackageFiles/4/47.md)|The execution plan of the data flow.|LogEntryInfos|
|[PipelineExecutionTrees](../../PackageFiles/4/48.md)|The input the scheduler had when forming the execution plan.|LogEntryInfos|
|[PipelineInitialization](../../PackageFiles/4/49.md)|Various information from Data Flow initialization.|LogEntryInfos|
|[ADO NET Source Output](../../PackageFiles/4/50.md)| |PathCollection|
|[Data Conversion Output](../../PackageFiles/4/51.md)| |PathCollection|
|[ContainerStartTime](../../PackageFiles/4/52.md)|The start time of the container|Variables|
|[CreationName](../../PackageFiles/4/53.md)|The creation name|Variables|
|[LocaleID](../../PackageFiles/4/54.md)|The locale ID|Variables|
|[ParentContainerGUID](../../PackageFiles/4/55.md)|The parent container GUID|Variables|
|[TaskID](../../PackageFiles/4/56.md)|The task ID|Variables|
|[TaskName](../../PackageFiles/4/57.md)|The task name|Variables|
|[TaskTransactionOption](../../PackageFiles/4/58.md)|The transaction option for the task|Variables|
|[CancelEvent](../../PackageFiles/4/59.md)|The cancel event|Variables|
|[ContainerStartTime](../../PackageFiles/4/60.md)|The start time of the container|Variables|
|[CreationDate](../../PackageFiles/4/61.md)|The date the package was created|Variables|
|[CreatorComputerName](../../PackageFiles/4/62.md)|The name of the computer where the package was created|Variables|
|[CreatorName](../../PackageFiles/4/63.md)|The name of the Package creator|Variables|
|[ExecutionInstanceGUID](../../PackageFiles/4/64.md)|The unique identifier of the current execution instance|Variables|
|[FailedConfigurations](../../PackageFiles/4/65.md)|The names of configurations that failed|Variables|
|[IgnoreConfigurationsOnLoad](../../PackageFiles/4/66.md)|Ignore Configurations when loading the package|Variables|
|[InteractiveMode](../../PackageFiles/4/67.md)|The interactive mode currently set for the package|Variables|
|[LastModifiedProductVersion](../../PackageFiles/4/68.md)|The product version of the SQL server where the package is last modified|Variables|
|[LocaleID](../../PackageFiles/4/69.md)|The locale ID|Variables|
|[MachineName](../../PackageFiles/4/70.md)|The machine name|Variables|
|[OfflineMode](../../PackageFiles/4/71.md)|The offline mode currently set for the package|Variables|
|[PackageID](../../PackageFiles/4/72.md)|The package ID|Variables|
|[PackageName](../../PackageFiles/4/73.md)|The package name|Variables|
|[ParentContainerGUID](../../PackageFiles/4/74.md)|The parent container GUID|Variables|
|[ProductVersion](../../PackageFiles/4/75.md)|The product version of current SQL Server|Variables|
|[ServerExecutionID](../../PackageFiles/4/76.md)|The unique identifier of an execution instance in SSIS server|Variables|
|[StartTime](../../PackageFiles/4/77.md)|The start time of the package|Variables|
|[UserName](../../PackageFiles/4/78.md)|The user name|Variables|
|[VersionBuild](../../PackageFiles/4/79.md)|The package build version|Variables|
|[VersionComments](../../PackageFiles/4/80.md)|The package version comments|Variables|
|[VersionGUID](../../PackageFiles/4/81.md)|The package version guid|Variables|
|[VersionMajor](../../PackageFiles/4/82.md)|The package major version|Variables|
|[VersionMinor](../../PackageFiles/4/83.md)|The package minor version|Variables|

![](../../SSISDiagrams/data_flow_20191212113116384.png "")
---
### See also
[Package index](../../package_index.md)

