##  Package element:Move Changes and New into Current
[Table of contents](../../index.md) > [Package Files](../../package_index.md) > [TheatresETL](../../PackageFiles/4/p4.md) > [Executables](../../PackageFiles/4/Executables.md) > [Process ACT Updates](../../PackageFiles/4/39.md) > **Move Changes and New into Current**

---
### Properties
| Name | Value |
|-|-|
|\[Get Start Date\].\[Derived Column Output\].\[StartDate\].\[FriendlyExpression\]|DATEADD("DD",-1,GETDATE())|
|ApartmentThreaded|False|
|AutoAdjustBufferSize|False|
|AutoGenerateIDForNewObjects|True|
|BLOBTempStoragePath| |
|BufferTempStoragePath| |
|CreationName|SSIS.Pipeline.7|
|DebugMode|False|
|DefaultBufferMaxRows|10000|
|DefaultBufferSize|10485760|
|DelayValidation|False|
|Description|Data Flow Task|
|Disable|False|
|DisableEventHandlers|False|
|EnableCacheUpdate|True|
|EnableDisconnectedColumns|False|
|EngineThreads|10|
|ExecutionDuration|0|
|ExecutionResult|Success|
|ExecutionStatus|None|
|FailPackageOnFailure|False|
|FailParentOnFailure|False|
|ForcedExecutionValue|0|
|ForceExecutionResult|None|
|ForceExecutionValue|False|
|HasExpressions|False|
|HostType|Task|
|ID|{E0FDF229-A5E8-4239-A748-548E19492AE2}|
|IsDefaultLocaleID|True|
|IsolationLevel|Serializable|
|IsSavingXml|False|
|LocaleID|English (United Kingdom)|
|LoggingMode|UseParentSetting|
|MaximumErrorCount|1|
|Name|Move Changes and New into Current|
|RunInOptimizedMode|True|
|SuspendRequired|False|
|TransactionOption|Supported|

---
### Elements
| Name | Description | Type |
|-|-|-|
|[Get Start Date](../../PackageFiles/4/3238.md)|Creates new column values by applying expressions to transformation input columns. Create new columns or overwrite existing ones. For example, concatenate the values from the 'first name' and 'last name' column to make a 'full name' column.|ComponentMetaDataCollection|
|[Staging Import Source](../../PackageFiles/4/3239.md)|OLE DB Source|ComponentMetaDataCollection|
|[Theatres Current Destination](../../PackageFiles/4/3240.md)|OLE DB Destination|ComponentMetaDataCollection|
|[BufferSizeTuning](../../PackageFiles/4/3241.md)|The Data Flow changed the size of a buffer away from the default values. The event text includes the sizes and the reasons.|LogEntryInfos|
|[PipelineBufferLeak](../../PackageFiles/4/3242.md)|After execution, some buffers were left outstanding. Some transform is hanging onto buffer references and if it freed them we would use a lot less memory. The logged text includes information about the transform that owned the buffer, and the ID of the buffer.|LogEntryInfos|
|[PipelineComponentTime](../../PackageFiles/4/3243.md)|Information about each phase of validation and execution for each data flow component. The processing time of each phase is specified.|LogEntryInfos|
|[PipelineExecutionPlan](../../PackageFiles/4/3244.md)|The execution plan of the data flow.|LogEntryInfos|
|[PipelineExecutionTrees](../../PackageFiles/4/3245.md)|The input the scheduler had when forming the execution plan.|LogEntryInfos|
|[PipelineInitialization](../../PackageFiles/4/3246.md)|Various information from Data Flow initialization.|LogEntryInfos|
|[Derived Column Output](../../PackageFiles/4/3247.md)| |PathCollection|
|[OLE DB Source Output](../../PackageFiles/4/3248.md)| |PathCollection|
|[ContainerStartTime](../../PackageFiles/4/3249.md)|The start time of the container|Variables|
|[CreationName](../../PackageFiles/4/3250.md)|The creation name|Variables|
|[LocaleID](../../PackageFiles/4/3251.md)|The locale ID|Variables|
|[ParentContainerGUID](../../PackageFiles/4/3252.md)|The parent container GUID|Variables|
|[TaskID](../../PackageFiles/4/3253.md)|The task ID|Variables|
|[TaskName](../../PackageFiles/4/3254.md)|The task name|Variables|
|[TaskTransactionOption](../../PackageFiles/4/3255.md)|The transaction option for the task|Variables|
|[LocaleID](../../PackageFiles/4/3256.md)|The locale ID|Variables|
|[ParentContainerGUID](../../PackageFiles/4/3257.md)|The parent container GUID|Variables|
|[CancelEvent](../../PackageFiles/4/3258.md)|The cancel event|Variables|
|[ContainerStartTime](../../PackageFiles/4/3259.md)|The start time of the container|Variables|
|[CreationDate](../../PackageFiles/4/3260.md)|The date the package was created|Variables|
|[CreatorComputerName](../../PackageFiles/4/3261.md)|The name of the computer where the package was created|Variables|
|[CreatorName](../../PackageFiles/4/3262.md)|The name of the Package creator|Variables|
|[ExecutionInstanceGUID](../../PackageFiles/4/3263.md)|The unique identifier of the current execution instance|Variables|
|[FailedConfigurations](../../PackageFiles/4/3264.md)|The names of configurations that failed|Variables|
|[IgnoreConfigurationsOnLoad](../../PackageFiles/4/3265.md)|Ignore Configurations when loading the package|Variables|
|[InteractiveMode](../../PackageFiles/4/3266.md)|The interactive mode currently set for the package|Variables|
|[LastModifiedProductVersion](../../PackageFiles/4/3267.md)|The product version of the SQL server where the package is last modified|Variables|
|[LocaleID](../../PackageFiles/4/3268.md)|The locale ID|Variables|
|[MachineName](../../PackageFiles/4/3269.md)|The machine name|Variables|
|[OfflineMode](../../PackageFiles/4/3270.md)|The offline mode currently set for the package|Variables|
|[PackageID](../../PackageFiles/4/3271.md)|The package ID|Variables|
|[PackageName](../../PackageFiles/4/3272.md)|The package name|Variables|
|[ParentContainerGUID](../../PackageFiles/4/3273.md)|The parent container GUID|Variables|
|[ProductVersion](../../PackageFiles/4/3274.md)|The product version of current SQL Server|Variables|
|[ServerExecutionID](../../PackageFiles/4/3275.md)|The unique identifier of an execution instance in SSIS server|Variables|
|[StartTime](../../PackageFiles/4/3276.md)|The start time of the package|Variables|
|[UserName](../../PackageFiles/4/3277.md)|The user name|Variables|
|[VersionBuild](../../PackageFiles/4/3278.md)|The package build version|Variables|
|[VersionComments](../../PackageFiles/4/3279.md)|The package version comments|Variables|
|[VersionGUID](../../PackageFiles/4/3280.md)|The package version guid|Variables|
|[VersionMajor](../../PackageFiles/4/3281.md)|The package major version|Variables|
|[VersionMinor](../../PackageFiles/4/3282.md)|The package minor version|Variables|

![](../../SSISDiagrams/data_flow_20191212113141606.png "")
---
### See also
[Package index](../../package_index.md)

