##  Package element:Data Flow Task
[Table of contents](../../index.md) > [Package Files](../../package_index.md) > [XFactor 3.1](../../PackageFiles/5/p5.md) > [Executables](../../PackageFiles/5/Executables.md) > **Data Flow Task**

---
### Properties
| Name | Value |
|-|-|
|\[Sort\].\[MaximumThreads\]|-1|
|ApartmentThreaded|False|
|AutoAdjustBufferSize|False|
|AutoGenerateIDForNewObjects|True|
|BLOBTempStoragePath| |
|BufferTempStoragePath| |
|CreationName|SSIS.Pipeline.7|
|DebugMode|False|
|DefaultBufferMaxRows|10000|
|DefaultBufferSize|10485760|
|DelayValidation|False|
|Description|Data Flow Task|
|Disable|False|
|DisableEventHandlers|False|
|EnableCacheUpdate|True|
|EnableDisconnectedColumns|False|
|EngineThreads|10|
|ExecutionDuration|0|
|ExecutionResult|Success|
|ExecutionStatus|None|
|FailPackageOnFailure|False|
|FailParentOnFailure|False|
|ForcedExecutionValue|0|
|ForceExecutionResult|None|
|ForceExecutionValue|False|
|HasExpressions|False|
|HostType|Task|
|ID|{B67B9243-0167-482D-937B-A33AFBFBB743}|
|IsDefaultLocaleID|True|
|IsolationLevel|Serializable|
|IsSavingXml|False|
|LocaleID|Finnish (Finland)|
|LoggingMode|UseParentSetting|
|MaximumErrorCount|1|
|Name|Data Flow Task|
|RunInOptimizedMode|True|
|SuspendRequired|False|
|TransactionOption|Supported|

---
### Elements
| Name | Description | Type |
|-|-|-|
|[ollidb2_XFactor](../../PackageFiles/5/28.md)|OLE DB Destination|ComponentMetaDataCollection|
|[Sort](../../PackageFiles/5/29.md)|Sorts input data in ascending or descending order when it cannot be sorted at its source. For example, sort sales data by 'customer id' before it is written to a flat file and delivered to another department. Note: We do not recommend this transformation for large data flows.|ComponentMetaDataCollection|
|[XFactor](../../PackageFiles/5/30.md)|Excel Source|ComponentMetaDataCollection|
|[BufferSizeTuning](../../PackageFiles/5/31.md)|The Data Flow changed the size of a buffer away from the default values. The event text includes the sizes and the reasons.|LogEntryInfos|
|[PipelineBufferLeak](../../PackageFiles/5/32.md)|After execution, some buffers were left outstanding. Some transform is hanging onto buffer references and if it freed them we would use a lot less memory. The logged text includes information about the transform that owned the buffer, and the ID of the buffer.|LogEntryInfos|
|[PipelineComponentTime](../../PackageFiles/5/33.md)|Information about each phase of validation and execution for each data flow component. The processing time of each phase is specified.|LogEntryInfos|
|[PipelineExecutionPlan](../../PackageFiles/5/34.md)|The execution plan of the data flow.|LogEntryInfos|
|[PipelineExecutionTrees](../../PackageFiles/5/35.md)|The input the scheduler had when forming the execution plan.|LogEntryInfos|
|[PipelineInitialization](../../PackageFiles/5/36.md)|Various information from Data Flow initialization.|LogEntryInfos|
|[Excel Source Output](../../PackageFiles/5/37.md)| |PathCollection|
|[Sort Output](../../PackageFiles/5/38.md)| |PathCollection|
|[ContainerStartTime](../../PackageFiles/5/39.md)|The start time of the container|Variables|
|[CreationName](../../PackageFiles/5/40.md)|The creation name|Variables|
|[LocaleID](../../PackageFiles/5/41.md)|The locale ID|Variables|
|[ParentContainerGUID](../../PackageFiles/5/42.md)|The parent container GUID|Variables|
|[TaskID](../../PackageFiles/5/43.md)|The task ID|Variables|
|[TaskName](../../PackageFiles/5/44.md)|The task name|Variables|
|[TaskTransactionOption](../../PackageFiles/5/45.md)|The transaction option for the task|Variables|
|[CancelEvent](../../PackageFiles/5/46.md)|The cancel event|Variables|
|[ContainerStartTime](../../PackageFiles/5/47.md)|The start time of the container|Variables|
|[CreationDate](../../PackageFiles/5/48.md)|The date the package was created|Variables|
|[CreatorComputerName](../../PackageFiles/5/49.md)|The name of the computer where the package was created|Variables|
|[CreatorName](../../PackageFiles/5/50.md)|The name of the Package creator|Variables|
|[ExecutionInstanceGUID](../../PackageFiles/5/51.md)|The unique identifier of the current execution instance|Variables|
|[FailedConfigurations](../../PackageFiles/5/52.md)|The names of configurations that failed|Variables|
|[IgnoreConfigurationsOnLoad](../../PackageFiles/5/53.md)|Ignore Configurations when loading the package|Variables|
|[InteractiveMode](../../PackageFiles/5/54.md)|The interactive mode currently set for the package|Variables|
|[LastModifiedProductVersion](../../PackageFiles/5/55.md)|The product version of the SQL server where the package is last modified|Variables|
|[LocaleID](../../PackageFiles/5/56.md)|The locale ID|Variables|
|[MachineName](../../PackageFiles/5/57.md)|The machine name|Variables|
|[OfflineMode](../../PackageFiles/5/58.md)|The offline mode currently set for the package|Variables|
|[PackageID](../../PackageFiles/5/59.md)|The package ID|Variables|
|[PackageName](../../PackageFiles/5/60.md)|The package name|Variables|
|[ParentContainerGUID](../../PackageFiles/5/61.md)|The parent container GUID|Variables|
|[ProductVersion](../../PackageFiles/5/62.md)|The product version of current SQL Server|Variables|
|[ServerExecutionID](../../PackageFiles/5/63.md)|The unique identifier of an execution instance in SSIS server|Variables|
|[StartTime](../../PackageFiles/5/64.md)|The start time of the package|Variables|
|[UserName](../../PackageFiles/5/65.md)|The user name|Variables|
|[VersionBuild](../../PackageFiles/5/66.md)|The package build version|Variables|
|[VersionComments](../../PackageFiles/5/67.md)|The package version comments|Variables|
|[VersionGUID](../../PackageFiles/5/68.md)|The package version guid|Variables|
|[VersionMajor](../../PackageFiles/5/69.md)|The package major version|Variables|
|[VersionMinor](../../PackageFiles/5/70.md)|The package minor version|Variables|

![](../../SSISDiagrams/data_flow_20191212113155616.png "")
---
### See also
[Package index](../../package_index.md)

